
/** For String.prototype.matchAll */
if(!String.prototype.matchAll) {
    String.prototype.matchAll = function (rx) {
        if (typeof rx === "string") rx = new RegExp(rx, "g"); // coerce a string to be a global regex
        rx = new RegExp(rx); // Clone the regex so we don't update the last index on the regex they pass us
        let cap = []; // the single capture
        let all = []; // all the captures (return this)
        while ((cap = rx.exec(this)) !== null) all.push(cap); // execute and add
        return all; // profit!
    };
}
      
(function (exports) {
    'use strict';

    function __awaiter(e,t,r,n){return new(r||(r=Promise))((function(o,a){function i(e){try{s(n.next(e));}catch(e){a(e);}}function c(e){try{s(n.throw(e));}catch(e){a(e);}}function s(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t);}))).then(i,c);}s((n=n.apply(e,t||[])).next());}))}"function"==typeof SuppressedError?SuppressedError:function(e,t,r){var n=new Error(r);return n.name="SuppressedError",n.error=e,n.suppressed=t,n};

    class Text$1{lineAt(t){if(t<0||t>this.length)throw new RangeError(`Invalid position ${t} in document of length ${this.length}`);return this.lineInner(t,!1,1,0)}line(t){if(t<1||t>this.lines)throw new RangeError(`Invalid line number ${t} in ${this.lines}-line document`);return this.lineInner(t,!0,1,0)}replace(t,e,n){let i=[];return this.decompose(0,t,i,2),n.length&&n.decompose(0,n.length,i,3),this.decompose(e,this.length,i,1),TextNode$1.from(i,this.length-(e-t)+n.length)}append(t){return this.replace(this.length,this.length,t)}slice(t,e=this.length){let n=[];return this.decompose(t,e,n,0),TextNode$1.from(n,e-t)}eq(t){if(t==this)return !0;if(t.length!=this.length||t.lines!=this.lines)return !1;let e=this.scanIdentical(t,1),n=this.length-this.scanIdentical(t,-1),i=new RawTextCursor$1(this),r=new RawTextCursor$1(t);for(let t=e,s=e;;){if(i.next(t),r.next(t),t=0,i.lineBreak!=r.lineBreak||i.done!=r.done||i.value!=r.value)return !1;if(s+=i.value.length,i.done||s>=n)return !0}}iter(t=1){return new RawTextCursor$1(this,t)}iterRange(t,e=this.length){return new PartialTextCursor$1(this,t,e)}iterLines(t,e){let n;if(null==t)n=this.iter();else {null==e&&(e=this.lines+1);let i=this.line(t).from;n=this.iterRange(i,Math.max(i,e==this.lines+1?this.length:e<=1?0:this.line(e-1).to));}return new LineCursor$1(n)}toString(){return this.sliceString(0)}toJSON(){let t=[];return this.flatten(t),t}constructor(){}static of(t){if(0==t.length)throw new RangeError("A document must have at least one line");return 1!=t.length||t[0]?t.length<=32?new TextLeaf$1(t):TextNode$1.from(TextLeaf$1.split(t,[])):Text$1.empty}}class TextLeaf$1 extends Text$1{constructor(t,e=textLength$1(t)){super(),this.text=t,this.length=e;}get lines(){return this.text.length}get children(){return null}lineInner(t,e,n,i){for(let r=0;;r++){let s=this.text[r],o=i+s.length;if((e?n:o)>=t)return new Line$1(i,o,n,s);i=o+1,n++;}}decompose(t,e,n,i){let r=t<=0&&e>=this.length?this:new TextLeaf$1(sliceText$1(this.text,t,e),Math.min(e,this.length)-Math.max(0,t));if(1&i){let t=n.pop(),e=appendText$1(r.text,t.text.slice(),0,r.length);if(e.length<=32)n.push(new TextLeaf$1(e,t.length+r.length));else {let t=e.length>>1;n.push(new TextLeaf$1(e.slice(0,t)),new TextLeaf$1(e.slice(t)));}}else n.push(r);}replace(t,e,n){if(!(n instanceof TextLeaf$1))return super.replace(t,e,n);let i=appendText$1(this.text,appendText$1(n.text,sliceText$1(this.text,0,t)),e),r=this.length+n.length-(e-t);return i.length<=32?new TextLeaf$1(i,r):TextNode$1.from(TextLeaf$1.split(i,[]),r)}sliceString(t,e=this.length,n="\n"){let i="";for(let r=0,s=0;r<=e&&s<this.text.length;s++){let o=this.text[s],a=r+o.length;r>t&&s&&(i+=n),t<a&&e>r&&(i+=o.slice(Math.max(0,t-r),e-r)),r=a+1;}return i}flatten(t){for(let e of this.text)t.push(e);}scanIdentical(){return 0}static split(t,e){let n=[],i=-1;for(let r of t)n.push(r),i+=r.length+1,32==n.length&&(e.push(new TextLeaf$1(n,i)),n=[],i=-1);return i>-1&&e.push(new TextLeaf$1(n,i)),e}}class TextNode$1 extends Text$1{constructor(t,e){super(),this.children=t,this.length=e,this.lines=0;for(let e of t)this.lines+=e.lines;}lineInner(t,e,n,i){for(let r=0;;r++){let s=this.children[r],o=i+s.length,a=n+s.lines-1;if((e?a:o)>=t)return s.lineInner(t,e,n,i);i=o+1,n=a+1;}}decompose(t,e,n,i){for(let r=0,s=0;s<=e&&r<this.children.length;r++){let o=this.children[r],a=s+o.length;if(t<=a&&e>=s){let r=i&((s<=t?1:0)|(a>=e?2:0));s>=t&&a<=e&&!r?n.push(o):o.decompose(t-s,e-s,n,r);}s=a+1;}}replace(t,e,n){if(n.lines<this.lines)for(let i=0,r=0;i<this.children.length;i++){let s=this.children[i],o=r+s.length;if(t>=r&&e<=o){let a=s.replace(t-r,e-r,n),h=this.lines-s.lines+a.lines;if(a.lines<h>>4&&a.lines>h>>6){let r=this.children.slice();return r[i]=a,new TextNode$1(r,this.length-(e-t)+n.length)}return super.replace(r,o,a)}r=o+1;}return super.replace(t,e,n)}sliceString(t,e=this.length,n="\n"){let i="";for(let r=0,s=0;r<this.children.length&&s<=e;r++){let o=this.children[r],a=s+o.length;s>t&&r&&(i+=n),t<a&&e>s&&(i+=o.sliceString(t-s,e-s,n)),s=a+1;}return i}flatten(t){for(let e of this.children)e.flatten(t);}scanIdentical(t,e){if(!(t instanceof TextNode$1))return 0;let n=0,[i,r,s,o]=e>0?[0,0,this.children.length,t.children.length]:[this.children.length-1,t.children.length-1,-1,-1];for(;;i+=e,r+=e){if(i==s||r==o)return n;let a=this.children[i],h=t.children[r];if(a!=h)return n+a.scanIdentical(h,e);n+=a.length+1;}}static from(t,e=t.reduce(((t,e)=>t+e.length+1),-1)){let n=0;for(let e of t)n+=e.lines;if(n<32){let n=[];for(let e of t)e.flatten(n);return new TextLeaf$1(n,e)}let i=Math.max(32,n>>5),r=i<<1,s=i>>1,o=[],a=0,h=-1,l=[];function c(t){let e;if(t.lines>r&&t instanceof TextNode$1)for(let e of t.children)c(e);else t.lines>s&&(a>s||!a)?(f(),o.push(t)):t instanceof TextLeaf$1&&a&&(e=l[l.length-1])instanceof TextLeaf$1&&t.lines+e.lines<=32?(a+=t.lines,h+=t.length+1,l[l.length-1]=new TextLeaf$1(e.text.concat(t.text),e.length+1+t.length)):(a+t.lines>i&&f(),a+=t.lines,h+=t.length+1,l.push(t));}function f(){0!=a&&(o.push(1==l.length?l[0]:TextNode$1.from(l,h)),h=-1,a=l.length=0);}for(let e of t)c(e);return f(),1==o.length?o[0]:new TextNode$1(o,e)}}function textLength$1(t){let e=-1;for(let n of t)e+=n.length+1;return e}function appendText$1(t,e,n=0,i=1e9){for(let r=0,s=0,o=!0;s<t.length&&r<=i;s++){let a=t[s],h=r+a.length;h>=n&&(h>i&&(a=a.slice(0,i-r)),r<n&&(a=a.slice(n-r)),o?(e[e.length-1]+=a,o=!1):e.push(a)),r=h+1;}return e}function sliceText$1(t,e,n){return appendText$1(t,[""],e,n)}Text$1.empty=new TextLeaf$1([""],0);class RawTextCursor$1{constructor(t,e=1){this.dir=e,this.done=!1,this.lineBreak=!1,this.value="",this.nodes=[t],this.offsets=[e>0?1:(t instanceof TextLeaf$1?t.text.length:t.children.length)<<1];}nextInner(t,e){for(this.done=this.lineBreak=!1;;){let n=this.nodes.length-1,i=this.nodes[n],r=this.offsets[n],s=r>>1,o=i instanceof TextLeaf$1?i.text.length:i.children.length;if(s==(e>0?o:0)){if(0==n)return this.done=!0,this.value="",this;e>0&&this.offsets[n-1]++,this.nodes.pop(),this.offsets.pop();}else if((1&r)==(e>0?0:1)){if(this.offsets[n]+=e,0==t)return this.lineBreak=!0,this.value="\n",this;t--;}else if(i instanceof TextLeaf$1){let r=i.text[s+(e<0?-1:0)];if(this.offsets[n]+=e,r.length>Math.max(0,t))return this.value=0==t?r:e>0?r.slice(t):r.slice(0,r.length-t),this;t-=r.length;}else {let r=i.children[s+(e<0?-1:0)];t>r.length?(t-=r.length,this.offsets[n]+=e):(e<0&&this.offsets[n]--,this.nodes.push(r),this.offsets.push(e>0?1:(r instanceof TextLeaf$1?r.text.length:r.children.length)<<1));}}}next(t=0){return t<0&&(this.nextInner(-t,-this.dir),t=this.value.length),this.nextInner(t,this.dir)}}class PartialTextCursor$1{constructor(t,e,n){this.value="",this.done=!1,this.cursor=new RawTextCursor$1(t,e>n?-1:1),this.pos=e>n?t.length:0,this.from=Math.min(e,n),this.to=Math.max(e,n);}nextInner(t,e){if(e<0?this.pos<=this.from:this.pos>=this.to)return this.value="",this.done=!0,this;t+=Math.max(0,e<0?this.pos-this.to:this.from-this.pos);let n=e<0?this.pos-this.from:this.to-this.pos;t>n&&(t=n),n-=t;let{value:i}=this.cursor.next(t);return this.pos+=(i.length+t)*e,this.value=i.length<=n?i:e<0?i.slice(i.length-n):i.slice(0,n),this.done=!this.value,this}next(t=0){return t<0?t=Math.max(t,this.from-this.pos):t>0&&(t=Math.min(t,this.to-this.pos)),this.nextInner(t,this.cursor.dir)}get lineBreak(){return this.cursor.lineBreak&&""!=this.value}}class LineCursor$1{constructor(t){this.inner=t,this.afterBreak=!0,this.value="",this.done=!1;}next(t=0){let{done:e,lineBreak:n,value:i}=this.inner.next(t);return e?(this.done=!0,this.value=""):n?this.afterBreak?this.value="":(this.afterBreak=!0,this.next()):(this.value=i,this.afterBreak=!1),this}get lineBreak(){return !1}}"undefined"!=typeof Symbol&&(Text$1.prototype[Symbol.iterator]=function(){return this.iter()},RawTextCursor$1.prototype[Symbol.iterator]=PartialTextCursor$1.prototype[Symbol.iterator]=LineCursor$1.prototype[Symbol.iterator]=function(){return this});class Line$1{constructor(t,e,n,i){this.from=t,this.to=e,this.number=n,this.text=i;}get length(){return this.to-this.from}}let extend$1="lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((t=>t?parseInt(t,36):1));for(let t=1;t<extend$1.length;t++)extend$1[t]+=extend$1[t-1];function isExtendingChar(t){for(let e=1;e<extend$1.length;e+=2)if(extend$1[e]>t)return extend$1[e-1]<=t;return !1}function isRegionalIndicator(t){return t>=127462&&t<=127487}const ZWJ=8205;function findClusterBreak(t,e,n=!0,i=!0){return (n?nextClusterBreak:prevClusterBreak)(t,e,i)}function nextClusterBreak(t,e,n){if(e==t.length)return e;e&&surrogateLow(t.charCodeAt(e))&&surrogateHigh(t.charCodeAt(e-1))&&e--;let i=codePointAt(t,e);for(e+=codePointSize(i);e<t.length;){let r=codePointAt(t,e);if(i==ZWJ||r==ZWJ||n&&isExtendingChar(r))e+=codePointSize(r),i=r;else {if(!isRegionalIndicator(r))break;{let n=0,i=e-2;for(;i>=0&&isRegionalIndicator(codePointAt(t,i));)n++,i-=2;if(n%2==0)break;e+=2;}}}return e}function prevClusterBreak(t,e,n){for(;e>0;){let i=nextClusterBreak(t,e-2,n);if(i<e)return i;e--;}return 0}function surrogateLow(t){return t>=56320&&t<57344}function surrogateHigh(t){return t>=55296&&t<56320}function codePointAt(t,e){let n=t.charCodeAt(e);if(!surrogateHigh(n)||e+1==t.length)return n;let i=t.charCodeAt(e+1);return surrogateLow(i)?i-56320+(n-55296<<10)+65536:n}function fromCodePoint(t){return t<=65535?String.fromCharCode(t):(t-=65536,String.fromCharCode(55296+(t>>10),56320+(1023&t)))}function codePointSize(t){return t<65536?1:2}const DefaultSplit=/\r\n?|\n/;var MapMode=function(t){return t[t.Simple=0]="Simple",t[t.TrackDel=1]="TrackDel",t[t.TrackBefore=2]="TrackBefore",t[t.TrackAfter=3]="TrackAfter",t}(MapMode||(MapMode={}));class ChangeDesc{constructor(t){this.sections=t;}get length(){let t=0;for(let e=0;e<this.sections.length;e+=2)t+=this.sections[e];return t}get newLength(){let t=0;for(let e=0;e<this.sections.length;e+=2){let n=this.sections[e+1];t+=n<0?this.sections[e]:n;}return t}get empty(){return 0==this.sections.length||2==this.sections.length&&this.sections[1]<0}iterGaps(t){for(let e=0,n=0,i=0;e<this.sections.length;){let r=this.sections[e++],s=this.sections[e++];s<0?(t(n,i,r),i+=r):i+=s,n+=r;}}iterChangedRanges(t,e=!1){iterChanges(this,t,e);}get invertedDesc(){let t=[];for(let e=0;e<this.sections.length;){let n=this.sections[e++],i=this.sections[e++];i<0?t.push(n,i):t.push(i,n);}return new ChangeDesc(t)}composeDesc(t){return this.empty?t:t.empty?this:composeSets(this,t)}mapDesc(t,e=!1){return t.empty?this:mapSet(this,t,e)}mapPos(t,e=-1,n=MapMode.Simple){let i=0,r=0;for(let s=0;s<this.sections.length;){let o=this.sections[s++],a=this.sections[s++],h=i+o;if(a<0){if(h>t)return r+(t-i);r+=o;}else {if(n!=MapMode.Simple&&h>=t&&(n==MapMode.TrackDel&&i<t&&h>t||n==MapMode.TrackBefore&&i<t||n==MapMode.TrackAfter&&h>t))return null;if(h>t||h==t&&e<0&&!o)return t==i||e<0?r:r+a;r+=a;}i=h;}if(t>i)throw new RangeError(`Position ${t} is out of range for changeset of length ${i}`);return r}touchesRange(t,e=t){for(let n=0,i=0;n<this.sections.length&&i<=e;){let r=i+this.sections[n++];if(this.sections[n++]>=0&&i<=e&&r>=t)return !(i<t&&r>e)||"cover";i=r;}return !1}toString(){let t="";for(let e=0;e<this.sections.length;){let n=this.sections[e++],i=this.sections[e++];t+=(t?" ":"")+n+(i>=0?":"+i:"");}return t}toJSON(){return this.sections}static fromJSON(t){if(!Array.isArray(t)||t.length%2||t.some((t=>"number"!=typeof t)))throw new RangeError("Invalid JSON representation of ChangeDesc");return new ChangeDesc(t)}static create(t){return new ChangeDesc(t)}}class ChangeSet extends ChangeDesc{constructor(t,e){super(t),this.inserted=e;}apply(t){if(this.length!=t.length)throw new RangeError("Applying change set to a document with the wrong length");return iterChanges(this,((e,n,i,r,s)=>t=t.replace(i,i+(n-e),s)),!1),t}mapDesc(t,e=!1){return mapSet(this,t,e,!0)}invert(t){let e=this.sections.slice(),n=[];for(let i=0,r=0;i<e.length;i+=2){let s=e[i],o=e[i+1];if(o>=0){e[i]=o,e[i+1]=s;let a=i>>1;for(;n.length<a;)n.push(Text$1.empty);n.push(s?t.slice(r,r+s):Text$1.empty);}r+=s;}return new ChangeSet(e,n)}compose(t){return this.empty?t:t.empty?this:composeSets(this,t,!0)}map(t,e=!1){return t.empty?this:mapSet(this,t,e,!0)}iterChanges(t,e=!1){iterChanges(this,t,e);}get desc(){return ChangeDesc.create(this.sections)}filter(t){let e=[],n=[],i=[],r=new SectionIter(this);t:for(let s=0,o=0;;){let a=s==t.length?1e9:t[s++];for(;o<a||o==a&&0==r.len;){if(r.done)break t;let t=Math.min(r.len,a-o);addSection(i,t,-1);let s=-1==r.ins?-1:0==r.off?r.ins:0;addSection(e,t,s),s>0&&addInsert(n,e,r.text),r.forward(t),o+=t;}let h=t[s++];for(;o<h;){if(r.done)break t;let t=Math.min(r.len,h-o);addSection(e,t,-1),addSection(i,t,-1==r.ins?-1:0==r.off?r.ins:0),r.forward(t),o+=t;}}return {changes:new ChangeSet(e,n),filtered:ChangeDesc.create(i)}}toJSON(){let t=[];for(let e=0;e<this.sections.length;e+=2){let n=this.sections[e],i=this.sections[e+1];i<0?t.push(n):0==i?t.push([n]):t.push([n].concat(this.inserted[e>>1].toJSON()));}return t}static of(t,e,n){let i=[],r=[],s=0,o=null;function a(t=!1){if(!t&&!i.length)return;s<e&&addSection(i,e-s,-1);let n=new ChangeSet(i,r);o=o?o.compose(n.map(o)):n,i=[],r=[],s=0;}return function t(h){if(Array.isArray(h))for(let e of h)t(e);else if(h instanceof ChangeSet){if(h.length!=e)throw new RangeError(`Mismatched change set length (got ${h.length}, expected ${e})`);a(),o=o?o.compose(h.map(o)):h;}else {let{from:t,to:o=t,insert:l}=h;if(t>o||t<0||o>e)throw new RangeError(`Invalid change range ${t} to ${o} (in doc of length ${e})`);let c=l?"string"==typeof l?Text$1.of(l.split(n||DefaultSplit)):l:Text$1.empty,f=c.length;if(t==o&&0==f)return;t<s&&a(),t>s&&addSection(i,t-s,-1),addSection(i,o-t,f),addInsert(r,i,c),s=o;}}(t),a(!o),o}static empty(t){return new ChangeSet(t?[t,-1]:[],[])}static fromJSON(t){if(!Array.isArray(t))throw new RangeError("Invalid JSON representation of ChangeSet");let e=[],n=[];for(let i=0;i<t.length;i++){let r=t[i];if("number"==typeof r)e.push(r,-1);else {if(!Array.isArray(r)||"number"!=typeof r[0]||r.some(((t,e)=>e&&"string"!=typeof t)))throw new RangeError("Invalid JSON representation of ChangeSet");if(1==r.length)e.push(r[0],0);else {for(;n.length<i;)n.push(Text$1.empty);n[i]=Text$1.of(r.slice(1)),e.push(r[0],n[i].length);}}}return new ChangeSet(e,n)}static createSet(t,e){return new ChangeSet(t,e)}}function addSection(t,e,n,i=!1){if(0==e&&n<=0)return;let r=t.length-2;r>=0&&n<=0&&n==t[r+1]?t[r]+=e:0==e&&0==t[r]?t[r+1]+=n:i?(t[r]+=e,t[r+1]+=n):t.push(e,n);}function addInsert(t,e,n){if(0==n.length)return;let i=e.length-2>>1;if(i<t.length)t[t.length-1]=t[t.length-1].append(n);else {for(;t.length<i;)t.push(Text$1.empty);t.push(n);}}function iterChanges(t,e,n){let i=t.inserted;for(let r=0,s=0,o=0;o<t.sections.length;){let a=t.sections[o++],h=t.sections[o++];if(h<0)r+=a,s+=a;else {let l=r,c=s,f=Text$1.empty;for(;l+=a,c+=h,h&&i&&(f=f.append(i[o-2>>1])),!(n||o==t.sections.length||t.sections[o+1]<0);)a=t.sections[o++],h=t.sections[o++];e(r,l,s,c,f),r=l,s=c;}}}function mapSet(t,e,n,i=!1){let r=[],s=i?[]:null,o=new SectionIter(t),a=new SectionIter(e);for(let t=-1;;)if(-1==o.ins&&-1==a.ins){let t=Math.min(o.len,a.len);addSection(r,t,-1),o.forward(t),a.forward(t);}else if(a.ins>=0&&(o.ins<0||t==o.i||0==o.off&&(a.len<o.len||a.len==o.len&&!n))){let e=a.len;for(addSection(r,a.ins,-1);e;){let n=Math.min(o.len,e);o.ins>=0&&t<o.i&&o.len<=n&&(addSection(r,0,o.ins),s&&addInsert(s,r,o.text),t=o.i),o.forward(n),e-=n;}a.next();}else {if(!(o.ins>=0)){if(o.done&&a.done)return s?ChangeSet.createSet(r,s):ChangeDesc.create(r);throw new Error("Mismatched change set lengths")}{let e=0,n=o.len;for(;n;)if(-1==a.ins){let t=Math.min(n,a.len);e+=t,n-=t,a.forward(t);}else {if(!(0==a.ins&&a.len<n))break;n-=a.len,a.next();}addSection(r,e,t<o.i?o.ins:0),s&&t<o.i&&addInsert(s,r,o.text),t=o.i,o.forward(o.len-n);}}}function composeSets(t,e,n=!1){let i=[],r=n?[]:null,s=new SectionIter(t),o=new SectionIter(e);for(let t=!1;;){if(s.done&&o.done)return r?ChangeSet.createSet(i,r):ChangeDesc.create(i);if(0==s.ins)addSection(i,s.len,0,t),s.next();else if(0!=o.len||o.done){if(s.done||o.done)throw new Error("Mismatched change set lengths");{let e=Math.min(s.len2,o.len),n=i.length;if(-1==s.ins){let n=-1==o.ins?-1:o.off?0:o.ins;addSection(i,e,n,t),r&&n&&addInsert(r,i,o.text);}else -1==o.ins?(addSection(i,s.off?0:s.len,e,t),r&&addInsert(r,i,s.textBit(e))):(addSection(i,s.off?0:s.len,o.off?0:o.ins,t),r&&!o.off&&addInsert(r,i,o.text));t=(s.ins>e||o.ins>=0&&o.len>e)&&(t||i.length>n),s.forward2(e),o.forward(e);}}else addSection(i,0,o.ins,t),r&&addInsert(r,i,o.text),o.next();}}class SectionIter{constructor(t){this.set=t,this.i=0,this.next();}next(){let{sections:t}=this.set;this.i<t.length?(this.len=t[this.i++],this.ins=t[this.i++]):(this.len=0,this.ins=-2),this.off=0;}get done(){return -2==this.ins}get len2(){return this.ins<0?this.len:this.ins}get text(){let{inserted:t}=this.set,e=this.i-2>>1;return e>=t.length?Text$1.empty:t[e]}textBit(t){let{inserted:e}=this.set,n=this.i-2>>1;return n>=e.length&&!t?Text$1.empty:e[n].slice(this.off,null==t?void 0:this.off+t)}forward(t){t==this.len?this.next():(this.len-=t,this.off+=t);}forward2(t){-1==this.ins?this.forward(t):t==this.ins?this.next():(this.ins-=t,this.off+=t);}}class SelectionRange{constructor(t,e,n){this.from=t,this.to=e,this.flags=n;}get anchor(){return 16&this.flags?this.to:this.from}get head(){return 16&this.flags?this.from:this.to}get empty(){return this.from==this.to}get assoc(){return 4&this.flags?-1:8&this.flags?1:0}get bidiLevel(){let t=3&this.flags;return 3==t?null:t}get goalColumn(){let t=this.flags>>5;return 33554431==t?void 0:t}map(t,e=-1){let n,i;return this.empty?n=i=t.mapPos(this.from,e):(n=t.mapPos(this.from,1),i=t.mapPos(this.to,-1)),n==this.from&&i==this.to?this:new SelectionRange(n,i,this.flags)}extend(t,e=t){if(t<=this.anchor&&e>=this.anchor)return EditorSelection.range(t,e);let n=Math.abs(t-this.anchor)>Math.abs(e-this.anchor)?t:e;return EditorSelection.range(this.anchor,n)}eq(t){return this.anchor==t.anchor&&this.head==t.head}toJSON(){return {anchor:this.anchor,head:this.head}}static fromJSON(t){if(!t||"number"!=typeof t.anchor||"number"!=typeof t.head)throw new RangeError("Invalid JSON representation for SelectionRange");return EditorSelection.range(t.anchor,t.head)}static create(t,e,n){return new SelectionRange(t,e,n)}}class EditorSelection{constructor(t,e){this.ranges=t,this.mainIndex=e;}map(t,e=-1){return t.empty?this:EditorSelection.create(this.ranges.map((n=>n.map(t,e))),this.mainIndex)}eq(t){if(this.ranges.length!=t.ranges.length||this.mainIndex!=t.mainIndex)return !1;for(let e=0;e<this.ranges.length;e++)if(!this.ranges[e].eq(t.ranges[e]))return !1;return !0}get main(){return this.ranges[this.mainIndex]}asSingle(){return 1==this.ranges.length?this:new EditorSelection([this.main],0)}addRange(t,e=!0){return EditorSelection.create([t].concat(this.ranges),e?0:this.mainIndex+1)}replaceRange(t,e=this.mainIndex){let n=this.ranges.slice();return n[e]=t,EditorSelection.create(n,this.mainIndex)}toJSON(){return {ranges:this.ranges.map((t=>t.toJSON())),main:this.mainIndex}}static fromJSON(t){if(!t||!Array.isArray(t.ranges)||"number"!=typeof t.main||t.main>=t.ranges.length)throw new RangeError("Invalid JSON representation for EditorSelection");return new EditorSelection(t.ranges.map((t=>SelectionRange.fromJSON(t))),t.main)}static single(t,e=t){return new EditorSelection([EditorSelection.range(t,e)],0)}static create(t,e=0){if(0==t.length)throw new RangeError("A selection needs at least one range");for(let n=0,i=0;i<t.length;i++){let r=t[i];if(r.empty?r.from<=n:r.from<n)return EditorSelection.normalized(t.slice(),e);n=r.to;}return new EditorSelection(t,e)}static cursor(t,e=0,n,i){return SelectionRange.create(t,t,(0==e?0:e<0?4:8)|(null==n?3:Math.min(2,n))|(null!=i?i:33554431)<<5)}static range(t,e,n,i){let r=(null!=n?n:33554431)<<5|(null==i?3:Math.min(2,i));return e<t?SelectionRange.create(e,t,24|r):SelectionRange.create(t,e,(e>t?4:0)|r)}static normalized(t,e=0){let n=t[e];t.sort(((t,e)=>t.from-e.from)),e=t.indexOf(n);for(let n=1;n<t.length;n++){let i=t[n],r=t[n-1];if(i.empty?i.from<=r.to:i.from<r.to){let s=r.from,o=Math.max(i.to,r.to);n<=e&&e--,t.splice(--n,2,i.anchor>i.head?EditorSelection.range(o,s):EditorSelection.range(s,o));}}return new EditorSelection(t,e)}}function checkSelection(t,e){for(let n of t.ranges)if(n.to>e)throw new RangeError("Selection points outside of document")}let nextID=0;class Facet{constructor(t,e,n,i,r){this.combine=t,this.compareInput=e,this.compare=n,this.isStatic=i,this.id=nextID++,this.default=t([]),this.extensions="function"==typeof r?r(this):r;}static define(t={}){return new Facet(t.combine||(t=>t),t.compareInput||((t,e)=>t===e),t.compare||(t.combine?(t,e)=>t===e:sameArray$1),!!t.static,t.enables)}of(t){return new FacetProvider([],this,0,t)}compute(t,e){if(this.isStatic)throw new Error("Can't compute a static facet");return new FacetProvider(t,this,1,e)}computeN(t,e){if(this.isStatic)throw new Error("Can't compute a static facet");return new FacetProvider(t,this,2,e)}from(t,e){return e||(e=t=>t),this.compute([t],(n=>e(n.field(t))))}}function sameArray$1(t,e){return t==e||t.length==e.length&&t.every(((t,n)=>t===e[n]))}class FacetProvider{constructor(t,e,n,i){this.dependencies=t,this.facet=e,this.type=n,this.value=i,this.id=nextID++;}dynamicSlot(t){var e;let n=this.value,i=this.facet.compareInput,r=this.id,s=t[r]>>1,o=2==this.type,a=!1,h=!1,l=[];for(let n of this.dependencies)"doc"==n?a=!0:"selection"==n?h=!0:0==(1&(null!==(e=t[n.id])&&void 0!==e?e:1))&&l.push(t[n.id]);return {create:t=>(t.values[s]=n(t),1),update(t,e){if(a&&e.docChanged||h&&(e.docChanged||e.selection)||ensureAll(t,l)){let e=n(t);if(o?!compareArray(e,t.values[s],i):!i(e,t.values[s]))return t.values[s]=e,1}return 0},reconfigure:(t,e)=>{let a,h=e.config.address[r];if(null!=h){let r=getAddr(e,h);if(this.dependencies.every((n=>n instanceof Facet?e.facet(n)===t.facet(n):!(n instanceof StateField)||e.field(n,!1)==t.field(n,!1)))||(o?compareArray(a=n(t),r,i):i(a=n(t),r)))return t.values[s]=r,0}else a=n(t);return t.values[s]=a,1}}}}function compareArray(t,e,n){if(t.length!=e.length)return !1;for(let i=0;i<t.length;i++)if(!n(t[i],e[i]))return !1;return !0}function ensureAll(t,e){let n=!1;for(let i of e)1&ensureAddr(t,i)&&(n=!0);return n}function dynamicFacetSlot(t,e,n){let i=n.map((e=>t[e.id])),r=n.map((t=>t.type)),s=i.filter((t=>!(1&t))),o=t[e.id]>>1;function a(t){let n=[];for(let e=0;e<i.length;e++){let s=getAddr(t,i[e]);if(2==r[e])for(let t of s)n.push(t);else n.push(s);}return e.combine(n)}return {create(t){for(let e of i)ensureAddr(t,e);return t.values[o]=a(t),1},update(t,n){if(!ensureAll(t,s))return 0;let i=a(t);return e.compare(i,t.values[o])?0:(t.values[o]=i,1)},reconfigure(t,r){let s=ensureAll(t,i),h=r.config.facets[e.id],l=r.facet(e);if(h&&!s&&sameArray$1(n,h))return t.values[o]=l,0;let c=a(t);return e.compare(c,l)?(t.values[o]=l,0):(t.values[o]=c,1)}}}const initField=Facet.define({static:!0});class StateField{constructor(t,e,n,i,r){this.id=t,this.createF=e,this.updateF=n,this.compareF=i,this.spec=r,this.provides=void 0;}static define(t){let e=new StateField(nextID++,t.create,t.update,t.compare||((t,e)=>t===e),t);return t.provide&&(e.provides=t.provide(e)),e}create(t){let e=t.facet(initField).find((t=>t.field==this));return ((null==e?void 0:e.create)||this.createF)(t)}slot(t){let e=t[this.id]>>1;return {create:t=>(t.values[e]=this.create(t),1),update:(t,n)=>{let i=t.values[e],r=this.updateF(i,n);return this.compareF(i,r)?0:(t.values[e]=r,1)},reconfigure:(t,n)=>null!=n.config.address[this.id]?(t.values[e]=n.field(this),0):(t.values[e]=this.create(t),1)}}init(t){return [this,initField.of({field:this,create:t})]}get extension(){return this}}const Prec_={lowest:4,low:3,default:2,high:1,highest:0};function prec(t){return e=>new PrecExtension(e,t)}const Prec={highest:prec(Prec_.highest),high:prec(Prec_.high),default:prec(Prec_.default),low:prec(Prec_.low),lowest:prec(Prec_.lowest)};class PrecExtension{constructor(t,e){this.inner=t,this.prec=e;}}class Compartment{of(t){return new CompartmentInstance(this,t)}reconfigure(t){return Compartment.reconfigure.of({compartment:this,extension:t})}get(t){return t.config.compartments.get(this)}}class CompartmentInstance{constructor(t,e){this.compartment=t,this.inner=e;}}class Configuration{constructor(t,e,n,i,r,s){for(this.base=t,this.compartments=e,this.dynamicSlots=n,this.address=i,this.staticValues=r,this.facets=s,this.statusTemplate=[];this.statusTemplate.length<n.length;)this.statusTemplate.push(0);}staticFacet(t){let e=this.address[t.id];return null==e?t.default:this.staticValues[e>>1]}static resolve(t,e,n){let i=[],r=Object.create(null),s=new Map;for(let n of flatten(t,e,s))n instanceof StateField?i.push(n):(r[n.facet.id]||(r[n.facet.id]=[])).push(n);let o=Object.create(null),a=[],h=[];for(let t of i)o[t.id]=h.length<<1,h.push((e=>t.slot(e)));let l=null==n?void 0:n.config.facets;for(let t in r){let e=r[t],i=e[0].facet,s=l&&l[t]||[];if(e.every((t=>0==t.type)))if(o[i.id]=a.length<<1|1,sameArray$1(s,e))a.push(n.facet(i));else {let t=i.combine(e.map((t=>t.value)));a.push(n&&i.compare(t,n.facet(i))?n.facet(i):t);}else {for(let t of e)0==t.type?(o[t.id]=a.length<<1|1,a.push(t.value)):(o[t.id]=h.length<<1,h.push((e=>t.dynamicSlot(e))));o[i.id]=h.length<<1,h.push((t=>dynamicFacetSlot(t,i,e)));}}let c=h.map((t=>t(o)));return new Configuration(t,s,c,o,a,r)}}function flatten(t,e,n){let i=[[],[],[],[],[]],r=new Map;return function t(s,o){let a=r.get(s);if(null!=a){if(a<=o)return;let t=i[a].indexOf(s);t>-1&&i[a].splice(t,1),s instanceof CompartmentInstance&&n.delete(s.compartment);}if(r.set(s,o),Array.isArray(s))for(let e of s)t(e,o);else if(s instanceof CompartmentInstance){if(n.has(s.compartment))throw new RangeError("Duplicate use of compartment in extensions");let i=e.get(s.compartment)||s.inner;n.set(s.compartment,i),t(i,o);}else if(s instanceof PrecExtension)t(s.inner,s.prec);else if(s instanceof StateField)i[o].push(s),s.provides&&t(s.provides,o);else if(s instanceof FacetProvider)i[o].push(s),s.facet.extensions&&t(s.facet.extensions,Prec_.default);else {let e=s.extension;if(!e)throw new Error(`Unrecognized extension value in extension set (${s}). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks.`);t(e,o);}}(t,Prec_.default),i.reduce(((t,e)=>t.concat(e)))}function ensureAddr(t,e){if(1&e)return 2;let n=e>>1,i=t.status[n];if(4==i)throw new Error("Cyclic dependency between fields and/or facets");if(2&i)return i;t.status[n]=4;let r=t.computeSlot(t,t.config.dynamicSlots[n]);return t.status[n]=2|r}function getAddr(t,e){return 1&e?t.config.staticValues[e>>1]:t.values[e>>1]}const languageData=Facet.define(),allowMultipleSelections=Facet.define({combine:t=>t.some((t=>t)),static:!0}),lineSeparator=Facet.define({combine:t=>t.length?t[0]:void 0,static:!0}),changeFilter=Facet.define(),transactionFilter=Facet.define(),transactionExtender=Facet.define(),readOnly=Facet.define({combine:t=>!!t.length&&t[0]});class Annotation{constructor(t,e){this.type=t,this.value=e;}static define(){return new AnnotationType}}class AnnotationType{of(t){return new Annotation(this,t)}}class StateEffectType{constructor(t){this.map=t;}of(t){return new StateEffect(this,t)}}class StateEffect{constructor(t,e){this.type=t,this.value=e;}map(t){let e=this.type.map(this.value,t);return void 0===e?void 0:e==this.value?this:new StateEffect(this.type,e)}is(t){return this.type==t}static define(t={}){return new StateEffectType(t.map||(t=>t))}static mapEffects(t,e){if(!t.length)return t;let n=[];for(let i of t){let t=i.map(e);t&&n.push(t);}return n}}StateEffect.reconfigure=StateEffect.define(),StateEffect.appendConfig=StateEffect.define();class Transaction{constructor(t,e,n,i,r,s){this.startState=t,this.changes=e,this.selection=n,this.effects=i,this.annotations=r,this.scrollIntoView=s,this._doc=null,this._state=null,n&&checkSelection(n,e.newLength),r.some((t=>t.type==Transaction.time))||(this.annotations=r.concat(Transaction.time.of(Date.now())));}static create(t,e,n,i,r,s){return new Transaction(t,e,n,i,r,s)}get newDoc(){return this._doc||(this._doc=this.changes.apply(this.startState.doc))}get newSelection(){return this.selection||this.startState.selection.map(this.changes)}get state(){return this._state||this.startState.applyTransaction(this),this._state}annotation(t){for(let e of this.annotations)if(e.type==t)return e.value}get docChanged(){return !this.changes.empty}get reconfigured(){return this.startState.config!=this.state.config}isUserEvent(t){let e=this.annotation(Transaction.userEvent);return !(!e||!(e==t||e.length>t.length&&e.slice(0,t.length)==t&&"."==e[t.length]))}}function joinRanges(t,e){let n=[];for(let i=0,r=0;;){let s,o;if(i<t.length&&(r==e.length||e[r]>=t[i]))s=t[i++],o=t[i++];else {if(!(r<e.length))return n;s=e[r++],o=e[r++];}!n.length||n[n.length-1]<s?n.push(s,o):n[n.length-1]<o&&(n[n.length-1]=o);}}function mergeTransaction(t,e,n){var i;let r,s,o;return n?(r=e.changes,s=ChangeSet.empty(e.changes.length),o=t.changes.compose(e.changes)):(r=e.changes.map(t.changes),s=t.changes.mapDesc(e.changes,!0),o=t.changes.compose(r)),{changes:o,selection:e.selection?e.selection.map(s):null===(i=t.selection)||void 0===i?void 0:i.map(r),effects:StateEffect.mapEffects(t.effects,r).concat(StateEffect.mapEffects(e.effects,s)),annotations:t.annotations.length?t.annotations.concat(e.annotations):e.annotations,scrollIntoView:t.scrollIntoView||e.scrollIntoView}}function resolveTransactionInner(t,e,n){let i=e.selection,r=asArray$1(e.annotations);return e.userEvent&&(r=r.concat(Transaction.userEvent.of(e.userEvent))),{changes:e.changes instanceof ChangeSet?e.changes:ChangeSet.of(e.changes||[],n,t.facet(lineSeparator)),selection:i&&(i instanceof EditorSelection?i:EditorSelection.single(i.anchor,i.head)),effects:asArray$1(e.effects),annotations:r,scrollIntoView:!!e.scrollIntoView}}function resolveTransaction(t,e,n){let i=resolveTransactionInner(t,e.length?e[0]:{},t.doc.length);e.length&&!1===e[0].filter&&(n=!1);for(let r=1;r<e.length;r++){!1===e[r].filter&&(n=!1);let s=!!e[r].sequential;i=mergeTransaction(i,resolveTransactionInner(t,e[r],s?i.changes.newLength:t.doc.length),s);}let r=Transaction.create(t,i.changes,i.selection,i.effects,i.annotations,i.scrollIntoView);return extendTransaction(n?filterTransaction(r):r)}function filterTransaction(t){let e=t.startState,n=!0;for(let i of e.facet(changeFilter)){let e=i(t);if(!1===e){n=!1;break}Array.isArray(e)&&(n=!0===n?e:joinRanges(n,e));}if(!0!==n){let i,r;if(!1===n)r=t.changes.invertedDesc,i=ChangeSet.empty(e.doc.length);else {let e=t.changes.filter(n);i=e.changes,r=e.filtered.mapDesc(e.changes).invertedDesc;}t=Transaction.create(e,i,t.selection&&t.selection.map(r),StateEffect.mapEffects(t.effects,r),t.annotations,t.scrollIntoView);}let i=e.facet(transactionFilter);for(let n=i.length-1;n>=0;n--){let r=i[n](t);t=r instanceof Transaction?r:Array.isArray(r)&&1==r.length&&r[0]instanceof Transaction?r[0]:resolveTransaction(e,asArray$1(r),!1);}return t}function extendTransaction(t){let e=t.startState,n=e.facet(transactionExtender),i=t;for(let r=n.length-1;r>=0;r--){let s=n[r](t);s&&Object.keys(s).length&&(i=mergeTransaction(i,resolveTransactionInner(e,s,t.changes.newLength),!0));}return i==t?t:Transaction.create(e,t.changes,t.selection,i.effects,i.annotations,i.scrollIntoView)}Transaction.time=Annotation.define(),Transaction.userEvent=Annotation.define(),Transaction.addToHistory=Annotation.define(),Transaction.remote=Annotation.define();const none$2=[];function asArray$1(t){return null==t?none$2:Array.isArray(t)?t:[t]}var CharCategory=function(t){return t[t.Word=0]="Word",t[t.Space=1]="Space",t[t.Other=2]="Other",t}(CharCategory||(CharCategory={}));const nonASCIISingleCaseWordChar=/[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;let wordChar;try{wordChar=new RegExp("[\\p{Alphabetic}\\p{Number}_]","u");}catch(t){}function hasWordChar(t){if(wordChar)return wordChar.test(t);for(let e=0;e<t.length;e++){let n=t[e];if(/\w/.test(n)||n>""&&(n.toUpperCase()!=n.toLowerCase()||nonASCIISingleCaseWordChar.test(n)))return !0}return !1}function makeCategorizer(t){return e=>{if(!/\S/.test(e))return CharCategory.Space;if(hasWordChar(e))return CharCategory.Word;for(let n=0;n<t.length;n++)if(e.indexOf(t[n])>-1)return CharCategory.Word;return CharCategory.Other}}class EditorState{constructor(t,e,n,i,r,s){this.config=t,this.doc=e,this.selection=n,this.values=i,this.status=t.statusTemplate.slice(),this.computeSlot=r,s&&(s._state=this);for(let t=0;t<this.config.dynamicSlots.length;t++)ensureAddr(this,t<<1);this.computeSlot=null;}field(t,e=!0){let n=this.config.address[t.id];if(null!=n)return ensureAddr(this,n),getAddr(this,n);if(e)throw new RangeError("Field is not present in this state")}update(...t){return resolveTransaction(this,t,!0)}applyTransaction(t){let e,n=this.config,{base:i,compartments:r}=n;for(let e of t.effects)e.is(Compartment.reconfigure)?(n&&(r=new Map,n.compartments.forEach(((t,e)=>r.set(e,t))),n=null),r.set(e.value.compartment,e.value.extension)):e.is(StateEffect.reconfigure)?(n=null,i=e.value):e.is(StateEffect.appendConfig)&&(n=null,i=asArray$1(i).concat(e.value));if(n)e=t.startState.values.slice();else {n=Configuration.resolve(i,r,this),e=new EditorState(n,this.doc,this.selection,n.dynamicSlots.map((()=>null)),((t,e)=>e.reconfigure(t,this)),null).values;}new EditorState(n,t.newDoc,t.newSelection,e,((e,n)=>n.update(e,t)),t);}replaceSelection(t){return "string"==typeof t&&(t=this.toText(t)),this.changeByRange((e=>({changes:{from:e.from,to:e.to,insert:t},range:EditorSelection.cursor(e.from+t.length)})))}changeByRange(t){let e=this.selection,n=t(e.ranges[0]),i=this.changes(n.changes),r=[n.range],s=asArray$1(n.effects);for(let n=1;n<e.ranges.length;n++){let o=t(e.ranges[n]),a=this.changes(o.changes),h=a.map(i);for(let t=0;t<n;t++)r[t]=r[t].map(h);let l=i.mapDesc(a,!0);r.push(o.range.map(l)),i=i.compose(h),s=StateEffect.mapEffects(s,h).concat(StateEffect.mapEffects(asArray$1(o.effects),l));}return {changes:i,selection:EditorSelection.create(r,e.mainIndex),effects:s}}changes(t=[]){return t instanceof ChangeSet?t:ChangeSet.of(t,this.doc.length,this.facet(EditorState.lineSeparator))}toText(t){return Text$1.of(t.split(this.facet(EditorState.lineSeparator)||DefaultSplit))}sliceDoc(t=0,e=this.doc.length){return this.doc.sliceString(t,e,this.lineBreak)}facet(t){let e=this.config.address[t.id];return null==e?t.default:(ensureAddr(this,e),getAddr(this,e))}toJSON(t){let e={doc:this.sliceDoc(),selection:this.selection.toJSON()};if(t)for(let n in t){let i=t[n];i instanceof StateField&&null!=this.config.address[i.id]&&(e[n]=i.spec.toJSON(this.field(t[n]),this));}return e}static fromJSON(t,e={},n){if(!t||"string"!=typeof t.doc)throw new RangeError("Invalid JSON representation for EditorState");let i=[];if(n)for(let e in n)if(Object.prototype.hasOwnProperty.call(t,e)){let r=n[e],s=t[e];i.push(r.init((t=>r.spec.fromJSON(s,t))));}return EditorState.create({doc:t.doc,selection:EditorSelection.fromJSON(t.selection),extensions:e.extensions?i.concat([e.extensions]):i})}static create(t={}){let e=Configuration.resolve(t.extensions||[],new Map),n=t.doc instanceof Text$1?t.doc:Text$1.of((t.doc||"").split(e.staticFacet(EditorState.lineSeparator)||DefaultSplit)),i=t.selection?t.selection instanceof EditorSelection?t.selection:EditorSelection.single(t.selection.anchor,t.selection.head):EditorSelection.single(0);return checkSelection(i,n.length),e.staticFacet(allowMultipleSelections)||(i=i.asSingle()),new EditorState(e,n,i,e.dynamicSlots.map((()=>null)),((t,e)=>e.create(t)),null)}get tabSize(){return this.facet(EditorState.tabSize)}get lineBreak(){return this.facet(EditorState.lineSeparator)||"\n"}get readOnly(){return this.facet(readOnly)}phrase(t,...e){for(let e of this.facet(EditorState.phrases))if(Object.prototype.hasOwnProperty.call(e,t)){t=e[t];break}return e.length&&(t=t.replace(/\$(\$|\d*)/g,((t,n)=>{if("$"==n)return "$";let i=+(n||1);return !i||i>e.length?t:e[i-1]}))),t}languageDataAt(t,e,n=-1){let i=[];for(let r of this.facet(languageData))for(let s of r(this,e,n))Object.prototype.hasOwnProperty.call(s,t)&&i.push(s[t]);return i}charCategorizer(t){return makeCategorizer(this.languageDataAt("wordChars",t).join(""))}wordAt(t){let{text:e,from:n,length:i}=this.doc.lineAt(t),r=this.charCategorizer(t),s=t-n,o=t-n;for(;s>0;){let t=findClusterBreak(e,s,!1);if(r(e.slice(t,s))!=CharCategory.Word)break;s=t;}for(;o<i;){let t=findClusterBreak(e,o);if(r(e.slice(o,t))!=CharCategory.Word)break;o=t;}return s==o?null:EditorSelection.range(s+n,o+n)}}function combineConfig(t,e,n={}){let i={};for(let e of t)for(let t of Object.keys(e)){let r=e[t],s=i[t];if(void 0===s)i[t]=r;else if(s===r||void 0===r);else {if(!Object.hasOwnProperty.call(n,t))throw new Error("Config merge conflict for field "+t);i[t]=n[t](s,r);}}for(let t in e)void 0===i[t]&&(i[t]=e[t]);return i}EditorState.allowMultipleSelections=allowMultipleSelections,EditorState.tabSize=Facet.define({combine:t=>t.length?t[0]:4}),EditorState.lineSeparator=lineSeparator,EditorState.readOnly=readOnly,EditorState.phrases=Facet.define({compare(t,e){let n=Object.keys(t),i=Object.keys(e);return n.length==i.length&&n.every((n=>t[n]==e[n]))}}),EditorState.languageData=languageData,EditorState.changeFilter=changeFilter,EditorState.transactionFilter=transactionFilter,EditorState.transactionExtender=transactionExtender,Compartment.reconfigure=StateEffect.define();class RangeValue{eq(t){return this==t}range(t,e=t){return Range$1.create(t,e,this)}}RangeValue.prototype.startSide=RangeValue.prototype.endSide=0,RangeValue.prototype.point=!1,RangeValue.prototype.mapMode=MapMode.TrackDel;class Range$1{constructor(t,e,n){this.from=t,this.to=e,this.value=n;}static create(t,e,n){return new Range$1(t,e,n)}}function cmpRange(t,e){return t.from-e.from||t.value.startSide-e.value.startSide}class Chunk{constructor(t,e,n,i){this.from=t,this.to=e,this.value=n,this.maxPoint=i;}get length(){return this.to[this.to.length-1]}findIndex(t,e,n,i=0){let r=n?this.to:this.from;for(let s=i,o=r.length;;){if(s==o)return s;let i=s+o>>1,a=r[i]-t||(n?this.value[i].endSide:this.value[i].startSide)-e;if(i==s)return a>=0?s:o;a>=0?o=i:s=i+1;}}between(t,e,n,i){for(let r=this.findIndex(e,-1e9,!0),s=this.findIndex(n,1e9,!1,r);r<s;r++)if(!1===i(this.from[r]+t,this.to[r]+t,this.value[r]))return !1}map(t,e){let n=[],i=[],r=[],s=-1,o=-1;for(let a=0;a<this.value.length;a++){let h,l,c=this.value[a],f=this.from[a]+t,u=this.to[a]+t;if(f==u){let t=e.mapPos(f,c.startSide,c.mapMode);if(null==t)continue;if(h=l=t,c.startSide!=c.endSide&&(l=e.mapPos(f,c.endSide),l<h))continue}else if(h=e.mapPos(f,c.startSide),l=e.mapPos(u,c.endSide),h>l||h==l&&c.startSide>0&&c.endSide<=0)continue;(l-h||c.endSide-c.startSide)<0||(s<0&&(s=h),c.point&&(o=Math.max(o,l-h)),n.push(c),i.push(h-s),r.push(l-s));}return {mapped:n.length?new Chunk(i,r,n,o):null,pos:s}}}class RangeSet{constructor(t,e,n,i){this.chunkPos=t,this.chunk=e,this.nextLayer=n,this.maxPoint=i;}static create(t,e,n,i){return new RangeSet(t,e,n,i)}get length(){let t=this.chunk.length-1;return t<0?0:Math.max(this.chunkEnd(t),this.nextLayer.length)}get size(){if(this.isEmpty)return 0;let t=this.nextLayer.size;for(let e of this.chunk)t+=e.value.length;return t}chunkEnd(t){return this.chunkPos[t]+this.chunk[t].length}update(t){let{add:e=[],sort:n=!1,filterFrom:i=0,filterTo:r=this.length}=t,s=t.filter;if(0==e.length&&!s)return this;if(n&&(e=e.slice().sort(cmpRange)),this.isEmpty)return e.length?RangeSet.of(e):this;let o=new LayerCursor(this,null,-1).goto(0),a=0,h=[],l=new RangeSetBuilder;for(;o.value||a<e.length;)if(a<e.length&&(o.from-e[a].from||o.startSide-e[a].value.startSide)>=0){let t=e[a++];l.addInner(t.from,t.to,t.value)||h.push(t);}else 1==o.rangeIndex&&o.chunkIndex<this.chunk.length&&(a==e.length||this.chunkEnd(o.chunkIndex)<e[a].from)&&(!s||i>this.chunkEnd(o.chunkIndex)||r<this.chunkPos[o.chunkIndex])&&l.addChunk(this.chunkPos[o.chunkIndex],this.chunk[o.chunkIndex])?o.nextChunk():((!s||i>o.to||r<o.from||s(o.from,o.to,o.value))&&(l.addInner(o.from,o.to,o.value)||h.push(Range$1.create(o.from,o.to,o.value))),o.next());return l.finishInner(this.nextLayer.isEmpty&&!h.length?RangeSet.empty:this.nextLayer.update({add:h,filter:s,filterFrom:i,filterTo:r}))}map(t){if(t.empty||this.isEmpty)return this;let e=[],n=[],i=-1;for(let r=0;r<this.chunk.length;r++){let s=this.chunkPos[r],o=this.chunk[r],a=t.touchesRange(s,s+o.length);if(!1===a)i=Math.max(i,o.maxPoint),e.push(o),n.push(t.mapPos(s));else if(!0===a){let{mapped:r,pos:a}=o.map(s,t);r&&(i=Math.max(i,r.maxPoint),e.push(r),n.push(a));}}let r=this.nextLayer.map(t);return 0==e.length?r:new RangeSet(n,e,r||RangeSet.empty,i)}between(t,e,n){if(!this.isEmpty){for(let i=0;i<this.chunk.length;i++){let r=this.chunkPos[i],s=this.chunk[i];if(e>=r&&t<=r+s.length&&!1===s.between(r,t-r,e-r,n))return}this.nextLayer.between(t,e,n);}}iter(t=0){return HeapCursor.from([this]).goto(t)}get isEmpty(){return this.nextLayer==this}static iter(t,e=0){return HeapCursor.from(t).goto(e)}static compare(t,e,n,i,r=-1){let s=t.filter((t=>t.maxPoint>0||!t.isEmpty&&t.maxPoint>=r)),o=e.filter((t=>t.maxPoint>0||!t.isEmpty&&t.maxPoint>=r)),a=findSharedChunks(s,o,n),h=new SpanCursor(s,a,r),l=new SpanCursor(o,a,r);n.iterGaps(((t,e,n)=>compare(h,t,l,e,n,i))),n.empty&&0==n.length&&compare(h,0,l,0,0,i);}static eq(t,e,n=0,i){null==i&&(i=999999999);let r=t.filter((t=>!t.isEmpty&&e.indexOf(t)<0)),s=e.filter((e=>!e.isEmpty&&t.indexOf(e)<0));if(r.length!=s.length)return !1;if(!r.length)return !0;let o=findSharedChunks(r,s),a=new SpanCursor(r,o,0).goto(n),h=new SpanCursor(s,o,0).goto(n);for(;;){if(a.to!=h.to||!sameValues(a.active,h.active)||a.point&&(!h.point||!a.point.eq(h.point)))return !1;if(a.to>i)return !0;a.next(),h.next();}}static spans(t,e,n,i,r=-1){let s=new SpanCursor(t,null,r).goto(e),o=e,a=s.openStart;for(;;){let t=Math.min(s.to,n);if(s.point){let n=s.activeForPoint(s.to),r=s.pointFrom<e?n.length+1:Math.min(n.length,a);i.point(o,t,s.point,n,r,s.pointRank),a=Math.min(s.openEnd(t),n.length);}else t>o&&(i.span(o,t,s.active,a),a=s.openEnd(t));if(s.to>n)return a+(s.point&&s.to>n?1:0);o=s.to,s.next();}}static of(t,e=!1){let n=new RangeSetBuilder;for(let i of t instanceof Range$1?[t]:e?lazySort(t):t)n.add(i.from,i.to,i.value);return n.finish()}}function lazySort(t){if(t.length>1)for(let e=t[0],n=1;n<t.length;n++){let i=t[n];if(cmpRange(e,i)>0)return t.slice().sort(cmpRange);e=i;}return t}RangeSet.empty=new RangeSet([],[],null,-1),RangeSet.empty.nextLayer=RangeSet.empty;class RangeSetBuilder{finishChunk(t){this.chunks.push(new Chunk(this.from,this.to,this.value,this.maxPoint)),this.chunkPos.push(this.chunkStart),this.chunkStart=-1,this.setMaxPoint=Math.max(this.setMaxPoint,this.maxPoint),this.maxPoint=-1,t&&(this.from=[],this.to=[],this.value=[]);}constructor(){this.chunks=[],this.chunkPos=[],this.chunkStart=-1,this.last=null,this.lastFrom=-1e9,this.lastTo=-1e9,this.from=[],this.to=[],this.value=[],this.maxPoint=-1,this.setMaxPoint=-1,this.nextLayer=null;}add(t,e,n){this.addInner(t,e,n)||(this.nextLayer||(this.nextLayer=new RangeSetBuilder)).add(t,e,n);}addInner(t,e,n){let i=t-this.lastTo||n.startSide-this.last.endSide;if(i<=0&&(t-this.lastFrom||n.startSide-this.last.startSide)<0)throw new Error("Ranges must be added sorted by `from` position and `startSide`");return !(i<0)&&(250==this.from.length&&this.finishChunk(!0),this.chunkStart<0&&(this.chunkStart=t),this.from.push(t-this.chunkStart),this.to.push(e-this.chunkStart),this.last=n,this.lastFrom=t,this.lastTo=e,this.value.push(n),n.point&&(this.maxPoint=Math.max(this.maxPoint,e-t)),!0)}addChunk(t,e){if((t-this.lastTo||e.value[0].startSide-this.last.endSide)<0)return !1;this.from.length&&this.finishChunk(!0),this.setMaxPoint=Math.max(this.setMaxPoint,e.maxPoint),this.chunks.push(e),this.chunkPos.push(t);let n=e.value.length-1;return this.last=e.value[n],this.lastFrom=e.from[n]+t,this.lastTo=e.to[n]+t,!0}finish(){return this.finishInner(RangeSet.empty)}finishInner(t){if(this.from.length&&this.finishChunk(!1),0==this.chunks.length)return t;let e=RangeSet.create(this.chunkPos,this.chunks,this.nextLayer?this.nextLayer.finishInner(t):t,this.setMaxPoint);return this.from=null,e}}function findSharedChunks(t,e,n){let i=new Map;for(let e of t)for(let t=0;t<e.chunk.length;t++)e.chunk[t].maxPoint<=0&&i.set(e.chunk[t],e.chunkPos[t]);let r=new Set;for(let t of e)for(let e=0;e<t.chunk.length;e++){let s=i.get(t.chunk[e]);null==s||(n?n.mapPos(s):s)!=t.chunkPos[e]||(null==n?void 0:n.touchesRange(s,s+t.chunk[e].length))||r.add(t.chunk[e]);}return r}class LayerCursor{constructor(t,e,n,i=0){this.layer=t,this.skip=e,this.minPoint=n,this.rank=i;}get startSide(){return this.value?this.value.startSide:0}get endSide(){return this.value?this.value.endSide:0}goto(t,e=-1e9){return this.chunkIndex=this.rangeIndex=0,this.gotoInner(t,e,!1),this}gotoInner(t,e,n){for(;this.chunkIndex<this.layer.chunk.length;){let e=this.layer.chunk[this.chunkIndex];if(!(this.skip&&this.skip.has(e)||this.layer.chunkEnd(this.chunkIndex)<t||e.maxPoint<this.minPoint))break;this.chunkIndex++,n=!1;}if(this.chunkIndex<this.layer.chunk.length){let i=this.layer.chunk[this.chunkIndex].findIndex(t-this.layer.chunkPos[this.chunkIndex],e,!0);(!n||this.rangeIndex<i)&&this.setRangeIndex(i);}this.next();}forward(t,e){(this.to-t||this.endSide-e)<0&&this.gotoInner(t,e,!0);}next(){for(;;){if(this.chunkIndex==this.layer.chunk.length){this.from=this.to=1e9,this.value=null;break}{let t=this.layer.chunkPos[this.chunkIndex],e=this.layer.chunk[this.chunkIndex],n=t+e.from[this.rangeIndex];if(this.from=n,this.to=t+e.to[this.rangeIndex],this.value=e.value[this.rangeIndex],this.setRangeIndex(this.rangeIndex+1),this.minPoint<0||this.value.point&&this.to-this.from>=this.minPoint)break}}}setRangeIndex(t){if(t==this.layer.chunk[this.chunkIndex].value.length){if(this.chunkIndex++,this.skip)for(;this.chunkIndex<this.layer.chunk.length&&this.skip.has(this.layer.chunk[this.chunkIndex]);)this.chunkIndex++;this.rangeIndex=0;}else this.rangeIndex=t;}nextChunk(){this.chunkIndex++,this.rangeIndex=0,this.next();}compare(t){return this.from-t.from||this.startSide-t.startSide||this.rank-t.rank||this.to-t.to||this.endSide-t.endSide}}class HeapCursor{constructor(t){this.heap=t;}static from(t,e=null,n=-1){let i=[];for(let r=0;r<t.length;r++)for(let s=t[r];!s.isEmpty;s=s.nextLayer)s.maxPoint>=n&&i.push(new LayerCursor(s,e,n,r));return 1==i.length?i[0]:new HeapCursor(i)}get startSide(){return this.value?this.value.startSide:0}goto(t,e=-1e9){for(let n of this.heap)n.goto(t,e);for(let t=this.heap.length>>1;t>=0;t--)heapBubble(this.heap,t);return this.next(),this}forward(t,e){for(let n of this.heap)n.forward(t,e);for(let t=this.heap.length>>1;t>=0;t--)heapBubble(this.heap,t);(this.to-t||this.value.endSide-e)<0&&this.next();}next(){if(0==this.heap.length)this.from=this.to=1e9,this.value=null,this.rank=-1;else {let t=this.heap[0];this.from=t.from,this.to=t.to,this.value=t.value,this.rank=t.rank,t.value&&t.next(),heapBubble(this.heap,0);}}}function heapBubble(t,e){for(let n=t[e];;){let i=1+(e<<1);if(i>=t.length)break;let r=t[i];if(i+1<t.length&&r.compare(t[i+1])>=0&&(r=t[i+1],i++),n.compare(r)<0)break;t[i]=n,t[e]=r,e=i;}}class SpanCursor{constructor(t,e,n){this.minPoint=n,this.active=[],this.activeTo=[],this.activeRank=[],this.minActive=-1,this.point=null,this.pointFrom=0,this.pointRank=0,this.to=-1e9,this.endSide=0,this.openStart=-1,this.cursor=HeapCursor.from(t,e,n);}goto(t,e=-1e9){return this.cursor.goto(t,e),this.active.length=this.activeTo.length=this.activeRank.length=0,this.minActive=-1,this.to=t,this.endSide=e,this.openStart=-1,this.next(),this}forward(t,e){for(;this.minActive>-1&&(this.activeTo[this.minActive]-t||this.active[this.minActive].endSide-e)<0;)this.removeActive(this.minActive);this.cursor.forward(t,e);}removeActive(t){remove(this.active,t),remove(this.activeTo,t),remove(this.activeRank,t),this.minActive=findMinIndex(this.active,this.activeTo);}addActive(t){let e=0,{value:n,to:i,rank:r}=this.cursor;for(;e<this.activeRank.length&&this.activeRank[e]<=r;)e++;insert(this.active,e,n),insert(this.activeTo,e,i),insert(this.activeRank,e,r),t&&insert(t,e,this.cursor.from),this.minActive=findMinIndex(this.active,this.activeTo);}next(){let t=this.to,e=this.point;this.point=null;let n=this.openStart<0?[]:null;for(;;){let i=this.minActive;if(i>-1&&(this.activeTo[i]-this.cursor.from||this.active[i].endSide-this.cursor.startSide)<0){if(this.activeTo[i]>t){this.to=this.activeTo[i],this.endSide=this.active[i].endSide;break}this.removeActive(i),n&&remove(n,i);}else {if(!this.cursor.value){this.to=this.endSide=1e9;break}if(this.cursor.from>t){this.to=this.cursor.from,this.endSide=this.cursor.startSide;break}{let t=this.cursor.value;if(t.point){if(!(e&&this.cursor.to==this.to&&this.cursor.from<this.cursor.to)){this.point=t,this.pointFrom=this.cursor.from,this.pointRank=this.cursor.rank,this.to=this.cursor.to,this.endSide=t.endSide,this.cursor.next(),this.forward(this.to,this.endSide);break}this.cursor.next();}else this.addActive(n),this.cursor.next();}}}if(n){this.openStart=0;for(let e=n.length-1;e>=0&&n[e]<t;e--)this.openStart++;}}activeForPoint(t){if(!this.active.length)return this.active;let e=[];for(let n=this.active.length-1;n>=0&&!(this.activeRank[n]<this.pointRank);n--)(this.activeTo[n]>t||this.activeTo[n]==t&&this.active[n].endSide>=this.point.endSide)&&e.push(this.active[n]);return e.reverse()}openEnd(t){let e=0;for(let n=this.activeTo.length-1;n>=0&&this.activeTo[n]>t;n--)e++;return e}}function compare(t,e,n,i,r,s){t.goto(e),n.goto(i);let o=i+r,a=i,h=i-e;for(;;){let e=t.to+h-n.to||t.endSide-n.endSide,i=e<0?t.to+h:n.to,r=Math.min(i,o);if(t.point||n.point?t.point&&n.point&&(t.point==n.point||t.point.eq(n.point))&&sameValues(t.activeForPoint(t.to),n.activeForPoint(n.to))||s.comparePoint(a,r,t.point,n.point):r>a&&!sameValues(t.active,n.active)&&s.compareRange(a,r,t.active,n.active),i>o)break;a=i,e<=0&&t.next(),e>=0&&n.next();}}function sameValues(t,e){if(t.length!=e.length)return !1;for(let n=0;n<t.length;n++)if(t[n]!=e[n]&&!t[n].eq(e[n]))return !1;return !0}function remove(t,e){for(let n=e,i=t.length-1;n<i;n++)t[n]=t[n+1];t.pop();}function insert(t,e,n){for(let n=t.length-1;n>=e;n--)t[n+1]=t[n];t[e]=n;}function findMinIndex(t,e){let n=-1,i=1e9;for(let r=0;r<e.length;r++)(e[r]-i||t[r].endSide-t[n].endSide)<0&&(n=r,i=e[r]);return n}function countColumn(t,e,n=t.length){let i=0;for(let r=0;r<n;)9==t.charCodeAt(r)?(i+=e-i%e,r++):(i++,r=findClusterBreak(t,r));return i}function findColumn(t,e,n,i){for(let i=0,r=0;;){if(r>=e)return i;if(i==t.length)break;r+=9==t.charCodeAt(i)?n-r%n:1,i=findClusterBreak(t,i);}return !0===i?-1:t.length}

    const C="ͼ",COUNT="undefined"==typeof Symbol?"__ͼ":Symbol.for(C),SET="undefined"==typeof Symbol?"__styleSet"+Math.floor(1e8*Math.random()):Symbol("styleSet"),top="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:{};class StyleModule{constructor(e,t){this.rules=[];let{finish:l}=t||{};function s(e){return /^@/.test(e)?[e]:e.split(/,\s*/)}function o(e,t,i,n){let r=[],h=/^@(\w+)\b/.exec(e[0]),u=h&&"keyframes"==h[1];if(h&&null==t)return i.push(e[0]+";");for(let l in t){let n=t[l];if(/&/.test(l))o(l.split(/,\s*/).map((t=>e.map((e=>t.replace(/&/,e))))).reduce(((e,t)=>e.concat(t))),n,i);else if(n&&"object"==typeof n){if(!h)throw new RangeError("The value of a property ("+l+") should be a primitive value.");o(s(l),n,r,u);}else null!=n&&r.push(l.replace(/_.*/,"").replace(/[A-Z]/g,(e=>"-"+e.toLowerCase()))+": "+n+";");}(r.length||u)&&i.push((!l||h||n?e:e.map(l)).join(", ")+" {"+r.join(" ")+"}");}for(let t in e)o(s(t),e[t],this.rules);}getRules(){return this.rules.join("\n")}static newName(){let e=top[COUNT]||1;return top[COUNT]=e+1,C+e.toString(36)}static mount(e,t){(e[SET]||new StyleSet(e)).mount(Array.isArray(t)?t:[t]);}}let adoptedSet=new Map;class StyleSet{constructor(e){let t=e.ownerDocument||e,l=t.defaultView;if(!e.head&&e.adoptedStyleSheets&&l.CSSStyleSheet){let s=adoptedSet.get(t);if(s)return e.adoptedStyleSheets=[s.sheet,...e.adoptedStyleSheets],e[SET]=s;this.sheet=new l.CSSStyleSheet,e.adoptedStyleSheets=[this.sheet,...e.adoptedStyleSheets],adoptedSet.set(t,this);}else {this.styleTag=t.createElement("style");let l=e.head||e;l.insertBefore(this.styleTag,l.firstChild);}this.modules=[],e[SET]=this;}mount(e){let t=this.sheet,l=0,s=0;for(let o=0;o<e.length;o++){let i=e[o],n=this.modules.indexOf(i);if(n<s&&n>-1&&(this.modules.splice(n,1),s--,n=-1),-1==n){if(this.modules.splice(s++,0,i),t)for(let e=0;e<i.rules.length;e++)t.insertRule(i.rules[e],l++);}else {for(;s<n;)l+=this.modules[s++].rules.length;l+=i.rules.length,s++;}}if(!t){let e="";for(let t=0;t<this.modules.length;t++)e+=this.modules[t].getRules()+"\n";this.styleTag.textContent=e;}}}

    var base={8:"Backspace",9:"Tab",10:"Enter",12:"NumLock",13:"Enter",16:"Shift",17:"Control",18:"Alt",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",44:"PrintScreen",45:"Insert",46:"Delete",59:";",61:"=",91:"Meta",92:"Meta",106:"*",107:"+",108:",",109:"-",110:".",111:"/",144:"NumLock",145:"ScrollLock",160:"Shift",161:"Shift",162:"Control",163:"Control",164:"Alt",165:"Alt",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'"};var shift={48:")",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",61:"+",173:"_",186:":",187:"+",188:"<",189:"_",190:">",191:"?",192:"~",219:"{",220:"|",221:"}",222:'"'};for(var mac="undefined"!=typeof navigator&&/Mac/.test(navigator.platform),ie$1="undefined"!=typeof navigator&&/MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent),i=0;i<10;i++)base[48+i]=base[96+i]=String(i);for(i=1;i<=24;i++)base[i+111]="F"+i;for(i=65;i<=90;i++)base[i]=String.fromCharCode(i+32),shift[i]=String.fromCharCode(i);for(var code in base)shift.hasOwnProperty(code)||(shift[code]=base[code]);function keyName(e){var r=!(mac&&e.metaKey&&e.shiftKey&&!e.ctrlKey&&!e.altKey||ie$1&&e.shiftKey&&e.key&&1==e.key.length||"Unidentified"==e.key)&&e.key||(e.shiftKey?shift:base)[e.keyCode]||e.key||"Unidentified";return "Esc"==r&&(r="Escape"),"Del"==r&&(r="Delete"),"Left"==r&&(r="ArrowLeft"),"Up"==r&&(r="ArrowUp"),"Right"==r&&(r="ArrowRight"),"Down"==r&&(r="ArrowDown"),r}

    function getSelection(t){let e;return e=11==t.nodeType?t.getSelection?t:t.ownerDocument:t,e.getSelection()}function contains(t,e){return !!e&&(t==e||t.contains(1!=e.nodeType?e.parentNode:e))}function deepActiveElement(t){let e=t.activeElement;for(;e&&e.shadowRoot;)e=e.shadowRoot.activeElement;return e}function hasSelection(t,e){if(!e.anchorNode)return !1;try{return contains(t,e.anchorNode)}catch(t){return !1}}function clientRectsFor(t){return 3==t.nodeType?textRange(t,0,t.nodeValue.length).getClientRects():1==t.nodeType?t.getClientRects():[]}function isEquivalentPosition(t,e,i,o){return !!i&&(scanFor(t,e,i,o,-1)||scanFor(t,e,i,o,1))}function domIndex(t){for(var e=0;;e++)if(!(t=t.previousSibling))return e}function scanFor(t,e,i,o,s){for(;;){if(t==i&&e==o)return !0;if(e==(s<0?0:maxOffset(t))){if("DIV"==t.nodeName)return !1;let i=t.parentNode;if(!i||1!=i.nodeType)return !1;e=domIndex(t)+(s<0?0:1),t=i;}else {if(1!=t.nodeType)return !1;if(1==(t=t.childNodes[e+(s<0?-1:0)]).nodeType&&"false"==t.contentEditable)return !1;e=s<0?maxOffset(t):0;}}}function maxOffset(t){return 3==t.nodeType?t.nodeValue.length:t.childNodes.length}function flattenRect(t,e){let i=e?t.left:t.right;return {left:i,right:i,top:t.top,bottom:t.bottom}}function windowRect(t){return {left:0,right:t.innerWidth,top:0,bottom:t.innerHeight}}function scrollRectIntoView(t,e,i,o,s,n,r,l){let a=t.ownerDocument,h=a.defaultView||window;for(let c=t;c;)if(1==c.nodeType){let t,d=c==a.body;if(d)t=windowRect(h);else {if(c.scrollHeight<=c.clientHeight&&c.scrollWidth<=c.clientWidth){c=c.assignedSlot||c.parentNode;continue}let e=c.getBoundingClientRect();t={left:e.left,right:e.left+c.clientWidth,top:e.top,bottom:e.top+c.clientHeight};}let u=0,p=0;if("nearest"==s)e.top<t.top?(p=-(t.top-e.top+r),i>0&&e.bottom>t.bottom+p&&(p=e.bottom-t.bottom+p+r)):e.bottom>t.bottom&&(p=e.bottom-t.bottom+r,i<0&&e.top-p<t.top&&(p=-(t.top+p-e.top+r)));else {let o=e.bottom-e.top,n=t.bottom-t.top;p=("center"==s&&o<=n?e.top+o/2-n/2:"start"==s||"center"==s&&i<0?e.top-r:e.bottom-n+r)-t.top;}if("nearest"==o)e.left<t.left?(u=-(t.left-e.left+n),i>0&&e.right>t.right+u&&(u=e.right-t.right+u+n)):e.right>t.right&&(u=e.right-t.right+n,i<0&&e.left<t.left+u&&(u=-(t.left+u-e.left+n)));else {u=("center"==o?e.left+(e.right-e.left)/2-(t.right-t.left)/2:"start"==o==l?e.left-n:e.right-(t.right-t.left)+n)-t.left;}if(u||p)if(d)h.scrollBy(u,p);else {let t=0,i=0;if(p){let t=c.scrollTop;c.scrollTop+=p,i=c.scrollTop-t;}if(u){let e=c.scrollLeft;c.scrollLeft+=u,t=c.scrollLeft-e;}e={left:e.left-t,top:e.top-i,right:e.right-t,bottom:e.bottom-i},t&&Math.abs(t-u)<1&&(o="nearest"),i&&Math.abs(i-p)<1&&(s="nearest");}if(d)break;c=c.assignedSlot||c.parentNode;}else {if(11!=c.nodeType)break;c=c.host;}}function scrollableParent(t){let e=t.ownerDocument;for(let i=t.parentNode;i&&i!=e.body;)if(1==i.nodeType){if(i.scrollHeight>i.clientHeight||i.scrollWidth>i.clientWidth)return i;i=i.assignedSlot||i.parentNode;}else {if(11!=i.nodeType)break;i=i.host;}return null}class DOMSelectionState{constructor(){this.anchorNode=null,this.anchorOffset=0,this.focusNode=null,this.focusOffset=0;}eq(t){return this.anchorNode==t.anchorNode&&this.anchorOffset==t.anchorOffset&&this.focusNode==t.focusNode&&this.focusOffset==t.focusOffset}setRange(t){let{anchorNode:e,focusNode:i}=t;this.set(e,Math.min(t.anchorOffset,e?maxOffset(e):0),i,Math.min(t.focusOffset,i?maxOffset(i):0));}set(t,e,i,o){this.anchorNode=t,this.anchorOffset=e,this.focusNode=i,this.focusOffset=o;}}let scratchRange,preventScrollSupported=null;function focusPreventScroll(t){if(t.setActive)return t.setActive();if(preventScrollSupported)return t.focus(preventScrollSupported);let e=[];for(let i=t;i&&(e.push(i,i.scrollTop,i.scrollLeft),i!=i.ownerDocument);i=i.parentNode);if(t.focus(null==preventScrollSupported?{get preventScroll(){return preventScrollSupported={preventScroll:!0},!0}}:void 0),!preventScrollSupported){preventScrollSupported=!1;for(let t=0;t<e.length;){let i=e[t++],o=e[t++],s=e[t++];i.scrollTop!=o&&(i.scrollTop=o),i.scrollLeft!=s&&(i.scrollLeft=s);}}}function textRange(t,e,i=e){let o=scratchRange||(scratchRange=document.createRange());return o.setEnd(t,i),o.setStart(t,e),o}function dispatchKey(t,e,i){let o={key:e,code:e,keyCode:i,which:i,cancelable:!0},s=new KeyboardEvent("keydown",o);s.synthetic=!0,t.dispatchEvent(s);let n=new KeyboardEvent("keyup",o);return n.synthetic=!0,t.dispatchEvent(n),s.defaultPrevented||n.defaultPrevented}function getRoot(t){for(;t;){if(t&&(9==t.nodeType||11==t.nodeType&&t.host))return t;t=t.assignedSlot||t.parentNode;}return null}function clearAttributes(t){for(;t.attributes.length;)t.removeAttributeNode(t.attributes[0]);}function atElementStart(t,e){let i=e.focusNode,o=e.focusOffset;if(!i||e.anchorNode!=i||e.anchorOffset!=o)return !1;for(o=Math.min(o,maxOffset(i));;)if(o){if(1!=i.nodeType)return !1;let t=i.childNodes[o-1];"false"==t.contentEditable?o--:(i=t,o=maxOffset(i));}else {if(i==t)return !0;o=domIndex(i),i=i.parentNode;}}class DOMPos{constructor(t,e,i=!0){this.node=t,this.offset=e,this.precise=i;}static before(t,e){return new DOMPos(t.parentNode,domIndex(t),e)}static after(t,e){return new DOMPos(t.parentNode,domIndex(t)+1,e)}}const noChildren=[];class ContentView{constructor(){this.parent=null,this.dom=null,this.dirty=2;}get overrideDOMText(){return null}get posAtStart(){return this.parent?this.parent.posBefore(this):0}get posAtEnd(){return this.posAtStart+this.length}posBefore(t){let e=this.posAtStart;for(let i of this.children){if(i==t)return e;e+=i.length+i.breakAfter;}throw new RangeError("Invalid child in posBefore")}posAfter(t){return this.posBefore(t)+t.length}sync(t,e){if(2&this.dirty){let i,o=this.dom,s=null;for(let n of this.children){if(n.dirty){if(!n.dom&&(i=s?s.nextSibling:o.firstChild)){let t=ContentView.get(i);(!t||!t.parent&&t.canReuseDOM(n))&&n.reuseDOM(i);}n.sync(t,e),n.dirty=0;}if(i=s?s.nextSibling:o.firstChild,e&&!e.written&&e.node==o&&i!=n.dom&&(e.written=!0),n.dom.parentNode==o)for(;i&&i!=n.dom;)i=rm$1(i);else o.insertBefore(n.dom,i);s=n.dom;}for(i=s?s.nextSibling:o.firstChild,i&&e&&e.node==o&&(e.written=!0);i;)i=rm$1(i);}else if(1&this.dirty)for(let i of this.children)i.dirty&&(i.sync(t,e),i.dirty=0);}reuseDOM(t){}localPosFromDOM(t,e){let i;if(t==this.dom)i=this.dom.childNodes[e];else {let o=0==maxOffset(t)?0:0==e?-1:1;for(;;){let e=t.parentNode;if(e==this.dom)break;0==o&&e.firstChild!=e.lastChild&&(o=t==e.firstChild?-1:1),t=e;}i=o<0?t:t.nextSibling;}if(i==this.dom.firstChild)return 0;for(;i&&!ContentView.get(i);)i=i.nextSibling;if(!i)return this.length;for(let t=0,e=0;;t++){let o=this.children[t];if(o.dom==i)return e;e+=o.length+o.breakAfter;}}domBoundsAround(t,e,i=0){let o=-1,s=-1,n=-1,r=-1;for(let l=0,a=i,h=i;l<this.children.length;l++){let i=this.children[l],c=a+i.length;if(a<t&&c>e)return i.domBoundsAround(t,e,a);if(c>=t&&-1==o&&(o=l,s=a),a>e&&i.dom.parentNode==this.dom){n=l,r=h;break}h=c,a=c+i.breakAfter;}return {from:s,to:r<0?i+this.length:r,startDOM:(o?this.children[o-1].dom.nextSibling:null)||this.dom.firstChild,endDOM:n<this.children.length&&n>=0?this.children[n].dom:null}}markDirty(t=!1){this.dirty|=2,this.markParentsDirty(t);}markParentsDirty(t){for(let e=this.parent;e;e=e.parent){if(t&&(e.dirty|=2),1&e.dirty)return;e.dirty|=1,t=!1;}}setParent(t){this.parent!=t&&(this.parent=t,this.dirty&&this.markParentsDirty(!0));}setDOM(t){this.dom&&(this.dom.cmView=null),this.dom=t,t.cmView=this;}get rootView(){for(let t=this;;){let e=t.parent;if(!e)return t;t=e;}}replaceChildren(t,e,i=noChildren){this.markDirty();for(let i=t;i<e;i++){let t=this.children[i];t.parent==this&&t.destroy();}this.children.splice(t,e-t,...i);for(let t=0;t<i.length;t++)i[t].setParent(this);}ignoreMutation(t){return !1}ignoreEvent(t){return !1}childCursor(t=this.length){return new ChildCursor(this.children,t,this.children.length)}childPos(t,e=1){return this.childCursor().findPos(t,e)}toString(){let t=this.constructor.name.replace("View","");return t+(this.children.length?"("+this.children.join()+")":this.length?"["+("Text"==t?this.text:this.length)+"]":"")+(this.breakAfter?"#":"")}static get(t){return t.cmView}get isEditable(){return !0}get isWidget(){return !1}get isHidden(){return !1}merge(t,e,i,o,s,n){return !1}become(t){return !1}canReuseDOM(t){return t.constructor==this.constructor}getSide(){return 0}destroy(){this.parent=null;}}function rm$1(t){let e=t.nextSibling;return t.parentNode.removeChild(t),e}ContentView.prototype.breakAfter=0;class ChildCursor{constructor(t,e,i){this.children=t,this.pos=e,this.i=i,this.off=0;}findPos(t,e=1){for(;;){if(t>this.pos||t==this.pos&&(e>0||0==this.i||this.children[this.i-1].breakAfter))return this.off=t-this.pos,this;let i=this.children[--this.i];this.pos-=i.length+i.breakAfter;}}}function replaceRange(t,e,i,o,s,n,r,l,a){let{children:h}=t,c=h.length?h[e]:null,d=n.length?n[n.length-1]:null,u=d?d.breakAfter:r;if(!(e==o&&c&&!r&&!u&&n.length<2&&c.merge(i,s,n.length?d:null,0==i,l,a))){if(o<h.length){let t=h[o];t&&s<t.length?(e==o&&(t=t.split(s),s=0),!u&&d&&t.merge(0,s,d,!0,0,a)?n[n.length-1]=t:(s&&t.merge(0,s,null,!1,0,a),n.push(t))):(null==t?void 0:t.breakAfter)&&(d?d.breakAfter=1:r=1),o++;}for(c&&(c.breakAfter=r,i>0&&(!r&&n.length&&c.merge(i,c.length,n[0],!1,l,0)?c.breakAfter=n.shift().breakAfter:(i<c.length||c.children.length&&0==c.children[c.children.length-1].length)&&c.merge(i,c.length,null,!1,l,0),e++));e<o&&n.length;)if(h[o-1].become(n[n.length-1]))o--,n.pop(),a=n.length?0:l;else {if(!h[e].become(n[0]))break;e++,n.shift(),l=n.length?0:a;}!n.length&&e&&o<h.length&&!h[e-1].breakAfter&&h[o].merge(0,0,h[e-1],!1,l,a)&&e--,(e<o||n.length)&&t.replaceChildren(e,o,n);}}function mergeChildrenInto(t,e,i,o,s,n){let r=t.childCursor(),{i:l,off:a}=r.findPos(i,1),{i:h,off:c}=r.findPos(e,-1),d=e-i;for(let t of o)d+=t.length;t.length+=d,replaceRange(t,h,c,l,a,o,0,s,n);}let nav="undefined"!=typeof navigator?navigator:{userAgent:"",vendor:"",platform:""},doc="undefined"!=typeof document?document:{documentElement:{style:{}}};const ie_edge=/Edge\/(\d+)/.exec(nav.userAgent),ie_upto10=/MSIE \d/.test(nav.userAgent),ie_11up=/Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(nav.userAgent),ie=!!(ie_upto10||ie_11up||ie_edge),gecko=!ie&&/gecko\/(\d+)/i.test(nav.userAgent),chrome=!ie&&/Chrome\/(\d+)/.exec(nav.userAgent),webkit="webkitFontSmoothing"in doc.documentElement.style,safari=!ie&&/Apple Computer/.test(nav.vendor),ios=safari&&(/Mobile\/\w+/.test(nav.userAgent)||nav.maxTouchPoints>2);var browser={mac:ios||/Mac/.test(nav.platform),windows:/Win/.test(nav.platform),linux:/Linux|X11/.test(nav.platform),ie:ie,ie_version:ie_upto10?doc.documentMode||6:ie_11up?+ie_11up[1]:ie_edge?+ie_edge[1]:0,gecko:gecko,gecko_version:gecko?+(/Firefox\/(\d+)/.exec(nav.userAgent)||[0,0])[1]:0,chrome:!!chrome,chrome_version:chrome?+chrome[1]:0,ios:ios,android:/Android\b/.test(nav.userAgent),webkit:webkit,safari:safari,webkit_version:webkit?+(/\bAppleWebKit\/(\d+)/.exec(navigator.userAgent)||[0,0])[1]:0,tabSize:null!=doc.documentElement.style.tabSize?"tab-size":"-moz-tab-size"};class TextView extends ContentView{constructor(t){super(),this.text=t;}get length(){return this.text.length}createDOM(t){this.setDOM(t||document.createTextNode(this.text));}sync(t,e){this.dom||this.createDOM(),this.dom.nodeValue!=this.text&&(e&&e.node==this.dom&&(e.written=!0),this.dom.nodeValue=this.text);}reuseDOM(t){3==t.nodeType&&this.createDOM(t);}merge(t,e,i){return (!i||i instanceof TextView&&!(this.length-(e-t)+i.length>256))&&(this.text=this.text.slice(0,t)+(i?i.text:"")+this.text.slice(e),this.markDirty(),!0)}split(t){let e=new TextView(this.text.slice(t));return this.text=this.text.slice(0,t),this.markDirty(),e}localPosFromDOM(t,e){return t==this.dom?e:e?this.text.length:0}domAtPos(t){return new DOMPos(this.dom,t)}domBoundsAround(t,e,i){return {from:i,to:i+this.length,startDOM:this.dom,endDOM:this.dom.nextSibling}}coordsAt(t,e){return textCoords(this.dom,t,e)}}class MarkView extends ContentView{constructor(t,e=[],i=0){super(),this.mark=t,this.children=e,this.length=i;for(let t of e)t.setParent(this);}setAttrs(t){if(clearAttributes(t),this.mark.class&&(t.className=this.mark.class),this.mark.attrs)for(let e in this.mark.attrs)t.setAttribute(e,this.mark.attrs[e]);return t}reuseDOM(t){t.nodeName==this.mark.tagName.toUpperCase()&&(this.setDOM(t),this.dirty|=6);}sync(t,e){this.dom?4&this.dirty&&this.setAttrs(this.dom):this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))),super.sync(t,e);}merge(t,e,i,o,s,n){return (!i||!(!(i instanceof MarkView&&i.mark.eq(this.mark))||t&&s<=0||e<this.length&&n<=0))&&(mergeChildrenInto(this,t,e,i?i.children:[],s-1,n-1),this.markDirty(),!0)}split(t){let e=[],i=0,o=-1,s=0;for(let n of this.children){let r=i+n.length;r>t&&e.push(i<t?n.split(t-i):n),o<0&&i>=t&&(o=s),i=r,s++;}let n=this.length-t;return this.length=t,o>-1&&(this.children.length=o,this.markDirty()),new MarkView(this.mark,e,n)}domAtPos(t){return inlineDOMAtPos(this,t)}coordsAt(t,e){return coordsInChildren(this,t,e)}}function textCoords(t,e,i){let o=t.nodeValue.length;e>o&&(e=o);let s=e,n=e,r=0;0==e&&i<0||e==o&&i>=0?browser.chrome||browser.gecko||(e?(s--,r=1):n<o&&(n++,r=-1)):i<0?s--:n<o&&n++;let l=textRange(t,s,n).getClientRects();if(!l.length)return null;let a=l[(r?r<0:i>=0)?0:l.length-1];return browser.safari&&!r&&0==a.width&&(a=Array.prototype.find.call(l,(t=>t.width))||a),r?flattenRect(a,r<0):a||null}class WidgetView extends ContentView{constructor(t,e,i){super(),this.widget=t,this.length=e,this.side=i,this.prevWidget=null;}static create(t,e,i){return new(t.customView||WidgetView)(t,e,i)}split(t){let e=WidgetView.create(this.widget,this.length-t,this.side);return this.length-=t,e}sync(t){this.dom&&this.widget.updateDOM(this.dom,t)||(this.dom&&this.prevWidget&&this.prevWidget.destroy(this.dom),this.prevWidget=null,this.setDOM(this.widget.toDOM(t)),this.dom.contentEditable="false");}getSide(){return this.side}merge(t,e,i,o,s,n){return !(i&&(!(i instanceof WidgetView&&this.widget.compare(i.widget))||t>0&&s<=0||e<this.length&&n<=0))&&(this.length=t+(i?i.length:0)+(this.length-e),!0)}become(t){return t instanceof WidgetView&&t.side==this.side&&this.widget.constructor==t.widget.constructor&&(this.widget.compare(t.widget)||this.markDirty(!0),this.dom&&!this.prevWidget&&(this.prevWidget=this.widget),this.widget=t.widget,this.length=t.length,!0)}ignoreMutation(){return !0}ignoreEvent(t){return this.widget.ignoreEvent(t)}get overrideDOMText(){if(0==this.length)return Text$1.empty;let t=this;for(;t.parent;)t=t.parent;let{view:e}=t,i=e&&e.state.doc,o=this.posAtStart;return i?i.slice(o,o+this.length):Text$1.empty}domAtPos(t){return (this.length?0==t:this.side>0)?DOMPos.before(this.dom):DOMPos.after(this.dom,t==this.length)}domBoundsAround(){return null}coordsAt(t,e){let i=this.widget.coordsAt(this.dom,t,e);if(i)return i;let o=this.dom.getClientRects(),s=null;if(!o.length)return null;let n=this.side?this.side<0:t>0;for(let e=n?o.length-1:0;s=o[e],!(t>0?0==e:e==o.length-1||s.top<s.bottom);e+=n?-1:1);return flattenRect(s,!n)}get isEditable(){return !1}get isWidget(){return !0}get isHidden(){return this.widget.isHidden}destroy(){super.destroy(),this.dom&&this.widget.destroy(this.dom);}}class CompositionView extends WidgetView{domAtPos(t){let{topView:e,text:i}=this.widget;return e?scanCompositionTree(t,0,e,i,this.length-e.length,((t,e)=>t.domAtPos(e)),((t,e)=>new DOMPos(t,Math.min(e,t.nodeValue.length)))):new DOMPos(i,Math.min(t,i.nodeValue.length))}sync(){this.setDOM(this.widget.toDOM());}localPosFromDOM(t,e){let{topView:i,text:o}=this.widget;return i?posFromDOMInCompositionTree(t,e,i,o,this.length-i.length):Math.min(e,this.length)}ignoreMutation(){return !1}get overrideDOMText(){return null}coordsAt(t,e){let{topView:i,text:o}=this.widget;return i?scanCompositionTree(t,e,i,o,this.length-i.length,((t,e,i)=>t.coordsAt(e,i)),((t,e,i)=>textCoords(t,e,i))):textCoords(o,t,e)}destroy(){var t;super.destroy(),null===(t=this.widget.topView)||void 0===t||t.destroy();}get isEditable(){return !0}canReuseDOM(){return !0}}function scanCompositionTree(t,e,i,o,s,n,r){if(i instanceof MarkView){for(let l=i.dom.firstChild;l;l=l.nextSibling){let i=ContentView.get(l);if(i){let a=contains(l,o),h=i.length+(a?s:0);if(t<h||t==h&&i.getSide()<=0)return a?scanCompositionTree(t,e,i,o,s,n,r):n(i,t,e);t-=h;}else {let i=scanCompositionNode(t,e,l,r);if("number"!=typeof i)return i;t=i;}}return n(i,i.length,-1)}return i.dom==o?r(o,t,e):n(i,t,e)}function scanCompositionNode(t,e,i,o){if(3==i.nodeType){let s=i.nodeValue.length;if(t<=s)return o(i,t,e);t-=s;}else if(1==i.nodeType&&"false"!=i.contentEditable)for(let s=i.firstChild;s;s=s.nextSibling){let i=scanCompositionNode(t,e,s,o);if("number"!=typeof i)return i;t=i;}return t}function posFromDOMInCompositionTree(t,e,i,o,s){if(i instanceof MarkView){let n=0;for(let r=i.dom.firstChild;r;r=r.nextSibling){let i=ContentView.get(r);if(i){let l=contains(r,o);if(contains(r,t))return n+(l?posFromDOMInCompositionTree(t,e,i,o,s):i.localPosFromDOM(t,e));n+=i.length+(l?s:0);}else {let i=posFromDOMInOpaqueNode(t,e,r);if(null!=i.result)return n+i.result;n+=i.size;}}}else if(i.dom==o)return Math.min(e,o.nodeValue.length);return i.localPosFromDOM(t,e)}function posFromDOMInOpaqueNode(t,e,i){if(3==i.nodeType)return t==i?{result:e}:{size:i.nodeValue.length};if(1!=i.nodeType||"false"==i.contentEditable)return i.contains(t)?{result:0}:{size:0};{let o=0;for(let s=i.firstChild,n=0;;s=s.nextSibling,n++){if(t==i&&n==e)return {result:o};if(!s)return {size:o};let r=posFromDOMInOpaqueNode(t,e,s);if(null!=r.result)return {result:e+r.result};o+=r.size;}}}class WidgetBufferView extends ContentView{constructor(t){super(),this.side=t;}get length(){return 0}merge(){return !1}become(t){return t instanceof WidgetBufferView&&t.side==this.side}split(){return new WidgetBufferView(this.side)}sync(){if(!this.dom){let t=document.createElement("img");t.className="cm-widgetBuffer",t.setAttribute("aria-hidden","true"),this.setDOM(t);}}getSide(){return this.side}domAtPos(t){return this.side>0?DOMPos.before(this.dom):DOMPos.after(this.dom)}localPosFromDOM(){return 0}domBoundsAround(){return null}coordsAt(t){return this.dom.getBoundingClientRect()}get overrideDOMText(){return Text$1.empty}get isHidden(){return !0}}function inlineDOMAtPos(t,e){let i=t.dom,{children:o}=t,s=0;for(let t=0;s<o.length;s++){let n=o[s],r=t+n.length;if(!(r==t&&n.getSide()<=0)){if(e>t&&e<r&&n.dom.parentNode==i)return n.domAtPos(e-t);if(e<=t)break;t=r;}}for(let t=s;t>0;t--){let e=o[t-1];if(e.dom.parentNode==i)return e.domAtPos(e.length)}for(let t=s;t<o.length;t++){let e=o[t];if(e.dom.parentNode==i)return e.domAtPos(0)}return new DOMPos(i,0)}function joinInlineInto(t,e,i){let o,{children:s}=t;i>0&&e instanceof MarkView&&s.length&&(o=s[s.length-1])instanceof MarkView&&o.mark.eq(e.mark)?joinInlineInto(o,e.children[0],i-1):(s.push(e),e.setParent(t)),t.length+=e.length;}function coordsInChildren(t,e,i){let o=null,s=-1,n=null,r=-1;!function t(e,l){for(let a=0,h=0;a<e.children.length&&h<=l;a++){let c=e.children[a],d=h+c.length;d>=l&&(c.children.length?t(c,l-h):(!n||n.isHidden&&i>0)&&(d>l||h==d&&c.getSide()>0)?(n=c,r=l-h):(h<l||h==d&&c.getSide()<0&&!c.isHidden)&&(o=c,s=l-h)),h=d;}}(t,e);let l=(i<0?o:n)||o||n;return l?l.coordsAt(Math.max(0,l==o?s:r),i):fallbackRect(t)}function fallbackRect(t){let e=t.dom.lastChild;if(!e)return t.dom.getBoundingClientRect();let i=clientRectsFor(e);return i[i.length-1]||null}function combineAttrs(t,e){for(let i in t)"class"==i&&e.class?e.class+=" "+t.class:"style"==i&&e.style?e.style+=";"+t.style:e[i]=t[i];return e}function attrsEq(t,e){if(t==e)return !0;if(!t||!e)return !1;let i=Object.keys(t),o=Object.keys(e);if(i.length!=o.length)return !1;for(let s of i)if(-1==o.indexOf(s)||t[s]!==e[s])return !1;return !0}function updateAttrs(t,e,i){let o=null;if(e)for(let s in e)i&&s in i||t.removeAttribute(o=s);if(i)for(let s in i)e&&e[s]==i[s]||t.setAttribute(o=s,i[s]);return !!o}TextView.prototype.children=WidgetView.prototype.children=WidgetBufferView.prototype.children=noChildren;class WidgetType{eq(t){return !1}updateDOM(t,e){return !1}compare(t){return this==t||this.constructor==t.constructor&&this.eq(t)}get estimatedHeight(){return -1}get lineBreaks(){return 0}ignoreEvent(t){return !0}coordsAt(t,e,i){return null}get customView(){return null}get isHidden(){return !1}destroy(t){}}var BlockType=function(t){return t[t.Text=0]="Text",t[t.WidgetBefore=1]="WidgetBefore",t[t.WidgetAfter=2]="WidgetAfter",t[t.WidgetRange=3]="WidgetRange",t}(BlockType||(BlockType={}));class Decoration extends RangeValue{constructor(t,e,i,o){super(),this.startSide=t,this.endSide=e,this.widget=i,this.spec=o;}get heightRelevant(){return !1}static mark(t){return new MarkDecoration(t)}static widget(t){let e=Math.max(-1e4,Math.min(1e4,t.side||0)),i=!!t.block;return e+=i&&!t.inlineOrder?e>0?3e8:-4e8:e>0?1e8:-1e8,new PointDecoration(t,e,e,i,t.widget||null,!1)}static replace(t){let e,i,o=!!t.block;if(t.isBlockGap)e=-5e8,i=4e8;else {let{start:s,end:n}=getInclusive(t,o);e=(s?o?-3e8:-1:5e8)-1,i=1+(n?o?2e8:1:-6e8);}return new PointDecoration(t,e,i,o,t.widget||null,!0)}static line(t){return new LineDecoration(t)}static set(t,e=!1){return RangeSet.of(t,e)}hasHeight(){return !!this.widget&&this.widget.estimatedHeight>-1}}Decoration.none=RangeSet.empty;class MarkDecoration extends Decoration{constructor(t){let{start:e,end:i}=getInclusive(t);super(e?-1:5e8,i?1:-6e8,null,t),this.tagName=t.tagName||"span",this.class=t.class||"",this.attrs=t.attributes||null;}eq(t){return this==t||t instanceof MarkDecoration&&this.tagName==t.tagName&&this.class==t.class&&attrsEq(this.attrs,t.attrs)}range(t,e=t){if(t>=e)throw new RangeError("Mark decorations may not be empty");return super.range(t,e)}}MarkDecoration.prototype.point=!1;class LineDecoration extends Decoration{constructor(t){super(-2e8,-2e8,null,t);}eq(t){return t instanceof LineDecoration&&this.spec.class==t.spec.class&&attrsEq(this.spec.attributes,t.spec.attributes)}range(t,e=t){if(e!=t)throw new RangeError("Line decoration ranges must be zero-length");return super.range(t,e)}}LineDecoration.prototype.mapMode=MapMode.TrackBefore,LineDecoration.prototype.point=!0;class PointDecoration extends Decoration{constructor(t,e,i,o,s,n){super(e,i,s,t),this.block=o,this.isReplace=n,this.mapMode=o?e<=0?MapMode.TrackBefore:MapMode.TrackAfter:MapMode.TrackDel;}get type(){return this.startSide<this.endSide?BlockType.WidgetRange:this.startSide<=0?BlockType.WidgetBefore:BlockType.WidgetAfter}get heightRelevant(){return this.block||!!this.widget&&(this.widget.estimatedHeight>=5||this.widget.lineBreaks>0)}eq(t){return t instanceof PointDecoration&&widgetsEq(this.widget,t.widget)&&this.block==t.block&&this.startSide==t.startSide&&this.endSide==t.endSide}range(t,e=t){if(this.isReplace&&(t>e||t==e&&this.startSide>0&&this.endSide<=0))throw new RangeError("Invalid range for replacement decoration");if(!this.isReplace&&e!=t)throw new RangeError("Widget decorations can only have zero-length ranges");return super.range(t,e)}}function getInclusive(t,e=!1){let{inclusiveStart:i,inclusiveEnd:o}=t;return null==i&&(i=t.inclusive),null==o&&(o=t.inclusive),{start:null!=i?i:e,end:null!=o?o:e}}function widgetsEq(t,e){return t==e||!!(t&&e&&t.compare(e))}function addRange(t,e,i,o=0){let s=i.length-1;s>=0&&i[s]+o>=t?i[s]=Math.max(i[s],e):i.push(t,e);}PointDecoration.prototype.point=!0;class LineView extends ContentView{constructor(){super(...arguments),this.children=[],this.length=0,this.prevAttrs=void 0,this.attrs=null,this.breakAfter=0;}merge(t,e,i,o,s,n){if(i){if(!(i instanceof LineView))return !1;this.dom||i.transferDOM(this);}return o&&this.setDeco(i?i.attrs:null),mergeChildrenInto(this,t,e,i?i.children:[],s,n),!0}split(t){let e=new LineView;if(e.breakAfter=this.breakAfter,0==this.length)return e;let{i:i,off:o}=this.childPos(t);o&&(e.append(this.children[i].split(o),0),this.children[i].merge(o,this.children[i].length,null,!1,0,0),i++);for(let t=i;t<this.children.length;t++)e.append(this.children[t],0);for(;i>0&&0==this.children[i-1].length;)this.children[--i].destroy();return this.children.length=i,this.markDirty(),this.length=t,e}transferDOM(t){this.dom&&(this.markDirty(),t.setDOM(this.dom),t.prevAttrs=void 0===this.prevAttrs?this.attrs:this.prevAttrs,this.prevAttrs=void 0,this.dom=null);}setDeco(t){attrsEq(this.attrs,t)||(this.dom&&(this.prevAttrs=this.attrs,this.markDirty()),this.attrs=t);}append(t,e){joinInlineInto(this,t,e);}addLineDeco(t){let e=t.spec.attributes,i=t.spec.class;e&&(this.attrs=combineAttrs(e,this.attrs||{})),i&&(this.attrs=combineAttrs({class:i},this.attrs||{}));}domAtPos(t){return inlineDOMAtPos(this,t)}reuseDOM(t){"DIV"==t.nodeName&&(this.setDOM(t),this.dirty|=6);}sync(t,e){var i;this.dom?4&this.dirty&&(clearAttributes(this.dom),this.dom.className="cm-line",this.prevAttrs=this.attrs?null:void 0):(this.setDOM(document.createElement("div")),this.dom.className="cm-line",this.prevAttrs=this.attrs?null:void 0),void 0!==this.prevAttrs&&(updateAttrs(this.dom,this.prevAttrs,this.attrs),this.dom.classList.add("cm-line"),this.prevAttrs=void 0),super.sync(t,e);let o=this.dom.lastChild;for(;o&&ContentView.get(o)instanceof MarkView;)o=o.lastChild;if(!(o&&this.length&&("BR"==o.nodeName||0!=(null===(i=ContentView.get(o))||void 0===i?void 0:i.isEditable)||browser.ios&&this.children.some((t=>t instanceof TextView))))){let t=document.createElement("BR");t.cmIgnore=!0,this.dom.appendChild(t);}}measureTextSize(){if(0==this.children.length||this.length>20)return null;let t,e=0;for(let i of this.children){if(!(i instanceof TextView)||/[^ -~]/.test(i.text))return null;let o=clientRectsFor(i.dom);if(1!=o.length)return null;e+=o[0].width,t=o[0].height;}return e?{lineHeight:this.dom.getBoundingClientRect().height,charWidth:e/this.length,textHeight:t}:null}coordsAt(t,e){let i=coordsInChildren(this,t,e);if(!this.children.length&&i&&this.parent){let{heightOracle:t}=this.parent.view.viewState,e=i.bottom-i.top;if(Math.abs(e-t.lineHeight)<2&&t.textHeight<e){let o=(e-t.textHeight)/2;return {top:i.top+o,bottom:i.bottom-o,left:i.left,right:i.left}}}return i}become(t){return !1}get type(){return BlockType.Text}static find(t,e){for(let i=0,o=0;i<t.children.length;i++){let s=t.children[i],n=o+s.length;if(n>=e){if(s instanceof LineView)return s;if(n>e)break}o=n+s.breakAfter;}return null}}class BlockWidgetView extends ContentView{constructor(t,e,i){super(),this.widget=t,this.length=e,this.type=i,this.breakAfter=0,this.prevWidget=null;}merge(t,e,i,o,s,n){return !(i&&(!(i instanceof BlockWidgetView&&this.widget.compare(i.widget))||t>0&&s<=0||e<this.length&&n<=0))&&(this.length=t+(i?i.length:0)+(this.length-e),!0)}domAtPos(t){return 0==t?DOMPos.before(this.dom):DOMPos.after(this.dom,t==this.length)}split(t){let e=this.length-t;this.length=t;let i=new BlockWidgetView(this.widget,e,this.type);return i.breakAfter=this.breakAfter,i}get children(){return noChildren}sync(t){this.dom&&this.widget.updateDOM(this.dom,t)||(this.dom&&this.prevWidget&&this.prevWidget.destroy(this.dom),this.prevWidget=null,this.setDOM(this.widget.toDOM(t)),this.dom.contentEditable="false");}get overrideDOMText(){return this.parent?this.parent.view.state.doc.slice(this.posAtStart,this.posAtEnd):Text$1.empty}domBoundsAround(){return null}become(t){return t instanceof BlockWidgetView&&t.widget.constructor==this.widget.constructor&&(t.widget.compare(this.widget)||this.markDirty(!0),this.dom&&!this.prevWidget&&(this.prevWidget=this.widget),this.widget=t.widget,this.length=t.length,this.type=t.type,this.breakAfter=t.breakAfter,!0)}ignoreMutation(){return !0}ignoreEvent(t){return this.widget.ignoreEvent(t)}get isEditable(){return !1}get isWidget(){return !0}coordsAt(t,e){return this.widget.coordsAt(this.dom,t,e)}destroy(){super.destroy(),this.dom&&this.widget.destroy(this.dom);}}class ContentBuilder{constructor(t,e,i,o){this.doc=t,this.pos=e,this.end=i,this.disallowBlockEffectsFor=o,this.content=[],this.curLine=null,this.breakAtStart=0,this.pendingBuffer=0,this.bufferMarks=[],this.atCursorPos=!0,this.openStart=-1,this.openEnd=-1,this.text="",this.textOff=0,this.cursor=t.iter(),this.skip=e;}posCovered(){if(0==this.content.length)return !this.breakAtStart&&this.doc.lineAt(this.pos).from!=this.pos;let t=this.content[this.content.length-1];return !(t.breakAfter||t instanceof BlockWidgetView&&t.type==BlockType.WidgetBefore)}getLine(){return this.curLine||(this.content.push(this.curLine=new LineView),this.atCursorPos=!0),this.curLine}flushBuffer(t=this.bufferMarks){this.pendingBuffer&&(this.curLine.append(wrapMarks(new WidgetBufferView(-1),t),t.length),this.pendingBuffer=0);}addBlockWidget(t){this.flushBuffer(),this.curLine=null,this.content.push(t);}finish(t){this.pendingBuffer&&t<=this.bufferMarks.length?this.flushBuffer():this.pendingBuffer=0,this.posCovered()||this.getLine();}buildText(t,e,i){for(;t>0;){if(this.textOff==this.text.length){let{value:e,lineBreak:i,done:o}=this.cursor.next(this.skip);if(this.skip=0,o)throw new Error("Ran out of text content when drawing inline views");if(i){this.posCovered()||this.getLine(),this.content.length?this.content[this.content.length-1].breakAfter=1:this.breakAtStart=1,this.flushBuffer(),this.curLine=null,this.atCursorPos=!0,t--;continue}this.text=e,this.textOff=0;}let o=Math.min(this.text.length-this.textOff,t,512);this.flushBuffer(e.slice(e.length-i)),this.getLine().append(wrapMarks(new TextView(this.text.slice(this.textOff,this.textOff+o)),e),i),this.atCursorPos=!0,this.textOff+=o,t-=o,i=0;}}span(t,e,i,o){this.buildText(e-t,i,o),this.pos=e,this.openStart<0&&(this.openStart=o);}point(t,e,i,o,s,n){if(this.disallowBlockEffectsFor[n]&&i instanceof PointDecoration){if(i.block)throw new RangeError("Block decorations may not be specified via plugins");if(e>this.doc.lineAt(this.pos).to)throw new RangeError("Decorations that replace line breaks may not be specified via plugins")}let r=e-t;if(i instanceof PointDecoration)if(i.block){let{type:t}=i;t!=BlockType.WidgetAfter||this.posCovered()||this.getLine(),this.addBlockWidget(new BlockWidgetView(i.widget||new NullWidget("div"),r,t));}else {let n=WidgetView.create(i.widget||new NullWidget("span"),r,r?0:i.startSide),l=this.atCursorPos&&!n.isEditable&&s<=o.length&&(t<e||i.startSide>0),a=!n.isEditable&&(t<e||s>o.length||i.startSide<=0),h=this.getLine();2!=this.pendingBuffer||l||n.isEditable||(this.pendingBuffer=0),this.flushBuffer(o),l&&(h.append(wrapMarks(new WidgetBufferView(1),o),s),s=o.length+Math.max(0,s-o.length)),h.append(wrapMarks(n,o),s),this.atCursorPos=a,this.pendingBuffer=a?t<e||s>o.length?1:2:0,this.pendingBuffer&&(this.bufferMarks=o.slice());}else this.doc.lineAt(this.pos).from==this.pos&&this.getLine().addLineDeco(i);r&&(this.textOff+r<=this.text.length?this.textOff+=r:(this.skip+=r-(this.text.length-this.textOff),this.text="",this.textOff=0),this.pos=e),this.openStart<0&&(this.openStart=s);}static build(t,e,i,o,s){let n=new ContentBuilder(t,e,i,s);return n.openEnd=RangeSet.spans(o,e,i,n),n.openStart<0&&(n.openStart=n.openEnd),n.finish(n.openEnd),n}}function wrapMarks(t,e){for(let i of e)t=new MarkView(i,[t],t.length);return t}class NullWidget extends WidgetType{constructor(t){super(),this.tag=t;}eq(t){return t.tag==this.tag}toDOM(){return document.createElement(this.tag)}updateDOM(t){return t.nodeName.toLowerCase()==this.tag}get isHidden(){return !0}}const clickAddsSelectionRange=Facet.define(),dragMovesSelection$1=Facet.define(),mouseSelectionStyle=Facet.define(),exceptionSink=Facet.define(),updateListener=Facet.define(),inputHandler$1=Facet.define(),focusChangeEffect=Facet.define(),perLineTextDirection=Facet.define({combine:t=>t.some((t=>t))}),nativeSelectionHidden=Facet.define({combine:t=>t.some((t=>t))});class ScrollTarget{constructor(t,e="nearest",i="nearest",o=5,s=5){this.range=t,this.y=e,this.x=i,this.yMargin=o,this.xMargin=s;}map(t){return t.empty?this:new ScrollTarget(this.range.map(t),this.y,this.x,this.yMargin,this.xMargin)}}const scrollIntoView$1=StateEffect.define({map:(t,e)=>t.map(e)});function logException(t,e,i){let o=t.facet(exceptionSink);o.length?o[0](e):window.onerror?window.onerror(String(e),i,void 0,void 0,e):i?console.error(i+":",e):console.error(e);}const editable=Facet.define({combine:t=>!t.length||t[0]});let nextPluginID=0;const viewPlugin=Facet.define();class ViewPlugin{constructor(t,e,i,o){this.id=t,this.create=e,this.domEventHandlers=i,this.extension=o(this);}static define(t,e){const{eventHandlers:i,provide:o,decorations:s}=e||{};return new ViewPlugin(nextPluginID++,t,i,(t=>{let e=[viewPlugin.of(t)];return s&&e.push(decorations.of((e=>{let i=e.plugin(t);return i?s(i):Decoration.none}))),o&&e.push(o(t)),e}))}static fromClass(t,e){return ViewPlugin.define((e=>new t(e)),e)}}class PluginInstance{constructor(t){this.spec=t,this.mustUpdate=null,this.value=null;}update(t){if(this.value){if(this.mustUpdate){let t=this.mustUpdate;if(this.mustUpdate=null,this.value.update)try{this.value.update(t);}catch(e){if(logException(t.state,e,"CodeMirror plugin crashed"),this.value.destroy)try{this.value.destroy();}catch(t){}this.deactivate();}}}else if(this.spec)try{this.value=this.spec.create(t);}catch(e){logException(t.state,e,"CodeMirror plugin crashed"),this.deactivate();}return this}destroy(t){var e;if(null===(e=this.value)||void 0===e?void 0:e.destroy)try{this.value.destroy();}catch(e){logException(t.state,e,"CodeMirror plugin crashed");}}deactivate(){this.spec=this.value=null;}}const editorAttributes=Facet.define(),contentAttributes=Facet.define(),decorations=Facet.define(),atomicRanges=Facet.define(),scrollMargins=Facet.define();function getScrollMargins(t){let e=0,i=0,o=0,s=0;for(let n of t.state.facet(scrollMargins)){let r=n(t);r&&(null!=r.left&&(e=Math.max(e,r.left)),null!=r.right&&(i=Math.max(i,r.right)),null!=r.top&&(o=Math.max(o,r.top)),null!=r.bottom&&(s=Math.max(s,r.bottom)));}return {left:e,right:i,top:o,bottom:s}}const styleModule=Facet.define();class ChangedRange{constructor(t,e,i,o){this.fromA=t,this.toA=e,this.fromB=i,this.toB=o;}join(t){return new ChangedRange(Math.min(this.fromA,t.fromA),Math.max(this.toA,t.toA),Math.min(this.fromB,t.fromB),Math.max(this.toB,t.toB))}addToSet(t){let e=t.length,i=this;for(;e>0;e--){let o=t[e-1];if(!(o.fromA>i.toA)){if(o.toA<i.fromA)break;i=i.join(o),t.splice(e-1,1);}}return t.splice(e,0,i),t}static extendWithRanges(t,e){if(0==e.length)return t;let i=[];for(let o=0,s=0,n=0,r=0;;o++){let l=o==t.length?null:t[o],a=n-r,h=l?l.fromB:1e9;for(;s<e.length&&e[s]<h;){let t=e[s],o=e[s+1],n=Math.max(r,t),l=Math.min(h,o);if(n<=l&&new ChangedRange(n+a,l+a,n,l).addToSet(i),o>h)break;s+=2;}if(!l)return i;new ChangedRange(l.fromA,l.toA,l.fromB,l.toB).addToSet(i),n=l.toA,r=l.toB;}}}class ViewUpdate{constructor(t,e,i){this.view=t,this.state=e,this.transactions=i,this.flags=0,this.startState=t.state,this.changes=ChangeSet.empty(this.startState.doc.length);for(let t of i)this.changes=this.changes.compose(t.changes);let o=[];this.changes.iterChangedRanges(((t,e,i,s)=>o.push(new ChangedRange(t,e,i,s)))),this.changedRanges=o;}static create(t,e,i){return new ViewUpdate(t,e,i)}get viewportChanged(){return (4&this.flags)>0}get heightChanged(){return (2&this.flags)>0}get geometryChanged(){return this.docChanged||(10&this.flags)>0}get focusChanged(){return (1&this.flags)>0}get docChanged(){return !this.changes.empty}get selectionSet(){return this.transactions.some((t=>t.selection))}get empty(){return 0==this.flags&&0==this.transactions.length}}var Direction=function(t){return t[t.LTR=0]="LTR",t[t.RTL=1]="RTL",t}(Direction||(Direction={}));const LTR=Direction.LTR,RTL=Direction.RTL;function dec(t){let e=[];for(let i=0;i<t.length;i++)e.push(1<<+t[i]);return e}const LowTypes=dec("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"),ArabicTypes=dec("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"),Brackets=Object.create(null),BracketStack=[];for(let t of ["()","[]","{}"]){let e=t.charCodeAt(0),i=t.charCodeAt(1);Brackets[e]=i,Brackets[i]=-e;}function charType(t){return t<=247?LowTypes[t]:1424<=t&&t<=1524?2:1536<=t&&t<=1785?ArabicTypes[t-1536]:1774<=t&&t<=2220?4:8192<=t&&t<=8203?256:64336<=t&&t<=65023?4:8204==t?256:1}const BidiRE=/[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac\ufb50-\ufdff]/;class BidiSpan{constructor(t,e,i){this.from=t,this.to=e,this.level=i;}get dir(){return this.level%2?RTL:LTR}side(t,e){return this.dir==e==t?this.to:this.from}static find(t,e,i,o){let s=-1;for(let n=0;n<t.length;n++){let r=t[n];if(r.from<=e&&r.to>=e){if(r.level==i)return n;(s<0||(0!=o?o<0?r.from<e:r.to>e:t[s].level>r.level))&&(s=n);}}if(s<0)throw new RangeError("Index out of range");return s}}const types=[];function computeOrder(t,e){let i=t.length,o=e==LTR?1:2,s=e==LTR?2:1;if(!t||1==o&&!BidiRE.test(t))return trivialOrder(i);for(let e=0,s=o,n=o;e<i;e++){let i=charType(t.charCodeAt(e));512==i?i=s:8==i&&4==n&&(i=16),types[e]=4==i?2:i,7&i&&(n=i),s=i;}for(let t=0,e=o,s=o;t<i;t++){let o=types[t];if(128==o)t<i-1&&e==types[t+1]&&24&e?o=types[t]=e:types[t]=256;else if(64==o){let o=t+1;for(;o<i&&64==types[o];)o++;let n=t&&8==e||o<i&&8==types[o]?1==s?1:8:256;for(let e=t;e<o;e++)types[e]=n;t=o-1;}else 8==o&&1==s&&(types[t]=1);e=o,7&o&&(s=o);}for(let e,n,r,l=0,a=0,h=0;l<i;l++)if(n=Brackets[e=t.charCodeAt(l)])if(n<0){for(let t=a-3;t>=0;t-=3)if(BracketStack[t+1]==-n){let e=BracketStack[t+2],i=2&e?o:4&e?1&e?s:o:0;i&&(types[l]=types[BracketStack[t]]=i),a=t;break}}else {if(189==BracketStack.length)break;BracketStack[a++]=l,BracketStack[a++]=e,BracketStack[a++]=h;}else if(2==(r=types[l])||1==r){let t=r==o;h=t?0:1;for(let e=a-3;e>=0;e-=3){let i=BracketStack[e+2];if(2&i)break;if(t)BracketStack[e+2]|=2;else {if(4&i)break;BracketStack[e+2]|=4;}}}for(let t=0;t<i;t++)if(256==types[t]){let e=t+1;for(;e<i&&256==types[e];)e++;let s=1==(t?types[t-1]:o),n=s==(1==(e<i?types[e]:o))?s?1:2:o;for(let i=t;i<e;i++)types[i]=n;t=e-1;}let n=[];if(1==o)for(let t=0;t<i;){let e=t,o=1!=types[t++];for(;t<i&&o==(1!=types[t]);)t++;if(o)for(let i=t;i>e;){let t=i,o=2!=types[--i];for(;i>e&&o==(2!=types[i-1]);)i--;n.push(new BidiSpan(i,t,o?2:1));}else n.push(new BidiSpan(e,t,0));}else for(let t=0;t<i;){let e=t,o=2==types[t++];for(;t<i&&o==(2==types[t]);)t++;n.push(new BidiSpan(e,t,o?1:2));}return n}function trivialOrder(t){return [new BidiSpan(0,t,0)]}let movedOver="";function moveVisually(t,e,i,o,s){var n;let r=o.head-t.from,l=-1;if(0==r){if(!s||!t.length)return null;e[0].level!=i&&(r=e[0].side(!1,i),l=0);}else if(r==t.length){if(s)return null;let t=e[e.length-1];t.level!=i&&(r=t.side(!0,i),l=e.length-1);}l<0&&(l=BidiSpan.find(e,r,null!==(n=o.bidiLevel)&&void 0!==n?n:-1,o.assoc));let a=e[l];r==a.side(s,i)&&(a=e[l+=s?1:-1],r=a.side(!s,i));let h=s==(a.dir==i),c=findClusterBreak(t.text,r,h);if(movedOver=t.text.slice(Math.min(r,c),Math.max(r,c)),c!=a.side(s,i))return EditorSelection.cursor(c+t.from,h?-1:1,a.level);let d=l==(s?e.length-1:0)?null:e[l+(s?1:-1)];return d||a.level==i?d&&d.level<a.level?EditorSelection.cursor(d.side(!s,i)+t.from,s?1:-1,d.level):EditorSelection.cursor(c+t.from,s?-1:1,a.level):EditorSelection.cursor(s?t.to:t.from,s?-1:1,i)}class DOMReader{constructor(t,e){this.points=t,this.text="",this.lineSeparator=e.facet(EditorState.lineSeparator);}append(t){this.text+=t;}lineBreak(){this.text+="￿";}readRange(t,e){if(!t)return this;let i=t.parentNode;for(let o=t;;){this.findPointBefore(i,o);let t=this.text.length;this.readNode(o);let s=o.nextSibling;if(s==e)break;let n=ContentView.get(o),r=ContentView.get(s);(n&&r?n.breakAfter:(n?n.breakAfter:isBlockElement(o))||isBlockElement(s)&&("BR"!=o.nodeName||o.cmIgnore)&&this.text.length>t)&&this.lineBreak(),o=s;}return this.findPointBefore(i,e),this}readTextNode(t){let e=t.nodeValue;for(let i of this.points)i.node==t&&(i.pos=this.text.length+Math.min(i.offset,e.length));for(let i=0,o=this.lineSeparator?null:/\r\n?|\n/g;;){let s,n=-1,r=1;if(this.lineSeparator?(n=e.indexOf(this.lineSeparator,i),r=this.lineSeparator.length):(s=o.exec(e))&&(n=s.index,r=s[0].length),this.append(e.slice(i,n<0?e.length:n)),n<0)break;if(this.lineBreak(),r>1)for(let e of this.points)e.node==t&&e.pos>this.text.length&&(e.pos-=r-1);i=n+r;}}readNode(t){if(t.cmIgnore)return;let e=ContentView.get(t),i=e&&e.overrideDOMText;if(null!=i){this.findPointInside(t,i.length);for(let t=i.iter();!t.next().done;)t.lineBreak?this.lineBreak():this.append(t.value);}else 3==t.nodeType?this.readTextNode(t):"BR"==t.nodeName?t.nextSibling&&this.lineBreak():1==t.nodeType&&this.readRange(t.firstChild,null);}findPointBefore(t,e){for(let i of this.points)i.node==t&&t.childNodes[i.offset]==e&&(i.pos=this.text.length);}findPointInside(t,e){for(let i of this.points)(3==t.nodeType?i.node==t:t.contains(i.node))&&(i.pos=this.text.length+Math.min(e,i.offset));}}function isBlockElement(t){return 1==t.nodeType&&/^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(t.nodeName)}class DOMPoint{constructor(t,e){this.node=t,this.offset=e,this.pos=-1;}}class DocView extends ContentView{constructor(t){super(),this.view=t,this.compositionDeco=Decoration.none,this.decorations=[],this.dynamicDecorationMap=[],this.minWidth=0,this.minWidthFrom=0,this.minWidthTo=0,this.impreciseAnchor=null,this.impreciseHead=null,this.forceSelection=!1,this.lastUpdate=Date.now(),this.setDOM(t.contentDOM),this.children=[new LineView],this.children[0].setParent(this),this.updateDeco(),this.updateInner([new ChangedRange(0,0,0,t.state.doc.length)],0);}get length(){return this.view.state.doc.length}update(t){let e=t.changedRanges;this.minWidth>0&&e.length&&(e.every((({fromA:t,toA:e})=>e<this.minWidthFrom||t>this.minWidthTo))?(this.minWidthFrom=t.changes.mapPos(this.minWidthFrom,1),this.minWidthTo=t.changes.mapPos(this.minWidthTo,1)):this.minWidth=this.minWidthFrom=this.minWidthTo=0),this.view.inputState.composing<0?this.compositionDeco=Decoration.none:(t.transactions.length||this.dirty)&&(this.compositionDeco=computeCompositionDeco(this.view,t.changes)),(browser.ie||browser.chrome)&&!this.compositionDeco.size&&t&&t.state.doc.lines!=t.startState.doc.lines&&(this.forceSelection=!0);let i=findChangedDeco(this.decorations,this.updateDeco(),t.changes);return e=ChangedRange.extendWithRanges(e,i),(0!=this.dirty||0!=e.length)&&(this.updateInner(e,t.startState.doc.length),t.transactions.length&&(this.lastUpdate=Date.now()),!0)}updateInner(t,e){this.view.viewState.mustMeasureContent=!0,this.updateChildren(t,e);let{observer:i}=this.view;i.ignore((()=>{this.dom.style.height=this.view.viewState.contentHeight+"px",this.dom.style.flexBasis=this.minWidth?this.minWidth+"px":"";let t=browser.chrome||browser.ios?{node:i.selectionRange.focusNode,written:!1}:void 0;this.sync(this.view,t),this.dirty=0,t&&(t.written||i.selectionRange.focusNode!=t.node)&&(this.forceSelection=!0),this.dom.style.height="";}));let o=[];if(this.view.viewport.from||this.view.viewport.to<this.view.state.doc.length)for(let t of this.children)t instanceof BlockWidgetView&&t.widget instanceof BlockGapWidget&&o.push(t.dom);i.updateGaps(o);}updateChildren(t,e){let i=this.childCursor(e);for(let e=t.length-1;;e--){let o=e>=0?t[e]:null;if(!o)break;let{fromA:s,toA:n,fromB:r,toB:l}=o,{content:a,breakAtStart:h,openStart:c,openEnd:d}=ContentBuilder.build(this.view.state.doc,r,l,this.decorations,this.dynamicDecorationMap),{i:u,off:p}=i.findPos(n,1),{i:f,off:g}=i.findPos(s,-1);replaceRange(this,f,g,u,p,a,h,c,d);}}updateSelection(t=!1,e=!1){!t&&this.view.observer.selectionRange.focusNode||this.view.observer.readSelectionRange();let i=this.view.root.activeElement,o=i==this.dom,s=!o&&hasSelection(this.dom,this.view.observer.selectionRange)&&!(i&&this.dom.contains(i));if(!(o||e||s))return;let n=this.forceSelection;this.forceSelection=!1;let r=this.view.state.selection.main,l=this.domAtPos(r.anchor),a=r.empty?l:this.domAtPos(r.head);if(browser.gecko&&r.empty&&!this.compositionDeco.size&&betweenUneditable(l)){let t=document.createTextNode("");this.view.observer.ignore((()=>l.node.insertBefore(t,l.node.childNodes[l.offset]||null))),l=a=new DOMPos(t,0),n=!0;}let h=this.view.observer.selectionRange;!n&&h.focusNode&&isEquivalentPosition(l.node,l.offset,h.anchorNode,h.anchorOffset)&&isEquivalentPosition(a.node,a.offset,h.focusNode,h.focusOffset)||(this.view.observer.ignore((()=>{browser.android&&browser.chrome&&this.dom.contains(h.focusNode)&&inUneditable(h.focusNode,this.dom)&&(this.dom.blur(),this.dom.focus({preventScroll:!0}));let t=getSelection(this.view.root);if(t)if(r.empty){if(browser.gecko){let t=nextToUneditable(l.node,l.offset);if(t&&3!=t){let e=nearbyTextNode(l.node,l.offset,1==t?1:-1);e&&(l=new DOMPos(e,1==t?0:e.nodeValue.length));}}t.collapse(l.node,l.offset),null!=r.bidiLevel&&null!=h.cursorBidiLevel&&(h.cursorBidiLevel=r.bidiLevel);}else if(t.extend){t.collapse(l.node,l.offset);try{t.extend(a.node,a.offset);}catch(t){}}else {let e=document.createRange();r.anchor>r.head&&([l,a]=[a,l]),e.setEnd(a.node,a.offset),e.setStart(l.node,l.offset),t.removeAllRanges(),t.addRange(e);}s&&this.view.root.activeElement==this.dom&&(this.dom.blur(),i&&i.focus());})),this.view.observer.setSelectionRange(l,a)),this.impreciseAnchor=l.precise?null:new DOMPos(h.anchorNode,h.anchorOffset),this.impreciseHead=a.precise?null:new DOMPos(h.focusNode,h.focusOffset);}enforceCursorAssoc(){if(this.compositionDeco.size)return;let{view:t}=this,e=t.state.selection.main,i=getSelection(t.root),{anchorNode:o,anchorOffset:s}=t.observer.selectionRange;if(!(i&&e.empty&&e.assoc&&i.modify))return;let n=LineView.find(this,e.head);if(!n)return;let r=n.posAtStart;if(e.head==r||e.head==r+n.length)return;let l=this.coordsAt(e.head,-1),a=this.coordsAt(e.head,1);if(!l||!a||l.bottom>a.top)return;let h=this.domAtPos(e.head+e.assoc);i.collapse(h.node,h.offset),i.modify("move",e.assoc<0?"forward":"backward","lineboundary"),t.observer.readSelectionRange();let c=t.observer.selectionRange;t.docView.posFromDOM(c.anchorNode,c.anchorOffset)!=e.from&&i.collapse(o,s);}nearest(t){for(let e=t;e;){let t=ContentView.get(e);if(t&&t.rootView==this)return t;e=e.parentNode;}return null}posFromDOM(t,e){let i=this.nearest(t);if(!i)throw new RangeError("Trying to find position for a DOM position outside of the document");return i.localPosFromDOM(t,e)+i.posAtStart}domAtPos(t){let{i:e,off:i}=this.childCursor().findPos(t,-1);for(;e<this.children.length-1;){let t=this.children[e];if(i<t.length||t instanceof LineView)break;e++,i=0;}return this.children[e].domAtPos(i)}coordsAt(t,e){for(let i=this.length,o=this.children.length-1;;o--){let s=this.children[o],n=i-s.breakAfter-s.length;if(t>n||t==n&&s.type!=BlockType.WidgetBefore&&s.type!=BlockType.WidgetAfter&&(!o||2==e||this.children[o-1].breakAfter||this.children[o-1].type==BlockType.WidgetBefore&&e>-2))return s.coordsAt(t-n,e);i=n;}}measureVisibleLineHeights(t){let e=[],{from:i,to:o}=t,s=this.view.contentDOM.clientWidth,n=s>Math.max(this.view.scrollDOM.clientWidth,this.minWidth)+1,r=-1,l=this.view.textDirection==Direction.LTR;for(let t=0,a=0;a<this.children.length;a++){let h=this.children[a],c=t+h.length;if(c>o)break;if(t>=i){let i=h.dom.getBoundingClientRect();if(e.push(i.height),n){let e=h.dom.lastChild,o=e?clientRectsFor(e):[];if(o.length){let e=o[o.length-1],n=l?e.right-i.left:i.right-e.left;n>r&&(r=n,this.minWidth=s,this.minWidthFrom=t,this.minWidthTo=c);}}}t=c+h.breakAfter;}return e}textDirectionAt(t){let{i:e}=this.childPos(t,1);return "rtl"==getComputedStyle(this.children[e].dom).direction?Direction.RTL:Direction.LTR}measureTextSize(){for(let t of this.children)if(t instanceof LineView){let e=t.measureTextSize();if(e)return e}let t,e,i,o=document.createElement("div");return o.className="cm-line",o.style.width="99999px",o.textContent="abc def ghi jkl mno pqr stu",this.view.observer.ignore((()=>{this.dom.appendChild(o);let s=clientRectsFor(o.firstChild)[0];t=o.getBoundingClientRect().height,e=s?s.width/27:7,i=s?s.height:t,o.remove();})),{lineHeight:t,charWidth:e,textHeight:i}}childCursor(t=this.length){let e=this.children.length;return e&&(t-=this.children[--e].length),new ChildCursor(this.children,t,e)}computeBlockGapDeco(){let t=[],e=this.view.viewState;for(let i=0,o=0;;o++){let s=o==e.viewports.length?null:e.viewports[o],n=s?s.from-1:this.length;if(n>i){let o=e.lineBlockAt(n).bottom-e.lineBlockAt(i).top;t.push(Decoration.replace({widget:new BlockGapWidget(o),block:!0,inclusive:!0,isBlockGap:!0}).range(i,n));}if(!s)break;i=s.to+1;}return Decoration.set(t)}updateDeco(){let t=this.view.state.facet(decorations).map(((t,e)=>(this.dynamicDecorationMap[e]="function"==typeof t)?t(this.view):t));for(let e=t.length;e<t.length+3;e++)this.dynamicDecorationMap[e]=!1;return this.decorations=[...t,this.compositionDeco,this.computeBlockGapDeco(),this.view.viewState.lineGapDeco]}scrollIntoView(t){let e,{range:i}=t,o=this.coordsAt(i.head,i.empty?i.assoc:i.head>i.anchor?-1:1);if(!o)return;!i.empty&&(e=this.coordsAt(i.anchor,i.anchor>i.head?-1:1))&&(o={left:Math.min(o.left,e.left),top:Math.min(o.top,e.top),right:Math.max(o.right,e.right),bottom:Math.max(o.bottom,e.bottom)});let s=getScrollMargins(this.view),n={left:o.left-s.left,top:o.top-s.top,right:o.right+s.right,bottom:o.bottom+s.bottom};scrollRectIntoView(this.view.scrollDOM,n,i.head<i.anchor?-1:1,t.x,t.y,t.xMargin,t.yMargin,this.view.textDirection==Direction.LTR);}}function betweenUneditable(t){return 1==t.node.nodeType&&t.node.firstChild&&(0==t.offset||"false"==t.node.childNodes[t.offset-1].contentEditable)&&(t.offset==t.node.childNodes.length||"false"==t.node.childNodes[t.offset].contentEditable)}class BlockGapWidget extends WidgetType{constructor(t){super(),this.height=t;}toDOM(){let t=document.createElement("div");return this.updateDOM(t),t}eq(t){return t.height==this.height}updateDOM(t){return t.style.height=this.height+"px",!0}get estimatedHeight(){return this.height}}function compositionSurroundingNode(t){let e=t.observer.selectionRange,i=e.focusNode&&nearbyTextNode(e.focusNode,e.focusOffset,0);if(!i)return null;let o=t.docView.nearest(i);if(!o)return null;if(o instanceof LineView){let t=i;for(;t.parentNode!=o.dom;)t=t.parentNode;let e=t.previousSibling;for(;e&&!ContentView.get(e);)e=e.previousSibling;let s=e?ContentView.get(e).posAtEnd:o.posAtStart;return {from:s,to:s,node:t,text:i}}{for(;;){let{parent:t}=o;if(!t)return null;if(t instanceof LineView)break;o=t;}let t=o.posAtStart;return {from:t,to:t+o.length,node:o.dom,text:i}}}function computeCompositionDeco(t,e){let i=compositionSurroundingNode(t);if(!i)return Decoration.none;let{from:o,to:s,node:n,text:r}=i,l=e.mapPos(o,1),a=Math.max(l,e.mapPos(s,-1)),{state:h}=t,c=new DOMReader([],h);3==n.nodeType?c.readTextNode(n):c.readRange(n.firstChild,null);let{text:d}=c;if(d.indexOf("￿")>-1)return Decoration.none;if(a-l<d.length)if(h.doc.sliceString(l,Math.min(h.doc.length,l+d.length))==d)a=l+d.length;else {if(h.doc.sliceString(Math.max(0,a-d.length),a)!=d)return Decoration.none;l=a-d.length;}else if(h.doc.sliceString(l,a)!=d)return Decoration.none;let u=ContentView.get(n);return u instanceof CompositionView?u=u.widget.topView:u&&(u.parent=null),Decoration.set(Decoration.replace({widget:new CompositionWidget(n,r,u),inclusive:!0}).range(l,a))}class CompositionWidget extends WidgetType{constructor(t,e,i){super(),this.top=t,this.text=e,this.topView=i;}eq(t){return this.top==t.top&&this.text==t.text}toDOM(){return this.top}ignoreEvent(){return !1}get customView(){return CompositionView}}function nearbyTextNode(t,e,i){if(i<=0)for(let i=t,o=e;;){if(3==i.nodeType)return i;if(!(1==i.nodeType&&o>0))break;i=i.childNodes[o-1],o=maxOffset(i);}if(i>=0)for(let o=t,s=e;;){if(3==o.nodeType)return o;if(!(1==o.nodeType&&s<o.childNodes.length&&i>=0))break;o=o.childNodes[s],s=0;}return null}function nextToUneditable(t,e){return 1!=t.nodeType?0:(e&&"false"==t.childNodes[e-1].contentEditable?1:0)|(e<t.childNodes.length&&"false"==t.childNodes[e].contentEditable?2:0)}class DecorationComparator$1{constructor(){this.changes=[];}compareRange(t,e){addRange(t,e,this.changes);}comparePoint(t,e){addRange(t,e,this.changes);}}function findChangedDeco(t,e,i){let o=new DecorationComparator$1;return RangeSet.compare(t,e,i,o),o.changes}function inUneditable(t,e){for(let i=t;i&&i!=e;i=i.assignedSlot||i.parentNode)if(1==i.nodeType&&"false"==i.contentEditable)return !0;return !1}function groupAt(t,e,i=1){let o=t.charCategorizer(e),s=t.doc.lineAt(e),n=e-s.from;if(0==s.length)return EditorSelection.cursor(e);0==n?i=1:n==s.length&&(i=-1);let r=n,l=n;i<0?r=findClusterBreak(s.text,n,!1):l=findClusterBreak(s.text,n);let a=o(s.text.slice(r,l));for(;r>0;){let t=findClusterBreak(s.text,r,!1);if(o(s.text.slice(t,r))!=a)break;r=t;}for(;l<s.length;){let t=findClusterBreak(s.text,l);if(o(s.text.slice(l,t))!=a)break;l=t;}return EditorSelection.range(r+s.from,l+s.from)}function getdx(t,e){return e.left>t?e.left-t:Math.max(0,t-e.right)}function getdy(t,e){return e.top>t?e.top-t:Math.max(0,t-e.bottom)}function yOverlap(t,e){return t.top<e.bottom-1&&t.bottom>e.top+1}function upTop(t,e){return e<t.top?{top:e,left:t.left,right:t.right,bottom:t.bottom}:t}function upBot(t,e){return e>t.bottom?{top:t.top,left:t.left,right:t.right,bottom:e}:t}function domPosAtCoords(t,e,i){let o,s,n,r,l,a,h,c,d=!1;for(let u=t.firstChild;u;u=u.nextSibling){let t=clientRectsFor(u);for(let p=0;p<t.length;p++){let f=t[p];s&&yOverlap(s,f)&&(f=upTop(upBot(f,s.bottom),s.top));let g=getdx(e,f),m=getdy(i,f);if(0==g&&0==m)return 3==u.nodeType?domPosInText(u,e,i):domPosAtCoords(u,e,i);if(!o||r>m||r==m&&n>g){o=u,s=f,n=g,r=m;let l=m?i<f.top?-1:1:g?e<f.left?-1:1:0;d=!l||(l>0?p<t.length-1:p>0);}0==g?i>f.bottom&&(!h||h.bottom<f.bottom)?(l=u,h=f):i<f.top&&(!c||c.top>f.top)&&(a=u,c=f):h&&yOverlap(h,f)?h=upBot(h,f.bottom):c&&yOverlap(c,f)&&(c=upTop(c,f.top));}}if(h&&h.bottom>=i?(o=l,s=h):c&&c.top<=i&&(o=a,s=c),!o)return {node:t,offset:0};let u=Math.max(s.left,Math.min(s.right,e));return 3==o.nodeType?domPosInText(o,u,i):d&&"false"!=o.contentEditable?domPosAtCoords(o,u,i):{node:t,offset:Array.prototype.indexOf.call(t.childNodes,o)+(e>=(s.left+s.right)/2?1:0)}}function domPosInText(t,e,i){let o=t.nodeValue.length,s=-1,n=1e9,r=0;for(let l=0;l<o;l++){let o=textRange(t,l,l+1).getClientRects();for(let a=0;a<o.length;a++){let h=o[a];if(h.top==h.bottom)continue;r||(r=e-h.left);let c=(h.top>i?h.top-i:i-h.bottom)-1;if(h.left-1<=e&&h.right+1>=e&&c<n){let i=e>=(h.left+h.right)/2,o=i;if(browser.chrome||browser.gecko){textRange(t,l).getBoundingClientRect().left==h.right&&(o=!i);}if(c<=0)return {node:t,offset:l+(o?1:0)};s=l+(o?1:0),n=c;}}}return {node:t,offset:s>-1?s:r>0?t.nodeValue.length:0}}function posAtCoords(t,e,i,o=-1){var s,n;let r,l=t.contentDOM.getBoundingClientRect(),a=l.top+t.viewState.paddingTop,{docHeight:h}=t.viewState,{x:c,y:d}=e,u=d-a;if(u<0)return 0;if(u>h)return t.state.doc.length;for(let e=t.viewState.heightOracle.textHeight/2,s=!1;r=t.elementAtHeight(u),r.type!=BlockType.Text;)for(;u=o>0?r.bottom+e:r.top-e,!(u>=0&&u<=h);){if(s)return i?null:0;s=!0,o=-o;}d=a+u;let p=r.from;if(p<t.viewport.from)return 0==t.viewport.from?0:i?null:posAtCoordsImprecise(t,l,r,c,d);if(p>t.viewport.to)return t.viewport.to==t.state.doc.length?t.state.doc.length:i?null:posAtCoordsImprecise(t,l,r,c,d);let f=t.dom.ownerDocument,g=t.root.elementFromPoint?t.root:f,m=g.elementFromPoint(c,d);m&&!t.contentDOM.contains(m)&&(m=null),m||(c=Math.max(l.left+1,Math.min(l.right-1,c)),m=g.elementFromPoint(c,d),m&&!t.contentDOM.contains(m)&&(m=null));let w,v=-1;if(m&&0!=(null===(s=t.docView.nearest(m))||void 0===s?void 0:s.isEditable))if(f.caretPositionFromPoint){let t=f.caretPositionFromPoint(c,d);t&&({offsetNode:w,offset:v}=t);}else if(f.caretRangeFromPoint){let e=f.caretRangeFromPoint(c,d);e&&(({startContainer:w,startOffset:v}=e),(!t.contentDOM.contains(w)||browser.safari&&isSuspiciousSafariCaretResult(w,v,c)||browser.chrome&&isSuspiciousChromeCaretResult(w,v,c))&&(w=void 0));}if(!w||!t.docView.dom.contains(w)){let e=LineView.find(t.docView,p);if(!e)return u>r.top+r.height/2?r.to:r.from;({node:w,offset:v}=domPosAtCoords(e.dom,c,d));}let y=t.docView.nearest(w);if(!y)return null;if(y.isWidget&&1==(null===(n=y.dom)||void 0===n?void 0:n.nodeType)){let t=y.dom.getBoundingClientRect();return e.y<t.top||e.y<=t.bottom&&e.x<=(t.left+t.right)/2?y.posAtStart:y.posAtEnd}return y.localPosFromDOM(w,v)+y.posAtStart}function posAtCoordsImprecise(t,e,i,o,s){let n=Math.round((o-e.left)*t.defaultCharacterWidth);if(t.lineWrapping&&i.height>1.5*t.defaultLineHeight){let e=t.viewState.heightOracle.textHeight;n+=Math.floor((s-i.top-.5*(t.defaultLineHeight-e))/e)*t.viewState.heightOracle.lineLength;}let r=t.state.sliceDoc(i.from,i.to);return i.from+findColumn(r,n,t.state.tabSize)}function isSuspiciousSafariCaretResult(t,e,i){let o;if(3!=t.nodeType||e!=(o=t.nodeValue.length))return !1;for(let e=t.nextSibling;e;e=e.nextSibling)if(1!=e.nodeType||"BR"!=e.nodeName)return !1;return textRange(t,o-1,o).getBoundingClientRect().left>i}function isSuspiciousChromeCaretResult(t,e,i){if(0!=e)return !1;for(let e=t;;){let t=e.parentNode;if(!t||1!=t.nodeType||t.firstChild!=e)return !1;if(t.classList.contains("cm-line"))break;e=t;}return i-(1==t.nodeType?t.getBoundingClientRect():textRange(t,0,Math.max(t.nodeValue.length,1)).getBoundingClientRect()).left>5}function blockAt(t,e){let i=t.lineBlockAt(e);if(Array.isArray(i.type))for(let t of i.type)if(t.to>e||t.to==e&&(t.to==i.to||t.type==BlockType.Text))return t;return i}function moveToLineBoundary(t,e,i,o){let s=blockAt(t,e.head),n=o&&s.type==BlockType.Text&&(t.lineWrapping||s.widgetLineBreaks)?t.coordsAtPos(e.assoc<0&&e.head>s.from?e.head-1:e.head):null;if(n){let e=t.dom.getBoundingClientRect(),o=t.textDirectionAt(s.from),r=t.posAtCoords({x:i==(o==Direction.LTR)?e.right-1:e.left+1,y:(n.top+n.bottom)/2});if(null!=r)return EditorSelection.cursor(r,i?-1:1)}return EditorSelection.cursor(i?s.to:s.from,i?-1:1)}function moveByChar(t,e,i,o){let s=t.state.doc.lineAt(e.head),n=t.bidiSpans(s),r=t.textDirectionAt(s.from);for(let l=e,a=null;;){let e=moveVisually(s,n,r,l,i),h=movedOver;if(!e){if(s.number==(i?t.state.doc.lines:1))return l;h="\n",s=t.state.doc.line(s.number+(i?1:-1)),n=t.bidiSpans(s),e=EditorSelection.cursor(i?s.from:s.to);}if(a){if(!a(h))return l}else {if(!o)return e;a=o(h);}l=e;}}function byGroup(t,e,i){let o=t.state.charCategorizer(e),s=o(i);return t=>{let e=o(t);return s==CharCategory.Space&&(s=e),s==e}}function moveVertically(t,e,i,o){let s=e.head,n=i?1:-1;if(s==(i?t.state.doc.length:0))return EditorSelection.cursor(s,e.assoc);let r,l=e.goalColumn,a=t.contentDOM.getBoundingClientRect(),h=t.coordsAtPos(s),c=t.documentTop;if(h)null==l&&(l=h.left-a.left),r=n<0?h.top:h.bottom;else {let e=t.viewState.lineBlockAt(s);null==l&&(l=Math.min(a.right-a.left,t.defaultCharacterWidth*(s-e.from))),r=(n<0?e.top:e.bottom)+c;}let d=a.left+l,u=null!=o?o:t.viewState.heightOracle.textHeight>>1;for(let i=0;;i+=10){let o=r+(u+i)*n,h=posAtCoords(t,{x:d,y:o},!1,n);if(o<a.top||o>a.bottom||(n<0?h<s:h>s))return EditorSelection.cursor(h,e.assoc,void 0,l)}}function skipAtomicRanges(t,e,i){for(;;){let o=0;for(let s of t)s.between(e-1,e+1,((t,s,n)=>{if(e>t&&e<s){let n=o||i||(e-t<s-e?-1:1);e=n<0?t:s,o=n;}}));if(!o)return e}}function skipAtoms(t,e,i){let o=skipAtomicRanges(t.state.facet(atomicRanges).map((e=>e(t))),i.from,e.head>i.from?-1:1);return o==i.from?i:EditorSelection.cursor(o,o<i.from?1:-1)}class InputState{constructor(t){this.lastKeyCode=0,this.lastKeyTime=0,this.lastTouchTime=0,this.lastFocusTime=0,this.lastScrollTop=0,this.lastScrollLeft=0,this.chromeScrollHack=-1,this.pendingIOSKey=void 0,this.lastSelectionOrigin=null,this.lastSelectionTime=0,this.lastEscPress=0,this.lastContextMenu=0,this.scrollHandlers=[],this.registeredEvents=[],this.customHandlers=[],this.composing=-1,this.compositionFirstChange=null,this.compositionEndedAt=0,this.compositionPendingKey=!1,this.compositionPendingChange=!1,this.mouseSelection=null;let e=(e,i)=>{this.ignoreDuringComposition(i)||"keydown"==i.type&&this.keydown(t,i)||(this.mustFlushObserver(i)&&t.observer.forceFlush(),this.runCustomHandlers(i.type,t,i)?i.preventDefault():e(t,i));};for(let i in handlers){let o=handlers[i];t.contentDOM.addEventListener(i,(i=>{eventBelongsToEditor(t,i)&&e(o,i);}),handlerOptions[i]),this.registeredEvents.push(i);}t.scrollDOM.addEventListener("mousedown",(i=>{if(i.target==t.scrollDOM&&i.clientY>t.contentDOM.getBoundingClientRect().bottom&&(e(handlers.mousedown,i),!i.defaultPrevented&&2==i.button)){let e=t.contentDOM.style.minHeight;t.contentDOM.style.minHeight="100%",setTimeout((()=>t.contentDOM.style.minHeight=e),200);}})),t.scrollDOM.addEventListener("drop",(i=>{i.target==t.scrollDOM&&i.clientY>t.contentDOM.getBoundingClientRect().bottom&&e(handlers.drop,i);})),browser.chrome&&102==browser.chrome_version&&t.scrollDOM.addEventListener("wheel",(()=>{this.chromeScrollHack<0?t.contentDOM.style.pointerEvents="none":window.clearTimeout(this.chromeScrollHack),this.chromeScrollHack=setTimeout((()=>{this.chromeScrollHack=-1,t.contentDOM.style.pointerEvents="";}),100);}),{passive:!0}),this.notifiedFocused=t.hasFocus,browser.safari&&t.contentDOM.addEventListener("input",(()=>null));}setSelectionOrigin(t){this.lastSelectionOrigin=t,this.lastSelectionTime=Date.now();}ensureHandlers(t,e){var i;let o;this.customHandlers=[];for(let s of e)if(o=null===(i=s.update(t).spec)||void 0===i?void 0:i.domEventHandlers){this.customHandlers.push({plugin:s.value,handlers:o});for(let e in o)this.registeredEvents.indexOf(e)<0&&"scroll"!=e&&(this.registeredEvents.push(e),t.contentDOM.addEventListener(e,(i=>{eventBelongsToEditor(t,i)&&this.runCustomHandlers(e,t,i)&&i.preventDefault();})));}}runCustomHandlers(t,e,i){for(let o of this.customHandlers){let s=o.handlers[t];if(s)try{if(s.call(o.plugin,i,e)||i.defaultPrevented)return !0}catch(t){logException(e.state,t);}}return !1}runScrollHandlers(t,e){this.lastScrollTop=t.scrollDOM.scrollTop,this.lastScrollLeft=t.scrollDOM.scrollLeft;for(let i of this.customHandlers){let o=i.handlers.scroll;if(o)try{o.call(i.plugin,e,t);}catch(e){logException(t.state,e);}}}keydown(t,e){if(this.lastKeyCode=e.keyCode,this.lastKeyTime=Date.now(),9==e.keyCode&&Date.now()<this.lastEscPress+2e3)return !0;if(27!=e.keyCode&&modifierCodes.indexOf(e.keyCode)<0&&(t.inputState.lastEscPress=0),browser.android&&browser.chrome&&!e.synthetic&&(13==e.keyCode||8==e.keyCode))return t.observer.delayAndroidKey(e.key,e.keyCode),!0;let i;return !(!browser.ios||e.synthetic||e.altKey||e.metaKey||!((i=PendingKeys.find((t=>t.keyCode==e.keyCode)))&&!e.ctrlKey||EmacsyPendingKeys.indexOf(e.key)>-1&&e.ctrlKey&&!e.shiftKey))&&(this.pendingIOSKey=i||e,setTimeout((()=>this.flushIOSKey(t)),250),!0)}flushIOSKey(t){let e=this.pendingIOSKey;return !!e&&(this.pendingIOSKey=void 0,dispatchKey(t.contentDOM,e.key,e.keyCode))}ignoreDuringComposition(t){return !!/^key/.test(t.type)&&(this.composing>0||!!(browser.safari&&!browser.ios&&this.compositionPendingKey&&Date.now()-this.compositionEndedAt<100)&&(this.compositionPendingKey=!1,!0))}mustFlushObserver(t){return "keydown"==t.type&&229!=t.keyCode}startMouseSelection(t){this.mouseSelection&&this.mouseSelection.destroy(),this.mouseSelection=t;}update(t){this.mouseSelection&&this.mouseSelection.update(t),t.transactions.length&&(this.lastKeyCode=this.lastSelectionTime=0);}destroy(){this.mouseSelection&&this.mouseSelection.destroy();}}const PendingKeys=[{key:"Backspace",keyCode:8,inputType:"deleteContentBackward"},{key:"Enter",keyCode:13,inputType:"insertParagraph"},{key:"Delete",keyCode:46,inputType:"deleteContentForward"}],EmacsyPendingKeys="dthko",modifierCodes=[16,17,18,20,91,92,224,225];function dragScrollSpeed(t){return .7*Math.max(0,t)+8}class MouseSelection{constructor(t,e,i,o){this.view=t,this.style=i,this.mustSelect=o,this.scrollSpeed={x:0,y:0},this.scrolling=-1,this.lastEvent=e,this.scrollParent=scrollableParent(t.contentDOM),this.atoms=t.state.facet(atomicRanges).map((e=>e(t)));let s=t.contentDOM.ownerDocument;s.addEventListener("mousemove",this.move=this.move.bind(this)),s.addEventListener("mouseup",this.up=this.up.bind(this)),this.extend=e.shiftKey,this.multiple=t.state.facet(EditorState.allowMultipleSelections)&&addsSelectionRange(t,e),this.dragging=!(!isInPrimarySelection(t,e)||1!=getClickType(e))&&null;}start(t){!1===this.dragging&&(t.preventDefault(),this.select(t));}move(t){var e;if(0==t.buttons)return this.destroy();if(!1!==this.dragging)return;this.select(this.lastEvent=t);let i=0,o=0,s=(null===(e=this.scrollParent)||void 0===e?void 0:e.getBoundingClientRect())||{left:0,top:0,right:this.view.win.innerWidth,bottom:this.view.win.innerHeight},n=getScrollMargins(this.view);t.clientX-n.left<=s.left+6?i=-dragScrollSpeed(s.left-t.clientX):t.clientX+n.right>=s.right-6&&(i=dragScrollSpeed(t.clientX-s.right)),t.clientY-n.top<=s.top+6?o=-dragScrollSpeed(s.top-t.clientY):t.clientY+n.bottom>=s.bottom-6&&(o=dragScrollSpeed(t.clientY-s.bottom)),this.setScrollSpeed(i,o);}up(t){null==this.dragging&&this.select(this.lastEvent),this.dragging||t.preventDefault(),this.destroy();}destroy(){this.setScrollSpeed(0,0);let t=this.view.contentDOM.ownerDocument;t.removeEventListener("mousemove",this.move),t.removeEventListener("mouseup",this.up),this.view.inputState.mouseSelection=null;}setScrollSpeed(t,e){this.scrollSpeed={x:t,y:e},t||e?this.scrolling<0&&(this.scrolling=setInterval((()=>this.scroll()),50)):this.scrolling>-1&&(clearInterval(this.scrolling),this.scrolling=-1);}scroll(){this.scrollParent?(this.scrollParent.scrollLeft+=this.scrollSpeed.x,this.scrollParent.scrollTop+=this.scrollSpeed.y):this.view.win.scrollBy(this.scrollSpeed.x,this.scrollSpeed.y),!1===this.dragging&&this.select(this.lastEvent);}skipAtoms(t){let e=null;for(let i=0;i<t.ranges.length;i++){let o=t.ranges[i],s=null;if(o.empty){let t=skipAtomicRanges(this.atoms,o.from,0);t!=o.from&&(s=EditorSelection.cursor(t,-1));}else {let t=skipAtomicRanges(this.atoms,o.from,-1),e=skipAtomicRanges(this.atoms,o.to,1);t==o.from&&e==o.to||(s=EditorSelection.range(o.from==o.anchor?t:e,o.from==o.head?t:e));}s&&(e||(e=t.ranges.slice()),e[i]=s);}return e?EditorSelection.create(e,t.mainIndex):t}select(t){let{view:e}=this,i=this.skipAtoms(this.style.get(t,this.extend,this.multiple));!this.mustSelect&&i.eq(e.state.selection)&&i.main.assoc==e.state.selection.main.assoc||this.view.dispatch({selection:i,userEvent:"select.pointer"}),this.mustSelect=!1;}update(t){t.docChanged&&this.dragging&&(this.dragging=this.dragging.map(t.changes)),this.style.update(t)&&setTimeout((()=>this.select(this.lastEvent)),20);}}function addsSelectionRange(t,e){let i=t.state.facet(clickAddsSelectionRange);return i.length?i[0](e):browser.mac?e.metaKey:e.ctrlKey}function dragMovesSelection(t,e){let i=t.state.facet(dragMovesSelection$1);return i.length?i[0](e):browser.mac?!e.altKey:!e.ctrlKey}function isInPrimarySelection(t,e){let{main:i}=t.state.selection;if(i.empty)return !1;let o=getSelection(t.root);if(!o||0==o.rangeCount)return !0;let s=o.getRangeAt(0).getClientRects();for(let t=0;t<s.length;t++){let i=s[t];if(i.left<=e.clientX&&i.right>=e.clientX&&i.top<=e.clientY&&i.bottom>=e.clientY)return !0}return !1}function eventBelongsToEditor(t,e){if(!e.bubbles)return !0;if(e.defaultPrevented)return !1;for(let i,o=e.target;o!=t.contentDOM;o=o.parentNode)if(!o||11==o.nodeType||(i=ContentView.get(o))&&i.ignoreEvent(e))return !1;return !0}const handlers=Object.create(null),handlerOptions=Object.create(null),brokenClipboardAPI=browser.ie&&browser.ie_version<15||browser.ios&&browser.webkit_version<604;function capturePaste(t){let e=t.dom.parentNode;if(!e)return;let i=e.appendChild(document.createElement("textarea"));i.style.cssText="position: fixed; left: -10000px; top: 10px",i.focus(),setTimeout((()=>{t.focus(),i.remove(),doPaste(t,i.value);}),50);}function doPaste(t,e){let i,{state:o}=t,s=1,n=o.toText(e),r=n.lines==o.selection.ranges.length;if(null!=lastLinewiseCopy&&o.selection.ranges.every((t=>t.empty))&&lastLinewiseCopy==n.toString()){let t=-1;i=o.changeByRange((i=>{let l=o.doc.lineAt(i.from);if(l.from==t)return {range:i};t=l.from;let a=o.toText((r?n.line(s++).text:e)+o.lineBreak);return {changes:{from:l.from,insert:a},range:EditorSelection.cursor(i.from+a.length)}}));}else i=r?o.changeByRange((t=>{let e=n.line(s++);return {changes:{from:t.from,to:t.to,insert:e.text},range:EditorSelection.cursor(t.from+e.length)}})):o.replaceSelection(n);t.dispatch(i,{userEvent:"input.paste",scrollIntoView:!0});}function rangeForClick(t,e,i,o){if(1==o)return EditorSelection.cursor(e,i);if(2==o)return groupAt(t.state,e,i);{let i=LineView.find(t.docView,e),o=t.state.doc.lineAt(i?i.posAtEnd:e),s=i?i.posAtStart:o.from,n=i?i.posAtEnd:o.to;return n<t.state.doc.length&&n==o.to&&n++,EditorSelection.range(s,n)}}handlers.keydown=(t,e)=>{t.inputState.setSelectionOrigin("select"),27==e.keyCode&&(t.inputState.lastEscPress=Date.now());},handlers.touchstart=(t,e)=>{t.inputState.lastTouchTime=Date.now(),t.inputState.setSelectionOrigin("select.pointer");},handlers.touchmove=t=>{t.inputState.setSelectionOrigin("select.pointer");},handlerOptions.touchstart=handlerOptions.touchmove={passive:!0},handlers.mousedown=(t,e)=>{if(t.observer.flush(),t.inputState.lastTouchTime>Date.now()-2e3)return;let i=null;for(let o of t.state.facet(mouseSelectionStyle))if(i=o(t,e),i)break;if(i||0!=e.button||(i=basicMouseSelection(t,e)),i){let o=t.root.activeElement!=t.contentDOM;t.inputState.startMouseSelection(new MouseSelection(t,e,i,o)),o&&t.observer.ignore((()=>focusPreventScroll(t.contentDOM))),t.inputState.mouseSelection&&t.inputState.mouseSelection.start(e);}};let insideY=(t,e)=>t>=e.top&&t<=e.bottom,inside=(t,e,i)=>insideY(e,i)&&t>=i.left&&t<=i.right;function findPositionSide(t,e,i,o){let s=LineView.find(t.docView,e);if(!s)return 1;let n=e-s.posAtStart;if(0==n)return 1;if(n==s.length)return -1;let r=s.coordsAt(n,-1);if(r&&inside(i,o,r))return -1;let l=s.coordsAt(n,1);return l&&inside(i,o,l)?1:r&&insideY(o,r)?-1:1}function queryPos(t,e){let i=t.posAtCoords({x:e.clientX,y:e.clientY},!1);return {pos:i,bias:findPositionSide(t,i,e.clientX,e.clientY)}}const BadMouseDetail=browser.ie&&browser.ie_version<=11;let lastMouseDown=null,lastMouseDownCount=0,lastMouseDownTime=0;function getClickType(t){if(!BadMouseDetail)return t.detail;let e=lastMouseDown,i=lastMouseDownTime;return lastMouseDown=t,lastMouseDownTime=Date.now(),lastMouseDownCount=!e||i>Date.now()-400&&Math.abs(e.clientX-t.clientX)<2&&Math.abs(e.clientY-t.clientY)<2?(lastMouseDownCount+1)%3:1}function basicMouseSelection(t,e){let i=queryPos(t,e),o=getClickType(e),s=t.state.selection;return {update(t){t.docChanged&&(i.pos=t.changes.mapPos(i.pos),s=s.map(t.changes));},get(e,n,r){let l,a=queryPos(t,e),h=rangeForClick(t,a.pos,a.bias,o);if(i.pos!=a.pos&&!n){let e=rangeForClick(t,i.pos,i.bias,o),s=Math.min(e.from,h.from),n=Math.max(e.to,h.to);h=s<h.from?EditorSelection.range(s,n):EditorSelection.range(n,s);}return n?s.replaceRange(s.main.extend(h.from,h.to)):r&&1==o&&s.ranges.length>1&&(l=removeRangeAround(s,a.pos))?l:r?s.addRange(h):EditorSelection.create([h])}}}function removeRangeAround(t,e){for(let i=0;i<t.ranges.length;i++){let{from:o,to:s}=t.ranges[i];if(o<=e&&s>=e)return EditorSelection.create(t.ranges.slice(0,i).concat(t.ranges.slice(i+1)),t.mainIndex==i?0:t.mainIndex-(t.mainIndex>i?1:0))}return null}function dropText(t,e,i,o){if(!i)return;let s=t.posAtCoords({x:e.clientX,y:e.clientY},!1);e.preventDefault();let{mouseSelection:n}=t.inputState,r=o&&n&&n.dragging&&dragMovesSelection(t,e)?{from:n.dragging.from,to:n.dragging.to}:null,l={from:s,insert:i},a=t.state.changes(r?[r,l]:l);t.focus(),t.dispatch({changes:a,selection:{anchor:a.mapPos(s,-1),head:a.mapPos(s,1)},userEvent:r?"move.drop":"input.drop"});}function captureCopy(t,e){let i=t.dom.parentNode;if(!i)return;let o=i.appendChild(document.createElement("textarea"));o.style.cssText="position: fixed; left: -10000px; top: 10px",o.value=e,o.focus(),o.selectionEnd=e.length,o.selectionStart=0,setTimeout((()=>{o.remove(),t.focus();}),50);}function copiedRange(t){let e=[],i=[],o=!1;for(let o of t.selection.ranges)o.empty||(e.push(t.sliceDoc(o.from,o.to)),i.push(o));if(!e.length){let s=-1;for(let{from:o}of t.selection.ranges){let n=t.doc.lineAt(o);n.number>s&&(e.push(n.text),i.push({from:n.from,to:Math.min(t.doc.length,n.to+1)})),s=n.number;}o=!0;}return {text:e.join(t.lineBreak),ranges:i,linewise:o}}handlers.dragstart=(t,e)=>{let{selection:{main:i}}=t.state,{mouseSelection:o}=t.inputState;o&&(o.dragging=i),e.dataTransfer&&(e.dataTransfer.setData("Text",t.state.sliceDoc(i.from,i.to)),e.dataTransfer.effectAllowed="copyMove");},handlers.drop=(t,e)=>{if(!e.dataTransfer)return;if(t.state.readOnly)return e.preventDefault();let i=e.dataTransfer.files;if(i&&i.length){e.preventDefault();let o=Array(i.length),s=0,n=()=>{++s==i.length&&dropText(t,e,o.filter((t=>null!=t)).join(t.state.lineBreak),!1);};for(let t=0;t<i.length;t++){let e=new FileReader;e.onerror=n,e.onload=()=>{/[\x00-\x08\x0e-\x1f]{2}/.test(e.result)||(o[t]=e.result),n();},e.readAsText(i[t]);}}else dropText(t,e,e.dataTransfer.getData("Text"),!0);},handlers.paste=(t,e)=>{if(t.state.readOnly)return e.preventDefault();t.observer.flush();let i=brokenClipboardAPI?null:e.clipboardData;i?(doPaste(t,i.getData("text/plain")||i.getData("text/uri-text")),e.preventDefault()):capturePaste(t);};let lastLinewiseCopy=null;handlers.copy=handlers.cut=(t,e)=>{let{text:i,ranges:o,linewise:s}=copiedRange(t.state);if(!i&&!s)return;lastLinewiseCopy=s?i:null;let n=brokenClipboardAPI?null:e.clipboardData;n?(e.preventDefault(),n.clearData(),n.setData("text/plain",i)):captureCopy(t,i),"cut"!=e.type||t.state.readOnly||t.dispatch({changes:o,scrollIntoView:!0,userEvent:"delete.cut"});};const isFocusChange=Annotation.define();function focusChangeTransaction(t,e){let i=[];for(let o of t.facet(focusChangeEffect)){let s=o(t,e);s&&i.push(s);}return i?t.update({effects:i,annotations:isFocusChange.of(!0)}):null}function updateForFocusChange(t){setTimeout((()=>{let e=t.hasFocus;if(e!=t.inputState.notifiedFocused){let i=focusChangeTransaction(t.state,e);i?t.dispatch(i):t.update([]);}}),10);}handlers.focus=t=>{t.inputState.lastFocusTime=Date.now(),t.scrollDOM.scrollTop||!t.inputState.lastScrollTop&&!t.inputState.lastScrollLeft||(t.scrollDOM.scrollTop=t.inputState.lastScrollTop,t.scrollDOM.scrollLeft=t.inputState.lastScrollLeft),updateForFocusChange(t);},handlers.blur=t=>{t.observer.clearSelectionRange(),updateForFocusChange(t);},handlers.compositionstart=handlers.compositionupdate=t=>{null==t.inputState.compositionFirstChange&&(t.inputState.compositionFirstChange=!0),t.inputState.composing<0&&(t.inputState.composing=0);},handlers.compositionend=t=>{t.inputState.composing=-1,t.inputState.compositionEndedAt=Date.now(),t.inputState.compositionPendingKey=!0,t.inputState.compositionPendingChange=t.observer.pendingRecords().length>0,t.inputState.compositionFirstChange=null,browser.chrome&&browser.android?t.observer.flushSoon():t.inputState.compositionPendingChange?Promise.resolve().then((()=>t.observer.flush())):setTimeout((()=>{t.inputState.composing<0&&t.docView.compositionDeco.size&&t.update([]);}),50);},handlers.contextmenu=t=>{t.inputState.lastContextMenu=Date.now();},handlers.beforeinput=(t,e)=>{var i;let o;if(browser.chrome&&browser.android&&(o=PendingKeys.find((t=>t.inputType==e.inputType)))&&(t.observer.delayAndroidKey(o.key,o.keyCode),"Backspace"==o.key||"Delete"==o.key)){let e=(null===(i=window.visualViewport)||void 0===i?void 0:i.height)||0;setTimeout((()=>{var i;((null===(i=window.visualViewport)||void 0===i?void 0:i.height)||0)>e+10&&t.hasFocus&&(t.contentDOM.blur(),t.focus());}),100);}};const wrappingWhiteSpace=["pre-wrap","normal","pre-line","break-spaces"];class HeightOracle{constructor(t){this.lineWrapping=t,this.doc=Text$1.empty,this.heightSamples={},this.lineHeight=14,this.charWidth=7,this.textHeight=14,this.lineLength=30,this.heightChanged=!1;}heightForGap(t,e){let i=this.doc.lineAt(e).number-this.doc.lineAt(t).number+1;return this.lineWrapping&&(i+=Math.max(0,Math.ceil((e-t-i*this.lineLength*.5)/this.lineLength))),this.lineHeight*i}heightForLine(t){if(!this.lineWrapping)return this.lineHeight;return (1+Math.max(0,Math.ceil((t-this.lineLength)/(this.lineLength-5))))*this.lineHeight}setDoc(t){return this.doc=t,this}mustRefreshForWrapping(t){return wrappingWhiteSpace.indexOf(t)>-1!=this.lineWrapping}mustRefreshForHeights(t){let e=!1;for(let i=0;i<t.length;i++){let o=t[i];o<0?i++:this.heightSamples[Math.floor(10*o)]||(e=!0,this.heightSamples[Math.floor(10*o)]=!0);}return e}refresh(t,e,i,o,s,n){let r=wrappingWhiteSpace.indexOf(t)>-1,l=Math.round(e)!=Math.round(this.lineHeight)||this.lineWrapping!=r;if(this.lineWrapping=r,this.lineHeight=e,this.charWidth=i,this.textHeight=o,this.lineLength=s,l){this.heightSamples={};for(let t=0;t<n.length;t++){let e=n[t];e<0?t++:this.heightSamples[Math.floor(10*e)]=!0;}}return l}}class MeasuredHeights{constructor(t,e){this.from=t,this.heights=e,this.index=0;}get more(){return this.index<this.heights.length}}class BlockInfo{constructor(t,e,i,o,s){this.from=t,this.length=e,this.top=i,this.height=o,this._content=s;}get type(){return "number"==typeof this._content?BlockType.Text:Array.isArray(this._content)?this._content:this._content.type}get to(){return this.from+this.length}get bottom(){return this.top+this.height}get widget(){return this._content instanceof PointDecoration?this._content.widget:null}get widgetLineBreaks(){return "number"==typeof this._content?this._content:0}join(t){let e=(Array.isArray(this._content)?this._content:[this]).concat(Array.isArray(t._content)?t._content:[t]);return new BlockInfo(this.from,this.length+t.length,this.top,this.height+t.height,e)}}var QueryType$1=function(t){return t[t.ByPos=0]="ByPos",t[t.ByHeight=1]="ByHeight",t[t.ByPosNoHeight=2]="ByPosNoHeight",t}(QueryType$1||(QueryType$1={}));class HeightMap{constructor(t,e,i=2){this.length=t,this.height=e,this.flags=i;}get outdated(){return (2&this.flags)>0}set outdated(t){this.flags=(t?2:0)|-3&this.flags;}setHeight(t,e){this.height!=e&&(Math.abs(this.height-e)>.001&&(t.heightChanged=!0),this.height=e);}replace(t,e,i){return HeightMap.of(i)}decomposeLeft(t,e){e.push(this);}decomposeRight(t,e){e.push(this);}applyChanges(t,e,i,o){let s=this,n=i.doc;for(let r=o.length-1;r>=0;r--){let{fromA:l,toA:a,fromB:h,toB:c}=o[r],d=s.lineAt(l,QueryType$1.ByPosNoHeight,i.setDoc(e),0,0),u=d.to>=a?d:s.lineAt(a,QueryType$1.ByPosNoHeight,i,0,0);for(c+=u.to-a,a=u.to;r>0&&d.from<=o[r-1].toA;)l=o[r-1].fromA,h=o[r-1].fromB,r--,l<d.from&&(d=s.lineAt(l,QueryType$1.ByPosNoHeight,i,0,0));h+=d.from-l,l=d.from;let p=NodeBuilder.build(i.setDoc(n),t,h,c);s=s.replace(l,a,p);}return s.updateHeight(i,0)}static empty(){return new HeightMapText(0,0)}static of(t){if(1==t.length)return t[0];let e=0,i=t.length,o=0,s=0;for(;;)if(e==i)if(o>2*s){let s=t[e-1];s.break?t.splice(--e,1,s.left,null,s.right):t.splice(--e,1,s.left,s.right),i+=1+s.break,o-=s.size;}else {if(!(s>2*o))break;{let e=t[i];e.break?t.splice(i,1,e.left,null,e.right):t.splice(i,1,e.left,e.right),i+=2+e.break,s-=e.size;}}else if(o<s){let i=t[e++];i&&(o+=i.size);}else {let e=t[--i];e&&(s+=e.size);}let n=0;return null==t[e-1]?(n=1,e--):null==t[e]&&(n=1,i++),new HeightMapBranch(HeightMap.of(t.slice(0,e)),n,HeightMap.of(t.slice(i)))}}HeightMap.prototype.size=1;class HeightMapBlock extends HeightMap{constructor(t,e,i){super(t,e),this.deco=i;}blockAt(t,e,i,o){return new BlockInfo(o,this.length,i,this.height,this.deco||0)}lineAt(t,e,i,o,s){return this.blockAt(0,i,o,s)}forEachLine(t,e,i,o,s,n){t<=s+this.length&&e>=s&&n(this.blockAt(0,i,o,s));}updateHeight(t,e=0,i=!1,o){return o&&o.from<=e&&o.more&&this.setHeight(t,o.heights[o.index++]),this.outdated=!1,this}toString(){return `block(${this.length})`}}class HeightMapText extends HeightMapBlock{constructor(t,e){super(t,e,null),this.collapsed=0,this.widgetHeight=0,this.breaks=0;}blockAt(t,e,i,o){return new BlockInfo(o,this.length,i,this.height,this.breaks)}replace(t,e,i){let o=i[0];return 1==i.length&&(o instanceof HeightMapText||o instanceof HeightMapGap&&4&o.flags)&&Math.abs(this.length-o.length)<10?(o instanceof HeightMapGap?o=new HeightMapText(o.length,this.height):o.height=this.height,this.outdated||(o.outdated=!1),o):HeightMap.of(i)}updateHeight(t,e=0,i=!1,o){return o&&o.from<=e&&o.more?this.setHeight(t,o.heights[o.index++]):(i||this.outdated)&&this.setHeight(t,Math.max(this.widgetHeight,t.heightForLine(this.length-this.collapsed))+this.breaks*t.lineHeight),this.outdated=!1,this}toString(){return `line(${this.length}${this.collapsed?-this.collapsed:""}${this.widgetHeight?":"+this.widgetHeight:""})`}}class HeightMapGap extends HeightMap{constructor(t){super(t,0);}heightMetrics(t,e){let i,o=t.doc.lineAt(e).number,s=t.doc.lineAt(e+this.length).number,n=s-o+1,r=0;if(t.lineWrapping){let e=Math.min(this.height,t.lineHeight*n);i=e/n,this.length>n+1&&(r=(this.height-e)/(this.length-n-1));}else i=this.height/n;return {firstLine:o,lastLine:s,perLine:i,perChar:r}}blockAt(t,e,i,o){let{firstLine:s,lastLine:n,perLine:r,perChar:l}=this.heightMetrics(e,o);if(e.lineWrapping){let s=o+Math.round(Math.max(0,Math.min(1,(t-i)/this.height))*this.length),n=e.doc.lineAt(s),a=r+n.length*l,h=Math.max(i,t-a/2);return new BlockInfo(n.from,n.length,h,a,0)}{let o=Math.max(0,Math.min(n-s,Math.floor((t-i)/r))),{from:l,length:a}=e.doc.line(s+o);return new BlockInfo(l,a,i+r*o,r,0)}}lineAt(t,e,i,o,s){if(e==QueryType$1.ByHeight)return this.blockAt(t,i,o,s);if(e==QueryType$1.ByPosNoHeight){let{from:e,to:o}=i.doc.lineAt(t);return new BlockInfo(e,o-e,0,0,0)}let{firstLine:n,perLine:r,perChar:l}=this.heightMetrics(i,s),a=i.doc.lineAt(t),h=r+a.length*l,c=a.number-n,d=o+r*c+l*(a.from-s-c);return new BlockInfo(a.from,a.length,Math.max(o,Math.min(d,o+this.height-h)),h,0)}forEachLine(t,e,i,o,s,n){t=Math.max(t,s),e=Math.min(e,s+this.length);let{firstLine:r,perLine:l,perChar:a}=this.heightMetrics(i,s);for(let h=t,c=o;h<=e;){let e=i.doc.lineAt(h);if(h==t){let i=e.number-r;c+=l*i+a*(t-s-i);}let o=l+a*e.length;n(new BlockInfo(e.from,e.length,c,o,0)),c+=o,h=e.to+1;}}replace(t,e,i){let o=this.length-e;if(o>0){let t=i[i.length-1];t instanceof HeightMapGap?i[i.length-1]=new HeightMapGap(t.length+o):i.push(null,new HeightMapGap(o-1));}if(t>0){let e=i[0];e instanceof HeightMapGap?i[0]=new HeightMapGap(t+e.length):i.unshift(new HeightMapGap(t-1),null);}return HeightMap.of(i)}decomposeLeft(t,e){e.push(new HeightMapGap(t-1),null);}decomposeRight(t,e){e.push(null,new HeightMapGap(this.length-t-1));}updateHeight(t,e=0,i=!1,o){let s=e+this.length;if(o&&o.from<=e+this.length&&o.more){let i=[],n=Math.max(e,o.from),r=-1;for(o.from>e&&i.push(new HeightMapGap(o.from-e-1).updateHeight(t,e));n<=s&&o.more;){let e=t.doc.lineAt(n).length;i.length&&i.push(null);let s=o.heights[o.index++];-1==r?r=s:Math.abs(s-r)>=.001&&(r=-2);let l=new HeightMapText(e,s);l.outdated=!1,i.push(l),n+=e+1;}n<=s&&i.push(null,new HeightMapGap(s-n).updateHeight(t,n));let l=HeightMap.of(i);return (r<0||Math.abs(l.height-this.height)>=.001||Math.abs(r-this.heightMetrics(t,e).perLine)>=.001)&&(t.heightChanged=!0),l}return (i||this.outdated)&&(this.setHeight(t,t.heightForGap(e,e+this.length)),this.outdated=!1),this}toString(){return `gap(${this.length})`}}class HeightMapBranch extends HeightMap{constructor(t,e,i){super(t.length+e+i.length,t.height+i.height,e|(t.outdated||i.outdated?2:0)),this.left=t,this.right=i,this.size=t.size+i.size;}get break(){return 1&this.flags}blockAt(t,e,i,o){let s=i+this.left.height;return t<s?this.left.blockAt(t,e,i,o):this.right.blockAt(t,e,s,o+this.left.length+this.break)}lineAt(t,e,i,o,s){let n=o+this.left.height,r=s+this.left.length+this.break,l=e==QueryType$1.ByHeight?t<n:t<r,a=l?this.left.lineAt(t,e,i,o,s):this.right.lineAt(t,e,i,n,r);if(this.break||(l?a.to<r:a.from>r))return a;let h=e==QueryType$1.ByPosNoHeight?QueryType$1.ByPosNoHeight:QueryType$1.ByPos;return l?a.join(this.right.lineAt(r,h,i,n,r)):this.left.lineAt(r,h,i,o,s).join(a)}forEachLine(t,e,i,o,s,n){let r=o+this.left.height,l=s+this.left.length+this.break;if(this.break)t<l&&this.left.forEachLine(t,e,i,o,s,n),e>=l&&this.right.forEachLine(t,e,i,r,l,n);else {let a=this.lineAt(l,QueryType$1.ByPos,i,o,s);t<a.from&&this.left.forEachLine(t,a.from-1,i,o,s,n),a.to>=t&&a.from<=e&&n(a),e>a.to&&this.right.forEachLine(a.to+1,e,i,r,l,n);}}replace(t,e,i){let o=this.left.length+this.break;if(e<o)return this.balanced(this.left.replace(t,e,i),this.right);if(t>this.left.length)return this.balanced(this.left,this.right.replace(t-o,e-o,i));let s=[];t>0&&this.decomposeLeft(t,s);let n=s.length;for(let t of i)s.push(t);if(t>0&&mergeGaps(s,n-1),e<this.length){let t=s.length;this.decomposeRight(e,s),mergeGaps(s,t);}return HeightMap.of(s)}decomposeLeft(t,e){let i=this.left.length;if(t<=i)return this.left.decomposeLeft(t,e);e.push(this.left),this.break&&(i++,t>=i&&e.push(null)),t>i&&this.right.decomposeLeft(t-i,e);}decomposeRight(t,e){let i=this.left.length,o=i+this.break;if(t>=o)return this.right.decomposeRight(t-o,e);t<i&&this.left.decomposeRight(t,e),this.break&&t<o&&e.push(null),e.push(this.right);}balanced(t,e){return t.size>2*e.size||e.size>2*t.size?HeightMap.of(this.break?[t,null,e]:[t,e]):(this.left=t,this.right=e,this.height=t.height+e.height,this.outdated=t.outdated||e.outdated,this.size=t.size+e.size,this.length=t.length+this.break+e.length,this)}updateHeight(t,e=0,i=!1,o){let{left:s,right:n}=this,r=e+s.length+this.break,l=null;return o&&o.from<=e+s.length&&o.more?l=s=s.updateHeight(t,e,i,o):s.updateHeight(t,e,i),o&&o.from<=r+n.length&&o.more?l=n=n.updateHeight(t,r,i,o):n.updateHeight(t,r,i),l?this.balanced(s,n):(this.height=this.left.height+this.right.height,this.outdated=!1,this)}toString(){return this.left+(this.break?" ":"-")+this.right}}function mergeGaps(t,e){let i,o;null==t[e]&&(i=t[e-1])instanceof HeightMapGap&&(o=t[e+1])instanceof HeightMapGap&&t.splice(e-1,3,new HeightMapGap(i.length+1+o.length));}class NodeBuilder{constructor(t,e){this.pos=t,this.oracle=e,this.nodes=[],this.lineStart=-1,this.lineEnd=-1,this.covering=null,this.writtenTo=t;}get isCovered(){return this.covering&&this.nodes[this.nodes.length-1]==this.covering}span(t,e){if(this.lineStart>-1){let t=Math.min(e,this.lineEnd),i=this.nodes[this.nodes.length-1];i instanceof HeightMapText?i.length+=t-this.pos:(t>this.pos||!this.isCovered)&&this.nodes.push(new HeightMapText(t-this.pos,-1)),this.writtenTo=t,e>t&&(this.nodes.push(null),this.writtenTo++,this.lineStart=-1);}this.pos=e;}point(t,e,i){if(t<e||i.heightRelevant){let o=i.widget?i.widget.estimatedHeight:0,s=i.widget?i.widget.lineBreaks:0;o<0&&(o=this.oracle.lineHeight);let n=e-t;i.block?this.addBlock(new HeightMapBlock(n,o,i)):(n||s||o>=5)&&this.addLineDeco(o,s,n);}else e>t&&this.span(t,e);this.lineEnd>-1&&this.lineEnd<this.pos&&(this.lineEnd=this.oracle.doc.lineAt(this.pos).to);}enterLine(){if(this.lineStart>-1)return;let{from:t,to:e}=this.oracle.doc.lineAt(this.pos);this.lineStart=t,this.lineEnd=e,this.writtenTo<t&&((this.writtenTo<t-1||null==this.nodes[this.nodes.length-1])&&this.nodes.push(this.blankContent(this.writtenTo,t-1)),this.nodes.push(null)),this.pos>t&&this.nodes.push(new HeightMapText(this.pos-t,-1)),this.writtenTo=this.pos;}blankContent(t,e){let i=new HeightMapGap(e-t);return this.oracle.doc.lineAt(t).to==e&&(i.flags|=4),i}ensureLine(){this.enterLine();let t=this.nodes.length?this.nodes[this.nodes.length-1]:null;if(t instanceof HeightMapText)return t;let e=new HeightMapText(0,-1);return this.nodes.push(e),e}addBlock(t){var e;this.enterLine();let i=null===(e=t.deco)||void 0===e?void 0:e.type;i!=BlockType.WidgetAfter||this.isCovered||this.ensureLine(),this.nodes.push(t),this.writtenTo=this.pos=this.pos+t.length,i!=BlockType.WidgetBefore&&(this.covering=t);}addLineDeco(t,e,i){let o=this.ensureLine();o.length+=i,o.collapsed+=i,o.widgetHeight=Math.max(o.widgetHeight,t),o.breaks+=e,this.writtenTo=this.pos=this.pos+i;}finish(t){let e=0==this.nodes.length?null:this.nodes[this.nodes.length-1];!(this.lineStart>-1)||e instanceof HeightMapText||this.isCovered?(this.writtenTo<this.pos||null==e)&&this.nodes.push(this.blankContent(this.writtenTo,this.pos)):this.nodes.push(new HeightMapText(0,-1));let i=t;for(let t of this.nodes)t instanceof HeightMapText&&t.updateHeight(this.oracle,i),i+=t?t.length:1;return this.nodes}static build(t,e,i,o){let s=new NodeBuilder(i,t);return RangeSet.spans(e,i,o,s,0),s.finish(i)}}function heightRelevantDecoChanges(t,e,i){let o=new DecorationComparator;return RangeSet.compare(t,e,i,o,0),o.changes}class DecorationComparator{constructor(){this.changes=[];}compareRange(){}comparePoint(t,e,i,o){(t<e||i&&i.heightRelevant||o&&o.heightRelevant)&&addRange(t,e,this.changes,5);}}function visiblePixelRange(t,e){let i=t.getBoundingClientRect(),o=t.ownerDocument,s=o.defaultView||window,n=Math.max(0,i.left),r=Math.min(s.innerWidth,i.right),l=Math.max(0,i.top),a=Math.min(s.innerHeight,i.bottom);for(let e=t.parentNode;e&&e!=o.body;)if(1==e.nodeType){let i=e,o=window.getComputedStyle(i);if((i.scrollHeight>i.clientHeight||i.scrollWidth>i.clientWidth)&&"visible"!=o.overflow){let o=i.getBoundingClientRect();n=Math.max(n,o.left),r=Math.min(r,o.right),l=Math.max(l,o.top),a=e==t.parentNode?o.bottom:Math.min(a,o.bottom);}e="absolute"==o.position||"fixed"==o.position?i.offsetParent:i.parentNode;}else {if(11!=e.nodeType)break;e=e.host;}return {left:n-i.left,right:Math.max(n,r)-i.left,top:l-(i.top+e),bottom:Math.max(l,a)-(i.top+e)}}function fullPixelRange(t,e){let i=t.getBoundingClientRect();return {left:0,right:i.right-i.left,top:e,bottom:i.bottom-(i.top+e)}}class LineGap{constructor(t,e,i){this.from=t,this.to=e,this.size=i;}static same(t,e){if(t.length!=e.length)return !1;for(let i=0;i<t.length;i++){let o=t[i],s=e[i];if(o.from!=s.from||o.to!=s.to||o.size!=s.size)return !1}return !0}draw(t){return Decoration.replace({widget:new LineGapWidget(this.size,t)}).range(this.from,this.to)}}class LineGapWidget extends WidgetType{constructor(t,e){super(),this.size=t,this.vertical=e;}eq(t){return t.size==this.size&&t.vertical==this.vertical}toDOM(){let t=document.createElement("div");return this.vertical?t.style.height=this.size+"px":(t.style.width=this.size+"px",t.style.height="2px",t.style.display="inline-block"),t}get estimatedHeight(){return this.vertical?this.size:-1}}class ViewState{constructor(t){this.state=t,this.pixelViewport={left:0,right:window.innerWidth,top:0,bottom:0},this.inView=!0,this.paddingTop=0,this.paddingBottom=0,this.contentDOMWidth=0,this.contentDOMHeight=0,this.editorHeight=0,this.editorWidth=0,this.scrollTop=0,this.scrolledToBottom=!0,this.scrollAnchorPos=0,this.scrollAnchorHeight=-1,this.scaler=IdScaler,this.scrollTarget=null,this.printing=!1,this.mustMeasureContent=!0,this.defaultTextDirection=Direction.LTR,this.visibleRanges=[],this.mustEnforceCursorAssoc=!1;let e=t.facet(contentAttributes).some((t=>"function"!=typeof t&&"cm-lineWrapping"==t.class));this.heightOracle=new HeightOracle(e),this.stateDeco=t.facet(decorations).filter((t=>"function"!=typeof t)),this.heightMap=HeightMap.empty().applyChanges(this.stateDeco,Text$1.empty,this.heightOracle.setDoc(t.doc),[new ChangedRange(0,0,0,t.doc.length)]),this.viewport=this.getViewport(0,null),this.updateViewportLines(),this.updateForViewport(),this.lineGaps=this.ensureLineGaps([]),this.lineGapDeco=Decoration.set(this.lineGaps.map((t=>t.draw(!1)))),this.computeVisibleRanges();}updateForViewport(){let t=[this.viewport],{main:e}=this.state.selection;for(let i=0;i<=1;i++){let o=i?e.head:e.anchor;if(!t.some((({from:t,to:e})=>o>=t&&o<=e))){let{from:e,to:i}=this.lineBlockAt(o);t.push(new Viewport(e,i));}}this.viewports=t.sort(((t,e)=>t.from-e.from)),this.scaler=this.heightMap.height<=7e6?IdScaler:new BigScaler(this.heightOracle,this.heightMap,this.viewports);}updateViewportLines(){this.viewportLines=[],this.heightMap.forEachLine(this.viewport.from,this.viewport.to,this.heightOracle.setDoc(this.state.doc),0,0,(t=>{this.viewportLines.push(1==this.scaler.scale?t:scaleBlock(t,this.scaler));}));}update(t,e=null){this.state=t.state;let i=this.stateDeco;this.stateDeco=this.state.facet(decorations).filter((t=>"function"!=typeof t));let o=t.changedRanges,s=ChangedRange.extendWithRanges(o,heightRelevantDecoChanges(i,this.stateDeco,t?t.changes:ChangeSet.empty(this.state.doc.length))),n=this.heightMap.height,r=this.scrolledToBottom?null:this.lineBlockAtHeight(this.scrollTop);this.heightMap=this.heightMap.applyChanges(this.stateDeco,t.startState.doc,this.heightOracle.setDoc(this.state.doc),s),this.heightMap.height!=n&&(t.flags|=2),r?(this.scrollAnchorPos=t.changes.mapPos(r.from,-1),this.scrollAnchorHeight=r.top):(this.scrollAnchorPos=-1,this.scrollAnchorHeight=this.heightMap.height);let l=s.length?this.mapViewport(this.viewport,t.changes):this.viewport;(e&&(e.range.head<l.from||e.range.head>l.to)||!this.viewportIsAppropriate(l))&&(l=this.getViewport(0,e));let a=!t.changes.empty||2&t.flags||l.from!=this.viewport.from||l.to!=this.viewport.to;this.viewport=l,this.updateForViewport(),a&&this.updateViewportLines(),(this.lineGaps.length||this.viewport.to-this.viewport.from>4e3)&&this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps,t.changes))),t.flags|=this.computeVisibleRanges(),e&&(this.scrollTarget=e),!this.mustEnforceCursorAssoc&&t.selectionSet&&t.view.lineWrapping&&t.state.selection.main.empty&&t.state.selection.main.assoc&&!t.state.facet(nativeSelectionHidden)&&(this.mustEnforceCursorAssoc=!0);}measure(t){let e=t.contentDOM,i=window.getComputedStyle(e),o=this.heightOracle,s=i.whiteSpace;this.defaultTextDirection="rtl"==i.direction?Direction.RTL:Direction.LTR;let n=this.heightOracle.mustRefreshForWrapping(s),r=e.getBoundingClientRect(),l=n||this.mustMeasureContent||this.contentDOMHeight!=r.height;this.contentDOMHeight=r.height,this.mustMeasureContent=!1;let a=0,h=0,c=parseInt(i.paddingTop)||0,d=parseInt(i.paddingBottom)||0;this.paddingTop==c&&this.paddingBottom==d||(this.paddingTop=c,this.paddingBottom=d,a|=10),this.editorWidth!=t.scrollDOM.clientWidth&&(o.lineWrapping&&(l=!0),this.editorWidth=t.scrollDOM.clientWidth,a|=8),this.scrollTop!=t.scrollDOM.scrollTop&&(this.scrollAnchorHeight=-1,this.scrollTop=t.scrollDOM.scrollTop),this.scrolledToBottom=this.scrollTop>t.scrollDOM.scrollHeight-t.scrollDOM.clientHeight-4;let u=(this.printing?fullPixelRange:visiblePixelRange)(e,this.paddingTop),p=u.top-this.pixelViewport.top,f=u.bottom-this.pixelViewport.bottom;this.pixelViewport=u;let g=this.pixelViewport.bottom>this.pixelViewport.top&&this.pixelViewport.right>this.pixelViewport.left;if(g!=this.inView&&(this.inView=g,g&&(l=!0)),!this.inView&&!this.scrollTarget)return 0;let m=r.width;if(this.contentDOMWidth==m&&this.editorHeight==t.scrollDOM.clientHeight||(this.contentDOMWidth=r.width,this.editorHeight=t.scrollDOM.clientHeight,a|=8),l){let e=t.docView.measureVisibleLineHeights(this.viewport);if(o.mustRefreshForHeights(e)&&(n=!0),n||o.lineWrapping&&Math.abs(m-this.contentDOMWidth)>o.charWidth){let{lineHeight:i,charWidth:r,textHeight:l}=t.docView.measureTextSize();n=i>0&&o.refresh(s,i,r,l,m/r,e),n&&(t.docView.minWidth=0,a|=8);}p>0&&f>0?h=Math.max(p,f):p<0&&f<0&&(h=Math.min(p,f)),o.heightChanged=!1;for(let i of this.viewports){let s=i.from==this.viewport.from?e:t.docView.measureVisibleLineHeights(i);this.heightMap=(n?HeightMap.empty().applyChanges(this.stateDeco,Text$1.empty,this.heightOracle,[new ChangedRange(0,0,0,t.state.doc.length)]):this.heightMap).updateHeight(o,0,n,new MeasuredHeights(i.from,s));}o.heightChanged&&(a|=2);}let w=!this.viewportIsAppropriate(this.viewport,h)||this.scrollTarget&&(this.scrollTarget.range.head<this.viewport.from||this.scrollTarget.range.head>this.viewport.to);return w&&(this.viewport=this.getViewport(h,this.scrollTarget)),this.updateForViewport(),(2&a||w)&&this.updateViewportLines(),(this.lineGaps.length||this.viewport.to-this.viewport.from>4e3)&&this.updateLineGaps(this.ensureLineGaps(n?[]:this.lineGaps,t)),a|=this.computeVisibleRanges(),this.mustEnforceCursorAssoc&&(this.mustEnforceCursorAssoc=!1,t.docView.enforceCursorAssoc()),a}get visibleTop(){return this.scaler.fromDOM(this.pixelViewport.top)}get visibleBottom(){return this.scaler.fromDOM(this.pixelViewport.bottom)}getViewport(t,e){let i=.5-Math.max(-.5,Math.min(.5,t/1e3/2)),o=this.heightMap,s=this.heightOracle,{visibleTop:n,visibleBottom:r}=this,l=new Viewport(o.lineAt(n-1e3*i,QueryType$1.ByHeight,s,0,0).from,o.lineAt(r+1e3*(1-i),QueryType$1.ByHeight,s,0,0).to);if(e){let{head:t}=e.range;if(t<l.from||t>l.to){let i,n=Math.min(this.editorHeight,this.pixelViewport.bottom-this.pixelViewport.top),r=o.lineAt(t,QueryType$1.ByPos,s,0,0);i="center"==e.y?(r.top+r.bottom)/2-n/2:"start"==e.y||"nearest"==e.y&&t<l.from?r.top:r.bottom-n,l=new Viewport(o.lineAt(i-500,QueryType$1.ByHeight,s,0,0).from,o.lineAt(i+n+500,QueryType$1.ByHeight,s,0,0).to);}}return l}mapViewport(t,e){let i=e.mapPos(t.from,-1),o=e.mapPos(t.to,1);return new Viewport(this.heightMap.lineAt(i,QueryType$1.ByPos,this.heightOracle,0,0).from,this.heightMap.lineAt(o,QueryType$1.ByPos,this.heightOracle,0,0).to)}viewportIsAppropriate({from:t,to:e},i=0){if(!this.inView)return !0;let{top:o}=this.heightMap.lineAt(t,QueryType$1.ByPos,this.heightOracle,0,0),{bottom:s}=this.heightMap.lineAt(e,QueryType$1.ByPos,this.heightOracle,0,0),{visibleTop:n,visibleBottom:r}=this;return (0==t||o<=n-Math.max(10,Math.min(-i,250)))&&(e==this.state.doc.length||s>=r+Math.max(10,Math.min(i,250)))&&o>n-2e3&&s<r+2e3}mapLineGaps(t,e){if(!t.length||e.empty)return t;let i=[];for(let o of t)e.touchesRange(o.from,o.to)||i.push(new LineGap(e.mapPos(o.from),e.mapPos(o.to),o.size));return i}ensureLineGaps(t,e){let i=this.heightOracle.lineWrapping,o=i?1e4:2e3,s=o>>1,n=o<<1;if(this.defaultTextDirection!=Direction.LTR&&!i)return [];let r=[],l=(o,n,a,h)=>{if(n-o<s)return;let c=this.state.selection.main,d=[c.from];c.empty||d.push(c.to);for(let t of d)if(t>o&&t<n)return l(o,t-10,a,h),void l(t+10,n,a,h);let u=find(t,(t=>t.from>=a.from&&t.to<=a.to&&Math.abs(t.from-o)<s&&Math.abs(t.to-n)<s&&!d.some((e=>t.from<e&&t.to>e))));if(!u){if(n<a.to&&e&&i&&e.visibleRanges.some((t=>t.from<=n&&t.to>=n))){let t=e.moveToLineBoundary(EditorSelection.cursor(n),!1,!0).head;t>o&&(n=t);}u=new LineGap(o,n,this.gapSize(a,o,n,h));}r.push(u);};for(let t of this.viewportLines){if(t.length<n)continue;let e=lineStructure(t.from,t.to,this.stateDeco);if(e.total<n)continue;let s,r,a=this.scrollTarget?this.scrollTarget.range.head:null;if(i){let i,n,l=o/this.heightOracle.lineLength*this.heightOracle.lineHeight;if(null!=a){let o=findFraction(e,a),s=((this.visibleBottom-this.visibleTop)/2+l)/t.height;i=o-s,n=o+s;}else i=(this.visibleTop-t.top-l)/t.height,n=(this.visibleBottom-t.top+l)/t.height;s=findPosition(e,i),r=findPosition(e,n);}else {let t,i,n=e.total*this.heightOracle.charWidth,l=o*this.heightOracle.charWidth;if(null!=a){let o=findFraction(e,a),s=((this.pixelViewport.right-this.pixelViewport.left)/2+l)/n;t=o-s,i=o+s;}else t=(this.pixelViewport.left-l)/n,i=(this.pixelViewport.right+l)/n;s=findPosition(e,t),r=findPosition(e,i);}s>t.from&&l(t.from,s,t,e),r<t.to&&l(r,t.to,t,e);}return r}gapSize(t,e,i,o){let s=findFraction(o,i)-findFraction(o,e);return this.heightOracle.lineWrapping?t.height*s:o.total*this.heightOracle.charWidth*s}updateLineGaps(t){LineGap.same(t,this.lineGaps)||(this.lineGaps=t,this.lineGapDeco=Decoration.set(t.map((t=>t.draw(this.heightOracle.lineWrapping)))));}computeVisibleRanges(){let t=this.stateDeco;this.lineGaps.length&&(t=t.concat(this.lineGapDeco));let e=[];RangeSet.spans(t,this.viewport.from,this.viewport.to,{span(t,i){e.push({from:t,to:i});},point(){}},20);let i=e.length!=this.visibleRanges.length||this.visibleRanges.some(((t,i)=>t.from!=e[i].from||t.to!=e[i].to));return this.visibleRanges=e,i?4:0}lineBlockAt(t){return t>=this.viewport.from&&t<=this.viewport.to&&this.viewportLines.find((e=>e.from<=t&&e.to>=t))||scaleBlock(this.heightMap.lineAt(t,QueryType$1.ByPos,this.heightOracle,0,0),this.scaler)}lineBlockAtHeight(t){return scaleBlock(this.heightMap.lineAt(this.scaler.fromDOM(t),QueryType$1.ByHeight,this.heightOracle,0,0),this.scaler)}elementAtHeight(t){return scaleBlock(this.heightMap.blockAt(this.scaler.fromDOM(t),this.heightOracle,0,0),this.scaler)}get docHeight(){return this.scaler.toDOM(this.heightMap.height)}get contentHeight(){return this.docHeight+this.paddingTop+this.paddingBottom}}class Viewport{constructor(t,e){this.from=t,this.to=e;}}function lineStructure(t,e,i){let o=[],s=t,n=0;return RangeSet.spans(i,t,e,{span(){},point(t,e){t>s&&(o.push({from:s,to:t}),n+=t-s),s=e;}},20),s<e&&(o.push({from:s,to:e}),n+=e-s),{total:n,ranges:o}}function findPosition({total:t,ranges:e},i){if(i<=0)return e[0].from;if(i>=1)return e[e.length-1].to;let o=Math.floor(t*i);for(let t=0;;t++){let{from:i,to:s}=e[t],n=s-i;if(o<=n)return i+o;o-=n;}}function findFraction(t,e){let i=0;for(let{from:o,to:s}of t.ranges){if(e<=s){i+=e-o;break}i+=s-o;}return i/t.total}function find(t,e){for(let i of t)if(e(i))return i}const IdScaler={toDOM:t=>t,fromDOM:t=>t,scale:1};class BigScaler{constructor(t,e,i){let o=0,s=0,n=0;this.viewports=i.map((({from:i,to:s})=>{let n=e.lineAt(i,QueryType$1.ByPos,t,0,0).top,r=e.lineAt(s,QueryType$1.ByPos,t,0,0).bottom;return o+=r-n,{from:i,to:s,top:n,bottom:r,domTop:0,domBottom:0}})),this.scale=(7e6-o)/(e.height-o);for(let t of this.viewports)t.domTop=n+(t.top-s)*this.scale,n=t.domBottom=t.domTop+(t.bottom-t.top),s=t.bottom;}toDOM(t){for(let e=0,i=0,o=0;;e++){let s=e<this.viewports.length?this.viewports[e]:null;if(!s||t<s.top)return o+(t-i)*this.scale;if(t<=s.bottom)return s.domTop+(t-s.top);i=s.bottom,o=s.domBottom;}}fromDOM(t){for(let e=0,i=0,o=0;;e++){let s=e<this.viewports.length?this.viewports[e]:null;if(!s||t<s.domTop)return i+(t-o)/this.scale;if(t<=s.domBottom)return s.top+(t-s.domTop);i=s.bottom,o=s.domBottom;}}}function scaleBlock(t,e){if(1==e.scale)return t;let i=e.toDOM(t.top),o=e.toDOM(t.bottom);return new BlockInfo(t.from,t.length,i,o-i,Array.isArray(t._content)?t._content.map((t=>scaleBlock(t,e))):t._content)}const theme=Facet.define({combine:t=>t.join(" ")}),darkTheme=Facet.define({combine:t=>t.indexOf(!0)>-1}),baseThemeID=StyleModule.newName(),baseLightID=StyleModule.newName(),baseDarkID=StyleModule.newName(),lightDarkIDs={"&light":"."+baseLightID,"&dark":"."+baseDarkID};function buildTheme(t,e,i){return new StyleModule(e,{finish:e=>/&/.test(e)?e.replace(/&\w*/,(e=>{if("&"==e)return t;if(!i||!i[e])throw new RangeError(`Unsupported selector: ${e}`);return i[e]})):t+" "+e})}const baseTheme$1$2=buildTheme("."+baseThemeID,{"&":{position:"relative !important",boxSizing:"border-box","&.cm-focused":{outline:"1px dotted #212121"},display:"flex !important",flexDirection:"column"},".cm-scroller":{display:"flex !important",alignItems:"flex-start !important",fontFamily:"monospace",lineHeight:1.4,height:"100%",overflowX:"auto",position:"relative",zIndex:0},".cm-content":{margin:0,flexGrow:2,flexShrink:0,display:"block",whiteSpace:"pre",wordWrap:"normal",boxSizing:"border-box",padding:"4px 0",outline:"none","&[contenteditable=true]":{WebkitUserModify:"read-write-plaintext-only"}},".cm-lineWrapping":{whiteSpace_fallback:"pre-wrap",whiteSpace:"break-spaces",wordBreak:"break-word",overflowWrap:"anywhere",flexShrink:1},"&light .cm-content":{caretColor:"black"},"&dark .cm-content":{caretColor:"white"},".cm-line":{display:"block",padding:"0 2px 0 6px"},".cm-layer":{position:"absolute",left:0,top:0,contain:"size style","& > *":{position:"absolute"}},"&light .cm-selectionBackground":{background:"#d9d9d9"},"&dark .cm-selectionBackground":{background:"#222"},"&light.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground":{background:"#d7d4f0"},"&dark.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground":{background:"#233"},".cm-cursorLayer":{pointerEvents:"none"},"&.cm-focused > .cm-scroller > .cm-cursorLayer":{animation:"steps(1) cm-blink 1.2s infinite"},"@keyframes cm-blink":{"0%":{},"50%":{opacity:0},"100%":{}},"@keyframes cm-blink2":{"0%":{},"50%":{opacity:0},"100%":{}},".cm-cursor, .cm-dropCursor":{borderLeft:"1.2px solid black",marginLeft:"-0.6px",pointerEvents:"none"},".cm-cursor":{display:"none"},"&dark .cm-cursor":{borderLeftColor:"#444"},".cm-dropCursor":{position:"absolute"},"&.cm-focused > .cm-scroller > .cm-cursorLayer .cm-cursor":{display:"block"},"&light .cm-activeLine":{backgroundColor:"#cceeff44"},"&dark .cm-activeLine":{backgroundColor:"#99eeff33"},"&light .cm-specialChar":{color:"red"},"&dark .cm-specialChar":{color:"#f78"},".cm-gutters":{flexShrink:0,display:"flex",height:"100%",boxSizing:"border-box",left:0,zIndex:200},"&light .cm-gutters":{backgroundColor:"#f5f5f5",color:"#6c6c6c",borderRight:"1px solid #ddd"},"&dark .cm-gutters":{backgroundColor:"#333338",color:"#ccc"},".cm-gutter":{display:"flex !important",flexDirection:"column",flexShrink:0,boxSizing:"border-box",minHeight:"100%",overflow:"hidden"},".cm-gutterElement":{boxSizing:"border-box"},".cm-lineNumbers .cm-gutterElement":{padding:"0 3px 0 5px",minWidth:"20px",textAlign:"right",whiteSpace:"nowrap"},"&light .cm-activeLineGutter":{backgroundColor:"#e2f2ff"},"&dark .cm-activeLineGutter":{backgroundColor:"#222227"},".cm-panels":{boxSizing:"border-box",position:"sticky",left:0,right:0},"&light .cm-panels":{backgroundColor:"#f5f5f5",color:"black"},"&light .cm-panels-top":{borderBottom:"1px solid #ddd"},"&light .cm-panels-bottom":{borderTop:"1px solid #ddd"},"&dark .cm-panels":{backgroundColor:"#333338",color:"white"},".cm-tab":{display:"inline-block",overflow:"hidden",verticalAlign:"bottom"},".cm-widgetBuffer":{verticalAlign:"text-top",height:"1em",width:0,display:"inline"},".cm-placeholder":{color:"#888",display:"inline-block",verticalAlign:"top"},".cm-highlightSpace:before":{content:"attr(data-display)",position:"absolute",pointerEvents:"none",color:"#888"},".cm-highlightTab":{backgroundImage:'url(\'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="200" height="20"><path stroke="%23888" stroke-width="1" fill="none" d="M1 10H196L190 5M190 15L196 10M197 4L197 16"/></svg>\')',backgroundSize:"auto 100%",backgroundPosition:"right 90%",backgroundRepeat:"no-repeat"},".cm-trailingSpace":{backgroundColor:"#ff332255"},".cm-button":{verticalAlign:"middle",color:"inherit",fontSize:"70%",padding:".2em 1em",borderRadius:"1px"},"&light .cm-button":{backgroundImage:"linear-gradient(#eff1f5, #d9d9df)",border:"1px solid #888","&:active":{backgroundImage:"linear-gradient(#b4b4b4, #d0d3d6)"}},"&dark .cm-button":{backgroundImage:"linear-gradient(#393939, #111)",border:"1px solid #888","&:active":{backgroundImage:"linear-gradient(#111, #333)"}},".cm-textfield":{verticalAlign:"middle",color:"inherit",fontSize:"70%",border:"1px solid silver",padding:".2em .5em"},"&light .cm-textfield":{backgroundColor:"white"},"&dark .cm-textfield":{border:"1px solid #555",backgroundColor:"inherit"}},lightDarkIDs);class DOMChange{constructor(t,e,i,o){this.typeOver=o,this.bounds=null,this.text="";let{impreciseHead:s,impreciseAnchor:n}=t.docView;if(t.state.readOnly&&e>-1)this.newSel=null;else if(e>-1&&(this.bounds=t.docView.domBoundsAround(e,i,0))){let e=s||n?[]:selectionPoints(t),i=new DOMReader(e,t.state);i.readRange(this.bounds.startDOM,this.bounds.endDOM),this.text=i.text,this.newSel=selectionFromPoints(e,this.bounds.from);}else {let e=t.observer.selectionRange,i=s&&s.node==e.focusNode&&s.offset==e.focusOffset||!contains(t.contentDOM,e.focusNode)?t.state.selection.main.head:t.docView.posFromDOM(e.focusNode,e.focusOffset),o=n&&n.node==e.anchorNode&&n.offset==e.anchorOffset||!contains(t.contentDOM,e.anchorNode)?t.state.selection.main.anchor:t.docView.posFromDOM(e.anchorNode,e.anchorOffset);this.newSel=EditorSelection.single(o,i);}}}function applyDOMChange(t,e){let i,{newSel:o}=e,s=t.state.selection.main,n=t.inputState.lastKeyTime>Date.now()-100?t.inputState.lastKeyCode:-1;if(e.bounds){let{from:o,to:r}=e.bounds,l=s.from,a=null;(8===n||browser.android&&e.text.length<r-o)&&(l=s.to,a="end");let h=findDiff(t.state.doc.sliceString(o,r,"￿"),e.text,l-o,a);h&&(browser.chrome&&13==n&&h.toB==h.from+2&&"￿￿"==e.text.slice(h.from,h.toB)&&h.toB--,i={from:o+h.from,to:o+h.toA,insert:Text$1.of(e.text.slice(h.from,h.toB).split("￿"))});}else o&&(!t.hasFocus&&t.state.facet(editable)||o.main.eq(s))&&(o=null);if(!i&&!o)return !1;if(!i&&e.typeOver&&!s.empty&&o&&o.main.empty?i={from:s.from,to:s.to,insert:t.state.doc.slice(s.from,s.to)}:i&&i.from>=s.from&&i.to<=s.to&&(i.from!=s.from||i.to!=s.to)&&s.to-s.from-(i.to-i.from)<=4?i={from:s.from,to:s.to,insert:t.state.doc.slice(s.from,i.from).append(i.insert).append(t.state.doc.slice(i.to,s.to))}:(browser.mac||browser.android)&&i&&i.from==i.to&&i.from==s.head-1&&/^\. ?$/.test(i.insert.toString())&&"off"==t.contentDOM.getAttribute("autocorrect")?(o&&2==i.insert.length&&(o=EditorSelection.single(o.main.anchor-1,o.main.head-1)),i={from:s.from,to:s.to,insert:Text$1.of([" "])}):browser.chrome&&i&&i.from==i.to&&i.from==s.head&&"\n "==i.insert.toString()&&t.lineWrapping&&(o&&(o=EditorSelection.single(o.main.anchor-1,o.main.head-1)),i={from:s.from,to:s.to,insert:Text$1.of([" "])}),i){let e=t.state;if(browser.ios&&t.inputState.flushIOSKey(t))return !0;if(browser.android&&(i.from==s.from&&i.to==s.to&&1==i.insert.length&&2==i.insert.lines&&dispatchKey(t.contentDOM,"Enter",13)||(i.from==s.from-1&&i.to==s.to&&0==i.insert.length||8==n&&i.insert.length<i.to-i.from)&&dispatchKey(t.contentDOM,"Backspace",8)||i.from==s.from&&i.to==s.to+1&&0==i.insert.length&&dispatchKey(t.contentDOM,"Delete",46)))return !0;let r,l=i.insert.toString();if(t.state.facet(inputHandler$1).some((e=>e(t,i.from,i.to,l))))return !0;if(t.inputState.composing>=0&&t.inputState.composing++,i.from>=s.from&&i.to<=s.to&&i.to-i.from>=(s.to-s.from)/3&&(!o||o.main.empty&&o.main.from==i.from+i.insert.length)&&t.inputState.composing<0){let o=s.from<i.from?e.sliceDoc(s.from,i.from):"",n=s.to>i.to?e.sliceDoc(i.to,s.to):"";r=e.replaceSelection(t.state.toText(o+i.insert.sliceString(0,void 0,t.state.lineBreak)+n));}else {let n=e.changes(i),l=o&&o.main.to<=n.newLength?o.main:void 0;if(e.selection.ranges.length>1&&t.inputState.composing>=0&&i.to<=s.to&&i.to>=s.to-10){let o=t.state.sliceDoc(i.from,i.to),a=compositionSurroundingNode(t)||t.state.doc.lineAt(s.head),h=s.to-i.to,c=s.to-s.from;r=e.changeByRange((r=>{if(r.from==s.from&&r.to==s.to)return {changes:n,range:l||r.map(n)};let d=r.to-h,u=d-o.length;if(r.to-r.from!=c||t.state.sliceDoc(u,d)!=o||a&&r.to>=a.from&&r.from<=a.to)return {range:r};let p=e.changes({from:u,to:d,insert:i.insert}),f=r.to-s.to;return {changes:p,range:l?EditorSelection.range(Math.max(0,l.anchor+f),Math.max(0,l.head+f)):r.map(p)}}));}else r={changes:n,selection:l&&e.selection.replaceRange(l)};}let a="input.type";return (t.composing||t.inputState.compositionPendingChange&&t.inputState.compositionEndedAt>Date.now()-50)&&(t.inputState.compositionPendingChange=!1,a+=".compose",t.inputState.compositionFirstChange&&(a+=".start",t.inputState.compositionFirstChange=!1)),t.dispatch(r,{scrollIntoView:!0,userEvent:a}),!0}if(o&&!o.main.eq(s)){let e=!1,i="select";return t.inputState.lastSelectionTime>Date.now()-50&&("select"==t.inputState.lastSelectionOrigin&&(e=!0),i=t.inputState.lastSelectionOrigin),t.dispatch({selection:o,scrollIntoView:e,userEvent:i}),!0}return !1}function findDiff(t,e,i,o){let s=Math.min(t.length,e.length),n=0;for(;n<s&&t.charCodeAt(n)==e.charCodeAt(n);)n++;if(n==s&&t.length==e.length)return null;let r=t.length,l=e.length;for(;r>0&&l>0&&t.charCodeAt(r-1)==e.charCodeAt(l-1);)r--,l--;if("end"==o){i-=r+Math.max(0,n-Math.min(r,l))-n;}if(r<n&&t.length<e.length){n-=i<=n&&i>=r?n-i:0,l=n+(l-r),r=n;}else if(l<n){n-=i<=n&&i>=l?n-i:0,r=n+(r-l),l=n;}return {from:n,toA:r,toB:l}}function selectionPoints(t){let e=[];if(t.root.activeElement!=t.contentDOM)return e;let{anchorNode:i,anchorOffset:o,focusNode:s,focusOffset:n}=t.observer.selectionRange;return i&&(e.push(new DOMPoint(i,o)),s==i&&n==o||e.push(new DOMPoint(s,n))),e}function selectionFromPoints(t,e){if(0==t.length)return null;let i=t[0].pos,o=2==t.length?t[1].pos:i;return i>-1&&o>-1?EditorSelection.single(i+e,o+e):null}const observeOptions={childList:!0,characterData:!0,subtree:!0,attributes:!0,characterDataOldValue:!0},useCharData=browser.ie&&browser.ie_version<=11;class DOMObserver{constructor(t){this.view=t,this.active=!1,this.selectionRange=new DOMSelectionState,this.selectionChanged=!1,this.delayedFlush=-1,this.resizeTimeout=-1,this.queue=[],this.delayedAndroidKey=null,this.flushingAndroidKey=-1,this.lastChange=0,this.scrollTargets=[],this.intersection=null,this.resizeScroll=null,this.resizeContent=null,this.intersecting=!1,this.gapIntersection=null,this.gaps=[],this.parentCheck=-1,this.dom=t.contentDOM,this.observer=new MutationObserver((e=>{for(let t of e)this.queue.push(t);(browser.ie&&browser.ie_version<=11||browser.ios&&t.composing)&&e.some((t=>"childList"==t.type&&t.removedNodes.length||"characterData"==t.type&&t.oldValue.length>t.target.nodeValue.length))?this.flushSoon():this.flush();})),useCharData&&(this.onCharData=t=>{this.queue.push({target:t.target,type:"characterData",oldValue:t.prevValue}),this.flushSoon();}),this.onSelectionChange=this.onSelectionChange.bind(this),this.onResize=this.onResize.bind(this),this.onPrint=this.onPrint.bind(this),this.onScroll=this.onScroll.bind(this),"function"==typeof ResizeObserver&&(this.resizeScroll=new ResizeObserver((()=>{var t;(null===(t=this.view.docView)||void 0===t?void 0:t.lastUpdate)<Date.now()-75&&this.onResize();})),this.resizeScroll.observe(t.scrollDOM),this.resizeContent=new ResizeObserver((()=>this.view.requestMeasure())),this.resizeContent.observe(t.contentDOM)),this.addWindowListeners(this.win=t.win),this.start(),"function"==typeof IntersectionObserver&&(this.intersection=new IntersectionObserver((t=>{this.parentCheck<0&&(this.parentCheck=setTimeout(this.listenForScroll.bind(this),1e3)),t.length>0&&t[t.length-1].intersectionRatio>0!=this.intersecting&&(this.intersecting=!this.intersecting,this.intersecting!=this.view.inView&&this.onScrollChanged(document.createEvent("Event")));}),{threshold:[0,.001]}),this.intersection.observe(this.dom),this.gapIntersection=new IntersectionObserver((t=>{t.length>0&&t[t.length-1].intersectionRatio>0&&this.onScrollChanged(document.createEvent("Event"));}),{})),this.listenForScroll(),this.readSelectionRange();}onScrollChanged(t){this.view.inputState.runScrollHandlers(this.view,t),this.intersecting&&this.view.measure();}onScroll(t){this.intersecting&&this.flush(!1),this.onScrollChanged(t);}onResize(){this.resizeTimeout<0&&(this.resizeTimeout=setTimeout((()=>{this.resizeTimeout=-1,this.view.requestMeasure();}),50));}onPrint(){this.view.viewState.printing=!0,this.view.measure(),setTimeout((()=>{this.view.viewState.printing=!1,this.view.requestMeasure();}),500);}updateGaps(t){if(this.gapIntersection&&(t.length!=this.gaps.length||this.gaps.some(((e,i)=>e!=t[i])))){this.gapIntersection.disconnect();for(let e of t)this.gapIntersection.observe(e);this.gaps=t;}}onSelectionChange(t){let e=this.selectionChanged;if(!this.readSelectionRange()||this.delayedAndroidKey)return;let{view:i}=this,o=this.selectionRange;if(i.state.facet(editable)?i.root.activeElement!=this.dom:!hasSelection(i.dom,o))return;let s=o.anchorNode&&i.docView.nearest(o.anchorNode);s&&s.ignoreEvent(t)?e||(this.selectionChanged=!1):(browser.ie&&browser.ie_version<=11||browser.android&&browser.chrome)&&!i.state.selection.main.empty&&o.focusNode&&isEquivalentPosition(o.focusNode,o.focusOffset,o.anchorNode,o.anchorOffset)?this.flushSoon():this.flush(!1);}readSelectionRange(){let{view:t}=this,e=browser.safari&&11==t.root.nodeType&&deepActiveElement(this.dom.ownerDocument)==this.dom&&safariSelectionRangeHack(this.view)||getSelection(t.root);if(!e||this.selectionRange.eq(e))return !1;let i=hasSelection(this.dom,e);return i&&!this.selectionChanged&&t.inputState.lastFocusTime>Date.now()-200&&t.inputState.lastTouchTime<Date.now()-300&&atElementStart(this.dom,e)?(this.view.inputState.lastFocusTime=0,t.docView.updateSelection(),!1):(this.selectionRange.setRange(e),i&&(this.selectionChanged=!0),!0)}setSelectionRange(t,e){this.selectionRange.set(t.node,t.offset,e.node,e.offset),this.selectionChanged=!1;}clearSelectionRange(){this.selectionRange.set(null,0,null,0);}listenForScroll(){this.parentCheck=-1;let t=0,e=null;for(let i=this.dom;i;)if(1==i.nodeType)!e&&t<this.scrollTargets.length&&this.scrollTargets[t]==i?t++:e||(e=this.scrollTargets.slice(0,t)),e&&e.push(i),i=i.assignedSlot||i.parentNode;else {if(11!=i.nodeType)break;i=i.host;}if(t<this.scrollTargets.length&&!e&&(e=this.scrollTargets.slice(0,t)),e){for(let t of this.scrollTargets)t.removeEventListener("scroll",this.onScroll);for(let t of this.scrollTargets=e)t.addEventListener("scroll",this.onScroll);}}ignore(t){if(!this.active)return t();try{return this.stop(),t()}finally{this.start(),this.clear();}}start(){this.active||(this.observer.observe(this.dom,observeOptions),useCharData&&this.dom.addEventListener("DOMCharacterDataModified",this.onCharData),this.active=!0);}stop(){this.active&&(this.active=!1,this.observer.disconnect(),useCharData&&this.dom.removeEventListener("DOMCharacterDataModified",this.onCharData));}clear(){this.processRecords(),this.queue.length=0,this.selectionChanged=!1;}delayAndroidKey(t,e){var i;if(!this.delayedAndroidKey){let t=()=>{let t=this.delayedAndroidKey;if(t){this.clearDelayedAndroidKey(),this.view.inputState.lastKeyCode=t.keyCode,this.view.inputState.lastKeyTime=Date.now(),!this.flush()&&t.force&&dispatchKey(this.dom,t.key,t.keyCode);}};this.flushingAndroidKey=this.view.win.requestAnimationFrame(t);}this.delayedAndroidKey&&"Enter"!=t||(this.delayedAndroidKey={key:t,keyCode:e,force:this.lastChange<Date.now()-50||!!(null===(i=this.delayedAndroidKey)||void 0===i?void 0:i.force)});}clearDelayedAndroidKey(){this.win.cancelAnimationFrame(this.flushingAndroidKey),this.delayedAndroidKey=null,this.flushingAndroidKey=-1;}flushSoon(){this.delayedFlush<0&&(this.delayedFlush=this.view.win.requestAnimationFrame((()=>{this.delayedFlush=-1,this.flush();})));}forceFlush(){this.delayedFlush>=0&&(this.view.win.cancelAnimationFrame(this.delayedFlush),this.delayedFlush=-1),this.flush();}pendingRecords(){for(let t of this.observer.takeRecords())this.queue.push(t);return this.queue}processRecords(){let t=this.pendingRecords();t.length&&(this.queue=[]);let e=-1,i=-1,o=!1;for(let s of t){let t=this.readMutation(s);t&&(t.typeOver&&(o=!0),-1==e?({from:e,to:i}=t):(e=Math.min(t.from,e),i=Math.max(t.to,i)));}return {from:e,to:i,typeOver:o}}readChange(){let{from:t,to:e,typeOver:i}=this.processRecords(),o=this.selectionChanged&&hasSelection(this.dom,this.selectionRange);return t<0&&!o?null:(t>-1&&(this.lastChange=Date.now()),this.view.inputState.lastFocusTime=0,this.selectionChanged=!1,new DOMChange(this.view,t,e,i))}flush(t=!0){if(this.delayedFlush>=0||this.delayedAndroidKey)return !1;t&&this.readSelectionRange();let e=this.readChange();if(!e)return !1;let i=this.view.state,o=applyDOMChange(this.view,e);return this.view.state==i&&this.view.update([]),o}readMutation(t){let e=this.view.docView.nearest(t.target);if(!e||e.ignoreMutation(t))return null;if(e.markDirty("attributes"==t.type),"attributes"==t.type&&(e.dirty|=4),"childList"==t.type){let i=findChild(e,t.previousSibling||t.target.previousSibling,-1),o=findChild(e,t.nextSibling||t.target.nextSibling,1);return {from:i?e.posAfter(i):e.posAtStart,to:o?e.posBefore(o):e.posAtEnd,typeOver:!1}}return "characterData"==t.type?{from:e.posAtStart,to:e.posAtEnd,typeOver:t.target.nodeValue==t.oldValue}:null}setWindow(t){t!=this.win&&(this.removeWindowListeners(this.win),this.win=t,this.addWindowListeners(this.win));}addWindowListeners(t){t.addEventListener("resize",this.onResize),t.addEventListener("beforeprint",this.onPrint),t.addEventListener("scroll",this.onScroll),t.document.addEventListener("selectionchange",this.onSelectionChange);}removeWindowListeners(t){t.removeEventListener("scroll",this.onScroll),t.removeEventListener("resize",this.onResize),t.removeEventListener("beforeprint",this.onPrint),t.document.removeEventListener("selectionchange",this.onSelectionChange);}destroy(){var t,e,i,o;this.stop(),null===(t=this.intersection)||void 0===t||t.disconnect(),null===(e=this.gapIntersection)||void 0===e||e.disconnect(),null===(i=this.resizeScroll)||void 0===i||i.disconnect(),null===(o=this.resizeContent)||void 0===o||o.disconnect();for(let t of this.scrollTargets)t.removeEventListener("scroll",this.onScroll);this.removeWindowListeners(this.win),clearTimeout(this.parentCheck),clearTimeout(this.resizeTimeout),this.win.cancelAnimationFrame(this.delayedFlush),this.win.cancelAnimationFrame(this.flushingAndroidKey);}}function findChild(t,e,i){for(;e;){let o=ContentView.get(e);if(o&&o.parent==t)return o;let s=e.parentNode;e=s!=t.dom?s:i>0?e.nextSibling:e.previousSibling;}return null}function safariSelectionRangeHack(t){let e=null;function i(t){t.preventDefault(),t.stopImmediatePropagation(),e=t.getTargetRanges()[0];}if(t.contentDOM.addEventListener("beforeinput",i,!0),t.dom.ownerDocument.execCommand("indent"),t.contentDOM.removeEventListener("beforeinput",i,!0),!e)return null;let o=e.startContainer,s=e.startOffset,n=e.endContainer,r=e.endOffset,l=t.docView.domAtPos(t.state.selection.main.anchor);return isEquivalentPosition(l.node,l.offset,n,r)&&([o,s,n,r]=[n,r,o,s]),{anchorNode:o,anchorOffset:s,focusNode:n,focusOffset:r}}class EditorView{constructor(t={}){this.plugins=[],this.pluginMap=new Map,this.editorAttrs={},this.contentAttrs={},this.bidiCache=[],this.destroyed=!1,this.updateState=2,this.measureScheduled=-1,this.measureRequests=[],this.contentDOM=document.createElement("div"),this.scrollDOM=document.createElement("div"),this.scrollDOM.tabIndex=-1,this.scrollDOM.className="cm-scroller",this.scrollDOM.appendChild(this.contentDOM),this.announceDOM=document.createElement("div"),this.announceDOM.style.cssText="position: fixed; top: -10000px",this.announceDOM.setAttribute("aria-live","polite"),this.dom=document.createElement("div"),this.dom.appendChild(this.announceDOM),this.dom.appendChild(this.scrollDOM),this._dispatch=t.dispatch||(t=>this.update([t])),this.dispatch=this.dispatch.bind(this),this._root=t.root||getRoot(t.parent)||document,this.viewState=new ViewState(t.state||EditorState.create(t)),this.plugins=this.state.facet(viewPlugin).map((t=>new PluginInstance(t)));for(let t of this.plugins)t.update(this);this.observer=new DOMObserver(this),this.inputState=new InputState(this),this.inputState.ensureHandlers(this,this.plugins),this.docView=new DocView(this),this.mountStyles(),this.updateAttrs(),this.updateState=0,this.requestMeasure(),t.parent&&t.parent.appendChild(this.dom);}get state(){return this.viewState.state}get viewport(){return this.viewState.viewport}get visibleRanges(){return this.viewState.visibleRanges}get inView(){return this.viewState.inView}get composing(){return this.inputState.composing>0}get compositionStarted(){return this.inputState.composing>=0}get root(){return this._root}get win(){return this.dom.ownerDocument.defaultView||window}dispatch(...t){let e=1==t.length&&t[0]instanceof Transaction?t[0]:this.state.update(...t);this._dispatch(e,this);}update(t){if(0!=this.updateState)throw new Error("Calls to EditorView.update are not allowed while an update is in progress");let e,i=!1,o=!1,s=this.state;for(let e of t){if(e.startState!=s)throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");s=e.state;}if(this.destroyed)return void(this.viewState.state=s);let n=this.hasFocus,r=0,l=null;t.some((t=>t.annotation(isFocusChange)))?(this.inputState.notifiedFocused=n,r=1):n!=this.inputState.notifiedFocused&&(this.inputState.notifiedFocused=n,l=focusChangeTransaction(s,n),l||(r=1));let a=this.observer.delayedAndroidKey,h=null;if(a?(this.observer.clearDelayedAndroidKey(),h=this.observer.readChange(),(h&&!this.state.doc.eq(s.doc)||!this.state.selection.eq(s.selection))&&(h=null)):this.observer.clear(),s.facet(EditorState.phrases)!=this.state.facet(EditorState.phrases))return this.setState(s);e=ViewUpdate.create(this,s,t),e.flags|=r;let c=this.viewState.scrollTarget;try{this.updateState=2;for(let e of t){if(c&&(c=c.map(e.changes)),e.scrollIntoView){let{main:t}=e.state.selection;c=new ScrollTarget(t.empty?t:EditorSelection.cursor(t.head,t.head>t.anchor?-1:1));}for(let t of e.effects)t.is(scrollIntoView$1)&&(c=t.value);}this.viewState.update(e,c),this.bidiCache=CachedOrder.update(this.bidiCache,e.changes),e.empty||(this.updatePlugins(e),this.inputState.update(e)),i=this.docView.update(e),this.state.facet(styleModule)!=this.styleModules&&this.mountStyles(),o=this.updateAttrs(),this.showAnnouncements(t),this.docView.updateSelection(i,t.some((t=>t.isUserEvent("select.pointer"))));}finally{this.updateState=0;}if(e.startState.facet(theme)!=e.state.facet(theme)&&(this.viewState.mustMeasureContent=!0),(i||o||c||this.viewState.mustEnforceCursorAssoc||this.viewState.mustMeasureContent)&&this.requestMeasure(),!e.empty)for(let t of this.state.facet(updateListener))t(e);(l||h)&&Promise.resolve().then((()=>{l&&this.state==l.startState&&this.dispatch(l),h&&!applyDOMChange(this,h)&&a.force&&dispatchKey(this.contentDOM,a.key,a.keyCode);}));}setState(t){if(0!=this.updateState)throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");if(this.destroyed)return void(this.viewState.state=t);this.updateState=2;let e=this.hasFocus;try{for(let t of this.plugins)t.destroy(this);this.viewState=new ViewState(t),this.plugins=t.facet(viewPlugin).map((t=>new PluginInstance(t))),this.pluginMap.clear();for(let t of this.plugins)t.update(this);this.docView=new DocView(this),this.inputState.ensureHandlers(this,this.plugins),this.mountStyles(),this.updateAttrs(),this.bidiCache=[];}finally{this.updateState=0;}e&&this.focus(),this.requestMeasure();}updatePlugins(t){let e=t.startState.facet(viewPlugin),i=t.state.facet(viewPlugin);if(e!=i){let o=[];for(let s of i){let i=e.indexOf(s);if(i<0)o.push(new PluginInstance(s));else {let e=this.plugins[i];e.mustUpdate=t,o.push(e);}}for(let e of this.plugins)e.mustUpdate!=t&&e.destroy(this);this.plugins=o,this.pluginMap.clear(),this.inputState.ensureHandlers(this,this.plugins);}else for(let e of this.plugins)e.mustUpdate=t;for(let t=0;t<this.plugins.length;t++)this.plugins[t].update(this);}measure(t=!0){if(this.destroyed)return;this.measureScheduled>-1&&this.win.cancelAnimationFrame(this.measureScheduled),this.measureScheduled=0,t&&this.observer.forceFlush();let e=null,i=this.scrollDOM,{scrollTop:o}=i,{scrollAnchorPos:s,scrollAnchorHeight:n}=this.viewState;if(this.viewState.scrollAnchorHeight=-1,n<0||o!=this.viewState.scrollTop)if(o>i.scrollHeight-i.clientHeight-4)s=-1,n=this.viewState.heightMap.height;else {let t=this.viewState.lineBlockAtHeight(o);s=t.from,n=t.top;}try{for(let t=0;;t++){this.updateState=1;let r=this.viewport,l=this.viewState.measure(this);if(!l&&!this.measureRequests.length&&null==this.viewState.scrollTarget)break;if(t>5){console.warn(this.measureRequests.length?"Measure loop restarted more than 5 times":"Viewport failed to stabilize");break}let a=[];4&l||([this.measureRequests,a]=[a,this.measureRequests]);let h=a.map((t=>{try{return t.read(this)}catch(t){return logException(this.state,t),BadMeasure}})),c=ViewUpdate.create(this,this.state,[]),d=!1,u=!1;c.flags|=l,e?e.flags|=l:e=c,this.updateState=2,c.empty||(this.updatePlugins(c),this.inputState.update(c),this.updateAttrs(),d=this.docView.update(c));for(let t=0;t<a.length;t++)if(h[t]!=BadMeasure)try{let e=a[t];e.write&&e.write(h[t],this);}catch(t){logException(this.state,t);}if(this.viewState.editorHeight)if(this.viewState.scrollTarget)this.docView.scrollIntoView(this.viewState.scrollTarget),this.viewState.scrollTarget=null,u=!0;else if(n>-1){let t=(s<0?this.viewState.heightMap.height:this.viewState.lineBlockAt(s).top)-n;(t>1||t<-1)&&(i.scrollTop=o+t,u=!0);}if(d&&this.docView.updateSelection(!0),this.viewport.from==r.from&&this.viewport.to==r.to&&!u&&0==this.measureRequests.length)break;n=-1;}}finally{this.updateState=0,this.measureScheduled=-1;}if(e&&!e.empty)for(let t of this.state.facet(updateListener))t(e);}get themeClasses(){return baseThemeID+" "+(this.state.facet(darkTheme)?baseDarkID:baseLightID)+" "+this.state.facet(theme)}updateAttrs(){let t=attrsFromFacet(this,editorAttributes,{class:"cm-editor"+(this.hasFocus?" cm-focused ":" ")+this.themeClasses}),e={spellcheck:"false",autocorrect:"off",autocapitalize:"off",translate:"no",contenteditable:this.state.facet(editable)?"true":"false",class:"cm-content",style:`${browser.tabSize}: ${this.state.tabSize}`,role:"textbox","aria-multiline":"true"};this.state.readOnly&&(e["aria-readonly"]="true"),attrsFromFacet(this,contentAttributes,e);let i=this.observer.ignore((()=>{let i=updateAttrs(this.contentDOM,this.contentAttrs,e),o=updateAttrs(this.dom,this.editorAttrs,t);return i||o}));return this.editorAttrs=t,this.contentAttrs=e,i}showAnnouncements(t){let e=!0;for(let i of t)for(let t of i.effects)if(t.is(EditorView.announce)){e&&(this.announceDOM.textContent=""),e=!1,this.announceDOM.appendChild(document.createElement("div")).textContent=t.value;}}mountStyles(){this.styleModules=this.state.facet(styleModule),StyleModule.mount(this.root,this.styleModules.concat(baseTheme$1$2).reverse());}readMeasured(){if(2==this.updateState)throw new Error("Reading the editor layout isn't allowed during an update");0==this.updateState&&this.measureScheduled>-1&&this.measure(!1);}requestMeasure(t){if(this.measureScheduled<0&&(this.measureScheduled=this.win.requestAnimationFrame((()=>this.measure()))),t){if(this.measureRequests.indexOf(t)>-1)return;if(null!=t.key)for(let e=0;e<this.measureRequests.length;e++)if(this.measureRequests[e].key===t.key)return void(this.measureRequests[e]=t);this.measureRequests.push(t);}}plugin(t){let e=this.pluginMap.get(t);return (void 0===e||e&&e.spec!=t)&&this.pluginMap.set(t,e=this.plugins.find((e=>e.spec==t))||null),e&&e.update(this).value}get documentTop(){return this.contentDOM.getBoundingClientRect().top+this.viewState.paddingTop}get documentPadding(){return {top:this.viewState.paddingTop,bottom:this.viewState.paddingBottom}}elementAtHeight(t){return this.readMeasured(),this.viewState.elementAtHeight(t)}lineBlockAtHeight(t){return this.readMeasured(),this.viewState.lineBlockAtHeight(t)}get viewportLineBlocks(){return this.viewState.viewportLines}lineBlockAt(t){return this.viewState.lineBlockAt(t)}get contentHeight(){return this.viewState.contentHeight}moveByChar(t,e,i){return skipAtoms(this,t,moveByChar(this,t,e,i))}moveByGroup(t,e){return skipAtoms(this,t,moveByChar(this,t,e,(e=>byGroup(this,t.head,e))))}moveToLineBoundary(t,e,i=!0){return moveToLineBoundary(this,t,e,i)}moveVertically(t,e,i){return skipAtoms(this,t,moveVertically(this,t,e,i))}domAtPos(t){return this.docView.domAtPos(t)}posAtDOM(t,e=0){return this.docView.posFromDOM(t,e)}posAtCoords(t,e=!0){return this.readMeasured(),posAtCoords(this,t,e)}coordsAtPos(t,e=1){this.readMeasured();let i=this.docView.coordsAt(t,e);if(!i||i.left==i.right)return i;let o=this.state.doc.lineAt(t),s=this.bidiSpans(o);return flattenRect(i,s[BidiSpan.find(s,t-o.from,-1,e)].dir==Direction.LTR==e>0)}get defaultCharacterWidth(){return this.viewState.heightOracle.charWidth}get defaultLineHeight(){return this.viewState.heightOracle.lineHeight}get textDirection(){return this.viewState.defaultTextDirection}textDirectionAt(t){return !this.state.facet(perLineTextDirection)||t<this.viewport.from||t>this.viewport.to?this.textDirection:(this.readMeasured(),this.docView.textDirectionAt(t))}get lineWrapping(){return this.viewState.heightOracle.lineWrapping}bidiSpans(t){if(t.length>MaxBidiLine)return trivialOrder(t.length);let e=this.textDirectionAt(t.from);for(let i of this.bidiCache)if(i.from==t.from&&i.dir==e)return i.order;let i=computeOrder(t.text,e);return this.bidiCache.push(new CachedOrder(t.from,t.to,e,i)),i}get hasFocus(){var t;return (this.dom.ownerDocument.hasFocus()||browser.safari&&(null===(t=this.inputState)||void 0===t?void 0:t.lastContextMenu)>Date.now()-3e4)&&this.root.activeElement==this.contentDOM}focus(){this.observer.ignore((()=>{focusPreventScroll(this.contentDOM),this.docView.updateSelection();}));}setRoot(t){this._root!=t&&(this._root=t,this.observer.setWindow((9==t.nodeType?t:t.ownerDocument).defaultView||window),this.mountStyles());}destroy(){for(let t of this.plugins)t.destroy(this);this.plugins=[],this.inputState.destroy(),this.dom.remove(),this.observer.destroy(),this.measureScheduled>-1&&this.win.cancelAnimationFrame(this.measureScheduled),this.destroyed=!0;}static scrollIntoView(t,e={}){return scrollIntoView$1.of(new ScrollTarget("number"==typeof t?EditorSelection.cursor(t):t,e.y,e.x,e.yMargin,e.xMargin))}static domEventHandlers(t){return ViewPlugin.define((()=>({})),{eventHandlers:t})}static theme(t,e){let i=StyleModule.newName(),o=[theme.of(i),styleModule.of(buildTheme(`.${i}`,t))];return e&&e.dark&&o.push(darkTheme.of(!0)),o}static baseTheme(t){return Prec.lowest(styleModule.of(buildTheme("."+baseThemeID,t,lightDarkIDs)))}static findFromDOM(t){var e;let i=t.querySelector(".cm-content"),o=i&&ContentView.get(i)||ContentView.get(t);return (null===(e=null==o?void 0:o.rootView)||void 0===e?void 0:e.view)||null}}EditorView.styleModule=styleModule,EditorView.inputHandler=inputHandler$1,EditorView.focusChangeEffect=focusChangeEffect,EditorView.perLineTextDirection=perLineTextDirection,EditorView.exceptionSink=exceptionSink,EditorView.updateListener=updateListener,EditorView.editable=editable,EditorView.mouseSelectionStyle=mouseSelectionStyle,EditorView.dragMovesSelection=dragMovesSelection$1,EditorView.clickAddsSelectionRange=clickAddsSelectionRange,EditorView.decorations=decorations,EditorView.atomicRanges=atomicRanges,EditorView.scrollMargins=scrollMargins,EditorView.darkTheme=darkTheme,EditorView.contentAttributes=contentAttributes,EditorView.editorAttributes=editorAttributes,EditorView.lineWrapping=EditorView.contentAttributes.of({class:"cm-lineWrapping"}),EditorView.announce=StateEffect.define();const MaxBidiLine=4096,BadMeasure={};class CachedOrder{constructor(t,e,i,o){this.from=t,this.to=e,this.dir=i,this.order=o;}static update(t,e){if(e.empty)return t;let i=[],o=t.length?t[t.length-1].dir:Direction.LTR;for(let s=Math.max(0,t.length-10);s<t.length;s++){let n=t[s];n.dir!=o||e.touchesRange(n.from,n.to)||i.push(new CachedOrder(e.mapPos(n.from,1),e.mapPos(n.to,-1),n.dir,n.order));}return i}}function attrsFromFacet(t,e,i){for(let o=t.state.facet(e),s=o.length-1;s>=0;s--){let e=o[s],n="function"==typeof e?e(t):e;n&&combineAttrs(n,i);}return i}const currentPlatform=browser.mac?"mac":browser.windows?"win":browser.linux?"linux":"key";function normalizeKeyName(t,e){const i=t.split(/-(?!$)/);let o,s,n,r,l=i[i.length-1];"Space"==l&&(l=" ");for(let t=0;t<i.length-1;++t){const l=i[t];if(/^(cmd|meta|m)$/i.test(l))r=!0;else if(/^a(lt)?$/i.test(l))o=!0;else if(/^(c|ctrl|control)$/i.test(l))s=!0;else if(/^s(hift)?$/i.test(l))n=!0;else {if(!/^mod$/i.test(l))throw new Error("Unrecognized modifier name: "+l);"mac"==e?r=!0:s=!0;}}return o&&(l="Alt-"+l),s&&(l="Ctrl-"+l),r&&(l="Meta-"+l),n&&(l="Shift-"+l),l}function modifiers(t,e,i){return e.altKey&&(t="Alt-"+t),e.ctrlKey&&(t="Ctrl-"+t),e.metaKey&&(t="Meta-"+t),!1!==i&&e.shiftKey&&(t="Shift-"+t),t}const handleKeyEvents=Prec.default(EditorView.domEventHandlers({keydown:(t,e)=>runHandlers(getKeymap(e.state),t,e,"editor")})),keymap=Facet.define({enables:handleKeyEvents}),Keymaps=new WeakMap;function getKeymap(t){let e=t.facet(keymap),i=Keymaps.get(e);return i||Keymaps.set(e,i=buildKeymap(e.reduce(((t,e)=>t.concat(e)),[]))),i}function runScopeHandlers(t,e,i){return runHandlers(getKeymap(t.state),e,t,i)}let storedPrefix=null;const PrefixTimeout=4e3;function buildKeymap(t,e=currentPlatform){let i=Object.create(null),o=Object.create(null),s=(t,e)=>{let i=o[t];if(null==i)o[t]=e;else if(i!=e)throw new Error("Key binding "+t+" is used both as a regular binding and as a multi-stroke prefix")},n=(t,o,n,r)=>{var l,a;let h=i[t]||(i[t]=Object.create(null)),c=o.split(/ (?!$)/).map((t=>normalizeKeyName(t,e)));for(let e=1;e<c.length;e++){let i=c.slice(0,e).join(" ");s(i,!0),h[i]||(h[i]={preventDefault:!0,run:[e=>{let o=storedPrefix={view:e,prefix:i,scope:t};return setTimeout((()=>{storedPrefix==o&&(storedPrefix=null);}),PrefixTimeout),!0}]});}let d=c.join(" ");s(d,!1);let u=h[d]||(h[d]={preventDefault:!1,run:(null===(a=null===(l=h._any)||void 0===l?void 0:l.run)||void 0===a?void 0:a.slice())||[]});n&&u.run.push(n),r&&(u.preventDefault=!0);};for(let o of t){let t=o.scope?o.scope.split(" "):["editor"];if(o.any)for(let e of t){let t=i[e]||(i[e]=Object.create(null));t._any||(t._any={preventDefault:!1,run:[]});for(let e in t)t[e].run.push(o.any);}let s=o[e]||o.key;if(s)for(let e of t)n(e,s,o.run,o.preventDefault),o.shift&&n(e,"Shift-"+s,o.shift,o.preventDefault);}return i}function runHandlers(t,e,i,o){let s=keyName(e),n=codePointAt(s,0),r=codePointSize(n)==s.length&&" "!=s,l="",a=!1;storedPrefix&&storedPrefix.view==i&&storedPrefix.scope==o&&(l=storedPrefix.prefix+" ",(a=modifierCodes.indexOf(e.keyCode)<0)&&(storedPrefix=null));let h,c,d=new Set,u=t=>{if(t){for(let o of t.run)if(!d.has(o)&&(d.add(o),o(i,e)))return !0;t.preventDefault&&(a=!0);}return !1},p=t[o];if(p){if(u(p[l+modifiers(s,e,!r)]))return !0;if(r&&(e.altKey||e.metaKey||e.ctrlKey)&&!(browser.windows&&e.ctrlKey&&e.altKey)&&(h=base[e.keyCode])&&h!=s){if(u(p[l+modifiers(h,e,!0)]))return !0;if(e.shiftKey&&(c=shift[e.keyCode])!=s&&c!=h&&u(p[l+modifiers(c,e,!1)]))return !0}else if(r&&e.shiftKey&&u(p[l+modifiers(s,e,!0)]))return !0;if(u(p._any))return !0}return a}class RectangleMarker{constructor(t,e,i,o,s){this.className=t,this.left=e,this.top=i,this.width=o,this.height=s;}draw(){let t=document.createElement("div");return t.className=this.className,this.adjust(t),t}update(t,e){return e.className==this.className&&(this.adjust(t),!0)}adjust(t){t.style.left=this.left+"px",t.style.top=this.top+"px",null!=this.width&&(t.style.width=this.width+"px"),t.style.height=this.height+"px";}eq(t){return this.left==t.left&&this.top==t.top&&this.width==t.width&&this.height==t.height&&this.className==t.className}static forRange(t,e,i){if(i.empty){let o=t.coordsAtPos(i.head,i.assoc||1);if(!o)return [];let s=getBase(t);return [new RectangleMarker(e,o.left-s.left,o.top-s.top,null,o.bottom-o.top)]}return rectanglesForRange(t,e,i)}}function getBase(t){let e=t.scrollDOM.getBoundingClientRect();return {left:(t.textDirection==Direction.LTR?e.left:e.right-t.scrollDOM.clientWidth)-t.scrollDOM.scrollLeft,top:e.top-t.scrollDOM.scrollTop}}function wrappedLine(t,e,i){let o=EditorSelection.cursor(e);return {from:Math.max(i.from,t.moveToLineBoundary(o,!1,!0).from),to:Math.min(i.to,t.moveToLineBoundary(o,!0,!0).from),type:BlockType.Text}}function rectanglesForRange(t,e,i){if(i.to<=t.viewport.from||i.from>=t.viewport.to)return [];let o=Math.max(i.from,t.viewport.from),s=Math.min(i.to,t.viewport.to),n=t.textDirection==Direction.LTR,r=t.contentDOM,l=r.getBoundingClientRect(),a=getBase(t),h=r.querySelector(".cm-line"),c=h&&window.getComputedStyle(h),d=l.left+(c?parseInt(c.paddingLeft)+Math.min(0,parseInt(c.textIndent)):0),u=l.right-(c?parseInt(c.paddingRight):0),p=blockAt(t,o),f=blockAt(t,s),g=p.type==BlockType.Text?p:null,m=f.type==BlockType.Text?f:null;if(g&&(t.lineWrapping||p.widgetLineBreaks)&&(g=wrappedLine(t,o,g)),m&&(t.lineWrapping||f.widgetLineBreaks)&&(m=wrappedLine(t,s,m)),g&&m&&g.from==m.from)return v(y(i.from,i.to,g));{let e=g?y(i.from,null,g):b(p,!1),o=m?y(null,i.to,m):b(f,!0),s=[];return (g||p).to<(m||f).from-(g&&m?1:0)||p.widgetLineBreaks>1&&e.bottom+t.defaultLineHeight/2<o.top?s.push(w(d,e.bottom,u,o.top)):e.bottom<o.top&&t.elementAtHeight((e.bottom+o.top)/2).type==BlockType.Text&&(e.bottom=o.top=(e.bottom+o.top)/2),v(e).concat(s).concat(v(o))}function w(t,i,o,s){return new RectangleMarker(e,t-a.left,i-a.top-.01,o-t,s-i+.01)}function v({top:t,bottom:e,horizontal:i}){let o=[];for(let s=0;s<i.length;s+=2)o.push(w(i[s],t,i[s+1],e));return o}function y(e,i,o){let s=1e9,r=-1e9,l=[];function a(e,i,a,h,c){let p=t.coordsAtPos(e,e==o.to?-2:2),f=t.coordsAtPos(a,a==o.from?2:-2);p&&f&&(s=Math.min(p.top,f.top,s),r=Math.max(p.bottom,f.bottom,r),c==Direction.LTR?l.push(n&&i?d:p.left,n&&h?u:f.right):l.push(!n&&h?d:f.left,!n&&i?u:p.right));}let h=null!=e?e:o.from,c=null!=i?i:o.to;for(let o of t.visibleRanges)if(o.to>h&&o.from<c)for(let s=Math.max(o.from,h),n=Math.min(o.to,c);;){let o=t.state.doc.lineAt(s);for(let r of t.bidiSpans(o)){let t=r.from+o.from,l=r.to+o.from;if(t>=n)break;l>s&&a(Math.max(t,s),null==e&&t<=h,Math.min(l,n),null==i&&l>=c,r.dir);}if(s=o.to+1,s>=n)break}return 0==l.length&&a(h,null==e,c,null==i,t.textDirection),{top:s,bottom:r,horizontal:l}}function b(t,e){let i=l.top+(e?t.top:t.bottom);return {top:i,bottom:i,horizontal:[]}}}function sameMarker(t,e){return t.constructor==e.constructor&&t.eq(e)}class LayerView{constructor(t,e){this.view=t,this.layer=e,this.drawn=[],this.measureReq={read:this.measure.bind(this),write:this.draw.bind(this)},this.dom=t.scrollDOM.appendChild(document.createElement("div")),this.dom.classList.add("cm-layer"),e.above&&this.dom.classList.add("cm-layer-above"),e.class&&this.dom.classList.add(e.class),this.dom.setAttribute("aria-hidden","true"),this.setOrder(t.state),t.requestMeasure(this.measureReq),e.mount&&e.mount(this.dom,t);}update(t){t.startState.facet(layerOrder)!=t.state.facet(layerOrder)&&this.setOrder(t.state),(this.layer.update(t,this.dom)||t.geometryChanged)&&t.view.requestMeasure(this.measureReq);}setOrder(t){let e=0,i=t.facet(layerOrder);for(;e<i.length&&i[e]!=this.layer;)e++;this.dom.style.zIndex=String((this.layer.above?150:-1)-e);}measure(){return this.layer.markers(this.view)}draw(t){if(t.length!=this.drawn.length||t.some(((t,e)=>!sameMarker(t,this.drawn[e])))){let e=this.dom.firstChild,i=0;for(let o of t)o.update&&e&&o.constructor&&this.drawn[i].constructor&&o.update(e,this.drawn[i])?(e=e.nextSibling,i++):this.dom.insertBefore(o.draw(),e);for(;e;){let t=e.nextSibling;e.remove(),e=t;}this.drawn=t;}}destroy(){this.layer.destroy&&this.layer.destroy(this.dom,this.view),this.dom.remove();}}const layerOrder=Facet.define();function layer(t){return [ViewPlugin.define((e=>new LayerView(e,t))),layerOrder.of(t)]}const CanHidePrimary=!browser.ios,selectionConfig=Facet.define({combine:t=>combineConfig(t,{cursorBlinkRate:1200,drawRangeCursor:!0},{cursorBlinkRate:(t,e)=>Math.min(t,e),drawRangeCursor:(t,e)=>t||e})});function drawSelection(t={}){return [selectionConfig.of(t),cursorLayer,selectionLayer,hideNativeSelection,nativeSelectionHidden.of(!0)]}function configChanged(t){return t.startState.facet(selectionConfig)!=t.state.facet(selectionConfig)}const cursorLayer=layer({above:!0,markers(t){let{state:e}=t,i=e.facet(selectionConfig),o=[];for(let s of e.selection.ranges){let n=s==e.selection.main;if(s.empty?!n||CanHidePrimary:i.drawRangeCursor){let e=n?"cm-cursor cm-cursor-primary":"cm-cursor cm-cursor-secondary",i=s.empty?s:EditorSelection.cursor(s.head,s.head>s.anchor?-1:1);for(let s of RectangleMarker.forRange(t,e,i))o.push(s);}}return o},update(t,e){t.transactions.some((t=>t.selection))&&(e.style.animationName="cm-blink"==e.style.animationName?"cm-blink2":"cm-blink");let i=configChanged(t);return i&&setBlinkRate(t.state,e),t.docChanged||t.selectionSet||i},mount(t,e){setBlinkRate(e.state,t);},class:"cm-cursorLayer"});function setBlinkRate(t,e){e.style.animationDuration=t.facet(selectionConfig).cursorBlinkRate+"ms";}const selectionLayer=layer({above:!1,markers:t=>t.state.selection.ranges.map((e=>e.empty?[]:RectangleMarker.forRange(t,"cm-selectionBackground",e))).reduce(((t,e)=>t.concat(e))),update:(t,e)=>t.docChanged||t.selectionSet||t.viewportChanged||configChanged(t),class:"cm-selectionLayer"}),themeSpec={".cm-line":{"& ::selection":{backgroundColor:"transparent !important"},"&::selection":{backgroundColor:"transparent !important"}}};CanHidePrimary&&(themeSpec[".cm-line"].caretColor="transparent !important");const hideNativeSelection=Prec.highest(EditorView.theme(themeSpec)),setDropCursorPos=StateEffect.define({map:(t,e)=>null==t?null:e.mapPos(t)}),dropCursorPos=StateField.define({create:()=>null,update:(t,e)=>(null!=t&&(t=e.changes.mapPos(t)),e.effects.reduce(((t,e)=>e.is(setDropCursorPos)?e.value:t),t))}),drawDropCursor=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.cursor=null,this.measureReq={read:this.readPos.bind(this),write:this.drawCursor.bind(this)};}update(t){var e;let i=t.state.field(dropCursorPos);null==i?null!=this.cursor&&(null===(e=this.cursor)||void 0===e||e.remove(),this.cursor=null):(this.cursor||(this.cursor=this.view.scrollDOM.appendChild(document.createElement("div")),this.cursor.className="cm-dropCursor"),(t.startState.field(dropCursorPos)!=i||t.docChanged||t.geometryChanged)&&this.view.requestMeasure(this.measureReq));}readPos(){let t=this.view.state.field(dropCursorPos),e=null!=t&&this.view.coordsAtPos(t);if(!e)return null;let i=this.view.scrollDOM.getBoundingClientRect();return {left:e.left-i.left+this.view.scrollDOM.scrollLeft,top:e.top-i.top+this.view.scrollDOM.scrollTop,height:e.bottom-e.top}}drawCursor(t){this.cursor&&(t?(this.cursor.style.left=t.left+"px",this.cursor.style.top=t.top+"px",this.cursor.style.height=t.height+"px"):this.cursor.style.left="-100000px");}destroy(){this.cursor&&this.cursor.remove();}setDropPos(t){this.view.state.field(dropCursorPos)!=t&&this.view.dispatch({effects:setDropCursorPos.of(t)});}},{eventHandlers:{dragover(t){this.setDropPos(this.view.posAtCoords({x:t.clientX,y:t.clientY}));},dragleave(t){t.target!=this.view.contentDOM&&this.view.contentDOM.contains(t.relatedTarget)||this.setDropPos(null);},dragend(){this.setDropPos(null);},drop(){this.setDropPos(null);}}});function dropCursor(){return [dropCursorPos,drawDropCursor]}function iterMatches(t,e,i,o,s){e.lastIndex=0;for(let n,r=t.iterRange(i,o),l=i;!r.next().done;l+=r.value.length)if(!r.lineBreak)for(;n=e.exec(r.value);)s(l+n.index,n);}function matchRanges(t,e){let i=t.visibleRanges;if(1==i.length&&i[0].from==t.viewport.from&&i[0].to==t.viewport.to)return i;let o=[];for(let{from:s,to:n}of i)s=Math.max(t.state.doc.lineAt(s).from,s-e),n=Math.min(t.state.doc.lineAt(n).to,n+e),o.length&&o[o.length-1].to>=s?o[o.length-1].to=n:o.push({from:s,to:n});return o}class MatchDecorator{constructor(t){const{regexp:e,decoration:i,decorate:o,boundary:s,maxLength:n=1e3}=t;if(!e.global)throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");if(this.regexp=e,o)this.addMatch=(t,e,i,s)=>o(s,i,i+t[0].length,t,e);else if("function"==typeof i)this.addMatch=(t,e,o,s)=>{let n=i(t,e,o);n&&s(o,o+t[0].length,n);};else {if(!i)throw new RangeError("Either 'decorate' or 'decoration' should be provided to MatchDecorator");this.addMatch=(t,e,o,s)=>s(o,o+t[0].length,i);}this.boundary=s,this.maxLength=n;}createDeco(t){let e=new RangeSetBuilder,i=e.add.bind(e);for(let{from:e,to:o}of matchRanges(t,this.maxLength))iterMatches(t.state.doc,this.regexp,e,o,((e,o)=>this.addMatch(o,t,e,i)));return e.finish()}updateDeco(t,e){let i=1e9,o=-1;return t.docChanged&&t.changes.iterChanges(((e,s,n,r)=>{r>t.view.viewport.from&&n<t.view.viewport.to&&(i=Math.min(n,i),o=Math.max(r,o));})),t.viewportChanged||o-i>1e3?this.createDeco(t.view):o>-1?this.updateRange(t.view,e.map(t.changes),i,o):e}updateRange(t,e,i,o){for(let s of t.visibleRanges){let n=Math.max(s.from,i),r=Math.min(s.to,o);if(r>n){let i=t.state.doc.lineAt(n),o=i.to<r?t.state.doc.lineAt(r):i,l=Math.max(s.from,i.from),a=Math.min(s.to,o.to);if(this.boundary){for(;n>i.from;n--)if(this.boundary.test(i.text[n-1-i.from])){l=n;break}for(;r<o.to;r++)if(this.boundary.test(o.text[r-o.from])){a=r;break}}let h,c=[],d=(t,e,i)=>c.push(i.range(t,e));if(i==o)for(this.regexp.lastIndex=l-i.from;(h=this.regexp.exec(i.text))&&h.index<a-i.from;)this.addMatch(h,t,h.index+i.from,d);else iterMatches(t.state.doc,this.regexp,l,a,((e,i)=>this.addMatch(i,t,e,d)));e=e.update({filterFrom:l,filterTo:a,filter:(t,e)=>t<l||e>a,add:c});}}return e}}const UnicodeRegexpSupport=null!=/x/.unicode?"gu":"g",Specials=new RegExp("[\0-\b\n--­؜​‎‏\u2028\u2029‭‮⁦⁧⁩\ufeff￹-￼]",UnicodeRegexpSupport),Names={0:"null",7:"bell",8:"backspace",10:"newline",11:"vertical tab",13:"carriage return",27:"escape",8203:"zero width space",8204:"zero width non-joiner",8205:"zero width joiner",8206:"left-to-right mark",8207:"right-to-left mark",8232:"line separator",8237:"left-to-right override",8238:"right-to-left override",8294:"left-to-right isolate",8295:"right-to-left isolate",8297:"pop directional isolate",8233:"paragraph separator",65279:"zero width no-break space",65532:"object replacement"};let _supportsTabSize=null;function supportsTabSize(){var t;if(null==_supportsTabSize&&"undefined"!=typeof document&&document.body){let e=document.body.style;_supportsTabSize=null!=(null!==(t=e.tabSize)&&void 0!==t?t:e.MozTabSize);}return _supportsTabSize||!1}const specialCharConfig=Facet.define({combine(t){let e=combineConfig(t,{render:null,specialChars:Specials,addSpecialChars:null});return (e.replaceTabs=!supportsTabSize())&&(e.specialChars=new RegExp("\t|"+e.specialChars.source,UnicodeRegexpSupport)),e.addSpecialChars&&(e.specialChars=new RegExp(e.specialChars.source+"|"+e.addSpecialChars.source,UnicodeRegexpSupport)),e}});function highlightSpecialChars(t={}){return [specialCharConfig.of(t),specialCharPlugin()]}let _plugin=null;function specialCharPlugin(){return _plugin||(_plugin=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.decorations=Decoration.none,this.decorationCache=Object.create(null),this.decorator=this.makeDecorator(t.state.facet(specialCharConfig)),this.decorations=this.decorator.createDeco(t);}makeDecorator(t){return new MatchDecorator({regexp:t.specialChars,decoration:(e,i,o)=>{let{doc:s}=i.state,n=codePointAt(e[0],0);if(9==n){let t=s.lineAt(o),e=i.state.tabSize,n=countColumn(t.text,e,o-t.from);return Decoration.replace({widget:new TabWidget((e-n%e)*this.view.defaultCharacterWidth)})}return this.decorationCache[n]||(this.decorationCache[n]=Decoration.replace({widget:new SpecialCharWidget(t,n)}))},boundary:t.replaceTabs?void 0:/[^]/})}update(t){let e=t.state.facet(specialCharConfig);t.startState.facet(specialCharConfig)!=e?(this.decorator=this.makeDecorator(e),this.decorations=this.decorator.createDeco(t.view)):this.decorations=this.decorator.updateDeco(t,this.decorations);}},{decorations:t=>t.decorations}))}function placeholder$1(t){return t>=32?"•":10==t?"␤":String.fromCharCode(9216+t)}class SpecialCharWidget extends WidgetType{constructor(t,e){super(),this.options=t,this.code=e;}eq(t){return t.code==this.code}toDOM(t){let e=placeholder$1(this.code),i=t.state.phrase("Control character")+" "+(Names[this.code]||"0x"+this.code.toString(16)),o=this.options.render&&this.options.render(this.code,i,e);if(o)return o;let s=document.createElement("span");return s.textContent=e,s.title=i,s.setAttribute("aria-label",i),s.className="cm-specialChar",s}ignoreEvent(){return !1}}class TabWidget extends WidgetType{constructor(t){super(),this.width=t;}eq(t){return t.width==this.width}toDOM(){let t=document.createElement("span");return t.textContent="\t",t.className="cm-tab",t.style.width=this.width+"px",t}ignoreEvent(){return !1}}ViewPlugin.fromClass(class{constructor(){this.height=1e3,this.attrs={style:"padding-bottom: 1000px"};}update(t){let{view:e}=t,i=e.viewState.editorHeight-e.defaultLineHeight-e.documentPadding.top-.5;i>=0&&i!=this.height&&(this.height=i,this.attrs={style:`padding-bottom: ${i}px`});}});function highlightActiveLine(){return activeLineHighlighter}const lineDeco=Decoration.line({class:"cm-activeLine"}),activeLineHighlighter=ViewPlugin.fromClass(class{constructor(t){this.decorations=this.getDeco(t);}update(t){(t.docChanged||t.selectionSet)&&(this.decorations=this.getDeco(t.view));}getDeco(t){let e=-1,i=[];for(let o of t.state.selection.ranges){let s=t.lineBlockAt(o.head);s.from>e&&(i.push(lineDeco.range(s.from)),e=s.from);}return Decoration.set(i)}},{decorations:t=>t.decorations});class Placeholder extends WidgetType{constructor(t){super(),this.content=t;}toDOM(){let t=document.createElement("span");return t.className="cm-placeholder",t.style.pointerEvents="none",t.appendChild("string"==typeof this.content?document.createTextNode(this.content):this.content),"string"==typeof this.content?t.setAttribute("aria-label","placeholder "+this.content):t.setAttribute("aria-hidden","true"),t}coordsAt(t){let e=t.firstChild?clientRectsFor(t.firstChild):[];if(!e.length)return null;let i=window.getComputedStyle(t.parentNode),o=flattenRect(e[0],"rtl"!=i.direction),s=parseInt(i.lineHeight);return o.bottom-o.top>1.5*s?{left:o.left,right:o.right,top:o.top,bottom:o.top+s}:o}ignoreEvent(){return !1}}function placeholder(t){return ViewPlugin.fromClass(class{constructor(e){this.view=e,this.placeholder=Decoration.set([Decoration.widget({widget:new Placeholder(t),side:1}).range(0)]);}get decorations(){return this.view.state.doc.length?Decoration.none:this.placeholder}},{decorations:t=>t.decorations})}const MaxOff=2e3;function rectangleFor(t,e,i){let o=Math.min(e.line,i.line),s=Math.max(e.line,i.line),n=[];if(e.off>MaxOff||i.off>MaxOff||e.col<0||i.col<0){let r=Math.min(e.off,i.off),l=Math.max(e.off,i.off);for(let e=o;e<=s;e++){let i=t.doc.line(e);i.length<=l&&n.push(EditorSelection.range(i.from+r,i.to+l));}}else {let r=Math.min(e.col,i.col),l=Math.max(e.col,i.col);for(let e=o;e<=s;e++){let i=t.doc.line(e),o=findColumn(i.text,r,t.tabSize,!0);if(o<0)n.push(EditorSelection.cursor(i.to));else {let e=findColumn(i.text,l,t.tabSize);n.push(EditorSelection.range(i.from+o,i.from+e));}}}return n}function absoluteColumn(t,e){let i=t.coordsAtPos(t.viewport.from);return i?Math.round(Math.abs((i.left-e)/t.defaultCharacterWidth)):-1}function getPos(t,e){let i=t.posAtCoords({x:e.clientX,y:e.clientY},!1),o=t.state.doc.lineAt(i),s=i-o.from,n=s>MaxOff?-1:s==o.length?absoluteColumn(t,e.clientX):countColumn(o.text,t.state.tabSize,i-o.from);return {line:o.number,col:n,off:s}}function rectangleSelectionStyle(t,e){let i=getPos(t,e),o=t.state.selection;return i?{update(t){if(t.docChanged){let e=t.changes.mapPos(t.startState.doc.line(i.line).from),s=t.state.doc.lineAt(e);i={line:s.number,col:i.col,off:Math.min(i.off,s.length)},o=o.map(t.changes);}},get(e,s,n){let r=getPos(t,e);if(!r)return o;let l=rectangleFor(t.state,i,r);return l.length?n?EditorSelection.create(l.concat(o.ranges)):EditorSelection.create(l):o}}:null}function rectangularSelection(t){let e=(null==t?void 0:t.eventFilter)||(t=>t.altKey&&0==t.button);return EditorView.mouseSelectionStyle.of(((t,i)=>e(i)?rectangleSelectionStyle(t,i):null))}const keys={Alt:[18,t=>!!t.altKey],Control:[17,t=>!!t.ctrlKey],Shift:[16,t=>!!t.shiftKey],Meta:[91,t=>!!t.metaKey]},showCrosshair={style:"cursor: crosshair"};function crosshairCursor(t={}){let[e,i]=keys[t.key||"Alt"],o=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.isDown=!1;}set(t){this.isDown!=t&&(this.isDown=t,this.view.update([]));}},{eventHandlers:{keydown(t){this.set(t.keyCode==e||i(t));},keyup(t){t.keyCode!=e&&i(t)||this.set(!1);},mousemove(t){this.set(i(t));}}});return [o,EditorView.contentAttributes.of((t=>{var e;return (null===(e=t.plugin(o))||void 0===e?void 0:e.isDown)?showCrosshair:null}))]}const Outside="-10000px";class TooltipViewManager{constructor(t,e,i){this.facet=e,this.createTooltipView=i,this.input=t.state.facet(e),this.tooltips=this.input.filter((t=>t)),this.tooltipViews=this.tooltips.map(i);}update(t){var e;let i=t.state.facet(this.facet),o=i.filter((t=>t));if(i===this.input){for(let e of this.tooltipViews)e.update&&e.update(t);return !1}let s=[];for(let e=0;e<o.length;e++){let i=o[e],n=-1;if(i){for(let t=0;t<this.tooltips.length;t++){let e=this.tooltips[t];e&&e.create==i.create&&(n=t);}if(n<0)s[e]=this.createTooltipView(i);else {let i=s[e]=this.tooltipViews[n];i.update&&i.update(t);}}}for(let t of this.tooltipViews)s.indexOf(t)<0&&(t.dom.remove(),null===(e=t.destroy)||void 0===e||e.call(t));return this.input=i,this.tooltips=o,this.tooltipViews=s,!0}}function windowSpace(t){let{win:e}=t;return {top:0,left:0,bottom:e.innerHeight,right:e.innerWidth}}const tooltipConfig=Facet.define({combine:t=>{var e,i,o;return {position:browser.ios?"absolute":(null===(e=t.find((t=>t.position)))||void 0===e?void 0:e.position)||"fixed",parent:(null===(i=t.find((t=>t.parent)))||void 0===i?void 0:i.parent)||null,tooltipSpace:(null===(o=t.find((t=>t.tooltipSpace)))||void 0===o?void 0:o.tooltipSpace)||windowSpace}}}),knownHeight=new WeakMap,tooltipPlugin=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.inView=!0,this.lastTransaction=0,this.measureTimeout=-1;let e=t.state.facet(tooltipConfig);this.position=e.position,this.parent=e.parent,this.classes=t.themeClasses,this.createContainer(),this.measureReq={read:this.readMeasure.bind(this),write:this.writeMeasure.bind(this),key:this},this.manager=new TooltipViewManager(t,showTooltip,(t=>this.createTooltip(t))),this.intersectionObserver="function"==typeof IntersectionObserver?new IntersectionObserver((t=>{Date.now()>this.lastTransaction-50&&t.length>0&&t[t.length-1].intersectionRatio<1&&this.measureSoon();}),{threshold:[1]}):null,this.observeIntersection(),t.win.addEventListener("resize",this.measureSoon=this.measureSoon.bind(this)),this.maybeMeasure();}createContainer(){this.parent?(this.container=document.createElement("div"),this.container.style.position="relative",this.container.className=this.view.themeClasses,this.parent.appendChild(this.container)):this.container=this.view.dom;}observeIntersection(){if(this.intersectionObserver){this.intersectionObserver.disconnect();for(let t of this.manager.tooltipViews)this.intersectionObserver.observe(t.dom);}}measureSoon(){this.measureTimeout<0&&(this.measureTimeout=setTimeout((()=>{this.measureTimeout=-1,this.maybeMeasure();}),50));}update(t){t.transactions.length&&(this.lastTransaction=Date.now());let e=this.manager.update(t);e&&this.observeIntersection();let i=e||t.geometryChanged,o=t.state.facet(tooltipConfig);if(o.position!=this.position){this.position=o.position;for(let t of this.manager.tooltipViews)t.dom.style.position=this.position;i=!0;}if(o.parent!=this.parent){this.parent&&this.container.remove(),this.parent=o.parent,this.createContainer();for(let t of this.manager.tooltipViews)this.container.appendChild(t.dom);i=!0;}else this.parent&&this.view.themeClasses!=this.classes&&(this.classes=this.container.className=this.view.themeClasses);i&&this.maybeMeasure();}createTooltip(t){let e=t.create(this.view);if(e.dom.classList.add("cm-tooltip"),t.arrow&&!e.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")){let t=document.createElement("div");t.className="cm-tooltip-arrow",e.dom.appendChild(t);}return e.dom.style.position=this.position,e.dom.style.top=Outside,this.container.appendChild(e.dom),e.mount&&e.mount(this.view),e}destroy(){var t,e;this.view.win.removeEventListener("resize",this.measureSoon);for(let e of this.manager.tooltipViews)e.dom.remove(),null===(t=e.destroy)||void 0===t||t.call(e);null===(e=this.intersectionObserver)||void 0===e||e.disconnect(),clearTimeout(this.measureTimeout);}readMeasure(){let t=this.view.dom.getBoundingClientRect();return {editor:t,parent:this.parent?this.container.getBoundingClientRect():t,pos:this.manager.tooltips.map(((t,e)=>{let i=this.manager.tooltipViews[e];return i.getCoords?i.getCoords(t.pos):this.view.coordsAtPos(t.pos)})),size:this.manager.tooltipViews.map((({dom:t})=>t.getBoundingClientRect())),space:this.view.state.facet(tooltipConfig).tooltipSpace(this.view)}}writeMeasure(t){var e;let{editor:i,space:o}=t,s=[];for(let n=0;n<this.manager.tooltips.length;n++){let r=this.manager.tooltips[n],l=this.manager.tooltipViews[n],{dom:a}=l,h=t.pos[n],c=t.size[n];if(!h||h.bottom<=Math.max(i.top,o.top)||h.top>=Math.min(i.bottom,o.bottom)||h.right<Math.max(i.left,o.left)-.1||h.left>Math.min(i.right,o.right)+.1){a.style.top=Outside;continue}let d=r.arrow?l.dom.querySelector(".cm-tooltip-arrow"):null,u=d?7:0,p=c.right-c.left,f=null!==(e=knownHeight.get(l))&&void 0!==e?e:c.bottom-c.top,g=l.offset||noOffset,m=this.view.textDirection==Direction.LTR,w=c.width>o.right-o.left?m?o.left:o.right-c.width:m?Math.min(h.left-(d?14:0)+g.x,o.right-p):Math.max(o.left,h.left-p+(d?14:0)-g.x),v=!!r.above;!r.strictSide&&(v?h.top-(c.bottom-c.top)-g.y<o.top:h.bottom+(c.bottom-c.top)+g.y>o.bottom)&&v==o.bottom-h.bottom>h.top-o.top&&(v=!v);let y=(v?h.top-o.top:o.bottom-h.bottom)-u;if(y<f&&!1!==l.resize){if(y<this.view.defaultLineHeight){a.style.top=Outside;continue}knownHeight.set(l,f),a.style.height=(f=y)+"px";}else a.style.height&&(a.style.height="");let b=v?h.top-f-u-g.y:h.bottom+u+g.y,S=w+p;if(!0!==l.overlap)for(let t of s)t.left<S&&t.right>w&&t.top<b+f&&t.bottom>b&&(b=v?t.top-f-2-u:t.bottom+u+2);"absolute"==this.position?(a.style.top=b-t.parent.top+"px",a.style.left=w-t.parent.left+"px"):(a.style.top=b+"px",a.style.left=w+"px"),d&&(d.style.left=h.left+(m?g.x:-g.x)-(w+14-7)+"px"),!0!==l.overlap&&s.push({left:w,top:b,right:S,bottom:b+f}),a.classList.toggle("cm-tooltip-above",v),a.classList.toggle("cm-tooltip-below",!v),l.positioned&&l.positioned(t.space);}}maybeMeasure(){if(this.manager.tooltips.length&&(this.view.inView&&this.view.requestMeasure(this.measureReq),this.inView!=this.view.inView&&(this.inView=this.view.inView,!this.inView)))for(let t of this.manager.tooltipViews)t.dom.style.top=Outside;}},{eventHandlers:{scroll(){this.maybeMeasure();}}}),baseTheme$5=EditorView.baseTheme({".cm-tooltip":{zIndex:100,boxSizing:"border-box"},"&light .cm-tooltip":{border:"1px solid #bbb",backgroundColor:"#f5f5f5"},"&light .cm-tooltip-section:not(:first-child)":{borderTop:"1px solid #bbb"},"&dark .cm-tooltip":{backgroundColor:"#333338",color:"white"},".cm-tooltip-arrow":{height:"7px",width:"14px",position:"absolute",zIndex:-1,overflow:"hidden","&:before, &:after":{content:"''",position:"absolute",width:0,height:0,borderLeft:"7px solid transparent",borderRight:"7px solid transparent"},".cm-tooltip-above &":{bottom:"-7px","&:before":{borderTop:"7px solid #bbb"},"&:after":{borderTop:"7px solid #f5f5f5",bottom:"1px"}},".cm-tooltip-below &":{top:"-7px","&:before":{borderBottom:"7px solid #bbb"},"&:after":{borderBottom:"7px solid #f5f5f5",top:"1px"}}},"&dark .cm-tooltip .cm-tooltip-arrow":{"&:before":{borderTopColor:"#333338",borderBottomColor:"#333338"},"&:after":{borderTopColor:"transparent",borderBottomColor:"transparent"}}}),noOffset={x:0,y:0},showTooltip=Facet.define({enables:[tooltipPlugin,baseTheme$5]}),showHoverTooltip=Facet.define();class HoverTooltipHost{constructor(t){this.view=t,this.mounted=!1,this.dom=document.createElement("div"),this.dom.classList.add("cm-tooltip-hover"),this.manager=new TooltipViewManager(t,showHoverTooltip,(t=>this.createHostedView(t)));}static create(t){return new HoverTooltipHost(t)}createHostedView(t){let e=t.create(this.view);return e.dom.classList.add("cm-tooltip-section"),this.dom.appendChild(e.dom),this.mounted&&e.mount&&e.mount(this.view),e}mount(t){for(let e of this.manager.tooltipViews)e.mount&&e.mount(t);this.mounted=!0;}positioned(t){for(let e of this.manager.tooltipViews)e.positioned&&e.positioned(t);}update(t){this.manager.update(t);}destroy(){var t;for(let e of this.manager.tooltipViews)null===(t=e.destroy)||void 0===t||t.call(e);}}const showHoverTooltipHost=showTooltip.compute([showHoverTooltip],(t=>{let e=t.facet(showHoverTooltip).filter((t=>t));return 0===e.length?null:{pos:Math.min(...e.map((t=>t.pos))),end:Math.max(...e.filter((t=>null!=t.end)).map((t=>t.end))),create:HoverTooltipHost.create,above:e[0].above,arrow:e.some((t=>t.arrow))}}));class HoverPlugin{constructor(t,e,i,o,s){this.view=t,this.source=e,this.field=i,this.setHover=o,this.hoverTime=s,this.hoverTimeout=-1,this.restartTimeout=-1,this.pending=null,this.lastMove={x:0,y:0,target:t.dom,time:0},this.checkHover=this.checkHover.bind(this),t.dom.addEventListener("mouseleave",this.mouseleave=this.mouseleave.bind(this)),t.dom.addEventListener("mousemove",this.mousemove=this.mousemove.bind(this));}update(){this.pending&&(this.pending=null,clearTimeout(this.restartTimeout),this.restartTimeout=setTimeout((()=>this.startHover()),20));}get active(){return this.view.state.field(this.field)}checkHover(){if(this.hoverTimeout=-1,this.active)return;let t=Date.now()-this.lastMove.time;t<this.hoverTime?this.hoverTimeout=setTimeout(this.checkHover,this.hoverTime-t):this.startHover();}startHover(){clearTimeout(this.restartTimeout);let{lastMove:t}=this,e=this.view.contentDOM.contains(t.target)?this.view.posAtCoords(t):null;if(null==e)return;let i=this.view.coordsAtPos(e);if(null==i||t.y<i.top||t.y>i.bottom||t.x<i.left-this.view.defaultCharacterWidth||t.x>i.right+this.view.defaultCharacterWidth)return;let o=this.view.bidiSpans(this.view.state.doc.lineAt(e)).find((t=>t.from<=e&&t.to>=e)),s=o&&o.dir==Direction.RTL?-1:1,n=this.source(this.view,e,t.x<i.left?-s:s);if(null==n?void 0:n.then){let t=this.pending={pos:e};n.then((e=>{this.pending==t&&(this.pending=null,e&&this.view.dispatch({effects:this.setHover.of(e)}));}),(t=>logException(this.view.state,t,"hover tooltip")));}else n&&this.view.dispatch({effects:this.setHover.of(n)});}mousemove(t){var e;this.lastMove={x:t.clientX,y:t.clientY,target:t.target,time:Date.now()},this.hoverTimeout<0&&(this.hoverTimeout=setTimeout(this.checkHover,this.hoverTime));let i=this.active;if(i&&!isInTooltip(this.lastMove.target)||this.pending){let{pos:o}=i||this.pending,s=null!==(e=null==i?void 0:i.end)&&void 0!==e?e:o;(o==s?this.view.posAtCoords(this.lastMove)==o:isOverRange(this.view,o,s,t.clientX,t.clientY,6))||(this.view.dispatch({effects:this.setHover.of(null)}),this.pending=null);}}mouseleave(t){clearTimeout(this.hoverTimeout),this.hoverTimeout=-1,this.active&&!isInTooltip(t.relatedTarget)&&this.view.dispatch({effects:this.setHover.of(null)});}destroy(){clearTimeout(this.hoverTimeout),this.view.dom.removeEventListener("mouseleave",this.mouseleave),this.view.dom.removeEventListener("mousemove",this.mousemove);}}function isInTooltip(t){for(let e=t;e;e=e.parentNode)if(1==e.nodeType&&e.classList.contains("cm-tooltip"))return !0;return !1}function isOverRange(t,e,i,o,s,n){let r=document.createRange(),l=t.domAtPos(e),a=t.domAtPos(i);r.setEnd(a.node,a.offset),r.setStart(l.node,l.offset);let h=r.getClientRects();r.detach();for(let t=0;t<h.length;t++){let e=h[t];if(Math.max(e.top-s,s-e.bottom,e.left-o,o-e.right)<=n)return !0}return !1}function hoverTooltip(t,e={}){let i=StateEffect.define(),o=StateField.define({create:()=>null,update(t,o){if(t&&(e.hideOnChange&&(o.docChanged||o.selection)||e.hideOn&&e.hideOn(o,t)))return null;if(t&&o.docChanged){let e=o.changes.mapPos(t.pos,-1,MapMode.TrackDel);if(null==e)return null;let i=Object.assign(Object.create(null),t);i.pos=e,null!=t.end&&(i.end=o.changes.mapPos(t.end)),t=i;}for(let e of o.effects)e.is(i)&&(t=e.value),e.is(closeHoverTooltipEffect)&&(t=null);return t},provide:t=>showHoverTooltip.from(t)});return [o,ViewPlugin.define((s=>new HoverPlugin(s,t,o,i,e.hoverTime||300))),showHoverTooltipHost]}function getTooltip$1(t,e){let i=t.plugin(tooltipPlugin);if(!i)return null;let o=i.manager.tooltips.indexOf(e);return o<0?null:i.manager.tooltipViews[o]}const closeHoverTooltipEffect=StateEffect.define();closeHoverTooltipEffect.of(null);const panelConfig=Facet.define({combine(t){let e,i;for(let o of t)e=e||o.topContainer,i=i||o.bottomContainer;return {topContainer:e,bottomContainer:i}}});function getPanel(t,e){let i=t.plugin(panelPlugin),o=i?i.specs.indexOf(e):-1;return o>-1?i.panels[o]:null}const panelPlugin=ViewPlugin.fromClass(class{constructor(t){this.input=t.state.facet(showPanel),this.specs=this.input.filter((t=>t)),this.panels=this.specs.map((e=>e(t)));let e=t.state.facet(panelConfig);this.top=new PanelGroup(t,!0,e.topContainer),this.bottom=new PanelGroup(t,!1,e.bottomContainer),this.top.sync(this.panels.filter((t=>t.top))),this.bottom.sync(this.panels.filter((t=>!t.top)));for(let t of this.panels)t.dom.classList.add("cm-panel"),t.mount&&t.mount();}update(t){let e=t.state.facet(panelConfig);this.top.container!=e.topContainer&&(this.top.sync([]),this.top=new PanelGroup(t.view,!0,e.topContainer)),this.bottom.container!=e.bottomContainer&&(this.bottom.sync([]),this.bottom=new PanelGroup(t.view,!1,e.bottomContainer)),this.top.syncClasses(),this.bottom.syncClasses();let i=t.state.facet(showPanel);if(i!=this.input){let e=i.filter((t=>t)),o=[],s=[],n=[],r=[];for(let i of e){let e,l=this.specs.indexOf(i);l<0?(e=i(t.view),r.push(e)):(e=this.panels[l],e.update&&e.update(t)),o.push(e),(e.top?s:n).push(e);}this.specs=e,this.panels=o,this.top.sync(s),this.bottom.sync(n);for(let t of r)t.dom.classList.add("cm-panel"),t.mount&&t.mount();}else for(let e of this.panels)e.update&&e.update(t);}destroy(){this.top.sync([]),this.bottom.sync([]);}},{provide:t=>EditorView.scrollMargins.of((e=>{let i=e.plugin(t);return i&&{top:i.top.scrollMargin(),bottom:i.bottom.scrollMargin()}}))});class PanelGroup{constructor(t,e,i){this.view=t,this.top=e,this.container=i,this.dom=void 0,this.classes="",this.panels=[],this.syncClasses();}sync(t){for(let e of this.panels)e.destroy&&t.indexOf(e)<0&&e.destroy();this.panels=t,this.syncDOM();}syncDOM(){if(0==this.panels.length)return void(this.dom&&(this.dom.remove(),this.dom=void 0));if(!this.dom){this.dom=document.createElement("div"),this.dom.className=this.top?"cm-panels cm-panels-top":"cm-panels cm-panels-bottom",this.dom.style[this.top?"top":"bottom"]="0";let t=this.container||this.view.dom;t.insertBefore(this.dom,this.top?t.firstChild:null);}let t=this.dom.firstChild;for(let e of this.panels)if(e.dom.parentNode==this.dom){for(;t!=e.dom;)t=rm(t);t=t.nextSibling;}else this.dom.insertBefore(e.dom,t);for(;t;)t=rm(t);}scrollMargin(){return !this.dom||this.container?0:Math.max(0,this.top?this.dom.getBoundingClientRect().bottom-Math.max(0,this.view.scrollDOM.getBoundingClientRect().top):Math.min(innerHeight,this.view.scrollDOM.getBoundingClientRect().bottom)-this.dom.getBoundingClientRect().top)}syncClasses(){if(this.container&&this.classes!=this.view.themeClasses){for(let t of this.classes.split(" "))t&&this.container.classList.remove(t);for(let t of (this.classes=this.view.themeClasses).split(" "))t&&this.container.classList.add(t);}}}function rm(t){let e=t.nextSibling;return t.remove(),e}const showPanel=Facet.define({enables:panelPlugin});class GutterMarker extends RangeValue{compare(t){return this==t||this.constructor==t.constructor&&this.eq(t)}eq(t){return !1}destroy(t){}}GutterMarker.prototype.elementClass="",GutterMarker.prototype.toDOM=void 0,GutterMarker.prototype.mapMode=MapMode.TrackBefore,GutterMarker.prototype.startSide=GutterMarker.prototype.endSide=-1,GutterMarker.prototype.point=!0;const gutterLineClass=Facet.define(),defaults$1={class:"",renderEmptyElements:!1,elementStyle:"",markers:()=>RangeSet.empty,lineMarker:()=>null,widgetMarker:()=>null,lineMarkerChange:null,initialSpacer:null,updateSpacer:null,domEventHandlers:{}},activeGutters=Facet.define();function gutter(t){return [gutters(),activeGutters.of(Object.assign(Object.assign({},defaults$1),t))]}const unfixGutters=Facet.define({combine:t=>t.some((t=>t))});function gutters(t){let e=[gutterView];return t&&!1===t.fixed&&e.push(unfixGutters.of(!0)),e}const gutterView=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.prevViewport=t.viewport,this.dom=document.createElement("div"),this.dom.className="cm-gutters",this.dom.setAttribute("aria-hidden","true"),this.dom.style.minHeight=this.view.contentHeight+"px",this.gutters=t.state.facet(activeGutters).map((e=>new SingleGutterView(t,e)));for(let t of this.gutters)this.dom.appendChild(t.dom);this.fixed=!t.state.facet(unfixGutters),this.fixed&&(this.dom.style.position="sticky"),this.syncGutters(!1),t.scrollDOM.insertBefore(this.dom,t.contentDOM);}update(t){if(this.updateGutters(t)){let e=this.prevViewport,i=t.view.viewport,o=Math.min(e.to,i.to)-Math.max(e.from,i.from);this.syncGutters(o<.8*(i.to-i.from));}t.geometryChanged&&(this.dom.style.minHeight=this.view.contentHeight+"px"),this.view.state.facet(unfixGutters)!=!this.fixed&&(this.fixed=!this.fixed,this.dom.style.position=this.fixed?"sticky":""),this.prevViewport=t.view.viewport;}syncGutters(t){let e=this.dom.nextSibling;t&&this.dom.remove();let i=RangeSet.iter(this.view.state.facet(gutterLineClass),this.view.viewport.from),o=[],s=this.gutters.map((t=>new UpdateContext(t,this.view.viewport,-this.view.documentPadding.top)));for(let t of this.view.viewportLineBlocks)if(o.length&&(o=[]),Array.isArray(t.type)){let e=!0;for(let n of t.type)if(n.type==BlockType.Text&&e){advanceCursor(i,o,n.from);for(let t of s)t.line(this.view,n,o);e=!1;}else if(n.widget)for(let t of s)t.widget(this.view,n);}else if(t.type==BlockType.Text){advanceCursor(i,o,t.from);for(let e of s)e.line(this.view,t,o);}for(let t of s)t.finish();t&&this.view.scrollDOM.insertBefore(this.dom,e);}updateGutters(t){let e=t.startState.facet(activeGutters),i=t.state.facet(activeGutters),o=t.docChanged||t.heightChanged||t.viewportChanged||!RangeSet.eq(t.startState.facet(gutterLineClass),t.state.facet(gutterLineClass),t.view.viewport.from,t.view.viewport.to);if(e==i)for(let e of this.gutters)e.update(t)&&(o=!0);else {o=!0;let s=[];for(let o of i){let i=e.indexOf(o);i<0?s.push(new SingleGutterView(this.view,o)):(this.gutters[i].update(t),s.push(this.gutters[i]));}for(let t of this.gutters)t.dom.remove(),s.indexOf(t)<0&&t.destroy();for(let t of s)this.dom.appendChild(t.dom);this.gutters=s;}return o}destroy(){for(let t of this.gutters)t.destroy();this.dom.remove();}},{provide:t=>EditorView.scrollMargins.of((e=>{let i=e.plugin(t);return i&&0!=i.gutters.length&&i.fixed?e.textDirection==Direction.LTR?{left:i.dom.offsetWidth}:{right:i.dom.offsetWidth}:null}))});function asArray(t){return Array.isArray(t)?t:[t]}function advanceCursor(t,e,i){for(;t.value&&t.from<=i;)t.from==i&&e.push(t.value),t.next();}class UpdateContext{constructor(t,e,i){this.gutter=t,this.height=i,this.i=0,this.cursor=RangeSet.iter(t.markers,e.from);}addElement(t,e,i){let{gutter:o}=this,s=e.top-this.height;if(this.i==o.elements.length){let n=new GutterElement(t,e.height,s,i);o.elements.push(n),o.dom.appendChild(n.dom);}else o.elements[this.i].update(t,e.height,s,i);this.height=e.bottom,this.i++;}line(t,e,i){let o=[];advanceCursor(this.cursor,o,e.from),i.length&&(o=o.concat(i));let s=this.gutter.config.lineMarker(t,e,o);s&&o.unshift(s);let n=this.gutter;(0!=o.length||n.config.renderEmptyElements)&&this.addElement(t,e,o);}widget(t,e){let i=this.gutter.config.widgetMarker(t,e.widget,e);i&&this.addElement(t,e,[i]);}finish(){let t=this.gutter;for(;t.elements.length>this.i;){let e=t.elements.pop();t.dom.removeChild(e.dom),e.destroy();}}}class SingleGutterView{constructor(t,e){this.view=t,this.config=e,this.elements=[],this.spacer=null,this.dom=document.createElement("div"),this.dom.className="cm-gutter"+(this.config.class?" "+this.config.class:"");for(let i in e.domEventHandlers)this.dom.addEventListener(i,(o=>{let s,n=o.target;if(n!=this.dom&&this.dom.contains(n)){for(;n.parentNode!=this.dom;)n=n.parentNode;let t=n.getBoundingClientRect();s=(t.top+t.bottom)/2;}else s=o.clientY;let r=t.lineBlockAtHeight(s-t.documentTop);e.domEventHandlers[i](t,r,o)&&o.preventDefault();}));this.markers=asArray(e.markers(t)),e.initialSpacer&&(this.spacer=new GutterElement(t,0,0,[e.initialSpacer(t)]),this.dom.appendChild(this.spacer.dom),this.spacer.dom.style.cssText+="visibility: hidden; pointer-events: none");}update(t){let e=this.markers;if(this.markers=asArray(this.config.markers(t.view)),this.spacer&&this.config.updateSpacer){let e=this.config.updateSpacer(this.spacer.markers[0],t);e!=this.spacer.markers[0]&&this.spacer.update(t.view,0,0,[e]);}let i=t.view.viewport;return !RangeSet.eq(this.markers,e,i.from,i.to)||!!this.config.lineMarkerChange&&this.config.lineMarkerChange(t)}destroy(){for(let t of this.elements)t.destroy();}}class GutterElement{constructor(t,e,i,o){this.height=-1,this.above=0,this.markers=[],this.dom=document.createElement("div"),this.dom.className="cm-gutterElement",this.update(t,e,i,o);}update(t,e,i,o){this.height!=e&&(this.dom.style.height=(this.height=e)+"px"),this.above!=i&&(this.dom.style.marginTop=(this.above=i)?i+"px":""),sameMarkers(this.markers,o)||this.setMarkers(t,o);}setMarkers(t,e){let i="cm-gutterElement",o=this.dom.firstChild;for(let s=0,n=0;;){let r=n,l=s<e.length?e[s++]:null,a=!1;if(l){let t=l.elementClass;t&&(i+=" "+t);for(let t=n;t<this.markers.length;t++)if(this.markers[t].compare(l)){r=t,a=!0;break}}else r=this.markers.length;for(;n<r;){let t=this.markers[n++];if(t.toDOM){t.destroy(o);let e=o.nextSibling;o.remove(),o=e;}}if(!l)break;l.toDOM&&(a?o=o.nextSibling:this.dom.insertBefore(l.toDOM(t),o)),a&&n++;}this.dom.className=i,this.markers=e;}destroy(){this.setMarkers(null,[]);}}function sameMarkers(t,e){if(t.length!=e.length)return !1;for(let i=0;i<t.length;i++)if(!t[i].compare(e[i]))return !1;return !0}const lineNumberMarkers=Facet.define(),lineNumberConfig=Facet.define({combine:t=>combineConfig(t,{formatNumber:String,domEventHandlers:{}},{domEventHandlers(t,e){let i=Object.assign({},t);for(let t in e){let o=i[t],s=e[t];i[t]=o?(t,e,i)=>o(t,e,i)||s(t,e,i):s;}return i}})});class NumberMarker extends GutterMarker{constructor(t){super(),this.number=t;}eq(t){return this.number==t.number}toDOM(){return document.createTextNode(this.number)}}function formatNumber(t,e){return t.state.facet(lineNumberConfig).formatNumber(e,t.state)}const lineNumberGutter=activeGutters.compute([lineNumberConfig],(t=>({class:"cm-lineNumbers",renderEmptyElements:!1,markers:t=>t.state.facet(lineNumberMarkers),lineMarker:(t,e,i)=>i.some((t=>t.toDOM))?null:new NumberMarker(formatNumber(t,t.state.doc.lineAt(e.from).number)),widgetMarker:()=>null,lineMarkerChange:t=>t.startState.facet(lineNumberConfig)!=t.state.facet(lineNumberConfig),initialSpacer:t=>new NumberMarker(formatNumber(t,maxLineNumber(t.state.doc.lines))),updateSpacer(t,e){let i=formatNumber(e.view,maxLineNumber(e.view.state.doc.lines));return i==t.number?t:new NumberMarker(i)},domEventHandlers:t.facet(lineNumberConfig).domEventHandlers})));function lineNumbers(t={}){return [lineNumberConfig.of(t),gutters(),lineNumberGutter]}function maxLineNumber(t){let e=9;for(;e<t;)e=10*e+9;return e}const activeLineGutterMarker=new class extends GutterMarker{constructor(){super(...arguments),this.elementClass="cm-activeLineGutter";}},activeLineGutterHighlighter=gutterLineClass.compute(["selection"],(t=>{let e=[],i=-1;for(let o of t.selection.ranges){let s=t.doc.lineAt(o.head).from;s>i&&(i=s,e.push(activeLineGutterMarker.range(s)));}return RangeSet.of(e)}));function highlightActiveLineGutter(){return activeLineGutterHighlighter}const WhitespaceDeco=new Map;function getWhitespaceDeco(t){let e=WhitespaceDeco.get(t);return e||WhitespaceDeco.set(t,e=Decoration.mark({attributes:"\t"===t?{class:"cm-highlightTab"}:{class:"cm-highlightSpace","data-display":t.replace(/ /g,"·")}})),e}function matcher(t){return ViewPlugin.define((e=>({decorations:t.createDeco(e),update(e){this.decorations=t.updateDeco(e,this.decorations);}})),{decorations:t=>t.decorations})}matcher(new MatchDecorator({regexp:/\t| +/g,decoration:t=>getWhitespaceDeco(t[0]),boundary:/\S/}));matcher(new MatchDecorator({regexp:/\s+$/g,decoration:Decoration.mark({class:"cm-trailingSpace"}),boundary:/\S/}));

    const DefaultBufferLength=1024;let nextPropID=0;class Range{constructor(e,t){this.from=e,this.to=t;}}class NodeProp{constructor(e={}){this.id=nextPropID++,this.perNode=!!e.perNode,this.deserialize=e.deserialize||(()=>{throw new Error("This node type doesn't define a deserialize function")});}add(e){if(this.perNode)throw new RangeError("Can't add per-node props to node types");return "function"!=typeof e&&(e=NodeType.match(e)),t=>{let r=e(t);return void 0===r?null:[this,r]}}}NodeProp.closedBy=new NodeProp({deserialize:e=>e.split(" ")}),NodeProp.openedBy=new NodeProp({deserialize:e=>e.split(" ")}),NodeProp.group=new NodeProp({deserialize:e=>e.split(" ")}),NodeProp.contextHash=new NodeProp({perNode:!0}),NodeProp.lookAhead=new NodeProp({perNode:!0}),NodeProp.mounted=new NodeProp({perNode:!0});class MountedTree{constructor(e,t,r){this.tree=e,this.overlay=t,this.parser=r;}}const noProps=Object.create(null);class NodeType{constructor(e,t,r,n=0){this.name=e,this.props=t,this.id=r,this.flags=n;}static define(e){let t=e.props&&e.props.length?Object.create(null):noProps,r=(e.top?1:0)|(e.skipped?2:0)|(e.error?4:0)|(null==e.name?8:0),n=new NodeType(e.name||"",t,e.id,r);if(e.props)for(let r of e.props)if(Array.isArray(r)||(r=r(n)),r){if(r[0].perNode)throw new RangeError("Can't store a per-node prop on a node type");t[r[0].id]=r[1];}return n}prop(e){return this.props[e.id]}get isTop(){return (1&this.flags)>0}get isSkipped(){return (2&this.flags)>0}get isError(){return (4&this.flags)>0}get isAnonymous(){return (8&this.flags)>0}is(e){if("string"==typeof e){if(this.name==e)return !0;let t=this.prop(NodeProp.group);return !!t&&t.indexOf(e)>-1}return this.id==e}static match(e){let t=Object.create(null);for(let r in e)for(let n of r.split(" "))t[n]=e[r];return e=>{for(let r=e.prop(NodeProp.group),n=-1;n<(r?r.length:0);n++){let i=t[n<0?e.name:r[n]];if(i)return i}}}}NodeType.none=new NodeType("",Object.create(null),0,8);class NodeSet{constructor(e){this.types=e;for(let t=0;t<e.length;t++)if(e[t].id!=t)throw new RangeError("Node type ids should correspond to array positions when creating a node set")}extend(...e){let t=[];for(let r of this.types){let n=null;for(let t of e){let e=t(r);e&&(n||(n=Object.assign({},r.props)),n[e[0].id]=e[1]);}t.push(n?new NodeType(r.name,n,r.id,r.flags):r);}return new NodeSet(t)}}const CachedNode=new WeakMap,CachedInnerNode=new WeakMap;var IterMode;!function(e){e[e.ExcludeBuffers=1]="ExcludeBuffers",e[e.IncludeAnonymous=2]="IncludeAnonymous",e[e.IgnoreMounts=4]="IgnoreMounts",e[e.IgnoreOverlays=8]="IgnoreOverlays";}(IterMode||(IterMode={}));class Tree{constructor(e,t,r,n,i){if(this.type=e,this.children=t,this.positions=r,this.length=n,this.props=null,i&&i.length){this.props=Object.create(null);for(let[e,t]of i)this.props["number"==typeof e?e:e.id]=t;}}toString(){let e=this.prop(NodeProp.mounted);if(e&&!e.overlay)return e.tree.toString();let t="";for(let e of this.children){let r=e.toString();r&&(t&&(t+=","),t+=r);}return this.type.name?(/\W/.test(this.type.name)&&!this.type.isError?JSON.stringify(this.type.name):this.type.name)+(t.length?"("+t+")":""):t}cursor(e=0){return new TreeCursor(this.topNode,e)}cursorAt(e,t=0,r=0){let n=CachedNode.get(this)||this.topNode,i=new TreeCursor(n);return i.moveTo(e,t),CachedNode.set(this,i._tree),i}get topNode(){return new TreeNode(this,0,0,null)}resolve(e,t=0){let r=resolveNode(CachedNode.get(this)||this.topNode,e,t,!1);return CachedNode.set(this,r),r}resolveInner(e,t=0){let r=resolveNode(CachedInnerNode.get(this)||this.topNode,e,t,!0);return CachedInnerNode.set(this,r),r}iterate(e){let{enter:t,leave:r,from:n=0,to:i=this.length}=e,s=e.mode||0,o=(s&IterMode.IncludeAnonymous)>0;for(let e=this.cursor(s|IterMode.IncludeAnonymous);;){let s=!1;if(e.from<=i&&e.to>=n&&(!o&&e.type.isAnonymous||!1!==t(e))){if(e.firstChild())continue;s=!0;}for(;s&&r&&(o||!e.type.isAnonymous)&&r(e),!e.nextSibling();){if(!e.parent())return;s=!0;}}}prop(e){return e.perNode?this.props?this.props[e.id]:void 0:this.type.prop(e)}get propValues(){let e=[];if(this.props)for(let t in this.props)e.push([+t,this.props[t]]);return e}balance(e={}){return this.children.length<=8?this:balanceRange(NodeType.none,this.children,this.positions,0,this.children.length,0,this.length,((e,t,r)=>new Tree(this.type,e,t,r,this.propValues)),e.makeTree||((e,t,r)=>new Tree(NodeType.none,e,t,r)))}static build(e){return buildTree(e)}}Tree.empty=new Tree(NodeType.none,[],[],0);class FlatBufferCursor{constructor(e,t){this.buffer=e,this.index=t;}get id(){return this.buffer[this.index-4]}get start(){return this.buffer[this.index-3]}get end(){return this.buffer[this.index-2]}get size(){return this.buffer[this.index-1]}get pos(){return this.index}next(){this.index-=4;}fork(){return new FlatBufferCursor(this.buffer,this.index)}}class TreeBuffer{constructor(e,t,r){this.buffer=e,this.length=t,this.set=r;}get type(){return NodeType.none}toString(){let e=[];for(let t=0;t<this.buffer.length;)e.push(this.childString(t)),t=this.buffer[t+3];return e.join(",")}childString(e){let t=this.buffer[e],r=this.buffer[e+3],n=this.set.types[t],i=n.name;if(/\W/.test(i)&&!n.isError&&(i=JSON.stringify(i)),r==(e+=4))return i;let s=[];for(;e<r;)s.push(this.childString(e)),e=this.buffer[e+3];return i+"("+s.join(",")+")"}findChild(e,t,r,n,i){let{buffer:s}=this,o=-1;for(let h=e;h!=t&&!(checkSide(i,n,s[h+1],s[h+2])&&(o=h,r>0));h=s[h+3]);return o}slice(e,t,r){let n=this.buffer,i=new Uint16Array(t-e),s=0;for(let o=e,h=0;o<t;){i[h++]=n[o++],i[h++]=n[o++]-r;let t=i[h++]=n[o++]-r;i[h++]=n[o++]-e,s=Math.max(s,t);}return new TreeBuffer(i,s,this.set)}}function checkSide(e,t,r,n){switch(e){case-2:return r<t;case-1:return n>=t&&r<t;case 0:return r<t&&n>t;case 1:return r<=t&&n>t;case 2:return n>t;case 4:return !0}}function enterUnfinishedNodesBefore(e,t){let r=e.childBefore(t);for(;r;){let t=r.lastChild;if(!t||t.to!=r.to)break;t.type.isError&&t.from==t.to?(e=r,r=t.prevSibling):r=t;}return e}function resolveNode(e,t,r,n){for(var i;e.from==e.to||(r<1?e.from>=t:e.from>t)||(r>-1?e.to<=t:e.to<t);){let t=!n&&e instanceof TreeNode&&e.index<0?null:e.parent;if(!t)return e;e=t;}let s=n?0:IterMode.IgnoreOverlays;if(n)for(let n=e,o=n.parent;o;n=o,o=n.parent)n instanceof TreeNode&&n.index<0&&(null===(i=o.enter(t,r,s))||void 0===i?void 0:i.from)!=n.from&&(e=o);for(;;){let n=e.enter(t,r,s);if(!n)return e;e=n;}}class TreeNode{constructor(e,t,r,n){this._tree=e,this.from=t,this.index=r,this._parent=n;}get type(){return this._tree.type}get name(){return this._tree.type.name}get to(){return this.from+this._tree.length}nextChild(e,t,r,n,i=0){for(let s=this;;){for(let{children:o,positions:h}=s._tree,f=t>0?o.length:-1;e!=f;e+=t){let f=o[e],l=h[e]+s.from;if(checkSide(n,r,l,l+f.length))if(f instanceof TreeBuffer){if(i&IterMode.ExcludeBuffers)continue;let o=f.findChild(0,f.buffer.length,t,r-l,n);if(o>-1)return new BufferNode(new BufferContext(s,f,e,l),null,o)}else if(i&IterMode.IncludeAnonymous||!f.type.isAnonymous||hasChild(f)){let o;if(!(i&IterMode.IgnoreMounts)&&f.props&&(o=f.prop(NodeProp.mounted))&&!o.overlay)return new TreeNode(o.tree,l,e,s);let h=new TreeNode(f,l,e,s);return i&IterMode.IncludeAnonymous||!h.type.isAnonymous?h:h.nextChild(t<0?f.children.length-1:0,t,r,n)}}if(i&IterMode.IncludeAnonymous||!s.type.isAnonymous)return null;if(e=s.index>=0?s.index+t:t<0?-1:s._parent._tree.children.length,s=s._parent,!s)return null}}get firstChild(){return this.nextChild(0,1,0,4)}get lastChild(){return this.nextChild(this._tree.children.length-1,-1,0,4)}childAfter(e){return this.nextChild(0,1,e,2)}childBefore(e){return this.nextChild(this._tree.children.length-1,-1,e,-2)}enter(e,t,r=0){let n;if(!(r&IterMode.IgnoreOverlays)&&(n=this._tree.prop(NodeProp.mounted))&&n.overlay){let r=e-this.from;for(let{from:e,to:i}of n.overlay)if((t>0?e<=r:e<r)&&(t<0?i>=r:i>r))return new TreeNode(n.tree,n.overlay[0].from+this.from,-1,this)}return this.nextChild(0,1,e,t,r)}nextSignificantParent(){let e=this;for(;e.type.isAnonymous&&e._parent;)e=e._parent;return e}get parent(){return this._parent?this._parent.nextSignificantParent():null}get nextSibling(){return this._parent&&this.index>=0?this._parent.nextChild(this.index+1,1,0,4):null}get prevSibling(){return this._parent&&this.index>=0?this._parent.nextChild(this.index-1,-1,0,4):null}cursor(e=0){return new TreeCursor(this,e)}get tree(){return this._tree}toTree(){return this._tree}resolve(e,t=0){return resolveNode(this,e,t,!1)}resolveInner(e,t=0){return resolveNode(this,e,t,!0)}enterUnfinishedNodesBefore(e){return enterUnfinishedNodesBefore(this,e)}getChild(e,t=null,r=null){let n=getChildren(this,e,t,r);return n.length?n[0]:null}getChildren(e,t=null,r=null){return getChildren(this,e,t,r)}toString(){return this._tree.toString()}get node(){return this}matchContext(e){return matchNodeContext(this,e)}}function getChildren(e,t,r,n){let i=e.cursor(),s=[];if(!i.firstChild())return s;if(null!=r)for(;!i.type.is(r);)if(!i.nextSibling())return s;for(;;){if(null!=n&&i.type.is(n))return s;if(i.type.is(t)&&s.push(i.node),!i.nextSibling())return null==n?s:[]}}function matchNodeContext(e,t,r=t.length-1){for(let n=e.parent;r>=0;n=n.parent){if(!n)return !1;if(!n.type.isAnonymous){if(t[r]&&t[r]!=n.name)return !1;r--;}}return !0}class BufferContext{constructor(e,t,r,n){this.parent=e,this.buffer=t,this.index=r,this.start=n;}}class BufferNode{get name(){return this.type.name}get from(){return this.context.start+this.context.buffer.buffer[this.index+1]}get to(){return this.context.start+this.context.buffer.buffer[this.index+2]}constructor(e,t,r){this.context=e,this._parent=t,this.index=r,this.type=e.buffer.set.types[e.buffer.buffer[r]];}child(e,t,r){let{buffer:n}=this.context,i=n.findChild(this.index+4,n.buffer[this.index+3],e,t-this.context.start,r);return i<0?null:new BufferNode(this.context,this,i)}get firstChild(){return this.child(1,0,4)}get lastChild(){return this.child(-1,0,4)}childAfter(e){return this.child(1,e,2)}childBefore(e){return this.child(-1,e,-2)}enter(e,t,r=0){if(r&IterMode.ExcludeBuffers)return null;let{buffer:n}=this.context,i=n.findChild(this.index+4,n.buffer[this.index+3],t>0?1:-1,e-this.context.start,t);return i<0?null:new BufferNode(this.context,this,i)}get parent(){return this._parent||this.context.parent.nextSignificantParent()}externalSibling(e){return this._parent?null:this.context.parent.nextChild(this.context.index+e,e,0,4)}get nextSibling(){let{buffer:e}=this.context,t=e.buffer[this.index+3];return t<(this._parent?e.buffer[this._parent.index+3]:e.buffer.length)?new BufferNode(this.context,this._parent,t):this.externalSibling(1)}get prevSibling(){let{buffer:e}=this.context,t=this._parent?this._parent.index+4:0;return this.index==t?this.externalSibling(-1):new BufferNode(this.context,this._parent,e.findChild(t,this.index,-1,0,4))}cursor(e=0){return new TreeCursor(this,e)}get tree(){return null}toTree(){let e=[],t=[],{buffer:r}=this.context,n=this.index+4,i=r.buffer[this.index+3];if(i>n){let s=r.buffer[this.index+1];e.push(r.slice(n,i,s)),t.push(0);}return new Tree(this.type,e,t,this.to-this.from)}resolve(e,t=0){return resolveNode(this,e,t,!1)}resolveInner(e,t=0){return resolveNode(this,e,t,!0)}enterUnfinishedNodesBefore(e){return enterUnfinishedNodesBefore(this,e)}toString(){return this.context.buffer.childString(this.index)}getChild(e,t=null,r=null){let n=getChildren(this,e,t,r);return n.length?n[0]:null}getChildren(e,t=null,r=null){return getChildren(this,e,t,r)}get node(){return this}matchContext(e){return matchNodeContext(this,e)}}class TreeCursor{get name(){return this.type.name}constructor(e,t=0){if(this.mode=t,this.buffer=null,this.stack=[],this.index=0,this.bufferNode=null,e instanceof TreeNode)this.yieldNode(e);else {this._tree=e.context.parent,this.buffer=e.context;for(let t=e._parent;t;t=t._parent)this.stack.unshift(t.index);this.bufferNode=e,this.yieldBuf(e.index);}}yieldNode(e){return !!e&&(this._tree=e,this.type=e.type,this.from=e.from,this.to=e.to,!0)}yieldBuf(e,t){this.index=e;let{start:r,buffer:n}=this.buffer;return this.type=t||n.set.types[n.buffer[e]],this.from=r+n.buffer[e+1],this.to=r+n.buffer[e+2],!0}yield(e){return !!e&&(e instanceof TreeNode?(this.buffer=null,this.yieldNode(e)):(this.buffer=e.context,this.yieldBuf(e.index,e.type)))}toString(){return this.buffer?this.buffer.buffer.childString(this.index):this._tree.toString()}enterChild(e,t,r){if(!this.buffer)return this.yield(this._tree.nextChild(e<0?this._tree._tree.children.length-1:0,e,t,r,this.mode));let{buffer:n}=this.buffer,i=n.findChild(this.index+4,n.buffer[this.index+3],e,t-this.buffer.start,r);return !(i<0)&&(this.stack.push(this.index),this.yieldBuf(i))}firstChild(){return this.enterChild(1,0,4)}lastChild(){return this.enterChild(-1,0,4)}childAfter(e){return this.enterChild(1,e,2)}childBefore(e){return this.enterChild(-1,e,-2)}enter(e,t,r=this.mode){return this.buffer?!(r&IterMode.ExcludeBuffers)&&this.enterChild(1,e,t):this.yield(this._tree.enter(e,t,r))}parent(){if(!this.buffer)return this.yieldNode(this.mode&IterMode.IncludeAnonymous?this._tree._parent:this._tree.parent);if(this.stack.length)return this.yieldBuf(this.stack.pop());let e=this.mode&IterMode.IncludeAnonymous?this.buffer.parent:this.buffer.parent.nextSignificantParent();return this.buffer=null,this.yieldNode(e)}sibling(e){if(!this.buffer)return !!this._tree._parent&&this.yield(this._tree.index<0?null:this._tree._parent.nextChild(this._tree.index+e,e,0,4,this.mode));let{buffer:t}=this.buffer,r=this.stack.length-1;if(e<0){let e=r<0?0:this.stack[r]+4;if(this.index!=e)return this.yieldBuf(t.findChild(e,this.index,-1,0,4))}else {let e=t.buffer[this.index+3];if(e<(r<0?t.buffer.length:t.buffer[this.stack[r]+3]))return this.yieldBuf(e)}return r<0&&this.yield(this.buffer.parent.nextChild(this.buffer.index+e,e,0,4,this.mode))}nextSibling(){return this.sibling(1)}prevSibling(){return this.sibling(-1)}atLastNode(e){let t,r,{buffer:n}=this;if(n){if(e>0){if(this.index<n.buffer.buffer.length)return !1}else for(let e=0;e<this.index;e++)if(n.buffer.buffer[e+3]<this.index)return !1;({index:t,parent:r}=n);}else ({index:t,_parent:r}=this._tree);for(;r;({index:t,_parent:r}=r))if(t>-1)for(let n=t+e,i=e<0?-1:r._tree.children.length;n!=i;n+=e){let e=r._tree.children[n];if(this.mode&IterMode.IncludeAnonymous||e instanceof TreeBuffer||!e.type.isAnonymous||hasChild(e))return !1}return !0}move(e,t){if(t&&this.enterChild(e,0,4))return !0;for(;;){if(this.sibling(e))return !0;if(this.atLastNode(e)||!this.parent())return !1}}next(e=!0){return this.move(1,e)}prev(e=!0){return this.move(-1,e)}moveTo(e,t=0){for(;(this.from==this.to||(t<1?this.from>=e:this.from>e)||(t>-1?this.to<=e:this.to<e))&&this.parent(););for(;this.enterChild(1,e,t););return this}get node(){if(!this.buffer)return this._tree;let e=this.bufferNode,t=null,r=0;if(e&&e.context==this.buffer)e:for(let n=this.index,i=this.stack.length;i>=0;){for(let s=e;s;s=s._parent)if(s.index==n){if(n==this.index)return s;t=s,r=i+1;break e}n=this.stack[--i];}for(let e=r;e<this.stack.length;e++)t=new BufferNode(this.buffer,t,this.stack[e]);return this.bufferNode=new BufferNode(this.buffer,t,this.index)}get tree(){return this.buffer?null:this._tree._tree}iterate(e,t){for(let r=0;;){let n=!1;if(this.type.isAnonymous||!1!==e(this)){if(this.firstChild()){r++;continue}this.type.isAnonymous||(n=!0);}for(;n&&t&&t(this),n=this.type.isAnonymous,!this.nextSibling();){if(!r)return;this.parent(),r--,n=!0;}}}matchContext(e){if(!this.buffer)return matchNodeContext(this.node,e);let{buffer:t}=this.buffer,{types:r}=t.set;for(let n=e.length-1,i=this.stack.length-1;n>=0;i--){if(i<0)return matchNodeContext(this.node,e,n);let s=r[t.buffer[this.stack[i]]];if(!s.isAnonymous){if(e[n]&&e[n]!=s.name)return !1;n--;}}return !0}}function hasChild(e){return e.children.some((e=>e instanceof TreeBuffer||!e.type.isAnonymous||hasChild(e)))}function buildTree(e){var t;let{buffer:r,nodeSet:n,maxBufferLength:i=DefaultBufferLength,reused:s=[],minRepeatType:o=n.types.length}=e,h=Array.isArray(r)?new FlatBufferCursor(r,r.length):r,f=n.types,l=0,u=0;function a(e,t,r,g,m){let{id:x,start:y,end:b,size:N}=h,C=u;for(;N<0;){if(h.next(),-1==N){let t=s[x];return r.push(t),void g.push(y-e)}if(-3==N)return void(l=x);if(-4==N)return void(u=x);throw new RangeError(`Unrecognized record size: ${N}`)}let v,w,T=f[x],I=y-e;if(b-y<=i&&(w=function(e,t){let r=h.fork(),n=0,s=0,f=0,l=r.end-i,u={size:0,start:0,skip:0};e:for(let i=r.pos-e;r.pos>i;){let e=r.size;if(r.id==t&&e>=0){u.size=n,u.start=s,u.skip=f,f+=4,n+=4,r.next();continue}let h=r.pos-e;if(e<0||h<i||r.start<l)break;let a=r.id>=o?4:0,d=r.start;for(r.next();r.pos>h;){if(r.size<0){if(-3!=r.size)break e;a+=4;}else r.id>=o&&(a+=4);r.next();}s=d,n+=e,f+=a;}(t<0||n==e)&&(u.size=n,u.start=s,u.skip=f);return u.size>4?u:void 0}(h.pos-t,m))){let t=new Uint16Array(w.size-w.skip),r=h.pos-w.size,i=t.length;for(;h.pos>r;)i=c(w.start,t,i);v=new TreeBuffer(t,b-w.start,n),I=w.start-e;}else {let e=h.pos-N;h.next();let t=[],r=[],n=x>=o?x:-1,s=0,f=b;for(;h.pos>e;)n>=0&&h.id==n&&h.size>=0?(h.end<=f-i&&(d(t,r,y,s,h.end,f,n,C),s=t.length,f=h.end),h.next()):a(y,e,t,r,n);if(n>=0&&s>0&&s<t.length&&d(t,r,y,s,y,f,n,C),t.reverse(),r.reverse(),n>-1&&s>0){let e=function(e){return (t,r,n)=>{let i,s,o=0,h=t.length-1;if(h>=0&&(i=t[h])instanceof Tree){if(!h&&i.type==e&&i.length==n)return i;(s=i.prop(NodeProp.lookAhead))&&(o=r[h]+i.length+s);}return p(e,t,r,n,o)}}(T);v=balanceRange(T,t,r,0,t.length,0,b-y,e,e);}else v=p(T,t,r,b-y,C-b);}r.push(v),g.push(I);}function d(e,t,r,i,s,o,h,f){let l=[],u=[];for(;e.length>i;)l.push(e.pop()),u.push(t.pop()+r-s);e.push(p(n.types[h],l,u,o-s,f-o)),t.push(s-r);}function p(e,t,r,n,i=0,s){if(l){let e=[NodeProp.contextHash,l];s=s?[e].concat(s):[e];}if(i>25){let e=[NodeProp.lookAhead,i];s=s?[e].concat(s):[e];}return new Tree(e,t,r,n,s)}function c(e,t,r){let{id:n,start:i,end:s,size:f}=h;if(h.next(),f>=0&&n<o){let o=r;if(f>4){let n=h.pos-(f-4);for(;h.pos>n;)r=c(e,t,r);}t[--r]=o,t[--r]=s-e,t[--r]=i-e,t[--r]=n;}else -3==f?l=n:-4==f&&(u=n);return r}let g=[],m=[];for(;h.pos>0;)a(e.start||0,e.bufferStart||0,g,m,-1);let x=null!==(t=e.length)&&void 0!==t?t:g.length?m[0]+g[0].length:0;return new Tree(f[e.topID],g.reverse(),m.reverse(),x)}const nodeSizeCache=new WeakMap;function nodeSize(e,t){if(!e.isAnonymous||t instanceof TreeBuffer||t.type!=e)return 1;let r=nodeSizeCache.get(t);if(null==r){r=1;for(let n of t.children){if(n.type!=e||!(n instanceof Tree)){r=1;break}r+=nodeSize(e,n);}nodeSizeCache.set(t,r);}return r}function balanceRange(e,t,r,n,i,s,o,h,f){let l=0;for(let r=n;r<i;r++)l+=nodeSize(e,t[r]);let u=Math.ceil(1.5*l/8),a=[],d=[];return function t(r,n,i,o,h){for(let l=i;l<o;){let i=l,p=n[l],c=nodeSize(e,r[l]);for(l++;l<o;l++){let t=nodeSize(e,r[l]);if(c+t>=u)break;c+=t;}if(l==i+1){if(c>u){let e=r[i];t(e.children,e.positions,0,e.children.length,n[i]+h);continue}a.push(r[i]);}else {let t=n[l-1]+r[l-1].length-p;a.push(balanceRange(e,r,n,i,l,p,t,null,f));}d.push(p+h-s);}}(t,r,n,i,0),(h||f)(a,d,o)}class NodeWeakMap{constructor(){this.map=new WeakMap;}setBuffer(e,t,r){let n=this.map.get(e);n||this.map.set(e,n=new Map),n.set(t,r);}getBuffer(e,t){let r=this.map.get(e);return r&&r.get(t)}set(e,t){e instanceof BufferNode?this.setBuffer(e.context.buffer,e.index,t):e instanceof TreeNode&&this.map.set(e.tree,t);}get(e){return e instanceof BufferNode?this.getBuffer(e.context.buffer,e.index):e instanceof TreeNode?this.map.get(e.tree):void 0}cursorSet(e,t){e.buffer?this.setBuffer(e.buffer.buffer,e.index,t):this.map.set(e.tree,t);}cursorGet(e){return e.buffer?this.getBuffer(e.buffer.buffer,e.index):this.map.get(e.tree)}}class TreeFragment{constructor(e,t,r,n,i=!1,s=!1){this.from=e,this.to=t,this.tree=r,this.offset=n,this.open=(i?1:0)|(s?2:0);}get openStart(){return (1&this.open)>0}get openEnd(){return (2&this.open)>0}static addTree(e,t=[],r=!1){let n=[new TreeFragment(0,e.length,e,0,!1,r)];for(let r of t)r.to>e.length&&n.push(r);return n}static applyChanges(e,t,r=128){if(!t.length)return e;let n=[],i=1,s=e.length?e[0]:null;for(let o=0,h=0,f=0;;o++){let l=o<t.length?t[o]:null,u=l?l.fromA:1e9;if(u-h>=r)for(;s&&s.from<u;){let t=s;if(h>=t.from||u<=t.to||f){let e=Math.max(t.from,h)-f,r=Math.min(t.to,u)-f;t=e>=r?null:new TreeFragment(e,r,t.tree,t.offset+f,o>0,!!l);}if(t&&n.push(t),s.to>u)break;s=i<e.length?e[i++]:null;}if(!l)break;h=l.toA,f=l.toA-l.toB;}return n}}class Parser{startParse(e,t,r){return "string"==typeof e&&(e=new StringInput(e)),r=r?r.length?r.map((e=>new Range(e.from,e.to))):[new Range(0,0)]:[new Range(0,e.length)],this.createParse(e,t||[],r)}parse(e,t,r){let n=this.startParse(e,t,r);for(;;){let e=n.advance();if(e)return e}}}class StringInput{constructor(e){this.string=e;}get length(){return this.string.length}chunk(e){return this.string.slice(e)}get lineChunks(){return !1}read(e,t){return this.string.slice(e,t)}}function parseMixed(e){return (t,r,n,i)=>new MixedParse(t,e,r,n,i)}class InnerParse{constructor(e,t,r,n,i){if(this.parser=e,this.parse=t,this.overlay=r,this.target=n,this.ranges=i,!i.length||i.some((e=>e.from>=e.to)))throw new RangeError("Invalid inner parse ranges given: "+JSON.stringify(i))}}class ActiveOverlay{constructor(e,t,r,n,i,s,o){this.parser=e,this.predicate=t,this.mounts=r,this.index=n,this.start=i,this.target=s,this.prev=o,this.depth=0,this.ranges=[];}}const stoppedInner=new NodeProp({perNode:!0});class MixedParse{constructor(e,t,r,n,i){this.nest=t,this.input=r,this.fragments=n,this.ranges=i,this.inner=[],this.innerDone=0,this.baseTree=null,this.stoppedAt=null,this.baseParse=e;}advance(){if(this.baseParse){let e=this.baseParse.advance();if(!e)return null;if(this.baseParse=null,this.baseTree=e,this.startInner(),null!=this.stoppedAt)for(let e of this.inner)e.parse.stopAt(this.stoppedAt);}if(this.innerDone==this.inner.length){let e=this.baseTree;return null!=this.stoppedAt&&(e=new Tree(e.type,e.children,e.positions,e.length,e.propValues.concat([[stoppedInner,this.stoppedAt]]))),e}let e=this.inner[this.innerDone],t=e.parse.advance();if(t){this.innerDone++;let r=Object.assign(Object.create(null),e.target.props);r[NodeProp.mounted.id]=new MountedTree(t,e.overlay,e.parser),e.target.props=r;}return null}get parsedPos(){if(this.baseParse)return 0;let e=this.input.length;for(let t=this.innerDone;t<this.inner.length;t++)this.inner[t].ranges[0].from<e&&(e=Math.min(e,this.inner[t].parse.parsedPos));return e}stopAt(e){if(this.stoppedAt=e,this.baseParse)this.baseParse.stopAt(e);else for(let t=this.innerDone;t<this.inner.length;t++)this.inner[t].parse.stopAt(e);}startInner(){let e=new FragmentCursor$1(this.fragments),t=null,r=null,n=new TreeCursor(new TreeNode(this.baseTree,this.ranges[0].from,0,null),IterMode.IncludeAnonymous|IterMode.IgnoreMounts);e:for(let i,s;null==this.stoppedAt||n.from<this.stoppedAt;){let o,h=!0;if(e.hasNode(n)){if(t){let e=t.mounts.find((e=>e.frag.from<=n.from&&e.frag.to>=n.to&&e.mount.overlay));if(e)for(let r of e.mount.overlay){let i=r.from+e.pos,s=r.to+e.pos;i>=n.from&&s<=n.to&&!t.ranges.some((e=>e.from<s&&e.to>i))&&t.ranges.push({from:i,to:s});}}h=!1;}else if(r&&(s=checkCover(r.ranges,n.from,n.to)))h=2!=s;else if(!n.type.isAnonymous&&n.from<n.to&&(i=this.nest(n,this.input))){n.tree||materialize(n);let s=e.findMounts(n.from,i.parser);if("function"==typeof i.overlay)t=new ActiveOverlay(i.parser,i.overlay,s,this.inner.length,n.from,n.tree,t);else {let e=punchRanges(this.ranges,i.overlay||[new Range(n.from,n.to)]);e.length&&this.inner.push(new InnerParse(i.parser,i.parser.startParse(this.input,enterFragments(s,e),e),i.overlay?i.overlay.map((e=>new Range(e.from-n.from,e.to-n.from))):null,n.tree,e)),i.overlay?e.length&&(r={ranges:e,depth:0,prev:r}):h=!1;}}else t&&(o=t.predicate(n))&&(!0===o&&(o=new Range(n.from,n.to)),o.from<o.to&&t.ranges.push(o));if(h&&n.firstChild())t&&t.depth++,r&&r.depth++;else for(;!n.nextSibling();){if(!n.parent())break e;if(t&&!--t.depth){let e=punchRanges(this.ranges,t.ranges);e.length&&this.inner.splice(t.index,0,new InnerParse(t.parser,t.parser.startParse(this.input,enterFragments(t.mounts,e),e),t.ranges.map((e=>new Range(e.from-t.start,e.to-t.start))),t.target,e)),t=t.prev;}r&&!--r.depth&&(r=r.prev);}}}}function checkCover(e,t,r){for(let n of e){if(n.from>=r)break;if(n.to>t)return n.from<=t&&n.to>=r?2:1}return 0}function sliceBuf(e,t,r,n,i,s){if(t<r){let o=e.buffer[t+1];n.push(e.slice(t,r,o)),i.push(o-s);}}function materialize(e){let{node:t}=e,r=0;do{e.parent(),r++;}while(!e.tree);let n=0,i=e.tree,s=0;for(;s=i.positions[n]+e.from,!(s<=t.from&&s+i.children[n].length>=t.to);n++);let o=i.children[n],h=o.buffer;i.children[n]=function e(r,n,i,f,l){let u=r;for(;h[u+2]+s<=t.from;)u=h[u+3];let a=[],d=[];sliceBuf(o,r,u,a,d,f);let p=h[u+1],c=h[u+2],g=p+s==t.from&&c+s==t.to&&h[u]==t.type.id;return a.push(g?t.toTree():e(u+4,h[u+3],o.set.types[h[u]],p,c-p)),d.push(p-f),sliceBuf(o,h[u+3],n,a,d,f),new Tree(i,a,d,l)}(0,h.length,NodeType.none,0,o.length);for(let n=0;n<=r;n++)e.childAfter(t.from);}class StructureCursor{constructor(e,t){this.offset=t,this.done=!1,this.cursor=e.cursor(IterMode.IncludeAnonymous|IterMode.IgnoreMounts);}moveTo(e){let{cursor:t}=this,r=e-this.offset;for(;!this.done&&t.from<r;)t.to>=e&&t.enter(r,1,IterMode.IgnoreOverlays|IterMode.ExcludeBuffers)||t.next(!1)||(this.done=!0);}hasNode(e){if(this.moveTo(e.from),!this.done&&this.cursor.from+this.offset==e.from&&this.cursor.tree)for(let t=this.cursor.tree;;){if(t==e.tree)return !0;if(!(t.children.length&&0==t.positions[0]&&t.children[0]instanceof Tree))break;t=t.children[0];}return !1}}class FragmentCursor$1{constructor(e){var t;if(this.fragments=e,this.curTo=0,this.fragI=0,e.length){let r=this.curFrag=e[0];this.curTo=null!==(t=r.tree.prop(stoppedInner))&&void 0!==t?t:r.to,this.inner=new StructureCursor(r.tree,-r.offset);}else this.curFrag=this.inner=null;}hasNode(e){for(;this.curFrag&&e.from>=this.curTo;)this.nextFrag();return this.curFrag&&this.curFrag.from<=e.from&&this.curTo>=e.to&&this.inner.hasNode(e)}nextFrag(){var e;if(this.fragI++,this.fragI==this.fragments.length)this.curFrag=this.inner=null;else {let t=this.curFrag=this.fragments[this.fragI];this.curTo=null!==(e=t.tree.prop(stoppedInner))&&void 0!==e?e:t.to,this.inner=new StructureCursor(t.tree,-t.offset);}}findMounts(e,t){var r;let n=[];if(this.inner){this.inner.cursor.moveTo(e,1);for(let e=this.inner.cursor.node;e;e=e.parent){let i=null===(r=e.tree)||void 0===r?void 0:r.prop(NodeProp.mounted);if(i&&i.parser==t)for(let t=this.fragI;t<this.fragments.length;t++){let r=this.fragments[t];if(r.from>=e.to)break;r.tree==this.curFrag.tree&&n.push({frag:r,pos:e.from-r.offset,mount:i});}}}return n}}function punchRanges(e,t){let r=null,n=t;for(let i=1,s=0;i<e.length;i++){let o=e[i-1].to,h=e[i].from;for(;s<n.length;s++){let e=n[s];if(e.from>=h)break;e.to<=o||(r||(n=r=t.slice()),e.from<o?(r[s]=new Range(e.from,o),e.to>h&&r.splice(s+1,0,new Range(h,e.to))):e.to>h?r[s--]=new Range(h,e.to):r.splice(s--,1));}}return n}function findCoverChanges(e,t,r,n){let i=0,s=0,o=!1,h=!1,f=-1e9,l=[];for(;;){let u=i==e.length?1e9:o?e[i].to:e[i].from,a=s==t.length?1e9:h?t[s].to:t[s].from;if(o!=h){let e=Math.max(f,r),t=Math.min(u,a,n);e<t&&l.push(new Range(e,t));}if(f=Math.min(u,a),1e9==f)break;u==f&&(o?(o=!1,i++):o=!0),a==f&&(h?(h=!1,s++):h=!0);}return l}function enterFragments(e,t){let r=[];for(let{pos:n,mount:i,frag:s}of e){let e=n+(i.overlay?i.overlay[0].from:0),o=e+i.tree.length,h=Math.max(s.from,e),f=Math.min(s.to,o);if(i.overlay){let o=findCoverChanges(t,i.overlay.map((e=>new Range(e.from+n,e.to+n))),h,f);for(let t=0,n=h;;t++){let h=t==o.length,l=h?f:o[t].from;if(l>n&&r.push(new TreeFragment(n,l,i.tree,-e,s.from>=n||s.openStart,s.to<=l||s.openEnd)),h)break;n=o[t].to;}}else r.push(new TreeFragment(h,f,i.tree,-e,s.from>=e||s.openStart,s.to<=o||s.openEnd));}return r}

    let nextTagID=0;class Tag{constructor(t,e,a){this.set=t,this.base=e,this.modified=a,this.id=nextTagID++;}static define(t){if(null==t?void 0:t.base)throw new Error("Can not derive from a modified tag");let e=new Tag([],null,[]);if(e.set.push(e),t)for(let a of t.set)e.set.push(a);return e}static defineModifier(){let t=new Modifier;return e=>e.modified.indexOf(t)>-1?e:Modifier.get(e.base||e,e.modified.concat(t).sort(((t,e)=>t.id-e.id)))}}let nextModifierID=0;class Modifier{constructor(){this.instances=[],this.id=nextModifierID++;}static get(t,e){if(!e.length)return t;let a=e[0].instances.find((a=>a.base==t&&sameArray(e,a.modified)));if(a)return a;let r=[],o=new Tag(r,t,e);for(let t of e)t.instances.push(o);let i=powerSet(e);for(let e of t.set)if(!e.modified.length)for(let t of i)r.push(Modifier.get(e,t));return o}}function sameArray(t,e){return t.length==e.length&&t.every(((t,a)=>t==e[a]))}function powerSet(t){let e=[[]];for(let a=0;a<t.length;a++)for(let r=0,o=e.length;r<o;r++)e.push(e[r].concat(t[a]));return e.sort(((t,e)=>e.length-t.length))}function styleTags(t){let e=Object.create(null);for(let a in t){let r=t[a];Array.isArray(r)||(r=[r]);for(let t of a.split(" "))if(t){let a=[],o=2,i=t;for(let e=0;;){if("..."==i&&e>0&&e+3==t.length){o=1;break}let r=/^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(i);if(!r)throw new RangeError("Invalid path: "+t);if(a.push("*"==r[0]?"":'"'==r[0][0]?JSON.parse(r[0]):r[0]),e+=r[0].length,e==t.length)break;let s=t[e++];if(e==t.length&&"!"==s){o=0;break}if("/"!=s)throw new RangeError("Invalid path: "+t);i=t.slice(e);}let s=a.length-1,n=a[s];if(!n)throw new RangeError("Invalid path: "+t);let l=new Rule(r,o,s>0?a.slice(0,s):null);e[n]=l.sort(e[n]);}}return ruleNodeProp.add(e)}const ruleNodeProp=new NodeProp;class Rule{constructor(t,e,a,r){this.tags=t,this.mode=e,this.context=a,this.next=r;}get opaque(){return 0==this.mode}get inherit(){return 1==this.mode}sort(t){return !t||t.depth<this.depth?(this.next=t,this):(t.next=this.sort(t.next),t)}get depth(){return this.context?this.context.length:0}}function tagHighlighter(t,e){let a=Object.create(null);for(let e of t)if(Array.isArray(e.tag))for(let t of e.tag)a[t.id]=e.class;else a[e.tag.id]=e.class;let{scope:r,all:o=null}=e||{};return {style:t=>{let e=o;for(let r of t)for(let t of r.set){let r=a[t.id];if(r){e=e?e+" "+r:r;break}}return e},scope:r}}function highlightTags(t,e){let a=null;for(let r of t){let t=r.style(e);t&&(a=a?a+" "+t:t);}return a}function highlightTree(t,e,a,r=0,o=t.length){let i=new HighlightBuilder(r,Array.isArray(e)?e:[e],a);i.highlightRange(t.cursor(),r,o,"",i.highlighters),i.flush(o);}Rule.empty=new Rule([],2,null);class HighlightBuilder{constructor(t,e,a){this.at=t,this.highlighters=e,this.span=a,this.class="";}startSpan(t,e){e!=this.class&&(this.flush(t),t>this.at&&(this.at=t),this.class=e);}flush(t){t>this.at&&this.class&&this.span(this.at,t,this.class);}highlightRange(t,e,a,r,o){let{type:i,from:s,to:n}=t;if(s>=a||n<=e)return;i.isTop&&(o=this.highlighters.filter((t=>!t.scope||t.scope(i))));let l=r,g=getStyleTags(t)||Rule.empty,h=highlightTags(o,g.tags);if(h&&(l&&(l+=" "),l+=h,1==g.mode&&(r+=(r?" ":"")+h)),this.startSpan(Math.max(e,s),l),g.opaque)return;let c=t.tree&&t.tree.prop(NodeProp.mounted);if(c&&c.overlay){let i=t.node.enter(c.overlay[0].from+s,1),g=this.highlighters.filter((t=>!t.scope||t.scope(c.tree.type))),h=t.firstChild();for(let d=0,m=s;;d++){let p=d<c.overlay.length?c.overlay[d]:null,f=p?p.from+s:n,u=Math.max(e,m),k=Math.min(a,f);if(u<k&&h)for(;t.from<k&&(this.highlightRange(t,u,k,r,o),this.startSpan(Math.min(k,t.to),l),!(t.to>=f)&&t.nextSibling()););if(!p||f>a)break;m=p.to+s,m>e&&(this.highlightRange(i.cursor(),Math.max(e,p.from+s),Math.min(a,m),"",g),this.startSpan(Math.min(a,m),l));}h&&t.parent();}else if(t.firstChild()){c&&(r="");do{if(!(t.to<=e)){if(t.from>=a)break;this.highlightRange(t,e,a,r,o),this.startSpan(Math.min(a,t.to),l);}}while(t.nextSibling());t.parent();}}}function getStyleTags(t){let e=t.type.prop(ruleNodeProp);for(;e&&e.context&&!t.matchContext(e.context);)e=e.next;return e||null}const t=Tag.define,comment=t(),name=t(),typeName=t(name),propertyName=t(name),literal=t(),string=t(literal),number=t(literal),content=t(),heading=t(content),keyword$1=t(),operator=t(),punctuation=t(),bracket=t(punctuation),meta=t(),tags$1={comment:comment,lineComment:t(comment),blockComment:t(comment),docComment:t(comment),name:name,variableName:t(name),typeName:typeName,tagName:t(typeName),propertyName:propertyName,attributeName:t(propertyName),className:t(name),labelName:t(name),namespace:t(name),macroName:t(name),literal:literal,string:string,docString:t(string),character:t(string),attributeValue:t(string),number:number,integer:t(number),float:t(number),bool:t(literal),regexp:t(literal),escape:t(literal),color:t(literal),url:t(literal),keyword:keyword$1,self:t(keyword$1),null:t(keyword$1),atom:t(keyword$1),unit:t(keyword$1),modifier:t(keyword$1),operatorKeyword:t(keyword$1),controlKeyword:t(keyword$1),definitionKeyword:t(keyword$1),moduleKeyword:t(keyword$1),operator:operator,derefOperator:t(operator),arithmeticOperator:t(operator),logicOperator:t(operator),bitwiseOperator:t(operator),compareOperator:t(operator),updateOperator:t(operator),definitionOperator:t(operator),typeOperator:t(operator),controlOperator:t(operator),punctuation:punctuation,separator:t(punctuation),bracket:bracket,angleBracket:t(bracket),squareBracket:t(bracket),paren:t(bracket),brace:t(bracket),content:content,heading:heading,heading1:t(heading),heading2:t(heading),heading3:t(heading),heading4:t(heading),heading5:t(heading),heading6:t(heading),contentSeparator:t(content),list:t(content),quote:t(content),emphasis:t(content),strong:t(content),link:t(content),monospace:t(content),strikethrough:t(content),inserted:t(),deleted:t(),changed:t(),invalid:t(),meta:meta,documentMeta:t(meta),annotation:t(meta),processingInstruction:t(meta),definition:Tag.defineModifier(),constant:Tag.defineModifier(),function:Tag.defineModifier(),standard:Tag.defineModifier(),local:Tag.defineModifier(),special:Tag.defineModifier()};tagHighlighter([{tag:tags$1.link,class:"tok-link"},{tag:tags$1.heading,class:"tok-heading"},{tag:tags$1.emphasis,class:"tok-emphasis"},{tag:tags$1.strong,class:"tok-strong"},{tag:tags$1.keyword,class:"tok-keyword"},{tag:tags$1.atom,class:"tok-atom"},{tag:tags$1.bool,class:"tok-bool"},{tag:tags$1.url,class:"tok-url"},{tag:tags$1.labelName,class:"tok-labelName"},{tag:tags$1.inserted,class:"tok-inserted"},{tag:tags$1.deleted,class:"tok-deleted"},{tag:tags$1.literal,class:"tok-literal"},{tag:tags$1.string,class:"tok-string"},{tag:tags$1.number,class:"tok-number"},{tag:[tags$1.regexp,tags$1.escape,tags$1.special(tags$1.string)],class:"tok-string2"},{tag:tags$1.variableName,class:"tok-variableName"},{tag:tags$1.local(tags$1.variableName),class:"tok-variableName tok-local"},{tag:tags$1.definition(tags$1.variableName),class:"tok-variableName tok-definition"},{tag:tags$1.special(tags$1.variableName),class:"tok-variableName2"},{tag:tags$1.definition(tags$1.propertyName),class:"tok-propertyName tok-definition"},{tag:tags$1.typeName,class:"tok-typeName"},{tag:tags$1.namespace,class:"tok-namespace"},{tag:tags$1.className,class:"tok-className"},{tag:tags$1.macroName,class:"tok-macroName"},{tag:tags$1.propertyName,class:"tok-propertyName"},{tag:tags$1.operator,class:"tok-operator"},{tag:tags$1.comment,class:"tok-comment"},{tag:tags$1.meta,class:"tok-meta"},{tag:tags$1.invalid,class:"tok-invalid"},{tag:tags$1.punctuation,class:"tok-punctuation"}]);

    var _a;const languageDataProp=new NodeProp;function defineLanguageFacet(t){return Facet.define({combine:t?e=>e.concat(t):void 0})}const sublanguageProp=new NodeProp;class Language{constructor(t,e,n=[],r=""){this.data=t,this.name=r,EditorState.prototype.hasOwnProperty("tree")||Object.defineProperty(EditorState.prototype,"tree",{get(){return syntaxTree(this)}}),this.parser=e,this.extension=[language.of(this),EditorState.languageData.of(((t,e,n)=>{let r=topNodeAt(t,e,n),i=r.type.prop(languageDataProp);if(!i)return [];let o=t.facet(i),s=r.type.prop(sublanguageProp);if(s){let i=r.resolve(e-r.from,n);for(let e of s)if(e.test(i,t)){let n=t.facet(e.facet);return "replace"==e.type?n:n.concat(o)}}return o}))].concat(n);}isActiveAt(t,e,n=-1){return topNodeAt(t,e,n).type.prop(languageDataProp)==this.data}findRegions(t){let e=t.facet(language);if((null==e?void 0:e.data)==this.data)return [{from:0,to:t.doc.length}];if(!e||!e.allowsNesting)return [];let n=[],r=(t,e)=>{if(t.prop(languageDataProp)==this.data)return void n.push({from:e,to:e+t.length});let i=t.prop(NodeProp.mounted);if(i){if(i.tree.prop(languageDataProp)==this.data){if(i.overlay)for(let t of i.overlay)n.push({from:t.from+e,to:t.to+e});else n.push({from:e,to:e+t.length});return}if(i.overlay){let t=n.length;if(r(i.tree,i.overlay[0].from+e),n.length>t)return}}for(let n=0;n<t.children.length;n++){let i=t.children[n];i instanceof Tree&&r(i,t.positions[n]+e);}};return r(syntaxTree(t),0),n}get allowsNesting(){return !0}}function topNodeAt(t,e,n){let r=t.facet(language),i=syntaxTree(t).topNode;if(!r||r.allowsNesting)for(let t=i;t;t=t.enter(e,n,IterMode.ExcludeBuffers))t.type.isTop&&(i=t);return i}Language.setState=StateEffect.define();class LRLanguage extends Language{constructor(t,e,n){super(t,e,[],n),this.parser=e;}static define(t){let e=defineLanguageFacet(t.languageData);return new LRLanguage(e,t.parser.configure({props:[languageDataProp.add((t=>t.isTop?e:void 0))]}),t.name)}configure(t,e){return new LRLanguage(this.data,this.parser.configure(t),e||this.name)}get allowsNesting(){return this.parser.hasWrappers()}}function syntaxTree(t){let e=t.field(Language.state,!1);return e?e.tree:Tree.empty}function ensureSyntaxTree(t,e,n=50){var r;let i=null===(r=t.field(Language.state,!1))||void 0===r?void 0:r.context;if(!i)return null;let o=i.viewport;i.updateViewport({from:0,to:e});let s=i.isDone(e)||i.work(n,e)?i.tree:null;return i.updateViewport(o),s}function forceParsing(t,e=t.viewport.to,n=100){let r=ensureSyntaxTree(t.state,e,n);return r!=syntaxTree(t.state)&&t.dispatch({}),!!r}class DocInput{constructor(t){this.doc=t,this.cursorPos=0,this.string="",this.cursor=t.iter();}get length(){return this.doc.length}syncTo(t){return this.string=this.cursor.next(t-this.cursorPos).value,this.cursorPos=t+this.string.length,this.cursorPos-this.string.length}chunk(t){return this.syncTo(t),this.string}get lineChunks(){return !0}read(t,e){let n=this.cursorPos-this.string.length;return t<n||e>=this.cursorPos?this.doc.sliceString(t,e):this.string.slice(t-n,e-n)}}let currentContext=null;class ParseContext{constructor(t,e,n=[],r,i,o,s,a){this.parser=t,this.state=e,this.fragments=n,this.tree=r,this.treeLen=i,this.viewport=o,this.skipped=s,this.scheduleOn=a,this.parse=null,this.tempSkipped=[];}static create(t,e,n){return new ParseContext(t,e,[],Tree.empty,0,n,[],null)}startParse(){return this.parser.startParse(new DocInput(this.state.doc),this.fragments)}work(t,e){return null!=e&&e>=this.state.doc.length&&(e=void 0),this.tree!=Tree.empty&&this.isDone(null!=e?e:this.state.doc.length)?(this.takeTree(),!0):this.withContext((()=>{var n;if("number"==typeof t){let e=Date.now()+t;t=()=>Date.now()>e;}for(this.parse||(this.parse=this.startParse()),null!=e&&(null==this.parse.stoppedAt||this.parse.stoppedAt>e)&&e<this.state.doc.length&&this.parse.stopAt(e);;){let r=this.parse.advance();if(r){if(this.fragments=this.withoutTempSkipped(TreeFragment.addTree(r,this.fragments,null!=this.parse.stoppedAt)),this.treeLen=null!==(n=this.parse.stoppedAt)&&void 0!==n?n:this.state.doc.length,this.tree=r,this.parse=null,!(this.treeLen<(null!=e?e:this.state.doc.length)))return !0;this.parse=this.startParse();}if(t())return !1}}))}takeTree(){let t,e;this.parse&&(t=this.parse.parsedPos)>=this.treeLen&&((null==this.parse.stoppedAt||this.parse.stoppedAt>t)&&this.parse.stopAt(t),this.withContext((()=>{for(;!(e=this.parse.advance()););})),this.treeLen=t,this.tree=e,this.fragments=this.withoutTempSkipped(TreeFragment.addTree(this.tree,this.fragments,!0)),this.parse=null);}withContext(t){let e=currentContext;currentContext=this;try{return t()}finally{currentContext=e;}}withoutTempSkipped(t){for(let e;e=this.tempSkipped.pop();)t=cutFragments(t,e.from,e.to);return t}changes(t,e){let{fragments:n,tree:r,treeLen:i,viewport:o,skipped:s}=this;if(this.takeTree(),!t.empty){let e=[];if(t.iterChangedRanges(((t,n,r,i)=>e.push({fromA:t,toA:n,fromB:r,toB:i}))),n=TreeFragment.applyChanges(n,e),r=Tree.empty,i=0,o={from:t.mapPos(o.from,-1),to:t.mapPos(o.to,1)},this.skipped.length){s=[];for(let e of this.skipped){let n=t.mapPos(e.from,1),r=t.mapPos(e.to,-1);n<r&&s.push({from:n,to:r});}}}return new ParseContext(this.parser,e,n,r,i,o,s,this.scheduleOn)}updateViewport(t){if(this.viewport.from==t.from&&this.viewport.to==t.to)return !1;this.viewport=t;let e=this.skipped.length;for(let e=0;e<this.skipped.length;e++){let{from:n,to:r}=this.skipped[e];n<t.to&&r>t.from&&(this.fragments=cutFragments(this.fragments,n,r),this.skipped.splice(e--,1));}return !(this.skipped.length>=e)&&(this.reset(),!0)}reset(){this.parse&&(this.takeTree(),this.parse=null);}skipUntilInView(t,e){this.skipped.push({from:t,to:e});}static getSkippingParser(t){return new class extends Parser{createParse(e,n,r){let i=r[0].from,o=r[r.length-1].to;return {parsedPos:i,advance(){let e=currentContext;if(e){for(let t of r)e.tempSkipped.push(t);t&&(e.scheduleOn=e.scheduleOn?Promise.all([e.scheduleOn,t]):t);}return this.parsedPos=o,new Tree(NodeType.none,[],[],o-i)},stoppedAt:null,stopAt(){}}}}}isDone(t){t=Math.min(t,this.state.doc.length);let e=this.fragments;return this.treeLen>=t&&e.length&&0==e[0].from&&e[0].to>=t}static get(){return currentContext}}function cutFragments(t,e,n){return TreeFragment.applyChanges(t,[{fromA:e,toA:n,fromB:e,toB:n}])}class LanguageState{constructor(t){this.context=t,this.tree=t.tree;}apply(t){if(!t.docChanged&&this.tree==this.context.tree)return this;let e=this.context.changes(t.changes,t.state),n=this.context.treeLen==t.startState.doc.length?void 0:Math.max(t.changes.mapPos(this.context.treeLen),e.viewport.to);return e.work(20,n)||e.takeTree(),new LanguageState(e)}static init(t){let e=Math.min(3e3,t.doc.length),n=ParseContext.create(t.facet(language).parser,t,{from:0,to:e});return n.work(20,e)||n.takeTree(),new LanguageState(n)}}Language.state=StateField.define({create:LanguageState.init,update(t,e){for(let t of e.effects)if(t.is(Language.setState))return t.value;return e.startState.facet(language)!=e.state.facet(language)?LanguageState.init(e.state):t.apply(e)}});let requestIdle=t=>{let e=setTimeout((()=>t()),500);return ()=>clearTimeout(e)};"undefined"!=typeof requestIdleCallback&&(requestIdle=t=>{let e=-1,n=setTimeout((()=>{e=requestIdleCallback(t,{timeout:400});}),100);return ()=>e<0?clearTimeout(n):cancelIdleCallback(e)});const isInputPending="undefined"!=typeof navigator&&(null===(_a=navigator.scheduling)||void 0===_a?void 0:_a.isInputPending)?()=>navigator.scheduling.isInputPending():null,parseWorker=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.working=null,this.workScheduled=0,this.chunkEnd=-1,this.chunkBudget=-1,this.work=this.work.bind(this),this.scheduleWork();}update(t){let e=this.view.state.field(Language.state).context;(e.updateViewport(t.view.viewport)||this.view.viewport.to>e.treeLen)&&this.scheduleWork(),t.docChanged&&(this.view.hasFocus&&(this.chunkBudget+=50),this.scheduleWork()),this.checkAsyncSchedule(e);}scheduleWork(){if(this.working)return;let{state:t}=this.view,e=t.field(Language.state);e.tree==e.context.tree&&e.context.isDone(t.doc.length)||(this.working=requestIdle(this.work));}work(t){this.working=null;let e=Date.now();if(this.chunkEnd<e&&(this.chunkEnd<0||this.view.hasFocus)&&(this.chunkEnd=e+3e4,this.chunkBudget=3e3),this.chunkBudget<=0)return;let{state:n,viewport:{to:r}}=this.view,i=n.field(Language.state);if(i.tree==i.context.tree&&i.context.isDone(r+1e5))return;let o=Date.now()+Math.min(this.chunkBudget,100,t&&!isInputPending?Math.max(25,t.timeRemaining()-5):1e9),s=i.context.treeLen<r&&n.doc.length>r+1e3,a=i.context.work((()=>isInputPending&&isInputPending()||Date.now()>o),r+(s?0:1e5));this.chunkBudget-=Date.now()-e,(a||this.chunkBudget<=0)&&(i.context.takeTree(),this.view.dispatch({effects:Language.setState.of(new LanguageState(i.context))})),this.chunkBudget>0&&(!a||s)&&this.scheduleWork(),this.checkAsyncSchedule(i.context);}checkAsyncSchedule(t){t.scheduleOn&&(this.workScheduled++,t.scheduleOn.then((()=>this.scheduleWork())).catch((t=>logException(this.view.state,t))).then((()=>this.workScheduled--)),t.scheduleOn=null);}destroy(){this.working&&this.working();}isWorking(){return !!(this.working||this.workScheduled>0)}},{eventHandlers:{focus(){this.scheduleWork();}}}),language=Facet.define({combine:t=>t.length?t[0]:null,enables:t=>[Language.state,parseWorker,EditorView.contentAttributes.compute([t],(e=>{let n=e.facet(t);return n&&n.name?{"data-language":n.name}:{}}))]});class LanguageSupport{constructor(t,e=[]){this.language=t,this.support=e,this.extension=[t,e];}}const indentService=Facet.define(),indentUnit=Facet.define({combine:t=>{if(!t.length)return "  ";let e=t[0];if(!e||/\S/.test(e)||Array.from(e).some((t=>t!=e[0])))throw new Error("Invalid indent unit: "+JSON.stringify(t[0]));return e}});function getIndentUnit(t){let e=t.facet(indentUnit);return 9==e.charCodeAt(0)?t.tabSize*e.length:e.length}function indentString(t,e){let n="",r=t.tabSize,i=t.facet(indentUnit)[0];if("\t"==i){for(;e>=r;)n+="\t",e-=r;i=" ";}for(let t=0;t<e;t++)n+=i;return n}function getIndentation(t,e){t instanceof EditorState&&(t=new IndentContext(t));for(let n of t.state.facet(indentService)){let r=n(t,e);if(void 0!==r)return r}let n=syntaxTree(t.state);return n?syntaxIndentation(t,n,e):null}function indentRange(t,e,n){let r=Object.create(null),i=new IndentContext(t,{overrideIndentation:t=>{var e;return null!==(e=r[t])&&void 0!==e?e:-1}}),o=[];for(let s=e;s<=n;){let e=t.doc.lineAt(s);s=e.to+1;let n=getIndentation(i,e.from);if(null==n)continue;/\S/.test(e.text)||(n=0);let a=/^\s*/.exec(e.text)[0],l=indentString(t,n);a!=l&&(r[e.from]=n,o.push({from:e.from,to:e.from+a.length,insert:l}));}return t.changes(o)}class IndentContext{constructor(t,e={}){this.state=t,this.options=e,this.unit=getIndentUnit(t);}lineAt(t,e=1){let n=this.state.doc.lineAt(t),{simulateBreak:r,simulateDoubleBreak:i}=this.options;return null!=r&&r>=n.from&&r<=n.to?i&&r==t?{text:"",from:t}:(e<0?r<t:r<=t)?{text:n.text.slice(r-n.from),from:r}:{text:n.text.slice(0,r-n.from),from:n.from}:n}textAfterPos(t,e=1){if(this.options.simulateDoubleBreak&&t==this.options.simulateBreak)return "";let{text:n,from:r}=this.lineAt(t,e);return n.slice(t-r,Math.min(n.length,t+100-r))}column(t,e=1){let{text:n,from:r}=this.lineAt(t,e),i=this.countColumn(n,t-r),o=this.options.overrideIndentation?this.options.overrideIndentation(r):-1;return o>-1&&(i+=o-this.countColumn(n,n.search(/\S|$/))),i}countColumn(t,e=t.length){return countColumn(t,this.state.tabSize,e)}lineIndent(t,e=1){let{text:n,from:r}=this.lineAt(t,e),i=this.options.overrideIndentation;if(i){let t=i(r);if(t>-1)return t}return this.countColumn(n,n.search(/\S|$/))}get simulatedBreak(){return this.options.simulateBreak||null}}const indentNodeProp=new NodeProp;function syntaxIndentation(t,e,n){return indentFrom(e.resolveInner(n).enterUnfinishedNodesBefore(n),n,t)}function ignoreClosed(t){return t.pos==t.options.simulateBreak&&t.options.simulateDoubleBreak}function indentStrategy(t){let e=t.type.prop(indentNodeProp);if(e)return e;let n,r=t.firstChild;if(r&&(n=r.type.prop(NodeProp.closedBy))){let e=t.lastChild,r=e&&n.indexOf(e.name)>-1;return t=>delimitedStrategy$1(t,!0,1,void 0,r&&!ignoreClosed(t)?e.from:void 0)}return null==t.parent?topIndent:null}function indentFrom(t,e,n){for(;t;t=t.parent){let r=indentStrategy(t);if(r)return r(TreeIndentContext.create(n,e,t))}return null}function topIndent(){return 0}class TreeIndentContext extends IndentContext{constructor(t,e,n){super(t.state,t.options),this.base=t,this.pos=e,this.node=n;}static create(t,e,n){return new TreeIndentContext(t,e,n)}get textAfter(){return this.textAfterPos(this.pos)}get baseIndent(){return this.baseIndentFor(this.node)}baseIndentFor(t){let e=this.state.doc.lineAt(t.from);for(;;){let n=t.resolve(e.from);for(;n.parent&&n.parent.from==n.from;)n=n.parent;if(isParent(n,t))break;e=this.state.doc.lineAt(n.from);}return this.lineIndent(e.from)}continue(){let t=this.node.parent;return t?indentFrom(t,this.pos,this.base):0}}function isParent(t,e){for(let n=e;n;n=n.parent)if(t==n)return !0;return !1}function bracketedAligned$1(t){let e=t.node,n=e.childAfter(e.from),r=e.lastChild;if(!n)return null;let i=t.options.simulateBreak,o=t.state.doc.lineAt(n.from),s=null==i||i<=o.from?o.to:Math.min(o.to,i);for(let t=n.to;;){let i=e.childAfter(t);if(!i||i==r)return null;if(!i.type.isSkipped)return i.from<s?n:null;t=i.to;}}function delimitedIndent({closing:t,align:e=!0,units:n=1}){return r=>delimitedStrategy$1(r,e,n,t)}function delimitedStrategy$1(t,e,n,r,i){let o=t.textAfter,s=o.match(/^\s*/)[0].length,a=r&&o.slice(s,s+r.length)==r||i==t.pos+s,l=e?bracketedAligned$1(t):null;return l?a?t.column(l.from):t.column(l.to):t.baseIndent+(a?0:t.unit*n)}const flatIndent=t=>t.baseIndent;function continuedIndent({except:t,units:e=1}={}){return n=>{let r=t&&t.test(n.textAfter);return n.baseIndent+(r?0:e*n.unit)}}function indentOnInput(){return EditorState.transactionFilter.of((t=>{if(!t.docChanged||!t.isUserEvent("input.type")&&!t.isUserEvent("input.complete"))return t;let e=t.startState.languageDataAt("indentOnInput",t.startState.selection.main.head);if(!e.length)return t;let n=t.newDoc,{head:r}=t.newSelection.main,i=n.lineAt(r);if(r>i.from+200)return t;let o=n.sliceString(i.from,r);if(!e.some((t=>t.test(o))))return t;let{state:s}=t,a=-1,l=[];for(let{head:t}of s.selection.ranges){let e=s.doc.lineAt(t);if(e.from==a)continue;a=e.from;let n=getIndentation(s,e.from);if(null==n)continue;let r=/^\s*/.exec(e.text)[0],i=indentString(s,n);r!=i&&l.push({from:e.from,to:e.from+r.length,insert:i});}return l.length?[t,{changes:l,sequential:!0}]:t}))}const foldService=Facet.define(),foldNodeProp=new NodeProp;function foldInside(t){let e=t.firstChild,n=t.lastChild;return e&&e.to<n.from?{from:e.to,to:n.type.isError?t.to:n.from}:null}function syntaxFolding(t,e,n){let r=syntaxTree(t);if(r.length<n)return null;let i=null;for(let o=r.resolveInner(n,1);o;o=o.parent){if(o.to<=n||o.from>n)continue;if(i&&o.from<e)break;let s=o.type.prop(foldNodeProp);if(s&&(o.to<r.length-50||r.length==t.doc.length||!isUnfinished(o))){let r=s(o,t);r&&r.from<=n&&r.from>=e&&r.to>n&&(i=r);}}return i}function isUnfinished(t){let e=t.lastChild;return e&&e.to==t.to&&e.type.isError}function foldable(t,e,n){for(let r of t.facet(foldService)){let i=r(t,e,n);if(i)return i}return syntaxFolding(t,e,n)}function mapRange(t,e){let n=e.mapPos(t.from,1),r=e.mapPos(t.to,-1);return n>=r?void 0:{from:n,to:r}}const foldEffect=StateEffect.define({map:mapRange}),unfoldEffect=StateEffect.define({map:mapRange});function selectedLines(t){let e=[];for(let{head:n}of t.state.selection.ranges)e.some((t=>t.from<=n&&t.to>=n))||e.push(t.lineBlockAt(n));return e}const foldState=StateField.define({create:()=>Decoration.none,update(t,e){t=t.map(e.changes);for(let n of e.effects)n.is(foldEffect)&&!foldExists(t,n.value.from,n.value.to)?t=t.update({add:[foldWidget.range(n.value.from,n.value.to)]}):n.is(unfoldEffect)&&(t=t.update({filter:(t,e)=>n.value.from!=t||n.value.to!=e,filterFrom:n.value.from,filterTo:n.value.to}));if(e.selection){let n=!1,{head:r}=e.selection.main;t.between(r,r,((t,e)=>{t<r&&e>r&&(n=!0);})),n&&(t=t.update({filterFrom:r,filterTo:r,filter:(t,e)=>e<=r||t>=r}));}return t},provide:t=>EditorView.decorations.from(t),toJSON(t,e){let n=[];return t.between(0,e.doc.length,((t,e)=>{n.push(t,e);})),n},fromJSON(t){if(!Array.isArray(t)||t.length%2)throw new RangeError("Invalid JSON for fold state");let e=[];for(let n=0;n<t.length;){let r=t[n++],i=t[n++];if("number"!=typeof r||"number"!=typeof i)throw new RangeError("Invalid JSON for fold state");e.push(foldWidget.range(r,i));}return Decoration.set(e,!0)}});function findFold(t,e,n){var r;let i=null;return null===(r=t.field(foldState,!1))||void 0===r||r.between(e,n,((t,e)=>{(!i||i.from>t)&&(i={from:t,to:e});})),i}function foldExists(t,e,n){let r=!1;return t.between(e,e,((t,i)=>{t==e&&i==n&&(r=!0);})),r}function maybeEnable(t,e){return t.field(foldState,!1)?e:e.concat(StateEffect.appendConfig.of(codeFolding()))}const foldCode=t=>{for(let e of selectedLines(t)){let n=foldable(t.state,e.from,e.to);if(n)return t.dispatch({effects:maybeEnable(t.state,[foldEffect.of(n),announceFold(t,n)])}),!0}return !1},unfoldCode=t=>{if(!t.state.field(foldState,!1))return !1;let e=[];for(let n of selectedLines(t)){let r=findFold(t.state,n.from,n.to);r&&e.push(unfoldEffect.of(r),announceFold(t,r,!1));}return e.length&&t.dispatch({effects:e}),e.length>0};function announceFold(t,e,n=!0){let r=t.state.doc.lineAt(e.from).number,i=t.state.doc.lineAt(e.to).number;return EditorView.announce.of(`${t.state.phrase(n?"Folded lines":"Unfolded lines")} ${r} ${t.state.phrase("to")} ${i}.`)}const foldAll=t=>{let{state:e}=t,n=[];for(let r=0;r<e.doc.length;){let i=t.lineBlockAt(r),o=foldable(e,i.from,i.to);o&&n.push(foldEffect.of(o)),r=(o?t.lineBlockAt(o.to):i).to+1;}return n.length&&t.dispatch({effects:maybeEnable(t.state,n)}),!!n.length},unfoldAll=t=>{let e=t.state.field(foldState,!1);if(!e||!e.size)return !1;let n=[];return e.between(0,t.state.doc.length,((t,e)=>{n.push(unfoldEffect.of({from:t,to:e}));})),t.dispatch({effects:n}),!0};const foldKeymap=[{key:"Ctrl-Shift-[",mac:"Cmd-Alt-[",run:foldCode},{key:"Ctrl-Shift-]",mac:"Cmd-Alt-]",run:unfoldCode},{key:"Ctrl-Alt-[",run:foldAll},{key:"Ctrl-Alt-]",run:unfoldAll}],defaultConfig={placeholderDOM:null,placeholderText:"…"},foldConfig=Facet.define({combine:t=>combineConfig(t,defaultConfig)});function codeFolding(t){let e=[foldState,baseTheme$1$1];return t&&e.push(foldConfig.of(t)),e}const foldWidget=Decoration.replace({widget:new class extends WidgetType{toDOM(t){let{state:e}=t,n=e.facet(foldConfig),r=e=>{let n=t.lineBlockAt(t.posAtDOM(e.target)),r=findFold(t.state,n.from,n.to);r&&t.dispatch({effects:unfoldEffect.of(r)}),e.preventDefault();};if(n.placeholderDOM)return n.placeholderDOM(t,r);let i=document.createElement("span");return i.textContent=n.placeholderText,i.setAttribute("aria-label",e.phrase("folded code")),i.title=e.phrase("unfold"),i.className="cm-foldPlaceholder",i.onclick=r,i}}}),foldGutterDefaults={openText:"⌄",closedText:"›",markerDOM:null,domEventHandlers:{},foldingChanged:()=>!1};class FoldMarker extends GutterMarker{constructor(t,e){super(),this.config=t,this.open=e;}eq(t){return this.config==t.config&&this.open==t.open}toDOM(t){if(this.config.markerDOM)return this.config.markerDOM(this.open);let e=document.createElement("span");return e.textContent=this.open?this.config.openText:this.config.closedText,e.title=t.state.phrase(this.open?"Fold line":"Unfold line"),e}}function foldGutter(t={}){let e=Object.assign(Object.assign({},foldGutterDefaults),t),n=new FoldMarker(e,!0),r=new FoldMarker(e,!1),i=ViewPlugin.fromClass(class{constructor(t){this.from=t.viewport.from,this.markers=this.buildMarkers(t);}update(t){(t.docChanged||t.viewportChanged||t.startState.facet(language)!=t.state.facet(language)||t.startState.field(foldState,!1)!=t.state.field(foldState,!1)||syntaxTree(t.startState)!=syntaxTree(t.state)||e.foldingChanged(t))&&(this.markers=this.buildMarkers(t.view));}buildMarkers(t){let e=new RangeSetBuilder;for(let i of t.viewportLineBlocks){let o=findFold(t.state,i.from,i.to)?r:foldable(t.state,i.from,i.to)?n:null;o&&e.add(i.from,i.from,o);}return e.finish()}}),{domEventHandlers:o}=e;return [i,gutter({class:"cm-foldGutter",markers(t){var e;return (null===(e=t.plugin(i))||void 0===e?void 0:e.markers)||RangeSet.empty},initialSpacer:()=>new FoldMarker(e,!1),domEventHandlers:Object.assign(Object.assign({},o),{click:(t,e,n)=>{if(o.click&&o.click(t,e,n))return !0;let r=findFold(t.state,e.from,e.to);if(r)return t.dispatch({effects:unfoldEffect.of(r)}),!0;let i=foldable(t.state,e.from,e.to);return !!i&&(t.dispatch({effects:foldEffect.of(i)}),!0)}})}),codeFolding()]}const baseTheme$1$1=EditorView.baseTheme({".cm-foldPlaceholder":{backgroundColor:"#eee",border:"1px solid #ddd",color:"#888",borderRadius:".2em",margin:"0 1px",padding:"0 1px",cursor:"pointer"},".cm-foldGutter span":{padding:"0 1px",cursor:"pointer"}});class HighlightStyle{constructor(t,e){let n;function r(t){let e=StyleModule.newName();return (n||(n=Object.create(null)))["."+e]=t,e}this.specs=t;const i="string"==typeof e.all?e.all:e.all?r(e.all):void 0,o=e.scope;this.scope=o instanceof Language?t=>t.prop(languageDataProp)==o.data:o?t=>t==o:void 0,this.style=tagHighlighter(t.map((t=>({tag:t.tag,class:t.class||r(Object.assign({},t,{tag:null}))}))),{all:i}).style,this.module=n?new StyleModule(n):null,this.themeType=e.themeType;}static define(t,e){return new HighlightStyle(t,e||{})}}const highlighterFacet=Facet.define(),fallbackHighlighter=Facet.define({combine:t=>t.length?[t[0]]:null});function getHighlighters(t){let e=t.facet(highlighterFacet);return e.length?e:t.facet(fallbackHighlighter)}function syntaxHighlighting(t,e){let n,r=[treeHighlighter];return t instanceof HighlightStyle&&(t.module&&r.push(EditorView.styleModule.of(t.module)),n=t.themeType),(null==e?void 0:e.fallback)?r.push(fallbackHighlighter.of(t)):n?r.push(highlighterFacet.computeN([EditorView.darkTheme],(e=>e.facet(EditorView.darkTheme)==("dark"==n)?[t]:[]))):r.push(highlighterFacet.of(t)),r}class TreeHighlighter{constructor(t){this.markCache=Object.create(null),this.tree=syntaxTree(t.state),this.decorations=this.buildDeco(t,getHighlighters(t.state));}update(t){let e=syntaxTree(t.state),n=getHighlighters(t.state),r=n!=getHighlighters(t.startState);e.length<t.view.viewport.to&&!r&&e.type==this.tree.type?this.decorations=this.decorations.map(t.changes):(e!=this.tree||t.viewportChanged||r)&&(this.tree=e,this.decorations=this.buildDeco(t.view,n));}buildDeco(t,e){if(!e||!this.tree.length)return Decoration.none;let n=new RangeSetBuilder;for(let{from:r,to:i}of t.visibleRanges)highlightTree(this.tree,e,((t,e,r)=>{n.add(t,e,this.markCache[r]||(this.markCache[r]=Decoration.mark({class:r})));}),r,i);return n.finish()}}const treeHighlighter=Prec.high(ViewPlugin.fromClass(TreeHighlighter,{decorations:t=>t.decorations})),defaultHighlightStyle=HighlightStyle.define([{tag:tags$1.meta,color:"#404740"},{tag:tags$1.link,textDecoration:"underline"},{tag:tags$1.heading,textDecoration:"underline",fontWeight:"bold"},{tag:tags$1.emphasis,fontStyle:"italic"},{tag:tags$1.strong,fontWeight:"bold"},{tag:tags$1.strikethrough,textDecoration:"line-through"},{tag:tags$1.keyword,color:"#708"},{tag:[tags$1.atom,tags$1.bool,tags$1.url,tags$1.contentSeparator,tags$1.labelName],color:"#219"},{tag:[tags$1.literal,tags$1.inserted],color:"#164"},{tag:[tags$1.string,tags$1.deleted],color:"#a11"},{tag:[tags$1.regexp,tags$1.escape,tags$1.special(tags$1.string)],color:"#e40"},{tag:tags$1.definition(tags$1.variableName),color:"#00f"},{tag:tags$1.local(tags$1.variableName),color:"#30a"},{tag:[tags$1.typeName,tags$1.namespace],color:"#085"},{tag:tags$1.className,color:"#167"},{tag:[tags$1.special(tags$1.variableName),tags$1.macroName],color:"#256"},{tag:tags$1.definition(tags$1.propertyName),color:"#00c"},{tag:tags$1.comment,color:"#940"},{tag:tags$1.invalid,color:"#f00"}]),baseTheme$4=EditorView.baseTheme({"&.cm-focused .cm-matchingBracket":{backgroundColor:"#328c8252"},"&.cm-focused .cm-nonmatchingBracket":{backgroundColor:"#bb555544"}}),bracketMatchingConfig=Facet.define({combine:t=>combineConfig(t,{afterCursor:!0,brackets:"()[]{}",maxScanDistance:1e4,renderMatch:defaultRenderMatch})}),matchingMark=Decoration.mark({class:"cm-matchingBracket"}),nonmatchingMark=Decoration.mark({class:"cm-nonmatchingBracket"});function defaultRenderMatch(t){let e=[],n=t.matched?matchingMark:nonmatchingMark;return e.push(n.range(t.start.from,t.start.to)),t.end&&e.push(n.range(t.end.from,t.end.to)),e}const bracketMatchingState=StateField.define({create:()=>Decoration.none,update(t,e){if(!e.docChanged&&!e.selection)return t;let n=[],r=e.state.facet(bracketMatchingConfig);for(let t of e.state.selection.ranges){if(!t.empty)continue;let i=matchBrackets(e.state,t.head,-1,r)||t.head>0&&matchBrackets(e.state,t.head-1,1,r)||r.afterCursor&&(matchBrackets(e.state,t.head,1,r)||t.head<e.state.doc.length&&matchBrackets(e.state,t.head+1,-1,r));i&&(n=n.concat(r.renderMatch(i,e.state)));}return Decoration.set(n,!0)},provide:t=>EditorView.decorations.from(t)}),bracketMatchingUnique=[bracketMatchingState,baseTheme$4];function bracketMatching(t={}){return [bracketMatchingConfig.of(t),bracketMatchingUnique]}const bracketMatchingHandle=new NodeProp;function matchingNodes(t,e,n){let r=t.prop(e<0?NodeProp.openedBy:NodeProp.closedBy);if(r)return r;if(1==t.name.length){let r=n.indexOf(t.name);if(r>-1&&r%2==(e<0?1:0))return [n[r+e]]}return null}function findHandle(t){let e=t.type.prop(bracketMatchingHandle);return e?e(t.node):t}function matchBrackets(t,e,n,r={}){let i=r.maxScanDistance||1e4,o=r.brackets||"()[]{}",s=syntaxTree(t),a=s.resolveInner(e,n);for(let r=a;r;r=r.parent){let i=matchingNodes(r.type,n,o);if(i&&r.from<r.to){let s=findHandle(r);if(s&&(n>0?e>=s.from&&e<s.to:e>s.from&&e<=s.to))return matchMarkedBrackets(t,e,n,r,s,i,o)}}return matchPlainBrackets(t,e,n,s,a.type,i,o)}function matchMarkedBrackets(t,e,n,r,i,o,s){let a=r.parent,l={from:i.from,to:i.to},h=0,d=null==a?void 0:a.cursor();if(d&&(n<0?d.childBefore(r.from):d.childAfter(r.to)))do{if(n<0?d.to<=r.from:d.from>=r.to){if(0==h&&o.indexOf(d.type.name)>-1&&d.from<d.to){let t=findHandle(d);return {start:l,end:t?{from:t.from,to:t.to}:void 0,matched:!0}}if(matchingNodes(d.type,n,s))h++;else if(matchingNodes(d.type,-n,s)){if(0==h){let t=findHandle(d);return {start:l,end:t&&t.from<t.to?{from:t.from,to:t.to}:void 0,matched:!1}}h--;}}}while(n<0?d.prevSibling():d.nextSibling());return {start:l,matched:!1}}function matchPlainBrackets(t,e,n,r,i,o,s){let a=n<0?t.sliceDoc(e-1,e):t.sliceDoc(e,e+1),l=s.indexOf(a);if(l<0||l%2==0!=n>0)return null;let h={from:n<0?e-1:e,to:n>0?e+1:e},d=t.doc.iterRange(e,n>0?t.doc.length:0),u=0;for(let t=0;!d.next().done&&t<=o;){let o=d.value;n<0&&(t+=o.length);let a=e+t*n;for(let t=n>0?0:o.length-1,e=n>0?o.length:-1;t!=e;t+=n){let e=s.indexOf(o[t]);if(!(e<0||r.resolveInner(a+t,1).type!=i))if(e%2==0==n>0)u++;else {if(1==u)return {start:h,end:{from:a+t,to:a+t+1},matched:e>>1==l>>1};u--;}}n>0&&(t+=o.length);}return d.done?{start:h,matched:!1}:null}const noTokens=Object.create(null),typeArray=[NodeType.none];new NodeSet(typeArray);const warned=[],defaultTable=Object.create(null);for(let[t,e]of [["variable","variableName"],["variable-2","variableName.special"],["string-2","string.special"],["def","variableName.definition"],["tag","tagName"],["attribute","attributeName"],["type","typeName"],["builtin","variableName.standard"],["qualifier","modifier"],["error","invalid"],["header","heading"],["property","propertyName"]])defaultTable[t]=createTokenType(noTokens,e);class TokenTable{constructor(t){this.extra=t,this.table=Object.assign(Object.create(null),defaultTable);}resolve(t){return t?this.table[t]||(this.table[t]=createTokenType(this.extra,t)):0}}new TokenTable(noTokens);function warnForPart(t,e){warned.indexOf(t)>-1||(warned.push(t),console.warn(e));}function createTokenType(t,e){let n=null;for(let r of e.split(".")){let e=t[r]||tags$1[r];e?"function"==typeof e?n?n=e(n):warnForPart(r,`Modifier ${r} used at start of tag`):n?warnForPart(r,`Tag ${r} used as modifier`):n=e:warnForPart(r,`Unknown highlighting tag ${r}`);}if(!n)return 0;let r=e.replace(/ /g,"_"),i=NodeType.define({id:typeArray.length,name:r,props:[styleTags({[r]:n})]});return typeArray.push(i),i.id}

    class CompletionContext{constructor(e,t,o){this.state=e,this.pos=t,this.explicit=o,this.abortListeners=[];}tokenBefore(e){let t=syntaxTree(this.state).resolveInner(this.pos,-1);for(;t&&e.indexOf(t.name)<0;)t=t.parent;return t?{from:t.from,to:this.pos,text:this.state.sliceDoc(t.from,this.pos),type:t.type}:null}matchBefore(e){let t=this.state.doc.lineAt(this.pos),o=Math.max(t.from,this.pos-250),n=t.text.slice(o-t.from,this.pos-t.from),i=n.search(ensureAnchor(e,!1));return i<0?null:{from:o+i,to:this.pos,text:n.slice(i)}}get aborted(){return null==this.abortListeners}addEventListener(e,t){"abort"==e&&this.abortListeners&&this.abortListeners.push(t);}}function toSet(e){let t=Object.keys(e).join(""),o=/\w/.test(t);return o&&(t=t.replace(/\w/g,"")),`[${o?"\\w":""}${t.replace(/[^\w\s]/g,"\\$&")}]`}function prefixMatch(e){let t=Object.create(null),o=Object.create(null);for(let{label:n}of e){t[n[0]]=!0;for(let e=1;e<n.length;e++)o[n[e]]=!0;}let n=toSet(t)+toSet(o)+"*$";return [new RegExp("^"+n),new RegExp(n)]}function completeFromList(e){let t=e.map((e=>"string"==typeof e?{label:e}:e)),[o,n]=t.every((e=>/^\w+$/.test(e.label)))?[/\w*$/,/\w+$/]:prefixMatch(t);return e=>{let i=e.matchBefore(n);return i||e.explicit?{from:i?i.from:e.pos,options:t,validFor:o}:null}}function ifNotIn(e,t){return o=>{for(let t=syntaxTree(o.state).resolveInner(o.pos,-1);t;t=t.parent){if(e.indexOf(t.name)>-1)return null;if(t.type.isTop)break}return t(o)}}class Option{constructor(e,t,o,n){this.completion=e,this.source=t,this.match=o,this.score=n;}}function cur(e){return e.selection.main.from}function ensureAnchor(e,t){var o;let{source:n}=e,i=t&&"^"!=n[0],s="$"!=n[n.length-1];return i||s?new RegExp(`${i?"^":""}(?:${n})${s?"$":""}`,null!==(o=e.flags)&&void 0!==o?o:e.ignoreCase?"i":""):e}const pickedCompletion=Annotation.define();function insertCompletionText(e,t,o,n){let{main:i}=e.selection,s=o-i.from,l=n-i.from;return Object.assign(Object.assign({},e.changeByRange((r=>r!=i&&o!=n&&e.sliceDoc(r.from+s,r.from+l)!=e.sliceDoc(o,n)?{range:r}:{changes:{from:r.from+s,to:n==i.from?r.to:r.from+l,insert:t},range:EditorSelection.cursor(r.from+s+t.length)}))),{userEvent:"input.complete"})}const SourceCache=new WeakMap;function asSource(e){if(!Array.isArray(e))return e;let t=SourceCache.get(e);return t||SourceCache.set(e,t=completeFromList(e)),t}const startCompletionEffect=StateEffect.define(),closeCompletionEffect=StateEffect.define();class FuzzyMatcher{constructor(e){this.pattern=e,this.chars=[],this.folded=[],this.any=[],this.precise=[],this.byWord=[];for(let t=0;t<e.length;){let o=codePointAt(e,t),n=codePointSize(o);this.chars.push(o);let i=e.slice(t,t+n),s=i.toUpperCase();this.folded.push(codePointAt(s==i?i.toLowerCase():s,0)),t+=n;}this.astral=e.length!=this.chars.length;}match(e){if(0==this.pattern.length)return [-100];if(e.length<this.pattern.length)return null;let{chars:t,folded:o,any:n,precise:i,byWord:s}=this;if(1==t.length){let n=codePointAt(e,0),i=codePointSize(n),s=i==e.length?0:-100;if(n==t[0]);else {if(n!=o[0])return null;s+=-200;}return [s,0,i]}let l=e.indexOf(this.pattern);if(0==l)return [e.length==this.pattern.length?0:-100,0,this.pattern.length];let r=t.length,a=0;if(l<0){for(let i=0,s=Math.min(e.length,200);i<s&&a<r;){let s=codePointAt(e,i);s!=t[a]&&s!=o[a]||(n[a++]=i),i+=codePointSize(s);}if(a<r)return null}let c=0,p=0,d=!1,f=0,h=-1,u=-1,m=/[a-z]/.test(e),g=!0;for(let n=0,a=Math.min(e.length,200),v=0;n<a&&p<r;){let a=codePointAt(e,n);l<0&&(c<r&&a==t[c]&&(i[c++]=n),f<r&&(a==t[f]||a==o[f]?(0==f&&(h=n),u=n+1,f++):f=0));let C,S=a<255?a>=48&&a<=57||a>=97&&a<=122?2:a>=65&&a<=90?1:0:(C=fromCodePoint(a))!=C.toLowerCase()?1:C!=C.toUpperCase()?2:0;(!n||1==S&&m||0==v&&0!=S)&&(t[p]==a||o[p]==a&&(d=!0)?s[p++]=n:s.length&&(g=!1)),v=S,n+=codePointSize(a);}return p==r&&0==s[0]&&g?this.result((d?-200:0)-100,s,e):f==r&&0==h?[-200-e.length+(u==e.length?0:-100),0,u]:l>-1?[-700-e.length,l,l+this.pattern.length]:f==r?[-900-e.length,h,u]:p==r?this.result((d?-200:0)-100-700+(g?0:-1100),s,e):2==t.length?null:this.result((n[0]?-700:0)-200-1100,n,e)}result(e,t,o){let n=[e-o.length],i=1;for(let e of t){let t=e+(this.astral?codePointSize(codePointAt(o,e)):1);i>1&&n[i-1]==e?n[i-1]=t:(n[i++]=e,n[i++]=t);}return n}}const completionConfig=Facet.define({combine:e=>combineConfig(e,{activateOnTyping:!0,selectOnOpen:!0,override:null,closeOnBlur:!0,maxRenderedOptions:100,defaultKeymap:!0,tooltipClass:()=>"",optionClass:()=>"",aboveCursor:!1,icons:!0,addToOptions:[],positionInfo:defaultPositionInfo,compareCompletions:(e,t)=>e.label.localeCompare(t.label),interactionDelay:75},{defaultKeymap:(e,t)=>e&&t,closeOnBlur:(e,t)=>e&&t,icons:(e,t)=>e&&t,tooltipClass:(e,t)=>o=>joinClass(e(o),t(o)),optionClass:(e,t)=>o=>joinClass(e(o),t(o)),addToOptions:(e,t)=>e.concat(t)})});function joinClass(e,t){return e?t?e+" "+t:e:t}function defaultPositionInfo(e,t,o,n,i){let s,l,r=e.textDirection==Direction.RTL,a=r,c=!1,p="top",d=t.left-i.left,f=i.right-t.right,h=n.right-n.left,u=n.bottom-n.top;if(a&&d<Math.min(h,f)?a=!1:!a&&f<Math.min(h,d)&&(a=!0),h<=(a?d:f))s=Math.max(i.top,Math.min(o.top,i.bottom-u))-t.top,l=Math.min(400,a?d:f);else {c=!0,l=Math.min(400,(r?t.right:i.right-t.left)-30);let e=i.bottom-t.bottom;e>=u||e>t.top?s=o.bottom-t.top:(p="bottom",s=t.bottom-o.top);}return {style:`${p}: ${s}px; max-width: ${l}px`,class:"cm-completionInfo-"+(c?r?"left-narrow":"right-narrow":a?"left":"right")}}function optionContent(e){let t=e.addToOptions.slice();return e.icons&&t.push({render(e){let t=document.createElement("div");return t.classList.add("cm-completionIcon"),e.type&&t.classList.add(...e.type.split(/\s+/g).map((e=>"cm-completionIcon-"+e))),t.setAttribute("aria-hidden","true"),t},position:20}),t.push({render(e,t,o){let n=document.createElement("span");n.className="cm-completionLabel";let{label:i}=e,s=0;for(let e=1;e<o.length;){let t=o[e++],l=o[e++];t>s&&n.appendChild(document.createTextNode(i.slice(s,t)));let r=n.appendChild(document.createElement("span"));r.appendChild(document.createTextNode(i.slice(t,l))),r.className="cm-completionMatchedText",s=l;}return s<i.length&&n.appendChild(document.createTextNode(i.slice(s))),n},position:50},{render(e){if(!e.detail)return null;let t=document.createElement("span");return t.className="cm-completionDetail",t.textContent=e.detail,t},position:80}),t.sort(((e,t)=>e.position-t.position)).map((e=>e.render))}function rangeAroundSelected(e,t,o){if(e<=o)return {from:0,to:e};if(t<0&&(t=0),t<=e>>1){let e=Math.floor(t/o);return {from:e*o,to:(e+1)*o}}let n=Math.floor((e-t)/o);return {from:e-(n+1)*o,to:e-n*o}}class CompletionTooltip{constructor(e,t,o){this.view=e,this.stateField=t,this.applyCompletion=o,this.info=null,this.infoDestroy=null,this.placeInfoReq={read:()=>this.measureInfo(),write:e=>this.placeInfo(e),key:this},this.space=null,this.currentClass="";let n=e.state.field(t),{options:i,selected:s}=n.open,l=e.state.facet(completionConfig);this.optionContent=optionContent(l),this.optionClass=l.optionClass,this.tooltipClass=l.tooltipClass,this.range=rangeAroundSelected(i.length,s,l.maxRenderedOptions),this.dom=document.createElement("div"),this.dom.className="cm-tooltip-autocomplete",this.updateTooltipClass(e.state),this.dom.addEventListener("mousedown",(t=>{for(let o,n=t.target;n&&n!=this.dom;n=n.parentNode)if("LI"==n.nodeName&&(o=/-(\d+)$/.exec(n.id))&&+o[1]<i.length)return this.applyCompletion(e,i[+o[1]]),void t.preventDefault()})),this.dom.addEventListener("focusout",(t=>{let o=e.state.field(this.stateField,!1);o&&o.tooltip&&e.state.facet(completionConfig).closeOnBlur&&t.relatedTarget!=e.contentDOM&&e.dispatch({effects:closeCompletionEffect.of(null)});})),this.list=this.dom.appendChild(this.createListBox(i,n.id,this.range)),this.list.addEventListener("scroll",(()=>{this.info&&this.view.requestMeasure(this.placeInfoReq);}));}mount(){this.updateSel();}update(e){var t,o,n;let i=e.state.field(this.stateField),s=e.startState.field(this.stateField);this.updateTooltipClass(e.state),i!=s&&(this.updateSel(),(null===(t=i.open)||void 0===t?void 0:t.disabled)!=(null===(o=s.open)||void 0===o?void 0:o.disabled)&&this.dom.classList.toggle("cm-tooltip-autocomplete-disabled",!!(null===(n=i.open)||void 0===n?void 0:n.disabled)));}updateTooltipClass(e){let t=this.tooltipClass(e);if(t!=this.currentClass){for(let e of this.currentClass.split(" "))e&&this.dom.classList.remove(e);for(let e of t.split(" "))e&&this.dom.classList.add(e);this.currentClass=t;}}positioned(e){this.space=e,this.info&&this.view.requestMeasure(this.placeInfoReq);}updateSel(){let e=this.view.state.field(this.stateField),t=e.open;if((t.selected>-1&&t.selected<this.range.from||t.selected>=this.range.to)&&(this.range=rangeAroundSelected(t.options.length,t.selected,this.view.state.facet(completionConfig).maxRenderedOptions),this.list.remove(),this.list=this.dom.appendChild(this.createListBox(t.options,e.id,this.range)),this.list.addEventListener("scroll",(()=>{this.info&&this.view.requestMeasure(this.placeInfoReq);}))),this.updateSelectedOption(t.selected)){this.destroyInfo();let{completion:o}=t.options[t.selected],{info:n}=o;if(!n)return;let i="string"==typeof n?document.createTextNode(n):n(o);if(!i)return;"then"in i?i.then((t=>{t&&this.view.state.field(this.stateField,!1)==e&&this.addInfoPane(t,o);})).catch((e=>logException(this.view.state,e,"completion info"))):this.addInfoPane(i,o);}}addInfoPane(e,t){this.destroyInfo();let o=this.info=document.createElement("div");if(o.className="cm-tooltip cm-completionInfo",null!=e.nodeType)o.appendChild(e),this.infoDestroy=null;else {let{dom:t,destroy:n}=e;o.appendChild(t),this.infoDestroy=n||null;}this.dom.appendChild(o),this.view.requestMeasure(this.placeInfoReq);}updateSelectedOption(e){let t=null;for(let o=this.list.firstChild,n=this.range.from;o;o=o.nextSibling,n++)"LI"==o.nodeName&&o.id?n==e?o.hasAttribute("aria-selected")||(o.setAttribute("aria-selected","true"),t=o):o.hasAttribute("aria-selected")&&o.removeAttribute("aria-selected"):n--;return t&&scrollIntoView(this.list,t),t}measureInfo(){let e=this.dom.querySelector("[aria-selected]");if(!e||!this.info)return null;let t=this.dom.getBoundingClientRect(),o=this.info.getBoundingClientRect(),n=e.getBoundingClientRect(),i=this.space;if(!i){let e=this.dom.ownerDocument.defaultView||window;i={left:0,top:0,right:e.innerWidth,bottom:e.innerHeight};}return n.top>Math.min(i.bottom,t.bottom)-10||n.bottom<Math.max(i.top,t.top)+10?null:this.view.state.facet(completionConfig).positionInfo(this.view,t,n,o,i)}placeInfo(e){this.info&&(e?(e.style&&(this.info.style.cssText=e.style),this.info.className="cm-tooltip cm-completionInfo "+(e.class||"")):this.info.style.cssText="top: -1e6px");}createListBox(e,t,o){const n=document.createElement("ul");n.id=t,n.setAttribute("role","listbox"),n.setAttribute("aria-expanded","true"),n.setAttribute("aria-label",this.view.state.phrase("Completions"));let i=null;for(let s=o.from;s<o.to;s++){let{completion:l,match:r}=e[s],{section:a}=l;if(a){let e="string"==typeof a?a:a.name;if(e!=i&&(s>o.from||0==o.from))if(i=e,"string"!=typeof a&&a.header)n.appendChild(a.header(a));else {n.appendChild(document.createElement("completion-section")).textContent=e;}}const c=n.appendChild(document.createElement("li"));c.id=t+"-"+s,c.setAttribute("role","option");let p=this.optionClass(l);p&&(c.className=p);for(let e of this.optionContent){let t=e(l,this.view.state,r);t&&c.appendChild(t);}}return o.from&&n.classList.add("cm-completionListIncompleteTop"),o.to<e.length&&n.classList.add("cm-completionListIncompleteBottom"),n}destroyInfo(){this.info&&(this.infoDestroy&&this.infoDestroy(),this.info.remove(),this.info=null);}destroy(){this.destroyInfo();}}function completionTooltip(e,t){return o=>new CompletionTooltip(o,e,t)}function scrollIntoView(e,t){let o=e.getBoundingClientRect(),n=t.getBoundingClientRect();n.top<o.top?e.scrollTop-=o.top-n.top:n.bottom>o.bottom&&(e.scrollTop+=n.bottom-o.bottom);}function score(e){return 100*(e.boost||0)+(e.apply?10:0)+(e.info?5:0)+(e.type?1:0)}function sortOptions(e,t){let o=[],n=null,i=e=>{o.push(e);let{section:t}=e.completion;if(t){n||(n=[]);let e="string"==typeof t?t:t.name;n.some((t=>t.name==e))||n.push("string"==typeof t?{name:e}:t);}};for(let n of e)if(n.hasResult())if(!1===n.result.filter){let e=n.result.getMatch;for(let t of n.result.options){let s=[1e9-o.length];if(e)for(let o of e(t))s.push(o);i(new Option(t,n.source,s,s[0]));}}else {let e,o=new FuzzyMatcher(t.sliceDoc(n.from,n.to));for(let t of n.result.options)(e=o.match(t.label))&&i(new Option(t,n.source,e,e[0]+(t.boost||0)));}if(n){let e=Object.create(null),t=0,i=(e,t)=>{var o,n;return (null!==(o=e.rank)&&void 0!==o?o:1e9)-(null!==(n=t.rank)&&void 0!==n?n:1e9)||(e.name<t.name?-1:1)};for(let o of n.sort(i))t-=1e5,e[o.name]=t;for(let t of o){let{section:o}=t.completion;o&&(t.score+=e["string"==typeof o?o:o.name]);}}let s=[],l=null,r=t.facet(completionConfig).compareCompletions;for(let e of o.sort(((e,t)=>t.score-e.score||r(e.completion,t.completion)))){let t=e.completion;!l||l.label!=t.label||l.detail!=t.detail||null!=l.type&&null!=t.type&&l.type!=t.type||l.apply!=t.apply||l.boost!=t.boost?s.push(e):score(e.completion)>score(l)&&(s[s.length-1]=e),l=e.completion;}return s}class CompletionDialog{constructor(e,t,o,n,i,s){this.options=e,this.attrs=t,this.tooltip=o,this.timestamp=n,this.selected=i,this.disabled=s;}setSelected(e,t){return e==this.selected||e>=this.options.length?this:new CompletionDialog(this.options,makeAttrs(t,e),this.tooltip,this.timestamp,e,this.disabled)}static build(e,t,o,n,i){let s=sortOptions(e,t);if(!s.length)return n&&e.some((e=>1==e.state))?new CompletionDialog(n.options,n.attrs,n.tooltip,n.timestamp,n.selected,!0):null;let l=t.facet(completionConfig).selectOnOpen?0:-1;if(n&&n.selected!=l&&-1!=n.selected){let e=n.options[n.selected].completion;for(let t=0;t<s.length;t++)if(s[t].completion==e){l=t;break}}return new CompletionDialog(s,makeAttrs(o,l),{pos:e.reduce(((e,t)=>t.hasResult()?Math.min(e,t.from):e),1e8),create:completionTooltip(completionState,applyCompletion),above:i.aboveCursor},n?n.timestamp:Date.now(),l,!1)}map(e){return new CompletionDialog(this.options,this.attrs,Object.assign(Object.assign({},this.tooltip),{pos:e.mapPos(this.tooltip.pos)}),this.timestamp,this.selected,this.disabled)}}class CompletionState{constructor(e,t,o){this.active=e,this.id=t,this.open=o;}static start(){return new CompletionState(none$1,"cm-ac-"+Math.floor(2e6*Math.random()).toString(36),null)}update(e){let{state:t}=e,o=t.facet(completionConfig),n=(o.override||t.languageDataAt("autocomplete",cur(t)).map(asSource)).map((t=>(this.active.find((e=>e.source==t))||new ActiveSource(t,this.active.some((e=>0!=e.state))?1:0)).update(e,o)));n.length==this.active.length&&n.every(((e,t)=>e==this.active[t]))&&(n=this.active);let i=this.open;i&&e.docChanged&&(i=i.map(e.changes)),e.selection||n.some((t=>t.hasResult()&&e.changes.touchesRange(t.from,t.to)))||!sameResults(n,this.active)?i=CompletionDialog.build(n,t,this.id,i,o):i&&i.disabled&&!n.some((e=>1==e.state))&&(i=null),!i&&n.every((e=>1!=e.state))&&n.some((e=>e.hasResult()))&&(n=n.map((e=>e.hasResult()?new ActiveSource(e.source,0):e)));for(let t of e.effects)t.is(setSelectedEffect)&&(i=i&&i.setSelected(t.value,this.id));return n==this.active&&i==this.open?this:new CompletionState(n,this.id,i)}get tooltip(){return this.open?this.open.tooltip:null}get attrs(){return this.open?this.open.attrs:baseAttrs}}function sameResults(e,t){if(e==t)return !0;for(let o=0,n=0;;){for(;o<e.length&&!e[o].hasResult;)o++;for(;n<t.length&&!t[n].hasResult;)n++;let i=o==e.length,s=n==t.length;if(i||s)return i==s;if(e[o++].result!=t[n++].result)return !1}}const baseAttrs={"aria-autocomplete":"list"};function makeAttrs(e,t){let o={"aria-autocomplete":"list","aria-haspopup":"listbox","aria-controls":e};return t>-1&&(o["aria-activedescendant"]=e+"-"+t),o}const none$1=[];function getUserEvent(e){return e.isUserEvent("input.type")?"input":e.isUserEvent("delete.backward")?"delete":null}class ActiveSource{constructor(e,t,o=-1){this.source=e,this.state=t,this.explicitPos=o;}hasResult(){return !1}update(e,t){let o=getUserEvent(e),n=this;o?n=n.handleUserEvent(e,o,t):e.docChanged?n=n.handleChange(e):e.selection&&0!=n.state&&(n=new ActiveSource(n.source,0));for(let t of e.effects)if(t.is(startCompletionEffect))n=new ActiveSource(n.source,1,t.value?cur(e.state):-1);else if(t.is(closeCompletionEffect))n=new ActiveSource(n.source,0);else if(t.is(setActiveEffect))for(let e of t.value)e.source==n.source&&(n=e);return n}handleUserEvent(e,t,o){return "delete"!=t&&o.activateOnTyping?new ActiveSource(this.source,1):this.map(e.changes)}handleChange(e){return e.changes.touchesRange(cur(e.startState))?new ActiveSource(this.source,0):this.map(e.changes)}map(e){return e.empty||this.explicitPos<0?this:new ActiveSource(this.source,this.state,e.mapPos(this.explicitPos))}}class ActiveResult extends ActiveSource{constructor(e,t,o,n,i){super(e,2,t),this.result=o,this.from=n,this.to=i;}hasResult(){return !0}handleUserEvent(e,t,o){var n;let i=e.changes.mapPos(this.from),s=e.changes.mapPos(this.to,1),l=cur(e.state);if((this.explicitPos<0?l<=i:l<this.from)||l>s||"delete"==t&&cur(e.startState)==this.from)return new ActiveSource(this.source,"input"==t&&o.activateOnTyping?1:0);let r,a=this.explicitPos<0?-1:e.changes.mapPos(this.explicitPos);return checkValid(this.result.validFor,e.state,i,s)?new ActiveResult(this.source,a,this.result,i,s):this.result.update&&(r=this.result.update(this.result,i,s,new CompletionContext(e.state,l,a>=0)))?new ActiveResult(this.source,a,r,r.from,null!==(n=r.to)&&void 0!==n?n:cur(e.state)):new ActiveSource(this.source,1,a)}handleChange(e){return e.changes.touchesRange(this.from,this.to)?new ActiveSource(this.source,0):this.map(e.changes)}map(e){return e.empty?this:new ActiveResult(this.source,this.explicitPos<0?-1:e.mapPos(this.explicitPos),this.result,e.mapPos(this.from),e.mapPos(this.to,1))}}function checkValid(e,t,o,n){if(!e)return !1;let i=t.sliceDoc(o,n);return "function"==typeof e?e(i,o,n,t):ensureAnchor(e,!0).test(i)}const setActiveEffect=StateEffect.define({map:(e,t)=>e.map((e=>e.map(t)))}),setSelectedEffect=StateEffect.define(),completionState=StateField.define({create:()=>CompletionState.start(),update:(e,t)=>e.update(t),provide:e=>[showTooltip.from(e,(e=>e.tooltip)),EditorView.contentAttributes.from(e,(e=>e.attrs))]});function applyCompletion(e,t){const o=t.completion.apply||t.completion.label;let n=e.state.field(completionState).active.find((e=>e.source==t.source));return n instanceof ActiveResult&&("string"==typeof o?e.dispatch(Object.assign(Object.assign({},insertCompletionText(e.state,o,n.from,n.to)),{annotations:pickedCompletion.of(t.completion)})):o(e,t.completion,n.from,n.to),!0)}function moveCompletionSelection(e,t="option"){return o=>{let n=o.state.field(completionState,!1);if(!n||!n.open||n.open.disabled||Date.now()-n.open.timestamp<o.state.facet(completionConfig).interactionDelay)return !1;let i,s=1;"page"==t&&(i=getTooltip$1(o,n.open.tooltip))&&(s=Math.max(2,Math.floor(i.dom.offsetHeight/i.dom.querySelector("li").offsetHeight)-1));let{length:l}=n.open.options,r=n.open.selected>-1?n.open.selected+s*(e?1:-1):e?0:l-1;return r<0?r="page"==t?0:l-1:r>=l&&(r="page"==t?l-1:0),o.dispatch({effects:setSelectedEffect.of(r)}),!0}}const acceptCompletion=e=>{let t=e.state.field(completionState,!1);return !(e.state.readOnly||!t||!t.open||t.open.selected<0||t.open.disabled||Date.now()-t.open.timestamp<e.state.facet(completionConfig).interactionDelay)&&applyCompletion(e,t.open.options[t.open.selected])},startCompletion=e=>!!e.state.field(completionState,!1)&&(e.dispatch({effects:startCompletionEffect.of(!0)}),!0),closeCompletion=e=>{let t=e.state.field(completionState,!1);return !(!t||!t.active.some((e=>0!=e.state)))&&(e.dispatch({effects:closeCompletionEffect.of(null)}),!0)};class RunningQuery{constructor(e,t){this.active=e,this.context=t,this.time=Date.now(),this.updates=[],this.done=void 0;}}const completionPlugin=ViewPlugin.fromClass(class{constructor(e){this.view=e,this.debounceUpdate=-1,this.running=[],this.debounceAccept=-1,this.composing=0;for(let t of e.state.field(completionState).active)1==t.state&&this.startQuery(t);}update(e){let t=e.state.field(completionState);if(!e.selectionSet&&!e.docChanged&&e.startState.field(completionState)==t)return;let o=e.transactions.some((e=>(e.selection||e.docChanged)&&!getUserEvent(e)));for(let t=0;t<this.running.length;t++){let n=this.running[t];if(o||n.updates.length+e.transactions.length>50&&Date.now()-n.time>1e3){for(let e of n.context.abortListeners)try{e();}catch(e){logException(this.view.state,e);}n.context.abortListeners=null,this.running.splice(t--,1);}else n.updates.push(...e.transactions);}if(this.debounceUpdate>-1&&clearTimeout(this.debounceUpdate),this.debounceUpdate=t.active.some((e=>1==e.state&&!this.running.some((t=>t.active.source==e.source))))?setTimeout((()=>this.startUpdate()),50):-1,0!=this.composing)for(let t of e.transactions)"input"==getUserEvent(t)?this.composing=2:2==this.composing&&t.selection&&(this.composing=3);}startUpdate(){this.debounceUpdate=-1;let{state:e}=this.view,t=e.field(completionState);for(let e of t.active)1!=e.state||this.running.some((t=>t.active.source==e.source))||this.startQuery(e);}startQuery(e){let{state:t}=this.view,o=cur(t),n=new CompletionContext(t,o,e.explicitPos==o),i=new RunningQuery(e,n);this.running.push(i),Promise.resolve(e.source(n)).then((e=>{i.context.aborted||(i.done=e||null,this.scheduleAccept());}),(e=>{this.view.dispatch({effects:closeCompletionEffect.of(null)}),logException(this.view.state,e);}));}scheduleAccept(){this.running.every((e=>void 0!==e.done))?this.accept():this.debounceAccept<0&&(this.debounceAccept=setTimeout((()=>this.accept()),50));}accept(){var e;this.debounceAccept>-1&&clearTimeout(this.debounceAccept),this.debounceAccept=-1;let t=[],o=this.view.state.facet(completionConfig);for(let n=0;n<this.running.length;n++){let i=this.running[n];if(void 0===i.done)continue;if(this.running.splice(n--,1),i.done){let n=new ActiveResult(i.active.source,i.active.explicitPos,i.done,i.done.from,null!==(e=i.done.to)&&void 0!==e?e:cur(i.updates.length?i.updates[0].startState:this.view.state));for(let e of i.updates)n=n.update(e,o);if(n.hasResult()){t.push(n);continue}}let s=this.view.state.field(completionState).active.find((e=>e.source==i.active.source));if(s&&1==s.state)if(null==i.done){let e=new ActiveSource(i.active.source,0);for(let t of i.updates)e=e.update(t,o);1!=e.state&&t.push(e);}else this.startQuery(s);}t.length&&this.view.dispatch({effects:setActiveEffect.of(t)});}},{eventHandlers:{blur(e){let t=this.view.state.field(completionState,!1);if(t&&t.tooltip&&this.view.state.facet(completionConfig).closeOnBlur){let o=t.open&&getTooltip$1(this.view,t.open.tooltip);o&&o.dom.contains(e.relatedTarget)||this.view.dispatch({effects:closeCompletionEffect.of(null)});}},compositionstart(){this.composing=1;},compositionend(){3==this.composing&&setTimeout((()=>this.view.dispatch({effects:startCompletionEffect.of(!1)})),20),this.composing=0;}}}),baseTheme$3=EditorView.baseTheme({".cm-tooltip.cm-tooltip-autocomplete":{"& > ul":{fontFamily:"monospace",whiteSpace:"nowrap",overflow:"hidden auto",maxWidth_fallback:"700px",maxWidth:"min(700px, 95vw)",minWidth:"250px",maxHeight:"10em",height:"100%",listStyle:"none",margin:0,padding:0,"& > li, & > completion-section":{padding:"1px 3px",lineHeight:1.2},"& > li":{overflowX:"hidden",textOverflow:"ellipsis",cursor:"pointer"},"& > completion-section":{display:"list-item",borderBottom:"1px solid silver",paddingLeft:"0.5em",opacity:.7}}},"&light .cm-tooltip-autocomplete ul li[aria-selected]":{background:"#17c",color:"white"},"&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]":{background:"#777"},"&dark .cm-tooltip-autocomplete ul li[aria-selected]":{background:"#347",color:"white"},"&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]":{background:"#444"},".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after":{content:'"···"',opacity:.5,display:"block",textAlign:"center"},".cm-tooltip.cm-completionInfo":{position:"absolute",padding:"3px 9px",width:"max-content",maxWidth:"400px",boxSizing:"border-box"},".cm-completionInfo.cm-completionInfo-left":{right:"100%"},".cm-completionInfo.cm-completionInfo-right":{left:"100%"},".cm-completionInfo.cm-completionInfo-left-narrow":{right:"30px"},".cm-completionInfo.cm-completionInfo-right-narrow":{left:"30px"},"&light .cm-snippetField":{backgroundColor:"#00000022"},"&dark .cm-snippetField":{backgroundColor:"#ffffff22"},".cm-snippetFieldPosition":{verticalAlign:"text-top",width:0,height:"1.15em",display:"inline-block",margin:"0 -0.7px -.7em",borderLeft:"1.4px dotted #888"},".cm-completionMatchedText":{textDecoration:"underline"},".cm-completionDetail":{marginLeft:"0.5em",fontStyle:"italic"},".cm-completionIcon":{fontSize:"90%",width:".8em",display:"inline-block",textAlign:"center",paddingRight:".6em",opacity:"0.6",boxSizing:"content-box"},".cm-completionIcon-function, .cm-completionIcon-method":{"&:after":{content:"'ƒ'"}},".cm-completionIcon-class":{"&:after":{content:"'○'"}},".cm-completionIcon-interface":{"&:after":{content:"'◌'"}},".cm-completionIcon-variable":{"&:after":{content:"'𝑥'"}},".cm-completionIcon-constant":{"&:after":{content:"'𝐶'"}},".cm-completionIcon-type":{"&:after":{content:"'𝑡'"}},".cm-completionIcon-enum":{"&:after":{content:"'∪'"}},".cm-completionIcon-property":{"&:after":{content:"'□'"}},".cm-completionIcon-keyword":{"&:after":{content:"'🔑︎'"}},".cm-completionIcon-namespace":{"&:after":{content:"'▢'"}},".cm-completionIcon-text":{"&:after":{content:"'abc'",fontSize:"50%",verticalAlign:"middle"}}});class FieldPos{constructor(e,t,o,n){this.field=e,this.line=t,this.from=o,this.to=n;}}class FieldRange{constructor(e,t,o){this.field=e,this.from=t,this.to=o;}map(e){let t=e.mapPos(this.from,-1,MapMode.TrackDel),o=e.mapPos(this.to,1,MapMode.TrackDel);return null==t||null==o?null:new FieldRange(this.field,t,o)}}class Snippet{constructor(e,t){this.lines=e,this.fieldPositions=t;}instantiate(e,t){let o=[],n=[t],i=e.doc.lineAt(t),s=/^\s*/.exec(i.text)[0];for(let i of this.lines){if(o.length){let o=s,l=/^\t*/.exec(i)[0].length;for(let t=0;t<l;t++)o+=e.facet(indentUnit);n.push(t+o.length-l),i=o+i.slice(l);}o.push(i),t+=i.length+1;}let l=this.fieldPositions.map((e=>new FieldRange(e.field,n[e.line]+e.from,n[e.line]+e.to)));return {text:o,ranges:l}}static parse(e){let t,o=[],n=[],i=[];for(let s of e.split(/\r\n?|\n/)){for(;t=/[#$]\{(?:(\d+)(?::([^}]*))?|([^}]*))\}/.exec(s);){let e=t[1]?+t[1]:null,l=t[2]||t[3]||"",r=-1;for(let t=0;t<o.length;t++)(null!=e?o[t].seq==e:l&&o[t].name==l)&&(r=t);if(r<0){let t=0;for(;t<o.length&&(null==e||null!=o[t].seq&&o[t].seq<e);)t++;o.splice(t,0,{seq:e,name:l}),r=t;for(let e of i)e.field>=r&&e.field++;}i.push(new FieldPos(r,n.length,t.index,t.index+l.length)),s=s.slice(0,t.index)+l+s.slice(t.index+t[0].length);}for(let e;e=/\\([{}])/.exec(s);){s=s.slice(0,e.index)+e[1]+s.slice(e.index+e[0].length);for(let t of i)t.line==n.length&&t.from>e.index&&(t.from--,t.to--);}n.push(s);}return new Snippet(n,i)}}let fieldMarker=Decoration.widget({widget:new class extends WidgetType{toDOM(){let e=document.createElement("span");return e.className="cm-snippetFieldPosition",e}ignoreEvent(){return !1}}}),fieldRange=Decoration.mark({class:"cm-snippetField"});class ActiveSnippet{constructor(e,t){this.ranges=e,this.active=t,this.deco=Decoration.set(e.map((e=>(e.from==e.to?fieldMarker:fieldRange).range(e.from,e.to))));}map(e){let t=[];for(let o of this.ranges){let n=o.map(e);if(!n)return null;t.push(n);}return new ActiveSnippet(t,this.active)}selectionInsideField(e){return e.ranges.every((e=>this.ranges.some((t=>t.field==this.active&&t.from<=e.from&&t.to>=e.to))))}}const setActive=StateEffect.define({map:(e,t)=>e&&e.map(t)}),moveToField=StateEffect.define(),snippetState=StateField.define({create:()=>null,update(e,t){for(let o of t.effects){if(o.is(setActive))return o.value;if(o.is(moveToField)&&e)return new ActiveSnippet(e.ranges,o.value)}return e&&t.docChanged&&(e=e.map(t.changes)),e&&t.selection&&!e.selectionInsideField(t.selection)&&(e=null),e},provide:e=>EditorView.decorations.from(e,(e=>e?e.deco:Decoration.none))});function fieldSelection(e,t){return EditorSelection.create(e.filter((e=>e.field==t)).map((e=>EditorSelection.range(e.from,e.to))))}function snippet(e){let t=Snippet.parse(e);return (e,o,n,i)=>{let{text:s,ranges:l}=t.instantiate(e.state,n),r={changes:{from:n,to:i,insert:Text$1.of(s)},scrollIntoView:!0,annotations:o?pickedCompletion.of(o):void 0};if(l.length&&(r.selection=fieldSelection(l,0)),l.length>1){let t=new ActiveSnippet(l,0),o=r.effects=[setActive.of(t)];void 0===e.state.field(snippetState,!1)&&o.push(StateEffect.appendConfig.of([snippetState,addSnippetKeymap,snippetPointerHandler,baseTheme$3]));}e.dispatch(e.state.update(r));}}function moveField(e){return ({state:t,dispatch:o})=>{let n=t.field(snippetState,!1);if(!n||e<0&&0==n.active)return !1;let i=n.active+e,s=e>0&&!n.ranges.some((t=>t.field==i+e));return o(t.update({selection:fieldSelection(n.ranges,i),effects:setActive.of(s?null:new ActiveSnippet(n.ranges,i))})),!0}}const clearSnippet=({state:e,dispatch:t})=>!!e.field(snippetState,!1)&&(t(e.update({effects:setActive.of(null)})),!0),nextSnippetField=moveField(1),prevSnippetField=moveField(-1);const defaultSnippetKeymap=[{key:"Tab",run:nextSnippetField,shift:prevSnippetField},{key:"Escape",run:clearSnippet}],snippetKeymap=Facet.define({combine:e=>e.length?e[0]:defaultSnippetKeymap}),addSnippetKeymap=Prec.highest(keymap.compute([snippetKeymap],(e=>e.facet(snippetKeymap))));function snippetCompletion(e,t){return Object.assign(Object.assign({},t),{apply:snippet(e)})}const snippetPointerHandler=EditorView.domEventHandlers({mousedown(e,t){let o,n=t.state.field(snippetState,!1);if(!n||null==(o=t.posAtCoords({x:e.clientX,y:e.clientY})))return !1;let i=n.ranges.find((e=>e.from<=o&&e.to>=o));return !(!i||i.field==n.active)&&(t.dispatch({selection:fieldSelection(n.ranges,i.field),effects:setActive.of(n.ranges.some((e=>e.field>i.field))?new ActiveSnippet(n.ranges,i.field):null)}),!0)}});const defaults={brackets:["(","[","{","'",'"'],before:")]}:;>",stringPrefixes:[]},closeBracketEffect=StateEffect.define({map(e,t){let o=t.mapPos(e,-1,MapMode.TrackAfter);return null==o?void 0:o}}),closedBracket=new class extends RangeValue{};closedBracket.startSide=1,closedBracket.endSide=-1;const bracketState=StateField.define({create:()=>RangeSet.empty,update(e,t){if(t.selection){let o=t.state.doc.lineAt(t.selection.main.head).from,n=t.startState.doc.lineAt(t.startState.selection.main.head).from;o!=t.changes.mapPos(n,-1)&&(e=RangeSet.empty);}e=e.map(t.changes);for(let o of t.effects)o.is(closeBracketEffect)&&(e=e.update({add:[closedBracket.range(o.value,o.value+1)]}));return e}});function closeBrackets(){return [inputHandler,bracketState]}const definedClosing="()[]{}<>";function closing(e){for(let t=0;t<definedClosing.length;t+=2)if(definedClosing.charCodeAt(t)==e)return definedClosing.charAt(t+1);return fromCodePoint(e<128?e:e+1)}function config(e,t){return e.languageDataAt("closeBrackets",t)[0]||defaults}const android$1="object"==typeof navigator&&/Android\b/.test(navigator.userAgent),inputHandler=EditorView.inputHandler.of(((e,t,o,n)=>{if((android$1?e.composing:e.compositionStarted)||e.state.readOnly)return !1;let i=e.state.selection.main;if(n.length>2||2==n.length&&1==codePointSize(codePointAt(n,0))||t!=i.from||o!=i.to)return !1;let s=insertBracket(e.state,n);return !!s&&(e.dispatch(s),!0)})),deleteBracketPair=({state:e,dispatch:t})=>{if(e.readOnly)return !1;let o=config(e,e.selection.main.head).brackets||defaults.brackets,n=null,i=e.changeByRange((t=>{if(t.empty){let n=prevChar(e.doc,t.head);for(let i of o)if(i==n&&nextChar(e.doc,t.head)==closing(codePointAt(i,0)))return {changes:{from:t.head-i.length,to:t.head+i.length},range:EditorSelection.cursor(t.head-i.length)}}return {range:n=t}}));return n||t(e.update(i,{scrollIntoView:!0,userEvent:"delete.backward"})),!n},closeBracketsKeymap=[{key:"Backspace",run:deleteBracketPair}];function insertBracket(e,t){let o=config(e,e.selection.main.head),n=o.brackets||defaults.brackets;for(let i of n){let s=closing(codePointAt(i,0));if(t==i)return s==i?handleSame(e,i,n.indexOf(i+i+i)>-1,o):handleOpen(e,i,s,o.before||defaults.before);if(t==s&&closedBracketAt(e,e.selection.main.from))return handleClose(e,i,s)}return null}function closedBracketAt(e,t){let o=!1;return e.field(bracketState).between(0,e.doc.length,(e=>{e==t&&(o=!0);})),o}function nextChar(e,t){let o=e.sliceString(t,t+2);return o.slice(0,codePointSize(codePointAt(o,0)))}function prevChar(e,t){let o=e.sliceString(t-2,t);return codePointSize(codePointAt(o,0))==o.length?o:o.slice(1)}function handleOpen(e,t,o,n){let i=null,s=e.changeByRange((s=>{if(!s.empty)return {changes:[{insert:t,from:s.from},{insert:o,from:s.to}],effects:closeBracketEffect.of(s.to+t.length),range:EditorSelection.range(s.anchor+t.length,s.head+t.length)};let l=nextChar(e.doc,s.head);return !l||/\s/.test(l)||n.indexOf(l)>-1?{changes:{insert:t+o,from:s.head},effects:closeBracketEffect.of(s.head+t.length),range:EditorSelection.cursor(s.head+t.length)}:{range:i=s}}));return i?null:e.update(s,{scrollIntoView:!0,userEvent:"input.type"})}function handleClose(e,t,o){let n=null,i=e.changeByRange((t=>t.empty&&nextChar(e.doc,t.head)==o?{changes:{from:t.head,to:t.head+o.length,insert:o},range:EditorSelection.cursor(t.head+o.length)}:n={range:t}));return n?null:e.update(i,{scrollIntoView:!0,userEvent:"input.type"})}function handleSame(e,t,o,n){let i=n.stringPrefixes||defaults.stringPrefixes,s=null,l=e.changeByRange((n=>{if(!n.empty)return {changes:[{insert:t,from:n.from},{insert:t,from:n.to}],effects:closeBracketEffect.of(n.to+t.length),range:EditorSelection.range(n.anchor+t.length,n.head+t.length)};let l,r=n.head,a=nextChar(e.doc,r);if(a==t){if(nodeStart(e,r))return {changes:{insert:t+t,from:r},effects:closeBracketEffect.of(r+t.length),range:EditorSelection.cursor(r+t.length)};if(closedBracketAt(e,r)){let n=o&&e.sliceDoc(r,r+3*t.length)==t+t+t?t+t+t:t;return {changes:{from:r,to:r+n.length,insert:n},range:EditorSelection.cursor(r+n.length)}}}else {if(o&&e.sliceDoc(r-2*t.length,r)==t+t&&(l=canStartStringAt(e,r-2*t.length,i))>-1&&nodeStart(e,l))return {changes:{insert:t+t+t+t,from:r},effects:closeBracketEffect.of(r+t.length),range:EditorSelection.cursor(r+t.length)};if(e.charCategorizer(r)(a)!=CharCategory.Word&&canStartStringAt(e,r,i)>-1&&!probablyInString(e,r,t,i))return {changes:{insert:t+t,from:r},effects:closeBracketEffect.of(r+t.length),range:EditorSelection.cursor(r+t.length)}}return {range:s=n}}));return s?null:e.update(l,{scrollIntoView:!0,userEvent:"input.type"})}function nodeStart(e,t){let o=syntaxTree(e).resolveInner(t+1);return o.parent&&o.from==t}function probablyInString(e,t,o,n){let i=syntaxTree(e).resolveInner(t,-1),s=n.reduce(((e,t)=>Math.max(e,t.length)),0);for(let l=0;l<5;l++){let l=e.sliceDoc(i.from,Math.min(i.to,i.from+o.length+s)),r=l.indexOf(o);if(!r||r>-1&&n.indexOf(l.slice(0,r))>-1){let t=i.firstChild;for(;t&&t.from==i.from&&t.to-t.from>o.length+r;){if(e.sliceDoc(t.to-o.length,t.to)==o)return !1;t=t.firstChild;}return !0}let a=i.to==t&&i.parent;if(!a)break;i=a;}return !1}function canStartStringAt(e,t,o){let n=e.charCategorizer(t);if(n(e.sliceDoc(t-1,t))!=CharCategory.Word)return t;for(let i of o){let o=t-i.length;if(e.sliceDoc(o,t)==i&&n(e.sliceDoc(o-1,o))!=CharCategory.Word)return o}return -1}function autocompletion(e={}){return [completionState,completionConfig.of(e),completionPlugin,completionKeymapExt,baseTheme$3]}const completionKeymap=[{key:"Ctrl-Space",run:startCompletion},{key:"Escape",run:closeCompletion},{key:"ArrowDown",run:moveCompletionSelection(!0)},{key:"ArrowUp",run:moveCompletionSelection(!1)},{key:"PageDown",run:moveCompletionSelection(!0,"page")},{key:"PageUp",run:moveCompletionSelection(!1,"page")},{key:"Enter",run:acceptCompletion}],completionKeymapExt=Prec.highest(keymap.computeN([completionConfig],(e=>e.facet(completionConfig).defaultKeymap?[completionKeymap]:[])));

    function crelt(){var e=arguments[0];"string"==typeof e&&(e=document.createElement(e));var r=1,t=arguments[1];if(t&&"object"==typeof t&&null==t.nodeType&&!Array.isArray(t)){for(var n in t)if(Object.prototype.hasOwnProperty.call(t,n)){var o=t[n];"string"==typeof o?e.setAttribute(n,o):null!=o&&(e[n]=o);}r++;}for(;r<arguments.length;r++)add(e,arguments[r]);return e}function add(e,r){if("string"==typeof r)e.appendChild(document.createTextNode(r));else if(null==r);else if(null!=r.nodeType)e.appendChild(r);else {if(!Array.isArray(r))throw new RangeError("Unsupported child node: "+r);for(var t=0;t<r.length;t++)add(e,r[t]);}}

    class SelectedDiagnostic$1{constructor(t,e,i){this.from=t,this.to=e,this.diagnostic=i;}}class LintState{constructor(t,e,i){this.diagnostics=t,this.panel=e,this.selected=i;}static init(t,e,i){let n=t,o=i.facet(lintConfig).markerFilter;o&&(n=o(n));let s=Decoration.set(n.map((t=>t.from==t.to||t.from==t.to-1&&i.doc.lineAt(t.from).to==t.from?Decoration.widget({widget:new DiagnosticWidget(t),diagnostic:t}).range(t.from):Decoration.mark({attributes:{class:"cm-lintRange cm-lintRange-"+t.severity},diagnostic:t}).range(t.from,t.to))),!0);return new LintState(s,e,findDiagnostic$1(s))}}function findDiagnostic$1(t,e=null,i=0){let n=null;return t.between(i,1e9,((t,i,{spec:o})=>{if(!e||o.diagnostic==e)return n=new SelectedDiagnostic$1(t,i,o.diagnostic),!1})),n}function hideTooltip(t,e){let i=t.startState.doc.lineAt(e.pos);return !(!t.effects.some((t=>t.is(setDiagnosticsEffect)))&&!t.changes.touchesRange(i.from,i.to))}function maybeEnableLint(t,e){return t.field(lintState$1,!1)?e:e.concat(StateEffect.appendConfig.of(lintExtensions))}function setDiagnostics(t,e){return {effects:maybeEnableLint(t,[setDiagnosticsEffect.of(e)])}}const setDiagnosticsEffect=StateEffect.define(),togglePanel$1=StateEffect.define(),movePanelSelection=StateEffect.define(),lintState$1=StateField.define({create:()=>new LintState(Decoration.none,null,null),update(t,e){if(e.docChanged){let i=t.diagnostics.map(e.changes),n=null;if(t.selected){let o=e.changes.mapPos(t.selected.from,1);n=findDiagnostic$1(i,t.selected.diagnostic,o)||findDiagnostic$1(i,null,o);}t=new LintState(i,t.panel,n);}for(let i of e.effects)i.is(setDiagnosticsEffect)?t=LintState.init(i.value,t.panel,e.state):i.is(togglePanel$1)?t=new LintState(t.diagnostics,i.value?LintPanel.open:null,t.selected):i.is(movePanelSelection)&&(t=new LintState(t.diagnostics,t.panel,i.value));return t},provide:t=>[showPanel.from(t,(t=>t.panel)),EditorView.decorations.from(t,(t=>t.diagnostics))]});const activeMark=Decoration.mark({class:"cm-lintRange cm-lintRange-active"});function lintTooltip(t,e,i){let{diagnostics:n}=t.state.field(lintState$1),o=[],s=2e8,l=0;n.between(e-(i<0?1:0),e+(i>0?1:0),((t,n,{spec:a})=>{e>=t&&e<=n&&(t==n||(e>t||i>0)&&(e<n||i<0))&&(o.push(a.diagnostic),s=Math.min(t,s),l=Math.max(n,l));}));let a=t.state.facet(lintConfig).tooltipFilter;return a&&(o=a(o)),o.length?{pos:s,end:l,above:t.state.doc.lineAt(s).to<l,create:()=>({dom:diagnosticsTooltip$1(t,o)})}:null}function diagnosticsTooltip$1(t,e){return crelt("ul",{class:"cm-tooltip-lint"},e.map((e=>renderDiagnostic$1(t,e,!1))))}const openLintPanel=t=>{let e=t.state.field(lintState$1,!1);e&&e.panel||t.dispatch({effects:maybeEnableLint(t.state,[togglePanel$1.of(!0)])});let i=getPanel(t,LintPanel.open);return i&&i.dom.querySelector(".cm-panel-lint ul").focus(),!0},closeLintPanel=t=>{let e=t.state.field(lintState$1,!1);return !(!e||!e.panel)&&(t.dispatch({effects:togglePanel$1.of(!1)}),!0)},nextDiagnostic=t=>{let e=t.state.field(lintState$1,!1);if(!e)return !1;let i=t.state.selection.main,n=e.diagnostics.iter(i.to+1);return !(!n.value&&(n=e.diagnostics.iter(0),!n.value||n.from==i.from&&n.to==i.to))&&(t.dispatch({selection:{anchor:n.from,head:n.to},scrollIntoView:!0}),!0)},lintKeymap=[{key:"Mod-Shift-m",run:openLintPanel,preventDefault:!0},{key:"F8",run:nextDiagnostic}],lintPlugin=ViewPlugin.fromClass(class{constructor(t){this.view=t,this.timeout=-1,this.set=!0;let{delay:e}=t.state.facet(lintConfig);this.lintTime=Date.now()+e,this.run=this.run.bind(this),this.timeout=setTimeout(this.run,e);}run(){let t=Date.now();if(t<this.lintTime-10)setTimeout(this.run,this.lintTime-t);else {this.set=!1;let{state:t}=this.view,{sources:e}=t.facet(lintConfig);Promise.all(e.map((t=>Promise.resolve(t(this.view))))).then((e=>{let i=e.reduce(((t,e)=>t.concat(e)));this.view.state.doc==t.doc&&this.view.dispatch(setDiagnostics(this.view.state,i));}),(t=>{logException(this.view.state,t);}));}}update(t){let e=t.state.facet(lintConfig);(t.docChanged||e!=t.startState.facet(lintConfig)||e.needsRefresh&&e.needsRefresh(t))&&(this.lintTime=Date.now()+e.delay,this.set||(this.set=!0,this.timeout=setTimeout(this.run,e.delay)));}force(){this.set&&(this.lintTime=Date.now(),this.run());}destroy(){clearTimeout(this.timeout);}}),lintConfig=Facet.define({combine:t=>Object.assign({sources:t.map((t=>t.source))},combineConfig(t.map((t=>t.config)),{delay:750,markerFilter:null,tooltipFilter:null,needsRefresh:null},{needsRefresh:(t,e)=>t?e?i=>t(i)||e(i):t:e}))});function linter(t,e={}){return [lintConfig.of({source:t,config:e}),lintPlugin,lintExtensions]}function assignKeys$1(t){let e=[];if(t)t:for(let{name:i}of t){for(let t=0;t<i.length;t++){let n=i[t];if(/[a-zA-Z]/.test(n)&&!e.some((t=>t.toLowerCase()==n.toLowerCase()))){e.push(n);continue t}}e.push("");}return e}function renderDiagnostic$1(t,e,i){var n;let o=i?assignKeys$1(e.actions):[];return crelt("li",{class:"cm-diagnostic cm-diagnostic-"+e.severity},crelt("span",{class:"cm-diagnosticText"},e.renderMessage?e.renderMessage():e.message),null===(n=e.actions)||void 0===n?void 0:n.map(((i,n)=>{let s=!1,l=n=>{if(n.preventDefault(),s)return;s=!0;let o=findDiagnostic$1(t.state.field(lintState$1).diagnostics,e);o&&i.apply(t,o.from,o.to);},{name:a}=i,r=o[n]?a.indexOf(o[n]):-1,c=r<0?a:[a.slice(0,r),crelt("u",a.slice(r,r+1)),a.slice(r+1)];return crelt("button",{type:"button",class:"cm-diagnosticAction",onclick:l,onmousedown:l,"aria-label":` Action: ${a}${r<0?"":` (access key "${o[n]})"`}.`},c)})),e.source&&crelt("div",{class:"cm-diagnosticSource"},e.source))}class DiagnosticWidget extends WidgetType{constructor(t){super(),this.diagnostic=t;}eq(t){return t.diagnostic==this.diagnostic}toDOM(){return crelt("span",{class:"cm-lintPoint cm-lintPoint-"+this.diagnostic.severity})}}class PanelItem{constructor(t,e){this.diagnostic=e,this.id="item_"+Math.floor(4294967295*Math.random()).toString(16),this.dom=renderDiagnostic$1(t,e,!0),this.dom.id=this.id,this.dom.setAttribute("role","option");}}class LintPanel{constructor(t){this.view=t,this.items=[];this.list=crelt("ul",{tabIndex:0,role:"listbox","aria-label":this.view.state.phrase("Diagnostics"),onkeydown:e=>{if(27==e.keyCode)closeLintPanel(this.view),this.view.focus();else if(38==e.keyCode||33==e.keyCode)this.moveSelection((this.selectedIndex-1+this.items.length)%this.items.length);else if(40==e.keyCode||34==e.keyCode)this.moveSelection((this.selectedIndex+1)%this.items.length);else if(36==e.keyCode)this.moveSelection(0);else if(35==e.keyCode)this.moveSelection(this.items.length-1);else if(13==e.keyCode)this.view.focus();else {if(!(e.keyCode>=65&&e.keyCode<=90&&this.selectedIndex>=0))return;{let{diagnostic:i}=this.items[this.selectedIndex],n=assignKeys$1(i.actions);for(let o=0;o<n.length;o++)if(n[o].toUpperCase().charCodeAt(0)==e.keyCode){let e=findDiagnostic$1(this.view.state.field(lintState$1).diagnostics,i);e&&i.actions[o].apply(t,e.from,e.to);}}}e.preventDefault();},onclick:t=>{for(let e=0;e<this.items.length;e++)this.items[e].dom.contains(t.target)&&this.moveSelection(e);}}),this.dom=crelt("div",{class:"cm-panel-lint"},this.list,crelt("button",{type:"button",name:"close","aria-label":this.view.state.phrase("close"),onclick:()=>closeLintPanel(this.view)},"×")),this.update();}get selectedIndex(){let t=this.view.state.field(lintState$1).selected;if(!t)return -1;for(let e=0;e<this.items.length;e++)if(this.items[e].diagnostic==t.diagnostic)return e;return -1}update(){let{diagnostics:t,selected:e}=this.view.state.field(lintState$1),i=0,n=!1,o=null;for(t.between(0,this.view.state.doc.length,((t,s,{spec:l})=>{let a,r=-1;for(let t=i;t<this.items.length;t++)if(this.items[t].diagnostic==l.diagnostic){r=t;break}r<0?(a=new PanelItem(this.view,l.diagnostic),this.items.splice(i,0,a),n=!0):(a=this.items[r],r>i&&(this.items.splice(i,r-i),n=!0)),e&&a.diagnostic==e.diagnostic?a.dom.hasAttribute("aria-selected")||(a.dom.setAttribute("aria-selected","true"),o=a):a.dom.hasAttribute("aria-selected")&&a.dom.removeAttribute("aria-selected"),i++;}));i<this.items.length&&!(1==this.items.length&&this.items[0].diagnostic.from<0);)n=!0,this.items.pop();0==this.items.length&&(this.items.push(new PanelItem(this.view,{from:-1,to:-1,severity:"info",message:this.view.state.phrase("No diagnostics")})),n=!0),o?(this.list.setAttribute("aria-activedescendant",o.id),this.view.requestMeasure({key:this,read:()=>({sel:o.dom.getBoundingClientRect(),panel:this.list.getBoundingClientRect()}),write:({sel:t,panel:e})=>{t.top<e.top?this.list.scrollTop-=e.top-t.top:t.bottom>e.bottom&&(this.list.scrollTop+=t.bottom-e.bottom);}})):this.selectedIndex<0&&this.list.removeAttribute("aria-activedescendant"),n&&this.sync();}sync(){let t=this.list.firstChild;function e(){let e=t;t=e.nextSibling,e.remove();}for(let i of this.items)if(i.dom.parentNode==this.list){for(;t!=i.dom;)e();t=i.dom.nextSibling;}else this.list.insertBefore(i.dom,t);for(;t;)e();}moveSelection(t){if(this.selectedIndex<0)return;let e=findDiagnostic$1(this.view.state.field(lintState$1).diagnostics,this.items[t].diagnostic);e&&this.view.dispatch({selection:{anchor:e.from,head:e.to},scrollIntoView:!0,effects:movePanelSelection.of(e)});}static open(t){return new LintPanel(t)}}function svg(t,e='viewBox="0 0 40 40"'){return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" ${e}>${encodeURIComponent(t)}</svg>')`}function underline(t){return svg(`<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="${t}" fill="none" stroke-width=".7"/>`,'width="6" height="3"')}const baseTheme$2=EditorView.baseTheme({".cm-diagnostic":{padding:"3px 6px 3px 8px",marginLeft:"-1px",display:"block",whiteSpace:"pre-wrap"},".cm-diagnostic-error":{borderLeft:"5px solid #d11"},".cm-diagnostic-warning":{borderLeft:"5px solid orange"},".cm-diagnostic-info":{borderLeft:"5px solid #999"},".cm-diagnosticAction":{font:"inherit",border:"none",padding:"2px 4px",backgroundColor:"#444",color:"white",borderRadius:"3px",marginLeft:"8px",cursor:"pointer"},".cm-diagnosticSource":{fontSize:"70%",opacity:.7},".cm-lintRange":{backgroundPosition:"left bottom",backgroundRepeat:"repeat-x",paddingBottom:"0.7px"},".cm-lintRange-error":{backgroundImage:underline("#d11")},".cm-lintRange-warning":{backgroundImage:underline("orange")},".cm-lintRange-info":{backgroundImage:underline("#999")},".cm-lintRange-active":{backgroundColor:"#ffdd9980"},".cm-tooltip-lint":{padding:0,margin:0},".cm-lintPoint":{position:"relative","&:after":{content:'""',position:"absolute",bottom:0,left:"-2px",borderLeft:"3px solid transparent",borderRight:"3px solid transparent",borderBottom:"4px solid #d11"}},".cm-lintPoint-warning":{"&:after":{borderBottomColor:"orange"}},".cm-lintPoint-info":{"&:after":{borderBottomColor:"#999"}},".cm-panel.cm-panel-lint":{position:"relative","& ul":{maxHeight:"100px",overflowY:"auto","& [aria-selected]":{backgroundColor:"#ddd","& u":{textDecoration:"underline"}},"&:focus [aria-selected]":{background_fallback:"#bdf",backgroundColor:"Highlight",color_fallback:"white",color:"HighlightText"},"& u":{textDecoration:"none"},padding:0,margin:0},"& [name=close]":{position:"absolute",top:"0",right:"2px",background:"inherit",border:"none",font:"inherit",padding:0,margin:0}}});class LintGutterMarker extends GutterMarker{constructor(t){super(),this.diagnostics=t,this.severity=t.reduce(((t,e)=>{let i=e.severity;return "error"==i||"warning"==i&&"info"==t?i:t}),"info");}toDOM(t){let e=document.createElement("div");e.className="cm-lint-marker cm-lint-marker-"+this.severity;let i=this.diagnostics,n=t.state.facet(lintGutterConfig).tooltipFilter;return n&&(i=n(i)),i.length&&(e.onmouseover=()=>gutterMarkerMouseOver(t,e,i)),e}}function trackHoverOn(t,e){let i=n=>{let o=e.getBoundingClientRect();if(!(n.clientX>o.left-10&&n.clientX<o.right+10&&n.clientY>o.top-10&&n.clientY<o.bottom+10)){for(let t=n.target;t;t=t.parentNode)if(1==t.nodeType&&t.classList.contains("cm-tooltip-lint"))return;window.removeEventListener("mousemove",i),t.state.field(lintGutterTooltip)&&t.dispatch({effects:setLintGutterTooltip.of(null)});}};window.addEventListener("mousemove",i);}function gutterMarkerMouseOver(t,e,i){function n(){let n=t.elementAtHeight(e.getBoundingClientRect().top+5-t.documentTop);t.coordsAtPos(n.from)&&t.dispatch({effects:setLintGutterTooltip.of({pos:n.from,above:!1,create:()=>({dom:diagnosticsTooltip$1(t,i),getCoords:()=>e.getBoundingClientRect()})})}),e.onmouseout=e.onmousemove=null,trackHoverOn(t,e);}let{hoverTime:o}=t.state.facet(lintGutterConfig),s=setTimeout(n,o);e.onmouseout=()=>{clearTimeout(s),e.onmouseout=e.onmousemove=null;},e.onmousemove=()=>{clearTimeout(s),s=setTimeout(n,o);};}function markersForDiagnostics(t,e){let i=Object.create(null);for(let n of e){let e=t.lineAt(n.from);(i[e.from]||(i[e.from]=[])).push(n);}let n=[];for(let t in i)n.push(new LintGutterMarker(i[t]).range(+t));return RangeSet.of(n,!0)}const lintGutterExtension=gutter({class:"cm-gutter-lint",markers:t=>t.state.field(lintGutterMarkers)}),lintGutterMarkers=StateField.define({create:()=>RangeSet.empty,update(t,e){t=t.map(e.changes);let i=e.state.facet(lintGutterConfig).markerFilter;for(let n of e.effects)if(n.is(setDiagnosticsEffect)){let o=n.value;i&&(o=i(o||[])),t=markersForDiagnostics(e.state.doc,o.slice(0));}return t}}),setLintGutterTooltip=StateEffect.define(),lintGutterTooltip=StateField.define({create:()=>null,update:(t,e)=>(t&&e.docChanged&&(t=hideTooltip(e,t)?null:Object.assign(Object.assign({},t),{pos:e.changes.mapPos(t.pos)})),e.effects.reduce(((t,e)=>e.is(setLintGutterTooltip)?e.value:t),t)),provide:t=>showTooltip.from(t)}),lintGutterTheme=EditorView.baseTheme({".cm-gutter-lint":{width:"1.4em","& .cm-gutterElement":{padding:".2em"}},".cm-lint-marker":{width:"1em",height:"1em"},".cm-lint-marker-info":{content:svg('<path fill="#aaf" stroke="#77e" stroke-width="6" stroke-linejoin="round" d="M5 5L35 5L35 35L5 35Z"/>')},".cm-lint-marker-warning":{content:svg('<path fill="#fe8" stroke="#fd7" stroke-width="6" stroke-linejoin="round" d="M20 6L37 35L3 35Z"/>')},".cm-lint-marker-error":{content:svg('<circle cx="20" cy="20" r="15" fill="#f87" stroke="#f43" stroke-width="6"/>')}}),lintExtensions=[lintState$1,EditorView.decorations.compute([lintState$1],(t=>{let{selected:e,panel:i}=t.field(lintState$1);return e&&i&&e.from!=e.to?Decoration.set([activeMark.range(e.from,e.to)]):Decoration.none})),hoverTooltip(lintTooltip,{hideOn:hideTooltip}),baseTheme$2],lintGutterConfig=Facet.define({combine:t=>combineConfig(t,{hoverTime:300,markerFilter:null,tooltipFilter:null})});function lintGutter(t={}){return [lintGutterConfig.of(t),lintGutterMarkers,lintGutterExtension,lintGutterTheme,lintGutterTooltip]}function forEachDiagnostic(t,e){let i=t.field(lintState$1,!1);if(i&&i.diagnostics.size)for(let t=RangeSet.iter([i.diagnostics]);t.value;t.next())e(t.value.spec.diagnostic,t.from,t.to);}

    const toggleComment=e=>{let{state:t}=e,n=t.doc.lineAt(t.selection.main.from),r=getConfig(e.state,n.from);return r.line?toggleLineComment(e):!!r.block&&toggleBlockCommentByLine(e)};function command(e,t){return ({state:n,dispatch:r})=>{if(n.readOnly)return !1;let o=e(t,n);return !!o&&(r(n.update(o)),!0)}}const toggleLineComment=command(changeLineComment,0),toggleBlockComment=command(changeBlockComment,0),toggleBlockCommentByLine=command(((e,t)=>changeBlockComment(e,t,selectedLineRanges(t))),0);function getConfig(e,t){let n=e.languageDataAt("commentTokens",t);return n.length?n[0]:{}}const SearchMargin=50;function findBlockComment(e,{open:t,close:n},r,o){let i,l,a=e.sliceDoc(r-SearchMargin,r),s=e.sliceDoc(o,o+SearchMargin),c=/\s*$/.exec(a)[0].length,d=/^\s*/.exec(s)[0].length,u=a.length-c;if(a.slice(u-t.length,u)==t&&s.slice(d,d+n.length)==n)return {open:{pos:r-c,margin:c&&1},close:{pos:o+d,margin:d&&1}};o-r<=2*SearchMargin?i=l=e.sliceDoc(r,o):(i=e.sliceDoc(r,r+SearchMargin),l=e.sliceDoc(o-SearchMargin,o));let h=/^\s*/.exec(i)[0].length,m=/\s*$/.exec(l)[0].length,f=l.length-m-n.length;return i.slice(h,h+t.length)==t&&l.slice(f,f+n.length)==n?{open:{pos:r+h+t.length,margin:/\s/.test(i.charAt(h+t.length))?1:0},close:{pos:o-m-n.length,margin:/\s/.test(l.charAt(f-1))?1:0}}:null}function selectedLineRanges(e){let t=[];for(let n of e.selection.ranges){let r=e.doc.lineAt(n.from),o=n.to<=r.to?r:e.doc.lineAt(n.to),i=t.length-1;i>=0&&t[i].to>r.from?t[i].to=o.to:t.push({from:r.from+/^\s*/.exec(r.text)[0].length,to:o.to});}return t}function changeBlockComment(e,t,n=t.selection.ranges){let r=n.map((e=>getConfig(t,e.from).block));if(!r.every((e=>e)))return null;let o=n.map(((e,n)=>findBlockComment(t,r[n],e.from,e.to)));if(2!=e&&!o.every((e=>e)))return {changes:t.changes(n.map(((e,t)=>o[t]?[]:[{from:e.from,insert:r[t].open+" "},{from:e.to,insert:" "+r[t].close}])))};if(1!=e&&o.some((e=>e))){let e=[];for(let t,n=0;n<o.length;n++)if(t=o[n]){let o=r[n],{open:i,close:l}=t;e.push({from:i.pos-o.open.length,to:i.pos+i.margin},{from:l.pos-l.margin,to:l.pos+o.close.length});}return {changes:e}}return null}function changeLineComment(e,t,n=t.selection.ranges){let r=[],o=-1;for(let{from:e,to:i}of n){let n=r.length,l=1e9,a=getConfig(t,e).line;if(a){for(let n=e;n<=i;){let s=t.doc.lineAt(n);if(s.from>o&&(e==i||i>s.from)){o=s.from;let e=/^\s*/.exec(s.text)[0].length,t=e==s.length,n=s.text.slice(e,e+a.length)==a?e:-1;e<s.text.length&&e<l&&(l=e),r.push({line:s,comment:n,token:a,indent:e,empty:t,single:!1});}n=s.to+1;}if(l<1e9)for(let e=n;e<r.length;e++)r[e].indent<r[e].line.text.length&&(r[e].indent=l);r.length==n+1&&(r[n].single=!0);}}if(2!=e&&r.some((e=>e.comment<0&&(!e.empty||e.single)))){let e=[];for(let{line:t,token:n,indent:o,empty:i,single:l}of r)!l&&i||e.push({from:t.from+o,insert:n+" "});let n=t.changes(e);return {changes:n,selection:t.selection.map(n,1)}}if(1!=e&&r.some((e=>e.comment>=0))){let e=[];for(let{line:t,comment:n,token:o}of r)if(n>=0){let r=t.from+n,i=r+o.length;" "==t.text[i-t.from]&&i++,e.push({from:r,to:i});}return {changes:e}}return null}const fromHistory=Annotation.define(),isolateHistory=Annotation.define(),invertedEffects=Facet.define(),historyConfig=Facet.define({combine:e=>combineConfig(e,{minDepth:100,newGroupDelay:500,joinToEvent:(e,t)=>t},{minDepth:Math.max,newGroupDelay:Math.min,joinToEvent:(e,t)=>(n,r)=>e(n,r)||t(n,r)})});function changeEnd(e){let t=0;return e.iterChangedRanges(((e,n)=>t=n)),t}const historyField_=StateField.define({create:()=>HistoryState.empty,update(e,t){let n=t.state.facet(historyConfig),r=t.annotation(fromHistory);if(r){let o=t.docChanged?EditorSelection.single(changeEnd(t.changes)):void 0,i=HistEvent.fromTransaction(t,o),l=r.side,a=0==l?e.undone:e.done;return a=i?updateBranch(a,a.length,n.minDepth,i):addSelection(a,t.startState.selection),new HistoryState(0==l?r.rest:a,0==l?a:r.rest)}let o=t.annotation(isolateHistory);if("full"!=o&&"before"!=o||(e=e.isolate()),!1===t.annotation(Transaction.addToHistory))return t.changes.empty?e:e.addMapping(t.changes.desc);let i=HistEvent.fromTransaction(t),l=t.annotation(Transaction.time),a=t.annotation(Transaction.userEvent);return i?e=e.addChanges(i,l,a,n,t):t.selection&&(e=e.addSelection(t.startState.selection,l,a,n.newGroupDelay)),"full"!=o&&"after"!=o||(e=e.isolate()),e},toJSON:e=>({done:e.done.map((e=>e.toJSON())),undone:e.undone.map((e=>e.toJSON()))}),fromJSON:e=>new HistoryState(e.done.map(HistEvent.fromJSON),e.undone.map(HistEvent.fromJSON))});function history(e={}){return [historyField_,historyConfig.of(e),EditorView.domEventHandlers({beforeinput(e,t){let n="historyUndo"==e.inputType?undo:"historyRedo"==e.inputType?redo:null;return !!n&&(e.preventDefault(),n(t))}})]}function cmd(e,t){return function({state:n,dispatch:r}){if(!t&&n.readOnly)return !1;let o=n.field(historyField_,!1);if(!o)return !1;let i=o.pop(e,n,t);return !!i&&(r(i),!0)}}const undo=cmd(0,!1),redo=cmd(1,!1),undoSelection=cmd(0,!0),redoSelection=cmd(1,!0);class HistEvent{constructor(e,t,n,r,o){this.changes=e,this.effects=t,this.mapped=n,this.startSelection=r,this.selectionsAfter=o;}setSelAfter(e){return new HistEvent(this.changes,this.effects,this.mapped,this.startSelection,e)}toJSON(){var e,t,n;return {changes:null===(e=this.changes)||void 0===e?void 0:e.toJSON(),mapped:null===(t=this.mapped)||void 0===t?void 0:t.toJSON(),startSelection:null===(n=this.startSelection)||void 0===n?void 0:n.toJSON(),selectionsAfter:this.selectionsAfter.map((e=>e.toJSON()))}}static fromJSON(e){return new HistEvent(e.changes&&ChangeSet.fromJSON(e.changes),[],e.mapped&&ChangeDesc.fromJSON(e.mapped),e.startSelection&&EditorSelection.fromJSON(e.startSelection),e.selectionsAfter.map(EditorSelection.fromJSON))}static fromTransaction(e,t){let n=none;for(let t of e.startState.facet(invertedEffects)){let r=t(e);r.length&&(n=n.concat(r));}return !n.length&&e.changes.empty?null:new HistEvent(e.changes.invert(e.startState.doc),n,void 0,t||e.startState.selection,none)}static selection(e){return new HistEvent(void 0,none,void 0,void 0,e)}}function updateBranch(e,t,n,r){let o=t+1>n+20?t-n-1:0,i=e.slice(o,t);return i.push(r),i}function isAdjacent(e,t){let n=[],r=!1;return e.iterChangedRanges(((e,t)=>n.push(e,t))),t.iterChangedRanges(((e,t,o,i)=>{for(let e=0;e<n.length;){let t=n[e++],l=n[e++];i>=t&&o<=l&&(r=!0);}})),r}function eqSelectionShape(e,t){return e.ranges.length==t.ranges.length&&0===e.ranges.filter(((e,n)=>e.empty!=t.ranges[n].empty)).length}function conc(e,t){return e.length?t.length?e.concat(t):e:t}const none=[],MaxSelectionsPerEvent=200;function addSelection(e,t){if(e.length){let n=e[e.length-1],r=n.selectionsAfter.slice(Math.max(0,n.selectionsAfter.length-MaxSelectionsPerEvent));return r.length&&r[r.length-1].eq(t)?e:(r.push(t),updateBranch(e,e.length-1,1e9,n.setSelAfter(r)))}return [HistEvent.selection([t])]}function popSelection(e){let t=e[e.length-1],n=e.slice();return n[e.length-1]=t.setSelAfter(t.selectionsAfter.slice(0,t.selectionsAfter.length-1)),n}function addMappingToBranch(e,t){if(!e.length)return e;let n=e.length,r=none;for(;n;){let o=mapEvent(e[n-1],t,r);if(o.changes&&!o.changes.empty||o.effects.length){let t=e.slice(0,n);return t[n-1]=o,t}t=o.mapped,n--,r=o.selectionsAfter;}return r.length?[HistEvent.selection(r)]:none}function mapEvent(e,t,n){let r=conc(e.selectionsAfter.length?e.selectionsAfter.map((e=>e.map(t))):none,n);if(!e.changes)return HistEvent.selection(r);let o=e.changes.map(t),i=t.mapDesc(e.changes,!0),l=e.mapped?e.mapped.composeDesc(i):i;return new HistEvent(o,StateEffect.mapEffects(e.effects,t),l,e.startSelection.map(i),r)}const joinableUserEvent=/^(input\.type|delete)($|\.)/;class HistoryState{constructor(e,t,n=0,r=void 0){this.done=e,this.undone=t,this.prevTime=n,this.prevUserEvent=r;}isolate(){return this.prevTime?new HistoryState(this.done,this.undone):this}addChanges(e,t,n,r,o){let i=this.done,l=i[i.length-1];return i=l&&l.changes&&!l.changes.empty&&e.changes&&(!n||joinableUserEvent.test(n))&&(!l.selectionsAfter.length&&t-this.prevTime<r.newGroupDelay&&r.joinToEvent(o,isAdjacent(l.changes,e.changes))||"input.type.compose"==n)?updateBranch(i,i.length-1,r.minDepth,new HistEvent(e.changes.compose(l.changes),conc(e.effects,l.effects),l.mapped,l.startSelection,none)):updateBranch(i,i.length,r.minDepth,e),new HistoryState(i,none,t,n)}addSelection(e,t,n,r){let o=this.done.length?this.done[this.done.length-1].selectionsAfter:none;return o.length>0&&t-this.prevTime<r&&n==this.prevUserEvent&&n&&/^select($|\.)/.test(n)&&eqSelectionShape(o[o.length-1],e)?this:new HistoryState(addSelection(this.done,e),this.undone,t,n)}addMapping(e){return new HistoryState(addMappingToBranch(this.done,e),addMappingToBranch(this.undone,e),this.prevTime,this.prevUserEvent)}pop(e,t,n){let r=0==e?this.done:this.undone;if(0==r.length)return null;let o=r[r.length-1];if(n&&o.selectionsAfter.length)return t.update({selection:o.selectionsAfter[o.selectionsAfter.length-1],annotations:fromHistory.of({side:e,rest:popSelection(r)}),userEvent:0==e?"select.undo":"select.redo",scrollIntoView:!0});if(o.changes){let n=1==r.length?none:r.slice(0,r.length-1);return o.mapped&&(n=addMappingToBranch(n,o.mapped)),t.update({changes:o.changes,selection:o.startSelection,effects:o.effects,annotations:fromHistory.of({side:e,rest:n}),filter:!1,userEvent:0==e?"undo":"redo",scrollIntoView:!0})}return null}}HistoryState.empty=new HistoryState(none,none);const historyKeymap=[{key:"Mod-z",run:undo,preventDefault:!0},{key:"Mod-y",mac:"Mod-Shift-z",run:redo,preventDefault:!0},{linux:"Ctrl-Shift-z",run:redo,preventDefault:!0},{key:"Mod-u",run:undoSelection,preventDefault:!0},{key:"Alt-u",mac:"Mod-Shift-u",run:redoSelection,preventDefault:!0}];function updateSel(e,t){return EditorSelection.create(e.ranges.map(t),e.mainIndex)}function setSel(e,t){return e.update({selection:t,scrollIntoView:!0,userEvent:"select"})}function moveSel({state:e,dispatch:t},n){let r=updateSel(e.selection,n);return !r.eq(e.selection)&&(t(setSel(e,r)),!0)}function rangeEnd(e,t){return EditorSelection.cursor(t?e.to:e.from)}function cursorByChar(e,t){return moveSel(e,(n=>n.empty?e.moveByChar(n,t):rangeEnd(n,t)))}function ltrAtCursor(e){return e.textDirectionAt(e.state.selection.main.head)==Direction.LTR}const cursorCharLeft=e=>cursorByChar(e,!ltrAtCursor(e)),cursorCharRight=e=>cursorByChar(e,ltrAtCursor(e));function cursorByGroup(e,t){return moveSel(e,(n=>n.empty?e.moveByGroup(n,t):rangeEnd(n,t)))}const cursorGroupLeft=e=>cursorByGroup(e,!ltrAtCursor(e)),cursorGroupRight=e=>cursorByGroup(e,ltrAtCursor(e));function interestingNode(e,t,n){if(t.type.prop(n))return !0;let r=t.to-t.from;return r&&(r>2||/[^\s,.;:]/.test(e.sliceDoc(t.from,t.to)))||t.firstChild}function moveBySyntax(e,t,n){let r,o,i=syntaxTree(e).resolveInner(t.head),l=n?NodeProp.closedBy:NodeProp.openedBy;for(let r=t.head;;){let t=n?i.childAfter(r):i.childBefore(r);if(!t)break;interestingNode(e,t,l)?i=t:r=n?t.to:t.from;}return o=i.type.prop(l)&&(r=n?matchBrackets(e,i.from,1):matchBrackets(e,i.to,-1))&&r.matched?n?r.end.to:r.end.from:n?i.to:i.from,EditorSelection.cursor(o,n?-1:1)}const cursorSyntaxLeft=e=>moveSel(e,(t=>moveBySyntax(e.state,t,!ltrAtCursor(e)))),cursorSyntaxRight=e=>moveSel(e,(t=>moveBySyntax(e.state,t,ltrAtCursor(e))));function cursorByLine(e,t){return moveSel(e,(n=>{if(!n.empty)return rangeEnd(n,t);let r=e.moveVertically(n,t);return r.head!=n.head?r:e.moveToLineBoundary(n,t)}))}const cursorLineUp=e=>cursorByLine(e,!1),cursorLineDown=e=>cursorByLine(e,!0);function pageInfo(e){let t,n=e.scrollDOM.clientHeight<e.scrollDOM.scrollHeight-2,r=0,o=0;if(n){for(let t of e.state.facet(EditorView.scrollMargins)){let n=t(e);(null==n?void 0:n.top)&&(r=Math.max(null==n?void 0:n.top,r)),(null==n?void 0:n.bottom)&&(o=Math.max(null==n?void 0:n.bottom,o));}t=e.scrollDOM.clientHeight-r-o;}else t=(e.dom.ownerDocument.defaultView||window).innerHeight;return {marginTop:r,marginBottom:o,selfScroll:n,height:Math.max(e.defaultLineHeight,t-5)}}function cursorByPage(e,t){let n,r=pageInfo(e),{state:o}=e,i=updateSel(o.selection,(n=>n.empty?e.moveVertically(n,t,r.height):rangeEnd(n,t)));if(i.eq(o.selection))return !1;if(r.selfScroll){let t=e.coordsAtPos(o.selection.main.head),l=e.scrollDOM.getBoundingClientRect(),a=l.top+r.marginTop,s=l.bottom-r.marginBottom;t&&t.top>a&&t.bottom<s&&(n=EditorView.scrollIntoView(i.main.head,{y:"start",yMargin:t.top-a}));}return e.dispatch(setSel(o,i),{effects:n}),!0}const cursorPageUp=e=>cursorByPage(e,!1),cursorPageDown=e=>cursorByPage(e,!0);function moveByLineBoundary(e,t,n){let r=e.lineBlockAt(t.head),o=e.moveToLineBoundary(t,n);if(o.head==t.head&&o.head!=(n?r.to:r.from)&&(o=e.moveToLineBoundary(t,n,!1)),!n&&o.head==r.from&&r.length){let n=/^\s*/.exec(e.state.sliceDoc(r.from,Math.min(r.from+100,r.to)))[0].length;n&&t.head!=r.from+n&&(o=EditorSelection.cursor(r.from+n));}return o}const cursorLineBoundaryForward=e=>moveSel(e,(t=>moveByLineBoundary(e,t,!0))),cursorLineBoundaryBackward=e=>moveSel(e,(t=>moveByLineBoundary(e,t,!1))),cursorLineBoundaryLeft=e=>moveSel(e,(t=>moveByLineBoundary(e,t,!ltrAtCursor(e)))),cursorLineBoundaryRight=e=>moveSel(e,(t=>moveByLineBoundary(e,t,ltrAtCursor(e)))),cursorLineStart=e=>moveSel(e,(t=>EditorSelection.cursor(e.lineBlockAt(t.head).from,1))),cursorLineEnd=e=>moveSel(e,(t=>EditorSelection.cursor(e.lineBlockAt(t.head).to,-1)));function toMatchingBracket(e,t,n){let r=!1,o=updateSel(e.selection,(t=>{let o=matchBrackets(e,t.head,-1)||matchBrackets(e,t.head,1)||t.head>0&&matchBrackets(e,t.head-1,1)||t.head<e.doc.length&&matchBrackets(e,t.head+1,-1);if(!o||!o.end)return t;r=!0;let i=o.start.from==t.head?o.end.to:o.end.from;return n?EditorSelection.range(t.anchor,i):EditorSelection.cursor(i)}));return !!r&&(t(setSel(e,o)),!0)}const cursorMatchingBracket=({state:e,dispatch:t})=>toMatchingBracket(e,t,!1);function extendSel(e,t){let n=updateSel(e.state.selection,(e=>{let n=t(e);return EditorSelection.range(e.anchor,n.head,n.goalColumn,n.bidiLevel||void 0)}));return !n.eq(e.state.selection)&&(e.dispatch(setSel(e.state,n)),!0)}function selectByChar(e,t){return extendSel(e,(n=>e.moveByChar(n,t)))}const selectCharLeft=e=>selectByChar(e,!ltrAtCursor(e)),selectCharRight=e=>selectByChar(e,ltrAtCursor(e));function selectByGroup(e,t){return extendSel(e,(n=>e.moveByGroup(n,t)))}const selectGroupLeft=e=>selectByGroup(e,!ltrAtCursor(e)),selectGroupRight=e=>selectByGroup(e,ltrAtCursor(e));const selectSyntaxLeft=e=>extendSel(e,(t=>moveBySyntax(e.state,t,!ltrAtCursor(e)))),selectSyntaxRight=e=>extendSel(e,(t=>moveBySyntax(e.state,t,ltrAtCursor(e))));function selectByLine(e,t){return extendSel(e,(n=>e.moveVertically(n,t)))}const selectLineUp=e=>selectByLine(e,!1),selectLineDown=e=>selectByLine(e,!0);function selectByPage(e,t){return extendSel(e,(n=>e.moveVertically(n,t,pageInfo(e).height)))}const selectPageUp=e=>selectByPage(e,!1),selectPageDown=e=>selectByPage(e,!0),selectLineBoundaryForward=e=>extendSel(e,(t=>moveByLineBoundary(e,t,!0))),selectLineBoundaryBackward=e=>extendSel(e,(t=>moveByLineBoundary(e,t,!1))),selectLineBoundaryLeft=e=>extendSel(e,(t=>moveByLineBoundary(e,t,!ltrAtCursor(e)))),selectLineBoundaryRight=e=>extendSel(e,(t=>moveByLineBoundary(e,t,ltrAtCursor(e)))),selectLineStart=e=>extendSel(e,(t=>EditorSelection.cursor(e.lineBlockAt(t.head).from))),selectLineEnd=e=>extendSel(e,(t=>EditorSelection.cursor(e.lineBlockAt(t.head).to))),cursorDocStart=({state:e,dispatch:t})=>(t(setSel(e,{anchor:0})),!0),cursorDocEnd=({state:e,dispatch:t})=>(t(setSel(e,{anchor:e.doc.length})),!0),selectDocStart=({state:e,dispatch:t})=>(t(setSel(e,{anchor:e.selection.main.anchor,head:0})),!0),selectDocEnd=({state:e,dispatch:t})=>(t(setSel(e,{anchor:e.selection.main.anchor,head:e.doc.length})),!0),selectAll=({state:e,dispatch:t})=>(t(e.update({selection:{anchor:0,head:e.doc.length},userEvent:"select"})),!0),selectLine=({state:e,dispatch:t})=>{let n=selectedLineBlocks(e).map((({from:t,to:n})=>EditorSelection.range(t,Math.min(n+1,e.doc.length))));return t(e.update({selection:EditorSelection.create(n),userEvent:"select"})),!0},selectParentSyntax=({state:e,dispatch:t})=>{let n=updateSel(e.selection,(t=>{var n;let r=syntaxTree(e).resolveInner(t.head,1);for(;!(r.from<t.from&&r.to>=t.to||r.to>t.to&&r.from<=t.from)&&(null===(n=r.parent)||void 0===n?void 0:n.parent);)r=r.parent;return EditorSelection.range(r.to,r.from)}));return t(setSel(e,n)),!0},simplifySelection=({state:e,dispatch:t})=>{let n=e.selection,r=null;return n.ranges.length>1?r=EditorSelection.create([n.main]):n.main.empty||(r=EditorSelection.create([EditorSelection.cursor(n.main.head)])),!!r&&(t(setSel(e,r)),!0)};function deleteBy(e,t){if(e.state.readOnly)return !1;let n="delete.selection",{state:r}=e,o=r.changeByRange((r=>{let{from:o,to:i}=r;if(o==i){let r=t(o);r<o?(n="delete.backward",r=skipAtomic(e,r,!1)):r>o&&(n="delete.forward",r=skipAtomic(e,r,!0)),o=Math.min(o,r),i=Math.max(i,r);}else o=skipAtomic(e,o,!1),i=skipAtomic(e,i,!0);return o==i?{range:r}:{changes:{from:o,to:i},range:EditorSelection.cursor(o)}}));return !o.changes.empty&&(e.dispatch(r.update(o,{scrollIntoView:!0,userEvent:n,effects:"delete.selection"==n?EditorView.announce.of(r.phrase("Selection deleted")):void 0})),!0)}function skipAtomic(e,t,n){if(e instanceof EditorView)for(let r of e.state.facet(EditorView.atomicRanges).map((t=>t(e))))r.between(t,t,((e,r)=>{e<t&&r>t&&(t=n?r:e);}));return t}const deleteByChar=(e,t)=>deleteBy(e,(n=>{let r,o,{state:i}=e,l=i.doc.lineAt(n);if(!t&&n>l.from&&n<l.from+200&&!/[^ \t]/.test(r=l.text.slice(0,n-l.from))){if("\t"==r[r.length-1])return n-1;let e=countColumn(r,i.tabSize)%getIndentUnit(i)||getIndentUnit(i);for(let t=0;t<e&&" "==r[r.length-1-t];t++)n--;o=n;}else o=findClusterBreak(l.text,n-l.from,t,t)+l.from,o==n&&l.number!=(t?i.doc.lines:1)&&(o+=t?1:-1);return o})),deleteCharBackward=e=>deleteByChar(e,!1),deleteCharForward=e=>deleteByChar(e,!0),deleteByGroup=(e,t)=>deleteBy(e,(n=>{let r=n,{state:o}=e,i=o.doc.lineAt(r),l=o.charCategorizer(r);for(let e=null;;){if(r==(t?i.to:i.from)){r==n&&i.number!=(t?o.doc.lines:1)&&(r+=t?1:-1);break}let a=findClusterBreak(i.text,r-i.from,t)+i.from,s=i.text.slice(Math.min(r,a)-i.from,Math.max(r,a)-i.from),c=l(s);if(null!=e&&c!=e)break;" "==s&&r==n||(e=c),r=a;}return r})),deleteGroupBackward=e=>deleteByGroup(e,!1),deleteGroupForward=e=>deleteByGroup(e,!0),deleteToLineEnd=e=>deleteBy(e,(t=>{let n=e.lineBlockAt(t).to;return t<n?n:Math.min(e.state.doc.length,t+1)})),deleteToLineStart=e=>deleteBy(e,(t=>{let n=e.lineBlockAt(t).from;return t>n?n:Math.max(0,t-1)})),splitLine=({state:e,dispatch:t})=>{if(e.readOnly)return !1;let n=e.changeByRange((e=>({changes:{from:e.from,to:e.to,insert:Text$1.of(["",""])},range:EditorSelection.cursor(e.from)})));return t(e.update(n,{scrollIntoView:!0,userEvent:"input"})),!0},transposeChars=({state:e,dispatch:t})=>{if(e.readOnly)return !1;let n=e.changeByRange((t=>{if(!t.empty||0==t.from||t.from==e.doc.length)return {range:t};let n=t.from,r=e.doc.lineAt(n),o=n==r.from?n-1:findClusterBreak(r.text,n-r.from,!1)+r.from,i=n==r.to?n+1:findClusterBreak(r.text,n-r.from,!0)+r.from;return {changes:{from:o,to:i,insert:e.doc.slice(n,i).append(e.doc.slice(o,n))},range:EditorSelection.cursor(i)}}));return !n.changes.empty&&(t(e.update(n,{scrollIntoView:!0,userEvent:"move.character"})),!0)};function selectedLineBlocks(e){let t=[],n=-1;for(let r of e.selection.ranges){let o=e.doc.lineAt(r.from),i=e.doc.lineAt(r.to);if(r.empty||r.to!=i.from||(i=e.doc.lineAt(r.to-1)),n>=o.number){let e=t[t.length-1];e.to=i.to,e.ranges.push(r);}else t.push({from:o.from,to:i.to,ranges:[r]});n=i.number+1;}return t}function moveLine(e,t,n){if(e.readOnly)return !1;let r=[],o=[];for(let t of selectedLineBlocks(e)){if(n?t.to==e.doc.length:0==t.from)continue;let i=e.doc.lineAt(n?t.to+1:t.from-1),l=i.length+1;if(n){r.push({from:t.to,to:i.to},{from:t.from,insert:i.text+e.lineBreak});for(let n of t.ranges)o.push(EditorSelection.range(Math.min(e.doc.length,n.anchor+l),Math.min(e.doc.length,n.head+l)));}else {r.push({from:i.from,to:t.from},{from:t.to,insert:e.lineBreak+i.text});for(let e of t.ranges)o.push(EditorSelection.range(e.anchor-l,e.head-l));}}return !!r.length&&(t(e.update({changes:r,scrollIntoView:!0,selection:EditorSelection.create(o,e.selection.mainIndex),userEvent:"move.line"})),!0)}const moveLineUp=({state:e,dispatch:t})=>moveLine(e,t,!1),moveLineDown=({state:e,dispatch:t})=>moveLine(e,t,!0);function copyLine(e,t,n){if(e.readOnly)return !1;let r=[];for(let t of selectedLineBlocks(e))n?r.push({from:t.from,insert:e.doc.slice(t.from,t.to)+e.lineBreak}):r.push({from:t.to,insert:e.lineBreak+e.doc.slice(t.from,t.to)});return t(e.update({changes:r,scrollIntoView:!0,userEvent:"input.copyline"})),!0}const copyLineUp=({state:e,dispatch:t})=>copyLine(e,t,!1),copyLineDown=({state:e,dispatch:t})=>copyLine(e,t,!0),deleteLine=e=>{if(e.state.readOnly)return !1;let{state:t}=e,n=t.changes(selectedLineBlocks(t).map((({from:e,to:n})=>(e>0?e--:n<t.doc.length&&n++,{from:e,to:n})))),r=updateSel(t.selection,(t=>e.moveVertically(t,!0))).map(n);return e.dispatch({changes:n,selection:r,scrollIntoView:!0,userEvent:"delete.line"}),!0};function isBetweenBrackets(e,t){if(/\(\)|\[\]|\{\}/.test(e.sliceDoc(t-1,t+1)))return {from:t,to:t};let n,r=syntaxTree(e).resolveInner(t),o=r.childBefore(t),i=r.childAfter(t);return o&&i&&o.to<=t&&i.from>=t&&(n=o.type.prop(NodeProp.closedBy))&&n.indexOf(i.name)>-1&&e.doc.lineAt(o.to).from==e.doc.lineAt(i.from).from?{from:o.to,to:i.from}:null}const insertNewlineAndIndent=newlineAndIndent(!1),insertBlankLine=newlineAndIndent(!0);function newlineAndIndent(e){return ({state:t,dispatch:n})=>{if(t.readOnly)return !1;let r=t.changeByRange((n=>{let{from:r,to:o}=n,i=t.doc.lineAt(r),l=!e&&r==o&&isBetweenBrackets(t,r);e&&(r=o=(o<=i.to?i:t.doc.lineAt(o)).to);let a=new IndentContext(t,{simulateBreak:r,simulateDoubleBreak:!!l}),s=getIndentation(a,r);for(null==s&&(s=/^\s*/.exec(t.doc.lineAt(r).text)[0].length);o<i.to&&/\s/.test(i.text[o-i.from]);)o++;l?({from:r,to:o}=l):r>i.from&&r<i.from+100&&!/\S/.test(i.text.slice(0,r))&&(r=i.from);let c=["",indentString(t,s)];return l&&c.push(indentString(t,a.lineIndent(i.from,-1))),{changes:{from:r,to:o,insert:Text$1.of(c)},range:EditorSelection.cursor(r+1+c[1].length)}}));return n(t.update(r,{scrollIntoView:!0,userEvent:"input"})),!0}}function changeBySelectedLine(e,t){let n=-1;return e.changeByRange((r=>{let o=[];for(let i=r.from;i<=r.to;){let l=e.doc.lineAt(i);l.number>n&&(r.empty||r.to>l.from)&&(t(l,o,r),n=l.number),i=l.to+1;}let i=e.changes(o);return {changes:o,range:EditorSelection.range(i.mapPos(r.anchor,1),i.mapPos(r.head,1))}}))}const indentSelection=({state:e,dispatch:t})=>{if(e.readOnly)return !1;let n=Object.create(null),r=new IndentContext(e,{overrideIndentation:e=>{let t=n[e];return null==t?-1:t}}),o=changeBySelectedLine(e,((t,o,i)=>{let l=getIndentation(r,t.from);if(null==l)return;/\S/.test(t.text)||(l=0);let a=/^\s*/.exec(t.text)[0],s=indentString(e,l);(a!=s||i.from<t.from+a.length)&&(n[t.from]=l,o.push({from:t.from,to:t.from+a.length,insert:s}));}));return o.changes.empty||t(e.update(o,{userEvent:"indent"})),!0},indentMore=({state:e,dispatch:t})=>!e.readOnly&&(t(e.update(changeBySelectedLine(e,((t,n)=>{n.push({from:t.from,insert:e.facet(indentUnit)});})),{userEvent:"input.indent"})),!0),indentLess=({state:e,dispatch:t})=>!e.readOnly&&(t(e.update(changeBySelectedLine(e,((t,n)=>{let r=/^\s*/.exec(t.text)[0];if(!r)return;let o=countColumn(r,e.tabSize),i=0,l=indentString(e,Math.max(0,o-getIndentUnit(e)));for(;i<r.length&&i<l.length&&r.charCodeAt(i)==l.charCodeAt(i);)i++;n.push({from:t.from+i,to:t.from+r.length,insert:l.slice(i)});})),{userEvent:"delete.dedent"})),!0),emacsStyleKeymap=[{key:"Ctrl-b",run:cursorCharLeft,shift:selectCharLeft,preventDefault:!0},{key:"Ctrl-f",run:cursorCharRight,shift:selectCharRight},{key:"Ctrl-p",run:cursorLineUp,shift:selectLineUp},{key:"Ctrl-n",run:cursorLineDown,shift:selectLineDown},{key:"Ctrl-a",run:cursorLineStart,shift:selectLineStart},{key:"Ctrl-e",run:cursorLineEnd,shift:selectLineEnd},{key:"Ctrl-d",run:deleteCharForward},{key:"Ctrl-h",run:deleteCharBackward},{key:"Ctrl-k",run:deleteToLineEnd},{key:"Ctrl-Alt-h",run:deleteGroupBackward},{key:"Ctrl-o",run:splitLine},{key:"Ctrl-t",run:transposeChars},{key:"Ctrl-v",run:cursorPageDown}],standardKeymap=[{key:"ArrowLeft",run:cursorCharLeft,shift:selectCharLeft,preventDefault:!0},{key:"Mod-ArrowLeft",mac:"Alt-ArrowLeft",run:cursorGroupLeft,shift:selectGroupLeft,preventDefault:!0},{mac:"Cmd-ArrowLeft",run:cursorLineBoundaryLeft,shift:selectLineBoundaryLeft,preventDefault:!0},{key:"ArrowRight",run:cursorCharRight,shift:selectCharRight,preventDefault:!0},{key:"Mod-ArrowRight",mac:"Alt-ArrowRight",run:cursorGroupRight,shift:selectGroupRight,preventDefault:!0},{mac:"Cmd-ArrowRight",run:cursorLineBoundaryRight,shift:selectLineBoundaryRight,preventDefault:!0},{key:"ArrowUp",run:cursorLineUp,shift:selectLineUp,preventDefault:!0},{mac:"Cmd-ArrowUp",run:cursorDocStart,shift:selectDocStart},{mac:"Ctrl-ArrowUp",run:cursorPageUp,shift:selectPageUp},{key:"ArrowDown",run:cursorLineDown,shift:selectLineDown,preventDefault:!0},{mac:"Cmd-ArrowDown",run:cursorDocEnd,shift:selectDocEnd},{mac:"Ctrl-ArrowDown",run:cursorPageDown,shift:selectPageDown},{key:"PageUp",run:cursorPageUp,shift:selectPageUp},{key:"PageDown",run:cursorPageDown,shift:selectPageDown},{key:"Home",run:cursorLineBoundaryBackward,shift:selectLineBoundaryBackward,preventDefault:!0},{key:"Mod-Home",run:cursorDocStart,shift:selectDocStart},{key:"End",run:cursorLineBoundaryForward,shift:selectLineBoundaryForward,preventDefault:!0},{key:"Mod-End",run:cursorDocEnd,shift:selectDocEnd},{key:"Enter",run:insertNewlineAndIndent},{key:"Mod-a",run:selectAll},{key:"Backspace",run:deleteCharBackward,shift:deleteCharBackward},{key:"Delete",run:deleteCharForward},{key:"Mod-Backspace",mac:"Alt-Backspace",run:deleteGroupBackward},{key:"Mod-Delete",mac:"Alt-Delete",run:deleteGroupForward},{mac:"Mod-Backspace",run:deleteToLineStart},{mac:"Mod-Delete",run:deleteToLineEnd}].concat(emacsStyleKeymap.map((e=>({mac:e.key,run:e.run,shift:e.shift})))),defaultKeymap=[{key:"Alt-ArrowLeft",mac:"Ctrl-ArrowLeft",run:cursorSyntaxLeft,shift:selectSyntaxLeft},{key:"Alt-ArrowRight",mac:"Ctrl-ArrowRight",run:cursorSyntaxRight,shift:selectSyntaxRight},{key:"Alt-ArrowUp",run:moveLineUp},{key:"Shift-Alt-ArrowUp",run:copyLineUp},{key:"Alt-ArrowDown",run:moveLineDown},{key:"Shift-Alt-ArrowDown",run:copyLineDown},{key:"Escape",run:simplifySelection},{key:"Mod-Enter",run:insertBlankLine},{key:"Alt-l",mac:"Ctrl-l",run:selectLine},{key:"Mod-i",run:selectParentSyntax,preventDefault:!0},{key:"Mod-[",run:indentLess},{key:"Mod-]",run:indentMore},{key:"Mod-Alt-\\",run:indentSelection},{key:"Shift-Mod-k",run:deleteLine},{key:"Shift-Mod-\\",run:cursorMatchingBracket},{key:"Mod-/",run:toggleComment},{key:"Alt-A",run:toggleBlockComment}].concat(standardKeymap),indentWithTab={key:"Tab",run:indentMore,shift:indentLess};

    class Stack{constructor(t,e,s,i,r,h,n,o,a,c=0,l){this.p=t,this.stack=e,this.state=s,this.reducePos=i,this.pos=r,this.score=h,this.buffer=n,this.bufferBase=o,this.curContext=a,this.lookAhead=c,this.parent=l;}toString(){return `[${this.stack.filter(((t,e)=>e%3==0)).concat(this.state)}]@${this.pos}${this.score?"!"+this.score:""}`}static start(t,e,s=0){let i=t.parser.context;return new Stack(t,[],e,s,s,0,[],0,i?new StackContext(i,i.start):null,0,null)}get context(){return this.curContext?this.curContext.context:null}pushState(t,e){this.stack.push(this.state,e,this.bufferBase+this.buffer.length),this.state=t;}reduce(t){var e;let s=t>>19,i=65535&t,{parser:r}=this.p,h=r.dynamicPrecedence(i);if(h&&(this.score+=h),0==s)return this.pushState(r.getGoto(this.state,i,!0),this.reducePos),i<r.minRepeatTerm&&this.storeNode(i,this.reducePos,this.reducePos,4,!0),void this.reduceContext(i,this.reducePos);let n=this.stack.length-3*(s-1)-(262144&t?6:0),o=n?this.stack[n-2]:this.p.ranges[0].from,a=this.reducePos-o;a>=2e3&&!(null===(e=this.p.parser.nodeSet.types[i])||void 0===e?void 0:e.isAnonymous)&&(o==this.p.lastBigReductionStart?(this.p.bigReductionCount++,this.p.lastBigReductionSize=a):this.p.lastBigReductionSize<a&&(this.p.bigReductionCount=1,this.p.lastBigReductionStart=o,this.p.lastBigReductionSize=a));let c=n?this.stack[n-1]:0,l=this.bufferBase+this.buffer.length-c;if(i<r.minRepeatTerm||131072&t){let t=r.stateFlag(this.state,1)?this.pos:this.reducePos;this.storeNode(i,o,t,l+4,!0);}if(262144&t)this.state=this.stack[n];else {let t=this.stack[n-3];this.state=r.getGoto(t,i,!0);}for(;this.stack.length>n;)this.stack.pop();this.reduceContext(i,o);}storeNode(t,e,s,i=4,r=!1){if(0==t&&(!this.stack.length||this.stack[this.stack.length-1]<this.buffer.length+this.bufferBase)){let t=this,i=this.buffer.length;if(0==i&&t.parent&&(i=t.bufferBase-t.parent.bufferBase,t=t.parent),i>0&&0==t.buffer[i-4]&&t.buffer[i-1]>-1){if(e==s)return;if(t.buffer[i-2]>=e)return void(t.buffer[i-2]=s)}}if(r&&this.pos!=s){let r=this.buffer.length;if(r>0&&0!=this.buffer[r-4])for(;r>0&&this.buffer[r-2]>s;)this.buffer[r]=this.buffer[r-4],this.buffer[r+1]=this.buffer[r-3],this.buffer[r+2]=this.buffer[r-2],this.buffer[r+3]=this.buffer[r-1],r-=4,i>4&&(i-=4);this.buffer[r]=t,this.buffer[r+1]=e,this.buffer[r+2]=s,this.buffer[r+3]=i;}else this.buffer.push(t,e,s,i);}shift(t,e,s){let i=this.pos;if(131072&t)this.pushState(65535&t,this.pos);else if(0==(262144&t)){let r=t,{parser:h}=this.p;(s>this.pos||e<=h.maxNode)&&(this.pos=s,h.stateFlag(r,1)||(this.reducePos=s)),this.pushState(r,i),this.shiftContext(e,i),e<=h.maxNode&&this.buffer.push(e,i,s,4);}else this.pos=s,this.shiftContext(e,i),e<=this.p.parser.maxNode&&this.buffer.push(e,i,s,4);}apply(t,e,s){65536&t?this.reduce(t):this.shift(t,e,s);}useNode(t,e){let s=this.p.reused.length-1;(s<0||this.p.reused[s]!=t)&&(this.p.reused.push(t),s++);let i=this.pos;this.reducePos=this.pos=i+t.length,this.pushState(e,i),this.buffer.push(s,i,this.reducePos,-1),this.curContext&&this.updateContext(this.curContext.tracker.reuse(this.curContext.context,t,this,this.p.stream.reset(this.pos-t.length)));}split(){let t=this,e=t.buffer.length;for(;e>0&&t.buffer[e-2]>t.reducePos;)e-=4;let s=t.buffer.slice(e),i=t.bufferBase+e;for(;t&&i==t.bufferBase;)t=t.parent;return new Stack(this.p,this.stack.slice(),this.state,this.reducePos,this.pos,this.score,s,i,this.curContext,this.lookAhead,t)}recoverByDelete(t,e){let s=t<=this.p.parser.maxNode;s&&this.storeNode(t,this.pos,e,4),this.storeNode(0,this.pos,e,s?8:4),this.pos=this.reducePos=e,this.score-=190;}canShift(t){for(let e=new SimulatedStack(this);;){let s=this.p.parser.stateSlot(e.state,4)||this.p.parser.hasAction(e.state,t);if(0==s)return !1;if(0==(65536&s))return !0;e.reduce(s);}}recoverByInsert(t){if(this.stack.length>=300)return [];let e=this.p.parser.nextStates(this.state);if(e.length>8||this.stack.length>=120){let s=[];for(let i,r=0;r<e.length;r+=2)(i=e[r+1])!=this.state&&this.p.parser.hasAction(i,t)&&s.push(e[r],i);if(this.stack.length<120)for(let t=0;s.length<8&&t<e.length;t+=2){let i=e[t+1];s.some(((t,e)=>1&e&&t==i))||s.push(e[t],i);}e=s;}let s=[];for(let t=0;t<e.length&&s.length<4;t+=2){let i=e[t+1];if(i==this.state)continue;let r=this.split();r.pushState(i,this.pos),r.storeNode(0,r.pos,r.pos,4,!0),r.shiftContext(e[t],this.pos),r.score-=200,s.push(r);}return s}forceReduce(){let{parser:t}=this.p,e=t.stateSlot(this.state,5);if(0==(65536&e))return !1;if(!t.validAction(this.state,e)){let s=e>>19,i=65535&e,r=this.stack.length-3*s;if(r<0||t.getGoto(this.stack[r],i,!1)<0){let t=this.findForcedReduction();if(null==t)return !1;e=t;}this.storeNode(0,this.reducePos,this.reducePos,4,!0),this.score-=100;}return this.reducePos=this.pos,this.reduce(e),!0}findForcedReduction(){let{parser:t}=this.p,e=[],s=(i,r)=>{if(!e.includes(i))return e.push(i),t.allActions(i,(e=>{if(393216&e);else if(65536&e){let s=(e>>19)-r;if(s>1){let i=65535&e,r=this.stack.length-3*s;if(r>=0&&t.getGoto(this.stack[r],i,!1)>=0)return s<<19|65536|i}}else {let t=s(e,r+1);if(null!=t)return t}}))};return s(this.state,0)}forceAll(){for(;!this.p.parser.stateFlag(this.state,2);)if(!this.forceReduce()){this.storeNode(0,this.pos,this.pos,4,!0);break}return this}get deadEnd(){if(3!=this.stack.length)return !1;let{parser:t}=this.p;return 65535==t.data[t.stateSlot(this.state,1)]&&!t.stateSlot(this.state,4)}restart(){this.state=this.stack[0],this.stack.length=0;}sameState(t){if(this.state!=t.state||this.stack.length!=t.stack.length)return !1;for(let e=0;e<this.stack.length;e+=3)if(this.stack[e]!=t.stack[e])return !1;return !0}get parser(){return this.p.parser}dialectEnabled(t){return this.p.parser.dialect.flags[t]}shiftContext(t,e){this.curContext&&this.updateContext(this.curContext.tracker.shift(this.curContext.context,t,this,this.p.stream.reset(e)));}reduceContext(t,e){this.curContext&&this.updateContext(this.curContext.tracker.reduce(this.curContext.context,t,this,this.p.stream.reset(e)));}emitContext(){let t=this.buffer.length-1;(t<0||-3!=this.buffer[t])&&this.buffer.push(this.curContext.hash,this.pos,this.pos,-3);}emitLookAhead(){let t=this.buffer.length-1;(t<0||-4!=this.buffer[t])&&this.buffer.push(this.lookAhead,this.pos,this.pos,-4);}updateContext(t){if(t!=this.curContext.context){let e=new StackContext(this.curContext.tracker,t);e.hash!=this.curContext.hash&&this.emitContext(),this.curContext=e;}}setLookAhead(t){t>this.lookAhead&&(this.emitLookAhead(),this.lookAhead=t);}close(){this.curContext&&this.curContext.tracker.strict&&this.emitContext(),this.lookAhead>0&&this.emitLookAhead();}}class StackContext{constructor(t,e){this.tracker=t,this.context=e,this.hash=t.strict?t.hash(e):0;}}var Recover;!function(t){t[t.Insert=200]="Insert",t[t.Delete=190]="Delete",t[t.Reduce=100]="Reduce",t[t.MaxNext=4]="MaxNext",t[t.MaxInsertStackDepth=300]="MaxInsertStackDepth",t[t.DampenInsertStackDepth=120]="DampenInsertStackDepth",t[t.MinBigReduction=2e3]="MinBigReduction";}(Recover||(Recover={}));class SimulatedStack{constructor(t){this.start=t,this.state=t.state,this.stack=t.stack,this.base=this.stack.length;}reduce(t){let e=65535&t,s=t>>19;0==s?(this.stack==this.start.stack&&(this.stack=this.stack.slice()),this.stack.push(this.state,0,0),this.base+=3):this.base-=3*(s-1);let i=this.start.p.parser.getGoto(this.stack[this.base-3],e,!0);this.state=i;}}class StackBufferCursor{constructor(t,e,s){this.stack=t,this.pos=e,this.index=s,this.buffer=t.buffer,0==this.index&&this.maybeNext();}static create(t,e=t.bufferBase+t.buffer.length){return new StackBufferCursor(t,e,e-t.bufferBase)}maybeNext(){let t=this.stack.parent;null!=t&&(this.index=this.stack.bufferBase-t.bufferBase,this.stack=t,this.buffer=t.buffer);}get id(){return this.buffer[this.index-4]}get start(){return this.buffer[this.index-3]}get end(){return this.buffer[this.index-2]}get size(){return this.buffer[this.index-1]}next(){this.index-=4,this.pos-=4,0==this.index&&this.maybeNext();}fork(){return new StackBufferCursor(this.stack,this.pos,this.index)}}function decodeArray(t,e=Uint16Array){if("string"!=typeof t)return t;let s=null;for(let i=0,r=0;i<t.length;){let h=0;for(;;){let e=t.charCodeAt(i++),s=!1;if(126==e){h=65535;break}e>=92&&e--,e>=34&&e--;let r=e-32;if(r>=46&&(r-=46,s=!0),h+=r,s)break;h*=46;}s?s[r++]=h:s=new e(h);}return s}class CachedToken{constructor(){this.start=-1,this.value=-1,this.end=-1,this.extended=-1,this.lookAhead=0,this.mask=0,this.context=0;}}const nullToken=new CachedToken;class InputStream{constructor(t,e){this.input=t,this.ranges=e,this.chunk="",this.chunkOff=0,this.chunk2="",this.chunk2Pos=0,this.next=-1,this.token=nullToken,this.rangeIndex=0,this.pos=this.chunkPos=e[0].from,this.range=e[0],this.end=e[e.length-1].to,this.readNext();}resolveOffset(t,e){let s=this.range,i=this.rangeIndex,r=this.pos+t;for(;r<s.from;){if(!i)return null;let t=this.ranges[--i];r-=s.from-t.to,s=t;}for(;e<0?r>s.to:r>=s.to;){if(i==this.ranges.length-1)return null;let t=this.ranges[++i];r+=t.from-s.to,s=t;}return r}clipPos(t){if(t>=this.range.from&&t<this.range.to)return t;for(let e of this.ranges)if(e.to>t)return Math.max(t,e.from);return this.end}peek(t){let e,s,i=this.chunkOff+t;if(i>=0&&i<this.chunk.length)e=this.pos+t,s=this.chunk.charCodeAt(i);else {let i=this.resolveOffset(t,1);if(null==i)return -1;if(e=i,e>=this.chunk2Pos&&e<this.chunk2Pos+this.chunk2.length)s=this.chunk2.charCodeAt(e-this.chunk2Pos);else {let t=this.rangeIndex,i=this.range;for(;i.to<=e;)i=this.ranges[++t];this.chunk2=this.input.chunk(this.chunk2Pos=e),e+this.chunk2.length>i.to&&(this.chunk2=this.chunk2.slice(0,i.to-e)),s=this.chunk2.charCodeAt(0);}}return e>=this.token.lookAhead&&(this.token.lookAhead=e+1),s}acceptToken(t,e=0){let s=e?this.resolveOffset(e,-1):this.pos;if(null==s||s<this.token.start)throw new RangeError("Token end out of bounds");this.token.value=t,this.token.end=s;}getChunk(){if(this.pos>=this.chunk2Pos&&this.pos<this.chunk2Pos+this.chunk2.length){let{chunk:t,chunkPos:e}=this;this.chunk=this.chunk2,this.chunkPos=this.chunk2Pos,this.chunk2=t,this.chunk2Pos=e,this.chunkOff=this.pos-this.chunkPos;}else {this.chunk2=this.chunk,this.chunk2Pos=this.chunkPos;let t=this.input.chunk(this.pos),e=this.pos+t.length;this.chunk=e>this.range.to?t.slice(0,this.range.to-this.pos):t,this.chunkPos=this.pos,this.chunkOff=0;}}readNext(){return this.chunkOff>=this.chunk.length&&(this.getChunk(),this.chunkOff==this.chunk.length)?this.next=-1:this.next=this.chunk.charCodeAt(this.chunkOff)}advance(t=1){for(this.chunkOff+=t;this.pos+t>=this.range.to;){if(this.rangeIndex==this.ranges.length-1)return this.setDone();t-=this.range.to-this.pos,this.range=this.ranges[++this.rangeIndex],this.pos=this.range.from;}return this.pos+=t,this.pos>=this.token.lookAhead&&(this.token.lookAhead=this.pos+1),this.readNext()}setDone(){return this.pos=this.chunkPos=this.end,this.range=this.ranges[this.rangeIndex=this.ranges.length-1],this.chunk="",this.next=-1}reset(t,e){if(e?(this.token=e,e.start=t,e.lookAhead=t+1,e.value=e.extended=-1):this.token=nullToken,this.pos!=t){if(this.pos=t,t==this.end)return this.setDone(),this;for(;t<this.range.from;)this.range=this.ranges[--this.rangeIndex];for(;t>=this.range.to;)this.range=this.ranges[++this.rangeIndex];t>=this.chunkPos&&t<this.chunkPos+this.chunk.length?this.chunkOff=t-this.chunkPos:(this.chunk="",this.chunkOff=0),this.readNext();}return this}read(t,e){if(t>=this.chunkPos&&e<=this.chunkPos+this.chunk.length)return this.chunk.slice(t-this.chunkPos,e-this.chunkPos);if(t>=this.chunk2Pos&&e<=this.chunk2Pos+this.chunk2.length)return this.chunk2.slice(t-this.chunk2Pos,e-this.chunk2Pos);if(t>=this.range.from&&e<=this.range.to)return this.input.read(t,e);let s="";for(let i of this.ranges){if(i.from>=e)break;i.to>t&&(s+=this.input.read(Math.max(i.from,t),Math.min(i.to,e)));}return s}}class TokenGroup{constructor(t,e){this.data=t,this.id=e;}token(t,e){let{parser:s}=e.p;readToken(this.data,t,e,this.id,s.data,s.tokenPrecTable);}}TokenGroup.prototype.contextual=TokenGroup.prototype.fallback=TokenGroup.prototype.extend=!1;class LocalTokenGroup{constructor(t,e,s){this.precTable=e,this.elseToken=s,this.data="string"==typeof t?decodeArray(t):t;}token(t,e){let s=t.pos,i=0;for(;;){let s=t.resolveOffset(1,-1);if(readToken(this.data,t,e,0,this.data,this.precTable),t.token.value>-1)break;if(null==this.elseToken)return;if(null==s)break;t.reset(s,t.token),i++;}i&&(t.reset(s,t.token),t.acceptToken(this.elseToken,i));}}LocalTokenGroup.prototype.contextual=TokenGroup.prototype.fallback=TokenGroup.prototype.extend=!1;class ExternalTokenizer{constructor(t,e={}){this.token=t,this.contextual=!!e.contextual,this.fallback=!!e.fallback,this.extend=!!e.extend;}}function readToken(t,e,s,i,r,h){let n=0,o=1<<i,{dialect:a}=s.p.parser;t:for(;0!=(o&t[n]);){let s=t[n+1];for(let i=n+3;i<s;i+=2)if((t[i+1]&o)>0){let s=t[i];if(a.allows(s)&&(-1==e.token.value||e.token.value==s||overrides(s,e.token.value,r,h))){e.acceptToken(s);break}}let i=e.next,c=0,l=t[n+2];if(!(e.next<0&&l>c&&65535==t[s+3*l-3]&&65535==t[s+3*l-3])){for(;c<l;){let r=c+l>>1,h=s+r+(r<<1),o=t[h],a=t[h+1]||65536;if(i<o)l=r;else {if(!(i>=a)){n=t[h+2],e.advance();continue t}c=r+1;}}break}n=t[s+3*l-1];}}function findOffset(t,e,s){for(let i,r=e;65535!=(i=t[r]);r++)if(i==s)return r-e;return -1}function overrides(t,e,s,i){let r=findOffset(s,i,e);return r<0||findOffset(s,i,t)<r}const verbose="undefined"!=typeof process&&process.env&&/\bparse\b/.test(process.env.LOG);let stackIDs=null;var Safety,Rec;function cutAt(t,e,s){let i=t.cursor(IterMode.IncludeAnonymous);for(i.moveTo(e);;)if(!(s<0?i.childBefore(e):i.childAfter(e)))for(;;){if((s<0?i.to<e:i.from>e)&&!i.type.isError)return s<0?Math.max(0,Math.min(i.to-1,e-25)):Math.min(t.length,Math.max(i.from+1,e+25));if(s<0?i.prevSibling():i.nextSibling())break;if(!i.parent())return s<0?0:t.length}}!function(t){t[t.Margin=25]="Margin";}(Safety||(Safety={}));class FragmentCursor{constructor(t,e){this.fragments=t,this.nodeSet=e,this.i=0,this.fragment=null,this.safeFrom=-1,this.safeTo=-1,this.trees=[],this.start=[],this.index=[],this.nextFragment();}nextFragment(){let t=this.fragment=this.i==this.fragments.length?null:this.fragments[this.i++];if(t){for(this.safeFrom=t.openStart?cutAt(t.tree,t.from+t.offset,1)-t.offset:t.from,this.safeTo=t.openEnd?cutAt(t.tree,t.to+t.offset,-1)-t.offset:t.to;this.trees.length;)this.trees.pop(),this.start.pop(),this.index.pop();this.trees.push(t.tree),this.start.push(-t.offset),this.index.push(0),this.nextStart=this.safeFrom;}else this.nextStart=1e9;}nodeAt(t){if(t<this.nextStart)return null;for(;this.fragment&&this.safeTo<=t;)this.nextFragment();if(!this.fragment)return null;for(;;){let e=this.trees.length-1;if(e<0)return this.nextFragment(),null;let s=this.trees[e],i=this.index[e];if(i==s.children.length){this.trees.pop(),this.start.pop(),this.index.pop();continue}let r=s.children[i],h=this.start[e]+s.positions[i];if(h>t)return this.nextStart=h,null;if(r instanceof Tree){if(h==t){if(h<this.safeFrom)return null;let t=h+r.length;if(t<=this.safeTo){let e=r.prop(NodeProp.lookAhead);if(!e||t+e<this.fragment.to)return r}}this.index[e]++,h+r.length>=Math.max(this.safeFrom,t)&&(this.trees.push(r),this.start.push(h),this.index.push(0));}else this.index[e]++,this.nextStart=h+r.length;}}}class TokenCache{constructor(t,e){this.stream=e,this.tokens=[],this.mainToken=null,this.actions=[],this.tokens=t.tokenizers.map((t=>new CachedToken));}getActions(t){let e=0,s=null,{parser:i}=t.p,{tokenizers:r}=i,h=i.stateSlot(t.state,3),n=t.curContext?t.curContext.hash:0,o=0;for(let i=0;i<r.length;i++){if(0==(1<<i&h))continue;let a=r[i],c=this.tokens[i];if((!s||a.fallback)&&((a.contextual||c.start!=t.pos||c.mask!=h||c.context!=n)&&(this.updateCachedToken(c,a,t),c.mask=h,c.context=n),c.lookAhead>c.end+25&&(o=Math.max(c.lookAhead,o)),0!=c.value)){let i=e;if(c.extended>-1&&(e=this.addActions(t,c.extended,c.end,e)),e=this.addActions(t,c.value,c.end,e),!a.extend&&(s=c,e>i))break}}for(;this.actions.length>e;)this.actions.pop();return o&&t.setLookAhead(o),s||t.pos!=this.stream.end||(s=new CachedToken,s.value=t.p.parser.eofTerm,s.start=s.end=t.pos,e=this.addActions(t,s.value,s.end,e)),this.mainToken=s,this.actions}getMainToken(t){if(this.mainToken)return this.mainToken;let e=new CachedToken,{pos:s,p:i}=t;return e.start=s,e.end=Math.min(s+1,i.stream.end),e.value=s==i.stream.end?i.parser.eofTerm:0,e}updateCachedToken(t,e,s){let i=this.stream.clipPos(s.pos);if(e.token(this.stream.reset(i,t),s),t.value>-1){let{parser:e}=s.p;for(let i=0;i<e.specialized.length;i++)if(e.specialized[i]==t.value){let r=e.specializers[i](this.stream.read(t.start,t.end),s);if(r>=0&&s.p.parser.dialect.allows(r>>1)){0==(1&r)?t.value=r>>1:t.extended=r>>1;break}}}else t.value=0,t.end=this.stream.clipPos(i+1);}putAction(t,e,s,i){for(let e=0;e<i;e+=3)if(this.actions[e]==t)return i;return this.actions[i++]=t,this.actions[i++]=e,this.actions[i++]=s,i}addActions(t,e,s,i){let{state:r}=t,{parser:h}=t.p,{data:n}=h;for(let t=0;t<2;t++)for(let o=h.stateSlot(r,t?2:1);;o+=3){if(65535==n[o]){if(1!=n[o+1]){0==i&&2==n[o+1]&&(i=this.putAction(pair(n,o+2),e,s,i));break}o=pair(n,o+2);}n[o]==e&&(i=this.putAction(pair(n,o+1),e,s,i));}return i}}!function(t){t[t.Distance=5]="Distance",t[t.MaxRemainingPerStep=3]="MaxRemainingPerStep",t[t.MinBufferLengthPrune=500]="MinBufferLengthPrune",t[t.ForceReduceLimit=10]="ForceReduceLimit",t[t.CutDepth=15e3]="CutDepth",t[t.CutTo=9e3]="CutTo",t[t.MaxLeftAssociativeReductionCount=300]="MaxLeftAssociativeReductionCount",t[t.MaxStackCount=12]="MaxStackCount";}(Rec||(Rec={}));class Parse{constructor(t,e,s,i){this.parser=t,this.input=e,this.ranges=i,this.recovering=0,this.nextStackID=9812,this.minStackPos=0,this.reused=[],this.stoppedAt=null,this.lastBigReductionStart=-1,this.lastBigReductionSize=0,this.bigReductionCount=0,this.stream=new InputStream(e,i),this.tokens=new TokenCache(t,this.stream),this.topTerm=t.top[1];let{from:r}=i[0];this.stacks=[Stack.start(this,t.top[0],r)],this.fragments=s.length&&this.stream.end-r>4*t.bufferLength?new FragmentCursor(s,t.nodeSet):null;}get parsedPos(){return this.minStackPos}advance(){let t,e,s=this.stacks,i=this.minStackPos,r=this.stacks=[];if(this.bigReductionCount>300&&1==s.length){let[t]=s;for(;t.forceReduce()&&t.stack.length&&t.stack[t.stack.length-2]>=this.lastBigReductionStart;);this.bigReductionCount=this.lastBigReductionSize=0;}for(let h=0;h<s.length;h++){let n=s[h];for(;;){if(this.tokens.mainToken=null,n.pos>i)r.push(n);else {if(this.advanceStack(n,r,s))continue;{t||(t=[],e=[]),t.push(n);let s=this.tokens.getMainToken(n);e.push(s.value,s.end);}}break}}if(!r.length){let e=t&&findFinished(t);if(e)return this.stackToTree(e);if(this.parser.strict)throw verbose&&t&&console.log("Stuck with token "+(this.tokens.mainToken?this.parser.getName(this.tokens.mainToken.value):"none")),new SyntaxError("No parse at "+i);this.recovering||(this.recovering=5);}if(this.recovering&&t){let s=null!=this.stoppedAt&&t[0].pos>this.stoppedAt?t[0]:this.runRecovery(t,e,r);if(s)return this.stackToTree(s.forceAll())}if(this.recovering){let t=1==this.recovering?1:3*this.recovering;if(r.length>t)for(r.sort(((t,e)=>e.score-t.score));r.length>t;)r.pop();r.some((t=>t.reducePos>i))&&this.recovering--;}else if(r.length>1){t:for(let t=0;t<r.length-1;t++){let e=r[t];for(let s=t+1;s<r.length;s++){let i=r[s];if(e.sameState(i)||e.buffer.length>500&&i.buffer.length>500){if(!((e.score-i.score||e.buffer.length-i.buffer.length)>0)){r.splice(t--,1);continue t}r.splice(s--,1);}}}r.length>12&&r.splice(12,r.length-12);}this.minStackPos=r[0].pos;for(let t=1;t<r.length;t++)r[t].pos<this.minStackPos&&(this.minStackPos=r[t].pos);return null}stopAt(t){if(null!=this.stoppedAt&&this.stoppedAt<t)throw new RangeError("Can't move stoppedAt forward");this.stoppedAt=t;}advanceStack(t,e,s){let i=t.pos,{parser:r}=this,h=verbose?this.stackID(t)+" -> ":"";if(null!=this.stoppedAt&&i>this.stoppedAt)return t.forceReduce()?t:null;if(this.fragments){let e=t.curContext&&t.curContext.tracker.strict,s=e?t.curContext.hash:0;for(let n=this.fragments.nodeAt(i);n;){let i=this.parser.nodeSet.types[n.type.id]==n.type?r.getGoto(t.state,n.type.id):-1;if(i>-1&&n.length&&(!e||(n.prop(NodeProp.contextHash)||0)==s))return t.useNode(n,i),verbose&&console.log(h+this.stackID(t)+` (via reuse of ${r.getName(n.type.id)})`),!0;if(!(n instanceof Tree)||0==n.children.length||n.positions[0]>0)break;let o=n.children[0];if(!(o instanceof Tree&&0==n.positions[0]))break;n=o;}}let n=r.stateSlot(t.state,4);if(n>0)return t.reduce(n),verbose&&console.log(h+this.stackID(t)+` (via always-reduce ${r.getName(65535&n)})`),!0;if(t.stack.length>=15e3)for(;t.stack.length>9e3&&t.forceReduce(););let o=this.tokens.getActions(t);for(let n=0;n<o.length;){let a=o[n++],c=o[n++],l=o[n++],u=n==o.length||!s,f=u?t:t.split();if(f.apply(a,c,l),verbose&&console.log(h+this.stackID(f)+` (via ${0==(65536&a)?"shift":`reduce of ${r.getName(65535&a)}`} for ${r.getName(c)} @ ${i}${f==t?"":", split"})`),u)return !0;f.pos>i?e.push(f):s.push(f);}return !1}advanceFully(t,e){let s=t.pos;for(;;){if(!this.advanceStack(t,null,null))return !1;if(t.pos>s)return pushStackDedup(t,e),!0}}runRecovery(t,e,s){let i=null,r=!1;for(let h=0;h<t.length;h++){let n=t[h],o=e[h<<1],a=e[1+(h<<1)],c=verbose?this.stackID(n)+" -> ":"";if(n.deadEnd){if(r)continue;if(r=!0,n.restart(),verbose&&console.log(c+this.stackID(n)+" (restarted)"),this.advanceFully(n,s))continue}let l=n.split(),u=c;for(let t=0;l.forceReduce()&&t<10;t++){if(verbose&&console.log(u+this.stackID(l)+" (via force-reduce)"),this.advanceFully(l,s))break;verbose&&(u=this.stackID(l)+" -> ");}for(let t of n.recoverByInsert(o))verbose&&console.log(c+this.stackID(t)+" (via recover-insert)"),this.advanceFully(t,s);this.stream.end>n.pos?(a==n.pos&&(a++,o=0),n.recoverByDelete(o,a),verbose&&console.log(c+this.stackID(n)+` (via recover-delete ${this.parser.getName(o)})`),pushStackDedup(n,s)):(!i||i.score<n.score)&&(i=n);}return i}stackToTree(t){return t.close(),Tree.build({buffer:StackBufferCursor.create(t),nodeSet:this.parser.nodeSet,topID:this.topTerm,maxBufferLength:this.parser.bufferLength,reused:this.reused,start:this.ranges[0].from,length:t.pos-this.ranges[0].from,minRepeatType:this.parser.minRepeatTerm})}stackID(t){let e=(stackIDs||(stackIDs=new WeakMap)).get(t);return e||stackIDs.set(t,e=String.fromCodePoint(this.nextStackID++)),e+t}}function pushStackDedup(t,e){for(let s=0;s<e.length;s++){let i=e[s];if(i.pos==t.pos&&i.sameState(t))return void(e[s].score<t.score&&(e[s]=t))}e.push(t);}class Dialect{constructor(t,e,s){this.source=t,this.flags=e,this.disabled=s;}allows(t){return !this.disabled||0==this.disabled[t]}}const id=t=>t;class ContextTracker{constructor(t){this.start=t.start,this.shift=t.shift||id,this.reduce=t.reduce||id,this.reuse=t.reuse||id,this.hash=t.hash||(()=>0),this.strict=!1!==t.strict;}}class LRParser extends Parser{constructor(t){if(super(),this.wrappers=[],14!=t.version)throw new RangeError(`Parser version (${t.version}) doesn't match runtime version (14)`);let e=t.nodeNames.split(" ");this.minRepeatTerm=e.length;for(let s=0;s<t.repeatNodeCount;s++)e.push("");let s=Object.keys(t.topRules).map((e=>t.topRules[e][1])),i=[];for(let t=0;t<e.length;t++)i.push([]);function r(t,e,s){i[t].push([e,e.deserialize(String(s))]);}if(t.nodeProps)for(let e of t.nodeProps){let t=e[0];"string"==typeof t&&(t=NodeProp[t]);for(let s=1;s<e.length;){let i=e[s++];if(i>=0)r(i,t,e[s++]);else {let h=e[s+-i];for(let n=-i;n>0;n--)r(e[s++],t,h);s++;}}}this.nodeSet=new NodeSet(e.map(((e,r)=>NodeType.define({name:r>=this.minRepeatTerm?void 0:e,id:r,props:i[r],top:s.indexOf(r)>-1,error:0==r,skipped:t.skippedNodes&&t.skippedNodes.indexOf(r)>-1})))),t.propSources&&(this.nodeSet=this.nodeSet.extend(...t.propSources)),this.strict=!1,this.bufferLength=DefaultBufferLength;let h=decodeArray(t.tokenData);this.context=t.context,this.specializerSpecs=t.specialized||[],this.specialized=new Uint16Array(this.specializerSpecs.length);for(let t=0;t<this.specializerSpecs.length;t++)this.specialized[t]=this.specializerSpecs[t].term;this.specializers=this.specializerSpecs.map(getSpecializer),this.states=decodeArray(t.states,Uint32Array),this.data=decodeArray(t.stateData),this.goto=decodeArray(t.goto),this.maxTerm=t.maxTerm,this.tokenizers=t.tokenizers.map((t=>"number"==typeof t?new TokenGroup(h,t):t)),this.topRules=t.topRules,this.dialects=t.dialects||{},this.dynamicPrecedences=t.dynamicPrecedences||null,this.tokenPrecTable=t.tokenPrec,this.termNames=t.termNames||null,this.maxNode=this.nodeSet.types.length-1,this.dialect=this.parseDialect(),this.top=this.topRules[Object.keys(this.topRules)[0]];}createParse(t,e,s){let i=new Parse(this,t,e,s);for(let r of this.wrappers)i=r(i,t,e,s);return i}getGoto(t,e,s=!1){let i=this.goto;if(e>=i[0])return -1;for(let r=i[e+1];;){let e=i[r++],h=1&e,n=i[r++];if(h&&s)return n;for(let s=r+(e>>1);r<s;r++)if(i[r]==t)return n;if(h)return -1}}hasAction(t,e){let s=this.data;for(let i=0;i<2;i++)for(let r,h=this.stateSlot(t,i?2:1);;h+=3){if(65535==(r=s[h])){if(1!=s[h+1]){if(2==s[h+1])return pair(s,h+2);break}r=s[h=pair(s,h+2)];}if(r==e||0==r)return pair(s,h+1)}return 0}stateSlot(t,e){return this.states[6*t+e]}stateFlag(t,e){return (this.stateSlot(t,0)&e)>0}validAction(t,e){return !!this.allActions(t,(t=>t==e||null))}allActions(t,e){let s=this.stateSlot(t,4),i=s?e(s):void 0;for(let s=this.stateSlot(t,1);null==i;s+=3){if(65535==this.data[s]){if(1!=this.data[s+1])break;s=pair(this.data,s+2);}i=e(pair(this.data,s+1));}return i}nextStates(t){let e=[];for(let s=this.stateSlot(t,1);;s+=3){if(65535==this.data[s]){if(1!=this.data[s+1])break;s=pair(this.data,s+2);}if(0==(1&this.data[s+2])){let t=this.data[s+1];e.some(((e,s)=>1&s&&e==t))||e.push(this.data[s],t);}}return e}configure(t){let e=Object.assign(Object.create(LRParser.prototype),this);if(t.props&&(e.nodeSet=this.nodeSet.extend(...t.props)),t.top){let s=this.topRules[t.top];if(!s)throw new RangeError(`Invalid top rule name ${t.top}`);e.top=s;}return t.tokenizers&&(e.tokenizers=this.tokenizers.map((e=>{let s=t.tokenizers.find((t=>t.from==e));return s?s.to:e}))),t.specializers&&(e.specializers=this.specializers.slice(),e.specializerSpecs=this.specializerSpecs.map(((s,i)=>{let r=t.specializers.find((t=>t.from==s.external));if(!r)return s;let h=Object.assign(Object.assign({},s),{external:r.to});return e.specializers[i]=getSpecializer(h),h}))),t.contextTracker&&(e.context=t.contextTracker),t.dialect&&(e.dialect=this.parseDialect(t.dialect)),null!=t.strict&&(e.strict=t.strict),t.wrap&&(e.wrappers=e.wrappers.concat(t.wrap)),null!=t.bufferLength&&(e.bufferLength=t.bufferLength),e}hasWrappers(){return this.wrappers.length>0}getName(t){return this.termNames?this.termNames[t]:String(t<=this.maxNode&&this.nodeSet.types[t].name||t)}get eofTerm(){return this.maxNode+1}get topNode(){return this.nodeSet.types[this.top[1]]}dynamicPrecedence(t){let e=this.dynamicPrecedences;return null==e?0:e[t]||0}parseDialect(t){let e=Object.keys(this.dialects),s=e.map((()=>!1));if(t)for(let i of t.split(" ")){let t=e.indexOf(i);t>=0&&(s[t]=!0);}let i=null;for(let t=0;t<e.length;t++)if(!s[t])for(let s,r=this.dialects[e[t]];65535!=(s=this.data[r++]);)(i||(i=new Uint8Array(this.maxTerm+1)))[s]=1;return new Dialect(t,s,i)}static deserialize(t){return new LRParser(t)}}function pair(t,e){return t[e]|t[e+1]<<16}function findFinished(t){let e=null;for(let s of t){let t=s.p.stoppedAt;(s.pos==s.p.stream.end||null!=t&&s.pos>t)&&s.p.parser.stateFlag(s.state,2)&&(!e||e.score<s.score)&&(e=s);}return e}function getSpecializer(t){if(t.external){let e=t.extend?1:0;return (s,i)=>t.external(s,i)<<1|e}return t.get}

    const TagName=22,Attribute=23,AttributeName=24,AttributeValue=26,UnquotedAttributeValue=27,selfClosers$1={area:!0,base:!0,br:!0,col:!0,command:!0,embed:!0,frame:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0,menuitem:!0},implicitlyClosed={dd:!0,li:!0,optgroup:!0,option:!0,p:!0,rp:!0,rt:!0,tbody:!0,td:!0,tfoot:!0,th:!0,tr:!0},closeOnOpen={dd:{dd:!0,dt:!0},dt:{dd:!0,dt:!0},li:{li:!0},option:{option:!0,optgroup:!0},optgroup:{optgroup:!0},p:{address:!0,article:!0,aside:!0,blockquote:!0,dir:!0,div:!0,dl:!0,fieldset:!0,footer:!0,form:!0,h1:!0,h2:!0,h3:!0,h4:!0,h5:!0,h6:!0,header:!0,hgroup:!0,hr:!0,menu:!0,nav:!0,ol:!0,p:!0,pre:!0,section:!0,table:!0,ul:!0},rp:{rp:!0,rt:!0},rt:{rp:!0,rt:!0},tbody:{tbody:!0,tfoot:!0},td:{td:!0,th:!0},tfoot:{tbody:!0},th:{td:!0,th:!0},thead:{tbody:!0,tfoot:!0},tr:{tr:!0}};function nameChar(e){return 45==e||46==e||58==e||e>=65&&e<=90||95==e||e>=97&&e<=122||e>=161}function isSpace(e){return 9==e||10==e||13==e||32==e}let cachedName=null,cachedInput=null,cachedPos=0;function tagNameAfter(e,t){let O=e.pos+t;if(cachedPos==O&&cachedInput==e)return cachedName;let a=e.peek(t);for(;isSpace(a);)a=e.peek(++t);let n="";for(;nameChar(a);)n+=String.fromCharCode(a),a=e.peek(++t);return cachedInput=e,cachedPos=O,cachedName=n?n.toLowerCase():a==question||a==bang?void 0:null}const question=63,bang=33;function ElementContext(e,t){this.name=e,this.parent=t,this.hash=t?t.hash:0;for(let t=0;t<e.length;t++)this.hash+=(this.hash<<4)+e.charCodeAt(t)+(e.charCodeAt(t)<<8);}const startTagTerms=[6,10,7,8,9],elementContext=new ContextTracker({start:null,shift:(e,t,O,a)=>startTagTerms.indexOf(t)>-1?new ElementContext(tagNameAfter(a,1)||"",e):e,reduce:(e,t)=>20==t&&e?e.parent:e,reuse(e,t,O,a){let n=t.type.id;return 6==n||36==n?new ElementContext(tagNameAfter(a,1)||"",e):e},hash:e=>e?e.hash:0,strict:!1}),tagStart=new ExternalTokenizer(((e,t)=>{if(60!=e.next)return void(e.next<0&&t.context&&e.acceptToken(57));e.advance();let O=47==e.next;O&&e.advance();let a=tagNameAfter(e,0);if(void 0===a)return;if(!a)return e.acceptToken(O?14:6);let n=t.context?t.context.name:null;if(O){if(a==n)return e.acceptToken(11);if(n&&implicitlyClosed[n])return e.acceptToken(57,-2);if(t.dialectEnabled(0))return e.acceptToken(12);for(let e=t.context;e;e=e.parent)if(e.name==a)return;e.acceptToken(13);}else {if("script"==a)return e.acceptToken(7);if("style"==a)return e.acceptToken(8);if("textarea"==a)return e.acceptToken(9);if(selfClosers$1.hasOwnProperty(a))return e.acceptToken(10);n&&closeOnOpen[n]&&closeOnOpen[n][a]?e.acceptToken(57,-1):e.acceptToken(6);}}),{contextual:!0}),commentContent=new ExternalTokenizer((e=>{for(let t=0,O=0;;O++){if(e.next<0){O&&e.acceptToken(58);break}if(45==e.next)t++;else {if(62==e.next&&t>=2){O>3&&e.acceptToken(58,-2);break}t=0;}e.advance();}}));function inForeignElement(e){for(;e;e=e.parent)if("svg"==e.name||"math"==e.name)return !0;return !1}const endTag=new ExternalTokenizer(((e,t)=>{if(47==e.next&&62==e.peek(1)){let O=t.dialectEnabled(1)||inForeignElement(t.context);e.acceptToken(O?5:4,2);}else 62==e.next&&e.acceptToken(4,1);}));function contentTokenizer(e,t,O){let a=2+e.length;return new ExternalTokenizer((n=>{for(let r=0,s=0,l=0;;l++){if(n.next<0){l&&n.acceptToken(t);break}if(0==r&&60==n.next||1==r&&47==n.next||r>=2&&r<a&&n.next==e.charCodeAt(r-2))r++,s++;else if(2!=r&&r!=a||!isSpace(n.next)){if(r==a&&62==n.next){l>s?n.acceptToken(t,-s):n.acceptToken(O,-(s-2));break}if((10==n.next||13==n.next)&&l){n.acceptToken(t,1);break}r=s=0;}else s++;n.advance();}}))}const scriptTokens=contentTokenizer("script",54,1),styleTokens=contentTokenizer("style",55,2),textareaTokens=contentTokenizer("textarea",56,3),htmlHighlighting=styleTags({"Text RawText":tags$1.content,"StartTag StartCloseTag SelfClosingEndTag EndTag":tags$1.angleBracket,TagName:tags$1.tagName,"MismatchedCloseTag/TagName":[tags$1.tagName,tags$1.invalid],AttributeName:tags$1.attributeName,"AttributeValue UnquotedAttributeValue":tags$1.attributeValue,Is:tags$1.definitionOperator,"EntityReference CharacterReference":tags$1.character,Comment:tags$1.blockComment,ProcessingInst:tags$1.processingInstruction,DoctypeDecl:tags$1.documentMeta}),parser$3=LRParser.deserialize({version:14,states:",xOVO!rOOO!WQ#tO'#CqO!]Q#tO'#CzO!bQ#tO'#C}O!gQ#tO'#DQO!lQ#tO'#DSO!qOaO'#CpO!|ObO'#CpO#XOdO'#CpO$eO!rO'#CpOOO`'#Cp'#CpO$lO$fO'#DTO$tQ#tO'#DVO$yQ#tO'#DWOOO`'#Dk'#DkOOO`'#DY'#DYQVO!rOOO%OQ&rO,59]O%WQ&rO,59fO%`Q&rO,59iO%hQ&rO,59lO%sQ&rO,59nOOOa'#D^'#D^O%{OaO'#CxO&WOaO,59[OOOb'#D_'#D_O&`ObO'#C{O&kObO,59[OOOd'#D`'#D`O&sOdO'#DOO'OOdO,59[OOO`'#Da'#DaO'WO!rO,59[O'_Q#tO'#DROOO`,59[,59[OOOp'#Db'#DbO'dO$fO,59oOOO`,59o,59oO'lQ#|O,59qO'qQ#|O,59rOOO`-E7W-E7WO'vQ&rO'#CsOOQW'#DZ'#DZO(UQ&rO1G.wOOOa1G.w1G.wO(^Q&rO1G/QOOOb1G/Q1G/QO(fQ&rO1G/TOOOd1G/T1G/TO(nQ&rO1G/WOOO`1G/W1G/WOOO`1G/Y1G/YO(yQ&rO1G/YOOOa-E7[-E7[O)RQ#tO'#CyOOO`1G.v1G.vOOOb-E7]-E7]O)WQ#tO'#C|OOOd-E7^-E7^O)]Q#tO'#DPOOO`-E7_-E7_O)bQ#|O,59mOOOp-E7`-E7`OOO`1G/Z1G/ZOOO`1G/]1G/]OOO`1G/^1G/^O)gQ,UO,59_OOQW-E7X-E7XOOOa7+$c7+$cOOOb7+$l7+$lOOOd7+$o7+$oOOO`7+$r7+$rOOO`7+$t7+$tO)rQ#|O,59eO)wQ#|O,59hO)|Q#|O,59kOOO`1G/X1G/XO*RO7[O'#CvO*dOMhO'#CvOOQW1G.y1G.yOOO`1G/P1G/POOO`1G/S1G/SOOO`1G/V1G/VOOOO'#D['#D[O*uO7[O,59bOOQW,59b,59bOOOO'#D]'#D]O+WOMhO,59bOOOO-E7Y-E7YOOQW1G.|1G.|OOOO-E7Z-E7Z",stateData:"+s~O!^OS~OUSOVPOWQOXROYTO[]O][O^^O`^Oa^Ob^Oc^Ox^O{_O!dZO~OfaO~OfbO~OfcO~OfdO~OfeO~O!WfOPlP!ZlP~O!XiOQoP!ZoP~O!YlORrP!ZrP~OUSOVPOWQOXROYTOZqO[]O][O^^O`^Oa^Ob^Oc^Ox^O!dZO~O!ZrO~P#dO![sO!euO~OfvO~OfwO~OS|OhyO~OS!OOhyO~OS!QOhyO~OS!SOT!TOhyO~OS!TOhyO~O!WfOPlX!ZlX~OP!WO!Z!XO~O!XiOQoX!ZoX~OQ!ZO!Z!XO~O!YlORrX!ZrX~OR!]O!Z!XO~O!Z!XO~P#dOf!_O~O![sO!e!aO~OS!bO~OS!cO~Oi!dOSgXhgXTgX~OS!fOhyO~OS!gOhyO~OS!hOhyO~OS!iOT!jOhyO~OS!jOhyO~Of!kO~Of!lO~Of!mO~OS!nO~Ok!qO!`!oO!b!pO~OS!rO~OS!sO~OS!tO~Oa!uOb!uOc!uO!`!wO!a!uO~Oa!xOb!xOc!xO!b!wO!c!xO~Oa!uOb!uOc!uO!`!{O!a!uO~Oa!xOb!xOc!xO!b!{O!c!xO~OT~bac!dx{!d~",goto:"%p!`PPPPPPPPPPPPPPPPPPPP!a!gP!mPP!yP!|#P#S#Y#]#`#f#i#l#r#x!aP!a!aP$O$U$l$r$x%O%U%[%bPPPPPPPP%hX^OX`pXUOX`pezabcde{}!P!R!UR!q!dRhUR!XhXVOX`pRkVR!XkXWOX`pRnWR!XnXXOX`pQrXR!XpXYOX`pQ`ORx`Q{aQ}bQ!PcQ!RdQ!UeZ!e{}!P!R!UQ!v!oR!z!vQ!y!pR!|!yQgUR!VgQjVR!YjQmWR![mQpXR!^pQtZR!`tS_O`ToXp",nodeNames:"⚠ StartCloseTag StartCloseTag StartCloseTag EndTag SelfClosingEndTag StartTag StartTag StartTag StartTag StartTag StartCloseTag StartCloseTag StartCloseTag IncompleteCloseTag Document Text EntityReference CharacterReference InvalidEntity Element OpenTag TagName Attribute AttributeName Is AttributeValue UnquotedAttributeValue ScriptText CloseTag OpenTag StyleText CloseTag OpenTag TextareaText CloseTag OpenTag CloseTag SelfClosingTag Comment ProcessingInst MismatchedCloseTag CloseTag DoctypeDecl",maxTerm:67,context:elementContext,nodeProps:[["closedBy",-10,1,2,3,7,8,9,10,11,12,13,"EndTag",6,"EndTag SelfClosingEndTag",-4,21,30,33,36,"CloseTag"],["openedBy",4,"StartTag StartCloseTag",5,"StartTag",-4,29,32,35,37,"OpenTag"],["group",-9,14,17,18,19,20,39,40,41,42,"Entity",16,"Entity TextContent",-3,28,31,34,"TextContent Entity"]],propSources:[htmlHighlighting],skippedNodes:[0],repeatNodeCount:9,tokenData:"#%g!aR!YOX$qXY,QYZ,QZ[$q[]&X]^,Q^p$qpq,Qqr-_rs4ysv-_vw5iwxJ^x}-_}!OKP!O!P-_!P!Q$q!Q![-_![!]!!O!]!^-_!^!_!&W!_!`#$o!`!a&X!a!c-_!c!}!!O!}#R-_#R#S!!O#S#T3V#T#o!!O#o#s-_#s$f$q$f%W-_%W%o!!O%o%p-_%p&a!!O&a&b-_&b1p!!O1p4U-_4U4d!!O4d4e-_4e$IS!!O$IS$I`-_$I`$Ib!!O$Ib$Kh-_$Kh%#t!!O%#t&/x-_&/x&Et!!O&Et&FV-_&FV;'S!!O;'S;:j!&Q;:j;=`4s<%l?&r-_?&r?Ah!!O?Ah?BY$q?BY?Mn!!O?MnO$q!Z$|c`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr$qrs&}sv$qvw+Pwx(tx!^$q!^!_*V!_!a&X!a#S$q#S#T&X#T;'S$q;'S;=`+z<%lO$q!R&bX`P!a`!cpOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&Xq'UV`P!cpOv&}wx'kx!^&}!^!_(V!_;'S&};'S;=`(n<%lO&}P'pT`POv'kw!^'k!_;'S'k;'S;=`(P<%lO'kP(SP;=`<%l'kp([S!cpOv(Vx;'S(V;'S;=`(h<%lO(Vp(kP;=`<%l(Vq(qP;=`<%l&}a({W`P!a`Or(trs'ksv(tw!^(t!^!_)e!_;'S(t;'S;=`*P<%lO(t`)jT!a`Or)esv)ew;'S)e;'S;=`)y<%lO)e`)|P;=`<%l)ea*SP;=`<%l(t!Q*^V!a`!cpOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!Q*vP;=`<%l*V!R*|P;=`<%l&XW+UYkWOX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+PW+wP;=`<%l+P!Z+}P;=`<%l$q!a,]``P!a`!cp!^^OX&XXY,QYZ,QZ]&X]^,Q^p&Xpq,Qqr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X!_-ljhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx!P-_!P!Q$q!Q!^-_!^!_1n!_!a&X!a#S-_#S#T3V#T#s-_#s$f$q$f;'S-_;'S;=`4s<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q[/echSkWOX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!^!_0p!a#S/^#S#T0p#T#s/^#s$f+P$f;'S/^;'S;=`1h<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+PS0uXhSqr0psw0px!P0p!Q!_0p!a#s0p$f;'S0p;'S;=`1b<%l?Ah0p?BY?Mn0pS1eP;=`<%l0p[1kP;=`<%l/^!U1wbhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!U3SP;=`<%l1n!V3bchS`P!a`!cpOq&Xqr3Vrs&}sv3Vvw0pwx(tx!P3V!P!Q&X!Q!^3V!^!_1n!_!a&X!a#s3V#s$f&X$f;'S3V;'S;=`4m<%l?Ah3V?Ah?BY&X?BY?Mn3V?MnO&X!V4pP;=`<%l3V!_4vP;=`<%l-_!Z5SV!`h`P!cpOv&}wx'kx!^&}!^!_(V!_;'S&};'S;=`(n<%lO&}!_5rjhSkWc!ROX7dXZ8qZ[7d[^8q^p7dqr:crs8qst@Ttw:cwx8qx!P:c!P!Q7d!Q!]:c!]!^/^!^!_=p!_!a8q!a#S:c#S#T=p#T#s:c#s$f7d$f;'S:c;'S;=`?}<%l?Ah:c?Ah?BY7d?BY?Mn:c?MnO7d!Z7ibkWOX7dXZ8qZ[7d[^8q^p7dqr7drs8qst+Ptw7dwx8qx!]7d!]!^9f!^!a8q!a#S7d#S#T8q#T;'S7d;'S;=`:]<%lO7d!R8tVOp8qqs8qt!]8q!]!^9Z!^;'S8q;'S;=`9`<%lO8q!R9`Oa!R!R9cP;=`<%l8q!Z9mYkWa!ROX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+P!Z:`P;=`<%l7d!_:jjhSkWOX7dXZ8qZ[7d[^8q^p7dqr:crs8qst/^tw:cwx8qx!P:c!P!Q7d!Q!]:c!]!^<[!^!_=p!_!a8q!a#S:c#S#T=p#T#s:c#s$f7d$f;'S:c;'S;=`?}<%l?Ah:c?Ah?BY7d?BY?Mn:c?MnO7d!_<echSkWa!ROX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!^!_0p!a#S/^#S#T0p#T#s/^#s$f+P$f;'S/^;'S;=`1h<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+P!V=udhSOp8qqr=prs8qst0ptw=pwx8qx!P=p!P!Q8q!Q!]=p!]!^?T!^!_=p!_!a8q!a#s=p#s$f8q$f;'S=p;'S;=`?w<%l?Ah=p?Ah?BY8q?BY?Mn=p?MnO8q!V?[XhSa!Rqr0psw0px!P0p!Q!_0p!a#s0p$f;'S0p;'S;=`1b<%l?Ah0p?BY?Mn0p!V?zP;=`<%l=p!_@QP;=`<%l:c!_@[ihSkWOXAyXZCTZ[Ay[^CT^pAyqrDrrsCTswDrwxCTx!PDr!P!QAy!Q!]Dr!]!^/^!^!_G|!_!aCT!a#SDr#S#TG|#T#sDr#s$fAy$f;'SDr;'S;=`JW<%l?AhDr?Ah?BYAy?BY?MnDr?MnOAy!ZBOakWOXAyXZCTZ[Ay[^CT^pAyqrAyrsCTswAywxCTx!]Ay!]!^Cu!^!aCT!a#SAy#S#TCT#T;'SAy;'S;=`Dl<%lOAy!RCWUOpCTq!]CT!]!^Cj!^;'SCT;'S;=`Co<%lOCT!RCoOb!R!RCrP;=`<%lCT!ZC|YkWb!ROX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+P!ZDoP;=`<%lAy!_DyihSkWOXAyXZCTZ[Ay[^CT^pAyqrDrrsCTswDrwxCTx!PDr!P!QAy!Q!]Dr!]!^Fh!^!_G|!_!aCT!a#SDr#S#TG|#T#sDr#s$fAy$f;'SDr;'S;=`JW<%l?AhDr?Ah?BYAy?BY?MnDr?MnOAy!_FqchSkWb!ROX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!^!_0p!a#S/^#S#T0p#T#s/^#s$f+P$f;'S/^;'S;=`1h<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+P!VHRchSOpCTqrG|rsCTswG|wxCTx!PG|!P!QCT!Q!]G|!]!^I^!^!_G|!_!aCT!a#sG|#s$fCT$f;'SG|;'S;=`JQ<%l?AhG|?Ah?BYCT?BY?MnG|?MnOCT!VIeXhSb!Rqr0psw0px!P0p!Q!_0p!a#s0p$f;'S0p;'S;=`1b<%l?Ah0p?BY?Mn0p!VJTP;=`<%lG|!_JZP;=`<%lDr!ZJgW!bx`P!a`Or(trs'ksv(tw!^(t!^!_)e!_;'S(t;'S;=`*P<%lO(t!aK^lhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx}-_}!OMU!O!P-_!P!Q$q!Q!^-_!^!_1n!_!a&X!a#S-_#S#T3V#T#s-_#s$f$q$f;'S-_;'S;=`4s<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q!aMckhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx!P-_!P!Q$q!Q!^-_!^!_1n!_!`&X!`!a! W!a#S-_#S#T3V#T#s-_#s$f$q$f;'S-_;'S;=`4s<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q!T! cX`P!a`!cp!eQOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X!a!!_!ZhSfQ`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx}-_}!O!!O!O!P!!O!P!Q$q!Q![!!O![!]!!O!]!^-_!^!_1n!_!a&X!a!c-_!c!}!!O!}#R-_#R#S!!O#S#T3V#T#o!!O#o#s-_#s$f$q$f$}-_$}%O!!O%O%W-_%W%o!!O%o%p-_%p&a!!O&a&b-_&b1p!!O1p4U!!O4U4d!!O4d4e-_4e$IS!!O$IS$I`-_$I`$Ib!!O$Ib$Je-_$Je$Jg!!O$Jg$Kh-_$Kh%#t!!O%#t&/x-_&/x&Et!!O&Et&FV-_&FV;'S!!O;'S;:j!&Q;:j;=`4s<%l?&r-_?&r?Ah!!O?Ah?BY$q?BY?Mn!!O?MnO$q!a!&TP;=`<%l!!O!V!&achS!a`!cpOq*Vqr!'lrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!b!Ey!b#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!'uhhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex}1n}!O!)a!O!P1n!P!Q*V!Q!_1n!_!a*V!a!f1n!f!g!,]!g#W1n#W#X!<y#X#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!)jdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex}1n}!O!*x!O!P1n!P!Q*V!Q!_1n!_!a*V!a#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!+TbhS!a`!cp!dPOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!,fdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!q1n!q!r!-t!r#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!-}dhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!e1n!e!f!/]!f#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!/fdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!v1n!v!w!0t!w#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!0}dhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!{1n!{!|!2]!|#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!2fdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!r1n!r!s!3t!s#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!3}dhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a!g1n!g!h!5]!h#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!5fchS!a`!cpOq!6qqr!5]rs!7hsv!5]vw!;`wx!9[x!P!5]!P!Q!6q!Q!_!5]!_!`!6q!`!a!:j!a#s!5]#s$f!6q$f;'S!5];'S;=`!<s<%l?Ah!5]?Ah?BY!6q?BY?Mn!5]?MnO!6q!R!6xY!a`!cpOr!6qrs!7hsv!6qvw!8Swx!9[x!`!6q!`!a!:j!a;'S!6q;'S;=`!;Y<%lO!6qq!7mV!cpOv!7hvx!8Sx!`!7h!`!a!8q!a;'S!7h;'S;=`!9U<%lO!7hP!8VTO!`!8S!`!a!8f!a;'S!8S;'S;=`!8k<%lO!8SP!8kO{PP!8nP;=`<%l!8Sq!8xS!cp{POv(Vx;'S(V;'S;=`(h<%lO(Vq!9XP;=`<%l!7ha!9aX!a`Or!9[rs!8Ssv!9[vw!8Sw!`!9[!`!a!9|!a;'S!9[;'S;=`!:d<%lO!9[a!:TT!a`{POr)esv)ew;'S)e;'S;=`)y<%lO)ea!:gP;=`<%l!9[!R!:sV!a`!cp{POr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!;]P;=`<%l!6qT!;ebhSOq!8Sqr!;`rs!8Ssw!;`wx!8Sx!P!;`!P!Q!8S!Q!_!;`!_!`!8S!`!a!8f!a#s!;`#s$f!8S$f;'S!;`;'S;=`!<m<%l?Ah!;`?Ah?BY!8S?BY?Mn!;`?MnO!8ST!<pP;=`<%l!;`!V!<vP;=`<%l!5]!V!=SdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#c1n#c#d!>b#d#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!>kdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#V1n#V#W!?y#W#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!@SdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#h1n#h#i!Ab#i#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!AkdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#m1n#m#n!By#n#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!CSdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#d1n#d#e!Db#e#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!DkdhS!a`!cpOq*Vqr1nrs(Vsv1nvw0pwx)ex!P1n!P!Q*V!Q!_1n!_!a*V!a#X1n#X#Y!5]#Y#s1n#s$f*V$f;'S1n;'S;=`3P<%l?Ah1n?Ah?BY*V?BY?Mn1n?MnO*V!V!FSchS!a`!cpOq!G_qr!Eyrs!HUsv!Eyvw!Ncwx!Jvx!P!Ey!P!Q!G_!Q!_!Ey!_!a!G_!a!b##T!b#s!Ey#s$f!G_$f;'S!Ey;'S;=`#$i<%l?Ah!Ey?Ah?BY!G_?BY?Mn!Ey?MnO!G_!R!GfY!a`!cpOr!G_rs!HUsv!G_vw!Hpwx!Jvx!a!G_!a!b!Lv!b;'S!G_;'S;=`!N]<%lO!G_q!HZV!cpOv!HUvx!Hpx!a!HU!a!b!Iq!b;'S!HU;'S;=`!Jp<%lO!HUP!HsTO!a!Hp!a!b!IS!b;'S!Hp;'S;=`!Ik<%lO!HpP!IVTO!`!Hp!`!a!If!a;'S!Hp;'S;=`!Ik<%lO!HpP!IkOxPP!InP;=`<%l!Hpq!IvV!cpOv!HUvx!Hpx!`!HU!`!a!J]!a;'S!HU;'S;=`!Jp<%lO!HUq!JdS!cpxPOv(Vx;'S(V;'S;=`(h<%lO(Vq!JsP;=`<%l!HUa!J{X!a`Or!Jvrs!Hpsv!Jvvw!Hpw!a!Jv!a!b!Kh!b;'S!Jv;'S;=`!Lp<%lO!Jva!KmX!a`Or!Jvrs!Hpsv!Jvvw!Hpw!`!Jv!`!a!LY!a;'S!Jv;'S;=`!Lp<%lO!Jva!LaT!a`xPOr)esv)ew;'S)e;'S;=`)y<%lO)ea!LsP;=`<%l!Jv!R!L}Y!a`!cpOr!G_rs!HUsv!G_vw!Hpwx!Jvx!`!G_!`!a!Mm!a;'S!G_;'S;=`!N]<%lO!G_!R!MvV!a`!cpxPOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!N`P;=`<%l!G_T!NhbhSOq!Hpqr!Ncrs!Hpsw!Ncwx!Hpx!P!Nc!P!Q!Hp!Q!_!Nc!_!a!Hp!a!b# p!b#s!Nc#s$f!Hp$f;'S!Nc;'S;=`#!}<%l?Ah!Nc?Ah?BY!Hp?BY?Mn!Nc?MnO!HpT# ubhSOq!Hpqr!Ncrs!Hpsw!Ncwx!Hpx!P!Nc!P!Q!Hp!Q!_!Nc!_!`!Hp!`!a!If!a#s!Nc#s$f!Hp$f;'S!Nc;'S;=`#!}<%l?Ah!Nc?Ah?BY!Hp?BY?Mn!Nc?MnO!HpT##QP;=`<%l!Nc!V##^chS!a`!cpOq!G_qr!Eyrs!HUsv!Eyvw!Ncwx!Jvx!P!Ey!P!Q!G_!Q!_!Ey!_!`!G_!`!a!Mm!a#s!Ey#s$f!G_$f;'S!Ey;'S;=`#$i<%l?Ah!Ey?Ah?BY!G_?BY?Mn!Ey?MnO!G_!V#$lP;=`<%l!Ey!V#$zXiS`P!a`!cpOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X",tokenizers:[scriptTokens,styleTokens,textareaTokens,endTag,tagStart,commentContent,0,1,2,3,4,5],topRules:{Document:[0,15]},dialects:{noMatch:0,selfClosing:485},tokenPrec:487});function getAttrs(e,t){let O=Object.create(null);for(let a of e.getChildren(Attribute)){let e=a.getChild(AttributeName),n=a.getChild(AttributeValue)||a.getChild(UnquotedAttributeValue);e&&(O[t.read(e.from,e.to)]=n?n.type.id==AttributeValue?t.read(n.from+1,n.to-1):t.read(n.from,n.to):"");}return O}function findTagName(e,t){let O=e.getChild(TagName);return O?t.read(O.from,O.to):" "}function maybeNest(e,t,O){let a;for(let n of O)if(!n.attrs||n.attrs(a||(a=getAttrs(e.node.parent.firstChild,t))))return {parser:n.parser};return null}function configureNesting(e=[],t=[]){let O=[],a=[],n=[],r=[];for(let t of e){("script"==t.tag?O:"style"==t.tag?a:"textarea"==t.tag?n:r).push(t);}let s=t.length?Object.create(null):null;for(let e of t)(s[e.name]||(s[e.name]=[])).push(e);return parseMixed(((e,t)=>{let l=e.type.id;if(28==l)return maybeNest(e,t,O);if(31==l)return maybeNest(e,t,a);if(34==l)return maybeNest(e,t,n);if(20==l&&r.length){let O,a=e.node,n=a.firstChild,s=n&&findTagName(n,t);if(s)for(let e of r)if(e.tag==s&&(!e.attrs||e.attrs(O||(O=getAttrs(a,t))))){let t=a.lastChild;return {parser:e.parser,overlay:[{from:n.to,to:37==t.type.id?t.from:a.to}]}}}if(s&&l==Attribute){let O,a=e.node;if(O=a.firstChild){let e=s[t.read(O.from,O.to)];if(e)for(let O of e){if(O.tagName&&O.tagName!=findTagName(a.parent,t))continue;let e=a.lastChild;if(e.type.id==AttributeValue){let t=e.from+1,a=e.lastChild,n=e.to-(a&&a.isError?0:1);if(n>t)return {parser:O.parser,overlay:[{from:t,to:n}]}}else if(e.type.id==UnquotedAttributeValue)return {parser:O.parser,overlay:[{from:e.from,to:e.to}]}}}}return null}))}

    const space$1=[9,10,11,12,13,32,133,160,5760,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8232,8233,8239,8287,12288];function isAlpha(O){return O>=65&&O<=90||O>=97&&O<=122||O>=161}function isDigit(O){return O>=48&&O<=57}const identifiers=new ExternalTokenizer(((O,e)=>{for(let Q=!1,a=0,t=0;;t++){let{next:o}=O;if(!(isAlpha(o)||45==o||95==o||Q&&isDigit(o))){Q&&O.acceptToken(40==o?96:2==a&&e.canShift(2)?2:97);break}!Q&&(45!=o||t>0)&&(Q=!0),a===t&&45==o&&a++,O.advance();}})),descendant=new ExternalTokenizer((O=>{if(space$1.includes(O.peek(-1))){let{next:e}=O;(isAlpha(e)||95==e||35==e||46==e||91==e||58==e||45==e)&&O.acceptToken(95);}})),unitToken=new ExternalTokenizer((O=>{if(!space$1.includes(O.peek(-1))){let{next:e}=O;if(37==e&&(O.advance(),O.acceptToken(1)),isAlpha(e)){do{O.advance();}while(isAlpha(O.next));O.acceptToken(1);}}})),cssHighlighting=styleTags({"AtKeyword import charset namespace keyframes media supports":tags$1.definitionKeyword,"from to selector":tags$1.keyword,NamespaceName:tags$1.namespace,KeyframeName:tags$1.labelName,KeyframeRangeName:tags$1.operatorKeyword,TagName:tags$1.tagName,ClassName:tags$1.className,PseudoClassName:tags$1.constant(tags$1.className),IdName:tags$1.labelName,"FeatureName PropertyName":tags$1.propertyName,AttributeName:tags$1.attributeName,NumberLiteral:tags$1.number,KeywordQuery:tags$1.keyword,UnaryQueryOp:tags$1.operatorKeyword,"CallTag ValueName":tags$1.atom,VariableName:tags$1.variableName,Callee:tags$1.operatorKeyword,Unit:tags$1.unit,"UniversalSelector NestingSelector":tags$1.definitionOperator,MatchOp:tags$1.compareOperator,"ChildOp SiblingOp, LogicOp":tags$1.logicOperator,BinOp:tags$1.arithmeticOperator,Important:tags$1.modifier,Comment:tags$1.blockComment,ColorLiteral:tags$1.color,"ParenthesizedContent StringLiteral":tags$1.string,":":tags$1.punctuation,"PseudoOp #":tags$1.derefOperator,"; ,":tags$1.separator,"( )":tags$1.paren,"[ ]":tags$1.squareBracket,"{ }":tags$1.brace}),spec_callee={__proto__:null,lang:32,"nth-child":32,"nth-last-child":32,"nth-of-type":32,"nth-last-of-type":32,dir:32,"host-context":32,url:60,"url-prefix":60,domain:60,regexp:60,selector:134},spec_AtKeyword={__proto__:null,"@import":114,"@media":138,"@charset":142,"@namespace":146,"@keyframes":152,"@supports":164},spec_identifier$1={__proto__:null,not:128,only:128},parser$2=LRParser.deserialize({version:14,states:"8`QYQ[OOO#_Q[OOOOQP'#Cd'#CdOOQP'#Cc'#CcO#fQ[O'#CfO$YQXO'#CaO$aQ[O'#ChO$lQ[O'#DPO$qQ[O'#DTOOQP'#Ee'#EeO$vQdO'#DeO%bQ[O'#DrO$vQdO'#DtO%sQ[O'#DvO&OQ[O'#DyO&WQ[O'#EPO&fQ[O'#EROOQS'#Ed'#EdOOQS'#ET'#ETQYQ[OOO&mQXO'#CdO'bQWO'#DaO'gQWO'#EkO'rQ[O'#EkQOQWOOOOQP'#Cg'#CgOOQP,59Q,59QO#fQ[O,59QO'|Q[O'#EWO(hQWO,58{O(pQ[O,59SO$lQ[O,59kO$qQ[O,59oO'|Q[O,59sO'|Q[O,59uO'|Q[O,59vO({Q[O'#D`OOQS,58{,58{OOQP'#Ck'#CkOOQO'#C}'#C}OOQP,59S,59SO)SQWO,59SO)XQWO,59SOOQP'#DR'#DROOQP,59k,59kOOQO'#DV'#DVO)^Q`O,59oOOQS'#Cp'#CpO$vQdO'#CqO)fQvO'#CsO*sQtO,5:POOQO'#Cx'#CxO)XQWO'#CwO+XQWO'#CyOOQS'#Eh'#EhOOQO'#Dh'#DhO+^Q[O'#DoO+lQWO'#ElO&WQ[O'#DmO+zQWO'#DpOOQO'#Em'#EmO(kQWO,5:^O,PQpO,5:`OOQS'#Dx'#DxO,XQWO,5:bO,^Q[O,5:bOOQO'#D{'#D{O,fQWO,5:eO,kQWO,5:kO,sQWO,5:mOOQS-E8R-E8RO$vQdO,59{O,{Q[O'#EYO-YQWO,5;VO-YQWO,5;VOOQP1G.l1G.lO.PQXO,5:rOOQO-E8U-E8UOOQS1G.g1G.gOOQP1G.n1G.nO)SQWO1G.nO)XQWO1G.nOOQP1G/V1G/VO.^Q`O1G/ZO.wQXO1G/_O/_QXO1G/aO/uQXO1G/bO0]QWO,59zO0bQ[O'#DOO0iQdO'#CoOOQP1G/Z1G/ZO$vQdO1G/ZO0pQpO,59]OOQS,59_,59_O$vQdO,59aO0xQWO1G/kOOQS,59c,59cO0}Q!bO,59eO1VQWO'#DhO1bQWO,5:TO1gQWO,5:ZO&WQ[O,5:VO&WQ[O'#EZO1oQWO,5;WO1zQWO,5:XO'|Q[O,5:[OOQS1G/x1G/xOOQS1G/z1G/zOOQS1G/|1G/|O2]QWO1G/|O2bQdO'#D|OOQS1G0P1G0POOQS1G0V1G0VOOQS1G0X1G0XO2mQtO1G/gOOQO,5:t,5:tO3TQ[O,5:tOOQO-E8W-E8WO3bQWO1G0qOOQP7+$Y7+$YOOQP7+$u7+$uO$vQdO7+$uOOQS1G/f1G/fO3mQXO'#EjO3tQWO,59jO3yQtO'#EUO4nQdO'#EgO4xQWO,59ZO4}QpO7+$uOOQS1G.w1G.wOOQS1G.{1G.{OOQS7+%V7+%VO5VQWO1G/PO$vQdO1G/oOOQO1G/u1G/uOOQO1G/q1G/qO5[QWO,5:uOOQO-E8X-E8XO5jQXO1G/vOOQS7+%h7+%hO5qQYO'#CsOOQO'#EO'#EOO5|Q`O'#D}OOQO'#D}'#D}O6XQWO'#E[O6aQdO,5:hOOQS,5:h,5:hO6lQtO'#EXO$vQdO'#EXO7jQdO7+%ROOQO7+%R7+%ROOQO1G0`1G0`O7}QpO<<HaO8VQWO,5;UOOQP1G/U1G/UOOQS-E8S-E8SO$vQdO'#EVO8_QWO,5;ROOQT1G.u1G.uOOQP<<Ha<<HaOOQS7+$k7+$kO8gQdO7+%ZOOQO7+%b7+%bOOQO,5:i,5:iO2eQdO'#E]O6XQWO,5:vOOQS,5:v,5:vOOQS-E8Y-E8YOOQS1G0S1G0SO8nQtO,5:sOOQS-E8V-E8VOOQO<<Hm<<HmOOQPAN={AN={O9lQdO,5:qOOQO-E8T-E8TOOQO<<Hu<<HuOOQO,5:w,5:wOOQO-E8Z-E8ZOOQS1G0b1G0b",stateData:":O~O#VOSROS~OUXOXXO]UO^UOtVOxWO!Y`O!ZYO!gZO!i[O!k]O!n^O!t_O#TQO#YSO~OQeOUXOXXO]UO^UOtVOxWO!Y`O!ZYO!gZO!i[O!k]O!n^O!t_O#TdO#YSO~O#Q#_P~P!ZO#TiO~O]nO^nOplOtoOxpO|qO!PsO#RrO#YkO~O!RtO~P#kO`zO#SwO#TvO~O#T{O~O#T}O~OQ!WOb!QOf!WOh!WOn!VO#S!TO#T!PO#]!RO~Ob!YO!b![O!e!]O#T!XO!R#`P~Oh!bOn!VO#T!aO~Oh!dO#T!dO~Ob!YO!b![O!e!]O#T!XO~O!W#`P~P%bO]WX]!UX^WXpWXtWXxWX|WX!PWX!RWX#RWX#YWX~O]!iO~O!W!jO#Q#_X!Q#_X~O#Q#_X!Q#_X~P!ZOUXOXXO]UO^UOtVOxWO#TQO#YSO~OplO!RtO~O`!sO#SwO#TvO~O!Q#_P~P!ZOb!zO~Ob!{O~Ov!|Oz!}O~OP#PObgXjgX!WgX!bgX!egX#TgXagXQgXfgXhgXngXpgX!VgX#QgX#SgX#]gXvgX!QgX~Ob!YOj#QO!b![O!e!]O#T!XO!W#`P~Ob#TO~Ob!YO!b![O!e!]O#T#UO~Op#YO!`#XO!R#`X!W#`X~Ob#]O~Oj#QO!W#_O~O!W#`O~Oh#aOn!VO~O!R#bO~O!RtO!`#XO~O!RtO!W#eO~O!W!|X#Q!|X!Q!|X~P!ZO!W!jO#Q#_a!Q#_a~O]nO^nOtoOxpO|qO!PsO#RrO#YkO~Op!za!R!zaa!za~P-eOv#lOz#mO~O]nO^nOtoOxpO#YkO~Op{i|{i!P{i!R{i#R{ia{i~P.fOp}i|}i!P}i!R}i#R}ia}i~P.fOp!Oi|!Oi!P!Oi!R!Oi#R!Oia!Oi~P.fO!Q#nO~Oa#^P~P'|Oa#ZP~P$vOa#uOj#QO~O!W#wO~Oh#xOo#xO~O]!^Xa![X!`![X~O]#yO~Oa#zO!`#XO~Op#YO!R#`a!W#`a~O!`#XOp!aa!R!aa!W!aaa!aa~O!W$PO~O!Q$WO#T$RO#]$QO~Oj#QOp$YO!V$[O!W!Ti#Q!Ti!Q!Ti~P$vO!W!|a#Q!|a!Q!|a~P!ZO!W!jO#Q#_i!Q#_i~Oa#^X~P#kOa$`O~Oj#QOQ!xXa!xXb!xXf!xXh!xXn!xXp!xX#S!xX#T!xX#]!xX~Op$bOa#ZX~P$vOa$dO~Oj#QOv$eO~Oa$fO~O!`#XOp!}a!R!}a!W!}a~Oa$hO~P-eOP#POpgX!RgX~O#]$QOp!qX!R!qX~Op$jO!RtO~O!Q$nO#T$RO#]$QO~Oj#QOQ!{Xb!{Xf!{Xh!{Xn!{Xp!{X!V!{X!W!{X#Q!{X#S!{X#T!{X#]!{X!Q!{X~Op$YO!V$qO!W!Tq#Q!Tq!Q!Tq~P$vOj#QOv$rO~OplOa#^a~Op$bOa#Za~Oa$uO~P$vOj#QOQ!{ab!{af!{ah!{an!{ap!{a!V!{a!W!{a#Q!{a#S!{a#T!{a#]!{a!Q!{a~Oa!yap!ya~P$vO#VoR#]j!Pj~",goto:",z#bPPPPP#cP#l#{P#l$[#lPP$bPPP$h$q$qP%TP$qP$q%o&RPPP&k&q#lP&wP#lP&}P#lP#l#lPPP'T'j'wPP#cPP(O(O(Y(OP(OP(O(OP#cP#cP#cP(]#cP(`(c(f(m#cP#cP(r)R)a)g)q)w*R*X*_PPPPPP*e*nP+Z+^P,S,V,],f_aOPcgt!j#hkXOPcglqrst!j!z#]#hkROPcglqrst!j!z#]#hQjSR!mkQxUR!qnQ!qzQ#S!UR#k!sq!WY[!Q!i!{!}#Q#f#m#r#y$Y$Z$b$g$sp!WY[!Q!i!{!}#Q#f#m#r#y$Y$Z$b$g$sU$T#b$V$jR$i$Sq!UY[!Q!i!{!}#Q#f#m#r#y$Y$Z$b$g$sp!WY[!Q!i!{!}#Q#f#m#r#y$Y$Z$b$g$sQ!b]R#a!cQyUR!rnQ!qyR#k!rQ|VR!toQ!OWR!upQuTQ!pmQ#^!_Q#d!fQ#e!gQ$l$UR$x$kSfPtQ!lgQ#g!jR$]#hZePgt!j#ha!^Z_`!S!Y![#X#YR#V!YR!c]R!e^R#c!eS$U#b$VR$v$jV$S#b$V$jQcOSgPtU!hcg#hR#h!jQ#r!{U$a#r$g$sQ$g#yR$s$bQ$c#rR$t$cQmTS!om$_R$_#oQ$Z#fR$p$ZQ!kfS#i!k#jR#j!lQ#Z!ZR#}#ZQ$V#bR$m$VQ$k$UR$w$k_bOPcgt!j#h^TOPcgt!j#hQ!nlQ!vqQ!wrQ!xsQ#o!zR$O#]R#s!{Q!SYQ!`[Q#O!QQ#f!i[#q!{#r#y$b$g$sQ#t!}Q#v#QS$X#f$ZQ$^#mR$o$YR#p!zQhPR!ytQ!_ZQ!g`R#R!SU!ZZ`!SQ!f_Q#W!YQ#[![Q#{#XR#|#Y",nodeNames:"⚠ Unit VariableName Comment StyleSheet RuleSet UniversalSelector TagSelector TagName NestingSelector ClassSelector ClassName PseudoClassSelector : :: PseudoClassName PseudoClassName ) ( ArgList ValueName ParenthesizedValue ColorLiteral NumberLiteral StringLiteral BinaryExpression BinOp CallExpression Callee CallLiteral CallTag ParenthesizedContent , PseudoClassName ArgList IdSelector # IdName ] AttributeSelector [ AttributeName MatchOp ChildSelector ChildOp DescendantSelector SiblingSelector SiblingOp } { Block Declaration PropertyName Important ; ImportStatement AtKeyword import KeywordQuery FeatureQuery FeatureName BinaryQuery LogicOp UnaryQuery UnaryQueryOp ParenthesizedQuery SelectorQuery selector MediaStatement media CharsetStatement charset NamespaceStatement namespace NamespaceName KeyframesStatement keyframes KeyframeName KeyframeList KeyframeSelector KeyframeRangeName SupportsStatement supports AtRule Styles",maxTerm:109,nodeProps:[["openedBy",17,"(",48,"{"],["closedBy",18,")",49,"}"]],propSources:[cssHighlighting],skippedNodes:[0,3],repeatNodeCount:9,tokenData:"Lq~R!^OX$}X^%u^p$}pq%uqr)Xrs.Rst/utu6duv$}vw7^wx7oxy9^yz9oz{9t{|:_|}?Q}!O?c!O!P@Q!P!Q@i!Q![Cu![!]Dp!]!^El!^!_$}!_!`E}!`!aF`!a!b$}!b!cG[!c!}$}!}#OHt#O#P$}#P#QIV#Q#R6d#R#T$}#T#UIh#U#c$}#c#dJy#d#o$}#o#pK`#p#q6d#q#rKq#r#sLS#s#y$}#y#z%u#z$f$}$f$g%u$g#BY$}#BY#BZ%u#BZ$IS$}$IS$I_%u$I_$I|$}$I|$JO%u$JO$JT$}$JT$JU%u$JU$KV$}$KV$KW%u$KW&FU$}&FU&FV%u&FV;'S$};'S;=`Lk<%lO$}W%QSOy%^z;'S%^;'S;=`%o<%lO%^W%cSoWOy%^z;'S%^;'S;=`%o<%lO%^W%rP;=`<%l%^~%zh#V~OX%^X^'f^p%^pq'fqy%^z#y%^#y#z'f#z$f%^$f$g'f$g#BY%^#BY#BZ'f#BZ$IS%^$IS$I_'f$I_$I|%^$I|$JO'f$JO$JT%^$JT$JU'f$JU$KV%^$KV$KW'f$KW&FU%^&FU&FV'f&FV;'S%^;'S;=`%o<%lO%^~'mh#V~oWOX%^X^'f^p%^pq'fqy%^z#y%^#y#z'f#z$f%^$f$g'f$g#BY%^#BY#BZ'f#BZ$IS%^$IS$I_'f$I_$I|%^$I|$JO'f$JO$JT%^$JT$JU'f$JU$KV%^$KV$KW'f$KW&FU%^&FU&FV'f&FV;'S%^;'S;=`%o<%lO%^^)[UOy%^z#]%^#]#^)n#^;'S%^;'S;=`%o<%lO%^^)sUoWOy%^z#a%^#a#b*V#b;'S%^;'S;=`%o<%lO%^^*[UoWOy%^z#d%^#d#e*n#e;'S%^;'S;=`%o<%lO%^^*sUoWOy%^z#c%^#c#d+V#d;'S%^;'S;=`%o<%lO%^^+[UoWOy%^z#f%^#f#g+n#g;'S%^;'S;=`%o<%lO%^^+sUoWOy%^z#h%^#h#i,V#i;'S%^;'S;=`%o<%lO%^^,[UoWOy%^z#T%^#T#U,n#U;'S%^;'S;=`%o<%lO%^^,sUoWOy%^z#b%^#b#c-V#c;'S%^;'S;=`%o<%lO%^^-[UoWOy%^z#h%^#h#i-n#i;'S%^;'S;=`%o<%lO%^^-uS!VUoWOy%^z;'S%^;'S;=`%o<%lO%^~.UWOY.RZr.Rrs.ns#O.R#O#P.s#P;'S.R;'S;=`/o<%lO.R~.sOh~~.vRO;'S.R;'S;=`/P;=`O.R~/SXOY.RZr.Rrs.ns#O.R#O#P.s#P;'S.R;'S;=`/o;=`<%l.R<%lO.R~/rP;=`<%l.R_/zYtPOy%^z!Q%^!Q![0j![!c%^!c!i0j!i#T%^#T#Z0j#Z;'S%^;'S;=`%o<%lO%^^0oYoWOy%^z!Q%^!Q![1_![!c%^!c!i1_!i#T%^#T#Z1_#Z;'S%^;'S;=`%o<%lO%^^1dYoWOy%^z!Q%^!Q![2S![!c%^!c!i2S!i#T%^#T#Z2S#Z;'S%^;'S;=`%o<%lO%^^2ZYfUoWOy%^z!Q%^!Q![2y![!c%^!c!i2y!i#T%^#T#Z2y#Z;'S%^;'S;=`%o<%lO%^^3QYfUoWOy%^z!Q%^!Q![3p![!c%^!c!i3p!i#T%^#T#Z3p#Z;'S%^;'S;=`%o<%lO%^^3uYoWOy%^z!Q%^!Q![4e![!c%^!c!i4e!i#T%^#T#Z4e#Z;'S%^;'S;=`%o<%lO%^^4lYfUoWOy%^z!Q%^!Q![5[![!c%^!c!i5[!i#T%^#T#Z5[#Z;'S%^;'S;=`%o<%lO%^^5aYoWOy%^z!Q%^!Q![6P![!c%^!c!i6P!i#T%^#T#Z6P#Z;'S%^;'S;=`%o<%lO%^^6WSfUoWOy%^z;'S%^;'S;=`%o<%lO%^Y6gUOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^Y7QSzQoWOy%^z;'S%^;'S;=`%o<%lO%^X7cSXPOy%^z;'S%^;'S;=`%o<%lO%^~7rWOY7oZw7owx.nx#O7o#O#P8[#P;'S7o;'S;=`9W<%lO7o~8_RO;'S7o;'S;=`8h;=`O7o~8kXOY7oZw7owx.nx#O7o#O#P8[#P;'S7o;'S;=`9W;=`<%l7o<%lO7o~9ZP;=`<%l7o_9cSbVOy%^z;'S%^;'S;=`%o<%lO%^~9tOa~_9{UUPjSOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^_:fWjS!PPOy%^z!O%^!O!P;O!P!Q%^!Q![>T![;'S%^;'S;=`%o<%lO%^^;TUoWOy%^z!Q%^!Q![;g![;'S%^;'S;=`%o<%lO%^^;nYoW#]UOy%^z!Q%^!Q![;g![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^^<cYoWOy%^z{%^{|=R|}%^}!O=R!O!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^^=WUoWOy%^z!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^^=qUoW#]UOy%^z!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^^>[[oW#]UOy%^z!O%^!O!P;g!P!Q%^!Q![>T![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^_?VSpVOy%^z;'S%^;'S;=`%o<%lO%^^?hWjSOy%^z!O%^!O!P;O!P!Q%^!Q![>T![;'S%^;'S;=`%o<%lO%^_@VU#YPOy%^z!Q%^!Q![;g![;'S%^;'S;=`%o<%lO%^~@nTjSOy%^z{@}{;'S%^;'S;=`%o<%lO%^~ASUoWOy@}yzAfz{Bm{;'S@};'S;=`Co<%lO@}~AiTOzAfz{Ax{;'SAf;'S;=`Bg<%lOAf~A{VOzAfz{Ax{!PAf!P!QBb!Q;'SAf;'S;=`Bg<%lOAf~BgOR~~BjP;=`<%lAf~BrWoWOy@}yzAfz{Bm{!P@}!P!QC[!Q;'S@};'S;=`Co<%lO@}~CcSoWR~Oy%^z;'S%^;'S;=`%o<%lO%^~CrP;=`<%l@}^Cz[#]UOy%^z!O%^!O!P;g!P!Q%^!Q![>T![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^XDuU]POy%^z![%^![!]EX!];'S%^;'S;=`%o<%lO%^XE`S^PoWOy%^z;'S%^;'S;=`%o<%lO%^_EqS!WVOy%^z;'S%^;'S;=`%o<%lO%^YFSSzQOy%^z;'S%^;'S;=`%o<%lO%^XFeU|POy%^z!`%^!`!aFw!a;'S%^;'S;=`%o<%lO%^XGOS|PoWOy%^z;'S%^;'S;=`%o<%lO%^XG_WOy%^z!c%^!c!}Gw!}#T%^#T#oGw#o;'S%^;'S;=`%o<%lO%^XHO[!YPoWOy%^z}%^}!OGw!O!Q%^!Q![Gw![!c%^!c!}Gw!}#T%^#T#oGw#o;'S%^;'S;=`%o<%lO%^XHySxPOy%^z;'S%^;'S;=`%o<%lO%^^I[SvUOy%^z;'S%^;'S;=`%o<%lO%^XIkUOy%^z#b%^#b#cI}#c;'S%^;'S;=`%o<%lO%^XJSUoWOy%^z#W%^#W#XJf#X;'S%^;'S;=`%o<%lO%^XJmS!`PoWOy%^z;'S%^;'S;=`%o<%lO%^XJ|UOy%^z#f%^#f#gJf#g;'S%^;'S;=`%o<%lO%^ZKeS!RROy%^z;'S%^;'S;=`%o<%lO%^_KvS!QVOy%^z;'S%^;'S;=`%o<%lO%^ZLXU!PPOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^WLnP;=`<%l$}",tokenizers:[descendant,unitToken,identifiers,0,1,2,3],topRules:{StyleSheet:[0,4],Styles:[1,84]},specialized:[{term:96,get:O=>spec_callee[O]||-1},{term:56,get:O=>spec_AtKeyword[O]||-1},{term:97,get:O=>spec_identifier$1[O]||-1}],tokenPrec:1142});

    let _properties=null;function properties(){if(!_properties&&"object"==typeof document&&document.body){let{style:e}=document.body,t=[],r=new Set;for(let a in e)"cssText"!=a&&"cssFloat"!=a&&"string"==typeof e[a]&&(/[A-Z]/.test(a)&&(a=a.replace(/[A-Z]/g,(e=>"-"+e.toLowerCase()))),r.has(a)||(t.push(a),r.add(a)));_properties=t.sort().map((e=>({type:"property",label:e})));}return _properties||[]}const pseudoClasses=["active","after","any-link","autofill","backdrop","before","checked","cue","default","defined","disabled","empty","enabled","file-selector-button","first","first-child","first-letter","first-line","first-of-type","focus","focus-visible","focus-within","fullscreen","has","host","host-context","hover","in-range","indeterminate","invalid","is","lang","last-child","last-of-type","left","link","marker","modal","not","nth-child","nth-last-child","nth-last-of-type","nth-of-type","only-child","only-of-type","optional","out-of-range","part","placeholder","placeholder-shown","read-only","read-write","required","right","root","scope","selection","slotted","target","target-text","valid","visited","where"].map((e=>({type:"class",label:e}))),values=["above","absolute","activeborder","additive","activecaption","after-white-space","ahead","alias","all","all-scroll","alphabetic","alternate","always","antialiased","appworkspace","asterisks","attr","auto","auto-flow","avoid","avoid-column","avoid-page","avoid-region","axis-pan","background","backwards","baseline","below","bidi-override","blink","block","block-axis","bold","bolder","border","border-box","both","bottom","break","break-all","break-word","bullets","button","button-bevel","buttonface","buttonhighlight","buttonshadow","buttontext","calc","capitalize","caps-lock-indicator","caption","captiontext","caret","cell","center","checkbox","circle","cjk-decimal","clear","clip","close-quote","col-resize","collapse","color","color-burn","color-dodge","column","column-reverse","compact","condensed","contain","content","contents","content-box","context-menu","continuous","copy","counter","counters","cover","crop","cross","crosshair","currentcolor","cursive","cyclic","darken","dashed","decimal","decimal-leading-zero","default","default-button","dense","destination-atop","destination-in","destination-out","destination-over","difference","disc","discard","disclosure-closed","disclosure-open","document","dot-dash","dot-dot-dash","dotted","double","down","e-resize","ease","ease-in","ease-in-out","ease-out","element","ellipse","ellipsis","embed","end","ethiopic-abegede-gez","ethiopic-halehame-aa-er","ethiopic-halehame-gez","ew-resize","exclusion","expanded","extends","extra-condensed","extra-expanded","fantasy","fast","fill","fill-box","fixed","flat","flex","flex-end","flex-start","footnotes","forwards","from","geometricPrecision","graytext","grid","groove","hand","hard-light","help","hidden","hide","higher","highlight","highlighttext","horizontal","hsl","hsla","hue","icon","ignore","inactiveborder","inactivecaption","inactivecaptiontext","infinite","infobackground","infotext","inherit","initial","inline","inline-axis","inline-block","inline-flex","inline-grid","inline-table","inset","inside","intrinsic","invert","italic","justify","keep-all","landscape","large","larger","left","level","lighter","lighten","line-through","linear","linear-gradient","lines","list-item","listbox","listitem","local","logical","loud","lower","lower-hexadecimal","lower-latin","lower-norwegian","lowercase","ltr","luminosity","manipulation","match","matrix","matrix3d","medium","menu","menutext","message-box","middle","min-intrinsic","mix","monospace","move","multiple","multiple_mask_images","multiply","n-resize","narrower","ne-resize","nesw-resize","no-close-quote","no-drop","no-open-quote","no-repeat","none","normal","not-allowed","nowrap","ns-resize","numbers","numeric","nw-resize","nwse-resize","oblique","opacity","open-quote","optimizeLegibility","optimizeSpeed","outset","outside","outside-shape","overlay","overline","padding","padding-box","painted","page","paused","perspective","pinch-zoom","plus-darker","plus-lighter","pointer","polygon","portrait","pre","pre-line","pre-wrap","preserve-3d","progress","push-button","radial-gradient","radio","read-only","read-write","read-write-plaintext-only","rectangle","region","relative","repeat","repeating-linear-gradient","repeating-radial-gradient","repeat-x","repeat-y","reset","reverse","rgb","rgba","ridge","right","rotate","rotate3d","rotateX","rotateY","rotateZ","round","row","row-resize","row-reverse","rtl","run-in","running","s-resize","sans-serif","saturation","scale","scale3d","scaleX","scaleY","scaleZ","screen","scroll","scrollbar","scroll-position","se-resize","self-start","self-end","semi-condensed","semi-expanded","separate","serif","show","single","skew","skewX","skewY","skip-white-space","slide","slider-horizontal","slider-vertical","sliderthumb-horizontal","sliderthumb-vertical","slow","small","small-caps","small-caption","smaller","soft-light","solid","source-atop","source-in","source-out","source-over","space","space-around","space-between","space-evenly","spell-out","square","start","static","status-bar","stretch","stroke","stroke-box","sub","subpixel-antialiased","svg_masks","super","sw-resize","symbolic","symbols","system-ui","table","table-caption","table-cell","table-column","table-column-group","table-footer-group","table-header-group","table-row","table-row-group","text","text-bottom","text-top","textarea","textfield","thick","thin","threeddarkshadow","threedface","threedhighlight","threedlightshadow","threedshadow","to","top","transform","translate","translate3d","translateX","translateY","translateZ","transparent","ultra-condensed","ultra-expanded","underline","unidirectional-pan","unset","up","upper-latin","uppercase","url","var","vertical","vertical-text","view-box","visible","visibleFill","visiblePainted","visibleStroke","visual","w-resize","wait","wave","wider","window","windowframe","windowtext","words","wrap","wrap-reverse","x-large","x-small","xor","xx-large","xx-small"].map((e=>({type:"keyword",label:e}))).concat(["aliceblue","antiquewhite","aqua","aquamarine","azure","beige","bisque","black","blanchedalmond","blue","blueviolet","brown","burlywood","cadetblue","chartreuse","chocolate","coral","cornflowerblue","cornsilk","crimson","cyan","darkblue","darkcyan","darkgoldenrod","darkgray","darkgreen","darkkhaki","darkmagenta","darkolivegreen","darkorange","darkorchid","darkred","darksalmon","darkseagreen","darkslateblue","darkslategray","darkturquoise","darkviolet","deeppink","deepskyblue","dimgray","dodgerblue","firebrick","floralwhite","forestgreen","fuchsia","gainsboro","ghostwhite","gold","goldenrod","gray","grey","green","greenyellow","honeydew","hotpink","indianred","indigo","ivory","khaki","lavender","lavenderblush","lawngreen","lemonchiffon","lightblue","lightcoral","lightcyan","lightgoldenrodyellow","lightgray","lightgreen","lightpink","lightsalmon","lightseagreen","lightskyblue","lightslategray","lightsteelblue","lightyellow","lime","limegreen","linen","magenta","maroon","mediumaquamarine","mediumblue","mediumorchid","mediumpurple","mediumseagreen","mediumslateblue","mediumspringgreen","mediumturquoise","mediumvioletred","midnightblue","mintcream","mistyrose","moccasin","navajowhite","navy","oldlace","olive","olivedrab","orange","orangered","orchid","palegoldenrod","palegreen","paleturquoise","palevioletred","papayawhip","peachpuff","peru","pink","plum","powderblue","purple","rebeccapurple","red","rosybrown","royalblue","saddlebrown","salmon","sandybrown","seagreen","seashell","sienna","silver","skyblue","slateblue","slategray","snow","springgreen","steelblue","tan","teal","thistle","tomato","turquoise","violet","wheat","white","whitesmoke","yellow","yellowgreen"].map((e=>({type:"constant",label:e})))),tags=["a","abbr","address","article","aside","b","bdi","bdo","blockquote","body","br","button","canvas","caption","cite","code","col","colgroup","dd","del","details","dfn","dialog","div","dl","dt","em","figcaption","figure","footer","form","header","hgroup","h1","h2","h3","h4","h5","h6","hr","html","i","iframe","img","input","ins","kbd","label","legend","li","main","meter","nav","ol","output","p","pre","ruby","section","select","small","source","span","strong","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","tr","u","ul"].map((e=>({type:"type",label:e}))),identifier$1=/^(\w[\w-]*|-\w[\w-]*|)$/,variable=/^-(-[\w-]*)?$/;function isVarArg(e,t){var r;if(("("==e.name||e.type.isError)&&(e=e.parent||e),"ArgList"!=e.name)return !1;let a=null===(r=e.parent)||void 0===r?void 0:r.firstChild;return "Callee"==(null==a?void 0:a.name)&&"var"==t.sliceString(a.from,a.to)}const VariablesByNode=new NodeWeakMap,declSelector=["Declaration"];function astTop(e){for(let t=e;;){if(t.type.isTop)return t;if(!(t=t.parent))return e}}function variableNames(e,t,r){if(t.to-t.from>4096){let a=VariablesByNode.get(t);if(a)return a;let o=[],i=new Set,l=t.cursor(IterMode.IncludeAnonymous);if(l.firstChild())do{for(let t of variableNames(e,l.node,r))i.has(t.label)||(i.add(t.label),o.push(t));}while(l.nextSibling());return VariablesByNode.set(t,o),o}{let a=[],o=new Set;return t.cursor().iterate((t=>{var i;if(r(t)&&t.matchContext(declSelector)&&":"==(null===(i=t.node.nextSibling)||void 0===i?void 0:i.name)){let r=e.sliceString(t.from,t.to);o.has(r)||(o.add(r),a.push({label:r,type:"variable"}));}})),a}}const defineCSSCompletionSource=e=>t=>{let{state:r,pos:a}=t,o=syntaxTree(r).resolveInner(a,-1),i=o.type.isError&&o.from==o.to-1&&"-"==r.doc.sliceString(o.from,o.to);if("PropertyName"==o.name||(i||"TagName"==o.name)&&/^(Block|Styles)$/.test(o.resolve(o.to).name))return {from:o.from,options:properties(),validFor:identifier$1};if("ValueName"==o.name)return {from:o.from,options:values,validFor:identifier$1};if("PseudoClassName"==o.name)return {from:o.from,options:pseudoClasses,validFor:identifier$1};if(e(o)||(t.explicit||i)&&isVarArg(o,r.doc))return {from:e(o)||i?o.from:a,options:variableNames(r.doc,astTop(o),e),validFor:variable};if("TagName"==o.name){for(let{parent:e}=o;e;e=e.parent)if("Block"==e.name)return {from:o.from,options:properties(),validFor:identifier$1};return {from:o.from,options:tags,validFor:identifier$1}}if(!t.explicit)return null;let l=o.resolve(a),n=l.childBefore(a);return n&&":"==n.name&&"PseudoClassSelector"==l.name?{from:a,options:pseudoClasses,validFor:identifier$1}:n&&":"==n.name&&"Declaration"==l.name||"ArgList"==l.name?{from:a,options:values,validFor:identifier$1}:"Block"==l.name||"Styles"==l.name?{from:a,options:properties(),validFor:identifier$1}:null},cssCompletionSource=defineCSSCompletionSource((e=>"VariableName"==e.name)),cssLanguage=LRLanguage.define({name:"css",parser:parser$2.configure({props:[indentNodeProp.add({Declaration:continuedIndent()}),foldNodeProp.add({Block:foldInside})]}),languageData:{commentTokens:{block:{open:"/*",close:"*/"}},indentOnInput:/^\s*\}$/,wordChars:"-"}});function css(){return new LanguageSupport(cssLanguage,cssLanguage.data.of({autocomplete:cssCompletionSource}))}

    const space=[9,10,11,12,13,32,133,160,5760,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8232,8233,8239,8287,12288],trackNewline=new ContextTracker({start:!1,shift:(O,Q)=>3==Q||4==Q||305==Q?O:306==Q,strict:!1}),insertSemicolon=new ExternalTokenizer(((O,Q)=>{let{next:$}=O;(125==$||-1==$||Q.context)&&Q.canShift(303)&&O.acceptToken(303);}),{contextual:!0,fallback:!0}),noSemicolon=new ExternalTokenizer(((O,Q)=>{let $,{next:i}=O;space.indexOf(i)>-1||(47!=i||47!=($=O.peek(1))&&42!=$)&&125!=i&&59!=i&&-1!=i&&!Q.context&&Q.canShift(302)&&O.acceptToken(302);}),{contextual:!0}),incdecToken=new ExternalTokenizer(((O,Q)=>{let{next:$}=O;if((43==$||45==$)&&(O.advance(),$==O.next)){O.advance();let $=!Q.context&&Q.canShift(1);O.acceptToken($?1:2);}}),{contextual:!0}),jsHighlight=styleTags({"get set async static":tags$1.modifier,"for while do if else switch try catch finally return throw break continue default case":tags$1.controlKeyword,"in of await yield void typeof delete instanceof":tags$1.operatorKeyword,"let var const function class extends":tags$1.definitionKeyword,"import export from":tags$1.moduleKeyword,"with debugger as new":tags$1.keyword,TemplateString:tags$1.special(tags$1.string),super:tags$1.atom,BooleanLiteral:tags$1.bool,this:tags$1.self,null:tags$1.null,Star:tags$1.modifier,VariableName:tags$1.variableName,"CallExpression/VariableName TaggedTemplateExpression/VariableName":tags$1.function(tags$1.variableName),VariableDefinition:tags$1.definition(tags$1.variableName),Label:tags$1.labelName,PropertyName:tags$1.propertyName,PrivatePropertyName:tags$1.special(tags$1.propertyName),"CallExpression/MemberExpression/PropertyName":tags$1.function(tags$1.propertyName),"FunctionDeclaration/VariableDefinition":tags$1.function(tags$1.definition(tags$1.variableName)),"ClassDeclaration/VariableDefinition":tags$1.definition(tags$1.className),PropertyDefinition:tags$1.definition(tags$1.propertyName),PrivatePropertyDefinition:tags$1.definition(tags$1.special(tags$1.propertyName)),UpdateOp:tags$1.updateOperator,LineComment:tags$1.lineComment,BlockComment:tags$1.blockComment,Number:tags$1.number,String:tags$1.string,Escape:tags$1.escape,ArithOp:tags$1.arithmeticOperator,LogicOp:tags$1.logicOperator,BitOp:tags$1.bitwiseOperator,CompareOp:tags$1.compareOperator,RegExp:tags$1.regexp,Equals:tags$1.definitionOperator,Arrow:tags$1.function(tags$1.punctuation),": Spread":tags$1.punctuation,"( )":tags$1.paren,"[ ]":tags$1.squareBracket,"{ }":tags$1.brace,"InterpolationStart InterpolationEnd":tags$1.special(tags$1.brace),".":tags$1.derefOperator,", ;":tags$1.separator,"@":tags$1.meta,TypeName:tags$1.typeName,TypeDefinition:tags$1.definition(tags$1.typeName),"type enum interface implements namespace module declare":tags$1.definitionKeyword,"abstract global Privacy readonly override":tags$1.modifier,"is keyof unique infer":tags$1.operatorKeyword,JSXAttributeValue:tags$1.attributeValue,JSXText:tags$1.content,"JSXStartTag JSXStartCloseTag JSXSelfCloseEndTag JSXEndTag":tags$1.angleBracket,"JSXIdentifier JSXNameSpacedName":tags$1.tagName,"JSXAttribute/JSXIdentifier JSXAttribute/JSXNameSpacedName":tags$1.attributeName,"JSXBuiltin/JSXIdentifier":tags$1.standard(tags$1.tagName)}),spec_identifier={__proto__:null,export:14,as:19,from:27,default:30,async:35,function:36,extends:46,this:50,true:58,false:58,null:70,void:74,typeof:78,super:96,new:130,delete:146,yield:155,await:159,class:164,public:221,private:221,protected:221,readonly:223,instanceof:242,satisfies:245,in:246,const:248,import:280,keyof:335,unique:339,infer:345,is:381,abstract:401,implements:403,type:405,let:408,var:410,interface:417,enum:421,namespace:427,module:429,declare:433,global:437,for:456,of:465,while:468,with:472,do:476,if:480,else:482,switch:486,case:492,try:498,catch:502,finally:506,return:510,throw:514,break:518,continue:522,debugger:526},spec_word={__proto__:null,async:117,get:119,set:121,declare:181,public:183,private:183,protected:183,static:185,abstract:187,override:189,readonly:195,accessor:197,new:385},spec_LessThan={__proto__:null,"<":137},parser$1=LRParser.deserialize({version:14,states:"$6[O`QUOOO%QQUOOO'TQWOOP(bOSOOO*pQ(CjO'#CfO*wOpO'#CgO+VO!bO'#CgO+eO07`O'#DZO-vQUO'#DaO.WQUO'#DlO%QQUO'#DvO0[QUO'#EOOOQ(CY'#EW'#EWO0uQSO'#ETOOQO'#Ei'#EiOOQO'#Ib'#IbO0}QSO'#GkO1YQSO'#EhO1_QSO'#EhO3aQ(CjO'#JcO6QQ(CjO'#JdO6nQSO'#FWO6sQ#tO'#FoOOQ(CY'#F`'#F`O7OO&jO'#F`O7^Q,UO'#FvO8tQSO'#FuOOQ(CY'#Jd'#JdOOQ(CW'#Jc'#JcOOQQ'#KO'#KOO8yQSO'#IOO9OQ(C[O'#IPOOQQ'#JP'#JPOOQQ'#IT'#ITQ`QUOOO%QQUO'#DnO9WQUO'#DzO%QQUO'#D|O9_QSO'#GkO9dQ,UO'#ClO9rQSO'#EgO9}QSO'#ErO:SQ,UO'#F_O:qQSO'#GkO:vQSO'#GoO;RQSO'#GoO;aQSO'#GrO;aQSO'#GsO;aQSO'#GuO9_QSO'#GxO<QQSO'#G{O=cQSO'#CbO=sQSO'#HXO={QSO'#H_O={QSO'#HaO`QUO'#HcO={QSO'#HeO={QSO'#HhO>QQSO'#HnO>VQ(C]O'#HtO%QQUO'#HvO>bQ(C]O'#HxO>mQ(C]O'#HzO9OQ(C[O'#H|O>xQ(CjO'#CfO?zQWO'#DfQOQSOOO@bQSO'#EPO9dQ,UO'#EgO@mQSO'#EgO@xQ`O'#F_OOQQ'#Cd'#CdOOQ(CW'#Dk'#DkOOQ(CW'#Jg'#JgO%QQUO'#JgOOQO'#Jk'#JkOOQO'#I_'#I_OAxQWO'#E`OOQ(CW'#E_'#E_OBtQ(C`O'#E`OCOQWO'#ESOOQO'#Jj'#JjOCdQWO'#JkODqQWO'#ESOCOQWO'#E`PEOO?MpO'#C`POOO)CDn)CDnOOOO'#IU'#IUOEZOpO,59ROOQ(CY,59R,59ROOOO'#IV'#IVOEiO!bO,59RO%QQUO'#D]OOOO'#IX'#IXOEwO07`O,59uOOQ(CY,59u,59uOFVQUO'#IYOFjQSO'#JeOHlQbO'#JeO+sQUO'#JeOHsQSO,59{OIZQSO'#EiOIhQSO'#JsOIsQSO'#JrOIsQSO'#JrOI{QSO,5;VOJQQSO'#JqOOQ(CY,5:W,5:WOJXQUO,5:WOLYQ(CjO,5:bOLyQSO,5:jOMdQ(C[O'#JpOMkQSO'#JoO:vQSO'#JoONPQSO'#JoONXQSO,5;UON^QSO'#JoO!!fQbO'#JdOOQ(CY'#Cf'#CfO%QQUO'#EOO!#UQ`O,5:oOOQO'#Jl'#JlOOQO-E<`-E<`O9_QSO,5=VO!#lQSO,5=VO!#qQUO,5;SO!%tQ,UO'#EdO!'XQSO,5;SO!(qQ,UO'#DpO!(xQUO'#DuO!)SQWO,5;]O!)[QWO,5;]O%QQUO,5;]OOQQ'#FO'#FOOOQQ'#FQ'#FQO%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^O%QQUO,5;^OOQQ'#FU'#FUO!)jQUO,5;oOOQ(CY,5;t,5;tOOQ(CY,5;u,5;uO!+mQSO,5;uOOQ(CY,5;v,5;vO%QQUO'#IfO!+uQ(C[O,5<cO!%tQ,UO,5;^O!,dQ,UO,5;^O%QQUO,5;rO!,kQ#tO'#FeO!-hQ#tO'#JwO!-SQ#tO'#JwO!-oQ#tO'#JwOOQO'#Jw'#JwO!.TQ#tO,5;}OOOO,5<Z,5<ZO!.fQUO'#FqOOOO'#Ie'#IeO7OO&jO,5;zO!.mQ#tO'#FsOOQ(CY,5;z,5;zO!/^Q7[O'#CrOOQ(CY'#Cv'#CvO!/qQSO'#CvO!/vO07`O'#CzO!0dQ,UO,5<`O!0kQSO,5<bO!2QQMhO'#GQO!2_QSO'#GRO!2dQSO'#GRO!2iQMhO'#GVO!3hQWO'#GZO!4ZQ7[O'#J^OOQ(CY'#J^'#J^O!4eQSO'#J]O!4sQSO'#J[O!4{QSO'#CqOOQ(CY'#Ct'#CtOOQ(CY'#DO'#DOOOQ(CY'#DQ'#DQO0xQSO'#DSO!'^Q,UO'#FxO!'^Q,UO'#FzO!5TQSO'#F|O!5YQSO'#F}O!2dQSO'#GTO!'^Q,UO'#GYO!5_QSO'#EjO!5|QSO,5<aO`QUO,5>jOOQQ'#JX'#JXOOQQ,5>k,5>kOOQQ-E<R-E<RO!7{Q(CjO,5:YO!:iQ(CjO,5:fO%QQUO,5:fO!=SQ(CjO,5:hOOQ(CW'#Co'#CoO!=sQ,UO,5=VO!>RQ(C[O'#JYO8tQSO'#JYO!>dQ(C[O,59WO!>oQWO,59WO!>wQ,UO,59WO9dQ,UO,59WO!?SQSO,5;SO!?[QSO'#HWO!?mQSO'#KSO%QQUO,5;wO!?uQWO,5;yO!?zQSO,5=qO!@PQSO,5=qO!@UQSO,5=qO9OQ(C[O,5=qO!@dQSO'#EkO!A^QWO'#ElOOQ(CW'#Jq'#JqO!AeQ(C[O'#KPO9OQ(C[O,5=ZO;aQSO,5=aOOQO'#Cr'#CrO!ApQWO,5=^O!AxQ,UO,5=_O!BTQSO,5=aO!BYQ`O,5=dO>QQSO'#G}O9_QSO'#HPO!BbQSO'#HPO9dQ,UO'#HRO!BgQSO'#HROOQQ,5=g,5=gO!BlQSO'#HSO!BtQSO'#ClO!ByQSO,58|O!CTQSO,58|O!E]QUO,58|OOQQ,58|,58|O!EjQ(C[O,58|O%QQUO,58|O!EuQUO'#HZOOQQ'#H['#H[OOQQ'#H]'#H]O`QUO,5=sO!FVQSO,5=sO`QUO,5=yO`QUO,5={O!F[QSO,5=}O`QUO,5>PO!FaQSO,5>SO!FfQUO,5>YOOQQ,5>`,5>`O%QQUO,5>`O9OQ(C[O,5>bOOQQ,5>d,5>dO!JmQSO,5>dOOQQ,5>f,5>fO!JmQSO,5>fOOQQ,5>h,5>hO!JrQWO'#DXO%QQUO'#JgO!KaQWO'#JgO!LOQWO'#DgO!LaQWO'#DgO!NrQUO'#DgO!NyQSO'#JfO# RQSO,5:QO# WQSO'#EmO# fQSO'#JtO# nQSO,5;WO# sQWO'#DgO#!QQWO'#EROOQ(CY,5:k,5:kO%QQUO,5:kO#!XQSO,5:kO>QQSO,5;RO!>oQWO,5;RO!>wQ,UO,5;RO9dQ,UO,5;RO#!aQSO,5@RO#!fQ!LQO,5:oOOQO-E<]-E<]O##lQ(C`O,5:zOCOQWO,5:nO##vQWO,5:nOCOQWO,5:zO!>dQ(C[O,5:nOOQ(CW'#Ec'#EcOOQO,5:z,5:zO%QQUO,5:zO#$TQ(C[O,5:zO#$`Q(C[O,5:zO!>oQWO,5:nOOQO,5;Q,5;QO#$nQ(C[O,5:zPOOO'#IS'#ISP#%SO?MpO,58zPOOO,58z,58zOOOO-E<S-E<SOOQ(CY1G.m1G.mOOOO-E<T-E<TO#%_Q`O,59wOOOO-E<V-E<VOOQ(CY1G/a1G/aO#%dQbO,5>tO+sQUO,5>tOOQO,5>z,5>zO#%nQUO'#IYOOQO-E<W-E<WO#%{QSO,5@PO#&TQbO,5@PO#&[QSO,5@^OOQ(CY1G/g1G/gO%QQUO,5@_O#&dQSO'#I`OOQO-E<^-E<^O#&[QSO,5@^OOQ(CW1G0q1G0qOOQ(CY1G/r1G/rOOQ(CY1G0U1G0UO%QQUO,5@[O#&xQ(C[O,5@[O#'ZQ(C[O,5@[O#'bQSO,5@ZO:vQSO,5@ZO#'jQSO,5@ZO#'xQSO'#IcO#'bQSO,5@ZOOQ(CW1G0p1G0pO!)SQWO,5:qO!)_QWO,5:qOOQO,5:s,5:sO#(jQSO,5:sO#(rQ,UO1G2qO9_QSO1G2qOOQ(CY1G0n1G0nO#)QQ(CjO1G0nO#*VQ(ChO,5;OOOQ(CY'#GP'#GPO#*sQ(CjO'#J^O!#qQUO1G0nO#,{Q,UO'#JhO#-VQSO,5:[O#-[QbO'#JiO%QQUO'#JiO#-fQSO,5:aOOQ(CY'#DX'#DXOOQ(CY1G0w1G0wO%QQUO1G0wOOQ(CY1G1a1G1aO#-kQSO1G0wO#0SQ(CjO1G0xO#0ZQ(CjO1G0xO#2tQ(CjO1G0xO#2{Q(CjO1G0xO#5VQ(CjO1G0xO#5mQ(CjO1G0xO#8gQ(CjO1G0xO#8nQ(CjO1G0xO#;XQ(CjO1G0xO#;`Q(CjO1G0xO#=WQ(CjO1G0xO#@WQ$IUO'#CfO#BUQ$IUO1G1ZO#B]Q$IUO'#JdO!+pQSO1G1aO#BmQ(CjO,5?QOOQ(CW-E<d-E<dO#CaQ(CjO1G0xOOQ(CY1G0x1G0xO#ElQ(CjO1G1^O#F`Q#tO,5<RO#FhQ#tO,5<SO#FpQ#tO'#FjO#GXQSO'#FiOOQO'#Jx'#JxOOQO'#Id'#IdO#G^Q#tO1G1iOOQ(CY1G1i1G1iOOOO1G1t1G1tO#GoQ$IUO'#JcO#GyQSO,5<]O!)jQUO,5<]OOOO-E<c-E<cOOQ(CY1G1f1G1fO#HOQWO'#JwOOQ(CY,5<_,5<_O#HWQWO,5<_OOQ(CY,59b,59bO!%tQ,UO'#C|OOOO'#IW'#IWO#H]O07`O,59fOOQ(CY,59f,59fO%QQUO1G1zO!5YQSO'#IhO#HhQSO,5<sOOQ(CY,5<p,5<pOOQO'#Gf'#GfO!'^Q,UO,5=POOQO'#Gh'#GhO!'^Q,UO,5=RO!%tQ,UO,5=TOOQO1G1|1G1|O#HvQ`O'#CoO#IZQ`O,5<lO#IbQSO'#J{O9_QSO'#J{O#IpQSO,5<nO!'^Q,UO,5<mO#IuQSO'#GSO#JQQSO,5<mO#JVQ`O'#GPO#JdQ`O'#J|O#JnQSO'#J|O!%tQ,UO'#J|O#JsQSO,5<qO#JxQWO'#G[O!3cQWO'#G[O#KZQSO'#G^O#K`QSO'#G`O!2dQSO'#GcO#KeQ(C[O'#IjO#KpQWO,5<uOOQ(CY,5<u,5<uO#KwQWO'#G[O#LVQWO'#G]O#L_QWO'#G]OOQ(CY,5=U,5=UO!'^Q,UO,5?wO!'^Q,UO,5?wO#LdQSO'#IkO#LoQSO,5?vO#LwQSO,59]O#MhQ,UO,59nOOQ(CY,59n,59nO#NZQ,UO,5<dO#N|Q,UO,5<fO?rQSO,5<hOOQ(CY,5<i,5<iO$ WQSO,5<oO$ ]Q,UO,5<tO$ mQSO'#JoO!#qQUO1G1{O$ rQSO1G1{OOQQ1G4U1G4UOOQ(CY1G/t1G/tO!+mQSO1G/tO$#qQ(CjO1G0QOOQQ1G2q1G2qO!%tQ,UO1G2qO%QQUO1G2qO$$bQSO1G2qO$$mQ,UO'#EdOOQ(CW,5?t,5?tO$$wQ(C[O,5?tOOQQ1G.r1G.rO!>dQ(C[O1G.rO!>oQWO1G.rO!>wQ,UO1G.rO$%YQSO1G0nO$%_QSO'#CfO$%jQSO'#KTO$%rQSO,5=rO$%wQSO'#KTO$%|QSO'#KTO$&XQSO'#IsO$&gQSO,5@nO$&oQbO1G1cOOQ(CY1G1e1G1eO9_QSO1G3]O?rQSO1G3]O$&vQSO1G3]O$&{QSO1G3]OOQQ1G3]1G3]O:vQSO'#JrO:vQSO'#EmO%QQUO'#EmO:vQSO'#ImO$'QQ(C[O,5@kOOQQ1G2u1G2uO!BTQSO1G2{O!%tQ,UO1G2xO$']QSO1G2xOOQQ1G2y1G2yO!%tQ,UO1G2yO$'bQSO1G2yO$'jQWO'#GwOOQQ1G2{1G2{O!3cQWO'#IoO!BYQ`O1G3OOOQQ1G3O1G3OOOQQ,5=i,5=iO$'rQ,UO,5=kO9_QSO,5=kO#K`QSO,5=mO8tQSO,5=mO!>oQWO,5=mO!>wQ,UO,5=mO9dQ,UO,5=mO$(QQSO'#KRO$(]QSO,5=nOOQQ1G.h1G.hO$(bQ(C[O1G.hO?rQSO1G.hO$(mQSO1G.hO9OQ(C[O1G.hO$*rQbO,5@pO$+SQSO,5@pO$+_QUO,5=uO$+fQSO,5=uO:vQSO,5@pOOQQ1G3_1G3_O`QUO1G3_OOQQ1G3e1G3eOOQQ1G3g1G3gO={QSO1G3iO$+kQUO1G3kO$/lQUO'#HjOOQQ1G3n1G3nO$/yQSO'#HpO>QQSO'#HrOOQQ1G3t1G3tO$0RQUO1G3tO9OQ(C[O1G3zOOQQ1G3|1G3|OOQ(CW'#GW'#GWO9OQ(C[O1G4OO9OQ(C[O1G4QO$4VQSO,5@RO!)jQUO,5;XO:vQSO,5;XO>QQSO,5:RO!)jQUO,5:RO!>oQWO,5:RO$4[Q$IUO,5:ROOQO,5;X,5;XO$4fQWO'#IZO$4|QSO,5@QOOQ(CY1G/l1G/lO$5UQWO'#IaO$5`QSO,5@`OOQ(CW1G0r1G0rO!LaQWO,5:ROOQO'#I^'#I^O$5hQWO,5:mOOQ(CY,5:m,5:mO#![QSO1G0VOOQ(CY1G0V1G0VO%QQUO1G0VOOQ(CY1G0m1G0mO>QQSO1G0mO!>oQWO1G0mO!>wQ,UO1G0mOOQ(CW1G5m1G5mO!>dQ(C[O1G0YOOQO1G0f1G0fO%QQUO1G0fO$5oQ(C[O1G0fO$5zQ(C[O1G0fO!>oQWO1G0YOCOQWO1G0YO$6YQ(C[O1G0fOOQO1G0Y1G0YO$6nQ(CjO1G0fPOOO-E<Q-E<QPOOO1G.f1G.fOOOO1G/c1G/cO$6xQ`O,5<cO$7QQbO1G4`OOQO1G4f1G4fO%QQUO,5>tO$7[QSO1G5kO$7dQSO1G5xO$7lQbO1G5yO:vQSO,5>zO$7vQ(CjO1G5vO%QQUO1G5vO$8WQ(C[O1G5vO$8iQSO1G5uO$8iQSO1G5uO:vQSO1G5uO$8qQSO,5>}O:vQSO,5>}OOQO,5>},5>}O$9VQSO,5>}O$ mQSO,5>}OOQO-E<a-E<aOOQO1G0]1G0]OOQO1G0_1G0_O!+pQSO1G0_OOQQ7+(]7+(]O!%tQ,UO7+(]O%QQUO7+(]O$9eQSO7+(]O$9pQ,UO7+(]O$:OQ(CjO,59nO$<WQ(CjO,5<dO$>cQ(CjO,5<fO$@nQ(CjO,5<tOOQ(CY7+&Y7+&YO$CPQ(CjO7+&YO$CsQ,UO'#I[O$C}QSO,5@SOOQ(CY1G/v1G/vO$DVQUO'#I]O$DdQSO,5@TO$DlQbO,5@TOOQ(CY1G/{1G/{O$DvQSO7+&cOOQ(CY7+&c7+&cO$D{Q$IUO,5:bO%QQUO7+&uO$EVQ$IUO,5:YO$EdQ$IUO,5:fO$EnQ$IUO,5:hOOQ(CY7+&{7+&{OOQO1G1m1G1mOOQO1G1n1G1nO$ExQ#tO,5<UO!)jQUO,5<TOOQO-E<b-E<bOOQ(CY7+'T7+'TOOOO7+'`7+'`OOOO1G1w1G1wO$FTQSO1G1wOOQ(CY1G1y1G1yO$FYQ`O,59hOOOO-E<U-E<UOOQ(CY1G/Q1G/QO$FaQ(CjO7+'fOOQ(CY,5?S,5?SO$GTQSO,5?SOOQ(CY1G2_1G2_P$GYQSO'#IhPOQ(CY-E<f-E<fO$G|Q,UO1G2kO$HoQ,UO1G2mO$HyQ`O1G2oOOQ(CY1G2W1G2WO$IQQSO'#IgO$I`QSO,5@gO$I`QSO,5@gO$IhQSO,5@gO$IsQSO,5@gOOQO1G2Y1G2YO$JRQ,UO1G2XO!'^Q,UO1G2XO$JcQMhO'#IiO$JsQSO,5@hO!%tQ,UO,5@hO$J{Q`O,5@hOOQ(CY1G2]1G2]OOQ(CW,5<v,5<vOOQ(CW,5<w,5<wO$ mQSO,5<wOBoQSO,5<wO!>oQWO,5<vOOQO'#G_'#G_O$KVQSO,5<xOOQ(CW,5<z,5<zO$ mQSO,5<}OOQO,5?U,5?UOOQO-E<h-E<hOOQ(CY1G2a1G2aO!3cQWO,5<vO$K_QSO,5<wO#KZQSO,5<xO!3cQWO,5<wO$KjQ,UO1G5cO$KtQ,UO1G5cOOQO,5?V,5?VOOQO-E<i-E<iOOQO1G.w1G.wO!?uQWO,59pO%QQUO,59pO$LRQSO1G2SO!'^Q,UO1G2ZO$LWQ(CjO7+'gOOQ(CY7+'g7+'gO!#qQUO7+'gOOQ(CY7+%`7+%`O$LzQ`O'#J}O#![QSO7+(]O$MUQbO7+(]O$9hQSO7+(]O$M]Q(ChO'#CfO$MpQ(ChO,5<{O$NbQSO,5<{OOQ(CW1G5`1G5`OOQQ7+$^7+$^O!>dQ(C[O7+$^O!>oQWO7+$^O!#qQUO7+&YO$NgQSO'#IrO$N{QSO,5@oOOQO1G3^1G3^O9_QSO,5@oO$N{QSO,5@oO% TQSO,5@oOOQO,5?_,5?_OOQO-E<q-E<qOOQ(CY7+&}7+&}O% YQSO7+(wO9OQ(C[O7+(wO9_QSO7+(wO?rQSO7+(wO% _QSO,5;XOOQ(CW,5?X,5?XOOQ(CW-E<k-E<kOOQQ7+(g7+(gO% dQ(ChO7+(dO!%tQ,UO7+(dO% nQ`O7+(eOOQQ7+(e7+(eO!%tQ,UO7+(eO% uQSO'#KQO%!QQSO,5=cOOQO,5?Z,5?ZOOQO-E<m-E<mOOQQ7+(j7+(jO%#aQWO'#HQOOQQ1G3V1G3VO!%tQ,UO1G3VO%QQUO1G3VO%#hQSO1G3VO%#sQ,UO1G3VO9OQ(C[O1G3XO#K`QSO1G3XO8tQSO1G3XO!>oQWO1G3XO!>wQ,UO1G3XO%$RQSO'#IqO%$^QSO,5@mO%$fQWO,5@mOOQ(CW1G3Y1G3YOOQQ7+$S7+$SO?rQSO7+$SO9OQ(C[O7+$SO%$qQSO7+$SO%QQUO1G6[O%QQUO1G6]O%$vQUO1G3aO%$}QSO1G3aO%%SQUO1G3aO%%ZQ(C[O1G6[OOQQ7+(y7+(yO9OQ(C[O7+)TO`QUO7+)VOOQQ'#KW'#KWOOQQ'#It'#ItO%%eQUO,5>UOOQQ,5>U,5>UO%QQUO'#HkO%%rQSO'#HmOOQQ,5>[,5>[O:vQSO,5>[OOQQ,5>^,5>^OOQQ7+)`7+)`OOQQ7+)f7+)fOOQQ7+)j7+)jOOQQ7+)l7+)lO%%wQWO1G5mO%&]Q$IUO1G0sO%&gQSO1G0sOOQO1G/m1G/mO%&rQ$IUO1G/mO>QQSO1G/mO!)jQUO'#DgOOQO,5>u,5>uOOQO-E<X-E<XOOQO,5>{,5>{OOQO-E<_-E<_O!>oQWO1G/mOOQO-E<[-E<[OOQ(CY1G0X1G0XOOQ(CY7+%q7+%qO#![QSO7+%qOOQ(CY7+&X7+&XO>QQSO7+&XO!>oQWO7+&XOOQO7+%t7+%tO$6nQ(CjO7+&QOOQO7+&Q7+&QO%QQUO7+&QO%&|Q(C[O7+&QO!>dQ(C[O7+%tO!>oQWO7+%tO%'XQ(C[O7+&QO%'gQ(CjO7++bO%QQUO7++bO%'wQSO7++aO%'wQSO7++aOOQO1G4i1G4iO:vQSO1G4iO%(PQSO1G4iOOQO7+%y7+%yO#![QSO<<KwO$MUQbO<<KwO%(_QSO<<KwOOQQ<<Kw<<KwO!%tQ,UO<<KwO%QQUO<<KwO%(gQSO<<KwO%(rQ(CjO1G2kO%*}Q(CjO1G2mO%-YQ(CjO1G2XO%/kQ,UO,5>vOOQO-E<Y-E<YO%/uQbO,5>wO%QQUO,5>wOOQO-E<Z-E<ZO%0PQSO1G5oOOQ(CY<<I}<<I}O%0XQ$IUO1G0nO%2cQ$IUO1G0xO%2jQ$IUO1G0xO%4nQ$IUO1G0xO%4uQ$IUO1G0xO%6jQ$IUO1G0xO%7QQ$IUO1G0xO%9eQ$IUO1G0xO%9lQ$IUO1G0xO%;pQ$IUO1G0xO%;wQ$IUO1G0xO%=oQ$IUO1G0xO%>SQ(CjO<<JaO%?XQ$IUO1G0xO%@}Q$IUO'#J^O%CQQ$IUO1G1^O%C_Q$IUO1G0QO!)jQUO'#FlOOQO'#Jy'#JyOOQO1G1p1G1pO%CiQSO1G1oO%CnQ$IUO,5?QOOOO7+'c7+'cOOOO1G/S1G/SOOQ(CY1G4n1G4nO!'^Q,UO7+(ZO%CxQSO,5?RO9_QSO,5?ROOQO-E<e-E<eO%DWQSO1G6RO%DWQSO1G6RO%D`QSO1G6RO%DkQ,UO7+'sO%D{Q`O,5?TO%EVQSO,5?TO!%tQ,UO,5?TOOQO-E<g-E<gO%E[Q`O1G6SO%EfQSO1G6SOOQ(CW1G2c1G2cO$ mQSO1G2cOOQ(CW1G2b1G2bO%EnQSO1G2dO!%tQ,UO1G2dOOQ(CW1G2i1G2iO!>oQWO1G2bOBoQSO1G2cO%EsQSO1G2dO%E{QSO1G2cO!'^Q,UO7+*}OOQ(CY1G/[1G/[O%FWQSO1G/[OOQ(CY7+'n7+'nO%F]Q,UO7+'uO%FmQ(CjO<<KROOQ(CY<<KR<<KRO!%tQ,UO'#IlO%GaQSO,5@iO!%tQ,UO1G2gOOQQ<<Gx<<GxO!>dQ(C[O<<GxO%GiQ(CjO<<ItOOQ(CY<<It<<ItOOQO,5?^,5?^O%H]QSO,5?^O$%|QSO,5?^OOQO-E<p-E<pO%HbQSO1G6ZO%HbQSO1G6ZO9_QSO1G6ZO?rQSO<<LcOOQQ<<Lc<<LcO%HjQSO<<LcO9OQ(C[O<<LcO%HoQSO1G0sOOQQ<<LO<<LOO% dQ(ChO<<LOOOQQ<<LP<<LPO% nQ`O<<LPO%HtQWO'#InO%IPQSO,5@lO!)jQUO,5@lOOQQ1G2}1G2}O%IXQUO'#JgOOQO'#Ip'#IpO9OQ(C[O'#IpO%IcQWO,5=lOOQQ,5=l,5=lO%IjQWO'#E`O%JOQSO7+(qO%JTQSO7+(qOOQQ7+(q7+(qO!%tQ,UO7+(qO%QQUO7+(qO%J]QSO7+(qOOQQ7+(s7+(sO9OQ(C[O7+(sO#K`QSO7+(sO8tQSO7+(sO!>oQWO7+(sO%JhQSO,5?]OOQO-E<o-E<oOOQO'#HT'#HTO%JsQSO1G6XO9OQ(C[O<<GnOOQQ<<Gn<<GnO?rQSO<<GnO%J{QSO7++vO%KQQSO7++wOOQQ7+({7+({O%KVQSO7+({O%K[QUO7+({O%KcQSO7+({O%QQUO7++vO%QQUO7++wOOQQ<<Lo<<LoOOQQ<<Lq<<LqOOQQ-E<r-E<rOOQQ1G3p1G3pO%KhQSO,5>VOOQQ,5>X,5>XO%KmQSO1G3vO:vQSO7+&_O!)jQUO7+&_OOQO7+%X7+%XO%KrQ$IUO1G5yO>QQSO7+%XOOQ(CY<<I]<<I]OOQ(CY<<Is<<IsO>QQSO<<IsOOQO<<Il<<IlO$6nQ(CjO<<IlO%QQUO<<IlOOQO<<I`<<I`O!>dQ(C[O<<I`O%K|Q(C[O<<IlO%LXQ(CjO<<N|O%LiQSO<<N{OOQO7+*T7+*TO:vQSO7+*TOOQQANAcANAcO%LqQSOANAcO!%tQ,UOANAcO#![QSOANAcO$MUQbOANAcO%QQUOANAcO%LyQ(CjO7+'sO& [Q(CjO7+'uO&#mQbO1G4cO&#wQ$IUO7+&YO&$UQ$IUO,59nO&&XQ$IUO,5<dO&([Q$IUO,5<fO&*_Q$IUO,5<tO&,TQ$IUO7+'fO&,bQ$IUO7+'gO&,oQSO,5<WOOQO7+'Z7+'ZO&,tQ,UO<<KuOOQO1G4m1G4mO&,{QSO1G4mO&-WQSO1G4mO&-fQSO7++mO&-fQSO7++mO!%tQ,UO1G4oO&-nQ`O1G4oO&-xQSO7++nOOQ(CW7+'}7+'}O$ mQSO7+(OO&.QQ`O7+(OOOQ(CW7+'|7+'|O$ mQSO7+'}O&.XQSO7+(OO!%tQ,UO7+(OOBoQSO7+'}O&.^Q,UO<<NiOOQ(CY7+$v7+$vO&.hQ`O,5?WOOQO-E<j-E<jO&.rQ(ChO7+(ROOQQAN=dAN=dO9_QSO1G4xOOQO1G4x1G4xO&/SQSO1G4xO&/XQSO7++uO&/XQSO7++uO9OQ(C[OANA}O?rQSOANA}OOQQANA}ANA}OOQQANAjANAjOOQQANAkANAkO&/aQSO,5?YOOQO-E<l-E<lO&/lQ$IUO1G6WO&1|QbO'#CfOOQO,5?[,5?[OOQO-E<n-E<nOOQQ1G3W1G3WO%IXQUO,5<xOOQQ<<L]<<L]O!%tQ,UO<<L]O%JOQSO<<L]O&2WQSO<<L]O%QQUO<<L]OOQQ<<L_<<L_O9OQ(C[O<<L_O#K`QSO<<L_O8tQSO<<L_O&2`QWO1G4wO&2kQSO7++sOOQQAN=YAN=YO9OQ(C[OAN=YOOQQ<= b<= bOOQQ<= c<= cOOQQ<<Lg<<LgO&2sQSO<<LgO&2xQUO<<LgO&3PQSO<= bO&3UQSO<= cOOQQ1G3q1G3qO>QQSO7+)bO&3ZQSO<<IyO&3fQ$IUO<<IyOOQO<<Hs<<HsOOQ(CYAN?_AN?_OOQOAN?WAN?WO$6nQ(CjOAN?WOOQOAN>zAN>zO%QQUOAN?WOOQO<<Mo<<MoOOQQG26}G26}O!%tQ,UOG26}O#![QSOG26}O&3pQSOG26}O$MUQbOG26}O&3xQ$IUO<<JaO&4VQ$IUO1G2XO&5{Q$IUO1G2kO&8OQ$IUO1G2mO&:RQ$IUO<<KRO&:`Q$IUO<<ItOOQO1G1r1G1rO!'^Q,UOANAaOOQO7+*X7+*XO&:mQSO7+*XO&:xQSO<= XO&;QQ`O7+*ZOOQ(CW<<Kj<<KjO$ mQSO<<KjOOQ(CW<<Ki<<KiO&;[Q`O<<KjO$ mQSO<<KiOOQO7+*d7+*dO9_QSO7+*dO&;cQSO<= aOOQQG27iG27iO9OQ(C[OG27iO!)jQUO1G4tO&;kQSO7++rO%JOQSOANAwOOQQANAwANAwO!%tQ,UOANAwO&;sQSOANAwOOQQANAyANAyO9OQ(C[OANAyO#K`QSOANAyOOQO'#HU'#HUOOQO7+*c7+*cOOQQG22tG22tOOQQANBRANBRO&;{QSOANBROOQQAND|AND|OOQQAND}AND}OOQQ<<L|<<L|O!)jQUOAN?eOOQOG24rG24rO$6nQ(CjOG24rO#![QSOLD,iOOQQLD,iLD,iO!%tQ,UOLD,iO&<QQSOLD,iO&<YQ$IUO7+'sO&>OQ$IUO7+'uO&?tQ,UOG26{OOQO<<Ms<<MsOOQ(CWANAUANAUO$ mQSOANAUOOQ(CWANATANATOOQO<<NO<<NOOOQQLD-TLD-TO&@UQ$IUO7+*`OOQQG27cG27cO%JOQSOG27cO!%tQ,UOG27cOOQQG27eG27eO9OQ(C[OG27eOOQQG27mG27mO&@`Q$IUOG25POOQOLD*^LD*^OOQQ!$(!T!$(!TO#![QSO!$(!TO!%tQ,UO!$(!TO&@jQ(CjOG26{OOQ(CWG26pG26pOOQQLD,}LD,}O%JOQSOLD,}OOQQLD-PLD-POOQQ!)9Eo!)9EoO#![QSO!)9EoOOQQ!$(!i!$(!iOOQQ!.K;Z!.K;ZO&B{Q$IUOG26{O!)jQUO'#DvO0uQSO'#ETO&DqQbO'#JcO!)jQUO'#DnO&DxQUO'#DzO!)jQUO'#D|O&EPQbO'#CfO&GgQbO'#CfO&GwQUO,5;SO!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO,5;^O!)jQUO'#IfO&IzQSO,5<cO&JSQ,UO,5;^O&KgQ,UO,5;^O!)jQUO,5;rO0xQSO'#DSO0xQSO'#DSO!%tQ,UO'#FxO&JSQ,UO'#FxO!%tQ,UO'#FzO&JSQ,UO'#FzO!%tQ,UO'#GYO&JSQ,UO'#GYO!)jQUO,5:fO!)jQUO,5@_O&GwQUO1G0nO&KnQ$IUO'#CfO!)jQUO1G1zO!%tQ,UO,5=PO&JSQ,UO,5=PO!%tQ,UO,5=RO&JSQ,UO,5=RO!%tQ,UO,5<mO&JSQ,UO,5<mO&GwQUO1G1{O!)jQUO7+&uO!%tQ,UO1G2XO&JSQ,UO1G2XO!%tQ,UO1G2ZO&JSQ,UO1G2ZO&GwQUO7+'gO&GwQUO7+&YO!%tQ,UOANAaO&JSQ,UOANAaO&KxQSO'#EhO&K}QSO'#EhO&LVQSO'#FWO&L[QSO'#ErO&LaQSO'#JsO&LlQSO'#JqO&LwQSO,5;SO&L|Q,UO,5<`O&MTQSO'#GRO&MYQSO'#GRO&M_QSO,5<aO&MgQSO,5;SO&MoQ$IUO1G1ZO&MvQSO,5<mO&M{QSO,5<mO&NQQSO,5<oO&NVQSO,5<oO&N[QSO1G1{O&NaQSO1G0nO&NfQ,UO<<KuO&NmQ,UO<<KuO7^Q,UO'#FvO8tQSO'#FuO@mQSO'#EgO!)jQUO,5;oO!2dQSO'#GRO!2dQSO'#GRO!2dQSO'#GTO!2dQSO'#GTO!'^Q,UO7+(ZO!'^Q,UO7+(ZO$HyQ`O1G2oO$HyQ`O1G2oO!%tQ,UO,5=TO!%tQ,UO,5=T",stateData:"' v~O'mOS'nOSROS'oRQ~OPYOQYOV!TO^pOaxObwOikOkYOlkOmkOskOuYOwYO|WO!QkO!RkO!XXO!csO!hZO!kYO!lYO!mYO!otO!quO!tvO!x]O#p}O$QzO$UfO%`{O%b!OO%d|O%e|O%h!PO%j!QO%m!RO%n!RO%p!SO%|!UO&S!VO&U!WO&W!XO&Y!YO&]!ZO&c![O&i!]O&k!^O&m!_O&o!`O&q!aO'tSO'vTO'yUO(RVO(a[O(niO~OPYOQYOa!gOb!fOikOkYOlkOmkOskOuYOwYO|WO!QkO!RkO!X!cO!csO!hZO!kYO!lYO!mYO!otO!quO!t!eO$Q!hO$UfO't!bO'vTO'yUO(RVO(a[O(niO~O^!sOl!kO|!lO![!uO!]!rO!^!rO!x9mO!|!mO!}!mO#O!tO#P!mO#Q!mO#T!vO#U!vO'u!iO'vTO'yUO(U!jO(a!pO~O'o!wO~OPYXXYX^YXkYXyYXzYX|YX!VYX!eYX!fYX!hYX!lYX#XYX#dcX#gYX#hYX#iYX#jYX#kYX#lYX#mYX#nYX#oYX#qYX#sYX#uYX#vYX#{YX'kYX(RYX(bYX(iYX(jYX~O!a$zX~P(gO[!yO'v!{O'w!yO'x!{O~O[!|O'x!{O'y!{O'z!|O~Oq#OO!O#PO(S#PO(T#RO~OPYOQYOa!gOb!fOikOkYOlkOmkOskOuYOwYO|WO!QkO!RkO!X!cO!csO!hZO!kYO!lYO!mYO!otO!quO!t!eO$Q!hO$UfO't9rO'vTO'yUO(RVO(a[O(niO~O!U#VO!V#SO!S(XP!S(fP~P+sO!W#_O~P`OPYOQYOa!gOb!fOkYOlkOmkOskOuYOwYO|WO!QkO!RkO!X!cO!csO!hZO!kYO!lYO!mYO!otO!quO!t!eO$Q!hO$UfO'vTO'yUO(RVO(a[O(niO~Oi#iO!U#eO!x]O#b#hO#c#eO't9sO!g(cP~P._O!h#kO't#jO~O!t#oO!x]O%`#pO~O#d#qO~O!a#rO#d#qO~OP$YOX$aOk#}Oy#vOz#wO|#xO!V$^O!e$PO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO#l$PO#m$PO#n$`O#o$PO#q$QO#s$SO#u$UO#v$VO(RVO(b$WO(i#yO(j#zO~O^(VX'k(VX'i(VX!g(VX!S(VX!X(VX%a(VX!a(VX~P1gO#X$bO#{$bOP(WXX(WXk(WXy(WXz(WX|(WX!V(WX!e(WX!h(WX!l(WX#g(WX#h(WX#i(WX#j(WX#k(WX#l(WX#m(WX#n(WX#o(WX#q(WX#s(WX#u(WX#v(WX(R(WX(b(WX(i(WX(j(WX!X(WX%a(WX~O^(WX!f(WX'k(WX'i(WX!S(WX!g(WXo(WX!a(WX~P3}O#X$bO~O$W$dO$Y$cO$a$iO~O!X$jO$UfO$d$kO$f$mO~Oi%POk$qOl$pOm$pOs%QOu%ROw%SO|$xO!X$yO!c%XO!h$uO#c%YO$Q%VO$m%TO$o%UO$r%WO't$oO'vTO'yUO'}%OO(R$rOd(OP~O!h%ZO~O!a%]O~O^%^O'k%^O~O'u!iO~P%QO't%eO~O!h%ZO't%eO'u!iO'}%OO~Ob%lO!h%ZO't%eO~O#o$PO~Oy%qO!X%nO!h%pO%b%tO't%eO'u!iO'vTO'yUO](vP~O!t#oO~O|%vO!X%wO't%eO~O|%vO!X%wO%j%{O't%eO~O't%|O~O#p}O%b!OO%d|O%e|O%h!PO%j!QO%m!RO%n!RO~Oa&VOb&UO!t&SO%`&TO%r&RO~P;fOa&YObwO!X&XO!tvO!x]O#p}O%`{O%d|O%e|O%h!PO%j!QO%m!RO%n!RO%p!SO~O_&]O#X&`O%b&ZO'u!iO~P<eO!h&aO!q&eO~O!h#kO~O!XXO~O^%^O'j&mO'k%^O~O^%^O'j&pO'k%^O~O^%^O'j&rO'k%^O~O'iYX!SYXoYX!gYX&QYX!XYX%aYX!aYX~P(gO!['PO!]&xO!^&xO'u!iO'vTO'yUO~Ol&vO|&uO!U&yO(U&tO!W(YP!W(hP~P?fOg'SO!X'QO't%eO~Ob'XO!h%ZO't%eO~Oy%qO!h%pO~Ol!kO|!lO!x9mO!|!mO!}!mO#P!mO#Q!mO'u!iO'vTO'yUO(U!jO(a!pO~O!['_O!]'^O!^'^O#O!mO#T'`O#U'`O~PAQO^%^O!a#rO!h%ZO'k%^O'}%OO(b'bO~O!l'fO#X'dO~PB`Ol!kO|!lO'vTO'yUO(U!jO(a!pO~O!XXOl(_X|(_X![(_X!](_X!^(_X!x(_X!|(_X!}(_X#O(_X#P(_X#Q(_X#T(_X#U(_X'u(_X'v(_X'y(_X(U(_X(a(_X~O!]'^O!^'^O'u!iO~PCOO'p'jO'q'jO'r'lO~O[!yO'v'nO'w!yO'x'nO~O[!|O'x'nO'y'nO'z!|O~Oq#OO!O#PO(S#PO(T'rO~O!U'tO!S&|X!S'SX!V&|X!V'SX~P+sO!V'vO!S(XX~OP$YOX$aOk#}Oy#vOz#wO|#xO!V'vO!e$PO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO#l$PO#m$PO#n$`O#o$PO#q$QO#s$SO#u$UO#v$VO(RVO(b$WO(i#yO(j#zO~O!S(XX~PFrO!S'{O~O!S(eX!V(eX!a(eX!g(eX(b(eX~O#X(eX#d#]X!W(eX~PHxO#X'|O!S(gX!V(gX~O!V'}O!S(fX~O!S(QO~O#X$bO~PHxO!W(RO~P`Oy#vOz#wO|#xO!f#tO!h#uO(RVOP!jaX!jak!ja!V!ja!e!ja!l!ja#g!ja#h!ja#i!ja#j!ja#k!ja#l!ja#m!ja#n!ja#o!ja#q!ja#s!ja#u!ja#v!ja(b!ja(i!ja(j!ja~O^!ja'k!ja'i!ja!S!ja!g!jao!ja!X!ja%a!ja!a!ja~PJ`O!g(SO~O!a#rO#X(TO(b'bO!V(dX^(dX'k(dX~O!g(dX~PMOO|%vO!X%wO!x]O#b(YO#c(XO't%eO~O!V(ZO!g(cX~O!g(]O~O|%vO!X%wO#c(XO't%eO~OP(WXX(WXk(WXy(WXz(WX|(WX!V(WX!e(WX!f(WX!h(WX!l(WX#g(WX#h(WX#i(WX#j(WX#k(WX#l(WX#m(WX#n(WX#o(WX#q(WX#s(WX#u(WX#v(WX(R(WX(b(WX(i(WX(j(WX~O!a#rO!g(WX~PNlOy(^Oz(_O!f#tO!h#uO!x!wa|!wa~O!t!wa%`!wa!X!wa#b!wa#c!wa't!wa~P!!pO!t(cO~OPYOQYOa!gOb!fOikOkYOlkOmkOskOuYOwYO|WO!QkO!RkO!XXO!csO!hZO!kYO!lYO!mYO!otO!quO!t!eO$Q!hO$UfO't!bO'vTO'yUO(RVO(a[O(niO~Oi%POk$qOl$pOm$pOs%QOu%ROw:VO|$xO!X$yO!c;aO!h$uO#c:]O$Q%VO$m:XO$o:ZO$r%WO't(gO'vTO'yUO'}%OO(R$rO~O#d(iO~Oi%POk$qOl$pOm$pOs%QOu%ROw%SO|$xO!X$yO!c%XO!h$uO#c%YO$Q%VO$m%TO$o%UO$r%WO't(gO'vTO'yUO'}%OO(R$rO~Od([P~P!'^O!U(mO!g(]P~P%QO(U(oO(a[O~O|(qO!h#uO(U(oO(a[O~OP9lOQ9lOa;]Ob!fOikOk9lOlkOmkOskOu9lOw9lO|WO!QkO!RkO!X!cO!c9oO!hZO!k9lO!l9lO!m9lO!o9pO!q9qO!t!eO$Q!hO$UfO't)PO'vTO'yUO(RVO(a[O(n;ZO~Oz)SO!h#uO~O!V$^O^$ka'k$ka'i$ka!g$ka!S$ka!X$ka%a$ka!a$ka~O#p)WO~P!%tOy)ZO!a)YO!X$XX$T$XX$W$XX$Y$XX$a$XX~O!a)YO!X(kX$T(kX$W(kX$Y(kX$a(kX~Oy)ZO~P!-SOy)ZO!X(kX$T(kX$W(kX$Y(kX$a(kX~O!X)]O$T)aO$W)[O$Y)[O$a)bO~O!U)eO~P!)jO$W$dO$Y$cO$a)iO~Og$sXy$sX|$sX!f$sX(i$sX(j$sX~OdfXd$sXgfX!VfX#XfX~P!.xOl)kO~Oq)lO(S)mO(T)oO~Og)xOy)qO|)rO(i)tO(j)vO~Od)pO~P!0ROd)yO~Oi%POk$qOl$pOm$pOs%QOu%ROw:VO|$xO!X$yO!c;aO!h$uO#c:]O$Q%VO$m:XO$o:ZO$r%WO'vTO'yUO'}%OO(R$rO~O!U)}O't)zO!g(oP~P!0pO#d*PO~O!h*QO~O!U*VO't*SO!S(pP~P!0pOk*cO|*ZO![*aO!]*YO!^*YO!h*QO#T*bO%W*]O'u!iO(U!jO~O!W*`O~P!2vO!f#tOg(QXy(QX|(QX(i(QX(j(QX!V(QX#X(QX~Od(QX#y(QX~P!3oOg*fO#X*eOd(PX!V(PX~O!V*gOd(OX~O't%|Od(OP~O!h*nO~O't(gO~Oi*rO|%vO!U#eO!X%wO!x]O#b#hO#c#eO't%eO!g(cP~O!a#rO#d*sO~OP$YOX$aOk#}Oy#vOz#wO|#xO!e$PO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO#l$PO#m$PO#n$`O#o$PO#q$QO#s$SO#u$UO#v$VO(RVO(b$WO(i#yO(j#zO~O^!ba!V!ba'k!ba'i!ba!S!ba!g!bao!ba!X!ba%a!ba!a!ba~P!6UOy#vOz#wO|#xO!f#tO!h#uO(RVOP!naX!nak!na!V!na!e!na!l!na#g!na#h!na#i!na#j!na#k!na#l!na#m!na#n!na#o!na#q!na#s!na#u!na#v!na(b!na(i!na(j!na~O^!na'k!na'i!na!S!na!g!nao!na!X!na%a!na!a!na~P!8oOy#vOz#wO|#xO!f#tO!h#uO(RVOP!paX!pak!pa!V!pa!e!pa!l!pa#g!pa#h!pa#i!pa#j!pa#k!pa#l!pa#m!pa#n!pa#o!pa#q!pa#s!pa#u!pa#v!pa(b!pa(i!pa(j!pa~O^!pa'k!pa'i!pa!S!pa!g!pao!pa!X!pa%a!pa!a!pa~P!;YOg*{O!X'QO%a*zO'}%OO~O!a*}O^'|X!X'|X'k'|X!V'|X~O^%^O!XXO'k%^O~O!h%ZO'}%OO~O!h%ZO't%eO'}%OO~O!a#rO#d(iO~O%b+ZO't+VO'vTO'yUO!W(wP~O!V+[O](vX~O(U(oO~OX+`O~O]+aO~O!X%nO't%eO'u!iO](vP~O|%vO!U+eO!V'}O!X%wO't%eO!S(fP~Ol&|O|+gO!U+fO'vTO'yUO(U(oO~O!W(hP~P!@xO!V+hO^(sX'k(sX~O#X+lO'}%OO~Og+oO!X$yO'}%OO~O!X+qO~Oy+sO!XXO~O!t+xO~Ob+}O~O't#jO!W(uP~Ob%lO~O%b!OO't%|O~P<eOX,TO],SO~OPYOQYOaxObwOikOkYOlkOmkOskOuYOwYO|WO!QkO!RkO!csO!hZO!kYO!lYO!mYO!otO!quO!tvO!x]O$UfO%`{O'vTO'yUO(RVO(a[O(niO~O!X!cO$Q!hO't!bO~P!C]O],SO^%^O'k%^O~O^,XO#p,ZO%d,ZO%e,ZO~P%QO!h&aO~O&S,`O~O!X,bO~O&e,dO&g,eOP&baQ&baV&ba^&baa&bab&bai&bak&bal&bam&bas&bau&baw&ba|&ba!Q&ba!R&ba!X&ba!c&ba!h&ba!k&ba!l&ba!m&ba!o&ba!q&ba!t&ba!x&ba#p&ba$Q&ba$U&ba%`&ba%b&ba%d&ba%e&ba%h&ba%j&ba%m&ba%n&ba%p&ba%|&ba&S&ba&U&ba&W&ba&Y&ba&]&ba&c&ba&i&ba&k&ba&m&ba&o&ba&q&ba'i&ba't&ba'v&ba'y&ba(R&ba(a&ba(n&ba!W&ba&Z&ba_&ba&`&ba~O't,jO~O!V{X!V!_X!W{X!W!_X!a{X!a!_X!h!_X#X{X'}!_X~O!a,oO#X,nO!V#aX!V(ZX!W#aX!W(ZX!a(ZX!h(ZX'}(ZX~O!a,qO!h%ZO'}%OO!V!ZX!W!ZX~Ol!kO|!lO'vTO'yUO(U!jO~OP9lOQ9lOa;]Ob!fOikOk9lOlkOmkOskOu9lOw9lO|WO!QkO!RkO!X!cO!c9oO!hZO!k9lO!l9lO!m9lO!o9pO!q9qO!t!eO$Q!hO$UfO'vTO'yUO(RVO(a[O(n;ZO~O't:bO~P!LrO!V,uO!W(YX~O!W,wO~O!a,oO#X,nO!V#aX!W#aX~O!V,xO!W(hX~O!W,zO~O!],{O!^,{O'u!iO~P!LaO!W-OO~P'TOg-RO!X'QO~O!S-WO~Ol!wa![!wa!]!wa!^!wa!|!wa!}!wa#O!wa#P!wa#Q!wa#T!wa#U!wa'u!wa'v!wa'y!wa(U!wa(a!wa~P!!pO!l-]O#X-ZO~PB`O!]-_O!^-_O'u!iO~PCOO^%^O#X-ZO'k%^O~O^%^O!a#rO#X-ZO'k%^O~O^%^O!a#rO!l-]O#X-ZO'k%^O(b'bO~O'p'jO'q'jO'r-dO~Oo-eO~O!S&|a!V&|a~P!6UO!U-iO!S&|X!V&|X~P%QO!V'vO!S(Xa~O!S(Xa~PFrO!V'}O!S(fa~O|%vO!U-mO!X%wO't%eO!S'SX!V'SX~O#X-oO!V(da!g(da^(da'k(da~O!a#rO~P#&xO!V(ZO!g(ca~O|%vO!X%wO#c-sO't%eO~Oi-xO|%vO!U-uO!X%wO!x]O#b-wO#c-uO't%eO!V'VX!g'VX~Oz-|O!h#uO~Og.PO!X'QO%a.OO'}%OO~O^#[i!V#[i'k#[i'i#[i!S#[i!g#[io#[i!X#[i%a#[i!a#[i~P!6UOg;gOy)qO|)rO(i)tO(j)vO~O#d#Wa^#Wa#X#Wa'k#Wa!V#Wa!g#Wa!X#Wa!S#Wa~P#)tO#d(QXP(QXX(QX^(QXk(QXz(QX!e(QX!h(QX!l(QX#g(QX#h(QX#i(QX#j(QX#k(QX#l(QX#m(QX#n(QX#o(QX#q(QX#s(QX#u(QX#v(QX'k(QX(R(QX(b(QX!g(QX!S(QX'i(QXo(QX!X(QX%a(QX!a(QX~P!3oO!V.YOd([X~P!0ROd.[O~O!V.]O!g(]X~P!6UO!g.`O~O!S.bO~OP$YOy#vOz#wO|#xO!f#tO!h#uO!l$YO(RVOX#fi^#fik#fi!V#fi!e#fi#h#fi#i#fi#j#fi#k#fi#l#fi#m#fi#n#fi#o#fi#q#fi#s#fi#u#fi#v#fi'k#fi(b#fi(i#fi(j#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~O#g#fi~P#-pO#g#{O~P#-pOP$YOy#vOz#wO|#xO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O(RVOX#fi^#fi!V#fi!e#fi#k#fi#l#fi#m#fi#n#fi#o#fi#q#fi#s#fi#u#fi#v#fi'k#fi(b#fi(i#fi(j#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~Ok#fi~P#0bOk#}O~P#0bOP$YOk#}Oy#vOz#wO|#xO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO(RVO^#fi!V#fi#q#fi#s#fi#u#fi#v#fi'k#fi(b#fi(i#fi(j#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~OX#fi!e#fi#l#fi#m#fi#n#fi#o#fi~P#3SOX$aO!e$PO#l$PO#m$PO#n$`O#o$PO~P#3SOP$YOX$aOk#}Oy#vOz#wO|#xO!e$PO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO#l$PO#m$PO#n$`O#o$PO#q$QO(RVO^#fi!V#fi#s#fi#u#fi#v#fi'k#fi(b#fi(j#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~O(i#fi~P#6TO(i#yO~P#6TOP$YOX$aOk#}Oy#vOz#wO|#xO!e$PO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO#l$PO#m$PO#n$`O#o$PO#q$QO#s$SO(RVO(i#yO^#fi!V#fi#u#fi#v#fi'k#fi(b#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~O(j#fi~P#8uO(j#zO~P#8uOP$YOX$aOk#}Oy#vOz#wO|#xO!e$PO!f#tO!h#uO!l$YO#g#{O#h#|O#i#|O#j#|O#k$OO#l$PO#m$PO#n$`O#o$PO#q$QO#s$SO#u$UO(RVO(i#yO(j#zO~O^#fi!V#fi#v#fi'k#fi(b#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~P#;gOPYXXYXkYXyYXzYX|YX!eYX!fYX!hYX!lYX#XYX#dcX#gYX#hYX#iYX#jYX#kYX#lYX#mYX#nYX#oYX#qYX#sYX#uYX#vYX#{YX(RYX(bYX(iYX(jYX!VYX!WYX~O#yYX~P#>QOP$YOX:TOk9wOy#vOz#wO|#xO!e9yO!f#tO!h#uO!l$YO#g9uO#h9vO#i9vO#j9vO#k9xO#l9yO#m9yO#n:SO#o9yO#q9zO#s9|O#u:OO#v:PO(RVO(b$WO(i#yO(j#zO~O#y.dO~P#@_O#X:UO#{:UO#y(WX!W(WX~PNlO^'Ya!V'Ya'k'Ya'i'Ya!g'Ya!S'Yao'Ya!X'Ya%a'Ya!a'Ya~P!6UOP#fiX#fi^#fik#fiz#fi!V#fi!e#fi!f#fi!h#fi!l#fi#g#fi#h#fi#i#fi#j#fi#k#fi#l#fi#m#fi#n#fi#o#fi#q#fi#s#fi#u#fi#v#fi'k#fi(R#fi(b#fi'i#fi!S#fi!g#fio#fi!X#fi%a#fi!a#fi~P#)tO^#zi!V#zi'k#zi'i#zi!S#zi!g#zio#zi!X#zi%a#zi!a#zi~P!6UO$W.iO$Y.iO~O$W.jO$Y.jO~O!a)YO#X.kO!X$^X$T$^X$W$^X$Y$^X$a$^X~O!U.lO~O!X)]O$T.nO$W)[O$Y)[O$a.oO~O!V:QO!W(VX~P#@_O!W.pO~O!a)YO$a(kX~O$a.rO~Oq)lO(S)mO(T.uO~Ol.xO!S.yO'vTO'yUO~O!VcX!acX!gcX!g$sX(bcX~P!.xO!g/PO~P#)tO!V/QO!a#rO(b'bO!g(oX~O!g/VO~O!U)}O't%eO!g(oP~O#d/XO~O!S$sX!V$sX!a$zX~P!.xO!V/YO!S(pX~P#)tO!a/[O~O!S/^O~Ok/bO!a#rO!h%ZO'}%OO(b'bO~O't/dO~O!a*}O~O^%^O!V/hO'k%^O~O!W/jO~P!2vO!]/kO!^/kO'u!iO(U!jO~O|/mO(U!jO~O#T/nO~O't%|Od'_X!V'_X~O!V*gOd(Oa~Od/sO~Oy/tOz/tO|/uOgva(iva(jva!Vva#Xva~Odva#yva~P#L|Oy)qO|)rOg$la(i$la(j$la!V$la#X$la~Od$la#y$la~P#MrOy)qO|)rOg$na(i$na(j$na!V$na#X$na~Od$na#y$na~P#NeO#d/wO~Od$|a!V$|a#X$|a#y$|a~P!0RO!a#rO~O#d/zO~Oy#vOz#wO|#xO!f#tO!h#uO(RVOP!niX!nik!ni!V!ni!e!ni!l!ni#g!ni#h!ni#i!ni#j!ni#k!ni#l!ni#m!ni#n!ni#o!ni#q!ni#s!ni#u!ni#v!ni(b!ni(i!ni(j!ni~O^!ni'k!ni'i!ni!S!ni!g!nio!ni!X!ni%a!ni!a!ni~P$ wOg.PO!X'QO%a.OO~Oi0RO't0QO~P!0sO!a*}O^'|a!X'|a'k'|a!V'|a~O#d0XO~OXYX!VcX!WcX~O!V0YO!W(wX~O!W0[O~OX0]O~O't+VO'vTO'yUO~O!X%nO't%eO]'gX!V'gX~O!V+[O](va~O!g0bO~P!6UOX0eO~O]0fO~O!V+hO^(sa'k(sa~O#X0lO~Og0oO!X$yO~O(U(oO!W(tP~Og0xO!X0uO%a0wO'}%OO~OX1SO!V1QO!W(uX~O!W1TO~O]1VO^%^O'k%^O~O't#jO'vTO'yUO~O#X$bO#{$bOP(WXX(WXk(WXy(WXz(WX|(WX!V(WX!e(WX!h(WX!l(WX#g(WX#h(WX#i(WX#j(WX#k(WX#l(WX#m(WX#n(WX#q(WX#s(WX#u(WX#v(WX(R(WX(b(WX(i(WX(j(WX~O#o1YO&Q1ZO^(WX!f(WX~P$(xO#X$bO#o1YO&Q1ZO~O^1[O~P%QO^1^O~O&Z1bOP&XiQ&XiV&Xi^&Xia&Xib&Xii&Xik&Xil&Xim&Xis&Xiu&Xiw&Xi|&Xi!Q&Xi!R&Xi!X&Xi!c&Xi!h&Xi!k&Xi!l&Xi!m&Xi!o&Xi!q&Xi!t&Xi!x&Xi#p&Xi$Q&Xi$U&Xi%`&Xi%b&Xi%d&Xi%e&Xi%h&Xi%j&Xi%m&Xi%n&Xi%p&Xi%|&Xi&S&Xi&U&Xi&W&Xi&Y&Xi&]&Xi&c&Xi&i&Xi&k&Xi&m&Xi&o&Xi&q&Xi'i&Xi't&Xi'v&Xi'y&Xi(R&Xi(a&Xi(n&Xi!W&Xi_&Xi&`&Xi~O_1hO!W1fO&`1gO~P`O!XXO!h1jO~O&g,eOP&biQ&biV&bi^&bia&bib&bii&bik&bil&bim&bis&biu&biw&bi|&bi!Q&bi!R&bi!X&bi!c&bi!h&bi!k&bi!l&bi!m&bi!o&bi!q&bi!t&bi!x&bi#p&bi$Q&bi$U&bi%`&bi%b&bi%d&bi%e&bi%h&bi%j&bi%m&bi%n&bi%p&bi%|&bi&S&bi&U&bi&W&bi&Y&bi&]&bi&c&bi&i&bi&k&bi&m&bi&o&bi&q&bi'i&bi't&bi'v&bi'y&bi(R&bi(a&bi(n&bi!W&bi&Z&bi_&bi&`&bi~O!S1pO~O!V!Za!W!Za~P#@_Ol!kO|!lO!U1vO(U!jO!V&}X!W&}X~P?fO!V,uO!W(Ya~O!V'TX!W'TX~P!@xO!V,xO!W(ha~O!W1}O~P'TO^%^O#X2WO'k%^O~O^%^O!a#rO#X2WO'k%^O~O^%^O!a#rO!l2[O#X2WO'k%^O(b'bO~O^%^O'k%^O~P!6UO!V$^Oo$ka~O!S&|i!V&|i~P!6UO!V'vO!S(Xi~O!V'}O!S(fi~O!S(gi!V(gi~P!6UO!V(di!g(di^(di'k(di~P!6UO#X2^O!V(di!g(di^(di'k(di~O!V(ZO!g(ci~O|%vO!X%wO!x]O#b2cO#c2bO't%eO~O|%vO!X%wO#c2bO't%eO~Og2jO!X'QO%a2iO~Og2jO!X'QO%a2iO'}%OO~O#dvaPvaXva^vakva!eva!fva!hva!lva#gva#hva#iva#jva#kva#lva#mva#nva#ova#qva#sva#uva#vva'kva(Rva(bva!gva!Sva'ivaova!Xva%ava!ava~P#L|O#d$laP$laX$la^$lak$laz$la!e$la!f$la!h$la!l$la#g$la#h$la#i$la#j$la#k$la#l$la#m$la#n$la#o$la#q$la#s$la#u$la#v$la'k$la(R$la(b$la!g$la!S$la'i$lao$la!X$la%a$la!a$la~P#MrO#d$naP$naX$na^$nak$naz$na!e$na!f$na!h$na!l$na#g$na#h$na#i$na#j$na#k$na#l$na#m$na#n$na#o$na#q$na#s$na#u$na#v$na'k$na(R$na(b$na!g$na!S$na'i$nao$na!X$na%a$na!a$na~P#NeO#d$|aP$|aX$|a^$|ak$|az$|a!V$|a!e$|a!f$|a!h$|a!l$|a#g$|a#h$|a#i$|a#j$|a#k$|a#l$|a#m$|a#n$|a#o$|a#q$|a#s$|a#u$|a#v$|a'k$|a(R$|a(b$|a!g$|a!S$|a'i$|a#X$|ao$|a!X$|a%a$|a!a$|a~P#)tO^#[q!V#[q'k#[q'i#[q!S#[q!g#[qo#[q!X#[q%a#[q!a#[q~P!6UOd'OX!V'OX~P!'^O!V.YOd([a~O!U2rO!V'PX!g'PX~P%QO!V.]O!g(]a~O!V.]O!g(]a~P!6UO!S2uO~O#y!ja!W!ja~PJ`O#y!ba!V!ba!W!ba~P#@_O#y!na!W!na~P!8oO#y!pa!W!pa~P!;YO!X3XO$UfO$_3YO~O!W3^O~Oo3_O~P#)tO^$hq!V$hq'k$hq'i$hq!S$hq!g$hqo$hq!X$hq%a$hq!a$hq~P!6UO!S3`O~Ol.xO'vTO'yUO~Oy)qO|)rO(j)vOg%Xi(i%Xi!V%Xi#X%Xi~Od%Xi#y%Xi~P$GeOy)qO|)rOg%Zi(i%Zi(j%Zi!V%Zi#X%Zi~Od%Zi#y%Zi~P$HWO(b$WO~P#)tO!U3cO't%eO!V'ZX!g'ZX~O!V/QO!g(oa~O!V/QO!a#rO!g(oa~O!V/QO!a#rO(b'bO!g(oa~Od$ui!V$ui#X$ui#y$ui~P!0RO!U3kO't*SO!S']X!V']X~P!0pO!V/YO!S(pa~O!V/YO!S(pa~P#)tO!a#rO#o3sO~Ok3vO!a#rO(b'bO~Od(Pi!V(Pi~P!0RO#X3yOd(Pi!V(Pi~P!0RO!g3|O~O^$iq!V$iq'k$iq'i$iq!S$iq!g$iqo$iq!X$iq%a$iq!a$iq~P!6UO!V4QO!X(qX~P#)tO!f#tO~P3}O^$sX!X$sX%UYX'k$sX!V$sX~P!.xO%U4SO^hXghXyhX|hX!XhX'khX(ihX(jhX!VhX~O%U4SO~O%b4ZO't+VO'vTO'yUO!V'fX!W'fX~O!V0YO!W(wa~OX4_O~O]4`O~O!S4dO~O^%^O'k%^O~P#)tO!X$yO~P#)tO!V4iO#X4kO!W(tX~O!W4lO~Ol!kO|4mO![!uO!]!rO!^!rO!x9mO!|!mO!}!mO#O!mO#P!mO#Q!mO#T4rO#U!vO'u!iO'vTO'yUO(U!jO(a!pO~O!W4qO~P%!VOg4wO!X0uO%a4vO~Og4wO!X0uO%a4vO'}%OO~O't#jO!V'eX!W'eX~O!V1QO!W(ua~O'vTO'yUO(U5QO~O]5UO~O!g5XO~P%QO^5ZO~O^5ZO~P%QO#o5]O&Q5^O~PMOO_1hO!W5bO&`1gO~P`O!a5dO~O!a5fO!V(Zi!W(Zi!a(Zi!h(Zi'}(Zi~O!V#ai!W#ai~P#@_O#X5gO!V#ai!W#ai~O!V!Zi!W!Zi~P#@_O^%^O#X5pO'k%^O~O^%^O!a#rO#X5pO'k%^O~O!V(dq!g(dq^(dq'k(dq~P!6UO!V(ZO!g(cq~O|%vO!X%wO#c5wO't%eO~O!X'QO%a5zO~Og5}O!X'QO%a5zO~O#d%XiP%XiX%Xi^%Xik%Xiz%Xi!e%Xi!f%Xi!h%Xi!l%Xi#g%Xi#h%Xi#i%Xi#j%Xi#k%Xi#l%Xi#m%Xi#n%Xi#o%Xi#q%Xi#s%Xi#u%Xi#v%Xi'k%Xi(R%Xi(b%Xi!g%Xi!S%Xi'i%Xio%Xi!X%Xi%a%Xi!a%Xi~P$GeO#d%ZiP%ZiX%Zi^%Zik%Ziz%Zi!e%Zi!f%Zi!h%Zi!l%Zi#g%Zi#h%Zi#i%Zi#j%Zi#k%Zi#l%Zi#m%Zi#n%Zi#o%Zi#q%Zi#s%Zi#u%Zi#v%Zi'k%Zi(R%Zi(b%Zi!g%Zi!S%Zi'i%Zio%Zi!X%Zi%a%Zi!a%Zi~P$HWO#d$uiP$uiX$ui^$uik$uiz$ui!V$ui!e$ui!f$ui!h$ui!l$ui#g$ui#h$ui#i$ui#j$ui#k$ui#l$ui#m$ui#n$ui#o$ui#q$ui#s$ui#u$ui#v$ui'k$ui(R$ui(b$ui!g$ui!S$ui'i$ui#X$uio$ui!X$ui%a$ui!a$ui~P#)tOd'Oa!V'Oa~P!0RO!V'Pa!g'Pa~P!6UO!V.]O!g(]i~O#y#[i!V#[i!W#[i~P#@_OP$YOy#vOz#wO|#xO!f#tO!h#uO!l$YO(RVOX#fik#fi!e#fi#h#fi#i#fi#j#fi#k#fi#l#fi#m#fi#n#fi#o#fi#q#fi#s#fi#u#fi#v#fi#y#fi(b#fi(i#fi(j#fi!V#fi!W#fi~O#g#fi~P%0fO#g9uO~P%0fOP$YOy#vOz#wO|#xO!f#tO!h#uO!l$YO#g9uO#h9vO#i9vO#j9vO(RVOX#fi!e#fi#k#fi#l#fi#m#fi#n#fi#o#fi#q#fi#s#fi#u#fi#v#fi#y#fi(b#fi(i#fi(j#fi!V#fi!W#fi~Ok#fi~P%2qOk9wO~P%2qOP$YOk9wOy#vOz#wO|#xO!f#tO!h#uO!l$YO#g9uO#h9vO#i9vO#j9vO#k9xO(RVO#q#fi#s#fi#u#fi#v#fi#y#fi(b#fi(i#fi(j#fi!V#fi!W#fi~OX#fi!e#fi#l#fi#m#fi#n#fi#o#fi~P%4|OX:TO!e9yO#l9yO#m9yO#n:SO#o9yO~P%4|OP$YOX:TOk9wOy#vOz#wO|#xO!e9yO!f#tO!h#uO!l$YO#g9uO#h9vO#i9vO#j9vO#k9xO#l9yO#m9yO#n:SO#o9yO#q9zO(RVO#s#fi#u#fi#v#fi#y#fi(b#fi(j#fi!V#fi!W#fi~O(i#fi~P%7hO(i#yO~P%7hOP$YOX:TOk9wOy#vOz#wO|#xO!e9yO!f#tO!h#uO!l$YO#g9uO#h9vO#i9vO#j9vO#k9xO#l9yO#m9yO#n:SO#o9yO#q9zO#s9|O(RVO(i#yO#u#fi#v#fi#y#fi(b#fi!V#fi!W#fi~O(j#fi~P%9sO(j#zO~P%9sOP$YOX:TOk9wOy#vOz#wO|#xO!e9yO!f#tO!h#uO!l$YO#g9uO#h9vO#i9vO#j9vO#k9xO#l9yO#m9yO#n:SO#o9yO#q9zO#s9|O#u:OO(RVO(i#yO(j#zO~O#v#fi#y#fi(b#fi!V#fi!W#fi~P%<OO^#wy!V#wy'k#wy'i#wy!S#wy!g#wyo#wy!X#wy%a#wy!a#wy~P!6UOg;hOy)qO|)rO(i)tO(j)vO~OP#fiX#fik#fiz#fi!e#fi!f#fi!h#fi!l#fi#g#fi#h#fi#i#fi#j#fi#k#fi#l#fi#m#fi#n#fi#o#fi#q#fi#s#fi#u#fi#v#fi#y#fi(R#fi(b#fi!V#fi!W#fi~P%>vO!f#tOP(QXX(QXg(QXk(QXy(QXz(QX|(QX!e(QX!h(QX!l(QX#g(QX#h(QX#i(QX#j(QX#k(QX#l(QX#m(QX#n(QX#o(QX#q(QX#s(QX#u(QX#v(QX#y(QX(R(QX(b(QX(i(QX(j(QX!V(QX!W(QX~O#y#zi!V#zi!W#zi~P#@_O#y!ni!W!ni~P$ wO!W6ZO~O!V'Ya!W'Ya~P#@_O!a#rO(b'bO!V'Za!g'Za~O!V/QO!g(oi~O!V/QO!a#rO!g(oi~Od$uq!V$uq#X$uq#y$uq~P!0RO!S']a!V']a~P#)tO!a6bO~O!V/YO!S(pi~P#)tO!V/YO!S(pi~O!S6fO~O!a#rO#o6kO~Ok6lO!a#rO(b'bO~O!S6nO~Od$wq!V$wq#X$wq#y$wq~P!0RO^$iy!V$iy'k$iy'i$iy!S$iy!g$iyo$iy!X$iy%a$iy!a$iy~P!6UO!V4QO!X(qa~O^#[y!V#[y'k#[y'i#[y!S#[y!g#[yo#[y!X#[y%a#[y!a#[y~P!6UOX6sO~O!V0YO!W(wi~O]6yO~O!a5fO~O(U(oO!V'bX!W'bX~O!V4iO!W(ta~OikO't7QO~P._O!W7TO~P%!VOl!kO|7UO'vTO'yUO(U!jO(a!pO~O!X0uO~O!X0uO%a7WO~Og7ZO!X0uO%a7WO~OX7`O!V'ea!W'ea~O!V1QO!W(ui~O!g7dO~O!g7eO~O!g7fO~O!g7fO~P%QO^7hO~O!a7kO~O!g7lO~O!V(gi!W(gi~P#@_O^%^O#X7tO'k%^O~O!V(dy!g(dy^(dy'k(dy~P!6UO!V(ZO!g(cy~O!X'QO%a7wO~O#d$uqP$uqX$uq^$uqk$uqz$uq!V$uq!e$uq!f$uq!h$uq!l$uq#g$uq#h$uq#i$uq#j$uq#k$uq#l$uq#m$uq#n$uq#o$uq#q$uq#s$uq#u$uq#v$uq'k$uq(R$uq(b$uq!g$uq!S$uq'i$uq#X$uqo$uq!X$uq%a$uq!a$uq~P#)tO#d$wqP$wqX$wq^$wqk$wqz$wq!V$wq!e$wq!f$wq!h$wq!l$wq#g$wq#h$wq#i$wq#j$wq#k$wq#l$wq#m$wq#n$wq#o$wq#q$wq#s$wq#u$wq#v$wq'k$wq(R$wq(b$wq!g$wq!S$wq'i$wq#X$wqo$wq!X$wq%a$wq!a$wq~P#)tO!V'Pi!g'Pi~P!6UO#y#[q!V#[q!W#[q~P#@_Oy/tOz/tO|/uOPvaXvagvakva!eva!fva!hva!lva#gva#hva#iva#jva#kva#lva#mva#nva#ova#qva#sva#uva#vva#yva(Rva(bva(iva(jva!Vva!Wva~Oy)qO|)rOP$laX$lag$lak$laz$la!e$la!f$la!h$la!l$la#g$la#h$la#i$la#j$la#k$la#l$la#m$la#n$la#o$la#q$la#s$la#u$la#v$la#y$la(R$la(b$la(i$la(j$la!V$la!W$la~Oy)qO|)rOP$naX$nag$nak$naz$na!e$na!f$na!h$na!l$na#g$na#h$na#i$na#j$na#k$na#l$na#m$na#n$na#o$na#q$na#s$na#u$na#v$na#y$na(R$na(b$na(i$na(j$na!V$na!W$na~OP$|aX$|ak$|az$|a!e$|a!f$|a!h$|a!l$|a#g$|a#h$|a#i$|a#j$|a#k$|a#l$|a#m$|a#n$|a#o$|a#q$|a#s$|a#u$|a#v$|a#y$|a(R$|a(b$|a!V$|a!W$|a~P%>vO#y$hq!V$hq!W$hq~P#@_O#y$iq!V$iq!W$iq~P#@_O!W8RO~O#y8SO~P!0RO!a#rO!V'Zi!g'Zi~O!a#rO(b'bO!V'Zi!g'Zi~O!V/QO!g(oq~O!S']i!V']i~P#)tO!V/YO!S(pq~O!S8YO~P#)tO!S8YO~Od(Py!V(Py~P!0RO!V'`a!X'`a~P#)tO^%Tq!X%Tq'k%Tq!V%Tq~P#)tOX8_O~O!V0YO!W(wq~O#X8cO!V'ba!W'ba~O!V4iO!W(ti~P#@_OPYXXYXkYXyYXzYX|YX!SYX!VYX!eYX!fYX!hYX!lYX#XYX#dcX#gYX#hYX#iYX#jYX#kYX#lYX#mYX#nYX#oYX#qYX#sYX#uYX#vYX#{YX(RYX(bYX(iYX(jYX~O!a%RX#o%RX~P&/vO!X0uO%a8gO~O'vTO'yUO(U8lO~O!V1QO!W(uq~O!g8oO~O!g8oO~P%QO!g8qO~O!g8rO~O#X8tO!V#ay!W#ay~O!V#ay!W#ay~P#@_O!X'QO%a8yO~O#y#wy!V#wy!W#wy~P#@_OP$uiX$uik$uiz$ui!e$ui!f$ui!h$ui!l$ui#g$ui#h$ui#i$ui#j$ui#k$ui#l$ui#m$ui#n$ui#o$ui#q$ui#s$ui#u$ui#v$ui#y$ui(R$ui(b$ui!V$ui!W$ui~P%>vOy)qO|)rO(j)vOP%XiX%Xig%Xik%Xiz%Xi!e%Xi!f%Xi!h%Xi!l%Xi#g%Xi#h%Xi#i%Xi#j%Xi#k%Xi#l%Xi#m%Xi#n%Xi#o%Xi#q%Xi#s%Xi#u%Xi#v%Xi#y%Xi(R%Xi(b%Xi(i%Xi!V%Xi!W%Xi~Oy)qO|)rOP%ZiX%Zig%Zik%Ziz%Zi!e%Zi!f%Zi!h%Zi!l%Zi#g%Zi#h%Zi#i%Zi#j%Zi#k%Zi#l%Zi#m%Zi#n%Zi#o%Zi#q%Zi#s%Zi#u%Zi#v%Zi#y%Zi(R%Zi(b%Zi(i%Zi(j%Zi!V%Zi!W%Zi~O#y$iy!V$iy!W$iy~P#@_O#y#[y!V#[y!W#[y~P#@_O!a#rO!V'Zq!g'Zq~O!V/QO!g(oy~O!S']q!V']q~P#)tO!S9QO~P#)tO!V0YO!W(wy~O!V4iO!W(tq~O!X0uO%a9XO~O!g9[O~O!X'QO%a9aO~OP$uqX$uqk$uqz$uq!e$uq!f$uq!h$uq!l$uq#g$uq#h$uq#i$uq#j$uq#k$uq#l$uq#m$uq#n$uq#o$uq#q$uq#s$uq#u$uq#v$uq#y$uq(R$uq(b$uq!V$uq!W$uq~P%>vOP$wqX$wqk$wqz$wq!e$wq!f$wq!h$wq!l$wq#g$wq#h$wq#i$wq#j$wq#k$wq#l$wq#m$wq#n$wq#o$wq#q$wq#s$wq#u$wq#v$wq#y$wq(R$wq(b$wq!V$wq!W$wq~P%>vOd%]!Z!V%]!Z#X%]!Z#y%]!Z~P!0RO!V'bq!W'bq~P#@_O!V#a!Z!W#a!Z~P#@_O#d%]!ZP%]!ZX%]!Z^%]!Zk%]!Zz%]!Z!V%]!Z!e%]!Z!f%]!Z!h%]!Z!l%]!Z#g%]!Z#h%]!Z#i%]!Z#j%]!Z#k%]!Z#l%]!Z#m%]!Z#n%]!Z#o%]!Z#q%]!Z#s%]!Z#u%]!Z#v%]!Z'k%]!Z(R%]!Z(b%]!Z!g%]!Z!S%]!Z'i%]!Z#X%]!Zo%]!Z!X%]!Z%a%]!Z!a%]!Z~P#)tOP%]!ZX%]!Zk%]!Zz%]!Z!e%]!Z!f%]!Z!h%]!Z!l%]!Z#g%]!Z#h%]!Z#i%]!Z#j%]!Z#k%]!Z#l%]!Z#m%]!Z#n%]!Z#o%]!Z#q%]!Z#s%]!Z#u%]!Z#v%]!Z#y%]!Z(R%]!Z(b%]!Z!V%]!Z!W%]!Z~P%>vOo(VX~P1gO'u!iO~P!)jO!ScX!VcX#XcX~P&/vOPYXXYXkYXyYXzYX|YX!VYX!VcX!eYX!fYX!hYX!lYX#XYX#XcX#dcX#gYX#hYX#iYX#jYX#kYX#lYX#mYX#nYX#oYX#qYX#sYX#uYX#vYX#{YX(RYX(bYX(iYX(jYX~O!acX!gYX!gcX(bcX~P&E^OP9lOQ9lOa;]Ob!fOikOk9lOlkOmkOskOu9lOw9lO|WO!QkO!RkO!XXO!c9oO!hZO!k9lO!l9lO!m9lO!o9pO!q9qO!t!eO$Q!hO$UfO't)PO'vTO'yUO(RVO(a[O(n;ZO~O!V:QO!W$ka~Oi%POk$qOl$pOm$pOs%QOu%ROw:WO|$xO!X$yO!c;bO!h$uO#c:^O$Q%VO$m:YO$o:[O$r%WO't(gO'vTO'yUO'}%OO(R$rO~O#p)WO~P&JSO!WYX!WcX~P&E^O#d9tO~O!a#rO#d9tO~O#X:UO~O#o9yO~O#X:`O!V(gX!W(gX~O#X:UO!V(eX!W(eX~O#d:aO~Od:cO~P!0RO#d:hO~O#d:iO~O!a#rO#d:jO~O!a#rO#d:aO~O#y:kO~P#@_O#d:lO~O#d:mO~O#d:nO~O#d:oO~O#d:pO~O#d:qO~O#y:rO~P!0RO#y:sO~P!0RO$U~!f!|!}#P#Q#T#b#c#n(n$m$o$r%U%`%a%b%h%j%m%n%p%r~'oR$U(n#h!R'm'u#il#g#jky'n(U'n't$W$Y$W~",goto:"$%Z({PPPP(|P)PP)aP*p.rPPPP5SPP5iP;d>iP>|P>|PPP>|P@lP>|P>|P>|P@pPP@uPA`PFUPPPFYPPPPFYIXPPPI_JYPFYPLgPPPPNuFYPPPFYPFYP!#TFYP!&g!'i!'rP!(e!(i!(ePPPPP!+r!'iPP!,`!-YP!/|FYFY!0R!3Z!7n!7n!;cPPP!;jFYPPPPPPPPPPP!>uP!@WPPFY!AePFYPFYFYFYFYPFY!BwPP!E}P!IPP!IT!I_!Ic!IcP!EzP!Ig!IgP!LiP!LmFYFY!Ls# t>|P>|P>|>|P##O>|>|#$x>|#'V>|#(y>|>|#)g#+c#+c#+g#+o#+c#+wP#+cP>|#,a>|#-i>|>|5SPPP#.tPP#/^#/^P#/^P#/s#/^PP#/yP#/pP#/p#0]#/p#0w#0}5P)P#1Q)PP#1X#1X#1XP)PP)PP)PP)PPP)PP#1_#1bP#1b)PP#1fP#1iP)PP)PP)PP)PP)PP)P)PPP#1o#1u#2P#2V#2]#2c#2i#2w#2}#3T#3_#3e#3o#4O#4U#4u#5X#5_#5e#5s#6Y#7j#7x#8O#8U#8[#8b#8l#8r#8x#9S#9f#9lPPPPPPPPPP#9rPPPPPPP#:f#=mP#>|#?T#?]PPPP#Cg#F]#Lr#Lu#Lx#Mq#Mt#Mw#NO#NWPP#N^#Nb$ Z$!Z$!_$!sPP$!w$!}$#RP$#U$#Y$#]$$R$$i$$n$$q$$t$$z$$}$%R$%VR!xRmpOXr!X#`%]&d&f&g&i,],b1b1eY!rQ'Q,}0u4pQ%ctQ%kwQ%rzQ&[!TS&x!c,uQ'W!fS'^!o!uS*Y$y*_Q+T%lQ+b%tQ+|&UQ,{'PQ-V'XQ-_'_Q/k*aQ1P+}R:_9p$zdOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&d&f&g&i&m&u'S'd't'v'|(T(i(m(q)p*s+g,X,],b-R-Z-i-o.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2r4m4w5Z5]5^5p7U7Z7h7tS#m]9m!r)R$X$j&y)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^Q*j%SQ+Y%nQ,O&XQ,V&aQ.S:VQ0O*{Q0S*}Q0_+ZQ1X,TQ2f.PQ4Y0YQ5O1QQ5|2jQ6S:WQ6u4ZR7z5}&xkOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^t!kQ!o!r!u!v&x'P'Q'^'_'`,u,{,}-_0u4p4r$Y$pi#r#t$`$a$u$x%T%U%Y)l)u)w)x*P*V*e*f*z*}+l+o.O.Y/X/Y/[/w0l0o0w2i3a3k3s3y4Q4S4v5z6b6k7W7w8S8g8y9X9a:S:T:X:Y:Z:[:]:^:d:e:f:g:h:i:l:m:n:o:r:s;Z;c;d;g;hQ%uzQ&v!cS&|%w,xQ+Y%nS.x)r.zQ/v*nQ0_+ZQ0d+aQ1W,SQ1X,TQ4Y0YQ4c0fQ5R1SQ5S1VQ6u4ZQ6x4`Q7c5UQ8b6yR8m7`pmOXr!T!X#`%]&Z&d&f&g&i,],b1b1eR,Q&]&r^OPXYrstux!X!^!g!l#O#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j%]%c%p&]&`&a&d&f&g&i&m&u'S'd'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;];^[#XWZ#S#V&y'tQ%fvQ%jwS%oz%t!U%x|}#d#e#h%Z%v'}(X(Y(Z+e+f+h,Z,o-m-s-t-u-w1j2b2c5f5wQ&Q!RQ'T!eQ'V!fQ(b#oS)|$u*QS+S%k%lQ+W%nQ+w&SQ+{&US-U'W'XQ.R(cQ/U)}Q0W+TQ0^+ZQ0`+[Q0c+`Q0z+xS1O+|+}Q2S-VQ3b/QQ4X0YQ4]0]Q4b0eQ4}1PQ6_3cQ6t4ZQ6w4_Q8^6sR9S8_v$wi#t%T%U%Y)u)w*P*e*f.Y/X/w3a3y8S;Z;c;d!S%hw!f!q%j%k%l&w'V'W'X']'g*X+S+T,r-U-V-^/c0W1{2S2Z3uQ*|%fQ+m%}Q+p&OQ+z&UQ.Q(bQ0y+wU0}+{+|+}Q2k.RQ4x0zS4|1O1PQ7_4}!z;_#r$`$a$u$x)l)x*V*z*}+l+o.O/Y/[0l0o0w2i3k3s4Q4S4v5z6b6k7W7w8g8y9X9a:X:Z:]:d:f:h:l:n:r;g;hg;`:S:T:Y:[:^:e:g:i:m:o:sW$|i%O*g;ZS%}!O&ZQ&O!PQ&P!QR+k%{$Z${i#r#t$`$a$u$x%T%U%Y)l)u)w)x*P*V*e*f*z*}+l+o.O.Y/X/Y/[/w0l0o0w2i3a3k3s3y4Q4S4v5z6b6k7W7w8S8g8y9X9a:S:T:X:Y:Z:[:]:^:d:e:f:g:h:i:l:m:n:o:r:s;Z;c;d;g;hT)m$r)nV*k%S:V:WU&|!c%w,xS(p#v#wQ+_%qS-z(^(_Q0p+qQ3z/tR6}4i&xkOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^$i$]c#U#a%a%b%d's'y(e(l(t(u(v(w(x(y(z({(|(})O)Q)T)X)c*x+^,s-b-g-l-n.X._.c.e.f.g.v/x1q1t2U2]2q2v2w2x2y2z2{2|2}3O3P3Q3R3S3V3W3]4O4V5i5o5t6Q6R6W6X7P7n7r7{8P8Q8v9U9]9n;QT#PV#Q&ykOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^Q&z!cR1w,uv!kQ!c!o!r!u!v&x'P'Q'^'_'`,u,{,}-_0u4p4rS*X$y*_S/c*Y*aQ/l*bQ0r+sQ3u/kR3x/nlpOXr!X#`%]&d&f&g&i,],b1b1eQ&k![Q'h!tS(d#q9tQ+Q%iQ+u&QQ+v&RQ-S'UQ-a'aS.W(i:aS/y*s:jQ0U+RQ0t+tQ1i,dQ1k,eQ1s,pQ2Q-TQ2T-XS4P/z:pQ4T0VS4W0X:qQ5h1uQ5l2RQ5q2YQ6r4UQ7o5jQ7p5mQ7s5rR8s7l$d$[c#U#a%b%d's'y(e(l(t(u(v(w(x(y(z({(|(})O)Q)T)X)c*x+^,s-b-g-l-n.X._.c.f.g.v/x1q1t2U2]2q2v2w2x2y2z2{2|2}3O3P3Q3R3S3V3W3]4O4V5i5o5t6Q6R6W6X7P7n7r7{8P8Q8v9U9]9n;QS(a#l'ZU*d$z(h3US*w%a.eQ2g0OQ5y2fQ7y5|R8z7z$d$Zc#U#a%b%d's'y(e(l(t(u(v(w(x(y(z({(|(})O)Q)T)X)c*x+^,s-b-g-l-n.X._.c.f.g.v/x1q1t2U2]2q2v2w2x2y2z2{2|2}3O3P3Q3R3S3V3W3]4O4V5i5o5t6Q6R6W6X7P7n7r7{8P8Q8v9U9]9n;QS(`#l'ZS(r#w$[S*v%a.eS-{(_(aQ.h)SQ/{*wR2d-|&xkOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^S#m]9mQ&f!VQ&g!WQ&i!YQ&j!ZR1a,`Q'R!eQ*y%fQ-Q'TS-}(b*|Q2O-PW2h.Q.R/}0PQ5k2PU5x2e2g2kS7v5y5{S8x7x7yS9_8w8zQ9g9`R9j9hU!sQ'Q,}T4n0u4p!O_OXZ`r!T!X#`#d%Z%]&Z&]&d&f&g&i(Z,],b-t1b1e]!mQ!o'Q,}0u4pT#m]9m%UyOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&a&d&f&g&i&m&u'S'd't'v'|(T(i(m(q)p*s*{+g,X,],b-R-Z-i-o.P.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2j2r4m4w5Z5]5^5p5}7U7Z7h7tS(p#v#wS-z(^(_!s:w$X$j&y)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^Y!qQ'Q,}0u4pQ']!oS'g!r!uS'i!v4rS-^'^'_Q-`'`R2Z-_Q'f!qS(V#c1_S-]']'iQ/T)|Q/a*XQ2[-`Q3g/US3p/b/lQ6^3bS6i3v3xQ8U6_R8]6lQ#sbQ'e!qS(U#c1_S(W#i*rQ*t%[Q+O%gQ+U%mU-[']'f'iQ-p(VQ/S)|Q/`*XQ/f*[Q0T+PQ0{+yS2X-]-`Q2a-xS3f/T/US3o/a/lQ3r/eQ3t/gQ4z0|Q5s2[Q6]3bQ6a3gS6e3p3xQ6j3wQ7]4{S8T6^6_Q8X6fQ8Z6iQ8j7^Q9O8UQ9P8YQ9R8]Q9Z8kQ9c9QQ:z:uQ;V;OR;W;PV!sQ'Q,}%UaOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&a&d&f&g&i&m&u'S'd't'v'|(T(i(m(q)p*s*{+g,X,],b-R-Z-i-o.P.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2j2r4m4w5Z5]5^5p5}7U7Z7h7tS#sx!g!r:t$X$j&y)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^R:z;]%UbOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&a&d&f&g&i&m&u'S'd't'v'|(T(i(m(q)p*s*{+g,X,],b-R-Z-i-o.P.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2j2r4m4w5Z5]5^5p5}7U7Z7h7tQ%[j!S%gw!f!q%j%k%l&w'V'W'X']'g*X+S+T,r-U-V-^/c0W1{2S2Z3uS%mx!gQ+P%hQ+y&UW0|+z+{+|+}U4{0}1O1PS7^4|4}Q8k7_!r:u$X$j&y)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^Q;O;[R;P;]$xeOPXYrstu!X!^!l#O#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&d&f&g&i&m&u'S'd'v'|(T(i(m(q)p*s*{+g,X,],b-R-Z-i-o.P.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2j2r4m4w5Z5]5^5p5}7U7Z7h7tY#^WZ#S#V't!U%x|}#d#e#h%Z%v'}(X(Y(Z+e+f+h,Z,o-m-s-t-u-w1j2b2c5f5wQ,W&a!p:v$X$j)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^R:y&yS&}!c%wR1y,x$zdOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&d&f&g&i&m&u'S'd't'v'|(T(i(m(q)p*s+g,X,],b-R-Z-i-o.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2r4m4w5Z5]5^5p7U7Z7h7t!r)R$X$j&y)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^Q,V&aQ0O*{Q2f.PQ5|2jR7z5}!f$Rc#U%a's'y(e(l({(|(})O)T)X+^-b-g-l-n.X._.v/x2U2]2q3S4O4V5o5t6Q7r8v9n!T9{)Q)c,s.e1q1t2v3O3P3Q3R3V3]5i6R6W6X7P7n7{8P8Q9U9];Q!b$Tc#U%a's'y(e(l(})O)T)X+^-b-g-l-n.X._.v/x2U2]2q3S4O4V5o5t6Q7r8v9n!P9})Q)c,s.e1q1t2v3Q3R3V3]5i6R6W6X7P7n7{8P8Q9U9];Q!^$Xc#U%a's'y(e(l)T)X+^-b-g-l-n.X._.v/x2U2]2q3S4O4V5o5t6Q7r8v9nQ3a/Oz;^)Q)c,s.e1q1t2v3V3]5i6R6W6X7P7n7{8P8Q9U9];QQ;c;eR;d;f&xkOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^S$kh$lR3Y.k'PgOPWXYZhrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j$l%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.k.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^T$gf$mQ$efS)[$h)`R)h$mT$ff$mT)^$h)`'PhOPWXYZhrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$X$^$b$j$l%]%c%p&]&`&a&d&f&g&i&m&u&y'S'd't'v'|(T(i(m(q)e)p*s*{+g,X,],b,n,q-R-Z-i-o.P.].d.k.l/u/z0X0x1Y1Z1[1^1b1e1g1v2W2^2j2r3X4k4m4w5Z5]5^5g5p5}7U7Z7h7t8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^T$kh$lQ$nhR)g$l%UjOPWXYZrstu!X!^!l#O#S#V#`#k#q#u#x#{#|#}$O$P$Q$R$S$T$U$V$^$b%]%c%p&]&`&a&d&f&g&i&m&u'S'd't'v'|(T(i(m(q)p*s*{+g,X,],b-R-Z-i-o.P.].d/u/z0X0x1Y1Z1[1^1b1e1g2W2^2j2r4m4w5Z5]5^5p5}7U7Z7h7t!s;[$X$j&y)e,n,q.l1v3X4k5g8c8t9l9o9p9q9t9u9v9w9x9y9z9{9|9}:O:P:Q:U:_:`:a:c:j:k:p:q;^#alOPXZr!X!^!l#O#`#k#x$j%]&]&`&a&d&f&g&i&m&u'S(q)e*{+g,X,],b-R.P.l/u0x1Y1Z1[1^1b1e1g2j3X4m4w5Z5]5^5}7U7Z7hv$zi#t%T%U%Y)u)w*P*e*f.Y/X/w3a3y8S;Z;c;d!z(h#r$`$a$u$x)l)x*V*z*}+l+o.O/Y/[0l0o0w2i3k3s4Q4S4v5z6b6k7W7w8g8y9X9a:X:Z:]:d:f:h:l:n:r;g;hQ*o%WQ.w)qg3U:S:T:Y:[:^:e:g:i:m:o:sv$vi#t%T%U%Y)u)w*P*e*f.Y/X/w3a3y8S;Z;c;dQ*R$wS*[$y*_Q*p%XQ/g*]!z:|#r$`$a$u$x)l)x*V*z*}+l+o.O/Y/[0l0o0w2i3k3s4Q4S4v5z6b6k7W7w8g8y9X9a:X:Z:]:d:f:h:l:n:r;g;hf:}:S:T:Y:[:^:e:g:i:m:o:sQ;R;_Q;S;`Q;T;aR;U;bv$zi#t%T%U%Y)u)w*P*e*f.Y/X/w3a3y8S;Z;c;d!z(h#r$`$a$u$x)l)x*V*z*}+l+o.O/Y/[0l0o0w2i3k3s4Q4S4v5z6b6k7W7w8g8y9X9a:X:Z:]:d:f:h:l:n:r;g;hg3U:S:T:Y:[:^:e:g:i:m:o:slnOXr!X#`%]&d&f&g&i,],b1b1eQ*U$xQ,k&pQ,l&rR3j/Y$Y${i#r#t$`$a$u$x%T%U%Y)l)u)w)x*P*V*e*f*z*}+l+o.O.Y/X/Y/[/w0l0o0w2i3a3k3s3y4Q4S4v5z6b6k7W7w8S8g8y9X9a:S:T:X:Y:Z:[:]:^:d:e:f:g:h:i:l:m:n:o:r:s;Z;c;d;g;hQ+n&OQ0n+pQ4g0mR6|4hT*^$y*_S*^$y*_T4o0u4pS/e*Z4mT3w/m7UQ+O%gQ/f*[Q0T+PQ0{+yQ4z0|Q7]4{Q8j7^R9Z8kn)u$s(j*q/W/o/p2o3h3}6[6m8}:{;X;Y!W:d(f)V){*T.V.s/O/]/|0k0m2n3i3m4f4h6O6P6c6g6o6q8W8[9b;e;f]:e3T6V7|8{8|9kp)w$s(j*q.|/W/o/p2o3h3}6[6m8}:{;X;Y!Y:f(f)V){*T.V.s/O/]/|0k0m2l2n3i3m4f4h6O6P6c6g6o6q8W8[9b;e;f_:g3T6V7|7}8{8|9kpmOXr!T!X#`%]&Z&d&f&g&i,],b1b1eQ&W!SR,X&apmOXr!T!X#`%]&Z&d&f&g&i,],b1b1eR&W!SQ+r&PR0j+kqmOXr!T!X#`%]&Z&d&f&g&i,],b1b1eQ0v+wS4u0y0zU7V4s4t4xS8f7X7YS9V8e8hQ9d9WR9i9eQ&_!TR,R&ZR5R1SS%oz%tR0`+[Q&d!UR,]&eR,c&jT1c,b1eR,g&kQ,f&kR1l,gQ'k!wR-c'kQrOQ#`XT%`r#`Q!zTR'm!zQ!}UR'o!}Q)n$rR.t)nQ#QVR'q#QQ#TWU'w#T'x-jQ'x#UR-j'yQ,v&zR1x,vQ.Z(jR2p.ZQ.^(lS2s.^2tR2t._Q,}'QR1|,}Y!oQ'Q,}0u4pR'[!oS#ZW%vU(O#Z(P-kQ(P#[R-k'zQ,y&}R1z,yr`OXr!T!X#`%]&Z&]&d&f&g&i,],b1b1eS#dZ%ZU#n`#d-tR-t(ZQ([#fQ-q(WW-y([-q2_5uQ2_-rR5u2`Q)`$hR.m)`Q$lhR)f$lQ$_cU)U$_-f:RQ-f9nR:R)cQ/R)|W3d/R3e6`8VU3e/S/T/US6`3f3gR8V6a#m)s$s(f(j)V){*T*l*m*q.T.U.V.s.|.}/O/W/]/o/p/|0k0m2l2m2n2o3T3h3i3m3}4f4h6O6P6T6U6V6[6c6g6m6o6q7|7}8O8W8[8{8|8}9b9k:{;X;Y;e;fQ/Z*TU3l/Z3n6dQ3n/]R6d3mQ*_$yR/i*_Q*h$}R/r*hQ4R/|R6p4RQ+i%yR0i+iQ4j0pS7O4j8dR8d7PQ+t&QR0s+tQ4p0uR7S4pQ1R,OS5P1R7aR7a5RQ0Z+WW4[0Z4^6v8`Q4^0^Q6v4]R8`6wQ+]%oR0a+]Q1e,bR5a1eWqOXr#`Q&h!XQ*u%]Q,[&dQ,^&fQ,_&gQ,a&iQ1`,]S1c,b1eR5`1bQ%_oQ&l!]Q&o!_Q&q!`Q&s!aQ'c!qQ+Q%iQ+d%uQ+j%zQ,Q&_Q,i&nW-Y']'e'f'iQ-a'aQ/h*^Q0U+RS1U,R,UQ1m,hQ1n,kQ1o,lQ2T-XW2V-[-]-`-bQ4T0VQ4a0dQ4e0kQ4y0{Q5T1WQ5_1aU5n2U2X2[Q5q2YQ6r4UQ6z4cQ6{4fQ7R4oQ7[4zQ7b5SS7q5o5sQ7s5rQ8a6xQ8i7]Q8n7cQ8u7rQ9T8bQ9Y8jQ9^8vR9f9ZQ%iwQ'U!fQ'a!qU+R%j%k%lQ,p&wU-T'V'W'XS-X']'gQ/_*XS0V+S+TQ1u,rS2R-U-VQ2Y-^Q3q/cQ4U0WQ5j1{Q5m2SQ5r2ZR6h3uS$ti;ZR*i%OU$}i%O;ZR/q*gQ$siS(f#r*}Q(j#tS)V$`$aQ){$uQ*T$xQ*l%TQ*m%UQ*q%YQ.T:XQ.U:ZQ.V:]Q.s)lQ.|)uQ.})wQ/O)xQ/W*PQ/]*VQ/o*eQ/p*fh/|*z.O0w2i4v5z7W7w8g8y9X9aQ0k+lQ0m+oQ2l:dQ2m:fQ2n:hQ2o.YS3T:S:TQ3h/XQ3i/YQ3m/[Q3}/wQ4f0lQ4h0oQ6O:lQ6P:nQ6T:YQ6U:[Q6V:^Q6[3aQ6c3kQ6g3sQ6m3yQ6o4QQ6q4SQ7|:iQ7}:eQ8O:gQ8W6bQ8[6kQ8{:mQ8|:oQ8}8SQ9b:rQ9k:sQ:{;ZQ;X;cQ;Y;dQ;e;gR;f;hloOXr!X#`%]&d&f&g&i,],b1b1eQ!dPS#bZ#kQ&n!^U'Y!l4m7UQ'p#OQ(s#xQ)d$jS,U&]&`Q,Y&aQ,h&mQ,m&uQ-P'SQ.a(qQ.q)eQ0P*{Q0g+gQ1],XQ2P-RQ2g.PQ3[.lQ3{/uQ4t0xQ5V1YQ5W1ZQ5Y1[Q5[1^Q5c1gQ5y2jQ6Y3XQ7Y4wQ7g5ZQ7i5]Q7j5^Q7y5}Q8h7ZR8p7h#UcOPXZr!X!^!l#`#k#x%]&]&`&a&d&f&g&i&m&u'S(q*{+g,X,],b-R.P/u0x1Y1Z1[1^1b1e1g2j4m4w5Z5]5^5}7U7Z7hQ#UWQ#aYQ%asQ%btQ%duS's#S'vQ'y#VQ(e#qQ(l#uQ(t#{Q(u#|Q(v#}Q(w$OQ(x$PQ(y$QQ(z$RQ({$SQ(|$TQ(}$UQ)O$VQ)Q$XQ)T$^Q)X$bW)c$j)e.l3XQ*x%cQ+^%pS,s&y1vQ-b'dS-g't-iQ-l'|Q-n(TQ.X(iQ._(mQ.c9lQ.e9oQ.f9pQ.g9qQ.v)pQ/x*sQ1q,nQ1t,qQ2U-ZQ2]-oQ2q.]Q2v9tQ2w9uQ2x9vQ2y9wQ2z9xQ2{9yQ2|9zQ2}9{Q3O9|Q3P9}Q3Q:OQ3R:PQ3S.dQ3V:UQ3W:_Q3]:QQ4O/zQ4V0XQ5i:`Q5o2WQ5t2^Q6Q2rQ6R:aQ6W:cQ6X:jQ7P4kQ7n5gQ7r5pQ7{:kQ8P:pQ8Q:qQ8v7tQ9U8cQ9]8tQ9n#OR;Q;^R#WWR&{!cY!qQ'Q,}0u4pS&w!c,uQ']!oS'g!r!uS'i!v4rS,r&x'PS-^'^'_Q-`'`Q1{,{R2Z-_R(k#tR(n#uQ!dQT,|'Q,}]!nQ!o'Q,}0u4pQ#l]R'Z9mT#gZ%ZS#fZ%ZU%y|},ZU(W#d#e#hS-r(X(YQ-v(ZQ0h+hQ2`-sU2a-t-u-wS5v2b2cR7u5w`#YW#S#V%v't'}+e-mt#cZ|}#d#e#h%Z(X(Y(Z+h-s-t-u-w2b2c5wQ1_,ZQ1r,oQ5e1jQ7m5fT:x&y+fT#]W%vS#[W%vS'u#S'}S'z#V+eS,t&y+fT-h't-mT'O!c%wQ$hfR)j$mT)_$h)`R3Z.kT*O$u*QR*W$xQ/}*zQ2e.OQ4s0wQ5{2iQ7X4vQ7x5zQ8e7WQ8w7wQ9W8gQ9`8yQ9e9XR9h9alpOXr!X#`%]&d&f&g&i,],b1b1eQ&^!TR,Q&ZV%z|},ZR0q+qR,P&XQ%szR+c%tR+X%nT&b!U&eT&c!U&eT1d,b1e",nodeNames:"⚠ ArithOp ArithOp LineComment BlockComment Script ExportDeclaration export Star as VariableName String Escape from ; default FunctionDeclaration async function VariableDefinition > TypeParamList TypeDefinition extends ThisType this LiteralType ArithOp Number BooleanLiteral TemplateType InterpolationEnd Interpolation InterpolationStart NullType null VoidType void TypeofType typeof MemberExpression . ?. PropertyName [ TemplateString Escape Interpolation super RegExp ] ArrayExpression Spread , } { ObjectExpression Property async get set PropertyDefinition Block : NewExpression new TypeArgList CompareOp < ) ( ArgList UnaryExpression delete LogicOp BitOp YieldExpression yield AwaitExpression await ParenthesizedExpression ClassExpression class ClassBody MethodDeclaration Decorator @ MemberExpression PrivatePropertyName CallExpression declare Privacy static abstract override PrivatePropertyDefinition PropertyDeclaration readonly accessor Optional TypeAnnotation Equals StaticBlock FunctionExpression ArrowFunction ParamList ParamList ArrayPattern ObjectPattern PatternProperty Privacy readonly Arrow MemberExpression BinaryExpression ArithOp ArithOp ArithOp ArithOp BitOp CompareOp instanceof satisfies in const CompareOp BitOp BitOp BitOp LogicOp LogicOp ConditionalExpression LogicOp LogicOp AssignmentExpression UpdateOp PostfixExpression CallExpression TaggedTemplateExpression DynamicImport import ImportMeta JSXElement JSXSelfCloseEndTag JSXStartTag JSXSelfClosingTag JSXIdentifier JSXBuiltin JSXIdentifier JSXNamespacedName JSXMemberExpression JSXSpreadAttribute JSXAttribute JSXAttributeValue JSXEscape JSXEndTag JSXOpenTag JSXFragmentTag JSXText JSXEscape JSXStartCloseTag JSXCloseTag PrefixCast ArrowFunction TypeParamList SequenceExpression KeyofType keyof UniqueType unique ImportType InferredType infer TypeName ParenthesizedType FunctionSignature ParamList NewSignature IndexedType TupleType Label ArrayType ReadonlyType ObjectType MethodType PropertyType IndexSignature PropertyDefinition CallSignature TypePredicate is NewSignature new UnionType LogicOp IntersectionType LogicOp ConditionalType ParameterizedType ClassDeclaration abstract implements type VariableDeclaration let var TypeAliasDeclaration InterfaceDeclaration interface EnumDeclaration enum EnumBody NamespaceDeclaration namespace module AmbientDeclaration declare GlobalDeclaration global ClassDeclaration ClassBody AmbientFunctionDeclaration ExportGroup VariableName VariableName ImportDeclaration ImportGroup ForStatement for ForSpec ForInSpec ForOfSpec of WhileStatement while WithStatement with DoStatement do IfStatement if else SwitchStatement switch SwitchBody CaseLabel case DefaultLabel TryStatement try CatchClause catch FinallyClause finally ReturnStatement return ThrowStatement throw BreakStatement break ContinueStatement continue DebuggerStatement debugger LabeledStatement ExpressionStatement SingleExpression SingleClassItem",maxTerm:364,context:trackNewline,nodeProps:[["group",-26,6,14,16,62,199,203,206,207,209,212,215,225,227,233,235,237,239,242,248,254,256,258,260,262,264,265,"Statement",-32,10,11,25,28,29,35,45,48,49,51,56,64,72,76,78,80,81,103,104,113,114,131,134,136,137,138,139,141,142,162,163,165,"Expression",-23,24,26,30,34,36,38,166,168,170,171,173,174,175,177,178,179,181,182,183,193,195,197,198,"Type",-3,84,96,102,"ClassItem"],["openedBy",31,"InterpolationStart",50,"[",54,"{",69,"(",143,"JSXStartTag",155,"JSXStartTag JSXStartCloseTag"],["closedBy",33,"InterpolationEnd",44,"]",55,"}",70,")",144,"JSXSelfCloseEndTag JSXEndTag",160,"JSXEndTag"]],propSources:[jsHighlight],skippedNodes:[0,3,4,268],repeatNodeCount:33,tokenData:"$>y(CSR!bOX%ZXY+gYZ-yZ[+g[]%Z]^.c^p%Zpq+gqr/mrs3cst:_tu>PuvBavwDxwxGgxyMvyz! Qz{!![{|!%O|}!&]}!O!%O!O!P!'g!P!Q!1w!Q!R#0t!R![#3T![!]#@T!]!^#Aa!^!_#Bk!_!`#GS!`!a#In!a!b#N{!b!c$$z!c!}>P!}#O$&U#O#P$'`#P#Q$,w#Q#R$.R#R#S>P#S#T$/`#T#o$0j#o#p$4z#p#q$5p#q#r$7Q#r#s$8^#s$f%Z$f$g+g$g#BY>P#BY#BZ$9h#BZ$IS>P$IS$I_$9h$I_$I|>P$I|$I}$<s$I}$JO$<s$JO$JT>P$JT$JU$9h$JU$KV>P$KV$KW$9h$KW&FU>P&FU&FV$9h&FV;'S>P;'S;=`BZ<%l?HT>P?HT?HU$9h?HUO>P(n%d_$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z&j&hT$d&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c&j&zP;=`<%l&c'|'U]$d&j'z!bOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}!b(SU'z!bOY'}Zw'}x#O'}#P;'S'};'S;=`(f<%lO'}!b(iP;=`<%l'}'|(oP;=`<%l&}'[(y]$d&j'wpOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(rp)wU'wpOY)rZr)rs#O)r#P;'S)r;'S;=`*Z<%lO)rp*^P;=`<%l)r'[*dP;=`<%l(r#S*nX'wp'z!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g#S+^P;=`<%l*g(n+dP;=`<%l%Z(CS+rq$d&j'wp'z!b'm(;dOX%ZXY+gYZ&cZ[+g[p%Zpq+gqr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p$f%Z$f$g+g$g#BY%Z#BY#BZ+g#BZ$IS%Z$IS$I_+g$I_$JT%Z$JT$JU+g$JU$KV%Z$KV$KW+g$KW&FU%Z&FU&FV+g&FV;'S%Z;'S;=`+a<%l?HT%Z?HT?HU+g?HUO%Z(CS.ST'x#S$d&j'n(;dO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c(CS.n_$d&j'wp'z!b'n(;dOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#`/x`$d&j!l$Ip'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`0z!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S1V`#q$Id$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`2X!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S2d_#q$Id$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$2b3l_'v$(n$d&j'z!bOY4kYZ5qZr4krs7nsw4kwx5qx!^4k!^!_8p!_#O4k#O#P5q#P#o4k#o#p8p#p;'S4k;'S;=`:X<%lO4k*r4r_$d&j'z!bOY4kYZ5qZr4krs7nsw4kwx5qx!^4k!^!_8p!_#O4k#O#P5q#P#o4k#o#p8p#p;'S4k;'S;=`:X<%lO4k)`5vX$d&jOr5qrs6cs!^5q!^!_6y!_#o5q#o#p6y#p;'S5q;'S;=`7h<%lO5q)`6jT$_#t$d&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c#t6|TOr6yrs7]s;'S6y;'S;=`7b<%lO6y#t7bO$_#t#t7eP;=`<%l6y)`7kP;=`<%l5q*r7w]$_#t$d&j'z!bOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}%W8uZ'z!bOY8pYZ6yZr8prs9hsw8pwx6yx#O8p#O#P6y#P;'S8p;'S;=`:R<%lO8p%W9oU$_#t'z!bOY'}Zw'}x#O'}#P;'S'};'S;=`(f<%lO'}%W:UP;=`<%l8p*r:[P;=`<%l4k#%|:hg$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}st%Ztu<Puw%Zwx(rx!^%Z!^!_*g!_!c%Z!c!}<P!}#O%Z#O#P&c#P#R%Z#R#S<P#S#T%Z#T#o<P#o#p*g#p$g%Z$g;'S<P;'S;=`=y<%lO<P#%|<[i$d&j(a!L^'wp'z!bOY%ZYZ&cZr%Zrs&}st%Ztu<Puw%Zwx(rx!Q%Z!Q![<P![!^%Z!^!_*g!_!c%Z!c!}<P!}#O%Z#O#P&c#P#R%Z#R#S<P#S#T%Z#T#o<P#o#p*g#p$g%Z$g;'S<P;'S;=`=y<%lO<P#%|=|P;=`<%l<P(CS>`k$d&j'wp'z!b(U!LY't&;d$W#tOY%ZYZ&cZr%Zrs&}st%Ztu>Puw%Zwx(rx}%Z}!O@T!O!Q%Z!Q![>P![!^%Z!^!_*g!_!c%Z!c!}>P!}#O%Z#O#P&c#P#R%Z#R#S>P#S#T%Z#T#o>P#o#p*g#p$g%Z$g;'S>P;'S;=`BZ<%lO>P+d@`k$d&j'wp'z!b$W#tOY%ZYZ&cZr%Zrs&}st%Ztu@Tuw%Zwx(rx}%Z}!O@T!O!Q%Z!Q![@T![!^%Z!^!_*g!_!c%Z!c!}@T!}#O%Z#O#P&c#P#R%Z#R#S@T#S#T%Z#T#o@T#o#p*g#p$g%Z$g;'S@T;'S;=`BT<%lO@T+dBWP;=`<%l@T(CSB^P;=`<%l>P%#SBl`$d&j'wp'z!b#i$IdOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#SCy_$d&j#{$Id'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%DfETa(j%<v$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sv%ZvwFYwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#SFe`$d&j#u$Id'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$2bGp_'y$)`$d&j'wpOYHoYZIuZrHorsIuswHowxKVx!^Ho!^!_LX!_#OHo#O#PIu#P#oHo#o#pLX#p;'SHo;'S;=`Mp<%lOHo*QHv_$d&j'wpOYHoYZIuZrHorsIuswHowxKVx!^Ho!^!_LX!_#OHo#O#PIu#P#oHo#o#pLX#p;'SHo;'S;=`Mp<%lOHo)`IzX$d&jOwIuwx6cx!^Iu!^!_Jg!_#oIu#o#pJg#p;'SIu;'S;=`KP<%lOIu#tJjTOwJgwx7]x;'SJg;'S;=`Jy<%lOJg#tJ|P;=`<%lJg)`KSP;=`<%lIu*QK`]$_#t$d&j'wpOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(r$fL^Z'wpOYLXYZJgZrLXrsJgswLXwxMPx#OLX#O#PJg#P;'SLX;'S;=`Mj<%lOLX$fMWU$_#t'wpOY)rZr)rs#O)r#P;'S)r;'S;=`*Z<%lO)r$fMmP;=`<%lLX*QMsP;=`<%lHo(*QNR_!h(!b$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z!'l! ]_!gM|$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'+h!!ib$d&j'wp'z!b'u#)d#j$IdOY%ZYZ&cZr%Zrs&}sw%Zwx(rxz%Zz{!#q{!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S!#|`$d&j'wp'z!b#g$IdOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z&-O!%Z`$d&j'wp'z!bk&%`OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z&C[!&h_!V&;l$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(CS!'rc$d&j'wp'z!by'<nOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!(}!P!Q%Z!Q![!+g![!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z!'d!)Wa$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!*]!P!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z!'d!*h_!UMt$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l!+rg$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!+g![!^%Z!^!_*g!_!g%Z!g!h!-Z!h#O%Z#O#P&c#P#R%Z#R#S!+g#S#X%Z#X#Y!-Z#Y#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l!-dg$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx{%Z{|!.{|}%Z}!O!.{!O!Q%Z!Q![!0a![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!0a#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l!/Uc$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!0a![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!0a#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l!0lc$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!0a![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!0a#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(CS!2Sf$d&j'wp'z!b#h$IdOY!3hYZ&cZr!3hrs!4{sw!3hwx!C}xz!3hz{#$s{!P!3h!P!Q#&Y!Q!^!3h!^!_!Mh!_!`#-x!`!a#/_!a!}!3h!}#O##[#O#P!<w#P#o!3h#o#p!Mh#p;'S!3h;'S;=`#$m<%lO!3h(r!3sb$d&j'wp'z!b!RSOY!3hYZ&cZr!3hrs!4{sw!3hwx!C}x!P!3h!P!Q!Kh!Q!^!3h!^!_!Mh!_!}!3h!}#O##[#O#P!<w#P#o!3h#o#p!Mh#p;'S!3h;'S;=`#$m<%lO!3h(Q!5U`$d&j'z!b!RSOY!4{YZ&cZw!4{wx!6Wx!P!4{!P!Q!=o!Q!^!4{!^!_!?g!_!}!4{!}#O!Bn#O#P!<w#P#o!4{#o#p!?g#p;'S!4{;'S;=`!Cw<%lO!4{&n!6_^$d&j!RSOY!6WYZ&cZ!P!6W!P!Q!7Z!Q!^!6W!^!_!8g!_!}!6W!}#O!;U#O#P!<w#P#o!6W#o#p!8g#p;'S!6W;'S;=`!=i<%lO!6W&n!7ba$d&j!RSO!^&c!_#Z&c#Z#[!7Z#[#]&c#]#^!7Z#^#a&c#a#b!7Z#b#g&c#g#h!7Z#h#i&c#i#j!7Z#j#m&c#m#n!7Z#n#o&c#p;'S&c;'S;=`&w<%lO&cS!8lX!RSOY!8gZ!P!8g!P!Q!9X!Q!}!8g!}#O!9p#O#P!:o#P;'S!8g;'S;=`!;O<%lO!8gS!9^U!RS#Z#[!9X#]#^!9X#a#b!9X#g#h!9X#i#j!9X#m#n!9XS!9sVOY!9pZ#O!9p#O#P!:Y#P#Q!8g#Q;'S!9p;'S;=`!:i<%lO!9pS!:]SOY!9pZ;'S!9p;'S;=`!:i<%lO!9pS!:lP;=`<%l!9pS!:rSOY!8gZ;'S!8g;'S;=`!;O<%lO!8gS!;RP;=`<%l!8g&n!;Z[$d&jOY!;UYZ&cZ!^!;U!^!_!9p!_#O!;U#O#P!<P#P#Q!6W#Q#o!;U#o#p!9p#p;'S!;U;'S;=`!<q<%lO!;U&n!<UX$d&jOY!;UYZ&cZ!^!;U!^!_!9p!_#o!;U#o#p!9p#p;'S!;U;'S;=`!<q<%lO!;U&n!<tP;=`<%l!;U&n!<|X$d&jOY!6WYZ&cZ!^!6W!^!_!8g!_#o!6W#o#p!8g#p;'S!6W;'S;=`!=i<%lO!6W&n!=lP;=`<%l!6W(Q!=xi$d&j'z!b!RSOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#Z&}#Z#[!=o#[#]&}#]#^!=o#^#a&}#a#b!=o#b#g&}#g#h!=o#h#i&}#i#j!=o#j#m&}#m#n!=o#n#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}!f!?nZ'z!b!RSOY!?gZw!?gwx!8gx!P!?g!P!Q!@a!Q!}!?g!}#O!Ap#O#P!:o#P;'S!?g;'S;=`!Bh<%lO!?g!f!@hb'z!b!RSOY'}Zw'}x#O'}#P#Z'}#Z#[!@a#[#]'}#]#^!@a#^#a'}#a#b!@a#b#g'}#g#h!@a#h#i'}#i#j!@a#j#m'}#m#n!@a#n;'S'};'S;=`(f<%lO'}!f!AuX'z!bOY!ApZw!Apwx!9px#O!Ap#O#P!:Y#P#Q!?g#Q;'S!Ap;'S;=`!Bb<%lO!Ap!f!BeP;=`<%l!Ap!f!BkP;=`<%l!?g(Q!Bu^$d&j'z!bOY!BnYZ&cZw!Bnwx!;Ux!^!Bn!^!_!Ap!_#O!Bn#O#P!<P#P#Q!4{#Q#o!Bn#o#p!Ap#p;'S!Bn;'S;=`!Cq<%lO!Bn(Q!CtP;=`<%l!Bn(Q!CzP;=`<%l!4{'`!DW`$d&j'wp!RSOY!C}YZ&cZr!C}rs!6Ws!P!C}!P!Q!EY!Q!^!C}!^!_!GQ!_!}!C}!}#O!JX#O#P!<w#P#o!C}#o#p!GQ#p;'S!C};'S;=`!Kb<%lO!C}'`!Eci$d&j'wp!RSOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#Z(r#Z#[!EY#[#](r#]#^!EY#^#a(r#a#b!EY#b#g(r#g#h!EY#h#i(r#i#j!EY#j#m(r#m#n!EY#n#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(rt!GXZ'wp!RSOY!GQZr!GQrs!8gs!P!GQ!P!Q!Gz!Q!}!GQ!}#O!IZ#O#P!:o#P;'S!GQ;'S;=`!JR<%lO!GQt!HRb'wp!RSOY)rZr)rs#O)r#P#Z)r#Z#[!Gz#[#])r#]#^!Gz#^#a)r#a#b!Gz#b#g)r#g#h!Gz#h#i)r#i#j!Gz#j#m)r#m#n!Gz#n;'S)r;'S;=`*Z<%lO)rt!I`X'wpOY!IZZr!IZrs!9ps#O!IZ#O#P!:Y#P#Q!GQ#Q;'S!IZ;'S;=`!I{<%lO!IZt!JOP;=`<%l!IZt!JUP;=`<%l!GQ'`!J`^$d&j'wpOY!JXYZ&cZr!JXrs!;Us!^!JX!^!_!IZ!_#O!JX#O#P!<P#P#Q!C}#Q#o!JX#o#p!IZ#p;'S!JX;'S;=`!K[<%lO!JX'`!K_P;=`<%l!JX'`!KeP;=`<%l!C}(r!Ksk$d&j'wp'z!b!RSOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#Z%Z#Z#[!Kh#[#]%Z#]#^!Kh#^#a%Z#a#b!Kh#b#g%Z#g#h!Kh#h#i%Z#i#j!Kh#j#m%Z#m#n!Kh#n#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#W!Mq]'wp'z!b!RSOY!MhZr!Mhrs!?gsw!Mhwx!GQx!P!Mh!P!Q!Nj!Q!}!Mh!}#O#!U#O#P!:o#P;'S!Mh;'S;=`##U<%lO!Mh#W!Nse'wp'z!b!RSOY*gZr*grs'}sw*gwx)rx#O*g#P#Z*g#Z#[!Nj#[#]*g#]#^!Nj#^#a*g#a#b!Nj#b#g*g#g#h!Nj#h#i*g#i#j!Nj#j#m*g#m#n!Nj#n;'S*g;'S;=`+Z<%lO*g#W#!]Z'wp'z!bOY#!UZr#!Urs!Apsw#!Uwx!IZx#O#!U#O#P!:Y#P#Q!Mh#Q;'S#!U;'S;=`##O<%lO#!U#W##RP;=`<%l#!U#W##XP;=`<%l!Mh(r##e`$d&j'wp'z!bOY##[YZ&cZr##[rs!Bnsw##[wx!JXx!^##[!^!_#!U!_#O##[#O#P!<P#P#Q!3h#Q#o##[#o#p#!U#p;'S##[;'S;=`#$g<%lO##[(r#$jP;=`<%l##[(r#$pP;=`<%l!3h(CS#%Qb$d&j'wp'z!b'o(;d!RSOY!3hYZ&cZr!3hrs!4{sw!3hwx!C}x!P!3h!P!Q!Kh!Q!^!3h!^!_!Mh!_!}!3h!}#O##[#O#P!<w#P#o!3h#o#p!Mh#p;'S!3h;'S;=`#$m<%lO!3h(CS#&e_$d&j'wp'z!bR(;dOY#&YYZ&cZr#&Yrs#'dsw#&Ywx#*tx!^#&Y!^!_#,s!_#O#&Y#O#P#(f#P#o#&Y#o#p#,s#p;'S#&Y;'S;=`#-r<%lO#&Y(Bb#'m]$d&j'z!bR(;dOY#'dYZ&cZw#'dwx#(fx!^#'d!^!_#)w!_#O#'d#O#P#(f#P#o#'d#o#p#)w#p;'S#'d;'S;=`#*n<%lO#'d(AO#(mX$d&jR(;dOY#(fYZ&cZ!^#(f!^!_#)Y!_#o#(f#o#p#)Y#p;'S#(f;'S;=`#)q<%lO#(f(;d#)_SR(;dOY#)YZ;'S#)Y;'S;=`#)k<%lO#)Y(;d#)nP;=`<%l#)Y(AO#)tP;=`<%l#(f(<v#*OW'z!bR(;dOY#)wZw#)wwx#)Yx#O#)w#O#P#)Y#P;'S#)w;'S;=`#*h<%lO#)w(<v#*kP;=`<%l#)w(Bb#*qP;=`<%l#'d(Ap#*}]$d&j'wpR(;dOY#*tYZ&cZr#*trs#(fs!^#*t!^!_#+v!_#O#*t#O#P#(f#P#o#*t#o#p#+v#p;'S#*t;'S;=`#,m<%lO#*t(<U#+}W'wpR(;dOY#+vZr#+vrs#)Ys#O#+v#O#P#)Y#P;'S#+v;'S;=`#,g<%lO#+v(<U#,jP;=`<%l#+v(Ap#,pP;=`<%l#*t(=h#,|Y'wp'z!bR(;dOY#,sZr#,srs#)wsw#,swx#+vx#O#,s#O#P#)Y#P;'S#,s;'S;=`#-l<%lO#,s(=h#-oP;=`<%l#,s(CS#-uP;=`<%l#&Y%#W#.Vb$d&j#{$Id'wp'z!b!RSOY!3hYZ&cZr!3hrs!4{sw!3hwx!C}x!P!3h!P!Q!Kh!Q!^!3h!^!_!Mh!_!}!3h!}#O##[#O#P!<w#P#o!3h#o#p!Mh#p;'S!3h;'S;=`#$m<%lO!3h+h#/lb$T#t$d&j'wp'z!b!RSOY!3hYZ&cZr!3hrs!4{sw!3hwx!C}x!P!3h!P!Q!Kh!Q!^!3h!^!_!Mh!_!}!3h!}#O##[#O#P!<w#P#o!3h#o#p!Mh#p;'S!3h;'S;=`#$m<%lO!3h$/l#1Pp$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!+g!P!Q%Z!Q![#3T![!^%Z!^!_*g!_!g%Z!g!h!-Z!h#O%Z#O#P&c#P#R%Z#R#S#3T#S#U%Z#U#V#6_#V#X%Z#X#Y!-Z#Y#b%Z#b#c#5T#c#d#9g#d#l%Z#l#m#<i#m#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#3`k$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!+g!P!Q%Z!Q![#3T![!^%Z!^!_*g!_!g%Z!g!h!-Z!h#O%Z#O#P&c#P#R%Z#R#S#3T#S#X%Z#X#Y!-Z#Y#b%Z#b#c#5T#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#5`_$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#6hd$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!R#7v!R!S#7v!S!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#7v#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#8Rf$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!R#7v!R!S#7v!S!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#7v#S#b%Z#b#c#5T#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#9pc$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!Y#:{!Y!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#:{#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#;We$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!Y#:{!Y!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#:{#S#b%Z#b#c#5T#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#<rg$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![#>Z![!^%Z!^!_*g!_!c%Z!c!i#>Z!i#O%Z#O#P&c#P#R%Z#R#S#>Z#S#T%Z#T#Z#>Z#Z#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z$/l#>fi$d&j'wp'z!bl$'|OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![#>Z![!^%Z!^!_*g!_!c%Z!c!i#>Z!i#O%Z#O#P&c#P#R%Z#R#S#>Z#S#T%Z#T#Z#>Z#Z#b%Z#b#c#5T#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%Gh#@b_!a$b$d&j#y%<f'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z)[#Al_^l$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(CS#Bz^'}!*v!e'.r'wp'z!b$U)d(nSOY*gZr*grs'}sw*gwx)rx!P*g!P!Q#Cv!Q!^*g!^!_#Dl!_!`#F^!`#O*g#P;'S*g;'S;=`+Z<%lO*g(n#DPX$f&j'wp'z!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g$Kh#DuZ#k$Id'wp'z!bOY*gZr*grs'}sw*gwx)rx!_*g!_!`#Eh!`#O*g#P;'S*g;'S;=`+Z<%lO*g$Kh#EqX#{$Id'wp'z!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g$Kh#FgX#l$Id'wp'z!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g%Gh#G_a#X%?x$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`0z!`!a#Hd!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#W#Ho_#d$Ih$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%Gh#I}adBf#l$Id$a#|$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`#KS!`!a#L^!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S#K__#l$Id$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S#Lia#k$Id$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`!a#Mn!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S#My`#k$Id$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'+h$ Wc(b$Ip$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P$!c!P!^%Z!^!_*g!_!a%Z!a!b$#m!b#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'+`$!n_z'#p$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S$#x`$d&j#v$Id'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#&^$%V_!x!Ln$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(@^$&a_|(8n$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(n$'eZ$d&jO!^$(W!^!_$(n!_#i$(W#i#j$(s#j#l$(W#l#m$*f#m#o$(W#o#p$(n#p;'S$(W;'S;=`$,q<%lO$(W(n$(_T[#S$d&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c#S$(sO[#S(n$(x[$d&jO!Q&c!Q![$)n![!^&c!_!c&c!c!i$)n!i#T&c#T#Z$)n#Z#o&c#o#p$,U#p;'S&c;'S;=`&w<%lO&c(n$)sZ$d&jO!Q&c!Q![$*f![!^&c!_!c&c!c!i$*f!i#T&c#T#Z$*f#Z#o&c#p;'S&c;'S;=`&w<%lO&c(n$*kZ$d&jO!Q&c!Q![$+^![!^&c!_!c&c!c!i$+^!i#T&c#T#Z$+^#Z#o&c#p;'S&c;'S;=`&w<%lO&c(n$+cZ$d&jO!Q&c!Q![$(W![!^&c!_!c&c!c!i$(W!i#T&c#T#Z$(W#Z#o&c#p;'S&c;'S;=`&w<%lO&c#S$,XR!Q![$,b!c!i$,b#T#Z$,b#S$,eS!Q![$,b!c!i$,b#T#Z$,b#q#r$(n(n$,tP;=`<%l$(W!'l$-S_!SM|$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#S$.^`#s$Id$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z&,v$/k_$d&j'wp'z!b(R&%WOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(CS$0yk$d&j'wp'z!b(U!LY't&;d$Y#tOY%ZYZ&cZr%Zrs&}st%Ztu$0juw%Zwx(rx}%Z}!O$2n!O!Q%Z!Q![$0j![!^%Z!^!_*g!_!c%Z!c!}$0j!}#O%Z#O#P&c#P#R%Z#R#S$0j#S#T%Z#T#o$0j#o#p*g#p$g%Z$g;'S$0j;'S;=`$4t<%lO$0j+d$2yk$d&j'wp'z!b$Y#tOY%ZYZ&cZr%Zrs&}st%Ztu$2nuw%Zwx(rx}%Z}!O$2n!O!Q%Z!Q![$2n![!^%Z!^!_*g!_!c%Z!c!}$2n!}#O%Z#O#P&c#P#R%Z#R#S$2n#S#T%Z#T#o$2n#o#p*g#p$g%Z$g;'S$2n;'S;=`$4n<%lO$2n+d$4qP;=`<%l$2n(CS$4wP;=`<%l$0j!5p$5TX!X!3l'wp'z!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g%Df$5{a(i%<v$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Cn!`#O%Z#O#P&c#P#o%Z#o#p*g#p#q$#m#q;'S%Z;'S;=`+a<%lO%Z%#`$7__!W$I`o`$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(r$8i_!mS$d&j'wp'z!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(CS$9y|$d&j'wp'z!b'm(;d(U!LY't&;d$W#tOX%ZXY+gYZ&cZ[+g[p%Zpq+gqr%Zrs&}st%Ztu>Puw%Zwx(rx}%Z}!O@T!O!Q%Z!Q![>P![!^%Z!^!_*g!_!c%Z!c!}>P!}#O%Z#O#P&c#P#R%Z#R#S>P#S#T%Z#T#o>P#o#p*g#p$f%Z$f$g+g$g#BY>P#BY#BZ$9h#BZ$IS>P$IS$I_$9h$I_$JT>P$JT$JU$9h$JU$KV>P$KV$KW$9h$KW&FU>P&FU&FV$9h&FV;'S>P;'S;=`BZ<%l?HT>P?HT?HU$9h?HUO>P(CS$=Uk$d&j'wp'z!b'n(;d(U!LY't&;d$W#tOY%ZYZ&cZr%Zrs&}st%Ztu>Puw%Zwx(rx}%Z}!O@T!O!Q%Z!Q![>P![!^%Z!^!_*g!_!c%Z!c!}>P!}#O%Z#O#P&c#P#R%Z#R#S>P#S#T%Z#T#o>P#o#p*g#p$g%Z$g;'S>P;'S;=`BZ<%lO>P",tokenizers:[noSemicolon,incdecToken,2,3,4,5,6,7,8,9,10,11,12,13,insertSemicolon,new LocalTokenGroup("$S~RRtu[#O#Pg#S#T#|~_P#o#pb~gOq~~jVO#i!P#i#j!U#j#l!P#l#m!q#m;'S!P;'S;=`#v<%lO!P~!UO!O~~!XS!Q![!e!c!i!e#T#Z!e#o#p#Z~!hR!Q![!q!c!i!q#T#Z!q~!tR!Q![!}!c!i!}#T#Z!}~#QR!Q![!P!c!i!P#T#Z!P~#^R!Q![#g!c!i#g#T#Z#g~#jS!Q![#g!c!i#g#T#Z#g#q#r!P~#yP;=`<%l!P~$RO(T~~",141,326),new LocalTokenGroup("j~RQYZXz{^~^O'q~~aP!P!Qd~iO'r~~",25,308)],topRules:{Script:[0,5],SingleExpression:[1,266],SingleClassItem:[2,267]},dialects:{jsx:12686,ts:12688},dynamicPrecedences:{76:1,78:1,163:1,191:1},specialized:[{term:312,get:O=>spec_identifier[O]||-1},{term:328,get:O=>spec_word[O]||-1},{term:67,get:O=>spec_LessThan[O]||-1}],tokenPrec:12712});

    const snippets=[snippetCompletion("function ${name}(${params}) {\n\t${}\n}",{label:"function",detail:"definition",type:"keyword"}),snippetCompletion("for (let ${index} = 0; ${index} < ${bound}; ${index}++) {\n\t${}\n}",{label:"for",detail:"loop",type:"keyword"}),snippetCompletion("for (let ${name} of ${collection}) {\n\t${}\n}",{label:"for",detail:"of loop",type:"keyword"}),snippetCompletion("do {\n\t${}\n} while (${})",{label:"do",detail:"loop",type:"keyword"}),snippetCompletion("while (${}) {\n\t${}\n}",{label:"while",detail:"loop",type:"keyword"}),snippetCompletion("try {\n\t${}\n} catch (${error}) {\n\t${}\n}",{label:"try",detail:"/ catch block",type:"keyword"}),snippetCompletion("if (${}) {\n\t${}\n}",{label:"if",detail:"block",type:"keyword"}),snippetCompletion("if (${}) {\n\t${}\n} else {\n\t${}\n}",{label:"if",detail:"/ else block",type:"keyword"}),snippetCompletion("class ${name} {\n\tconstructor(${params}) {\n\t\t${}\n\t}\n}",{label:"class",detail:"definition",type:"keyword"}),snippetCompletion('import {${names}} from "${module}"\n${}',{label:"import",detail:"named",type:"keyword"}),snippetCompletion('import ${name} from "${module}"\n${}',{label:"import",detail:"default",type:"keyword"})],cache=new NodeWeakMap,ScopeNodes=new Set(["Script","Block","FunctionExpression","FunctionDeclaration","ArrowFunction","MethodDeclaration","ForStatement"]);function defID(e){return (t,n)=>{let o=t.node.getChild("VariableDefinition");return o&&n(o,e),!0}}const functionContext=["FunctionDeclaration"],gatherCompletions={FunctionDeclaration:defID("function"),ClassDeclaration:defID("class"),ClassExpression:()=>!0,EnumDeclaration:defID("constant"),TypeAliasDeclaration:defID("type"),NamespaceDeclaration:defID("namespace"),VariableDefinition(e,t){e.matchContext(functionContext)||t(e,"variable");},TypeDefinition(e,t){t(e,"type");},__proto__:null};function getScope(e,t){let n=cache.get(t);if(n)return n;let o=[],a=!0;function r(t,n){let a=e.sliceString(t.from,t.to);o.push({label:a,type:n});}return t.cursor(IterMode.IncludeAnonymous).iterate((t=>{if(a)a=!1;else if(t.name){let e=gatherCompletions[t.name];if(e&&e(t,r)||ScopeNodes.has(t.name))return !1}else if(t.to-t.from>8192){for(let n of getScope(e,t.node))o.push(n);return !1}})),cache.set(t,o),o}const Identifier$1=/^[\w$\xa1-\uffff][\w$\d\xa1-\uffff]*$/,dontComplete=["TemplateString","String","RegExp","LineComment","BlockComment","VariableDefinition","TypeDefinition","Label","PropertyDefinition","PropertyName","PrivatePropertyDefinition","PrivatePropertyName",".","?."];function localCompletionSource(e){let t=syntaxTree(e.state).resolveInner(e.pos,-1);if(dontComplete.indexOf(t.name)>-1)return null;let n="VariableName"==t.name||t.to-t.from<20&&Identifier$1.test(e.state.sliceDoc(t.from,t.to));if(!n&&!e.explicit)return null;let o=[];for(let n=t;n;n=n.parent)ScopeNodes.has(n.name)&&(o=o.concat(getScope(e.state.doc,n)));return {options:o,from:n?t.from:e.pos,validFor:Identifier$1}}const javascriptLanguage=LRLanguage.define({name:"javascript",parser:parser$1.configure({props:[indentNodeProp.add({IfStatement:continuedIndent({except:/^\s*({|else\b)/}),TryStatement:continuedIndent({except:/^\s*({|catch\b|finally\b)/}),LabeledStatement:flatIndent,SwitchBody:e=>{let t=e.textAfter,n=/^\s*\}/.test(t),o=/^\s*(case|default)\b/.test(t);return e.baseIndent+(n?0:o?1:2)*e.unit},Block:delimitedIndent({closing:"}"}),ArrowFunction:e=>e.baseIndent+e.unit,"TemplateString BlockComment":()=>null,"Statement Property":continuedIndent({except:/^{/}),JSXElement(e){let t=/^\s*<\//.test(e.textAfter);return e.lineIndent(e.node.from)+(t?0:e.unit)},JSXEscape(e){let t=/\s*\}/.test(e.textAfter);return e.lineIndent(e.node.from)+(t?0:e.unit)},"JSXOpenTag JSXSelfClosingTag":e=>e.column(e.node.from)+e.unit}),foldNodeProp.add({"Block ClassBody SwitchBody EnumBody ObjectExpression ArrayExpression ObjectType":foldInside,BlockComment:e=>({from:e.from+2,to:e.to-2})})]}),languageData:{closeBrackets:{brackets:["(","[","{","'",'"',"`"]},commentTokens:{line:"//",block:{open:"/*",close:"*/"}},indentOnInput:/^\s*(?:case |default:|\{|\}|<\/)$/,wordChars:"$"}}),jsxSublanguage={test:e=>/^JSX/.test(e.name),facet:defineLanguageFacet({commentTokens:{block:{open:"{/*",close:"*/}"}}})},typescriptLanguage=javascriptLanguage.configure({dialect:"ts"},"typescript"),jsxLanguage=javascriptLanguage.configure({dialect:"jsx",props:[sublanguageProp.add((e=>e.isTop?[jsxSublanguage]:void 0))]}),tsxLanguage=javascriptLanguage.configure({dialect:"jsx ts",props:[sublanguageProp.add((e=>e.isTop?[jsxSublanguage]:void 0))]},"typescript"),keywords="break case const continue default delete export extends false finally in instanceof let new return static super switch this throw true typeof var yield".split(" ").map((e=>({label:e,type:"keyword"})));function javascript(e={}){let t=e.jsx?e.typescript?tsxLanguage:jsxLanguage:e.typescript?typescriptLanguage:javascriptLanguage;return new LanguageSupport(t,[javascriptLanguage.data.of({autocomplete:ifNotIn(dontComplete,completeFromList(snippets.concat(keywords)))}),javascriptLanguage.data.of({autocomplete:localCompletionSource}),e.jsx?autoCloseTags$1:[]])}function findOpenTag(e){for(;;){if("JSXOpenTag"==e.name||"JSXSelfClosingTag"==e.name||"JSXFragmentTag"==e.name)return e;if("JSXEscape"==e.name||!e.parent)return null;e=e.parent;}}function elementName$1(e,t,n=e.length){for(let o=null==t?void 0:t.firstChild;o;o=o.nextSibling)if("JSXIdentifier"==o.name||"JSXBuiltin"==o.name||"JSXNamespacedName"==o.name||"JSXMemberExpression"==o.name)return e.sliceString(o.from,Math.min(o.to,n));return ""}function isEndTag(e){return e&&("JSXEndTag"==e.name||"JSXSelfCloseEndTag"==e.name)}const android="object"==typeof navigator&&/Android\b/.test(navigator.userAgent),autoCloseTags$1=EditorView.inputHandler.of(((e,t,n,o)=>{if((android?e.composing:e.compositionStarted)||e.state.readOnly||t!=n||">"!=o&&"/"!=o||!javascriptLanguage.isActiveAt(e.state,t,-1))return !1;let{state:a}=e,r=a.changeByRange((e=>{var t;let n,{head:r}=e,i=syntaxTree(a).resolveInner(r,-1);if("JSXStartTag"==i.name&&(i=i.parent),"JSXAttributeValue"==i.name&&i.to>r);else {if(">"==o&&"JSXFragmentTag"==i.name)return {range:EditorSelection.cursor(r+1),changes:{from:r,insert:"></>"}};if("/"==o&&"JSXFragmentTag"==i.name){let e=i.parent,o=null==e?void 0:e.parent;if(e.from==r-1&&"JSXEndTag"!=(null===(t=o.lastChild)||void 0===t?void 0:t.name)&&(n=elementName$1(a.doc,null==o?void 0:o.firstChild,r))){let e=`/${n}>`;return {range:EditorSelection.cursor(r+e.length),changes:{from:r,insert:e}}}}else if(">"==o){let e=findOpenTag(i);if(e&&!isEndTag(e.lastChild)&&"</"!=a.sliceDoc(r,r+2)&&(n=elementName$1(a.doc,e,r)))return {range:EditorSelection.cursor(r+1),changes:{from:r,insert:`></${n}>`}}}}return {range:e}}));return !r.changes.empty&&(e.dispatch(r,{userEvent:"input.type",scrollIntoView:!0}),!0)}));

    const Targets=["_blank","_self","_top","_parent"],Charsets=["ascii","utf-8","utf-16","latin1","latin1"],Methods=["get","post","put","delete"],Encs=["application/x-www-form-urlencoded","multipart/form-data","text/plain"],Bool=["true","false"],S={},Tags={a:{attrs:{href:null,ping:null,type:null,media:null,target:Targets,hreflang:null}},abbr:S,address:S,area:{attrs:{alt:null,coords:null,href:null,target:null,ping:null,media:null,hreflang:null,type:null,shape:["default","rect","circle","poly"]}},article:S,aside:S,audio:{attrs:{src:null,mediagroup:null,crossorigin:["anonymous","use-credentials"],preload:["none","metadata","auto"],autoplay:["autoplay"],loop:["loop"],controls:["controls"]}},b:S,base:{attrs:{href:null,target:Targets}},bdi:S,bdo:S,blockquote:{attrs:{cite:null}},body:S,br:S,button:{attrs:{form:null,formaction:null,name:null,value:null,autofocus:["autofocus"],disabled:["autofocus"],formenctype:Encs,formmethod:Methods,formnovalidate:["novalidate"],formtarget:Targets,type:["submit","reset","button"]}},canvas:{attrs:{width:null,height:null}},caption:S,center:S,cite:S,code:S,col:{attrs:{span:null}},colgroup:{attrs:{span:null}},command:{attrs:{type:["command","checkbox","radio"],label:null,icon:null,radiogroup:null,command:null,title:null,disabled:["disabled"],checked:["checked"]}},data:{attrs:{value:null}},datagrid:{attrs:{disabled:["disabled"],multiple:["multiple"]}},datalist:{attrs:{data:null}},dd:S,del:{attrs:{cite:null,datetime:null}},details:{attrs:{open:["open"]}},dfn:S,div:S,dl:S,dt:S,em:S,embed:{attrs:{src:null,type:null,width:null,height:null}},eventsource:{attrs:{src:null}},fieldset:{attrs:{disabled:["disabled"],form:null,name:null}},figcaption:S,figure:S,footer:S,form:{attrs:{action:null,name:null,"accept-charset":Charsets,autocomplete:["on","off"],enctype:Encs,method:Methods,novalidate:["novalidate"],target:Targets}},h1:S,h2:S,h3:S,h4:S,h5:S,h6:S,head:{children:["title","base","link","style","meta","script","noscript","command"]},header:S,hgroup:S,hr:S,html:{attrs:{manifest:null}},i:S,iframe:{attrs:{src:null,srcdoc:null,name:null,width:null,height:null,sandbox:["allow-top-navigation","allow-same-origin","allow-forms","allow-scripts"],seamless:["seamless"]}},img:{attrs:{alt:null,src:null,ismap:null,usemap:null,width:null,height:null,crossorigin:["anonymous","use-credentials"]}},input:{attrs:{alt:null,dirname:null,form:null,formaction:null,height:null,list:null,max:null,maxlength:null,min:null,name:null,pattern:null,placeholder:null,size:null,src:null,step:null,value:null,width:null,accept:["audio/*","video/*","image/*"],autocomplete:["on","off"],autofocus:["autofocus"],checked:["checked"],disabled:["disabled"],formenctype:Encs,formmethod:Methods,formnovalidate:["novalidate"],formtarget:Targets,multiple:["multiple"],readonly:["readonly"],required:["required"],type:["hidden","text","search","tel","url","email","password","datetime","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"]}},ins:{attrs:{cite:null,datetime:null}},kbd:S,keygen:{attrs:{challenge:null,form:null,name:null,autofocus:["autofocus"],disabled:["disabled"],keytype:["RSA"]}},label:{attrs:{for:null,form:null}},legend:S,li:{attrs:{value:null}},link:{attrs:{href:null,type:null,hreflang:null,media:null,sizes:["all","16x16","16x16 32x32","16x16 32x32 64x64"]}},map:{attrs:{name:null}},mark:S,menu:{attrs:{label:null,type:["list","context","toolbar"]}},meta:{attrs:{content:null,charset:Charsets,name:["viewport","application-name","author","description","generator","keywords"],"http-equiv":["content-language","content-type","default-style","refresh"]}},meter:{attrs:{value:null,min:null,low:null,high:null,max:null,optimum:null}},nav:S,noscript:S,object:{attrs:{data:null,type:null,name:null,usemap:null,form:null,width:null,height:null,typemustmatch:["typemustmatch"]}},ol:{attrs:{reversed:["reversed"],start:null,type:["1","a","A","i","I"]},children:["li","script","template","ul","ol"]},optgroup:{attrs:{disabled:["disabled"],label:null}},option:{attrs:{disabled:["disabled"],label:null,selected:["selected"],value:null}},output:{attrs:{for:null,form:null,name:null}},p:S,param:{attrs:{name:null,value:null}},pre:S,progress:{attrs:{value:null,max:null}},q:{attrs:{cite:null}},rp:S,rt:S,ruby:S,samp:S,script:{attrs:{type:["text/javascript"],src:null,async:["async"],defer:["defer"],charset:Charsets}},section:S,select:{attrs:{form:null,name:null,size:null,autofocus:["autofocus"],disabled:["disabled"],multiple:["multiple"]}},slot:{attrs:{name:null}},small:S,source:{attrs:{src:null,type:null,media:null}},span:S,strong:S,style:{attrs:{type:["text/css"],media:null,scoped:null}},sub:S,summary:S,sup:S,table:S,tbody:S,td:{attrs:{colspan:null,rowspan:null,headers:null}},template:S,textarea:{attrs:{dirname:null,form:null,maxlength:null,name:null,placeholder:null,rows:null,cols:null,autofocus:["autofocus"],disabled:["disabled"],readonly:["readonly"],required:["required"],wrap:["soft","hard"]}},tfoot:S,th:{attrs:{colspan:null,rowspan:null,headers:null,scope:["row","col","rowgroup","colgroup"]}},thead:S,time:{attrs:{datetime:null}},title:S,tr:S,track:{attrs:{src:null,label:null,default:null,kind:["subtitles","captions","descriptions","chapters","metadata"],srclang:null}},ul:{children:["li","script","template","ul","ol"]},var:S,video:{attrs:{src:null,poster:null,width:null,height:null,crossorigin:["anonymous","use-credentials"],preload:["auto","metadata","none"],autoplay:["autoplay"],mediagroup:["movie"],muted:["muted"],controls:["controls"]}},wbr:S},GlobalAttrs={accesskey:null,class:null,contenteditable:Bool,contextmenu:null,dir:["ltr","rtl","auto"],draggable:["true","false","auto"],dropzone:["copy","move","link","string:","file:"],hidden:["hidden"],id:null,inert:["inert"],itemid:null,itemprop:null,itemref:null,itemscope:["itemscope"],itemtype:null,lang:["ar","bn","de","en-GB","en-US","es","fr","hi","id","ja","pa","pt","ru","tr","zh"],spellcheck:Bool,autocorrect:Bool,autocapitalize:Bool,style:null,tabindex:null,title:null,translate:["yes","no"],rel:["stylesheet","alternate","author","bookmark","help","license","next","nofollow","noreferrer","prefetch","prev","search","tag"],role:"alert application article banner button cell checkbox complementary contentinfo dialog document feed figure form grid gridcell heading img list listbox listitem main navigation region row rowgroup search switch tab table tabpanel textbox timer".split(" "),"aria-activedescendant":null,"aria-atomic":Bool,"aria-autocomplete":["inline","list","both","none"],"aria-busy":Bool,"aria-checked":["true","false","mixed","undefined"],"aria-controls":null,"aria-describedby":null,"aria-disabled":Bool,"aria-dropeffect":null,"aria-expanded":["true","false","undefined"],"aria-flowto":null,"aria-grabbed":["true","false","undefined"],"aria-haspopup":Bool,"aria-hidden":Bool,"aria-invalid":["true","false","grammar","spelling"],"aria-label":null,"aria-labelledby":null,"aria-level":null,"aria-live":["off","polite","assertive"],"aria-multiline":Bool,"aria-multiselectable":Bool,"aria-owns":null,"aria-posinset":null,"aria-pressed":["true","false","mixed","undefined"],"aria-readonly":Bool,"aria-relevant":null,"aria-required":Bool,"aria-selected":["true","false","undefined"],"aria-setsize":null,"aria-sort":["ascending","descending","none","other"],"aria-valuemax":null,"aria-valuemin":null,"aria-valuenow":null,"aria-valuetext":null},eventAttributes="beforeunload copy cut dragstart dragover dragleave dragenter dragend drag paste focus blur change click load mousedown mouseenter mouseleave mouseup keydown keyup resize scroll unload".split(" ").map((e=>"on"+e));for(let e of eventAttributes)GlobalAttrs[e]=null;class Schema{constructor(e,t){this.tags=Object.assign(Object.assign({},Tags),e),this.globalAttrs=Object.assign(Object.assign({},GlobalAttrs),t),this.allTags=Object.keys(this.tags),this.globalAttrNames=Object.keys(this.globalAttrs);}}function elementName(e,t,l=e.length){if(!t)return "";let a=t.firstChild,n=a&&a.getChild("TagName");return n?e.sliceString(n.from,Math.min(n.to,l)):""}function findParentElement(e,t=!1){for(;e;e=e.parent)if("Element"==e.name){if(!t)return e;t=!1;}return null}function allowedChildren(e,t,l){let a=l.tags[elementName(e,findParentElement(t))];return (null==a?void 0:a.children)||l.allTags}function openTags(e,t){let l=[];for(let a=findParentElement(t);a&&!a.type.isTop;a=findParentElement(a.parent)){let n=elementName(e,a);if(n&&"CloseTag"==a.lastChild.name)break;n&&l.indexOf(n)<0&&("EndTag"==t.name||t.from>=a.firstChild.to)&&l.push(n);}return l}Schema.default=new Schema;const identifier=/^[:\-\.\w\u00b7-\uffff]*$/;function completeTag(e,t,l,a,n){let r=/\s*>/.test(e.sliceDoc(n,n+5))?"":">",o=findParentElement(l,!0);return {from:a,to:n,options:allowedChildren(e.doc,o,t).map((e=>({label:e,type:"type"}))).concat(openTags(e.doc,l).map(((e,t)=>({label:"/"+e,apply:"/"+e+r,type:"type",boost:99-t})))),validFor:/^\/?[:\-\.\w\u00b7-\uffff]*$/}}function completeCloseTag(e,t,l,a){let n=/\s*>/.test(e.sliceDoc(a,a+5))?"":">";return {from:l,to:a,options:openTags(e.doc,t).map(((e,t)=>({label:e,apply:e+n,type:"type",boost:99-t}))),validFor:identifier}}function completeStartTag(e,t,l,a){let n=[],r=0;for(let a of allowedChildren(e.doc,l,t))n.push({label:"<"+a,type:"type"});for(let t of openTags(e.doc,l))n.push({label:"</"+t+">",type:"type",boost:99-r++});return {from:a,to:a,options:n,validFor:/^<\/?[:\-\.\w\u00b7-\uffff]*$/}}function completeAttrName(e,t,l,a,n){let r=findParentElement(l),o=r?t.tags[elementName(e.doc,r)]:null,s=o&&o.attrs?Object.keys(o.attrs):[];return {from:a,to:n,options:(o&&!1===o.globalAttrs?s:s.length?s.concat(t.globalAttrNames):t.globalAttrNames).map((e=>({label:e,type:"property"}))),validFor:identifier}}function completeAttrValue(e,t,l,a,n){var r;let o,s=null===(r=l.parent)||void 0===r?void 0:r.getChild("AttributeName"),i=[];if(s){let r=e.sliceDoc(s.from,s.to),u=t.globalAttrs[r];if(!u){let a=findParentElement(l),n=a?t.tags[elementName(e.doc,a)]:null;u=(null==n?void 0:n.attrs)&&n.attrs[r];}if(u){let t=e.sliceDoc(a,n).toLowerCase(),l='"',r='"';/^['"]/.test(t)?(o='"'==t[0]?/^[^"]*$/:/^[^']*$/,l="",r=e.sliceDoc(n,n+1)==t[0]?"":t[0],t=t.slice(1),a++):o=/^[^\s<>='"]*$/;for(let e of u)i.push({label:e,apply:l+e+r,type:"constant"});}}return {from:a,to:n,options:i,validFor:o}}function htmlCompletionFor(e,t){let{state:l,pos:a}=t,n=syntaxTree(l).resolveInner(a,-1),r=n.resolve(a);for(let e,t=a;r==n&&(e=n.childBefore(t));){let l=e.lastChild;if(!l||!l.type.isError||l.from<l.to)break;r=n=e,t=l.from;}return "TagName"==n.name?n.parent&&/CloseTag$/.test(n.parent.name)?completeCloseTag(l,n,n.from,a):completeTag(l,e,n,n.from,a):"StartTag"==n.name?completeTag(l,e,n,a,a):"StartCloseTag"==n.name||"IncompleteCloseTag"==n.name?completeCloseTag(l,n,a,a):t.explicit&&("OpenTag"==n.name||"SelfClosingTag"==n.name)||"AttributeName"==n.name?completeAttrName(l,e,n,"AttributeName"==n.name?n.from:a,a):"Is"==n.name||"AttributeValue"==n.name||"UnquotedAttributeValue"==n.name?completeAttrValue(l,e,n,"Is"==n.name?a:n.from,a):!t.explicit||"Element"!=r.name&&"Text"!=r.name&&"Document"!=r.name?null:completeStartTag(l,e,n,a)}function htmlCompletionSourceWith(e){let{extraTags:t,extraGlobalAttributes:l}=e,a=l||t?new Schema(t,l):Schema.default;return e=>htmlCompletionFor(a,e)}const defaultNesting=[{tag:"script",attrs:e=>"text/typescript"==e.type||"ts"==e.lang,parser:typescriptLanguage.parser},{tag:"script",attrs:e=>"text/babel"==e.type||"text/jsx"==e.type,parser:jsxLanguage.parser},{tag:"script",attrs:e=>"text/typescript-jsx"==e.type,parser:tsxLanguage.parser},{tag:"script",attrs:e=>!e.type||/^(?:text|application)\/(?:x-)?(?:java|ecma)script$|^module$|^$/i.test(e.type),parser:javascriptLanguage.parser},{tag:"style",attrs:e=>(!e.lang||"css"==e.lang)&&(!e.type||/^(text\/)?(x-)?(stylesheet|css)$/i.test(e.type)),parser:cssLanguage.parser}],defaultAttrs=[{name:"style",parser:cssLanguage.parser.configure({top:"Styles"})}].concat(eventAttributes.map((e=>({name:e,parser:javascriptLanguage.parser})))),htmlPlain=LRLanguage.define({name:"html",parser:parser$3.configure({props:[indentNodeProp.add({Element(e){let t=/^(\s*)(<\/)?/.exec(e.textAfter);return e.node.to<=e.pos+t[0].length?e.continue():e.lineIndent(e.node.from)+(t[2]?0:e.unit)},"OpenTag CloseTag SelfClosingTag":e=>e.column(e.node.from)+e.unit,Document(e){if(e.pos+/\s*/.exec(e.textAfter)[0].length<e.node.to)return e.continue();let t,l=null;for(let t=e.node;;){let e=t.lastChild;if(!e||"Element"!=e.name||e.to!=t.to)break;l=t=e;}return l&&(!(t=l.lastChild)||"CloseTag"!=t.name&&"SelfClosingTag"!=t.name)?e.lineIndent(l.from)+e.unit:null}}),foldNodeProp.add({Element(e){let t=e.firstChild,l=e.lastChild;return t&&"OpenTag"==t.name?{from:t.to,to:"CloseTag"==l.name?l.from:e.to}:null}}),bracketMatchingHandle.add({"OpenTag CloseTag":e=>e.getChild("TagName")})]}),languageData:{commentTokens:{block:{open:"\x3c!--",close:"--\x3e"}},indentOnInput:/^\s*<\/\w+\W$/,wordChars:"-._"}}),htmlLanguage=htmlPlain.configure({wrap:configureNesting(defaultNesting,defaultAttrs)});function html(e={}){let t,l="";!1===e.matchClosingTags&&(l="noMatch"),!0===e.selfClosingTags&&(l=(l?l+" ":"")+"selfClosing"),(e.nestedLanguages&&e.nestedLanguages.length||e.nestedAttributes&&e.nestedAttributes.length)&&(t=configureNesting((e.nestedLanguages||[]).concat(defaultNesting),(e.nestedAttributes||[]).concat(defaultAttrs)));let a=t?htmlPlain.configure({wrap:t,dialect:l}):l?htmlLanguage.configure({dialect:l}):htmlLanguage;return new LanguageSupport(a,[htmlLanguage.data.of({autocomplete:htmlCompletionSourceWith(e)}),!1!==e.autoCloseTags?autoCloseTags:[],javascript().support,css().support])}const selfClosers=new Set("area base br col command embed frame hr img input keygen link meta param source track wbr menuitem".split(" ")),autoCloseTags=EditorView.inputHandler.of(((e,t,l,a)=>{if(e.composing||e.state.readOnly||t!=l||">"!=a&&"/"!=a||!htmlLanguage.isActiveAt(e.state,t,-1))return !1;let{state:n}=e,r=n.changeByRange((t=>{var l,r,o;let s,{head:i}=t,u=syntaxTree(n).resolveInner(i,-1);if("TagName"!=u.name&&"StartTag"!=u.name||(u=u.parent),">"==a&&"OpenTag"==u.name){if("CloseTag"!=(null===(r=null===(l=u.parent)||void 0===l?void 0:l.lastChild)||void 0===r?void 0:r.name)&&(s=elementName(n.doc,u.parent,i))&&!selfClosers.has(s)){let t=">"===e.state.doc.sliceString(i,i+1),l=`${t?"":">"}</${s}>`;return {range:EditorSelection.cursor(i+1),changes:{from:i+(t?1:0),insert:l}}}}else if("/"==a&&"OpenTag"==u.name){let t=u.parent,l=null==t?void 0:t.parent;if(t.from==i-1&&"CloseTag"!=(null===(o=l.lastChild)||void 0===o?void 0:o.name)&&(s=elementName(n.doc,l,i))&&!selfClosers.has(s)){let t=">"===e.state.doc.sliceString(i,i+1),l=`/${s}${t?"":">"}`,a=i+l.length+(t?1:0);return {range:EditorSelection.cursor(a),changes:{from:i,insert:l}}}}return {range:t}}));return !r.changes.empty&&(e.dispatch(r,{userEvent:"input.type",scrollIntoView:!0}),!0)}));

    const en_us={Add:()=>"Add",Remove:()=>"Remove",Explain:()=>"Explain",Fix:()=>"Fix","Unrecognized breed name _":e=>`Cannot recognize the breed name "${e}". Did you define it at the beginning?`,"Unrecognized identifier _":e=>`Nothing called "${e}" was defined or reserved by NetLogo. Did you forget to define it?`,"Unrecognized identifier with replacement _":(e,o)=>`Nothing called "${e}" was defined or reserved by NetLogo. Maybe try "${o}"?`,"Unrecognized global statement _":e=>`Cannot recognize "${e}" as a proper global statement here. Did you spell it correctly?`,"Unrecognized statement _":e=>`"${e}" is out of place. Did you put it in the correct place?`,"Unrecognized statement with replacement _":(e,o)=>`"${e}" is out of place. Maybe try "${o}"？`,"Invalid content for code block _":e=>`"${e}" is out of place in the surrounding code block.`,"Invalid content for list _":e=>`"${e}" is out of place in the surrounding list.`,"Unsupported statement _":e=>`"${e}" is not supported in this version of NetLogo.`,"Unsupported extension statement _":e=>`"${e}" is not supported in this version of NetLogo. The parsing could be wrong.`,"Invalid for Normal mode _":e=>"This editor mode expects a full NetLogo model.","Invalid for Embedded mode _":e=>"This editor mode expects a few command statements.","Invalid for Oneline mode _":e=>"This editor mode expects command statements or a single reporter statement.","Invalid for OnelineReporter mode _":e=>"This editor mode expects a single reporter statement.","Problem identifying primitive _. Expected _, found _.":(e,o,t)=>`"${e}" is not a valid primitive. Expected ${o} but found ${t}.`,"Left args for _. Expected _, found _.":(e,o,t)=>`"${e}" expects ${o} left argument(s). ${t} argument(s) found.`,"Too few right args for _. Expected _, found _.":(e,o,t)=>`"${e}" expects at least ${o} right argument(s). ${t} argument(s) found.`,"Too many right args for _. Expected _, found _.":(e,o,t)=>`"${e}" expects at most ${o} right argument(s). ${t} argument(s) found.`,"Missing extension _":e=>`Seems that you need to put "${e}" in the "extensions" section. Do you want to do that now?`,"Unsupported missing extension _":e=>`"${e}" is missing in the "extensions" section; this extension might not yet be supported by this version of NetLogo.`,"Unsupported extension _":e=>`The extension "${e}" is not supported in this editor.`,"Term _ already used":(e,o)=>`"${e}" is already defined in the code. Try a different ${en_us[o]().toLowerCase()} name.`,"Term _ reserved":(e,o)=>`"${e}" is a reserved keyword in NetLogo. Try a different ${en_us[o]().toLowerCase()} name.`,"Variable _ reserved":(e,o)=>`"${e}" is a built-in variable in NetLogo. There is no need to define this ${en_us[o]().toLowerCase()} in the code.`,"Invalid breed procedure _":e=>`It seems that you forgot to declare "${e}" as a breed. Do you want to do that now?`,"Missing command _":()=>"Every NetLogo statement has to start with a command.","Missing command before _":e=>`The statement "${e}" needs to start with a command. What do you want to do with it?`,"Improperly placed procedure _":e=>`The procedure "${e}" cannot be written prior to global statements. Do you want to move the procedure?`,"Unmatched item _":(e,o)=>`This "${e}" needs a matching ${o}.`,"Invalid context _":(e,o,t)=>`Based on preceding statements, the context of this codeblock is "${e}", but "${t}" has a "${o}" context.`,"Duplicate global statement _":e=>`The global "${e}" statement is already defined. Do you want to combine into one?`,"Infinite loop _":e=>`This "${e}" loop will run forever and likely block the model. Do you want to re-write into a "go" loop?`,"Argument is reserved _":e=>`The argument "${e}" is a reserved NetLogo keyword. Do you want to replace it?`,"Argument is invalid _":e=>`The argument "${e}" is invalid. Do you want to replace it?`,"Negation _":e=>`This expression looks like an incorrect negation. The correct format is "(- ${e.substring(1)})".`,"Deprecated usage of ?":e=>'This expression looks like an incorrect anonymous procedure. The correct format looks like "[[ arg ] -> print arg]".',"Incorrect usage of ,":e=>'In NetLogo, spaces " " are used to separate meanings. There is no need to use ",".',"Invalid report _":e=>'"Report" can only be used in a procedure beginning with "to-report".',"Invalid report warning _":e=>'"report" can only be used in a procedure beginning with "to-report". Would you like to change to "to-report"?',"Invalid to-report _":e=>'Any procedure beginning with "to-report" must include the "report" command. Would you like to change to "to"?',"Missing breed names _":e=>'A breed statement must contain a plural and a singular name inside of the brackets, e.g. "breed [ sheep a-sheep ]".',"Invalid breed type _":e=>"This breed type cannot be used in this type of command",Observer:()=>"Observer",Turtle:()=>"Turtle",Turtles:()=>"Turtles",Patch:()=>"Patch",Patches:()=>"Patches",Link:()=>"Link",Links:()=>"Links",Utility:()=>"Utility",Command:()=>"Command",Reporter:()=>"Reporter",Argument:()=>"Argument",Arguments:e=>"Argument"+(e>1?"s":""),Breed:()=>"Breed",Procedure:()=>"Procedure","Global variable":()=>"Global variable","Turtle variable":()=>"Turtle variable","Patch variable":()=>"Patch variable","Link variable":()=>"Link variable","Local variable":()=>"Local variable","~VariableName":e=>"A (unknown) variable. ","~ProcedureName":e=>"The name of a procedure. ","~Arguments":e=>"The name of an argument. ","~PatchVar":e=>"A built-in variable for every patch. ","~TurtleVar":e=>"A built-in variable for every turtle. ","~LinkVar":e=>"A built-in variable for every link. ","~Reporter":e=>"A NetLogo reporter. ","~Command":e=>"A NetLogo command. ","~Constant":e=>"A NetLogo constant. ","~Extension":e=>"A NetLogo extension. ","~Numeric":e=>"A number. ","~String":e=>"A string, which is a sequence of characters.","~LineComment":e=>"Comments do nothing in the program, but could help others read the code. ","~Globals/Identifier":e=>"A code-defined global variable. ","~WidgetGlobal":e=>"A widget-defined global variable. ","~BreedVars/Identifier":e=>"A model-defined variable for a breed. ","~BreedPlural":e=>"The plural name of a model-defined breed. ","~BreedSingular":e=>"The singular name of a model-defined breed. ","~BreedVariable":e=>`A custom variable for the "${e}" breed. `,"~LocalVariable":e=>`A local variable within the "${e.includes("{anonymous}")?"{anonymous}":e}" procedure or reporter. `,"~BreedReporter":e=>`A reporter for the "${e}" breed. `,"~CustomReporter":e=>"A user-defined reporter. ","~BreedCommand":e=>`A command for the "${e}" breed. `,"~CustomCommand":e=>"A user-defined command. ",ClickHere:()=>"Click here",Reconnect:()=>"Try it again",RunCode:()=>"Run","Trying to run the code":()=>"Trying to run the code...","Trying to run the procedure _":e=>`Trying to run the procedure \`${e}\`...`,FixCode:()=>"Fix",AskCode:()=>"Ask",AddCode:()=>"Add to Code",CopyCode:()=>"Copy Code","Trying to add the code":()=>"Trying to add the code to the project...",PreviousVersion:()=>"Back",NextVersion:()=>"Next",PreviousPage:()=>"Previous page",NextPage:()=>"Next page","Original version":()=>"Showing the original content.","Translated version":()=>"Showing the AI translated content.","Switch to original":()=>"switch to original.","Switch to translated":()=>"switch to AI translated.",Need:()=>"Need",Finish:()=>"Finish","Expand options _":e=>`Expand ${e} option`+(e>1?"s":""),"Expand messages _":e=>`Expand ${e} message`+(e>1?"s":""),"Code placeholder _":e=>`Click to work on ${e} ${e>1?"lines":"line"} of code`,FullText:()=>"Read more",Acknowledgement:()=>"Acknowledgement",SeeAlso:()=>"See Also",OK:()=>"OK",Cancel:()=>"Cancel","Run command":()=>"Run command","Run reporter":()=>"Run reporter","Execute the procedure":()=>"Execute the procedure now",MoreFeatures:()=>"More features",SelectAll:()=>"Select all",Undo:()=>"Undo",Redo:()=>"Redo",JumpToLine:()=>"Jump to line",JumpToProcedure:()=>"Jump to procedure","There is no procedure":()=>"There is no procedure in the code.",Prettify:()=>"Prettify",ResetCode:()=>"Reset code","Do you want to reset the code":()=>"Do you want to reset the code to the last successful compilation?","Type NetLogo command here":()=>"Type NetLogo command here","Talk to the computer in NetLogo or natural languages":()=>"Talk to the computer in NetLogo or natural languages","Press enter to execute again":()=>"Press Enter will execute the code again.","Copied to clipboard":()=>"The item has been copied to clipboard.","Feature not supported":()=>"The feature is not supported yet. Stay tuned!","Connection to server failed _":e=>`Sorry, the connection to our server failed. Code ${e}.`,"Summary of request":()=>"Below is a summary of my request: ","We need to fix the following errors _":e=>`Sorry, but we need to fix the ${e} errors in the code (marked with ___red squiggly lines___) before continuing.`,"Successfully executed":()=>"Successfully executed the code.","Successfully compiled":()=>"Successfully compiled the code. We can run them now!","Runtime error _":e=>`Sorry, the code failed to run: ${e}`,"Runtime error in snippet _":e=>`Sorry, there are ${e} errors during this run.`,"Compile error _":e=>`Sorry, I cannot understand the code: ${e}`,"Compile error in snippet _":e=>`Sorry, there are still ${e} errors in the code snippet.`,"Compile error unknown":e=>"Sorry, there is an unknown error. Please report it as a bug.","Compile error in model":()=>"Sorry, there are errors in the open project. Please fix the issue in the code tab first.","Showing full text help of _":e=>`Here is the help information of [${e}](<observer=help ${e} -full>).`,"Arguments needed for execution _":(e,o)=>`The "${e}" procedure needs ${o>1?"":"an "}argument${o>1?"s":""} to run. Please provide ${o>1?"them":"it"}.`,"Please download Turtle Universe":()=>"The feature is unavailable in Web Preview. Please download [Turtle Universe](https://www.turtlesim.com/products/turtle-universe/) to continue.","Failed to retrieve knowledge":()=>"Sorry, we did not find the specific knowledge.","Execute again":()=>"Execute the code **again**","Help me fix this code":()=>"Help me fix this code","Explain the error":()=>"Explain the error","Command center welcome (user)":()=>"What is here about? Where should I start with?","Command center welcome (command)":()=>"Here is the command center. You can type in NetLogo code and run it here, but there is always more to explore. Here are something you can try out.","Command center welcome (assistant)":()=>"Hello! This is an AI assistant. I can help you learn NetLogo or build your own project, but there is always more to explore. Here are something you can try out.","Run NetLogo code directly":()=>"Run **NetLogo** code directly","Check out the code tab":()=>"Check out the **code** tab of the project","Talk to the computer in natural languages":()=>"Talk to the computer in **natural languages**","Look for the documentation":()=>"Look for the **learning materials** of NetLogo","Ask questions about NetLogo":()=>"Ask **questions** about NetLogo"};

    const zh_cn={Add:()=>"添加",Remove:()=>"Remove",Explain:()=>"Explain",Fix:()=>"Fix","Unrecognized breed name _":e=>`未能识别出名为 "${e}" 的海龟种类。种类需要在代码的开头处进行定义。`,"Unrecognized identifier _":e=>`"${e}" 既没有被定义，也不是 NetLogo 的关键字。`,"Unrecognized identifier with replacement _":(e,o)=>`"${e}" 既没有被定义，也不是 NetLogo 的关键字。也许你想用的是 "${o}"？`,"Unrecognized global statement _":e=>`未能识别出名为 "${e}" 的全局声明。请检查你的拼写是否正确。`,"Unrecognized statement _":e=>`"${e}" 不是合理的 NetLogo 代码。`,"Unrecognized statement with replacement _":(e,o)=>`"${e}" 不是合理的 NetLogo 代码。试试 "${o}"。`,"Invalid content for code block _":e=>`"${e}" 不应存在于代码块之中。`,"Invalid content for list _":e=>`"${e}" 不应存在于列表之中`,"Unsupported statement _":e=>`此版本 NetLogo 不支持 "${e}"。`,"Unsupported extension statement _":e=>`此版本 NetLogo 不支持 "${e}"。提示和错误信息可能不正确。`,"Invalid for Normal mode _":e=>"此编辑器模式只用于编辑 NetLogo 模型。","Invalid for Embedded mode _":e=>"此编辑器模式只用于编辑 NetLogo 模型中的一小段代码。","Invalid for Oneline mode _":e=>"此编辑器模式只用于编辑单行命令或单行函数。","Invalid for OnelineReporter mode _":e=>"此编辑器模式只用于编辑单行函数。","Problem identifying primitive _. Expected _, found _.":(e,o,t)=>`"${e}" 不是有效的原语。预计 "${o}" 却得到 "${t}"。`,"Left args for _. Expected _, found _.":(e,o,t)=>`原语 "${e}" 需要 ${o} 个左侧参数，但代码中只有 ${t} 个。`,"Too few right args for _. Expected _, found _.":(e,o,t)=>`原语 "${e}" 需要至少 ${o} 个右侧参数，但代码中只有 ${t} 个。`,"Too many right args for _. Expected _, found _.":(e,o,t)=>`"原语 "${e}" 需要至多 ${o} 个右侧参数，但代码中只有 ${t} 个。`,"Invalid extension _.":e=>`看起来你需要在 "extensions" 中加入 "${e}"。想现在试试吗？`,"Term _ already used":(e,o)=>`"${zh_cn[o]()} ${e}" 已经被定义过了。试试换个名字吧。`,"Term _ reserved":(e,o)=>`"${zh_cn[o]()} ${e}" 是一个 NetLogo 关键字。试试换个名字吧。`,"Invalid breed procedure _":e=>`你还没有定义名为 "${e}" 的种类。想现在试试吗？`,"Missing command before _":e=>`语句 "${e}" 之前需要一个命令。你打算用它做些什么？`,"Improperly placed procedure _":e=>`过程或函数 "${e}" 必须放在模型声明的后面。想移动它吗？`,"Unmatched item _":(e,o)=>`"${e}" 需要对应的 ${o}。`,"Unsupported extension _":e=>`这个编辑器不支持扩展 "${e}"。`,"Missing command _":()=>"这里需要增加一个命令。","Missing extension _":e=>`你需要将扩展 "${e}" 放进 "extensions" 中。想现在试试吗？`,"Unsupported missing extension _":e=>`你需要将扩展 "${e}" 放进 "extensions" 中，但是这个编辑器不支持它。`,"Invalid context _":(e,o,t)=>`根据之前的语句，这段代码中只能使用 "${e}" 语句，但 "${t}" 却只能用于 "${o}"。`,"Duplicate global statement _":e=>`全局声明 "${e}" 已经被定义过了。你想合并吗？`,"Infinite loop _":e=>`这个 "${e}" 循环将永远运行下去，可能会阻塞模型。你想将它改成 "go" 循环吗？`,"Argument is reserved _":e=>`参数名称 "${e}" 和 NetLogo 的关键字重复了。你想换一个名字吗？`,"Argument is invalid _":e=>`参数名称 "${e}" 不可用。你想换一个名字吗？`,"Inconsistent code block type _":(e,o)=>`中括号内的 "${o}" 和此前观察到的 "${e}" 不匹配。`,"Negation _":e=>`取负值的方式不受支持。正确的格式是："(- ${e.substring(1)})"。`,"Deprecated usage of ?":e=>'匿名函数的写法不受支持。正确的格式类似于 "[[ 参数 ] -> print 参数]".',"Incorrect usage of ,":e=>'NetLogo 语言中使用空格分隔词义，无须使用 ","。',"Invalid report _":e=>"'report' 只能在函数（to-report）中使用。","Invalid report warning _":e=>"'report' 只能在函数（to-report）中使用。你想将过程（to）改为函数（to-report）吗？","Invalid to-report _":e=>"函数（to-report）必须返回（report）一个值。你想将函数改为过程（to）吗?","Missing breed names _":e=>'种类（breed）语句中必须包括一个复数和一个单数名称，例如 "breed [ sheep a-sheep ]"。',Observer:()=>"观察者",Turtle:()=>"海龟",Turtles:()=>"海龟们",Patch:()=>"格子",Patches:()=>"格子们",Link:()=>"链接",Links:()=>"链接们",Utility:()=>"工具",Command:()=>"命令",Reporter:()=>"函数",Argument:()=>"参数",Arguments:()=>"参数",Breed:()=>"种类",Procedure:()=>"过程","Global variable":()=>"全局变量","Turtle variable":()=>"海龟变量","Patch variable":()=>"格子变量","Link variable":()=>"链接变量","Local variable":()=>"本地变量","~VariableName":e=>"一个（未知的）变量。","~ProcedureName":e=>"过程或函数的名称。","~Arguments":e=>"过程或函数定义的参数名称。","~PatchVar":e=>"格子的内置变量。","~TurtleVar":e=>"海龟的内置变量。","~LinkVar":e=>"链接的内置变量。","~Reporter":e=>"NetLogo 语言的内置函数。","~Command":e=>"NetLogo 语言的内置命令。","~Constant":e=>"NetLogo 语言规定的常量。","~Extension":e=>"NetLogo 语言的扩展。","~Numeric":e=>"一个数字。","~String":e=>"字符串，或者说一串文字。","~LineComment":e=>"注释在代码中没有直接作用，但可以帮助其他人理解代码。","~Globals/Identifier":e=>"模型代码中定义的全局变量。","~BreedVars/Identifier":e=>"某类模型中定义的海龟或链接具有的变量。","~BreedPlural":e=>"某类模型中定义的海龟的复数名称。","~BreedSingular":e=>"某类模型中定义的海龟的单数名称。","~WidgetGlobal":e=>"通过界面组件定义的全局变量。 ","~BreedVariable":e=>`种类 "${e}" 定义的变量。`,"~LocalVariable":e=>`"${e.includes("{anonymous}")?"{匿名}":e}" 过程或函数定义的本地变量。 `,"~BreedReporter":e=>`关于 "${e}" 种类的函数。`,"~CustomReporter":e=>"代码中定义的一个函数。","~BreedCommand":e=>`关于 "${e}" 种类的过程。 `,"~CustomCommand":e=>"代码中定义的一个过程。",ClickHere:()=>"点击这里",MoreFeatures:()=>"更多功能",SelectAll:()=>"全选",Undo:()=>"撤销",Redo:()=>"重做",JumpToLine:()=>"跳转到行",JumpToProcedure:()=>"跳转到子程序","There is no procedure":()=>"代码中还没有任何子程序。",Prettify:()=>"整理代码",ResetCode:()=>"重置代码","Do you want to reset the code":()=>"是否将代码重置到最后一次成功编译的状态？","Type NetLogo command here":()=>"在这里输入 NetLogo 命令","Talk to the computer in NetLogo or natural languages":()=>"用 NetLogo 或自然语言写代码",Reconnect:()=>"再试一次",RunCode:()=>"运行","Trying to run the code":()=>"尝试运行代码……","Trying to run the procedure _":e=>`尝试运行子程序 \`${e}\`……`,FixCode:()=>"修复",AskCode:()=>"提问",AddCode:()=>"放入作品",CopyCode:()=>"复制代码","Trying to add the code":()=>"尝试将代码放入作品……",PreviousVersion:()=>"后退",NextVersion:()=>"前进",PreviousPage:()=>"返回上一页",NextPage:()=>"进入下一页","Original version":()=>"正在显示原文。","Translated version":()=>"正在显示 AI 翻译的内容。","Switch to original":()=>"显示原文。","Switch to translated":()=>"显示 AI 翻译的内容。",Need:()=>"需求",Finish:()=>"完成","Expand options _":e=>`展开 ${e} 个选项`,"Expand messages _":e=>`展开 ${e} 条消息`,"Code placeholder _":e=>`点击编辑 ${e} 行代码`,FullText:()=>"阅读全文",Acknowledgement:()=>"致谢",SeeAlso:()=>"参见",OK:()=>"确定",Cancel:()=>"取消","Run command":()=>"执行命令","Run reporter":()=>"执行函数","Execute the procedure":()=>"开始执行这段程序","Press enter to execute again":()=>"按回车键可以再次执行。","Copied to clipboard":()=>"内容已复制到剪贴板。","Feature not supported":()=>"此功能尚未推出，敬请期待！","Connection to server failed _":e=>`抱歉，和服务器的连接中断了。代码 ${e}。`,"Summary of request":()=>"简单总结我的请求的要点：","We need to fix the following errors _":e=>`我们需要先修复代码中的 ${e} 个错误（用___红色波浪线___标记）。`,"Successfully executed":()=>"成功执行了代码。","Successfully compiled":()=>"成功编译了代码。现在可以开始执行了！","Runtime error _":e=>`运行时错误：${e}`,"Compile error _":e=>`抱歉，未能理解你输入的命令：${e}`,"Runtime error in snippet _":e=>`抱歉，代码运行时出现了 ${e} 个错误。`,"Compile error in snippet _":e=>`抱歉，代码中还有 ${e} 个错误。`,"Compile error unknown":e=>"抱歉，编译过程中存在未知错误。请将 BUG 报告给开发者。","Compile error in model":()=>"编译模型时遇到错误。请先修复代码面板中的错误，然后尝试执行。","Showing full text help of _":e=>`显示 [${e}](<observer=help ${e} -full>) 的帮助文档。`,"Arguments needed for execution _":(e,o)=>`在执行 \`${e}\` 之前，需要知道它的参数。`,"Please download Turtle Universe":()=>"功能在网页模式下不可用。请下载[海龟实验室](https://www.turtlesim.com/products/turtle-universe/index-cn.html)以获得更好的体验。","Failed to retrieve knowledge":()=>"抱歉，未能找到相应知识。","Execute again":()=>"**再次执行**这段代码","Help me fix this code":()=>"试试 AI 自动修复代码","Explain the error":()=>"让 AI 解释错误信息","Command center welcome (user)":()=>"这是哪儿？我应该怎么开始使用？","Command center welcome (command)":()=>"你好！这里是控制台。你可以在这里输入 NetLogo 命令并立即执行。还有许多值得探索的功能，例如：","Command center welcome (assistant)":()=>"你好！这里是 AI 助手。我可以帮助你学习 NetLogo 或创作你的作品。还有许多值得探索的功能，例如：","Run NetLogo code directly":()=>"直接运行 **NetLogo** 代码","Check out the code tab":()=>"查看作品的**代码**","Talk to the computer in natural languages":()=>"用**自然语言**写代码","Look for the documentation":()=>"查看 NetLogo 语言的**帮助文档**","Ask questions about NetLogo":()=>"询问关于 NetLogo 的**问题**"};

    class LocalizationManager{constructor(){this.Current=en_us;}Get(r,...e){var t=this.Current;if(t.hasOwnProperty(r)||(t=en_us),!t.hasOwnProperty(r))return r;try{return t[r].apply(this,e)}catch(e){return `Error in producing message: ${r}`}}Switch(r){switch(r.toLowerCase()){case"zh_cn":case"chinese":this.Current=zh_cn;break;default:this.Current=en_us;}}}

    class DictionaryManager{constructor(){this.Data={};}Initialize(i){this.Data=i,this.RegisterBuiltin("~VariableName"),this.RegisterBuiltin("~ProcedureName"),this.RegisterBuiltin("~Arguments"),this.RegisterBuiltin("~PatchVar"),this.RegisterBuiltin("~TurtleVar"),this.RegisterBuiltin("~LinkVar"),this.RegisterBuiltin("~Reporter"),this.RegisterBuiltin("~Command"),this.RegisterBuiltin("~Constant"),this.RegisterBuiltin("~Extension"),this.RegisterBuiltin("~Numeric"),this.RegisterBuiltin("~String"),this.RegisterBuiltin("~LineComment"),this.RegisterBuiltin("~Globals/Identifier"),this.RegisterBuiltin("~BreedVars/Identifier"),this.RegisterBuiltin("~BreedPlural"),this.RegisterBuiltin("~BreedSingular"),this.RegisterBuiltin("~BreedVariable"),this.RegisterBuiltin("~BreedReporter"),this.RegisterBuiltin("~BreedCommand"),this.RegisterBuiltin("~WidgetGlobal"),this.RegisterBuiltin("~CustomCommand"),this.RegisterBuiltin("~CustomReporter"),this.RegisterBuiltin("~LocalVariable");}RegisterBuiltin(...i){i.map((t=>this.Data[t.toLowerCase()]=Localized.Get(i[0],"{0}")));}Get(i,t){return Dictionary.Check(i)?Dictionary.Data[i.trim().toLowerCase()].replace("{0}",t):i}Check(i){return this.Data&&this.Data.hasOwnProperty(i.trim().toLowerCase())}}const Dictionary=new DictionaryManager;try{window.EditorDictionary=Dictionary;}catch(i){}

    var EditorLanguage;!function(e){e[e.NetLogo=0]="NetLogo",e[e.Javascript=1]="Javascript",e[e.HTML=2]="HTML",e[e.CSS=3]="CSS";}(EditorLanguage||(EditorLanguage={}));var ParseMode;!function(e){e.Normal="Normal",e.Oneline="Oneline",e.OnelineReporter="OnelineReporter",e.Embedded="Embedded",e.Generative="Generative";}(ParseMode||(ParseMode={}));try{window.EditorLanguage=EditorLanguage;}catch(e){}

    const highlightStyle=HighlightStyle.define([{tag:tags$1.strong,color:"#007F69","font-weight":"bold"},{tag:tags$1.variableName,color:"#0000AA"},{tag:tags$1.operator,color:"#660096"},{tag:tags$1.literal,color:"#963700"},{tag:tags$1.lineComment,color:"#5A5A5A"},{tag:tags$1.bool,color:"#660096"},{tag:tags$1.paren,color:"#333333"}]),highlight=syntaxHighlighting(highlightStyle);

    const updateExtension=function(e){return EditorView.updateListener.of(e)};

    var NetLogoType;!function(t){t[t.Unit=0]="Unit",t[t.Wildcard=1]="Wildcard",t[t.String=2]="String",t[t.Number=3]="Number",t[t.List=4]="List",t[t.Boolean=5]="Boolean",t[t.Agent=6]="Agent",t[t.AgentSet=7]="AgentSet",t[t.Nobody=8]="Nobody",t[t.Turtle=9]="Turtle",t[t.Patch=10]="Patch",t[t.Link=11]="Link",t[t.CommandBlock=12]="CommandBlock",t[t.CodeBlock=13]="CodeBlock",t[t.NumberBlock=14]="NumberBlock",t[t.Reporter=15]="Reporter",t[t.Symbol=16]="Symbol",t[t.LinkSet=17]="LinkSet",t[t.ReporterBlock=18]="ReporterBlock",t[t.BooleanBlock=19]="BooleanBlock",t[t.Command=20]="Command",t[t.Other=21]="Other";}(NetLogoType||(NetLogoType={}));class AgentContexts{constructor(t){this.Observer=!0,this.Turtle=!0,this.Patch=!0,this.Link=!0,t&&("?"!=t?("O"!=t[0]&&(this.Observer=!1),"T"!=t[1]&&(this.Turtle=!1),"P"!=t[2]&&(this.Patch=!1),"L"!=t[3]&&(this.Link=!1)):this.Observer=!1);}}class Breed{constructor(t,e,o,i){this.Singular=t,this.Plural=e,this.Variables=o,this.BreedType=i;}}var BreedType;!function(t){t[t.Turtle=0]="Turtle",t[t.Patch=1]="Patch",t[t.UndirectedLink=2]="UndirectedLink",t[t.DirectedLink=3]="DirectedLink";}(BreedType||(BreedType={}));class Procedure{constructor(){this.Name="",this.Arguments=[],this.Variables=[],this.AnonymousProcedures=[],this.PositionStart=0,this.PositionEnd=0,this.IsCommand=!1,this.IsAnonymous=!1,this.Context=new AgentContexts,this.CodeBlocks=[];}}class CodeBlock{constructor(){this.PositionStart=0,this.PositionEnd=0,this.Context=new AgentContexts,this.CodeBlocks=[],this.Variables=[],this.Arguments=[],this.AnonymousProcedures=[],this.Primitive="",this.Breed=null,this.InheritParentContext=!1;}}class LocalVariable{constructor(t,e,o){this.Name=t,this.Type=e,this.CreationPos=o;}}class ContextError{constructor(t,e,o,i,s){this.From=t,this.To=e,this.PriorContext=o,this.ConflictingContext=i,this.Primitive=s;}}

    const combineContexts=function(t,e){let n=new AgentContexts;return t.Observer&&e.Observer||(n.Observer=!1),t.Turtle&&e.Turtle||(n.Turtle=!1),t.Patch&&e.Patch||(n.Patch=!1),t.Link&&e.Link||(n.Link=!1),n};const noContext=function(t){return !(t.Observer||t.Turtle||t.Patch||t.Link)};

    const Dataset=[{Extension:"",Name:"link-shapes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"standard-deviation",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"se",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:2,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"rgb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"replace-item",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[2,4],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-read-characters",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"but-last",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__block",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[13],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"modes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-pxcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"range",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,MinimumOption:1,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link-length",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-exit-message?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ln",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"max",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"bl",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"towardsxy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:2,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"exp",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__check-syntax",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"shade-of?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"with-max",LeftArgumentType:{Types:[7],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[14],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:12,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"is-turtle-set?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__apply-result",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"in-link-from",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hsb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"netlogo-version",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-normal",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"towards",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9,10],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"atan",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"mean",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__random-state",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-here",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"+",LeftArgumentType:{Types:[3],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:7,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"first",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"out-link-to",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-read-line",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"substring",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-name",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"remove-duplicates",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"precision",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"turtles",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-agentset?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"no-turtles",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,7,10],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-directed-link?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"at-points",LeftArgumentType:{Types:[7,7],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:12,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"asin",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"remainder",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"in-cone",LeftArgumentType:{Types:[7,7],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7,7],CanRepeat:!1,Optional:!1},Precedence:12,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"butfirst",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"/",LeftArgumentType:{Types:[3],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:8,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-agent?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"remove",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"and",LeftArgumentType:{Types:[5],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:4,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"min",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"self",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"in-link-neighbor?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-link-set?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"distance",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9,10],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-x-max",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sentence",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:2,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"log",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__reference",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"new-seed",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"mod",LeftArgumentType:{Types:[3],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:8,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link-neighbors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"min-one-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[14],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"^",LeftArgumentType:{Types:[3],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:9,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"with-min",LeftArgumentType:{Types:[7],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[14],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:12,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"distancexy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sort-by",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"item",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"*",LeftArgumentType:{Types:[3],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:8,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"filter",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__symbol",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-ycor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"variance",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"in-radius",LeftArgumentType:{Types:[7,7],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7,7],CanRepeat:!1,Optional:!1},Precedence:12,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-x-min",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"no-patches",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-right-and-ahead",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-exponential",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"<=",LeftArgumentType:{Types:[6,3,2],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,3,2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:6,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"turtles-here",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-number?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"error-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"not",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__dump",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-input",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-left-and-ahead",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"member?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2,4,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-patch?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"shuffle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"mouse-xcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"min-n-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[7],CanRepeat:!1,Optional:!1},{Types:[14],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"links",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[17],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__stack-trace",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__to-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"world-height",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"my-out-links",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[17],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"in-link-neighbors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"one-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-pycor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"min-pycor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"mouse-inside?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"empty?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"subject",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"n-values",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"neighbors4",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-anonymous-reporter?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"scale-color",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"turtles-on",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-at",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"mouse-down?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"other-end",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ifelse-value",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[18],CanRepeat:!1,Optional:!1},{Types:[5,18],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:3,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:3,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"round",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"position",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3,5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"turtles-at",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sort",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"insert-item",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[2,4],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"max-one-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[14],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"abs",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-at-end?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"word",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:2,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"mouse-ycor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"up-to-n-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4,7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ticks",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"min-pxcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-list?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"my-in-links",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[17],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link-with",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[11],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"subtract-headings",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__processors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"shapes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sin",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"butlast",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"count",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"runresult",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,15],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"timer",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patches",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__nano-time",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"extract-hsb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"run-result",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,15],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ceiling",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-poisson",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-pen-exists?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-y-min",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:">",LeftArgumentType:{Types:[6,3,2],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,3,2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:6,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"xor",LeftArgumentType:{Types:[5],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:4,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-undirected-link?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"bf",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"dy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"autoplot?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-clients-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"reduce",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5,2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"extract-rgb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-link?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-yes-or-no?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-string?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"reverse",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-y-max",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"max-n-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[7],CanRepeat:!1,Optional:!1},{Types:[14],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"hubnet-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"length",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"behaviorspace-run-number",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"behaviorspace-experiment-name",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"read-from-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3,5,2,4,8],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__dump-extensions",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"netlogo-applet?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"tan",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"other",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"neighbors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"approximate-hsb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"int",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-message-tag",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"remove-item",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"out-link-neighbors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"both-ends",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"dx",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"floor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-ahead",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"world-width",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link-neighbor?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"max-pycor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sum",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"my-links",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[17],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"approximate-rgb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-new-file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5,2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"<",LeftArgumentType:{Types:[6,3,2],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,3,2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:6,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"-",LeftArgumentType:{Types:[3],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:7,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-exists?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"wrap-color",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[11],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-anonymous-command?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-float",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"or",LeftArgumentType:{Types:[5],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:4,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"netlogo-web?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"cos",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sort-on",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[18],CanRepeat:!1,Optional:!1},{Types:[7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"lput",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"out-link-neighbor?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"median",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"acos",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"=",LeftArgumentType:{Types:[1],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:5,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"all?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[19],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"__dump-extension-prims",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-gamma",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-size",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-one-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"any?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"turtle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[9],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-message-source",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-boolean?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__checksum",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__dump1",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"n-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4,7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"date-and-time",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"can-move?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"but-first",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2,4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"base-colors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:">=",LeftArgumentType:{Types:[6,3,2],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,3,2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:6,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__boom",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link-heading",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-patch-set?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"is-turtle?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sqrt",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"link-set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,17,11],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[17],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-read",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3,5,2,4,8],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-directory",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5,2],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"sublist",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"max-pxcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"turtle-set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,7,9],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,MinimumOption:0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"map",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:2,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-message-waiting?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"!=",LeftArgumentType:{Types:[1],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:5,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"fput",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"no-links",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[17],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"last",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"myself",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[6],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"patch-at-heading-and-distance",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[10],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-xcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"with",LeftArgumentType:{Types:[7],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[19],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},Precedence:12,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"of",LeftArgumentType:{Types:[18],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,7],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},Precedence:11,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IsRightAssociative:!0,IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"hubnet-enter-message?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},Precedence:10,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"update-plots",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-globals",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"display",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ask",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6,7],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"plot",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-links-from",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"carefully",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[12],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-broadcast",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"forward",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-pen-reset",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__stdout",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__linkcode",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},InheritParentContext:!0},{Extension:"",Name:"set-plot-x-range",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-temporary-plot-pen",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-send",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-broadcast-clear-output",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"output-print",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-send-follow",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[6],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"rp",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"cro",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"file-write",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,5,2,4,8],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ht",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ct",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-plot-pen-color",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__patchcode",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!0,Link:!1},InheritParentContext:!0},{Extension:"",Name:"error",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"output-show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"reset-perspective",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__pwd",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"if",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"uphill",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-pen-down",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-current-plot-pen",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"downhill",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-plot-y-range",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"stop",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-current-directory",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__done",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},InheritParentContext:!0},{Extension:"",Name:"rt",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"import-pcolors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"import-pcolors-rgb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__turtlecode",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},InheritParentContext:!0},{Extension:"",Name:"create-link-to",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"diffuse4",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-default-shape",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7,17],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"bk",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-patches",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"tie",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-open",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"show-link",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__experimentstepend",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"reset-timer",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__apply",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[20],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"setxy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"jump",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-broadcast-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ride",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-close-all",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-send-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"downhill4",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__stderr",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-kick-client",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__bench",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pen-up",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"back",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"export-interface",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-plot-pen-interval",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-turtles",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"repeat",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__plot-pen-hide",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"wait",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"follow-me",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ride-me",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__plot-pen-show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__set-line-thickness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-type",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"lt",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__reload-extensions",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__foreverbuttonend",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},InheritParentContext:!0},{Extension:"",Name:"__ignore",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"import-world",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plotxy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"show-turtle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"auto-plot-off",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ca",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"print",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-ordered-turtles",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"left",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"st",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pu",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"let",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"random-seed",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"watch-me",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-clear-overrides",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-links",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-send-override",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[6,7],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[18],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"layout-tutte",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[17],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"tick-advance",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-send-watch",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-output",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-send-clear-output",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-all",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-reset",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"export-plot",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"resize-world",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-plot",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-fetch-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"diffuse",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"while",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[19],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"user-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"fd",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"loop",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__export-drawing",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"tick",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__let",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-reset-perspective",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"export-world",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"reset-ticks",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"no-display",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"beep",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"stop-inspecting",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"follow",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pen-erase",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"output-type",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-histogram-num-bars",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"type",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__mkdir",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-patch-size",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-print",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-link-with",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"hide-turtle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"inspect",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"every",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"output-write",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,5,2,4,8],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"cp",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"right",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-drawing",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"run",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:1,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"plot-pen-up",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"report",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-all-plots",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-close",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-links-with",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"auto-plot-on",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pendown",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-kick-all-clients",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"without-interruption",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"import-drawing",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"home",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__observercode",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},InheritParentContext:!0},{Extension:"",Name:"layout-radial",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[17],CanRepeat:!1,Optional:!1},{Types:[9],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"penup",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"write",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,5,2,4,8],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"face",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9,10],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ifelse",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[5,12],CanRepeat:!0,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:3,MinimumOption:2,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pd",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-delete",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-link-from",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"watch",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[6],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"layout-circle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,7],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"ask-concurrent",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"hide-link",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"create-links-to",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"setup-plots",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"facexy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"stop-inspecting-dead-agents",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-turtles",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__thunk-did-finish",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"histogram",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"stamp-erase",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"layout-spring",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[17],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"stamp",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-flush",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"crt",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"die",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"foreach",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!0,Optional:!1},{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:2,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"with-local-randomness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-current-plot",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pe",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"export-view",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"cd",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"move-to",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[9,10],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"if-else",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[5,12],CanRepeat:!0,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},DefaultOption:3,MinimumOption:2,CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"set-plot-pen-mode",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"uphill4",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[16],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"__change-topology",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"pen-down",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"clear-ticks",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},BlockContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"file-show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"untie",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},BlockContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"export-all-plots",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hubnet-clear-override",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[6,7],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"sprout",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!1,Patch:!0,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"",Name:"export-output",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},BlockContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},CanBeConcise:!0,InheritParentContext:!0},{Extension:"",Name:"hatch",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},Precedence:0,AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},BlockContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},IntroducesContext:!0,CanBeConcise:!0,InheritParentContext:!1},{Extension:"array",Name:"from-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"array",Name:"to-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"array",Name:"is-array?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"array",Name:"length",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"array",Name:"item",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"array",Name:"set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"average-color",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"channel",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"copy-to-drawing",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"copy-to-pcolors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"copy-to-shape",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:2},{Extension:"bitmap",Name:"difference-rgb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"export",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"from-base64",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"to-base64",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"from-view",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"to-grayscale",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"height",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"import",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"scaled",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"width",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"set-pixel",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"bitmap",Name:"get-pixel",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"codap",Name:"init",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"codap",Name:"call",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"csv",Name:"from-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"csv",Name:"from-row",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"csv",Name:"from-file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"csv",Name:"to-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"csv",Name:"to-row",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"csv",Name:"to-file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:2},{Extension:"dialog",Name:"user-input",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"dialog",Name:"user-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"dialog",Name:"user-one-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"dialog",Name:"user-yes-or-no?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"encode",Name:"base64-to-bytes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"encode",Name:"bytes-to-base64",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"encode",Name:"bytes-to-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"encode",Name:"string-to-bytes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"export-the",Name:"model",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"export-the",Name:"output",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"export-the",Name:"plot",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"export-the",Name:"view",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"export-the",Name:"world",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fetch",Name:"file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fetch",Name:"file-async",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fetch",Name:"url",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fetch",Name:"url-async",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fetch",Name:"user-file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fetch",Name:"user-file-async",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"take",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"drop",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"scan",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"compose",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[15],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:2},{Extension:"fp",Name:"pipe",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[15],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:2},{Extension:"fp",Name:"curry",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[15],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:2},{Extension:"fp",Name:"find-indices",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"find",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"zip",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:2},{Extension:"fp",Name:"unzip",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"flatten",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"iterate",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"fp",Name:"iterate-last",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"http-req",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"http-req",Name:"post",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"import-a",Name:"drawing",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"import-a",Name:"pcolors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"import-a",Name:"pcolors-rgb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"import-a",Name:"world",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"logging",Name:"all-logs",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"logging",Name:"clear-logs",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"logging",Name:"log-globals",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"logging",Name:"log-message",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"is-matrix?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"regress",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"forecast-continuous-growth",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"forecast-compound-growth",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"forecast-linear-growth",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"make-constant",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"dimensions",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"det",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"rank",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"trace",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"make-identity",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"from-row-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"from-column-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"to-row-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"to-column-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"copy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"pretty-print-text",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"solve",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"get-row",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"get-column",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"set-row",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"set-column",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"swap-rows",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"swap-columns",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"set-and-report",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"submatrix",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"map",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[15],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"times-scalar",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"times",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"*",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"times-element-wise",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"plus-scalar",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"plus",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"+",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"minus",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"-",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"inverse",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"transpose",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"real-eigenvalues",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"imaginary-eigenvalues",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"matrix",Name:"eigenvectors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"mini-csv",Name:"from-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"mini-csv",Name:"from-row",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"mini-csv",Name:"to-string",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"mini-csv",Name:"to-row",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0,DefaultOption:1},{Extension:"mini-csv",Name:"__t-context-reporter",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"mini-csv",Name:"__o-context-command",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},Precedence:0},{Extension:"nettango",Name:"activate",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"hide",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"recompile",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"show-blocks",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"show-blocks-except",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"hide-blocks",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"hide-blocks-except",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"highlight-blocks",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"highlight-blocks-except",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nettango",Name:"switch-program",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"from-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"to-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"is-map?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"remove",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"add",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"to-json",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"to-urlenc",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nlmap",Name:"from-json",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nt",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"nt",Name:"set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"alpha-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"transparency-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-alpha",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"alpha",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"transparency",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-alpha",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-transparency",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-transparency",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"hue-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"saturation-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"brightness-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-hue",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-saturation",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-brightness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"hue",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"saturation",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"brightness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-hue",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-saturation",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-brightness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"r-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"g-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"b-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-r",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-g",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"with-b",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"r",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"g",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"b",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-r",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-g",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"set-b",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"scale-gradient-hsb",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"scale-gradient",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"scale-scheme",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"palette",Name:"scheme-colors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"update",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"raycast",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"raycast-all",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"pointcast",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"query",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"turtles-around",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"turtles-here",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"can-move?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"contacts",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[7],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"all-contacts",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"contact-end",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"contact-begin",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"contact-end",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"filter-contact",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"show-vector",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,4],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"show-orthogonal",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3,4],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"hide-vectors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"clear-vectors",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"get-type",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"set-type",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"set-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"get-gravity",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"set-gravity",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"is-physical?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"phys",Name:"set-physical",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"get-friction",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"set-friction",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"get-restitution",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"set-restitution",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"phys",Name:"get-mass",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-mass",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-density",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-density",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-origin",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-origin",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-v",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-vx",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-vy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-a",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-v",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-angular-v",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-angular-v",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-angular-a",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-linear-damping",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-linear-damping",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"get-angular-damping",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"set-angular-damping",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"push",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"apply-force",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"apply-torque",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"make-circle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"make-box",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"make-polygon",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"make-edges",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"add-circle",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"add-box",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"add-polygon",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"add-edges",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1},{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!1,Link:!1},Precedence:0},{Extension:"phys",Name:"detach-joint",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"distance-joint",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"distance-joint-anchored",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"mouse-joint",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-length",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-length",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-lengths",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-linear-stiffness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-damping",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-damping",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-stiffness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-stiffness",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-max-force",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-max-force",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"set-max-torque",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-max-torque",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-force",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"phys",Name:"get-torque",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!1,Patch:!1,Link:!0},Precedence:0},{Extension:"plot",Name:"show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"plot",Name:"hide",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"plot",Name:"activate",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"plot",Name:"move",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"plot",Name:"set-title",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"plot",Name:"bind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"plot",Name:"unbind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"send-to",Name:"file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"clear",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"bind-gesture",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"unbind-gesture",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"touches",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"touch-size",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"touch",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"open",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"close",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"on-change",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"read-number",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"read-vector",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"is-available?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sensor",Name:"set-warning",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"drums",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"instruments",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"play-drum",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"play-note",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"play-note-later",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"start-note",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"stop-note",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"stop-instrument",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"sound",Name:"stop-music",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"list-stores",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"switch-store",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"delete-store",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"put",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"get-keys",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"has-key",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"remove",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"store",Name:"clear",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[12],CanRepeat:!1,Optional:!0}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"explode",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"from-file",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"from-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"hash-code",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"md5",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"message-digest-5",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"rex-match?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"rex-replace-first",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"rex-replace-all",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"rex-split",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"starts-with?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"ends-with?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"trim",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"upper-case",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"lower-case",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"string",Name:"split-on",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"is-table?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"clear",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"counts",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"group-agents",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[7],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"group-items",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[15],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"from-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"get-or-default",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"has-key?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"keys",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"length",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"make",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"put",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"remove",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"to-list",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"values",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"to-json",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"table",Name:"from-json",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"drums",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"instruments",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"use",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"tempo",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"note",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"rest",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"loop",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"once",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"loop-then",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"once-then",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"who",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"volume",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"moveto",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"rewind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"forward",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"play-at",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"play-here",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"tune",Name:"clear",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tune",Name:"stop",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"show-dialog",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"minimize-dialog",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"hide-dialog",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"back-dialog",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"submit-input",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[5],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"set",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"get",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[1],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"activate",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"deactivate",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"get-activated",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"is-activated?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"go",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"forward",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"back",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"survey",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"tutorial",Name:"in-tutorial?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"toast",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"hide",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"move",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"set-title",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"bind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"unbind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"set-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"show-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"hide-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"move-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"rename-group",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"show-joystick",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"hide-joystick",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"bind-joystick",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"joystick-x",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"widget",Name:"joystick-y",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"pause",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"play",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"show",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"hide",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"set-speed",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"get-speed",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"get-platform",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"id",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"recompile",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"trigger",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[1],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"bind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,3],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1},{Types:[5],CanRepeat:!1,Optional:!1},{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"unbind",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,3],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"unbind-all",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"clear-commands",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"workspace",Name:"execute-command",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"is-supported?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"is-on?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"start",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"stop",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"get-gravity",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"get-scale",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"set-scale",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"xcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"ycor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"zcor",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"dx",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"dy",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"heading",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"colorize-wireframes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"show-wireframes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"hide-wireframes",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"colorize-wireframe",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[4,3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"show-wireframe",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"hide-wireframe",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"room-scan",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},Precedence:0},{Extension:"xr",Name:"is-room-scan-supported?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"scans",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"current-scan",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[2],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"use-scan",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},Precedence:0},{Extension:"xr",Name:"resize-world",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[3],CanRepeat:!0,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!1,Patch:!1,Link:!1},Precedence:0},{Extension:"xr",Name:"get-dimensions",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[4],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"iterate-as-patches",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"iterate-as-turtles",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2,20],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[0],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0},{Extension:"xr",Name:"inside-scan?",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[],ReturnType:{Types:[5],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!1,Turtle:!0,Patch:!0,Link:!1},Precedence:0},{Extension:"xr",Name:"color-of",LeftArgumentType:{Types:[0],CanRepeat:!1,Optional:!1},RightArgumentTypes:[{Types:[2],CanRepeat:!1,Optional:!1},{Types:[2],CanRepeat:!1,Optional:!1}],ReturnType:{Types:[3],CanRepeat:!1,Optional:!1},AgentContext:{Observer:!0,Turtle:!0,Patch:!0,Link:!0},Precedence:0}];

    class Primitives{constructor(){this.Metadata=new Map,this.Extensions=new Map,this.ExtensionNames=[];}Register(t,e){var i=""==t?e.Name:`${t}:${e.Name}`;this.Metadata.has(i)||(-1==this.ExtensionNames.indexOf(t)&&(this.ExtensionNames.push(t),this.Extensions.set(t,[])),this.Extensions.get(t).push(e),this.Metadata.set(i,e));}static BuildInstance(){var t=new Primitives;return Dataset.forEach((e=>{t.Register(e.Extension,e);})),t}GetPrimitive(t,e){var i,s=""==t?e:`${t}:${e}`;return null!==(i=this.Metadata.get(s))&&void 0!==i?i:null}HasPrimitive(t,e){var i=""==t?e:`${t}:${e}`;return this.Metadata.has(i)}GetNamedPrimitive(t){var e;return null!==(e=this.Metadata.get(t))&&void 0!==e?e:null}HasNamedPrimitive(t){return this.Metadata.has(t)}IsReporter(t){return t.ReturnType.Types[0]!=NetLogoType.Unit}GetExtensions(){return this.ExtensionNames}GetCompletions(t){var e=[];for(var i of this.Metadata.values())if(""==i.Extension||-1!=t.indexOf(i.Extension)){var s=i.Name;""!=i.Extension&&(s=`${i.Extension}:${s}`),e.push({label:s,type:this.IsReporter(i)?"Reporter":"Command"});}return e}}const PrimitiveManager=Primitives.BuildInstance();try{window.PrimitiveManager=Primitives;}catch(t){}

    const Global="undefined"==typeof globalThis?window:globalThis;const Log=Global.GalapagosSilent?()=>{}:console.log;String.prototype.trimStart||(String.prototype.trimStart=function(){return this.replace(new RegExp("^"+/[\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF]+/.source,"g"),"")}),String.prototype.trimEnd||(String.prototype.trimEnd=function(){return this.replace(new RegExp(/[\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF]+/.source+"$","g"),"")});

    function GetCursorUntilMode(r){const n=syntaxTree(r).cursor();if(!n.firstChild())return null;for(;"LineComment"==n.node.name;)n.nextSibling();return n}function GetCursorInsideMode(r){const n=GetCursorUntilMode(r);return (null==n?void 0:n.firstChild())?n:null}

    const getNodeContext=function(e,r){let t=r;for(;t;){if("Procedure"==t.name||"Extensions"==t.name||"Globals"==t.name||"Breed"==t.name||"BreedsOwn"==t.name)return e.sliceDoc(t.from,t.to);t=t.parent;}return e.sliceDoc(r.from,r.to)};const getCodeName=function(e,r){return e.sliceDoc(r.from,r.to).trim().toLowerCase()};const getParentProcedure=function(e,r){let t=r;for(;t.parent;)if(t=t.parent,"Procedure"==t.name){var o=t.getChildren("ProcedureName");if(o.length>0)return getCodeName(e,o[0])}};

    class PreprocessContext{constructor(){this.PluralBreeds=new Map,this.SingularBreeds=new Map,this.SingularToPlurals=new Map,this.PluralToSingulars=new Map,this.SpecialReporters=new Map,this.BreedTypes=new Map,this.BreedVars=new Map,this.BreedVarToPlurals=new Map,this.Commands=new Map,this.Reporters=new Map,this.CommandsOrigin=new Map,this.ReportersOrigin=new Map;}Clear(){return this.PluralBreeds.clear(),this.SingularBreeds.clear(),this.BreedTypes.clear(),this.BreedVars.clear(),this.BreedVarToPlurals.clear(),this.Commands.clear(),this.Reporters.clear(),this.CommandsOrigin.clear(),this.ReportersOrigin.clear(),this.SpecialReporters.clear(),this}GetBreedContext(e,t){var r=this.BreedTypes.get(e);return void 0===r?new AgentContexts("O---"):r==BreedType.DirectedLink||r==BreedType.UndirectedLink?new AgentContexts("---L"):r==BreedType.Patch?new AgentContexts(t?"-TP-":"--P-"):new AgentContexts("-T--")}GetSuperType(e){var t=this.BreedTypes.get(e);return t==BreedType.Patch?"patches":t==BreedType.Turtle?"turtles":t==BreedType.DirectedLink||t==BreedType.UndirectedLink?"links":null}GetBreedVariableContexts(e){if(this.BreedVarToPlurals.has(e)){let t=this.BreedVarToPlurals.get(e);if(t&&t.length>0){let e=new AgentContexts;for(let r of t)e=combineContexts(e,this.GetBreedContext(r,!0));return e}}}GetReporterBreed(e){if(0==this.SpecialReporters.size){for(let[e,r]of this.BreedTypes)switch(r){case BreedType.Turtle:this.SpecialReporters.set(e,e),this.SpecialReporters.set(e+"-at",e),this.SpecialReporters.set(e+"-here",e),this.SpecialReporters.set(e+"-on",e);break;case BreedType.Patch:this.SpecialReporters.set("patch-at",e),this.SpecialReporters.set("patch-here",e),this.SpecialReporters.set("patch-ahead",e),this.SpecialReporters.set("patch-at-heading-and-distance",e),this.SpecialReporters.set("patch-left-and-ahead",e),this.SpecialReporters.set("patch-right-and-ahead",e),this.SpecialReporters.set("neighbors",e),this.SpecialReporters.set("neighbors4",e);break;case BreedType.UndirectedLink:case BreedType.DirectedLink:var t=this.PluralToSingulars.get(e);this.SpecialReporters.set("link-at",e),this.SpecialReporters.set("out-"+t+"-to",e),this.SpecialReporters.set("in-"+t+"-from",e),this.SpecialReporters.set("my-"+e,e),this.SpecialReporters.set("my-in-"+e,e),this.SpecialReporters.set("my-out-"+e,e),this.SpecialReporters.set(t+"-with",e),this.SpecialReporters.set("out-"+t+"-neighbors","turtles"),this.SpecialReporters.set("in-"+t+"-neighbors","turtles"),this.SpecialReporters.set(t+"-neighbors","turtles");}return this.SpecialReporters.get(e)}}}class LintContext{constructor(){this.Extensions=new Map,this.Globals=new Map,this.WidgetGlobals=new Map,this.Breeds=new Map,this.Procedures=new Map;}Clear(){return this.Extensions.clear(),this.Globals.clear(),this.WidgetGlobals.clear(),this.Breeds.clear(),this.Procedures.clear(),this}GetDefined(){var e=[];return e.push(...this.Globals.keys()),e.push(...this.WidgetGlobals.keys()),e.push(...this.Procedures.keys()),e.push(...this.GetBreedNames()),e.push(...this.GetBreedVariables()),e}GetBreedNames(){var e=[];for(let t of this.Breeds.values())e.push(t.Singular),e.push(t.Plural);return e}GetPluralBreedNames(){var e=[];for(let t of this.Breeds.values())e.push(t.Plural);return e}GetBreedVariables(){var e=[];for(let t of this.Breeds.values())e=e.concat(t.Variables);return e}GetBreeds(){var e=[];for(let t of this.Breeds.values())e.push(t);return e}GetBreedFromVariable(e){for(let t of this.Breeds.values())if(t.Variables.includes(e))return t.Plural;return null}checkCodeBlocks(e,t,r,s,i){for(let a of t){if(a.PositionEnd<s||a.PositionStart>i)continue;for(let t of a.Variables)if(t.Name==e&&t.CreationPos<=i)return r;let t=this.checkCodeBlocks(e,a.CodeBlocks,r,s,i);if(null!=t)return t;let o=this.checkAnonProc(e,a.AnonymousProcedures,r,s,i);if(null!=o)return o}return null}checkAnonProc(e,t,r,s,i){for(let a of t)if(!(a.PositionEnd<s||a.PositionStart>i)){if(a.Arguments.includes(e))return "{anonymous},"+r;for(let t of a.Variables)if(t.Name==e&&t.CreationPos<=i)return "{anonymous},"+r}return null}GetProcedureFromVariable(e,t,r){for(let s of this.Procedures.values()){if(s.PositionEnd<t||s.PositionStart>r)continue;if(s.Arguments.includes(e))return s.Name;for(let t of s.Variables)if(t.Name==e&&t.CreationPos<=r)return s.Name;let i=this.checkAnonProc(e,s.AnonymousProcedures,s.Name,t,r);if(null!=i)return i;let a=this.checkCodeBlocks(e,s.CodeBlocks,s.Name,t,r);if(null!=a)return a}return null}}

    const ReporterLeft1Args=1,ReporterLeft2Args=2,ReporterLeft1ArgsOpt=3,GlobalStr=4,ExtensionStr=5,BreedStr=6,Own=7,Set$1=8,Let=9,To=10,End=11,Identifier=12,Command=13,Reporter=14,TurtleVar=15,PatchVar=16,LinkVar=17,Constant=18,SpecialReporter=20,SpecialCommand=21,BreedToken=22,AndOr=23,APCommand=24,APReporterFlip=25,APReporterVar=26,APReporter=27,UnsupportedPrim=28,SpecialCommandCreateTurtle=29,SpecialCommandCreateLink=30,SpecialReporter1ArgsBoth=31,SpecialReporter0ArgsLink=32,SpecialReporter1ArgsLink=33,SpecialReporter2ArgsTurtle=34,SpecialReporter0ArgsTurtle=35,SpecialReporter1ArgsTurtle=36,SpecialReporter0ArgsLinkP=37,SpecialCommandCreateTurtlePossible=38,Reporter0Args=39,Reporter1Args=40,Reporter2Args=41,Reporter3Args=42,Reporter4Args=43,Reporter5Args=44,Reporter6Args=45,Reporter0ArgsVar=46,Reporter1ArgsVar=47,Reporter2ArgsVar=48,Reporter3ArgsVar=49,Reporter4ArgsVar=50,Reporter5ArgsVar=51,Reporter6ArgsVar=52,Reporter2ArgsVar0=53,Reporter1ArgsVar0=54,SpecialReporter0Args=55,SpecialReporter1Args=56,SpecialReporter2Args=57,SpecialReporter3Args=58,SpecialReporter4Args=59,SpecialReporter5Args=60,SpecialReporter6Args=61,Command0Args=62,Command1Args=63,Command2Args=64,Command3Args=65,Command4Args=66,Command5Args=67,Command6Args=68,Command0ArgsVar=69,Command1ArgsVar=70,Command2ArgsVar=71,Command3ArgsVar=72,Command4ArgsVar=73,Command5ArgsVar=74,Command6ArgsVar=75,Command3ArgsVar2=76,Command1_2ArgsOpt=77,SpecialCommand0Args=78,SpecialCommand1Args=79,SpecialCommand2Args=80,SpecialCommand3Args=81,SpecialCommand4Args=82,SpecialCommand5Args=83,SpecialCommand6Args=84;

    const BreedStatementRules=[{Match:/^(.*?)-own$/,Singular:!1,Tag:Own,Type:void 0,Position:0,String:["<breed>-own"],Context:new AgentContexts("O---"),isCommand:!1},{Match:/^(.*?)-(at)$/,Singular:!1,Tag:SpecialReporter2ArgsTurtle,Type:BreedType.Turtle,Position:0,String:["<breed>-at"],Context:new AgentContexts("-TPL"),isCommand:!1},{Match:/^(.*?)-(here)$/,Singular:!1,Tag:SpecialReporter0ArgsTurtle,Type:BreedType.Turtle,Position:0,String:["<breed>-here"],Context:new AgentContexts("-TP-"),isCommand:!1},{Match:/^(.*?)-(on)$/,Singular:!1,Tag:SpecialReporter1ArgsTurtle,Type:BreedType.Turtle,Position:0,String:["<breed>-on"],Context:new AgentContexts("OTPL"),isCommand:!1},{Match:/^(in)-(.*?)-(from)$/,Singular:!0,Tag:SpecialReporter1ArgsLink,Type:BreedType.UndirectedLink,Position:1,String:["in-<breed>-from"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(out)-(.*?)-(to)$/,Singular:!0,Tag:SpecialReporter1ArgsLink,Type:BreedType.UndirectedLink,Position:1,String:["out-<breed>-to"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(out|in)-(.*?)-(neighbor\?)$/,Singular:!0,Tag:SpecialReporter1ArgsLink,Type:BreedType.UndirectedLink,Position:1,String:["out-<breed>-neighbor?","in-<breed>-neighbor?"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(out|in)-(.*?)-(neighbors)$/,Singular:!0,Tag:SpecialReporter0ArgsLink,Type:BreedType.UndirectedLink,Position:1,String:["out-<breed>-neighbors","in-<breed>-neighbors"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(my-in|my-out|my)-(.*?)$/,Singular:!1,Tag:SpecialReporter0ArgsLinkP,Type:BreedType.UndirectedLink,Position:1,String:["my-out-<breed>","my-in-<breed>","my-<breed>"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(is)-(.*?)\?$/,Singular:!0,Tag:SpecialReporter1ArgsBoth,Type:void 0,Position:1,String:["is-<breed>?"],Context:new AgentContexts("OTPL"),isCommand:!1},{Match:/^(create)-(.*?)-(to|from|with)$/,Singular:void 0,Tag:SpecialCommandCreateLink,Type:BreedType.UndirectedLink,Position:1,String:["create-<breed>-to","create-<breed>-with","create-<breed>-from"],Context:new AgentContexts("-T--"),isCommand:!0},{Match:/^(.*?)-(with|neighbor\?)$/,Singular:!0,Tag:SpecialReporter1ArgsLink,Type:BreedType.UndirectedLink,Position:0,String:["<breed>-with","<breed>-neighbor?"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(.*?)-(neighbors)$/,Singular:!0,Tag:SpecialReporter0ArgsLink,Type:BreedType.UndirectedLink,Position:0,String:["<breed>-neighbors"],Context:new AgentContexts("-T--"),isCommand:!1},{Match:/^(create-ordered|create)-(.*?)$/,Singular:!1,Tag:SpecialCommandCreateTurtle,Type:BreedType.Turtle,Position:1,String:["create-ordered-<breed>","create-<breed>"],Context:new AgentContexts("O---"),isCommand:!0},{Match:/^(hatch)-(.*?)$/,Singular:!1,Tag:SpecialCommandCreateTurtle,Type:BreedType.Turtle,Position:1,String:["hatch-<breed>"],Context:new AgentContexts("-T--"),isCommand:!0},{Match:/^(sprout)-(.*?)$/,Singular:!1,Tag:SpecialCommandCreateTurtle,Type:BreedType.Turtle,Position:1,String:["sprout-<breed>"],Context:new AgentContexts("--P-"),isCommand:!0}];function MatchBreed(e,r,t=!1){if(e=e.toLowerCase(),!t){if(r.BreedVars.has(e))return {Tag:Identifier,Valid:!1};if(r.SingularBreeds.has(e)){let t=r.SingularToPlurals.get(e);var n=r.BreedTypes.get(t);return n==BreedType.Turtle?{Tag:SpecialReporter1Args,Singular:e,Plural:t,Valid:!0}:{Tag:SpecialReporter2Args,Singular:e,Plural:t,Valid:!0}}}var i=!0;for(let u of BreedStatementRules){let g=e.match(u.Match);if(g){var a,o,l=g[u.Position+1],s=void 0!==u.Singular?u.Singular:r.SingularBreeds.has(l);if(s)if(a=l,r.SingularBreeds.has(l))o=r.SingularToPlurals.get(l);else {if(!t)return {Tag:0,Valid:!1};o=getPluralName(l),i=!1;}else if(o=l,r.PluralBreeds.has(l))a=r.PluralToSingulars.get(l);else {if(!t)return {Tag:0,Valid:!1};a=getSingularName(l),i=!1;}if(void 0===(n=r.BreedTypes.get(o))&&t&&(n=u.Type),n==BreedType.DirectedLink&&(n=BreedType.UndirectedLink),void 0!==u.Type&&n!==u.Type)return {Tag:SpecialCommandCreateTurtlePossible,Valid:!1};switch(n){case BreedType.Turtle:g[u.Position+1]=s?"turtle":"turtles";break;case BreedType.Patch:g[u.Position+1]=s?"patch":"patches";break;case BreedType.UndirectedLink:g[u.Position+1]=s?"link":"links";}return {Rule:u,Tag:u.Tag,Plural:o,Singular:a,Context:u.Context,Type:n,Valid:i,Prototype:g.slice(1).join("-")}}}return {Tag:0,Valid:!1}}function GetAllBreedPrimitives(e){let r=[];for(let t of e.Breeds.values())r.push(...GetBreedPrimitives(t));return r}function GetBreedPrimitives(e){let r=[];return e.BreedType==BreedType.Turtle||e.BreedType==BreedType.Patch?(e.BreedType==BreedType.Turtle&&(r.push("hatch-"+e.Plural),r.push("sprout-"+e.Plural),r.push("create-"+e.Plural),r.push("create-ordered-"+e.Plural)),r.push(e.Plural+"-at"),r.push(e.Plural+"-here"),r.push(e.Plural+"-on"),r.push("is-"+e.Singular+"?")):(r.push("create-"+e.Plural+"-to"),r.push("create-"+e.Singular+"-to"),r.push("create-"+e.Plural+"-from"),r.push("create-"+e.Singular+"-from"),r.push("create-"+e.Plural+"-with"),r.push("create-"+e.Singular+"-with"),r.push("out-"+e.Singular+"-to"),r.push("out-"+e.Singular+"-neighbors"),r.push("out-"+e.Singular+"-neighbor?"),r.push("in-"+e.Singular+"-from"),r.push("in-"+e.Singular+"-neighbors"),r.push("in-"+e.Singular+"-neighbor?"),r.push("my-"+e.Plural),r.push("my-in-"+e.Plural),r.push("my-out-"+e.Plural),r.push(e.Singular+"-neighbor?"),r.push(e.Singular+"-neighbors"),r.push(e.Singular+"-with"),r.push("is-"+e.Singular+"?")),r}const getPluralName=function(e){return "s"==e[e.length-1]?e+"es":e+"s"};const getSingularName=function(e){return "s"!=e[e.length-1]?"a-"+e:e.substring(0,e.length-1)};

    let primitives$5=PrimitiveManager;class StateNetLogo{constructor(){this.Preprocess=new PreprocessContext,this.Extensions=[],this.Globals=[],this.WidgetGlobals=[],this.Breeds=new Map,this.Procedures=new Map,this.CompilerErrors=[],this.RuntimeErrors=[],this.IsDirty=!0,this.Mode=ParseMode.Normal,this.RecognizedMode="Unknown",this.ContextErrors=[],this.EditorID=0,this.Context="";}SetContext(e){return this.Context!==e&&(this.Context=e,!0)}SetDirty(){this.IsDirty=!0;}GetDirty(){return this.IsDirty}ParseState(e){var t,r,n;if(!this.IsDirty)return this;this.Breeds=new Map,this.Procedures=new Map,this.Extensions=[],this.Globals=[],this.ContextErrors=[],this.Breeds.set("turtle",new Breed("turtle","turtles",[],BreedType.Turtle)),this.Breeds.set("patch",new Breed("patch","patches",[],BreedType.Patch)),this.Breeds.set("link",new Breed("link","links",[],BreedType.UndirectedLink));let o=new Map;this.IsDirty=!1;const i=GetCursorUntilMode(e);if(!i)return this;switch(i.node.name){case"Embedded":this.RecognizedMode="Command";break;case"OnelineReporter":this.RecognizedMode="Reporter";break;case"Normal":this.RecognizedMode="Model";break;default:this.RecognizedMode="Unknown";}if("Model"==this.RecognizedMode){if(!i.firstChild())return this;for(;;){if("Extensions"==i.node.name)i.node.getChildren("Identifier").map((t=>{this.Extensions.push(getCodeName(e,t));}));else if("Globals"==i.node.name)this.Globals=[...this.Globals,...this.getVariables(i.node,e)];else if("Breed"==i.node.name){let r=BreedType.Turtle;i.node.getChildren("BreedStr").map((t=>{let n=getCodeName(e,t);"undirected-link-breed"==n.toLowerCase()?r=BreedType.UndirectedLink:"directed-link-breed"==n.toLowerCase()&&(r=BreedType.DirectedLink);}));const n=i.node.getChildren("BreedPlural"),s=i.node.getChildren("BreedSingular");if(1==n.length&&1==s.length){let i=getCodeName(e,s[0]),d=getCodeName(e,n[0]),a=null!==(t=o.get(d))&&void 0!==t?t:[],l=new Breed(i,d,a,r);this.Breeds.set(i,l);}}else if("BreedsOwn"==i.node.name){let t="";i.node.getChildren("Own").map((r=>{t=getCodeName(e,r),t=t.substring(0,t.length-4);}));let r=this.getVariables(i.node,e),n=!1;for(let e of this.Breeds.values())e.Plural==t&&(e.Variables=r,n=!0);n||o.set(t,r);}else if("Procedure"==i.node.name){let t=this.gatherProcedure(i.node,e);this.Procedures.set(t.Name,t);}if(!i.nextSibling())return this}}else {if("Command"==this.RecognizedMode){let t=this.gatherEmbeddedProcedure(i.node,e);this.Procedures.set(t.Name,t);}else if("Reporter"==this.RecognizedMode){let t=this.gatherOnelineProcedure(i.node,e);this.Procedures.set(t.Name,t);}let t=this.Preprocess.GetBreedContext(this.Context,!1);this.combineContext(null!==(n=null===(r=syntaxTree(e).cursor().node.firstChild)||void 0===r?void 0:r.firstChild)&&void 0!==n?n:syntaxTree(e).cursor().node,e,t,new AgentContexts);}return this}gatherEmbeddedProcedure(e,t){let r=new Procedure;return r.PositionStart=e.from,r.PositionEnd=e.to,r.IsCommand=!0,r.Name="⚠EmbeddedProcedure⚠",r.Arguments=[],r.Variables=this.getLocalVarsCommand(e,t,!1),r.AnonymousProcedures=this.gatherAnonProcedures(e,t,r),r.Context=this.getContext(e,t),r.CodeBlocks=this.gatherCodeBlocks(t,e,r.Context,r.Variables,r.Arguments),r}gatherOnelineProcedure(e,t){let r=new Procedure;return r.PositionStart=e.from,r.PositionEnd=e.to,r.IsCommand=!1,r.Name="⚠OnelineReporter⚠",r.Arguments=[],r.Variables=this.getLocalVarsCommand(e,t,!1),r.AnonymousProcedures=this.gatherAnonProcedures(e,t,r),r.Context=this.getContext(e,t),r.CodeBlocks=this.gatherCodeBlocks(t,e,r.Context,r.Variables,r.Arguments),r}gatherProcedure(e,t){let r=new Procedure;return r.PositionStart=e.from,r.PositionEnd=e.to,r.IsCommand=!0,e.getChild("To")&&(r.IsCommand="to"==getCodeName(t,e.getChildren("To")[0].node).toLowerCase()),e.getChildren("ProcedureName").map((e=>{r.Name=getCodeName(t,e);})),r.Arguments=this.getArgs(e,t),r.Variables=this.getLocalVars(e,t,!1),r.AnonymousProcedures=this.gatherAnonProcedures(e,t,r),r.Context=this.getContext(e,t),r.CodeBlocks=this.gatherCodeBlocks(t,e,r.Context,r.Variables,r.Arguments),this.checkReporterContext(e,t),r}checkReporterContext(e,t){e.cursor().iterate((e=>{if("ReporterLeft1Args"==e.name){let r=null,n=null;if("of"==getCodeName(t,e)?(r=e.node.prevSibling,n=e.node.nextSibling):"with"==getCodeName(t,e)&&(n=e.node.prevSibling,r=e.node.nextSibling),r&&n){let e=this.identifyBreed(n,t),o=getCodeName(t,r);if(o=o.replace(/^\s*\[/,""),o=o.replace(/\]\s$/,""),o=o.replace(/\[[^\]]*\]/,""),e)for(let t of o.split(" "))if(this.Preprocess.BreedVarToPlurals.has(t.toLowerCase())){let n=this.Preprocess.BreedVarToPlurals.get(t.toLowerCase()),o=this.Preprocess.GetSuperType(e),i=new AgentContexts;if(o&&n&&!n.includes(e)&&!n.includes(o)){if("turtles"==o&&n.includes("patches"))continue;for(let e of n)i=combineContexts(i,this.Preprocess.GetBreedContext(e,!0));this.ContextErrors.push(new ContextError(r.from,r.to,this.Preprocess.GetBreedContext(e,!1),i,t));}}}}}));}getContext(e,t,r){let n=new AgentContexts,o=null!=r?r:new AgentContexts,i=n;return e.getChildren("ProcedureContent").map((e=>{e.getChildren("CommandStatement").map((e=>{[o,i]=this.combineContext(e,t,o,i);}));})),o}combineContext(e,t,r,n){return e.cursor().iterate((e=>{var o,i;let s,d;if(e.name.includes("Block")||"AnonymousProcedure"==e.name)return !1;if(!e.node.name.includes("Command")&&!e.node.name.includes("Reporter")||e.node.name.includes("Commands")||e.node.name.includes("Reporters")||e.node.name.includes("Special")||e.node.name.includes("Content")||e.node.name.includes("Statement"))if("VariableDeclaration"==e.node.name){let r=null===(o=e.node.getChild("SetVariable"))||void 0===o?void 0:o.getChild("VariableName");r&&(d=getCodeName(t,r),s=["shape","breed","hidden?","label","label-color","color"].includes(d)?new AgentContexts("-T-L"):(null==r?void 0:r.getChild("PatchVar"))?new AgentContexts("-TP-"):(null==r?void 0:r.getChild("TurtleVar"))?new AgentContexts("-T--"):(null==r?void 0:r.getChild("LinkVar"))?new AgentContexts("---L"):this.Preprocess.GetBreedVariableContexts(d));}else e.node.name.includes("Special")&&(d=getCodeName(t,e.node),s=e.node.name.includes("Both")||e.node.name.includes("Turtle")||e.node.name.includes("Link")?MatchBreed(d,this.Preprocess).Context:null===(i=this.Procedures.get(d))||void 0===i?void 0:i.Context);else d=getCodeName(t,e.node),s=this.getPrimitiveContext(t,e.node,d);s&&(n=combineContexts(s,r),noContext(n)?this.ContextErrors.push(new ContextError(e.node.from,e.node.to,r,s,d)):r=n);})),[r,n]}OLDcombineContext(e,t,r,n){var o,i;let s=e.cursor(),d=s.firstChild();for(;d;){let e,a;if(!s.node.name.includes("Command")&&!s.node.name.includes("Reporter")||s.node.name.includes("Commands")||s.node.name.includes("Reporters")||s.node.name.includes("Special"))if("VariableDeclaration"==s.node.name){let r=null===(o=s.node.getChild("SetVariable"))||void 0===o?void 0:o.getChild("VariableName");r&&(a=getCodeName(t,r),e=["shape","breed","hidden?","label","label-color","color"].includes(a)?new AgentContexts("-T-L"):(null==r?void 0:r.getChild("PatchVar"))?new AgentContexts("-TP-"):(null==r?void 0:r.getChild("TurtleVar"))?new AgentContexts("-T--"):(null==r?void 0:r.getChild("LinkVar"))?new AgentContexts("---L"):this.Preprocess.GetBreedVariableContexts(a));}else s.node.name.includes("Special")&&(a=getCodeName(t,s.node),e=s.node.name.includes("Both")||s.node.name.includes("Turtle")||s.node.name.includes("Link")?MatchBreed(a,this.Preprocess).Context:null===(i=this.Procedures.get(a))||void 0===i?void 0:i.Context);else a=getCodeName(t,s.node),e=this.getPrimitiveContext(t,s.node,a);e&&(n=combineContexts(e,r),noContext(n)?this.ContextErrors.push(new ContextError(s.node.from,s.node.to,r,e,a)):r=n),d=s.nextSibling();}return [r,n]}getPrimitiveContext(e,t,r){let n=primitives$5.GetNamedPrimitive(r);return null==n?void 0:n.AgentContext}gatherCodeBlocks(e,t,r,n,o){var i=[];return t.cursor().iterate((s=>{if(s.node.to>t.to)return !1;"Value"==s.name&&s.node.getChildren("CodeBlock").map((t=>{this.gatherCodeBlock(e,t,i,r,n,o);}));})),i}gatherCodeBlock(e,t,r,n,o,i){if(this.checkRanges(r,t))return;let s=new CodeBlock,d=this.getPrimitive(t.parent.node.parent.node,e);s.Primitive=d.name,s.PositionStart=t.from,s.PositionEnd=t.to,s.InheritParentContext=d.inheritParentContext;let a=noContext(d.context)||s.InheritParentContext?n:d.context;s.Context=this.getContext(t,e,a),s.Variables=o.concat(this.getLocalVars(t.node,e,!0)),s.Arguments=i,s.Breed=d.breed,s.CodeBlocks=this.gatherCodeBlocks(e,t,s.Context,s.Variables,s.Arguments),r.push(s);}getPrimitive(e,t){var r,n,o,i,s,d;let a={name:"",type:"",isSpecial:!1,context:new AgentContexts("null"),firstArg:null===(r=e.parent)||void 0===r?void 0:r.getChild("Arg"),breed:"",inheritParentContext:!1},l=null===(n=e.parent)||void 0===n?void 0:n.cursor(),m=!1;if(null==l?void 0:l.firstChild())for(["OpenParen","CloseParen","Reporters","Commands","Arg"].includes(l.node.name)||(a.name=getCodeName(t,l.node),a.type=l.node.name,"ask"==a.name&&(m=!0));l.nextSibling()&&(""==a.name||m);)["OpenParen","CloseParen","Reporters","Commands","Arg"].includes(l.node.name)?"Arg"==l.node.name&&m&&(a.breed=null!==(o=this.identifyBreed(l.node,t))&&void 0!==o?o:a.breed,m=!1):(a.name=getCodeName(t,l.node),a.type=l.node.name);if(a.type.includes("Special")&&(a.isSpecial=!0,a.breed=null!==(i=MatchBreed(a.name,this.Preprocess).Plural)&&void 0!==i?i:""),""!=a.breed)a.context=new AgentContexts("null"),this.Preprocess.PluralBreeds.has(a.breed)?a.context=this.Preprocess.GetBreedContext(a.breed,!1):this.Preprocess.SingularBreeds.has(a.breed)&&(a.context=this.Preprocess.GetBreedContext(this.Preprocess.SingularToPlurals.get(a.breed),!1));else {let e=primitives$5.GetNamedPrimitive(a.name);a.context=null!==(s=null==e?void 0:e.BlockContext)&&void 0!==s?s:new AgentContexts("null"),a.inheritParentContext=null!==(d=null==e?void 0:e.InheritParentContext)&&void 0!==d&&d;}return noContext(a.context)&&Log("No available context: "+a.name),a}identifyBreed(e,t){let r=getCodeName(t,e);if(this.Preprocess.PluralBreeds.has(r))return r;var n=this.Preprocess.GetReporterBreed(r.split(" ")[0].trim());return n||(e.cursor().iterate((e=>{if(null!=n)return !1;let r=getCodeName(t,e);return !r.startsWith("[")&&(this.Preprocess.PluralBreeds.has(r)?(n=r,!1):this.Preprocess.SingularBreeds.has(r)?(n=this.Preprocess.SingularToPlurals.get(r),!1):void 0)})),n)}gatherAnonProcedures(e,t,r){let n=[];return e.cursor().iterate((o=>{if(o.node.to>e.to)return !1;e==o.node||"AnonymousProcedure"!=o.name&&"ShortAnonymousProcedure"!=o.name||this.checkRanges(n,o.node)||n.push(this.gatherAnonProcedure(o,t,r));})),n}checkRanges(e,t){for(let r of e)if(r.PositionStart<=t.from&&r.PositionEnd>=t.to)return !0;return !1}gatherAnonProcedure(e,t,r){let n=new Procedure;n.PositionStart=e.from,n.PositionEnd=e.to,n.Variables=r.Variables,n.IsAnonymous=!0,n.Name="",n.IsCommand=e.node.getChildren("ProcedureContent").length>0;let o=[],i=e.node;return i.getChildren("AnonArguments").map((e=>{e.getChildren("Identifier").map((e=>{o.push(getCodeName(t,e));})),e.getChildren("Arguments").map((e=>{e.getChildren("Identifier").map((e=>{o.push(getCodeName(t,e));}));}));})),n.Arguments=o,n.Variables=n.Variables.concat(this.getLocalVars(i,t,!0)),n.AnonymousProcedures=this.gatherAnonProcedures(i,t,n),n}getLocalVars(e,t,r){let n=[];return e.getChildren("ProcedureContent").map((e=>{n=n.concat(this.getLocalVarsCommand(e,t,r));})),n}getLocalVarsCommand(e,t,r){let n=[];return e.getChildren("CommandStatement").map((e=>{e.getChildren("VariableDeclaration").map((e=>{e.getChildren("NewVariableDeclaration").map((e=>{e.getChildren("Identifier").map((e=>{let r=new LocalVariable(getCodeName(t,e),1,e.from);n.push(r);})),e.getChildren("UnsupportedPrim").map((e=>{let r=new LocalVariable(getCodeName(t,e),1,e.from);n.push(r);}));}));}));})),n}getVariables(e,t){let r=[];return e.cursor().iterate((n=>{if(n.node.to>e.to)return !1;if(!["OpenParen","CloseParen","OpenBracket","CloseBracket","LineComment","BreedsOwn","Own","GlobalStr","ExtensionStr","BreedDeclarative","Globals","Breed","Extensions"].includes(n.name)){var o=getCodeName(t,n.node);""===o||o.includes("\n")||r.push(getCodeName(t,n.node));}})),[...new Set(r)]}getArgs(e,t){const r=[];return e.getChildren("Arguments").map((e=>{e.getChildren("Identifier").map((e=>{r.push(getCodeName(t,e));}));})),r}}const stateExtension=StateField.define({create:e=>{var t=new StateNetLogo;return t.SetDirty(),t},update:(e,t)=>(t.docChanged&&(e.SetDirty(),Log(e)),e)});

    class StatePreprocess{constructor(){this.PluralBreeds=[],this.SingularBreeds=[],this.BreedTypes=[],this.BreedVars=new Map,this.Commands=new Map,this.Reporters=new Map,this.Editor=null;}ParseState(e){this.Commands.clear(),this.Reporters.clear(),this.BreedVars.clear();let r=e.doc.toString().toLowerCase(),s=r.replace(/(^|\n)([^;\n]+[ ]+)?to\s+[\s\S]*\s+end/gi,""),t=s.matchAll(/(^|\n)([^;\n]+[ ]+)?(directed-link-|undirected-link-)?breed\s*\[\s*([^\s]+)\s+([^\s]+)\s*\]/g);this.processBreeds(t);let l=s.matchAll(/(^|\n)([^;\n]+[ ]+)?([^\s]+)-own\s*\[([^\]]+)/g);this.processBreedVars(l);let o=r.matchAll(/(^|\n)([^;\n]+[ ]+)?to\s+([^\s\[;]+)(\s*\[([^\];]*)\])?/g);this.Commands=this.processProcedures(o);let i=r.matchAll(/(^|\n)([^;\n]+[ ]+)?to-report\s+([^\s\[;]+)(\s*\[([^\]']*)\])?/g);return this.Reporters=this.processProcedures(i),this}SetEditor(e){this.Editor=e;}processBreedVars(e){var r,s,t;for(var l of e){let e=l[4];e=e.replace(/;[^\n]*\n/g,""),e=e.replace(/\n/g," "),this.BreedVars.set(l[3],e.split(" ").filter((e=>""!=e&&"\n"!=e)));}this.BreedVars.set("patches",(null!==(r=this.BreedVars.get("patches"))&&void 0!==r?r:[]).concat(["pxcor","pycor","pcolor","plabel","plabel-color"])),this.BreedVars.set("turtles",(null!==(s=this.BreedVars.get("turtles"))&&void 0!==s?s:[]).concat(["who","color","heading","xcor","ycor","shape","label","label-color","hidden?","size","pen-size","pen-mode","breed"])),this.BreedVars.set("links",(null!==(t=this.BreedVars.get("links"))&&void 0!==t?t:[]).concat(["end1","end2","color","label","label-color","hidden?","breed","thickness","shape","tie-mode"]));}processProcedures(e){let r=new Map;for(var s of e)if(!s[2]||s[2].split('"').length%2!=0){const e=s[3],t=s[5];r.set(e,null==t?0:[...t.matchAll(/([^\s])+/g)].length);}return r}processBreeds(e){for(var r of(this.SingularBreeds=["patch","turtle","link"],this.PluralBreeds=["patches","turtles","links"],this.BreedTypes=[BreedType.Patch,BreedType.Turtle,BreedType.UndirectedLink],e)){var s=BreedType.Turtle;"directed-link-"==r[3]&&(s=BreedType.DirectedLink),"undirected-link-"==r[3]&&(s=BreedType.UndirectedLink),this.BreedTypes.push(s),this.PluralBreeds.push(r[4]),this.SingularBreeds.push(r[5]);}}}const preprocessStateExtension=StateField.define({create:e=>{let r=new StatePreprocess;return r.ParseState(e),r},update:(e,r)=>r.docChanged?(e.ParseState(r.state),e.Editor&&e.Editor.UpdatePreprocessContext(),Log(e),e):e});

    const buildLinter=function(t,e){var r=-1,o=[],n=n=>{if(e.UpdateContext()||e.GetVersion()>r){var i=n.state.field(stateExtension);o=t(n,e.PreprocessContext,e.LintContext,i),r=e.GetVersion();}return o},i=linter(n);return i.Source=n,4==i[2].length&&(lintState=i[2][0],i[2].splice(2,1),console.log(i)),i};var lintState;const getLintState=function(t){return t.field(lintState)};const getDiagnostic=function(t,e,r,o="error",...n){var i=t.state.sliceDoc(e.from,e.to),l=e.from+i.length-i.trimStart().length,s=e.to-i.length+i.trimEnd().length;return (i=i.trim()).length>=20&&(i=i.replace("\n"," ").substring(0,17)+"..."),0==n.length&&n.push(i),{from:l,to:s,severity:o,message:Localized.Get(r,...n)}};

    const classifyPrimitive=function(e){return -1!=e.indexOf("Reporter")&&-1==e.indexOf("ReporterStatement")&&(e=-1!=e.indexOf("Special")?-1!=e.indexOf("Turtle")||-1!=e.indexOf("Link")||-1!=e.indexOf("Both")?"BreedReporter":"CustomReporter":"Reporter"),-1!=e.indexOf("Command")&&-1==e.indexOf("CommandStatement")&&(e=-1!=e.indexOf("Special")?-1!=e.indexOf("Create")?"BreedCommand":"CustomCommand":"Command"),e};const classifyBreedName=function(e,r){let t=[],n=[],o="";for(let e of r)t.push(e.Plural),n.push(e.Singular);return o=t.includes(e)?"~BreedPlural":"~BreedSingular",o};const getLink=function(e,r,t,n){let o={to:0,from:0,hasLink:!1};return syntaxTree(n).cursor().iterate((i=>{i.name==e&&i.node.getChildren(r).map((e=>{getCodeName(n,e)==t&&(o={to:e.to,from:e.from,hasLink:!0});}));})),o};

    function getTooltip(e,r,t,o){var i=o.LintContext,a=o.PreprocessContext,n=0,l=0,s="",d="",m=null;if(syntaxTree(e.state).iterate({enter:e=>{if(e.from==e.to||t==e.from)return !0;n=e.from,l=e.to;var r=classifyPrimitive(e.name);"~BreedSingular"==s||"~Arguments"==s||"~ProcedureName"==s||(Dictionary.Check(`~${r}`)||Localized.Get(`~${r}`)!=`~${r}`?s=`~${r}`:(Dictionary.Check(`~${d}/${r}`)||Localized.Get(`~${d}/${r}`)!=`~${d}/${r}`)&&(s=`~${d}/${r}`)),d=r;},from:r,to:t}),n==l)return;const c=getCodeName(e.state,{from:n,to:l});if(Dictionary.Check(c)?s=c:i.Globals.has(c)?s="~Globals/Identifier":i.WidgetGlobals.has(c)?s="~WidgetGlobal":i.GetBreedNames().includes(c)?s=classifyBreedName(c,i.GetBreeds()):null!=(m=i.GetBreedFromVariable(c))?s="~BreedVariable":("~VariableName"==s||"~NewVariableDeclaration/Identifier"==s||"Identifier"==d&&""==s)&&(m=i.GetProcedureFromVariable(c,n,l),s=null!=m?"~LocalVariable":"~VariableName"),"~BreedReporter"==s||"~BreedCommand"==s){var f=MatchBreed(c,a);f.Valid&&f.Plural?(f.Prototype&&Dictionary.Check(f.Prototype)&&(s=f.Prototype),m=f.Plural):m="Unknown";}if(Log("Term: "+c,s,d),""==s)return;let u=getInternalLink(c,s,null!=m?m:"",e.state,i);return {from:n,to:l,severity:"info",message:"",renderMessage:()=>{const r=document.createElement("span");var t=Dictionary.Get(s,null!=m?m:"");return null==Dictionary.ClickHandler||s.startsWith("~")?u.hasLink&&(t+="➤",r.addEventListener("click",(()=>e.dispatch({selection:EditorSelection.create([EditorSelection.range(u.from,u.to)]),effects:[EditorView.scrollIntoView(u.from,{y:"center"})]}))),r.classList.add("cm-tooltip-extendable")):(t+="➤",r.addEventListener("click",(()=>Dictionary.ClickHandler(c))),r.classList.add("cm-tooltip-extendable")),r.innerText=t,r}}}function getInternalLink(e,r,t,o,i){let a={to:0,from:0,hasLink:!1};if("~Globals/Identifier"==r)a=getLink("Globals","Identifier",e,o);else if("~BreedSingular"==r)a=getLink("Breed","BreedSingular",e,o);else if("~BreedPlural"==r)a=getLink("Breed","BreedPlural",e,o);else if("~BreedVariable"==r)syntaxTree(o).cursor().iterate((r=>{if("BreedsOwn"==r.name){let i=!1;r.node.getChildren("Own").map((e=>{getCodeName(o,e)==t+"-own"&&(i=!0);})),i&&r.node.getChildren("Identifier").map((r=>{getCodeName(o,r)==e&&(a.to=r.to,a.from=r.from,a.hasLink=!0);}));}}));else if("~CustomReporter"==r||"~CustomCommand"==r)syntaxTree(o).cursor().iterate((r=>{"ProcedureName"==r.name&&getCodeName(o,r)==e&&(a.to=r.to,a.from=r.from,a.hasLink=!0);}));else if("~LocalVariable"==r){let r=t.replace("{anonymous},",""),s=i.Procedures.get(r);if(!s)return a;if(s.Arguments.includes(e))syntaxTree(o).cursor().iterate((t=>{var i;if("Procedure"==t.name){let n=t.node.getChild("ProcedureName");n&&getCodeName(o,n)==r&&(null===(i=t.node.getChild("Arguments"))||void 0===i||i.getChildren("Identifier").map((r=>{getCodeName(o,r)==e&&(a.to=r.to,a.from=r.from,a.hasLink=!0);})));}}));else if(t.includes("{anonymous}")){for(var n of s.AnonymousProcedures)if(n.Arguments.includes(e))syntaxTree(o).iterate({enter:r=>{var t,i;"Identifier"!=r.name||"AnonArguments"!=(null===(t=r.node.parent)||void 0===t?void 0:t.name)&&"Arguments"!=(null===(i=r.node.parent)||void 0===i?void 0:i.name)||getCodeName(o,r)==e&&(a.to=r.to,a.from=r.from,a.hasLink=!0);},to:n.PositionStart,from:n.PositionEnd});else for(var l of n.Variables)if(l.Name==e){let e=syntaxTree(o).cursorAt(l.CreationPos).node;a.to=e.to,a.from=e.from,a.hasLink=!0;}}else for(let r of s.Variables)if(r.Name==e){let e=syntaxTree(o).cursorAt(r.CreationPos).node;a.to=e.to,a.from=e.from,a.hasLink=!0;}}return a}

    const directives=["breed","to","to-report","globals","directed-link-breed","undirected-link-breed","extensions","__includes"];const turtleVars=["who","color","heading","xcor","ycor","shape","label","label-color","hidden?","size","pen-size","pen-mode","breed"];const patchVars=["pxcor","pycor","pcolor","plabel","plabel-color"];const linkVars=["end1","end2","color","label","label-color","hidden?","breed","thickness","shape","tie-mode"];const constants=["true","false","nobody","e","pi","gray","grey","red","orange","brown","yellow","green","lime","turquoise","cyan","sky","blue","violet","magenta","pink","black","white"];const unsupported=["ask-concurrent","beep","display","export-interface","file-close","file-close-all","file-delete","file-flush","file-open","file-print","file-show","file-type","file-write","hubnet-broadcast","hubnet-broadcast-clear-output","hubnet-broadcast-message","hubnet-clear-override","hubnet-clear-overrides","hubnet-kick-all-clients","hubnet-kick-client","hubnet-fetch-message","hubnet-reset","hubnet-reset-perspective","hubnet-send","hubnet-send-clear-output","hubnet-send-follow","hubnet-send-message","hubnet-send-override","hubnet-send-watch","wait","inspect","no-display","set-current-directory","file-at-end?","file-exists?","file-read","file-read-characters","file-read-line","hubnet-clients-list","hubnet-enter-message?","hubnet-exit-message?","hubnet-message","hubnet-message-source","hubnet-message-tag","hubnet-message-waiting?","movie-status","user-directory","user-file","user-new-file","user-one-of","__hubnet-clear-plot","__hubnet-make-plot-narrowcast"];const reserved=[...directives,...turtleVars,...patchVars,...linkVars,...constants,...unsupported];

    class CodeEditing{constructor(e){this.View=e,this.Galapagos=e.state.field(preprocessStateExtension).Editor;}ChangeCode(e){this.View.dispatch({changes:e});}GetSlice(e,r){return this.View.state.sliceDoc(e,r)}FindFirstChild(e,r,t){var i;for(let o of e.getChildren(r))if(null===(i=null==t?void 0:t(o))||void 0===i||i)return o;return null}AddTermToBracket(e,r){var t=r.node.getChildren("Identifier").map((e=>this.GetSlice(e.from,e.to).trim()));if(0==(e=e.filter((e=>-1==t.indexOf(e)))).length)return !1;let i=this.View.state.sliceDoc(r.from,r.to).includes("\n")?"\n":" ";var o=this.FindFirstChild(r,"CloseBracket").from;for(let r of e.reverse())this.ChangeCode({from:o,to:o,insert:r+i}),this.ChangeCode(indentRange(this.View.state,o,o+1+r.length));return !0}AppendGlobals(e,r){if(0==(r=[...new Set(r.filter((e=>-1==reserved.indexOf(e))))]).length)return !1;let t=GetCursorUntilMode(this.View.state);if(t){var i=this.FindFirstChild(t.node,e);if(i)return this.AddTermToBracket(r,i)}return this.ChangeCode({from:0,to:0,insert:`${e.toLowerCase()} [ ${r.join(" ")} ]\n`}),!0}AppendBreed(e,r,t){if("patches"==r||"patch"==t)return !1;r==t&&(t=getSingularName(r));for(let[e,i]of this.Galapagos.LintContext.Breeds)if(i.Plural==r||i.Singular==t||i.Singular==r||i.Plural==t)return !1;var i="breed";return e==BreedType.DirectedLink&&(i="directed-link-breed"),e==BreedType.UndirectedLink&&(i="undirected-link-breed"),this.ChangeCode({from:0,to:0,insert:`${i} [ ${r} ${t} ]\n`}),!0}AppendBreedVariables(e,r){if(0==(r=[...new Set(r.filter((e=>-1==reserved.indexOf(e))))]).length)return !1;let t=GetCursorInsideMode(this.View.state);if(t)for(;;){if("BreedsOwn"==t.node.name){var i=this.FindFirstChild(t.node,"Own");if(this.GetSlice(i.from,i.to).trim().toLowerCase()===e.toLowerCase()+"-own")return this.AddTermToBracket(r,t.node),!0}if(!t.nextSibling()||"Procedure"===t.node.name)break}return this.ChangeCode({from:0,to:0,insert:`${e.toLowerCase()}-own [ ${r.join(" ")} ]\n`}),!0}ReplaceProcedure(e,r,t){r=r.trim().toLowerCase(),syntaxTree(e.state).cursor().iterate((o=>{"Procedure"==o.name&&getCodeName(e.state,o)==r&&(o.from+t.length,e.dispatch({changes:{from:o.from,to:o.to,insert:t}}));}));}}

    const addBreedAction=function(e,o,t,n){var i;return e.actions=[...null!==(i=e.actions)&&void 0!==i?i:[],{name:Localized.Get("Add"),apply(e,i,a){new CodeEditing(e).AppendBreed(o,t,n);}}],e};const addGlobalsAction=function(e,o,t){var n;return e.actions=[...null!==(n=e.actions)&&void 0!==n?n:[],{name:Localized.Get("Add"),apply(e,n,i){new CodeEditing(e).AppendGlobals(o,t);}}],e};const removeAction=function(e){var o;return e.actions=[...null!==(o=e.actions)&&void 0!==o?o:[],{name:Localized.Get("Remove"),apply(e,o,t){e.dispatch({changes:{from:o,to:t,insert:""}});}}],e};const AddReplaceAction=function(e,o){var t;return e.actions=[...null!==(t=e.actions)&&void 0!==t?t:[],{name:Localized.Get("Replace"),apply(e,t,n){e.dispatch({changes:{from:t,to:n,insert:o}});}}],e};const explainAction=function(e,o){var t;return e.actions=[...null!==(t=e.actions)&&void 0!==t?t:[],{name:Localized.Get("Explain"),apply(t,n,i){var a=syntaxTree(t.state).resolve(n,-1);o(e,getNodeContext(t.state,a));}}],e};

    const buildToolTips=t=>hoverTooltip(((e,i,o)=>getTooltips(e,i,o,t)));function getTooltips(t,e,i,o){var n=getLintState(t.state).diagnostics;let s=[],a=2e8,l=0;if(n.between(e-(i<0?1:0),e+(i>0?1:0),((t,n,{spec:c})=>{var r;if(e>=t&&e<=n&&(t==n||(e>t||i>0)&&(e<n||i<0))){var g=c.diagnostic;g.actions=null!==(r=g.actions)&&void 0!==r?r:[],0===g.actions.length&&o.Options.OnExplain&&explainAction(g,o.Options.OnExplain),s.push(g),a=Math.min(t,a),l=Math.max(n,l);}})),0==s.length){var c=getTooltip(t,e,e,o);if(!c)return null;a=c.from,l=c.to,s.push(c);}return {pos:a,end:l,above:t.state.doc.lineAt(a).to<l,create:()=>({dom:diagnosticsTooltip(t,s)})}}function diagnosticsTooltip(t,e){return crelt("ul",{class:"cm-tooltip-lint"},e.map((e=>renderDiagnostic(t,e,!1))))}function assignKeys(t){let e=[];if(t)t:for(let{name:i}of t){for(let t=0;t<i.length;t++){let o=i[t];if(/[a-zA-Z]/.test(o)&&!e.some((t=>t.toLowerCase()==o.toLowerCase()))){e.push(o);continue t}}e.push("");}return e}function renderDiagnostic(t,e,i){var o;let n=i?assignKeys(e.actions):[];return crelt("li",{class:"cm-diagnostic cm-diagnostic-"+e.severity},crelt("span",{class:"cm-diagnosticText"},e.renderMessage?e.renderMessage():e.message),null===(o=e.actions)||void 0===o?void 0:o.map(((i,o)=>{let s=!1,a=o=>{if(o.preventDefault(),s)return;s=!0;let n=findDiagnostic(getLintState(t.state).diagnostics,e);n&&i.apply(t,n.from,n.to);},{name:l}=i,c=n[o]?l.indexOf(n[o]):-1,r=c<0?l:[l.slice(0,c),crelt("u",l.slice(c,c+1)),l.slice(c+1)];return crelt("button",{type:"button",class:"cm-diagnosticAction",onclick:a,onmousedown:a,"aria-label":` Action: ${l}${c<0?"":` (access key "${n[o]})"`}.`},r)})),e.source&&crelt("div",{class:"cm-diagnosticSource"},e.source))}function findDiagnostic(t,e=null,i=0){let o=null;return t.between(i,1e9,((t,i,{spec:n})=>{if(!e||n.diagnostic==e)return o=new SelectedDiagnostic(t,i,n.diagnostic),!1})),o}class SelectedDiagnostic{constructor(t,e,i){this.from=t,this.to=e,this.diagnostic=i;}}

    const lightTheme=EditorView.theme({"&.cm-editor":{height:"100%","&.cm-focused":{outline:"none"}},".cm-diagnostic":{fontSize:"0.9em",padding:"0.3em 0.5em"},".cm-tooltip-extendable":{cursor:"pointer"},".cm-tooltip-extendable:hover":{textDecoration:"underline"},".cm-editor.cm-focused":{outline:"none"},".cm-gutter-lint":{width:"3px"},".cm-gutter-lint .cm-gutterElement":{padding:"0"},".cm-lint-marker":{width:"100%",height:"100%"},".cm-lint-marker-error":{background:"#cc2200",content:"none"},".cm-lint-marker-warning":{background:"#FAD842",content:"none"},".cm-added":{textDecoration:"overline underline",textDecorationColor:"#117432",textDecorationThickness:"2px"},".cm-removed":{textDecoration:"overline underline",textDecorationColor:"#cc2200",textDecorationThickness:"2px"},".cm-gutters":{userSelect:"none",webkitUserSelect:"none",msUserSelect:"none"}});

    let primitives$4=PrimitiveManager,checker=generateChecker();const keyword=new ExternalTokenizer(((e,t)=>{let r="";for(;e.next>=255||checker[e.next];)r+=String.fromCharCode(e.next),e.advance();if(""!=r)if(r=r.toLowerCase(),t.context.extensionsGlobals||t.context.procedureName<2)e.acceptToken(Identifier);else if("set"==r)e.acceptToken(Set$1);else if("let"==r)e.acceptToken(Let);else if("to"==r||"to-report"==r)e.acceptToken(To);else if("end"==r)e.acceptToken(End);else if("and"==r||"or"==r||"xor"==r)e.acceptToken(AndOr);else if("globals"==r)e.acceptToken(GlobalStr);else if("extensions"==r)e.acceptToken(ExtensionStr);else if("foreach"==r)e.acceptToken(APCommand);else if("n-values"==r)e.acceptToken(APReporterFlip);else if("map"==r)e.acceptToken(APReporterVar);else if("reduce"==r||"filter"==r||"sort-by"==r)e.acceptToken(APReporter);else if(["+","*","/","^","=","!=",">","<","<=",">=","and","or","mod","in-radius","at-points","of","with","with-max","with-min"].indexOf(r)>-1)e.acceptToken(ReporterLeft1Args);else if("-"==r)e.acceptToken(ReporterLeft1ArgsOpt);else if("in-cone"==r)e.acceptToken(ReporterLeft2Args);else if("breed"==r){if(t.context.globalStatement)return void e.acceptToken(BreedStr);let r=0,o=!1,n=!1,i="";for(;r<100&&(isValidKeyword(e.peek(r))||!o);)isValidKeyword(e.peek(r))?(i+=String.fromCharCode(e.peek(r)),o=!0):91==e.peek(r)&&(n=!0),r++;n&&[...GetContext().PluralBreeds.keys()].includes(i.toLowerCase())?e.acceptToken(BreedStr):e.acceptToken(BreedToken);}else if("directed-link-breed"==r||"undirected-link-breed"==r)e.acceptToken(BreedStr);else if(-1!=turtleVars.indexOf(r))e.acceptToken(TurtleVar);else if(-1!=patchVars.indexOf(r))e.acceptToken(PatchVar);else if(-1!=linkVars.indexOf(r))e.acceptToken(LinkVar);else if(-1!=constants.indexOf(r))e.acceptToken(Constant);else {const t=PrimitiveManager.GetNamedPrimitive(r);if(null!=t)return void(PrimitiveManager.IsReporter(t)?e.acceptToken(Reporter):e.acceptToken(Command));const o=MatchBreed(r,GetContext());if(0!=o.Tag&&o.Valid)return void e.acceptToken(o.Tag);const n=matchCustomProcedure(r);if(0!=n)return void e.acceptToken(n);0!=o.Tag?e.acceptToken(o.Tag):r.match(/^create-[^\?]+$/i)?e.acceptToken(SpecialCommandCreateTurtlePossible):-1!=r.indexOf(":")&&-1==primitives$4.GetExtensions().indexOf(r.split(":")[0])?e.acceptToken(UnsupportedPrim):e.acceptToken(Identifier);}}));function isValidKeyword(e){return e>=160||35==e||33==e||37==e||39==e||63==e||e>=42&&e<=58||45==e||94==e||95==e||e>=60&&e<=90||94==e||95==e||e>=97&&e<=122}function generateChecker(){let e=[];for(var t=0;t<256;t++)e.push(isValidKeyword(t));return e}function matchCustomProcedure(e){let t=GetContext();return t.Commands.has(e)?SpecialCommand:t.Reporters.has(e)?SpecialReporter:0}

    const contextTracker=new ContextTracker({start:{extensionsGlobals:!1,globalStatement:!0,procedureName:2},shift:(e,t,o,r)=>{let n=0==r.pos||e.globalStatement,a=e.procedureName<2?e.procedureName+1:e.procedureName,l="";if(93==r.next)return r.advance(),{extensionsGlobals:!1,globalStatement:n,procedureName:a};for(;isValidKeyword(r.next);)l+=String.fromCharCode(r.next).toLowerCase(),r.advance();if(l=l.toLowerCase(),"extensions"==l||"globals"==l||"breed"==l||"directed-link-breed"==l||"undirected-link-breed"==l||l.endsWith("-own")){for(;32==r.next;)r.advance();if(91==r.next&&n)return {extensionsGlobals:!0,globalStatement:n,procedureName:a}}else {if("to"==l||"to-report"==l)return {extensionsGlobals:e.extensionsGlobals,globalStatement:!1,procedureName:0};if("end"==l)return {extensionsGlobals:e.extensionsGlobals,globalStatement:!0,procedureName:a}}return {extensionsGlobals:e.extensionsGlobals,globalStatement:n,procedureName:a}}});

    let primitives$3=PrimitiveManager;const specializeReporter=function(r){if("se"==(r=r.toLowerCase())||"list"==r||"sentence"==r||"word"==r)return Reporter2ArgsVar0;if("patch-set"==r||"link-set"==r||"turtle-set"==r)return Reporter1ArgsVar0;let e=primitives$3.GetPrimitive("",r);if(!e)return -1;{let r=!1,t=null==e?void 0:e.RightArgumentTypes.length;if(e.RightArgumentTypes.map((a=>{a.CanRepeat&&(r=!0,(null==e?void 0:e.DefaultOption)&&(t=null==e?void 0:e.DefaultOption));})),r){if(0==t)return Reporter0ArgsVar;if(1==t)return Reporter1ArgsVar;if(2==t)return Reporter2ArgsVar;if(3==t)return Reporter3ArgsVar;if(4==t)return Reporter4ArgsVar;if(5==t)return Reporter5ArgsVar;if(6==t)return Reporter6ArgsVar}else {if(0==t)return Reporter0Args;if(1==t)return Reporter1Args;if(2==t)return Reporter2Args;if(3==t)return Reporter3Args;if(4==t)return Reporter4Args;if(5==t)return Reporter5Args;if(6==t)return Reporter6Args}}},specializeSpecialReporter=function(r){r=r.toLowerCase();let e=GetContext().Reporters;if(e.has(r)){let t=e.get(r);return 0==t?SpecialReporter0Args:1==t?SpecialReporter1Args:2==t?SpecialReporter2Args:3==t?SpecialReporter3Args:4==t?SpecialReporter4Args:5==t?SpecialReporter5Args:6==t?SpecialReporter6Args:-1}},specializeCommand=function(r){if("ifelse"==(r=r.toLowerCase())||"if-else"==r)return Command3ArgsVar2;if("create-turtles"==r)return SpecialCommandCreateTurtle;if("create-links"==r)return SpecialCommandCreateLink;let e=primitives$3.GetPrimitive("",r);if(!e)return -1;{let r=!1,t=0,a=null==e?void 0:e.RightArgumentTypes.length;if(e.RightArgumentTypes.map((i=>{i.CanRepeat&&(r=!0,(null==e?void 0:e.DefaultOption)&&(a=null==e?void 0:e.DefaultOption)),i.Optional||(t+=1);})),r){if(0==a)return Command0ArgsVar;if(1==a)return Command1ArgsVar;if(2==a)return Command2ArgsVar;if(3==a)return Command3ArgsVar;if(4==a)return Command4ArgsVar;if(5==a)return Command5ArgsVar;if(6==a)return Command6ArgsVar}else {if(1==t&&2==a)return Command1_2ArgsOpt;if(0==a)return Command0Args;if(1==a)return Command1Args;if(2==a)return Command2Args;if(3==a)return Command3Args;if(4==a)return Command4Args;if(5==a)return Command5Args;if(6==a)return Command6Args}}},specializeSpecialCommand=function(r){r=r.toLowerCase();let e=GetContext().Commands;if(e.has(r)){let t=e.get(r);return 0==t?SpecialCommand0Args:1==t?SpecialCommand1Args:2==t?SpecialCommand2Args:3==t?SpecialCommand3Args:4==t?SpecialCommand4Args:5==t?SpecialCommand5Args:6==t?SpecialCommand6Args:-1}return -1};

    const parser=LRParser.deserialize({version:14,states:"&)jO$OQROOO&jQRO'#E]O+jQPO'#ElO+oQPO'#EmO+tQPO'#EnO+yQPO'#EqOOQQ'#Fe'#FeO,OQRO'#ErO1dQRO'#EtOOQQ'#E_'#E_O1qQROOO4{QRO'#E_O5fQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O8rQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O9]QRO'#E_O;lQRO'#E_O9]QRO'#E_OOQQ'#Eu'#EuOOQQ'#Ey'#EyO>kQRO'#EyOOQQ'#EY'#EYO?OQRO'#EXOOQQ'#EX'#EXO5sQRO'#FgO?aQRO'#E}OBPQRO'#FOOOQQ'#E|'#E|OOQQ'#EW'#EWODrQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWOLzQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWOMRQRO'#FVOOQQ'#FV'#FVO!#oQRO'#EVO!%xQRO'#FSOOQQ'#F_'#F_O!&iQRO'#FQQOQPOOO&jQRO'#E]O!(hQRO,5:wO!(yQRO,5:zO!)[QRO'#FcO!,ZQPO,5:{O!,`QPO,5;UO!,eQRO,5;WO!,mQRO,5;XO!,uQRO,5;YO!-QQRO,5;]O!-YQRO'#FXO!0}QRO'#FXO!1wQRO'#EfO!2SQRO'#EgOOQO'#Ef'#EfOOQQ'#Ek'#EkO!2rQRO'#EyOOQQ'#Ei'#EiO!3[QRO'#EiOOQQ'#Er'#ErO!6VQPO,5;PO!6[QRO'#F]O!9zQRO,5;`O!CsQRO,5;`O!EoQRO'#F^OOQQ'#F^'#F^O!HjQRO,5;dO!J{QRO,5;gO!K^QRO,5;fO5sQRO'#FdOOQQ,5:y,5:yO5fQRO,5:yO!KoQRO,5:yO!LQQRO'#E_O#)]QRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#*WQRO'#FWO#/|QRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#5dQRO'#EsOOQQ'#Eb'#EbO#8WQRO,5:yO5sQRO,5:yO#8_QRO,5<ROOQQ'#Fi'#FiOOQQ'#Fh'#FhODrQRO,5;iODrQRO,5;jO#=fQRO,5:rO#=vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#>WQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#EfQRO,5:rO#GmQRO'#EjO5sQRO'#FgOOQQ-E9T-E9TOOQQ'#FT'#FTO#GwQRO,5;nOOQQ'#FR'#FROOQQ-E9]-E9]O#I|QPO,5:xO#JRQRO1G0cO#MsQRO1G0fO$#eQRO,5;}OOQQ1G0g1G0gO$&YQRO1G0pOOQQ'#FZ'#FZO$&dQRO1G0rOOQQ1G0r1G0rO$&lQRO1G0sOOQQ1G0s1G0sOOQQ'#Eo'#EoO$&tQRO1G0tO$&|QRO1G0wOOQQ1G0w1G0wOOQQ'#FX'#FXOOQQ-E9V-E9VO$'UQRO,5;RO$,^QRO,5;RO!,uQRO,5;VO$-sQRO1G0kOOQQ'#F]'#F]OOQQ-E9Z-E9ZO$.TQRO'#EtOOQQ1G0z1G0zO$.[QRO'#EjO$1]QPO'#EkO$1bQRO'#EtOOQQ-E9[-E9[OOQQ1G1O1G1OOOQQ1G1R1G1ROOQQ1G1Q1G1QO$3sQRO,5<OO$4TQRO1G0eO#)]QRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eOOQQ-E9U-E9UO$4fQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO$5PQRO'#FXOOQQ'#FY'#FYO$5^QRO,5;_O$:kQRO'#F[O$=qQRO,5;_OOQQ,5;_,5;_O$=xQRO,5;_O$AuQRO'#EbO$DTQRO'#EbOOQQ1G0e1G0eO$GTQRO1G1lO$JmQRO'#ErO$J}QRO'#EXOOQQ1G1T1G1TOOQQ1G1U1G1UO$MwQRO1G0^O#=vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O$NXQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O%(YQRO'#EsO%/nQRO'#EyO%7SQRO'#EYOOQQ'#FP'#FPOOQQ1G0^1G0^O%7ZQPO,5;UO%7`QRO'#EgO%7kQRO1G1YOOQQ1G1Y1G1YO%7kQRO1G1YOOQQ1G0d1G0dOOQQ-E9X-E9XOOQQ7+&^7+&^OOQQ7+&_7+&_OOQO'#Ep'#EpO%9mQPO7+&`OOQQ7+&c7+&cOOQQ1G0m1G0mO$&tQRO1G0qO%9rQRO7+&VO%;tQRO7+&VOOQQ7+&V7+&VO%;{QRO7+&VOOQQ,5;`,5;`O%<^QRO,5:xO%<oQRO,5:xO%=QQRO'#F]O%@]QRO1G1jO%@tQRO7+&PO#)]QRO7+&PO#)vQRO7+&PO#)vQRO7+&PO%AVQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&POOQQ-E9W-E9WOOQQ1G0y1G0yOOQQ-E9Y-E9YO%DYQRO7+%xO#=vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO%DjQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO%JZQRO'#FYO%LuQRO,5;fO%L|QRO,5;_O& hQRO,5;_OOQQ1G0p1G0pO& yQRO,5;ROOQQ,5;R,5;ROOQQ7+&t7+&tO&!UQRO7+&tOOQQ<<Iz<<IzO&$WQPO7+&]OOQQ<<Iq<<IqOOQQ7+&P7+&PO&$]QRO<<IkO#)]QRO<<IkO#)vQRO<<IkO&$nQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO&'qQRO<<IdO#=vQRO<<IdO#)vQRO<<IdO&(RQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO&*yQRO1G0yOOQQ<<J`<<J`OOQQ<<Iw<<IwOOQQ<<Ik<<IkO&0oQROAN?VO#)]QROAN?VO&1QQROAN?VO#)vQROAN?VO&4TQROAN?OO#=vQROAN?OO&4eQROAN?OO#)vQROAN?OOOQQAN?VAN?VO&7]QROG24qO&7nQROG24qO&:qQROG24jO&;RQROG24jOOQQG24qG24qO&=yQRO'#E_O5sQRO'#E_O&CjQRO'#E_O&IvQRO'#E_O' jQRO'#E_O' qQRO'#E_O'$[QRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O!)[QRO'#EWO''cQRO'#EWO'*bQRO'#EWO'-aQRO'#EWO'0`QRO'#EWO'3_QRO'#EWO'3fQRO'#EWO'6dQRO'#EWO'6kQRO'#EWO'9fQRO'#FcO'<eQRO'#FcO5sQRO'#FcO'?dQRO'#FcO'BcQRO'#FcO'EbQRO'#FcO'HaQRO'#FcO'K`QRO'#FcO'N_QRO'#FcO(#^QRO'#FcO(&]QRO'#FcO()[QRO'#FcO(,ZQRO'#FcO(/YQRO'#FcO(2XQRO'#FcO(5WQRO'#FcO(8VQRO'#FXO(8^QRO'#FXO(9ZQRO'#FXO(=QQRO'#FXO5sQRO,5:yO'<eQRO,5:yO'?dQRO,5:yO'BcQRO,5:yO'EbQRO,5:yO'HaQRO,5:yO(@hQRO,5:yO'K`QRO,5:yO'N_QRO,5:yO(CgQRO,5:yO;lQRO,5:yO(FfQRO,5:yO(#^QRO,5:yO(IeQRO,5:yO(&]QRO,5:yO(LdQRO,5:yO()[QRO,5:yO(,ZQRO,5:yO) cQRO,5:yO)$bQRO,5:yO(2XQRO,5:yODrQRO,5:yO''cQRO,5:yO(5WQRO,5:yO(/YQRO,5:yO'-aQRO,5:yO'9fQRO,5:yO'0`QRO,5:yO)'aQRO,5:yO)*kQRO,5:yO)-nQRO,5:yO)3_QRO,5:yO)6UQRO,5:yO)8oQRO,5:yO)8vQRO,5:yO);vQRO,5:yO)>^QRO,5:yO)AWQRO,5:yO)DQQRO,5:yO)FwQRO,5:yO)IbQRO,5:yO)IiQRO,5:yO)LiQRO,5:yO* PQRO,5:yO* WQRO'#E_O#)vQRO,5:yO*!dQRO,5:yO*!tQRO,5:yO*#UQRO,5:yO*#fQRO,5:yO*#vQRO,5:yO*$WQRO,5:yO*$hQRO,5:yO*$xQRO,5:yO*%YQRO,5:yO*%jQRO,5:yO*%zQRO,5:yO*&[QRO,5:yO*&lQRO,5:yO*&|QRO,5:yO*'^QRO,5:yO*'nQRO,5:yO*(OQRO,5:yO*(`QRO,5:yO*(pQRO,5:yO*)QQRO,5:yO#=vQRO,5:yO*)bQRO,5:yO*)rQRO,5:yO**SQRO,5:yO**dQRO,5:yO**tQRO,5:yO*+UQRO,5:yO*+fQRO,5:yO*,lQRO,5:yO*/vQRO,5:yO*3QQRO,5:yO*6[QRO,5:yO#)vQRO,5:yO*8yQRO,5:yO5sQRO,5:yO*9QQRO,5<RO*9eQRO,5<RO*<PQRO,5<RO*>kQRO,5<RO*AYQRO,5<RO!)[QRO,5;iO''cQRO,5;iO'*bQRO,5;iO'-aQRO,5;iO'0`QRO,5;iO!)[QRO,5;jO''cQRO,5;jO'*bQRO,5;jO'-aQRO,5;jO'0`QRO,5;jO*CtQRO,5:rO*FoQRO,5:rO*IiQRO,5:rO*L`QRO,5:rO*NvQRO,5:rO+ ZQRO,5:rO$3sQRO,5:rO*)bQRO,5:rO+ zQRO,5:rO**dQRO,5:rO*+UQRO,5:rO+![QRO,5:rO+!cQRO,5:rO+%ZQRO,5:rO+(UQRO,5:rO5sQRO'#FgO5sQRO'#FgO5sQRO'#FgO5sQRO'#FgO5sQRO'#FgO+*yQRO1G0cO+2uQRO1G0fO+@sQRO1G0fO+AWQRO1G0fO+:qQRO1G0fO+DrQRO,5;}O+GsQRO,5;}O+JyQRO,5;}O,!gQRO,5;}O,%^QRO,5;}O,'wQRO,5;}O,(RQRO,5;}O,+OQRO,5;}O,-fQRO,5;}O,-pQRO,5;}O,.XQRO,5;}O,.cQRO,5;}O,.mQRO,5;}O,.wQRO,5;}O,/RQRO,5;}O,/`QRO,5;}O,/jQRO,5;}O,/tQRO1G0pO#)vQRO,5<OO*!dQRO,5<OO*!tQRO,5<OO*#UQRO,5<OO*#fQRO,5<OO*#vQRO,5<OO*$WQRO,5<OO*$hQRO,5<OO*$xQRO,5<OO*%YQRO,5<OO*(pQRO,5<OO*%zQRO,5<OO*&lQRO,5<OO*'^QRO,5<OO*(`QRO,5<OO,3hQRO1G0eO,6rQRO1G0eO,9uQRO1G0eO,?fQRO1G0eO,B]QRO1G0eO,DvQRO1G0eO,D}QRO1G0eO,G}QRO1G0eO,JeQRO1G0eO,M_QRO1G0eO-!XQRO1G0eO-%OQRO1G0eO-'iQRO1G0eO-'pQRO1G0eO-*pQRO1G0eO--WQRO1G0eO#)vQRO1G0eO*!dQRO1G0eO*!tQRO1G0eO*#UQRO1G0eO*#fQRO1G0eO*#vQRO1G0eO*$WQRO1G0eO*$hQRO1G0eO*$xQRO1G0eO*%YQRO1G0eO*%jQRO1G0eO*%zQRO1G0eO*&[QRO1G0eO*&lQRO1G0eO*&|QRO1G0eO*'^QRO1G0eO*'nQRO1G0eO*(OQRO1G0eO*(`QRO1G0eO*(pQRO1G0eO*)QQRO1G0eO#=vQRO1G0eO*)bQRO1G0eO*)rQRO1G0eO**SQRO1G0eO**dQRO1G0eO**tQRO1G0eO*+UQRO1G0eO--_QRO1G0eO-.eQRO1G0eO-1oQRO1G0eO-4yQRO1G0eO-8TQRO1G0eO#)vQRO1G0eO-;sQRO'#EbO->RQRO'#EbO-A]QRO'#EbO-C_QRO'#EbO-FiQRO'#EbO-IpQRO1G1lO-LhQRO1G1lO-L{QRO1G1lO-M`QRO1G1lO. vQRO1G1lO.!ZQRO1G1lO.!}QRO1G0^O.%xQRO1G0^O.(rQRO1G0^O.+iQRO1G0^O..PQRO1G0^O..dQRO1G0^O$3sQRO1G0^O*)bQRO1G0^O+ zQRO1G0^O**dQRO1G0^O*+UQRO1G0^O./TQRO1G0^O./[QRO1G0^O.2SQRO1G0^O.4}QRO1G0^O.<lQRO'#EyO.<sQRO'#EyO%(aQRO'#EyO.?bQRO'#EyO.GVQRO'#EYO.G^QRO'#EYO%/uQRO'#EYO.I{QRO'#EYO/ rQRO1G1jO/'cQRO1G1jO/*]QRO1G1jO/-SQRO1G1jO//mQRO1G1jO//tQRO1G1jO/2tQRO1G1jO/5[QRO1G1jO/5cQRO7+&PO/8mQRO7+&PO/;pQRO7+&PO/AaQRO7+&PO/DWQRO7+&PO/FqQRO7+&PO/FxQRO7+&PO/IxQRO7+&PO/L`QRO7+&PO0 YQRO7+&PO0$SQRO7+&PO0&yQRO7+&PO0)dQRO7+&PO0)kQRO7+&PO0,kQRO7+&PO0/RQRO7+&PO#)vQRO7+&PO*!dQRO7+&PO*!tQRO7+&PO*#UQRO7+&PO*#fQRO7+&PO*#vQRO7+&PO*$WQRO7+&PO*$hQRO7+&PO*$xQRO7+&PO*%YQRO7+&PO*%jQRO7+&PO*%zQRO7+&PO*&[QRO7+&PO*&lQRO7+&PO*&|QRO7+&PO*'^QRO7+&PO*'nQRO7+&PO*(OQRO7+&PO*(`QRO7+&PO*(pQRO7+&PO*)QQRO7+&PO#=vQRO7+&PO*)bQRO7+&PO*)rQRO7+&PO**SQRO7+&PO**dQRO7+&PO**tQRO7+&PO*+UQRO7+&PO0/YQRO7+&PO00`QRO7+&PO03jQRO7+&PO06tQRO7+&PO0:OQRO7+&PO#)vQRO7+&PO0<mQRO7+%xO0?hQRO7+%xO0BbQRO7+%xO0EXQRO7+%xO0GoQRO7+%xO0HSQRO7+%xO$3sQRO7+%xO*)bQRO7+%xO+ zQRO7+%xO**dQRO7+%xO*+UQRO7+%xO0HsQRO7+%xO0HzQRO7+%xO0KrQRO7+%xO0NmQRO7+%xO1#bQRO,5;_O1#iQRO,5;_O1&WQRO,5;_O1(oQRO,5;_O1+jQRO<<IkO1.tQRO<<IkO11wQRO<<IkO17hQRO<<IkO1:_QRO<<IkO1<xQRO<<IkO1=PQRO<<IkO1@PQRO<<IkO1BgQRO<<IkO1EaQRO<<IkO1HZQRO<<IkO1KQQRO<<IkO1MkQRO<<IkO1MrQRO<<IkO2!rQRO<<IkO2%YQRO<<IkO#)vQRO<<IkO*!dQRO<<IkO*!tQRO<<IkO*#UQRO<<IkO*#fQRO<<IkO*#vQRO<<IkO*$WQRO<<IkO*$hQRO<<IkO*$xQRO<<IkO*%YQRO<<IkO*%jQRO<<IkO*%zQRO<<IkO*&[QRO<<IkO*&lQRO<<IkO*&|QRO<<IkO*'^QRO<<IkO*'nQRO<<IkO*(OQRO<<IkO*(`QRO<<IkO*(pQRO<<IkO*)QQRO<<IkO#=vQRO<<IkO*)bQRO<<IkO*)rQRO<<IkO**SQRO<<IkO**dQRO<<IkO**tQRO<<IkO*+UQRO<<IkO2%aQRO<<IkO2&gQRO<<IkO2)qQRO<<IkO2,{QRO<<IkO20VQRO<<IkO#)vQRO<<IkO22tQRO<<IdO25oQRO<<IdO28iQRO<<IdO2;`QRO<<IdO2=vQRO<<IdO2>ZQRO<<IdO$3sQRO<<IdO*)bQRO<<IdO+ zQRO<<IdO**dQRO<<IdO*+UQRO<<IdO2>zQRO<<IdO2?RQRO<<IdO2AyQRO<<IdO2DtQRO<<IdO2GiQROAN?VO2JsQROAN?VO2MvQROAN?VO3%gQROAN?VO3(^QROAN?VO3*wQROAN?VO3+OQROAN?VO3.OQROAN?VO30fQROAN?VO33`QROAN?VO36YQROAN?VO39PQROAN?VO3;jQROAN?VO3;qQROAN?VO3>qQROAN?VO3AXQROAN?VO#)vQROAN?VO*!dQROAN?VO*!tQROAN?VO*#UQROAN?VO*#fQROAN?VO*#vQROAN?VO*$WQROAN?VO*$hQROAN?VO*$xQROAN?VO*%YQROAN?VO*%jQROAN?VO*%zQROAN?VO*&[QROAN?VO*&lQROAN?VO*&|QROAN?VO*'^QROAN?VO*'nQROAN?VO*(OQROAN?VO*(`QROAN?VO*(pQROAN?VO*)QQROAN?VO#=vQROAN?VO*)bQROAN?VO*)rQROAN?VO**SQROAN?VO**dQROAN?VO**tQROAN?VO*+UQROAN?VO3A`QROAN?VO3BfQROAN?VO3EpQROAN?VO3HzQROAN?VO3LUQROAN?VO#)vQROAN?VO3NsQROAN?OO4#nQROAN?OO4&hQROAN?OO4)_QROAN?OO4+uQROAN?OO4,YQROAN?OO$3sQROAN?OO*)bQROAN?OO+ zQROAN?OO**dQROAN?OO*+UQROAN?OO4,yQROAN?OO4-QQROAN?OO4/xQROAN?OO42sQROAN?OO45hQROG24qO48rQROG24qO4;uQROG24qO4AfQROG24qO4D]QROG24qO4FvQROG24qO4F}QROG24qO4I}QROG24qO4LeQROG24qO5 _QROG24qO5$XQROG24qO5'OQROG24qO5)iQROG24qO5)pQROG24qO5,pQROG24qO5/WQROG24qO5/_QROG24qO50eQROG24qO53oQROG24qO56yQROG24qO5:TQROG24qO5<rQROG24jO5?mQROG24jO5BgQROG24jO5E^QROG24jO5GtQROG24jO5HXQROG24jO5HxQROG24jO5IPQROG24jO5KwQROG24jO5NrQROG24jO6#gQROOO6#uQROOO6$TQROOO6$cQROOO6$qQROOO6%PQROOO6%_QROOO6%mQRO'#E_O!)[QRO'#E_O) cQRO'#E_O(,ZQRO'#E_O)$bQRO'#E_O()[QRO'#E_O(LdQRO'#E_O(2XQRO'#E_O(&]QRO'#E_O(IeQRO'#E_O''cQRO'#E_O(#^QRO'#E_O(FfQRO'#E_O(5WQRO'#E_O(/YQRO'#E_O'*bQRO'#E_O(CgQRO'#E_O'-aQRO'#E_O6%{QRO'#E_O'N_QRO'#E_O'9fQRO'#E_O'0`QRO'#E_O'K`QRO'#E_O(@hQRO'#E_O'HaQRO'#E_O'EbQRO'#E_ODrQRO'#E_O'BcQRO'#E_O;lQRO'#E_O'?dQRO'#E_O'<eQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O;lQRO'#E_O9]QRO'#E_O6(zQRO'#EyO6)_QRO'#EyO6)_QRO'#EyO?aQRO'#E}O?aQRO'#E}O?aQRO'#E}O?aQRO'#E}O?aQRO'#E}OBPQRO'#FOOBPQRO'#FOOBPQRO'#FOOBPQRO'#FOOBPQRO'#FOO6%{QRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO6)rQRO,5:wO6*TQRO,5:zO6*fQRO,5:zO6*wQRO,5:zO6+YQRO,5:zO!)[QRO'#FcO6+kQPO,5;UO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO5sQRO'#FdO!)[QRO,5:yO$3sQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO6+pQRO,5:yO6+wQRO,5:yO6,OQRO,5:yO6,VQRO,5:yO6,^QRO,5:yO5sQRO,5:yO5sQRO,5:yO5sQRO,5:yO5sQRO,5:yO5sQRO,5:yO6,eQRO,5<RO6%{QRO,5;iO6%{QRO,5;jO6.sQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO6/TQRO,5:rO6/_QRO,5:rO6/iQRO,5:rO6/sQRO,5:rO$3sQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO6.sQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O6/}QRO'#EsO60UQRO'#EsO60]QRO'#EsO60dQRO'#EsO$3sQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO6.sQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO$3sQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO6.sQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO$3sQROAN?VO#)vQROAN?VO#)vQROAN?VO#)vQROAN?VO#)vQROAN?VO#)vQROAN?VO6.sQROAN?OO#)vQROAN?OO#)vQROAN?OO#)vQROAN?OO#)vQROAN?OO'*bQRO,5:yO6%{QRO,5:yO60kQRO,5:yO60rQRO,5:yO60yQRO,5:yO61QQRO,5:yO61XQRO,5:yO61fQRO,5:yO61mQRO,5:yO61tQRO,5:yO61{QRO,5:yO62SQRO,5:yO62ZQRO,5:yO62bQRO,5:yO62oQRO,5:yO62vQRO,5:yO+ zQRO,5:yO6.sQRO,5:yO62}QRO1G0eO63UQRO1G0eO63]QRO1G0eO63dQRO1G0eO63kQRO1G0eO63xQRO1G0eO64PQRO1G0eO64WQRO1G0eO64_QRO1G0eO64fQRO1G0eO64mQRO1G0eO64tQRO1G0eO65RQRO1G0eO65YQRO1G0eO+ zQRO1G0eO6.sQRO1G0eO65aQRO1G1jO65hQRO1G1jO65oQRO1G1jO65vQRO1G1jO65}QRO1G1jO66[QRO1G1jO66cQRO1G1jO66jQRO7+&PO66qQRO7+&PO66xQRO7+&PO67PQRO7+&PO67WQRO7+&PO67eQRO7+&PO67lQRO7+&PO67sQRO7+&PO67zQRO7+&PO68RQRO7+&PO68YQRO7+&PO68aQRO7+&PO68nQRO7+&PO68uQRO7+&PO+ zQRO7+&PO6.sQRO7+&PO68|QRO<<IkO69TQRO<<IkO69[QRO<<IkO69cQRO<<IkO69jQRO<<IkO69wQRO<<IkO6:OQRO<<IkO6:VQRO<<IkO6:^QRO<<IkO6:eQRO<<IkO6:lQRO<<IkO6:sQRO<<IkO6;QQRO<<IkO6;XQRO<<IkO+ zQRO<<IkO6.sQRO<<IkO6;`QROAN?VO6;gQROAN?VO6;nQROAN?VO6;uQROAN?VO6;|QROAN?VO6<ZQROAN?VO6<bQROAN?VO6<iQROAN?VO6<pQROAN?VO6<wQROAN?VO6=OQROAN?VO6=VQROAN?VO6=dQROAN?VO6=kQROAN?VO+ zQROAN?VO6.sQROAN?VO6=rQROG24qO6=yQROG24qO6>QQROG24qO6>XQROG24qO6>`QROG24qO6>mQROG24qO6>tQROG24qO6>{QROG24qO6?SQROG24qO6?ZQROG24qO6?bQROG24qO6?iQROG24qO6?vQROG24qO6?}QROG24qO&jQRO'#E]O&jQRO'#E]O&jQRO'#E]O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O9]QRO'#E_O;lQRO'#E_O;lQRO'#E_O;lQRO'#E_O;lQRO'#E_O;lQRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O9]QRO'#E_O?aQRO'#E}OBPQRO'#FOO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO&jQRO'#E]O&jQRO'#E]O#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IkO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO#)vQRO<<IdO5sQRO'#E_O5sQRO'#E_O9]QRO'#E_O9]QRO'#E_O#)vQRO,5:yO#)vQRO,5:yO#)vQRO1G0eO#)vQRO1G0eO#)vQRO7+&PO#)vQRO7+&PO#)vQRO<<IkO#)vQRO<<IkO5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+&PO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO#)vQRO7+%xO5sQRO'#E_O5sQRO'#E_O#)vQRO,5:yO#)vQRO,5:yO#)vQRO1G0eO#)vQRO1G0eO#)vQRO7+&PO#)vQRO7+&PO5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0eO#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O#)vQRO1G0^O5sQRO'#E_O5sQRO'#E_O#)vQRO,5:yO#)vQRO,5:yO#)vQRO1G0eO#)vQRO1G0eO5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:yO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO#)vQRO,5:rO5sQRO'#E_O5sQRO'#E_O#)vQRO,5:yO#)vQRO,5:yO5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#E_O5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#EWO5sQRO'#E_O5sQRO'#E_",stateData:"6@U~O$UOS!wOS~O[mO_mO`mOamOblOfmOijOjkOkiOo[OpXOq[Or]OsXOt[OuXOwXOx[Oy]Oz^O{_O|`O}aO!ObO!PcO!QdO!ReO!SfO!TgO!UhO!VdO!WcO!XXO!Y[O!Z]O![^O!]_O!^`O!_aO#WWO#jlO#klO~OSROTQOUSOVTOWtOXsOY!YOcvOh!UOlZOmrOnrOvnO!`vO!awO!bxO!cyO!dzO!e{O!f|O!g}O!h!OO!i!PO!j!QO!k!RO!l!SO!m!TO!n!QO!orO!pvO!qwO!rxO!syO!tzO!u{O!v|O#OPO$S#tP~PYOP!aOR!aOW4{OX4vO[mO_mO`mOamOblOcvOfmOh={OijOjkOk=dOlZOm*tOn*tOo2vOpXOq2vOr<oOsXOt2vOuXOv4sOwXOx2vOy<oOzAgO{DwO|GWO}HfO!ObO!PcO!QdO!ReO!SfO!TgO!UhO!VdO!WcO!XXO!Y2vO!Z<oO![AgO!]DwO!^GWO!_HfO!`vO!a'oO!b5RO!c=rO!dB]O!eEmO!fG|O!g'tO!h5WO!i=wO!jBbO!kErO!lHRO!mHmO!nBbO!o*tO!pvO!q'oO!r5RO!s=rO!tB]O!uEmO!vG|O#O!^O#WWO#jlO#klO~O#W!dO~O#W!eO~O#W!fO~O#W!gO~OP#fXQ#fXR#fXg#fX$S#xX~OSROTQOUSOVTOW5POX4zO_mO`mOamOblOcvOf!nOh>OOijOjkOk=dOm*uOn*uOo2vOpXOq2vOr<oOsXOt2vOuXOv4uOwXOx2vOy<oOzAgO{DwO|GWO}HfO!ObO!PcO!QdO!ReO!SfO!TgO!UhO!VdO!WcO!XXO!Y2vO!Z<oO![AgO!]DwO!^GWO!_HfO!`vO!a'sO!b5VO!c=vO!dBaO!eEqO!fHQO!g'wO!h5ZO!i=zO!jBeO!kEuO!lHUO!mHpO!nBeO!o*uO!pvO!q'sO!r5VO!s=vO!tBaO!uEqO!vHQO#O<lO#W!kO#jlO#klO#[#YP~O[!hOl!iO#V!uO~P,aOP'xOQ!{OR'xOg!}O~OP#RXP#mXQ#RXQ#mXR#RXR#mXS!zXT!zXU!zXV!zXW!zXX!zXc!zXg#RXg#mXh!zXl!zXm!zXn!zXv!zX!`!zX!a!zX!b!zX!c!zX!d!zX!e!zX!f!zX!g!zX!h!zX!i!zX!j!zX!k!zX!l!zX!m!zX!n!zX!o!zX!p!zX!q!zX!r!zX!s!zX!t!zX!u!zX!v!zX#O!zX~OY!zX$S!zX$S#RX$S#mX!}!zX!}#RX!}#mX~P2POl#POvmO#O!^O~PYO[mO_mO`mOamOblOfmOi4qOj4rOk4TOl#POo'cOpXOq'cOr3fOsXOt'cOuXOvmOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~OP#RXQ#RXR#RXg#RX$S#RX!}#RX#V#RX~P5sOP#_OQ#_OR#_O[#_Oo#_Op#_Oq#_Or#_Os#_Ot#_Ou#_Ow#_Ox#_Oy#_Oz#_O{#_O|#_O}#_O!O#_O!P#_O!Q#_O!R#_O!S#_O!T#_O!U#_O!V#_O!W#_O!X#_O!Y#_O!Z#_O![#_O!]#_O!^#_O!_#_O#W#^O~O[mO_mO`mOamOblOfmOi=gOj=lOk4_Ol#POo3cOpXOq3cOr3pOsXOt3cOuXOvmOwXOx3cOy3pOz<zO{ArO|ESO}GcO!O'dO!P'mO!Q=`O!RBWO!SEhO!TGwO!UHiO!V=`O!W'mO!XXO!Y3cO!Z3pO![<zO!]ArO!^ESO!_GcO#O>PO#WWO#jlO#klO~OP#mXQ#mXR#mXg#mX$S#mX~P5sOP!{XQ!{XR!{Xg!{X$S#xX~OP#cOQ#cOR#cO[#dO_#dO`#dOa#dOl#dOv#dOw#cOx#cOy#cOz#cO{#cO|#cO}#cO!O#cO!P#cO!Q#cO!R#cO!S#cO!T#cO!U#cO!V#cO!W#cO!`#cO!a#cO!b#cO!c#cO!d#cO!e#cO!f#cO!g#cO!h#cO!i#cO!j#cO!k#cO!l#cO!m#cO!n#cO~OP#cOQ#cOR#cO[mO_mO`mOamOfmOlmOvmOw#cOx#cOy#cOz#cO{#cO|#cO}#cO!O#cO!P#cO!Q#cO!R#cO!S#cO!T#cO!U#cO!V#cO!W#cO!`#cO!a#cO!b#cO!c#cO!d#cO!e#cO!f#cO!g#cO!h#cO!i#cO!j#cO!k#cO!l#cO!m#cO!n#cO~O[mO_mO`mOamOblOfmOi=fOj=kOk4jOl#POo3aOpXOq3aOr3{OsXOt3aOuXOvmOwXOx3aOy3{Oz=VO{A}O|E_O}GnO!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y3aO!Z3{O![=VO!]A}O!^E_O!_GnO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klOS!zXT!zXU!zXV!zXW!zXX!zXY!zXc!zXh!zXl!zXm!zXn!zXv!zX!`!zX!a!zX!b!zX!c!zX!d!zX!e!zX!f!zX!g!zX!h!zX!i!zX!j!zX!k!zX!l!zX!m!zX!n!zX!o!zX!p!zX!q!zX!r!zX!s!zX!t!zX!u!zX!v!zX$S!zX~O#O!zX~PGqOS#uXT#uXU#uXV#uXW#uXW#yXX#uXX#yXY#uXc#uXc#yXh#uXh#yXl#uXl#yXm#uXm#yXn#uXn#yXv#uXv#yX!`#uX!`#yX!a#uX!a#yX!b#uX!b#yX!c#uX!c#yX!d#uX!d#yX!e#uX!e#yX!f#uX!f#yX!g#uX!g#yX!h#uX!h#yX!i#uX!i#yX!j#uX!j#yX!k#uX!k#yX!l#uX!l#yX!m#uX!m#yX!n#uX!n#yX!o#uX!o#yX!p#uX!p#yX!q#uX!q#yX!r#uX!r#yX!s#uX!s#yX!t#uX!t#yX!u#uX!u#yX!v#uX!v#yX#O#yX$S#uX$S#yX~OW=pOX=oOcvOh!UOlvOm#uOn#uOv#uO!`vO!a5QO!b=qO!cB[O!dElO!eG{O!fHlO!g}O!h!OO!i!PO!j!QO!k!RO!l!SO!m!TO!n!QO!o#uO!pvO!q5QO!r=qO!sB[O!tElO!uG{O!vHlO#O#tO$S!yX~O[#wO~OSROTQOUSOVTOcvOlvO!`vO!pvO~OW5OOX4yOY!YOh=}Om*qOn*qOv*qO!a'rO!b5UO!c=uO!dB`O!eEpO!fHPO!g'vO!h5YO!i=yO!jBdO!kEtO!lHTO!mHoO!nBdO!o*qO!q'rO!r5UO!s=uO!tB`O!uEpO!vHPO$S#tX~P!%}O!}#|OP!{XQ!{XR!{Xg!{X~O!}#}OP#fXQ#fXR#fXg#fX~O[mO_mO`mOamOblOfmOijOjkOk=dOl#POo2vOpXOq2vOr<oOsXOt2vOuXOvmOwXOx2vOy<oOzAgO{DwO|GWO}HfO!ObO!PcO!QdO!ReO!SfO!TgO!UhO!VdO!WcO!XXO!Y2vO!Z<oO![AgO!]DwO!^GWO!_HfO#O!^O#WWO#jlO#klO~O!}$PO~O!}$QO~O[$RO#V$TO~O[$RO#V$VO~O[$WOw$WO!Y$WO~O[$RO#V$ZO~OP#mXQ#mXR#mXS$QXT$QXU$QXV$QXW$QXX$QX[#{X[$PX[$QXb$PXb$QXc$QXf$QXg#mXh$QXl#{Xl$QXm$QXn$QXv$QX!`$QX!a$QX!b$QX!c$QX!d$QX!e$QX!f$QX!g$QX!h$QX!i$QX!j$QX!k$QX!l$QX!m$QX!n$QX!o$QX!p$QX!q$QX!r$QX!s$QX!t$QX!u$QX!v$QX#O$QX#V#mX#V$PX#V$QX#W$PX#W$QX#[#{X#j$PX#j$QX#k$PX#k$QX~O[!zX[#{Xb!zXf!zXl#{X#V!zX#V#RX#V#mX#W!zX#[#{X#j!zX#k!zX~P2PO[$[Ol$[O#[#YX~O[(YOl(ZO#V$_O~P,aOP#mXQ#mXR#mXg#mX#V#mX~O#W$`O~P!2aOP!|XQ!|XR!|Xg!|X#V!|X~OS#]XT#]XU#]XV#]XW#]XX#]X[#]Xb#]Xc#]Xf#]Xh#]Xl#]Xm#]Xn#]Xv#]X!`#]X!a#]X!b#]X!c#]X!d#]X!e#]X!f#]X!g#]X!h#]X!i#]X!j#]X!k#]X!l#]X!m#]X!n#]X!o#]X!p#]X!q#]X!r#]X!s#]X!t#]X!u#]X!v#]X#O#]X#V#]X#W#]X#j#]X#k#]X~P!2yO#[$aO~OS$QXT$QXU$QXV$QXW$QXX$QX[$PX[$QXb$PXb$QXc$QXf$QXh$QXl$QXm$QXn$QXv$QX!`$QX!a$QX!b$QX!c$QX!d$QX!e$QX!f$QX!g$QX!h$QX!i$QX!j$QX!k$QX!l$QX!m$QX!n$QX!o$QX!p$QX!q$QX!r$QX!s$QX!t$QX!u$QX!v$QX#O$QX#V$PX#V$QX#W$PX#W$QX#j$PX#j$QX#k$PX#k$QX~P!2yO[$bOblO#W$dO#jlO#klO~O#V$eO~P!9iOP#haP#laQ#haQ#laR#haR#lag#hag#la[#ha[#la_#ha_#la`#ha`#laa#haa#lab#hab#laf#haf#lai#hai#laj#haj#lak#hak#lal#hal#lao#hao#lap#hap#laq#haq#lar#har#las#has#lat#hat#lau#hau#lav#hav#law#haw#lax#hax#lay#hay#laz#haz#la{#ha{#la|#ha|#la}#ha}#la!O#ha!O#la!P#ha!P#la!Q#ha!Q#la!R#ha!R#la!S#ha!S#la!T#ha!T#la!U#ha!U#la!V#ha!V#la!W#ha!W#la!X#ha!X#la!Y#ha!Y#la!Z#ha!Z#la![#ha![#la!]#ha!]#la!^#ha!^#la!_#ha!_#la#O#ha#O#la#W#ha#W#la#j#ha#j#la#k#ha#k#lam#ham#lan#han#la!`#ha!`#la!a#ha!a#la!b#ha!b#la!c#ha!c#la!d#ha!d#la!e#ha!e#la!f#ha!f#la!g#ha!g#la!h#ha!h#la!i#ha!i#la!j#ha!j#la!k#ha!k#la!l#ha!l#la!m#ha!m#la!n#ha!n#la!p#ha!p#la!q#ha!q#la!r#ha!r#la!s#ha!s#la!t#ha!t#la!u#ha!u#la!v#ha!v#lae#hae#la~O$S#ha$S#la!}#ha!}#laS#haS#laT#haT#laU#haU#laV#haV#laW#haW#laX#haX#laY#haY#lac#hac#lah#hah#la!o#ha!o#la#V#ha#V#laZ#haZ#la~P!:ROS$QXT$QXU$QXV$QXW$QXX$QX[$QXb$QXc$QXf$QXh$QXl$QXm$QXn$QXv$QX!`$QX!a$QX!b$QX!c$QX!d$QX!e$QX!f$QX!g$QX!h$QX!i$QX!j$QX!k$QX!l$QX!m$QX!n$QX!o$QX!p$QX!q$QX!r$QX!s$QX!t$QX!u$QX!v$QX#O$QX#V$QX#W$QX#j$QX#k$QX~P!2yOW5POX4zO[!wOblOf$gOh>OOm*uOn*uOv*uO!a'sO!b5VO!c=vO!dBaO!eEqO!fHQO!g'wO!h5ZO!i=zO!jBeO!kEuO!lHUO!mHpO!nBeO!o*uO!q'sO!r5VO!s=vO!tBaO!uEqO!vHQO#O$fO#V$jO#W$hO#jlO#klO~P!%}O#V$kOP!|XQ!|XR!|Xg!|X~O#V$lOP!{XQ!{XR!{Xg!{X~OP'xOQ!{OR'xOg#Ra$S#Ra~OP#RXQ#RXR#RXg#RX$S#RX$S#mX[#RX[#mX_#RX_#mX`#RX`#mXa#RXa#mXb#RXb#mXf#RXf#mXi#RXi#mXj#RXj#mXk#RXk#mXl#RXl#mXo#RXo#mXp#RXp#mXq#RXq#mXr#RXr#mXs#RXs#mXt#RXt#mXu#RXu#mXv#RXv#mXw#RXw#mXx#RXx#mXy#RXy#mXz#RXz#mX{#RX{#mX|#RX|#mX}#RX}#mX!O#RX!O#mX!P#RX!P#mX!Q#RX!Q#mX!R#RX!R#mX!S#RX!S#mX!T#RX!T#mX!U#RX!U#mX!V#RX!V#mX!W#RX!W#mX!X#RX!X#mX!Y#RX!Y#mX!Z#RX!Z#mX![#RX![#mX!]#RX!]#mX!^#RX!^#mX!_#RX!_#mX#O#RX#O#mX#W#RX#W#mX#j#RX#j#mX#k#RX#k#mXS#RXS#mXT#RXT#mXU#RXU#mXV#RXV#mXW#RXW#mXX#RXX#mXY#RXY#mXc#RXc#mXh#RXh#mXm#RXm#mXn#RXn#mX!`#RX!`#mX!a#RX!a#mX!b#RX!b#mX!c#RX!c#mX!d#RX!d#mX!e#RX!e#mX!f#RX!f#mX!g#RX!g#mX!h#RX!h#mX!i#RX!i#mX!j#RX!j#mX!k#RX!k#mX!l#RX!l#mX!m#RX!m#mX!n#RX!n#mX!o#RX!o#mX!p#RX!p#mX!q#RX!q#mX!r#RX!r#mX!s#RX!s#mX!t#RX!t#mX!u#RX!u#mX!v#RX!v#mXe#RXe#mX!}#RX!}#mX#V#RXZ#RXZ#mX~P!2aOP'zOQ5cOR'zOg(^Ol#POvmO#O!^O~PYOP'zOQ5cOR'zOg(^O~P5sOP'zOQ5cOR'zOg(^O[#zX_#zX`#zXa#zXb#zXf#zXi#zXj#zXk#zXl#zXo#zXp#zXq#zXr#zXs#zXt#zXu#zXv#zXw#zXx#zXy#zXz#zX{#zX|#zX}#zX!O#zX!P#zX!Q#zX!R#zX!S#zX!T#zX!U#zX!V#zX!W#zX!X#zX!Y#zX!Z#zX![#zX!]#zX!^#zX!_#zX#O#zX#W#zX#j#zX#k#zX$S#zXS#zXT#zXU#zXV#zXW#zXX#zXY#zXc#zXh#zXm#zXn#zX!`#zX!a#zX!b#zX!c#zX!d#zX!e#zX!f#zX!g#zX!h#zX!i#zX!j#zX!k#zX!l#zX!m#zX!n#zX!o#zX!p#zX!q#zX!r#zX!s#zX!t#zX!u#zX!v#zXe#zX!}#zX#V#zXZ#zX~OP#RaQ#RaR#Rag#Ra$S#Ra!}#Ra#V#Ra~P5sOSROTQOUSOVTOW4}OX4xO_mO`mOamOblOcvOf!nOh=|Oi4qOj4rOk4TOm*rOn*rOo'cOpXOq'cOr3fOsXOt'cOuXOv4tOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO!`vO!a'qO!b5TO!c=tO!dB_O!eEoO!fHOO!g'uO!h5XO!i=xO!jBcO!kEsO!lHSO!mHnO!nBcO!o*rO!pvO!q'qO!r5TO!s=tO!tB_O!uEoO!vHOO#O<nO#jlO#klO~O[$yOl(]O#V%OO#W!kO#[#YP~P#0gOP%QOR%QO[#_Og(hOo#_Op#_Oq#_Or#_Os#_Ot#_Ou#_Ow#_Ox#_Oy#_Oz#_O{#_O|#_O}#_O!O#_O!P#_O!Q#_O!R#_O!S#_O!T#_O!U#_O!V#_O!W#_O!X#_O!Y#_O!Z#_O![#_O!]#_O!^#_O!_#_O#W#^O~OQ%RO~P#5wOP'zOQ5cOR'zOg(^OS$ZaT$ZaU$ZaV$ZaW$ZaX$ZaY$Zac$Zah$Zam$Zan$Za!`$Za!a$Za!b$Za!c$Za!d$Za!e$Za!f$Za!g$Za!h$Za!i$Za!j$Za!k$Za!l$Za!m$Za!n$Za!o$Za!p$Za!q$Za!r$Za!s$Za!t$Za!u$Za!v$Za$S$Za~PDrOS!zaT!zaU!zaV!zaW!zaX!zaY!zac!zah!zal!zam!zan!zav!za!`!za!a!za!b!za!c!za!d!za!e!za!f!za!g!za!h!za!i!za!j!za!k!za!l!za!m!za!n!za!o!za!p!za!q!za!r!za!s!za!t!za!u!za!v!za#O!za$S!za~OP(XOQ5pOR(XOg(sO~P#:|OP'zOQ5cOR'zOg(^O~PDrO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO~P#:|O_mO`mOamOblOe%gOfmOi4qOj4rOk4TOl#POm%gOn%gOo'cOpXOq'cOr3fOsXOt'cOuXOvmOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO!`%gO!a%gO!b%gO!c%gO!d%gO!e%gO!f%gO!g%gO!h%gO!i%gO!j%gO!k%gO!l%gO!m%gO!n%gO!p%gO!q%gO!r%gO!s%gO!t%gO!u%gO!v%gO#O>PO#jlO#klO~O[%eO#W%dO~P#AOOW4{OX4vOcvOh={Om*tOn*tO!`vO!a'oO!b5RO!c=rO!dB]O!eEmO!fG|O!g'tO!h5WO!i=wO!jBbO!kErO!lHRO!mHmO!nBbO!o*tO!pvO!q'oO!r5RO!s=rO!tB]O!uEmO!vG|O~OlvOv*tO~P#EpOW4|OX4wOZ%lOf$gOh=|Om*sOn*sOv*sO!a'pO!b5SO!c=sO!dB^O!eEnO!fG}O!g'uO!h5XO!i=xO!jBcO!kEsO!lHSO!mHnO!nBcO!o*sO!q'pO!r5SO!s=sO!tB^O!uEnO!vG}O#O$fO#W%jO~P!%}O!}%nO~OP#PiP#QiQ#PiQ#QiR#PiR#Qig#Pig#Qi$S#Pi$S#Qi!}#Pi!}#QiS#QiT#QiU#QiV#QiW#QiX#Qi[#Qib#Qic#Qif#Qih#Qil#Qim#Qin#Qiv#Qi!`#Qi!a#Qi!b#Qi!c#Qi!d#Qi!e#Qi!f#Qi!g#Qi!h#Qi!i#Qi!j#Qi!k#Qi!l#Qi!m#Qi!n#Qi!o#Qi!p#Qi!q#Qi!r#Qi!s#Qi!t#Qi!u#Qi!v#Qi#O#Qi#V#Pi#V#Qi#W#Qi#j#Qi#k#Qi~OP#QiP#SiQ#QiQ#SiR#QiR#Sig#Qig#Si$S#Qi$S#Si!}#Qi!}#SiS#QiT#QiU#QiV#QiW#QiX#Qi[#Qib#Qic#Qif#Qih#Qil#Qim#Qin#Qiv#Qi!`#Qi!a#Qi!b#Qi!c#Qi!d#Qi!e#Qi!f#Qi!g#Qi!h#Qi!i#Qi!j#Qi!k#Qi!l#Qi!m#Qi!n#Qi!o#Qi!p#Qi!q#Qi!r#Qi!s#Qi!t#Qi!u#Qi!v#Qi#O#Qi#V#Qi#V#Si#W#Qi#j#Qi#k#Qi~OP5aOQ!{OR5aOg5rO!}$Va~OP#QiQ#QiR#QiW#^iX#^ic#^ig#Qih#^il#^im#^in#^iv#^i!`#^i!a#^i!b#^i!c#^i!d#^i!e#^i!f#^i!g#^i!h#^i!i#^i!j#^i!k#^i!l#^i!m#^i!n#^i!o#^i!p#^i!q#^i!r#^i!s#^i!t#^i!u#^i!v#^i#O#^i~O$S#Qi$S#^i~P$#vO[$RO#V%pO~O[$RO#V%qO~O[%rO!Y%rO~O[$RO#V%tO~O[$[Ol$[O#V%uO#[#YX~OP#haP#laQ#haQ#laR#haR#la[#ha[#lab#hab#laf#haf#lag#hag#lal#hal#lam#ham#lan#han#lav#hav#la!`#ha!`#la!a#ha!a#la!b#ha!b#la!c#ha!c#la!d#ha!d#la!e#ha!e#la!f#ha!f#la!g#ha!g#la!h#ha!h#la!i#ha!i#la!j#ha!j#la!k#ha!k#la!l#ha!l#la!m#ha!m#la!n#ha!n#la!p#ha!p#la!q#ha!q#la!r#ha!r#la!s#ha!s#la!t#ha!t#la!u#ha!u#la!v#ha!v#la#O#ha#O#la#W#ha#W#la#j#ha#j#la#k#ha#k#la~OS#haS#laT#haT#laU#haU#laV#haV#laW#haW#laX#haX#lac#hac#lah#hah#la!o#ha!o#la#V#ha#V#la#[#Za~P$'dO[mOl'bO#V%yO#WWO~P#0gO#V%{O~P!9iO[mO_mO`mOamOblOfmOijOjkOk=dOlZOo2vOpXOq2vOr<oOsXOt2vOuXOv4sOwXOx2vOy<oOzAgO{DwO|GWO}HfO!ObO!PcO!QdO!ReO!SfO!TgO!UhO!VdO!WcO!XXO!Y2vO!Z<oO![AgO!]DwO!^GWO!_HfO#O!^O#WWO#jlO#klO~P#EpO#W$`O~OW5POX4zO[&OOblOf$gOh>OOm*uOn*uOv*uO!a'sO!b5VO!c=vO!dBaO!eEqO!fHQO!g'wO!h5ZO!i=zO!jBeO!kEuO!lHUO!mHpO!nBeO!o*uO!q'sO!r5VO!s=vO!tBaO!uEqO!vHQO#O$fO#V!uO#W$hO#jlO#klO~P!%}OP'zOQ5cOR'zOg(^O~P!)[OP'xOQ!{OR'xOg#Ri$S#Ri~OP#RiQ#RiR#Rig#Ri$S#Ri!}#Ri#V#Ri~P5sO[#{Xl#{X#[#{X~P!2aOW4}OX4xOf$gOh=|Om*rOn*rOv*rO!a'qO!b5TO!c=tO!dB_O!eEoO!fHOO!g'uO!h5XO!i=xO!jBcO!kEsO!lHSO!mHnO!nBcO!o*rO!q'qO!r5TO!s=tO!tB_O!uEoO!vHOO#O$fO#V&ZO~P!%}OP!{XQ!{XR!{X[$OX_$OX`$OXa$OXb$OXf$OXg!{Xi$OXj$OXk$OXl$OXo$OXp$OXq$OXr$OXs$OXt$OXu$OXv$OXw$OXx$OXy$OXz$OX{$OX|$OX}$OX!O$OX!P$OX!Q$OX!R$OX!S$OX!T$OX!U$OX!V$OX!W$OX!X$OX!Y$OX!Z$OX![$OX!]$OX!^$OX!_$OX#O$OX#W$OX#j$OX#k$OX~O#V$OX~P$7`O[mO_mO`mOamOblOfmOi4qOj4rOk4TOl)[Oo'cOpXOq'cOr3fOsXOt'cOuXOvmOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>QO#WWO#jlO#klO~O#V&ZO~P$:rO#V&ZOP!{XQ!{XR!{Xg!{X~O[mO_mO`mOamOblOfmOpXOsXOuXOwXO!XXO#O>PO#WWO#jlO#klOP#UXQ#UXR#UXg#UX$S#UXS#UXT#UXU#UXV#UXW#UXX#UXY#UXc#UXh#UXm#UXn#UX!`#UX!a#UX!b#UX!c#UX!d#UX!e#UX!f#UX!g#UX!h#UX!i#UX!j#UX!k#UX!l#UX!m#UX!n#UX!o#UX!p#UX!q#UX!r#UX!s#UX!t#UX!u#UX!v#UX~Oi=gOj=lOk4mOl#POo3TOq3TOr4OOt3TOvmOx3TOy4OOz=YO{BQO|EbO}GqO!O'dO!P'mO!Q=`O!RBWO!SEhO!TGwO!UHiO!V=`O!W'mO!Y3TO!Z4OO![=YO!]BQO!^EbO!_GqO!}#UX#V#UXe#UXZ#UX~P$>ZOP#UXQ#UXR#UXg#UX$S#UX!}#UX#V#UX~P5sOS$YiT$YiU$YiV$YiW$YiX$YiY$Yic$Yih$Yil$Yim$Yin$Yiv$Yi!`$Yi!a$Yi!b$Yi!c$Yi!d$Yi!e$Yi!f$Yi!g$Yi!h$Yi!i$Yi!j$Yi!k$Yi!l$Yi!m$Yi!n$Yi!o$Yi!p$Yi!q$Yi!r$Yi!s$Yi!t$Yi!u$Yi!v$Yi$S$Yi~OP(XOQ5pOR(XOg(sO#O$Yi~P$DnOS$^XT$^XU$^XV$^XW$^XX$^XY$^Xc$^Xh$^Xl$^Xm$^Xn$^Xv$^X!`$^X!a$^X!b$^X!c$^X!d$^X!e$^X!f$^X!g$^X!h$^X!i$^X!j$^X!k$^X!l$^X!m$^X!n$^X!o$^X!p$^X!q$^X!r$^X!s$^X!t$^X!u$^X!v$^X#O$^X$S$^X!}$^X[$^Xb$^Xf$^X#V$^X#W$^X#j$^X#k$^XZ$^X~OP#fXQ#fXR#fXg#fX~P$GhOP!{XQ!{XR!{Xg!{X~P$GhOS!ziT!ziU!ziV!ziW!ziX!ziY!zic!zih!zil!zim!zin!ziv!zi!`!zi!a!zi!b!zi!c!zi!d!zi!e!zi!f!zi!g!zi!h!zi!i!zi!j!zi!k!zi!l!zi!m!zi!n!zi!o!zi!p!zi!q!zi!r!zi!s!zi!t!zi!u!zi!v!zi#O!zi$S!zi~OP(XOQ5pOR(XOg(sO~P$K_O[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO~P$K_OSROTQOUSOVTOW5POX4zO[!hO_mO`mOamOblOcvOf!nOh>OOi4qOj4rOk4TOl([Om*uOn*uOo'cOpXOq'cOr3fOsXOt'cOuXOv4uOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO!`vO!a'sO!b5VO!c=vO!dBaO!eEqO!fHQO!g'wO!h5ZO!i=zO!jBeO!kEuO!lHUO!mHpO!nBeO!o*uO!pvO!q'sO!r5VO!s=vO!tBaO!uEqO!vHQO#O<mO#W!kO#jlO#klO#[#YP~O#V&gO~P%#POP#mXQ#mXR#mXS#sXT#sXU#sXV#sXW#sXX#sXY#sX[#mX_#mX`#mXa#mXb#mXc#sXe#mXf#mXg#mXh#sXi#mXj#mXk#mXl#mXl#sXm#mXm#sXn#mXn#sXo#mXp#mXq#mXr#mXs#mXt#mXu#mXv#mXv#sXw#mXx#mXy#mXz#mX{#mX|#mX}#mX!O#mX!P#mX!Q#mX!R#mX!S#mX!T#mX!U#mX!V#mX!W#mX!X#mX!Y#mX!Z#mX![#mX!]#mX!^#mX!_#mX!`#mX!`#sX!a#mX!a#sX!b#mX!b#sX!c#mX!c#sX!d#mX!d#sX!e#mX!e#sX!f#mX!f#sX!g#mX!g#sX!h#mX!h#sX!i#mX!i#sX!j#mX!j#sX!k#mX!k#sX!l#mX!l#sX!m#mX!m#sX!n#mX!n#sX!o#sX!p#mX!p#sX!q#mX!q#sX!r#mX!r#sX!s#mX!s#sX!t#mX!t#sX!u#mX!u#sX!v#mX!v#sX#O#mX#W#mX#j#mX#k#mX$S#sX~O#O#sX~P%(aOP!|XQ!|XR!|XS#sXT#sXU#sXV#sXW#sXX#sXY#sX[!|X_!|X`!|Xa!|Xb!|Xc#sXe!|Xf!|Xg!|Xh#sXi!|Xj!|Xk!|Xl!|Xl#sXm!|Xm#sXn!|Xn#sXo!|Xp!|Xq!|Xr!|Xs!|Xt!|Xu!|Xv!|Xv#sXw!|Xx!|Xy!|Xz!|X{!|X|!|X}!|X!O!|X!P!|X!Q!|X!R!|X!S!|X!T!|X!U!|X!V!|X!W!|X!X!|X!Y!|X!Z!|X![!|X!]!|X!^!|X!_!|X!`!|X!`#sX!a!|X!a#sX!b!|X!b#sX!c!|X!c#sX!d!|X!d#sX!e!|X!e#sX!f!|X!f#sX!g!|X!g#sX!h!|X!h#sX!i!|X!i#sX!j!|X!j#sX!k!|X!k#sX!l!|X!l#sX!m!|X!m#sX!n!|X!n#sX!o#sX!p!|X!p#sX!q!|X!q#sX!r!|X!r#sX!s!|X!s#sX!t!|X!t#sX!u!|X!u#sX!v!|X!v#sX#O!|X#W!|X#j!|X#k!|X$S#sX~O#O#sX~P%/uO!}&iO~O[$[Ol$[O#V&kO~OW4|OX4wOZ&lOf$gOh=|Om*sOn*sOv*sO!a'pO!b5SO!c=sO!dB^O!eEnO!fG}O!g'uO!h5XO!i=xO!jBcO!kEsO!lHSO!mHnO!nBcO!o*sO!q'pO!r5SO!s=sO!tB^O!uEnO!vG}O#O$fO~P!%}O#V&nO~OW4}OX4xOf$gOh=|Om*rOn*rOv*rO!a'qO!b5TO!c=tO!dB_O!eEoO!fHOO!g'uO!h5XO!i=xO!jBcO!kEsO!lHSO!mHnO!nBcO!o*rO!q'qO!r5TO!s=tO!tB_O!uEoO!vHOO#O$fO#V&pO~P!%}O#V&pO~P$:rO#V&pOP!{XQ!{XR!{Xg!{X~O!}%nOP#fXQ#fXR#fXg#fX~O!}%nOP!{XQ!{XR!{Xg!{X~OS$QXT$QXU$QXV$QXW$QXX$QX[$PX[$QXb$PXb$QXc$QXf$QXh$QXl$QXm$QXn$QXv$QX!`$QX!a$QX!b$QX!c$QX!d$QX!e$QX!f$QX!g$QX!h$QX!i$QX!j$QX!k$QX!l$QX!m$QX!n$QX!o$QX!p$QX!q$QX!r$QX!s$QX!t$QX!u$QX!v$QX#O$QX#V$PX#V$QX#W$PX#W$QX#j$PX#j$QX#k$PX#k$QX~OP5aOQ!{OR5aOg$Wi$S$Wi!}$Wi#V$Wi~OP'xOQ!{OR'xOg#Rq$S#Rq~OP#RqQ#RqR#Rqg#Rq$S#Rq!}#Rq#V#Rq~P5sOS!zqT!zqU!zqV!zqW!zqX!zqY!zqc!zqh!zql!zqm!zqn!zqv!zq!`!zq!a!zq!b!zq!c!zq!d!zq!e!zq!f!zq!g!zq!h!zq!i!zq!j!zq!k!zq!l!zq!m!zq!n!zq!o!zq!p!zq!q!zq!r!zq!s!zq!t!zq!u!zq!v!zq#O!zq$S!zq~OP(XOQ5pOR(XOg(sO~P%ApO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO~P%ApOS$QXT$QXU$QXV$QXW$QXX$QX[$QXb$QXc$QXf$QXh$QXl$QXm$QXn$QXv$QX!`$QX!a$QX!b$QX!c$QX!d$QX!e$QX!f$QX!g$QX!h$QX!i$QX!j$QX!k$QX!l$QX!m$QX!n$QX!o$QX!p$QX!q$QX!r$QX!s$QX!t$QX!u$QX!v$QX#O$QX#V$QX#W$QX#j$QX#k$QX~OS#|XT#|XU#|XV#|XW#|XX#|Xc#|Xf#|Xh#|Xl#|Xm#|Xn#|Xv#|X!`#|X!a#|X!b#|X!c#|X!d#|X!e#|X!f#|X!g#|X!h#|X!i#|X!j#|X!k#|X!l#|X!m#|X!n#|X!o#|X!p#|X!q#|X!r#|X!s#|X!t#|X!u#|X!v#|X#O#|X#V#|X~P%GbO#V$lO~P$7`OS#gaT#gaU#gaV#gaW#gaX#gaY#gac#gah#gal#gam#gan#gav#ga!`#ga!a#ga!b#ga!c#ga!d#ga!e#ga!f#ga!g#ga!h#ga!i#ga!j#ga!k#ga!l#ga!m#ga!n#ga!o#ga!p#ga!q#ga!r#ga!s#ga!t#ga!u#ga!v#ga#O#ga$S#ga~P!:RO#V'OOP!{XQ!{XR!{Xg!{X~O[$[Ol$[O#V%uO~OW4|OX4wOZ'POf$gOh=|Om*sOn*sOv*sO!a'pO!b5SO!c=sO!dB^O!eEnO!fG}O!g'uO!h5XO!i=xO!jBcO!kEsO!lHSO!mHnO!nBcO!o*sO!q'pO!r5SO!s=sO!tB^O!uEnO!vG}O#O$fO~P!%}O#V'QO~OP'xOQ!{OR'xOg#Ry$S#Ry~OP#RyQ#RyR#Ryg#Ry$S#Ry!}#Ry#V#Ry~P5sOS!zyT!zyU!zyV!zyW!zyX!zyY!zyc!zyh!zyl!zym!zyn!zyv!zy!`!zy!a!zy!b!zy!c!zy!d!zy!e!zy!f!zy!g!zy!h!zy!i!zy!j!zy!k!zy!l!zy!m!zy!n!zy!o!zy!p!zy!q!zy!r!zy!s!zy!t!zy!u!zy!v!zy#O!zy$S!zy~OP(XOQ5pOR(XOg(sO~P&%XO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO~P&%XOP#niQ#niR#niS#giT#giU#giV#giW#giX#giY#gi[#ni_#ni`#nia#nib#nic#gie#nif#nig#nih#gii#nij#nik#nil#nim#nin#nio#nip#niq#nir#nis#nit#niu#niv#niw#nix#niy#niz#ni{#ni|#ni}#ni!O#ni!P#ni!Q#ni!R#ni!S#ni!T#ni!U#ni!V#ni!W#ni!X#ni!Y#ni!Z#ni![#ni!]#ni!^#ni!_#ni!`#ni!a#ni!b#ni!c#ni!d#ni!e#ni!f#ni!g#ni!h#ni!i#ni!j#ni!k#ni!l#ni!m#ni!n#ni!o#gi!p#ni!q#ni!r#ni!s#ni!t#ni!u#ni!v#ni#O#ni#W#ni#j#ni#k#ni$S#gi!}#gi#V#giZ#gi~OP'xOQ!{OR'xOg#R!R$S#R!R~OP#R!RQ#R!RR#R!Rg#R!R$S#R!R!}#R!R#V#R!R~P5sOS!z!RT!z!RU!z!RV!z!RW!z!RX!z!RY!z!Rc!z!Rh!z!Rl!z!Rm!z!Rn!z!Rv!z!R!`!z!R!a!z!R!b!z!R!c!z!R!d!z!R!e!z!R!f!z!R!g!z!R!h!z!R!i!z!R!j!z!R!k!z!R!l!z!R!m!z!R!n!z!R!o!z!R!p!z!R!q!z!R!r!z!R!s!z!R!t!z!R!u!z!R!v!z!R#O!z!R$S!z!R~OP(XOQ5pOR(XOg(sO~P&1kO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO~P&1kOP'xOQ!{OR'xOg#R!Z$S#R!Z~OP#R!ZQ#R!ZR#R!Zg#R!Z$S#R!Z!}#R!Z#V#R!Z~P5sOS!z!ZT!z!ZU!z!ZV!z!ZW!z!ZX!z!ZY!z!Zc!z!Zh!z!Zl!z!Zm!z!Zn!z!Zv!z!Z!`!z!Z!a!z!Z!b!z!Z!c!z!Z!d!z!Z!e!z!Z!f!z!Z!g!z!Z!h!z!Z!i!z!Z!j!z!Z!k!z!Z!l!z!Z!m!z!Z!n!z!Z!o!z!Z!p!z!Z!q!z!Z!r!z!Z!s!z!Z!t!z!Z!u!z!Z!v!z!Z#O!z!Z$S!z!Z~OP(XOQ5pOR(XOg(sO~P&8XO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO~P&8XO[#RX_#RX`#RXa#RXb#RXf!zXf#RXi#RXj#RXk#RXl#RXo#RXp#RXq#RXr#RXs#RXt#RXu#RXv#RXw#RXx#RXy#RXz#RX{#RX|#RX}#RX!O#RX!P#RX!Q#RX!R#RX!S#RX!T#RX!U#RX!V#RX!W#RX!X#RX!Y#RX!Z#RX![#RX!]#RX!^#RX!_#RX#O#RX#V!zX#V#RX#V#mX#W#RX#j#RX#k#RX~P2POP#RXQ#RXR#RX[#RXg#RXo#RXp#RXq#RXr#RXs#RXt#RXu#RXw#RXx#RXy#RXz#RX{#RX|#RX}#RX!O#RX!P#RX!Q#RX!R#RX!S#RX!T#RX!U#RX!V#RX!W#RX!X#RX!Y#RX!Z#RX![#RX!]#RX!^#RX!_#RX#W#RX~O_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klO~P&AWO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klOP#RXQ#RXR#RXS#RXT#RXU#RXV#RXW#RXX#RXc#RXg#RXh#RXl#RXm#RXn#RXv#RX!`#RX!a#RX!b#RX!c#RX!d#RX!e#RX!f#RX!g#RX!h#RX!i#RX!j#RX!k#RX!l#RX!m#RX!n#RX!o#RX!p#RX!q#RX!r#RX!s#RX!t#RX!u#RX!v#RX#O#RX~Of#RX#V#RXZ#RX~P&DgO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klOP#RXQ#RXR#RXS#RXT#RXU#RXV#RXW#RXX#RXY#RXc#RXg#RXh#RXl#RXm#RXn#RXv#RX!`#RX!a#RX!b#RX!c#RX!d#RX!e#RX!f#RX!g#RX!h#RX!i#RX!j#RX!k#RX!l#RX!m#RX!n#RX!o#RX!p#RX!q#RX!r#RX!s#RX!t#RX!u#RX!v#RX$S#RX~O#O>PO~P&JTO#O#RX~P&JTO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO~OP#RXQ#RXR#RXS#RXT#RXU#RXV#RXW#RXX#RX[#RXb#RXc#RXf#RXg#RXh#RXl#RXm#RXn#RXv#RX!`#RX!a#RX!b#RX!c#RX!d#RX!e#RX!f#RX!g#RX!h#RX!i#RX!j#RX!k#RX!l#RX!m#RX!n#RX!o#RX!p#RX!q#RX!r#RX!s#RX!t#RX!u#RX!v#RX#O#RX#V#RX#W#RX#j#RX#k#RX~P' xO[mO_mO`mOamOblOfmOi=eOj=jOk4kOl#POo3POpXOq3POr3|OsXOt3POuXOvmOwXOx3POy3|Oz=WO{BOO|E`O}GoO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3PO!Z3|O![=WO!]BOO!^E`O!_GoO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=eOj=jOkA]Ol#POo3UOpXOq3UOrAZOsXOt3UOuXOvmOwXOx3UOyAZOzDoO{GQO|HbO}HqO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3UO!ZAZO![DoO!]GQO!^HbO!_HqO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=hOj=mOk4nOl#POo3WOpXOq3WOr4POsXOt3WOuXOvmOwXOx3WOy4POz=ZO{BRO|EcO}GrO!O'fO!P'nO!Q=aO!RBXO!SEiO!TGxO!UHjO!V=aO!W'nO!XXO!Y3WO!Z4PO![=ZO!]BRO!^EcO!_GrO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=iOj=nOk4pOl#POo3[OpXOq3[Or4ROsXOt3[OuXOvmOwXOx3[Oy4ROz=]O{BTO|EeO}GtO!O'hO!P'kO!Q=bO!RBYO!SEjO!TGyO!UHkO!V=bO!W'kO!XXO!Y3[O!Z4RO![=]O!]BTO!^EeO!_GtO#O>PO#WWO#jlO#klO~O!}!zX~P5sO[mOblO#WWO#jlO#klOS!zXT!zXU!zXV!zXW!zXX!zXc!zXf!zXh!zXl!zXm!zXn!zXv!zX!`!zX!a!zX!b!zX!c!zX!d!zX!e!zX!f!zX!g!zX!h!zX!i!zX!j!zX!k!zX!l!zX!m!zX!n!zX!o!zX!p!zX!q!zX!r!zX!s!zX!t!zX!u!zX!v!zX#O!zX#V!zXZ!zX~P' xO#O>PO~PGqOS!zXT!zXU!zXV!zXW!zXX!zX[!zXb!zXc!zXf!zXh!zXl!zXm!zXn!zXv!zX!`!zX!a!zX!b!zX!c!zX!d!zX!e!zX!f!zX!g!zX!h!zX!i!zX!j!zX!k!zX!l!zX!m!zX!n!zX!o!zX!p!zX!q!zX!r!zX!s!zX!t!zX!u!zX!v!zX#O!zX#V!zX#W!zX#j!zX#k!zX~P' xO[mO_mO`mOamOblOfmOijOjkOk4oOl#POo3ZOpXOq3ZOr4QOsXOt3ZOuXOvmOwXOx3ZOy4QOz=[O{BSO|EdO}GsO!ObO!PcO!QdO!ReO!SfO!TgO!UhO!VdO!WcO!XXO!Y3ZO!Z4QO![=[O!]BSO!^EdO!_GsO#O!^O#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=eOj=jOk4UOl#POo3eOpXOq3eOr3gOsXOt3eOuXOvmOwXOx3eOy3gOz<qO{AiO|DyO}GYO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3eO!Z3gO![<qO!]AiO!^DyO!_GYO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=eOj=jOk4VOl#POo3dOpXOq3dOr3hOsXOt3dOuXOvmOwXOx3dOy3hOz<rO{AjO|DzO}GZO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3dO!Z3hO![<rO!]AjO!^DzO!_GZO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=hOj=mOk4WOl#POo3bOpXOq3bOr3iOsXOt3bOuXOvmOwXOx3bOy3iOz<sO{AkO|D{O}G[O!O'fO!P'nO!Q=aO!RBXO!SEiO!TGxO!UHjO!V=aO!W'nO!XXO!Y3bO!Z3iO![<sO!]AkO!^D{O!_G[O#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=fOj=kOk4XOl#POo3`OpXOq3`Or3jOsXOt3`OuXOvmOwXOx3`Oy3jOz<tO{AlO|D|O}G]O!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y3`O!Z3jO![<tO!]AlO!^D|O!_G]O#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=iOj=nOk4YOl#POo3_OpXOq3_Or3kOsXOt3_OuXOvmOwXOx3_Oy3kOz<uO{AmO|D}O}G^O!O'hO!P'kO!Q=bO!RBYO!SEjO!TGyO!UHkO!V=bO!W'kO!XXO!Y3_O!Z3kO![<uO!]AmO!^D}O!_G^O#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=fOj=kOk4[Ol#POo3]OpXOq3]Or3mOsXOt3]OuXOvmOwXOx3]Oy3mOz<wO{AoO|EPO}G`O!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y3]O!Z3mO![<wO!]AoO!^EPO!_G`O#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=gOj=lOk4]Ol#POo3YOpXOq3YOr3nOsXOt3YOuXOvmOwXOx3YOy3nOz<xO{ApO|EQO}GaO!O'dO!P'mO!Q=`O!RBWO!SEhO!TGwO!UHiO!V=`O!W'mO!XXO!Y3YO!Z3nO![<xO!]ApO!^EQO!_GaO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=eOj=jOk4aOl#POo3QOpXOq3QOr3rOsXOt3QOuXOvmOwXOx3QOy3rOz<|O{AtO|EUO}GeO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3QO!Z3rO![<|O!]AtO!^EUO!_GeO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=eOj=jOk4cOl#POo2}OpXOq2}Or3tOsXOt2}OuXOvmOwXOx2}Oy3tOz=OO{AvO|EWO}GgO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y2}O!Z3tO![=OO!]AvO!^EWO!_GgO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=hOj=mOk4eOl#POo2zOpXOq2zOr3vOsXOt2zOuXOvmOwXOx2zOy3vOz=QO{AxO|EYO}GiO!O'fO!P'nO!Q=aO!RBXO!SEiO!TGxO!UHjO!V=aO!W'nO!XXO!Y2zO!Z3vO![=QO!]AxO!^EYO!_GiO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=fOj=kOk4fOl#POo2xOpXOq2xOr3wOsXOt2xOuXOvmOwXOx2xOy3wOz=RO{AyO|EZO}GjO!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y2xO!Z3wO![=RO!]AyO!^EZO!_GjO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=gOj=lOk4mOl#POo3TOpXOq3TOr4OOsXOt3TOuXOvmOwXOx3TOy4OOz=YO{BQO|EbO}GqO!O'dO!P'mO!Q=`O!RBWO!SEhO!TGwO!UHiO!V=`O!W'mO!XXO!Y3TO!Z4OO![=YO!]BQO!^EbO!_GqO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=iOj=nOk4iOl#POo2|OpXOq2|Or3zOsXOt2|OuXOvmOwXOx2|Oy3zOz=UO{A|O|E^O}GmO!O'hO!P'kO!Q=bO!RBYO!SEjO!TGyO!UHkO!V=bO!W'kO!XXO!Y2|O!Z3zO![=UO!]A|O!^E^O!_GmO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=fOj=kOk4lOl#POo3SOpXOq3SOr3}OsXOt3SOuXOvmOwXOx3SOy3}Oz=XO{BPO|EaO}GpO!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y3SO!Z3}O![=XO!]BPO!^EaO!_GpO#O>PO#WWO#jlO#klO~O#V#{X~P!-YO[!zX[#{Xb!zXf!zXl#{X#V!zX#V#RX#V#mX#V#{X#W!zX#[#{X#j!zX#k!zX~P2PO[!zX[#RX[#{X_#RX`#RXa#RXb!zXb#RXf!zXf#RXi#RXj#RXk#RXl#RXl#{Xo#RXp#RXq#RXr#RXs#RXt#RXu#RXv#RXw#RXx#RXy#RXz#RX{#RX|#RX}#RX!O#RX!P#RX!Q#RX!R#RX!S#RX!T#RX!U#RX!V#RX!W#RX!X#RX!Y#RX!Z#RX![#RX!]#RX!^#RX!_#RX#O#RX#V!zX#V#RX#V#mX#W!zX#W#RX#[#{X#j!zX#j#RX#k!zX#k#RX~P2PO[#RX[#{X_#RX`#RXa#RXb#RXf!zXf#RXi#RXj#RXk#RXl#RXl#{Xo#RXp#RXq#RXr#RXs#RXt#RXu#RXv#RXw#RXx#RXy#RXz#RX{#RX|#RX}#RX!O#RX!P#RX!Q#RX!R#RX!S#RX!T#RX!U#RX!V#RX!W#RX!X#RX!Y#RX!Z#RX![#RX!]#RX!^#RX!_#RX#O#RX#V!zX#V#RX#V#mX#W#RX#[#{X#j#RX#k#RX~P2PO[mO_mO`mOamOblOfmOi=eOj=jOk4ZOl#POo3^OpXOq3^Or3lOsXOt3^OuXOvmOwXOx3^Oy3lOz<vO{AnO|EOO}G_O!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3^O!Z3lO![<vO!]AnO!^EOO!_G_O#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=eOj=jOk4^Ol#POo3VOpXOq3VOr3oOsXOt3VOuXOvmOwXOx3VOy3oOz<yO{AqO|ERO}GbO!O'eO!P'jO!Q=^O!RBUO!SEfO!TGuO!UHgO!V=^O!W'jO!XXO!Y3VO!Z3oO![<yO!]AqO!^ERO!_GbO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=hOj=mOk4`Ol#POo3ROpXOq3ROr3qOsXOt3ROuXOvmOwXOx3ROy3qOz<{O{AsO|ETO}GdO!O'fO!P'nO!Q=aO!RBXO!SEiO!TGxO!UHjO!V=aO!W'nO!XXO!Y3RO!Z3qO![<{O!]AsO!^ETO!_GdO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=fOj=kOk4bOl#POo3OOpXOq3OOr3sOsXOt3OOuXOvmOwXOx3OOy3sOz<}O{AuO|EVO}GfO!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y3OO!Z3sO![<}O!]AuO!^EVO!_GfO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=iOj=nOk4dOl#POo2{OpXOq2{Or3uOsXOt2{OuXOvmOwXOx2{Oy3uOz=PO{AwO|EXO}GhO!O'hO!P'kO!Q=bO!RBYO!SEjO!TGyO!UHkO!V=bO!W'kO!XXO!Y2{O!Z3uO![=PO!]AwO!^EXO!_GhO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=fOj=kOk4gOl#POo2wOpXOq2wOr3xOsXOt2wOuXOvmOwXOx2wOy3xOz=SO{AzO|E[O}GkO!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y2wO!Z3xO![=SO!]AzO!^E[O!_GkO#O>PO#WWO#jlO#klO~O[mO_mO`mOamOblOfmOi=gOj=lOk4hOl#POo2yOpXOq2yOr3yOsXOt2yOuXOvmOwXOx2yOy3yOz=TO{A{O|E]O}GlO!O'dO!P'mO!Q=`O!RBWO!SEhO!TGwO!UHiO!V=`O!W'mO!XXO!Y2yO!Z3yO![=TO!]A{O!^E]O!_GlO#O>PO#WWO#jlO#klO~OP5aOQ!{OR5aOg#Ra!}#Ra#V#Ra$S#Ra~OP'yOR'yOS#RaT#RaU#RaV#RaW#RaX#RaZ#Rac#Raf#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra~OQ5dO~P)'xO[#Rab#Raf#Rag#Ral#Rav#Ra#O#Ra#W#Ra#j#Ra#k#RaS#RaT#RaU#RaV#RaW#RaX#Rac#Rah#Ram#Ran#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#V#Ra~OP'zOQ5cOR'zO_#Ra`#Raa#Rai#Raj#Rak#Rao#Rap#Raq#Rar#Ras#Rat#Rau#Raw#Rax#Ray#Raz#Ra{#Ra|#Ra}#Ra!O#Ra!P#Ra!Q#Ra!R#Ra!S#Ra!T#Ra!U#Ra!V#Ra!W#Ra!X#Ra!Y#Ra!Z#Ra![#Ra!]#Ra!^#Ra!_#Ra$S#RaY#Rae#Ra!}#RaZ#Ra~P)*rOP'{OR'{OS#RaT#RaU#RaV#RaW#RaX#Rac#Raf#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra#V#Ra~OQ5eO~P)0lOP'|OR'|OS#RaT#RaU#RaV#RaW#RaX#RaY#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra$S#Ra~OQ5fO~P)3fOP'}OR'}OW#RaX#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra$S#Ra~OQ5gO~P)6]OP(OOQ5hOR(OO~P)*rOP(POR(POS#RaT#RaU#RaV#RaW#RaX#RaY#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra$S#Ra~OQ5jO~P)9TOP(QOR(QO[#Rag#Rao#Rap#Raq#Rar#Ras#Rat#Rau#Raw#Rax#Ray#Raz#Ra{#Ra|#Ra}#Ra!O#Ra!P#Ra!Q#Ra!R#Ra!S#Ra!T#Ra!U#Ra!V#Ra!W#Ra!X#Ra!Y#Ra!Z#Ra![#Ra!]#Ra!^#Ra!_#Ra#W#Ra~OQ5kO~P);}OP(ROR(ROS#RaT#RaU#RaV#RaW#RaX#RaZ#Rac#Raf#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra~OQ5dO~P)>eOP(SOR(SOS#RaT#RaU#RaV#RaW#RaX#Rac#Raf#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra#V#Ra~OQ5eO~P)A_OP(TOR(TOS#RaT#RaU#RaV#RaW#RaX#RaY#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra$S#Ra~OQ5fO~P)DXOP(UOR(UOW#RaX#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra$S#Ra~OQ5gO~P)GOOP(WOQ5hOR(WO~P)*rOP(XOR(XOS#RaT#RaU#RaV#RaW#RaX#RaY#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra$S#Ra~OQ5jO~P)IvOP(VOR(VO[#Rag#Rao#Rap#Raq#Rar#Ras#Rat#Rau#Raw#Rax#Ray#Raz#Ra{#Ra|#Ra}#Ra!O#Ra!P#Ra!Q#Ra!R#Ra!S#Ra!T#Ra!U#Ra!V#Ra!W#Ra!X#Ra!Y#Ra!Z#Ra![#Ra!]#Ra!^#Ra!_#Ra#W#Ra~OQ5kO~P)LpOP#mXQ#mXR#mX_#RX`#RXa#RXb#RXf#RXg#mXi#RXj#RXk#RXl#RXv#RX#O#RX#V#RX#j#RX#k#RX~P&AWOP'zOQ5cOR'zOg(^O~P'<eOP'zOQ5cOR'zOg(^O~P'?dOP'zOQ5cOR'zOg(^O~P'BcOP'zOQ5cOR'zOg(^O~P'EbOP'zOQ5cOR'zOg(^O~P'HaOP'zOQ5cOR'zOg(^O~P(@hOP'zOQ5cOR'zOg(^O~P'K`OP'zOQ5cOR'zOg(^O~P'N_OP'zOQ5cOR'zOg(^O~P(CgOP'zOQ5cOR'zOg(^O~P;lOP'zOQ5cOR'zOg(^O~P(FfOP'zOQ5cOR'zOg(^O~P(#^OP'zOQ5cOR'zOg(^O~P(IeOP'zOQ5cOR'zOg(^O~P(&]OP'zOQ5cOR'zOg(^O~P(LdOP'zOQ5cOR'zOg(^O~P()[OP'zOQ5cOR'zOg(^O~P(,ZOP'zOQ5cOR'zOg(^O~P) cOP'zOQ5cOR'zOg(^O~P)$bOP'zOQ5cOR'zOg(^O~P(2XOP'zOQ5cOR'zOg(^O~P''cOP'zOQ5cOR'zOg(^O~P(5WOP'zOQ5cOR'zOg(^O~P(/YOP'zOQ5cOR'zOg(^O~P'-aOP'zOQ5cOR'zOg(^O~P'9fOP'zOQ5cOR'zOg(^O~P'0`O_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klOP#RaQ#RaR#Ra~P)<TO[mOblO#WWO#jlO#klOP#RaQ#RaR#RaS#RaT#RaU#RaV#RaW#RaX#Rac#Raf#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra#V#RaZ#Ra~P' xO[mOblOfmO#O>PO#WWO#jlO#klOP#RaQ#RaR#RaS#RaT#RaU#RaV#RaW#RaX#RaY#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra$S#Ra~P' xO[mOblOfmO#WWO#jlO#klOP#RaQ#RaR#RaS#RaT#RaU#RaV#RaW#RaX#RaY#Rac#Rag#Rah#Ral#Ram#Ran#Rav#Ra!`#Ra!a#Ra!b#Ra!c#Ra!d#Ra!e#Ra!f#Ra!g#Ra!h#Ra!i#Ra!j#Ra!k#Ra!l#Ra!m#Ra!n#Ra!o#Ra!p#Ra!q#Ra!r#Ra!s#Ra!t#Ra!u#Ra!v#Ra#O#Ra$S#Ra~P' xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOP#RaQ#RaR#Ra~P)*rOQ#_O~P#5wOP'zOQ5cOR'zOg(^O!}$Za~P!)[OP'zOQ5cOR'zOg(^OS$ZaT$ZaU$ZaV$ZaW$ZaX$ZaZ$Zac$Zah$Zam$Zan$Za!`$Za!a$Za!b$Za!c$Za!d$Za!e$Za!f$Za!g$Za!h$Za!i$Za!j$Za!k$Za!l$Za!m$Za!n$Za!o$Za!p$Za!q$Za!r$Za!s$Za!t$Za!u$Za!v$Za~P''cOP'zOQ5cOR'zOg(^OS$ZaT$ZaU$ZaV$ZaW$ZaX$Zac$Zah$Zam$Zan$Za!`$Za!a$Za!b$Za!c$Za!d$Za!e$Za!f$Za!g$Za!h$Za!i$Za!j$Za!k$Za!l$Za!m$Za!n$Za!o$Za!p$Za!q$Za!r$Za!s$Za!t$Za!u$Za!v$Za#V$Za~P'*bOP'zOQ5cOR'zOg(^OS$ZaT$ZaU$ZaV$ZaW$ZaX$ZaY$Zac$Zah$Zam$Zan$Za!`$Za!a$Za!b$Za!c$Za!d$Za!e$Za!f$Za!g$Za!h$Za!i$Za!j$Za!k$Za!l$Za!m$Za!n$Za!o$Za!p$Za!q$Za!r$Za!s$Za!t$Za!u$Za!v$Za$S$Za~P'-aOP'zOQ5cOR'zOg(^OS$ZaT$ZaU$ZaV$ZaW$ZaX$Zac$Zah$Zam$Zan$Za!`$Za!a$Za!b$Za!c$Za!d$Za!e$Za!f$Za!g$Za!h$Za!i$Za!j$Za!k$Za!l$Za!m$Za!n$Za!o$Za!p$Za!q$Za!r$Za!s$Za!t$Za!u$Za!v$Za#V$Za~P'0`OP5aOQ!{OR5aOg5rO!}!za~OS!zaT!zaU!zaV!zaW!zaX!zaZ!zac!zaf!zah!zal!zam!zan!zav!za!`!za!a!za!b!za!c!za!d!za!e!za!f!za!g!za!h!za!i!za!j!za!k!za!l!za!m!za!n!za!o!za!p!za!q!za!r!za!s!za!t!za!u!za!v!za#O!za~OP(ROQ5iOR(ROg(tO~P*DVOS!zaT!zaU!zaV!zaW!zaX!zac!zaf!zah!zal!zam!zan!zav!za!`!za!a!za!b!za!c!za!d!za!e!za!f!za!g!za!h!za!i!za!j!za!k!za!l!za!m!za!n!za!o!za!p!za!q!za!r!za!s!za!t!za!u!za!v!za#O!za#V!za~OP(SOQ5lOR(SOg:aO~P*GPOS!zaT!zaU!zaV!zaW!zaX!zaY!zac!zah!zal!zam!zan!zav!za!`!za!a!za!b!za!c!za!d!za!e!za!f!za!g!za!h!za!i!za!j!za!k!za!l!za!m!za!n!za!o!za!p!za!q!za!r!za!s!za!t!za!u!za!v!za$S!za~OP(TOQ5mOR(TOg(wO~P*IyOW!zaX!zac!zah!zal!zam!zan!zav!za!`!za!a!za!b!za!c!za!d!za!e!za!f!za!g!za!h!za!i!za!j!za!k!za!l!za!m!za!n!za!o!za!p!za!q!za!r!za!s!za!t!za!u!za!v!za#O!za~OP(UOQ5nOR(UOg:bO$S!za~P*LpOP(WOQ5qOR(WOg(yO[!zab!za#W!za#j!za#k!za~P*GPOP'zOQ5cOR'zOg(^O~P'*bO!}!za~P5sO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO#V!za~P*DVO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~P*IyO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO[!zab!za#W!za#j!za#k!za~P*GPO[#Pi_#Pi_#Qi`#Pi`#Qia#Pia#Qib#Pif#Pii#Pii#Qij#Pij#Qik#Pik#Qil#Pio#Pio#Qip#Pip#Qiq#Piq#Qir#Pir#Qis#Pis#Qit#Pit#Qiu#Piu#Qiv#Piw#Piw#Qix#Pix#Qiy#Piy#Qiz#Piz#Qi{#Pi{#Qi|#Pi|#Qi}#Pi}#Qi!O#Pi!O#Qi!P#Pi!P#Qi!Q#Pi!Q#Qi!R#Pi!R#Qi!S#Pi!S#Qi!T#Pi!T#Qi!U#Pi!U#Qi!V#Pi!V#Qi!W#Pi!W#Qi!X#Pi!X#Qi!Y#Pi!Y#Qi!Z#Pi!Z#Qi![#Pi![#Qi!]#Pi!]#Qi!^#Pi!^#Qi!_#Pi!_#Qi#O#Pi#W#Pi#j#Pi#k#PiS#PiT#PiU#PiV#PiW#PiX#PiY#PiY#Qic#Pih#Pim#Pin#Pi!`#Pi!a#Pi!b#Pi!c#Pi!d#Pi!e#Pi!f#Pi!g#Pi!h#Pi!i#Pi!j#Pi!k#Pi!l#Pi!m#Pi!n#Pi!o#Pi!p#Pi!q#Pi!r#Pi!s#Pi!t#Pi!u#Pi!v#Pie#Pie#QiZ#PiZ#Qi~P#JRO[#Si_#Qi_#Si`#Qi`#Sia#Qia#Sib#Sif#Sii#Qii#Sij#Qij#Sik#Qik#Sil#Sio#Qio#Sip#Qip#Siq#Qiq#Sir#Qir#Sis#Qis#Sit#Qit#Siu#Qiu#Siv#Siw#Qiw#Six#Qix#Siy#Qiy#Siz#Qiz#Si{#Qi{#Si|#Qi|#Si}#Qi}#Si!O#Qi!O#Si!P#Qi!P#Si!Q#Qi!Q#Si!R#Qi!R#Si!S#Qi!S#Si!T#Qi!T#Si!U#Qi!U#Si!V#Qi!V#Si!W#Qi!W#Si!X#Qi!X#Si!Y#Qi!Y#Si!Z#Qi!Z#Si![#Qi![#Si!]#Qi!]#Si!^#Qi!^#Si!_#Qi!_#Si#O#Si#W#Si#j#Si#k#SiS#SiT#SiU#SiV#SiW#SiX#SiY#QiY#Sic#Sih#Sim#Sin#Si!`#Si!a#Si!b#Si!c#Si!d#Si!e#Si!f#Si!g#Si!h#Si!i#Si!j#Si!k#Si!l#Si!m#Si!n#Si!o#Si!p#Si!q#Si!r#Si!s#Si!t#Si!u#Si!v#Sie#Qie#SiZ#QiZ#Si~P#MsOP#QiP#SiQ#QiQ#SiR#QiR#SiS#QiT#QiU#QiV#QiW#QiX#Qi[#Si_#Si`#Sia#Sib#Sic#Qif#Qif#Sig#Qig#Sih#Qii#Sij#Sik#Sil#Qil#Sim#Qin#Qio#Sip#Siq#Sir#Sis#Sit#Siu#Siv#Qiv#Siw#Six#Siy#Siz#Si{#Si|#Si}#Si!O#Si!P#Si!Q#Si!R#Si!S#Si!T#Si!U#Si!V#Si!W#Si!X#Si!Y#Si!Z#Si![#Si!]#Si!^#Si!_#Si!`#Qi!a#Qi!b#Qi!c#Qi!d#Qi!e#Qi!f#Qi!g#Qi!h#Qi!i#Qi!j#Qi!k#Qi!l#Qi!m#Qi!n#Qi!o#Qi!p#Qi!q#Qi!r#Qi!s#Qi!t#Qi!u#Qi!v#Qi#O#Qi#O#Si#V#Qi#V#Si#W#Si#j#Si#k#Si~O[#Qib#Qi#W#Qi#j#Qi#k#Qi~P+:qOP#QiP#SiQ#QiQ#SiR#QiR#Si[#Si_#Si`#Sia#Sib#Sif#Sig#Qig#Sii#Sij#Sik#Sil#Sio#Sip#Siq#Sir#Sis#Sit#Siu#Siv#Siw#Six#Siy#Siz#Si{#Si|#Si}#Si!O#Si!P#Si!Q#Si!R#Si!S#Si!T#Si!U#Si!V#Si!W#Si!X#Si!Y#Si!Z#Si![#Si!]#Si!^#Si!_#Si#O#Si#V#Si#W#Si#j#Si#k#Si~OP'xOQ!{OR'xOg$Va$S$Va~OQ5dOS$VaT$VaU$VaV$VaW$VaX$VaZ$Vac$Vaf$Vag$Vah$Val$Vam$Van$Vav$Va!`$Va!a$Va!b$Va!c$Va!d$Va!e$Va!f$Va!g$Va!h$Va!i$Va!j$Va!k$Va!l$Va!m$Va!n$Va!o$Va!p$Va!q$Va!r$Va!s$Va!t$Va!u$Va!v$Va#O$Va~OP'yOR'yO~P+ETO[$Vab$Vaf$Vag$Val$Vav$Va#O$Va#W$Va#j$Va#k$VaS$VaT$VaU$VaV$VaW$VaX$Vac$Vah$Vam$Van$Va!`$Va!a$Va!b$Va!c$Va!d$Va!e$Va!f$Va!g$Va!h$Va!i$Va!j$Va!k$Va!l$Va!m$Va!n$Va!o$Va!p$Va!q$Va!r$Va!s$Va!t$Va!u$Va!v$Va#V$Va~OP'zOQ5cOR'zO_$Va`$Vaa$Vai$Vaj$Vak$Vao$Vap$Vaq$Var$Vas$Vat$Vau$Vaw$Vax$Vay$Vaz$Va{$Va|$Va}$Va!O$Va!P$Va!Q$Va!R$Va!S$Va!T$Va!U$Va!V$Va!W$Va!X$Va!Y$Va!Z$Va![$Va!]$Va!^$Va!_$Va$S$VaY$Vae$Va!}$VaZ$Va~P+G}OQ5eOS$VaT$VaU$VaV$VaW$VaX$Vac$Vaf$Vag$Vah$Val$Vam$Van$Vav$Va!`$Va!a$Va!b$Va!c$Va!d$Va!e$Va!f$Va!g$Va!h$Va!i$Va!j$Va!k$Va!l$Va!m$Va!n$Va!o$Va!p$Va!q$Va!r$Va!s$Va!t$Va!u$Va!v$Va#O$Va#V$Va~OP'{OR'{O~P+MwOQ5fOS$VaT$VaU$VaV$VaW$VaX$VaY$Vac$Vag$Vah$Val$Vam$Van$Vav$Va!`$Va!a$Va!b$Va!c$Va!d$Va!e$Va!f$Va!g$Va!h$Va!i$Va!j$Va!k$Va!l$Va!m$Va!n$Va!o$Va!p$Va!q$Va!r$Va!s$Va!t$Va!u$Va!v$Va$S$Va~OP'|OR'|O~P,!qOQ5gOW$VaX$Vac$Vag$Vah$Val$Vam$Van$Vav$Va!`$Va!a$Va!b$Va!c$Va!d$Va!e$Va!f$Va!g$Va!h$Va!i$Va!j$Va!k$Va!l$Va!m$Va!n$Va!o$Va!p$Va!q$Va!r$Va!s$Va!t$Va!u$Va!v$Va#O$Va$S$Va~OP'}OR'}O~P,%hOP(OOQ5hOR(OO~P+G}OQ5jOS$VaT$VaU$VaV$VaW$VaX$VaY$Vac$Vag$Vah$Val$Vam$Van$Vav$Va!`$Va!a$Va!b$Va!c$Va!d$Va!e$Va!f$Va!g$Va!h$Va!i$Va!j$Va!k$Va!l$Va!m$Va!n$Va!o$Va!p$Va!q$Va!r$Va!s$Va!t$Va!u$Va!v$Va#O$Va$S$Va~OP(POR(PO~P,(`OQ5kO[$Vag$Vao$Vap$Vaq$Var$Vas$Vat$Vau$Vaw$Vax$Vay$Vaz$Va{$Va|$Va}$Va!O$Va!P$Va!Q$Va!R$Va!S$Va!T$Va!U$Va!V$Va!W$Va!X$Va!Y$Va!Z$Va![$Va!]$Va!^$Va!_$Va#W$Va~OP(QOR(QO~P,+YOP5aOQ!{OR5aOg$Va!}$Va#V$Va$S$Va~OP(ROR(RO~P+ETOP(SOR(SO~P+MwOP(TOR(TO~P,!qOP(UOR(UO~P,%hOP(WOQ5hOR(WO~P+G}OP(XOR(XO~P,(`OP(VOR(VO~P,+YOS#QiS#^iT#QiT#^iU#QiU#^iV#QiV#^iW#QiX#Qi[#Qi[#^ib#Qib#^ic#Qif#Qif#^ih#Qil#Qim#Qin#Qiv#Qi!`#Qi!a#Qi!b#Qi!c#Qi!d#Qi!e#Qi!f#Qi!g#Qi!h#Qi!i#Qi!j#Qi!k#Qi!l#Qi!m#Qi!n#Qi!o#Qi!p#Qi!q#Qi!r#Qi!s#Qi!t#Qi!u#Qi!v#Qi#O#Qi#V#Qi#V#^i#W#Qi#W#^i#j#Qi#j#^i#k#Qi#k#^iZ#QiZ#^i~P$#vOP5aOQ!{OR5aOg#Ri!}#Ri#V#Ri$S#Ri~OP'yOR'yOS#RiT#RiU#RiV#RiW#RiX#RiZ#Ric#Rif#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri~OQ5dO~P,4PO[#Rib#Rif#Rig#Ril#Riv#Ri#O#Ri#W#Ri#j#Ri#k#RiS#RiT#RiU#RiV#RiW#RiX#Ric#Rih#Rim#Rin#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#V#Ri~OP'zOQ5cOR'zO_#Ri`#Ria#Rii#Rij#Rik#Rio#Rip#Riq#Rir#Ris#Rit#Riu#Riw#Rix#Riy#Riz#Ri{#Ri|#Ri}#Ri!O#Ri!P#Ri!Q#Ri!R#Ri!S#Ri!T#Ri!U#Ri!V#Ri!W#Ri!X#Ri!Y#Ri!Z#Ri![#Ri!]#Ri!^#Ri!_#Ri$S#RiY#Rie#Ri!}#RiZ#Ri~P,6yOP'{OR'{OS#RiT#RiU#RiV#RiW#RiX#Ric#Rif#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri#V#Ri~OQ5eO~P,<sOP'|OR'|OS#RiT#RiU#RiV#RiW#RiX#RiY#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri$S#Ri~OQ5fO~P,?mOP'}OR'}OW#RiX#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri$S#Ri~OQ5gO~P,BdOP(OOQ5hOR(OO~P,6yOP(POR(POS#RiT#RiU#RiV#RiW#RiX#RiY#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri$S#Ri~OQ5jO~P,E[OP(QOR(QO[#Rig#Rio#Rip#Riq#Rir#Ris#Rit#Riu#Riw#Rix#Riy#Riz#Ri{#Ri|#Ri}#Ri!O#Ri!P#Ri!Q#Ri!R#Ri!S#Ri!T#Ri!U#Ri!V#Ri!W#Ri!X#Ri!Y#Ri!Z#Ri![#Ri!]#Ri!^#Ri!_#Ri#W#Ri~OQ5kO~P,HUOP(ROR(ROS#RiT#RiU#RiV#RiW#RiX#RiZ#Ric#Rif#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri~OQ5dO~P,JlOP(SOR(SOS#RiT#RiU#RiV#RiW#RiX#Ric#Rif#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri#V#Ri~OQ5eO~P,MfOP(TOR(TOS#RiT#RiU#RiV#RiW#RiX#RiY#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri$S#Ri~OQ5fO~P-!`OP(UOR(UOW#RiX#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri$S#Ri~OQ5gO~P-%VOP(WOQ5hOR(WO~P,6yOP(XOR(XOS#RiT#RiU#RiV#RiW#RiX#RiY#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri$S#Ri~OQ5jO~P-'}OP(VOR(VO[#Rig#Rio#Rip#Riq#Rir#Ris#Rit#Riu#Riw#Rix#Riy#Riz#Ri{#Ri|#Ri}#Ri!O#Ri!P#Ri!Q#Ri!R#Ri!S#Ri!T#Ri!U#Ri!V#Ri!W#Ri!X#Ri!Y#Ri!Z#Ri![#Ri!]#Ri!^#Ri!_#Ri#W#Ri~OQ5kO~P-*wO_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klOP#RiQ#RiR#Ri~P,H[O[mOblO#WWO#jlO#klOP#RiQ#RiR#RiS#RiT#RiU#RiV#RiW#RiX#Ric#Rif#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri#V#RiZ#Ri~P' xO[mOblOfmO#O>PO#WWO#jlO#klOP#RiQ#RiR#RiS#RiT#RiU#RiV#RiW#RiX#RiY#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri$S#Ri~P' xO[mOblOfmO#WWO#jlO#klOP#RiQ#RiR#RiS#RiT#RiU#RiV#RiW#RiX#RiY#Ric#Rig#Rih#Ril#Rim#Rin#Riv#Ri!`#Ri!a#Ri!b#Ri!c#Ri!d#Ri!e#Ri!f#Ri!g#Ri!h#Ri!i#Ri!j#Ri!k#Ri!l#Ri!m#Ri!n#Ri!o#Ri!p#Ri!q#Ri!r#Ri!s#Ri!t#Ri!u#Ri!v#Ri#O#Ri$S#Ri~P' xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOP#RiQ#RiR#Ri~P,6yO_mO`mOamOblOfmOi4qOj4rOk4TO#O>PO#jlO#klOP#UXQ#UXR#UXg#UX~Ol#POvmO[#UXo#UXp#UXq#UXr#UXs#UXt#UXu#UXw#UXx#UXy#UXz#UX{#UX|#UX}#UX!O#UX!P#UX!Q#UX!R#UX!S#UX!T#UX!U#UX!V#UX!W#UX!X#UX!Y#UX!Z#UX![#UX!]#UX!^#UX!_#UX#W#UX~P-:rO[mOblO#WWO#jlO#klOP#UXQ#UXR#UXS#UXT#UXU#UXV#UXW#UXX#UXc#UXf#UXg#UXh#UXl#UXm#UXn#UXv#UX!`#UX!a#UX!b#UX!c#UX!d#UX!e#UX!f#UX!g#UX!h#UX!i#UX!j#UX!k#UX!l#UX!m#UX!n#UX!o#UX!p#UX!q#UX!r#UX!s#UX!t#UX!u#UX!v#UX#O#UX#V#UXZ#UX~P' xOi4qOj4rOk4TOo'cOq'cOr3fOt'cOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOl#UXv#UX~P$>ZO[mOblOfmO#WWO#jlO#klOP#UXQ#UXR#UXS#UXT#UXU#UXV#UXW#UXX#UXY#UXc#UXg#UXh#UXl#UXm#UXn#UXv#UX!`#UX!a#UX!b#UX!c#UX!d#UX!e#UX!f#UX!g#UX!h#UX!i#UX!j#UX!k#UX!l#UX!m#UX!n#UX!o#UX!p#UX!q#UX!r#UX!s#UX!t#UX!u#UX!v#UX#O#UX$S#UX~P' xOP#UXQ#UXR#UXS#UXT#UXU#UXV#UXW#UXX#UX[#UXb#UXc#UXf#UXg#UXh#UXl#UXm#UXn#UXv#UX!`#UX!a#UX!b#UX!c#UX!d#UX!e#UX!f#UX!g#UX!h#UX!i#UX!j#UX!k#UX!l#UX!m#UX!n#UX!o#UX!p#UX!q#UX!r#UX!s#UX!t#UX!u#UX!v#UX#O#UX#V#UX#W#UX#j#UX#k#UX~P' xOP5aOQ!{OR5aOg5rO!}$Yi~OS$YiT$YiU$YiV$YiW$YiX$Yic$Yif$Yih$Yil$Yim$Yin$Yiv$Yi!`$Yi!a$Yi!b$Yi!c$Yi!d$Yi!e$Yi!f$Yi!g$Yi!h$Yi!i$Yi!j$Yi!k$Yi!l$Yi!m$Yi!n$Yi!o$Yi!p$Yi!q$Yi!r$Yi!s$Yi!t$Yi!u$Yi!v$Yi#O$Yi~OP(ROQ5iOR(ROg(tOZ$Yi~P-JROP(SOQ5lOR(SOg:aO#V$Yi~P-JROP(TOQ5mOR(TOg(wO~P$DnOW$YiX$Yic$Yih$Yil$Yim$Yin$Yiv$Yi!`$Yi!a$Yi!b$Yi!c$Yi!d$Yi!e$Yi!f$Yi!g$Yi!h$Yi!i$Yi!j$Yi!k$Yi!l$Yi!m$Yi!n$Yi!o$Yi!p$Yi!q$Yi!r$Yi!s$Yi!t$Yi!u$Yi!v$Yi#O$Yi~OP(UOQ5nOR(UOg:bO$S$Yi~P-MpOP(WOQ5qOR(WOg(yO[$Yib$Yi#V$Yi#W$Yi#j$Yi#k$Yi~P-JROP5aOQ!{OR5aOg5rO!}!zi~OS!ziT!ziU!ziV!ziW!ziX!ziZ!zic!zif!zih!zil!zim!zin!ziv!zi!`!zi!a!zi!b!zi!c!zi!d!zi!e!zi!f!zi!g!zi!h!zi!i!zi!j!zi!k!zi!l!zi!m!zi!n!zi!o!zi!p!zi!q!zi!r!zi!s!zi!t!zi!u!zi!v!zi#O!zi~OP(ROQ5iOR(ROg(tO~P.#`OS!ziT!ziU!ziV!ziW!ziX!zic!zif!zih!zil!zim!zin!ziv!zi!`!zi!a!zi!b!zi!c!zi!d!zi!e!zi!f!zi!g!zi!h!zi!i!zi!j!zi!k!zi!l!zi!m!zi!n!zi!o!zi!p!zi!q!zi!r!zi!s!zi!t!zi!u!zi!v!zi#O!zi#V!zi~OP(SOQ5lOR(SOg:aO~P.&YOS!ziT!ziU!ziV!ziW!ziX!ziY!zic!zih!zil!zim!zin!ziv!zi!`!zi!a!zi!b!zi!c!zi!d!zi!e!zi!f!zi!g!zi!h!zi!i!zi!j!zi!k!zi!l!zi!m!zi!n!zi!o!zi!p!zi!q!zi!r!zi!s!zi!t!zi!u!zi!v!zi$S!zi~OP(TOQ5mOR(TOg(wO~P.)SOW!ziX!zic!zih!zil!zim!zin!ziv!zi!`!zi!a!zi!b!zi!c!zi!d!zi!e!zi!f!zi!g!zi!h!zi!i!zi!j!zi!k!zi!l!zi!m!zi!n!zi!o!zi!p!zi!q!zi!r!zi!s!zi!t!zi!u!zi!v!zi#O!zi~OP(UOQ5nOR(UOg:bO$S!zi~P.+yOP(WOQ5qOR(WOg(yO[!zib!zi#W!zi#j!zi#k!zi~P.&YO!}!zi~P5sO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO#V!zi~P.#`O[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~P.)SO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO[!zib!zi#W!zi#j!zi#k!zi~P.&YOP#mXQ#mXR#mX[#mX_#mX`#mXa#mXb#mXe#mXf#mXg#mXi#mXj#mXk#mXl#mXm#mXn#mXo#mXp#mXq#mXr#mXs#mXt#mXu#mXv#mXw#mXx#mXy#mXz#mX{#mX|#mX}#mX!O#mX!P#mX!Q#mX!R#mX!S#mX!T#mX!U#mX!V#mX!W#mX!X#mX!Y#mX!Z#mX![#mX!]#mX!^#mX!_#mX!`#mX!a#mX!b#mX!c#mX!d#mX!e#mX!f#mX!g#mX!h#mX!i#mX!j#mX!k#mX!l#mX!m#mX!n#mX!p#mX!q#mX!r#mX!s#mX!t#mX!u#mX!v#mX#O#mX#W#mX#j#mX#k#mX~O!}#sX~P.7rOS#sXT#sXU#sXV#sXW#sXX#sXc#sXf#sXh#sXl#sXm#sXn#sXv#sX!`#sX!a#sX!b#sX!c#sX!d#sX!e#sX!f#sX!g#sX!h#sX!i#sX!j#sX!k#sX!l#sX!m#sX!n#sX!o#sX!p#sX!q#sX!r#sX!s#sX!t#sX!u#sX!v#sX#O#sX#V#sXZ#sX~P.7rOS#sXT#sXU#sXV#sXW#sXX#sX[#sXb#sXc#sXf#sXh#sXl#sXm#sXn#sXv#sX!`#sX!a#sX!b#sX!c#sX!d#sX!e#sX!f#sX!g#sX!h#sX!i#sX!j#sX!k#sX!l#sX!m#sX!n#sX!o#sX!p#sX!q#sX!r#sX!s#sX!t#sX!u#sX!v#sX#O#sX#V#sX#W#sX#j#sX#k#sX~P.7rOP!|XQ!|XR!|X[!|X_!|X`!|Xa!|Xb!|Xe!|Xf!|Xg!|Xi!|Xj!|Xk!|Xl!|Xm!|Xn!|Xo!|Xp!|Xq!|Xr!|Xs!|Xt!|Xu!|Xv!|Xw!|Xx!|Xy!|Xz!|X{!|X|!|X}!|X!O!|X!P!|X!Q!|X!R!|X!S!|X!T!|X!U!|X!V!|X!W!|X!X!|X!Y!|X!Z!|X![!|X!]!|X!^!|X!_!|X!`!|X!a!|X!b!|X!c!|X!d!|X!e!|X!f!|X!g!|X!h!|X!i!|X!j!|X!k!|X!l!|X!m!|X!n!|X!p!|X!q!|X!r!|X!s!|X!t!|X!u!|X!v!|X#O!|X#W!|X#j!|X#k!|X~O!}#sX~P.B]OS#sXT#sXU#sXV#sXW#sXX#sXc#sXf#sXh#sXl#sXm#sXn#sXv#sX!`#sX!a#sX!b#sX!c#sX!d#sX!e#sX!f#sX!g#sX!h#sX!i#sX!j#sX!k#sX!l#sX!m#sX!n#sX!o#sX!p#sX!q#sX!r#sX!s#sX!t#sX!u#sX!v#sX#O#sX#V#sXZ#sX~P.B]OS#sXT#sXU#sXV#sXW#sXX#sX[#sXb#sXc#sXf#sXh#sXl#sXm#sXn#sXv#sX!`#sX!a#sX!b#sX!c#sX!d#sX!e#sX!f#sX!g#sX!h#sX!i#sX!j#sX!k#sX!l#sX!m#sX!n#sX!o#sX!p#sX!q#sX!r#sX!s#sX!t#sX!u#sX!v#sX#O#sX#V#sX#W#sX#j#sX#k#sX~P.B]O[$Wib$Wif$Wig$Wil$Wiv$Wi#O$Wi#W$Wi#j$Wi#k$WiS$WiT$WiU$WiV$WiW$WiX$Wic$Wih$Wim$Win$Wi!`$Wi!a$Wi!b$Wi!c$Wi!d$Wi!e$Wi!f$Wi!g$Wi!h$Wi!i$Wi!j$Wi!k$Wi!l$Wi!m$Wi!n$Wi!o$Wi!p$Wi!q$Wi!r$Wi!s$Wi!t$Wi!u$Wi!v$Wi#V$Wi~OP'zOQ5cOR'zO_$Wi`$Wia$Wii$Wij$Wik$Wio$Wip$Wiq$Wir$Wis$Wit$Wiu$Wiw$Wix$Wiy$Wiz$Wi{$Wi|$Wi}$Wi!O$Wi!P$Wi!Q$Wi!R$Wi!S$Wi!T$Wi!U$Wi!V$Wi!W$Wi!X$Wi!Y$Wi!Z$Wi![$Wi!]$Wi!^$Wi!_$Wi$S$WiY$Wie$Wi!}$WiZ$Wi~P.LvOP'yOR'yOS$WiT$WiU$WiV$WiW$WiX$WiZ$Wic$Wif$Wig$Wih$Wil$Wim$Win$Wiv$Wi!`$Wi!a$Wi!b$Wi!c$Wi!d$Wi!e$Wi!f$Wi!g$Wi!h$Wi!i$Wi!j$Wi!k$Wi!l$Wi!m$Wi!n$Wi!o$Wi!p$Wi!q$Wi!r$Wi!s$Wi!t$Wi!u$Wi!v$Wi#O$Wi~OQ5dO~P/$pOP'{OR'{OS$WiT$WiU$WiV$WiW$WiX$Wic$Wif$Wig$Wih$Wil$Wim$Win$Wiv$Wi!`$Wi!a$Wi!b$Wi!c$Wi!d$Wi!e$Wi!f$Wi!g$Wi!h$Wi!i$Wi!j$Wi!k$Wi!l$Wi!m$Wi!n$Wi!o$Wi!p$Wi!q$Wi!r$Wi!s$Wi!t$Wi!u$Wi!v$Wi#O$Wi#V$Wi~OQ5eO~P/'jOP'|OR'|OS$WiT$WiU$WiV$WiW$WiX$WiY$Wic$Wig$Wih$Wil$Wim$Win$Wiv$Wi!`$Wi!a$Wi!b$Wi!c$Wi!d$Wi!e$Wi!f$Wi!g$Wi!h$Wi!i$Wi!j$Wi!k$Wi!l$Wi!m$Wi!n$Wi!o$Wi!p$Wi!q$Wi!r$Wi!s$Wi!t$Wi!u$Wi!v$Wi$S$Wi~OQ5fO~P/*dOP'}OR'}OW$WiX$Wic$Wig$Wih$Wil$Wim$Win$Wiv$Wi!`$Wi!a$Wi!b$Wi!c$Wi!d$Wi!e$Wi!f$Wi!g$Wi!h$Wi!i$Wi!j$Wi!k$Wi!l$Wi!m$Wi!n$Wi!o$Wi!p$Wi!q$Wi!r$Wi!s$Wi!t$Wi!u$Wi!v$Wi#O$Wi$S$Wi~OQ5gO~P/-ZOP(OOQ5hOR(OO~P.LvOP(POR(POS$WiT$WiU$WiV$WiW$WiX$WiY$Wic$Wig$Wih$Wil$Wim$Win$Wiv$Wi!`$Wi!a$Wi!b$Wi!c$Wi!d$Wi!e$Wi!f$Wi!g$Wi!h$Wi!i$Wi!j$Wi!k$Wi!l$Wi!m$Wi!n$Wi!o$Wi!p$Wi!q$Wi!r$Wi!s$Wi!t$Wi!u$Wi!v$Wi#O$Wi$S$Wi~OQ5jO~P/0ROP(QOR(QO[$Wig$Wio$Wip$Wiq$Wir$Wis$Wit$Wiu$Wiw$Wix$Wiy$Wiz$Wi{$Wi|$Wi}$Wi!O$Wi!P$Wi!Q$Wi!R$Wi!S$Wi!T$Wi!U$Wi!V$Wi!W$Wi!X$Wi!Y$Wi!Z$Wi![$Wi!]$Wi!^$Wi!_$Wi#W$Wi~OQ5kO~P/2{OP5aOQ!{OR5aOg#Rq!}#Rq#V#Rq$S#Rq~OP'yOR'yOS#RqT#RqU#RqV#RqW#RqX#RqZ#Rqc#Rqf#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq~OQ5dO~P/5zO[#Rqb#Rqf#Rqg#Rql#Rqv#Rq#O#Rq#W#Rq#j#Rq#k#RqS#RqT#RqU#RqV#RqW#RqX#Rqc#Rqh#Rqm#Rqn#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#V#Rq~OP'zOQ5cOR'zO_#Rq`#Rqa#Rqi#Rqj#Rqk#Rqo#Rqp#Rqq#Rqr#Rqs#Rqt#Rqu#Rqw#Rqx#Rqy#Rqz#Rq{#Rq|#Rq}#Rq!O#Rq!P#Rq!Q#Rq!R#Rq!S#Rq!T#Rq!U#Rq!V#Rq!W#Rq!X#Rq!Y#Rq!Z#Rq![#Rq!]#Rq!^#Rq!_#Rq$S#RqY#Rqe#Rq!}#RqZ#Rq~P/8tOP'{OR'{OS#RqT#RqU#RqV#RqW#RqX#Rqc#Rqf#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq#V#Rq~OQ5eO~P/>nOP'|OR'|OS#RqT#RqU#RqV#RqW#RqX#RqY#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq$S#Rq~OQ5fO~P/AhOP'}OR'}OW#RqX#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq$S#Rq~OQ5gO~P/D_OP(OOQ5hOR(OO~P/8tOP(POR(POS#RqT#RqU#RqV#RqW#RqX#RqY#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq$S#Rq~OQ5jO~P/GVOP(QOR(QO[#Rqg#Rqo#Rqp#Rqq#Rqr#Rqs#Rqt#Rqu#Rqw#Rqx#Rqy#Rqz#Rq{#Rq|#Rq}#Rq!O#Rq!P#Rq!Q#Rq!R#Rq!S#Rq!T#Rq!U#Rq!V#Rq!W#Rq!X#Rq!Y#Rq!Z#Rq![#Rq!]#Rq!^#Rq!_#Rq#W#Rq~OQ5kO~P/JPOP(ROR(ROS#RqT#RqU#RqV#RqW#RqX#RqZ#Rqc#Rqf#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq~OQ5dO~P/LgOP(SOR(SOS#RqT#RqU#RqV#RqW#RqX#Rqc#Rqf#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq#V#Rq~OQ5eO~P0 aOP(TOR(TOS#RqT#RqU#RqV#RqW#RqX#RqY#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq$S#Rq~OQ5fO~P0$ZOP(UOR(UOW#RqX#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq$S#Rq~OQ5gO~P0'QOP(WOQ5hOR(WO~P/8tOP(XOR(XOS#RqT#RqU#RqV#RqW#RqX#RqY#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq$S#Rq~OQ5jO~P0)xOP(VOR(VO[#Rqg#Rqo#Rqp#Rqq#Rqr#Rqs#Rqt#Rqu#Rqw#Rqx#Rqy#Rqz#Rq{#Rq|#Rq}#Rq!O#Rq!P#Rq!Q#Rq!R#Rq!S#Rq!T#Rq!U#Rq!V#Rq!W#Rq!X#Rq!Y#Rq!Z#Rq![#Rq!]#Rq!^#Rq!_#Rq#W#Rq~OQ5kO~P0,rO_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klOP#RqQ#RqR#Rq~P/JVO[mOblO#WWO#jlO#klOP#RqQ#RqR#RqS#RqT#RqU#RqV#RqW#RqX#Rqc#Rqf#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq#V#RqZ#Rq~P' xO[mOblOfmO#O>PO#WWO#jlO#klOP#RqQ#RqR#RqS#RqT#RqU#RqV#RqW#RqX#RqY#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq$S#Rq~P' xO[mOblOfmO#WWO#jlO#klOP#RqQ#RqR#RqS#RqT#RqU#RqV#RqW#RqX#RqY#Rqc#Rqg#Rqh#Rql#Rqm#Rqn#Rqv#Rq!`#Rq!a#Rq!b#Rq!c#Rq!d#Rq!e#Rq!f#Rq!g#Rq!h#Rq!i#Rq!j#Rq!k#Rq!l#Rq!m#Rq!n#Rq!o#Rq!p#Rq!q#Rq!r#Rq!s#Rq!t#Rq!u#Rq!v#Rq#O#Rq$S#Rq~P' xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOP#RqQ#RqR#Rq~P/8tOP5aOQ!{OR5aOg5rO!}!zq~OS!zqT!zqU!zqV!zqW!zqX!zqZ!zqc!zqf!zqh!zql!zqm!zqn!zqv!zq!`!zq!a!zq!b!zq!c!zq!d!zq!e!zq!f!zq!g!zq!h!zq!i!zq!j!zq!k!zq!l!zq!m!zq!n!zq!o!zq!p!zq!q!zq!r!zq!s!zq!t!zq!u!zq!v!zq#O!zq~OP(ROQ5iOR(ROg(tO~P0=OOS!zqT!zqU!zqV!zqW!zqX!zqc!zqf!zqh!zql!zqm!zqn!zqv!zq!`!zq!a!zq!b!zq!c!zq!d!zq!e!zq!f!zq!g!zq!h!zq!i!zq!j!zq!k!zq!l!zq!m!zq!n!zq!o!zq!p!zq!q!zq!r!zq!s!zq!t!zq!u!zq!v!zq#O!zq#V!zq~OP(SOQ5lOR(SOg:aO~P0?xOS!zqT!zqU!zqV!zqW!zqX!zqY!zqc!zqh!zql!zqm!zqn!zqv!zq!`!zq!a!zq!b!zq!c!zq!d!zq!e!zq!f!zq!g!zq!h!zq!i!zq!j!zq!k!zq!l!zq!m!zq!n!zq!o!zq!p!zq!q!zq!r!zq!s!zq!t!zq!u!zq!v!zq$S!zq~OP(TOQ5mOR(TOg(wO~P0BrOW!zqX!zqc!zqh!zql!zqm!zqn!zqv!zq!`!zq!a!zq!b!zq!c!zq!d!zq!e!zq!f!zq!g!zq!h!zq!i!zq!j!zq!k!zq!l!zq!m!zq!n!zq!o!zq!p!zq!q!zq!r!zq!s!zq!t!zq!u!zq!v!zq#O!zq~OP(UOQ5nOR(UOg:bO$S!zq~P0EiOP(WOQ5qOR(WOg(yO[!zqb!zq#W!zq#j!zq#k!zq~P0?xO!}!zq~P5sO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO#V!zq~P0=OO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~P0BrO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO[!zqb!zq#W!zq#j!zq#k!zq~P0?xO!}#ga~P!:ROS#gaT#gaU#gaV#gaW#gaX#gac#gaf#gah#gal#gam#gan#gav#ga!`#ga!a#ga!b#ga!c#ga!d#ga!e#ga!f#ga!g#ga!h#ga!i#ga!j#ga!k#ga!l#ga!m#ga!n#ga!o#ga!p#ga!q#ga!r#ga!s#ga!t#ga!u#ga!v#ga#O#ga#V#gaZ#ga~P!:ROS#gaT#gaU#gaV#gaW#gaX#gaY#gac#gah#gal#gam#gan#gav#ga!`#ga!a#ga!b#ga!c#ga!d#ga!e#ga!f#ga!g#ga!h#ga!i#ga!j#ga!k#ga!l#ga!m#ga!n#ga!o#ga!p#ga!q#ga!r#ga!s#ga!t#ga!u#ga!v#ga$S#ga~P!:ROS#gaT#gaU#gaV#gaW#gaX#ga[#gab#gac#gaf#gah#gal#gam#gan#gav#ga!`#ga!a#ga!b#ga!c#ga!d#ga!e#ga!f#ga!g#ga!h#ga!i#ga!j#ga!k#ga!l#ga!m#ga!n#ga!o#ga!p#ga!q#ga!r#ga!s#ga!t#ga!u#ga!v#ga#O#ga#V#ga#W#ga#j#ga#k#ga~P!:ROP5aOQ!{OR5aOg#Ry!}#Ry#V#Ry$S#Ry~OP'yOR'yOS#RyT#RyU#RyV#RyW#RyX#RyZ#Ryc#Ryf#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry~OQ5dO~P1,RO[#Ryb#Ryf#Ryg#Ryl#Ryv#Ry#O#Ry#W#Ry#j#Ry#k#RyS#RyT#RyU#RyV#RyW#RyX#Ryc#Ryh#Rym#Ryn#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#V#Ry~OP'zOQ5cOR'zO_#Ry`#Rya#Ryi#Ryj#Ryk#Ryo#Ryp#Ryq#Ryr#Rys#Ryt#Ryu#Ryw#Ryx#Ryy#Ryz#Ry{#Ry|#Ry}#Ry!O#Ry!P#Ry!Q#Ry!R#Ry!S#Ry!T#Ry!U#Ry!V#Ry!W#Ry!X#Ry!Y#Ry!Z#Ry![#Ry!]#Ry!^#Ry!_#Ry$S#RyY#Rye#Ry!}#RyZ#Ry~P1.{OP'{OR'{OS#RyT#RyU#RyV#RyW#RyX#Ryc#Ryf#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry#V#Ry~OQ5eO~P14uOP'|OR'|OS#RyT#RyU#RyV#RyW#RyX#RyY#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry$S#Ry~OQ5fO~P17oOP'}OR'}OW#RyX#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry$S#Ry~OQ5gO~P1:fOP(OOQ5hOR(OO~P1.{OP(POR(POS#RyT#RyU#RyV#RyW#RyX#RyY#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry$S#Ry~OQ5jO~P1=^OP(QOR(QO[#Ryg#Ryo#Ryp#Ryq#Ryr#Rys#Ryt#Ryu#Ryw#Ryx#Ryy#Ryz#Ry{#Ry|#Ry}#Ry!O#Ry!P#Ry!Q#Ry!R#Ry!S#Ry!T#Ry!U#Ry!V#Ry!W#Ry!X#Ry!Y#Ry!Z#Ry![#Ry!]#Ry!^#Ry!_#Ry#W#Ry~OQ5kO~P1@WOP(ROR(ROS#RyT#RyU#RyV#RyW#RyX#RyZ#Ryc#Ryf#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry~OQ5dO~P1BnOP(SOR(SOS#RyT#RyU#RyV#RyW#RyX#Ryc#Ryf#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry#V#Ry~OQ5eO~P1EhOP(TOR(TOS#RyT#RyU#RyV#RyW#RyX#RyY#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry$S#Ry~OQ5fO~P1HbOP(UOR(UOW#RyX#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry$S#Ry~OQ5gO~P1KXOP(WOQ5hOR(WO~P1.{OP(XOR(XOS#RyT#RyU#RyV#RyW#RyX#RyY#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry$S#Ry~OQ5jO~P1NPOP(VOR(VO[#Ryg#Ryo#Ryp#Ryq#Ryr#Rys#Ryt#Ryu#Ryw#Ryx#Ryy#Ryz#Ry{#Ry|#Ry}#Ry!O#Ry!P#Ry!Q#Ry!R#Ry!S#Ry!T#Ry!U#Ry!V#Ry!W#Ry!X#Ry!Y#Ry!Z#Ry![#Ry!]#Ry!^#Ry!_#Ry#W#Ry~OQ5kO~P2!yO_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klOP#RyQ#RyR#Ry~P1@^O[mOblO#WWO#jlO#klOP#RyQ#RyR#RyS#RyT#RyU#RyV#RyW#RyX#Ryc#Ryf#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry#V#RyZ#Ry~P' xO[mOblOfmO#O>PO#WWO#jlO#klOP#RyQ#RyR#RyS#RyT#RyU#RyV#RyW#RyX#RyY#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry$S#Ry~P' xO[mOblOfmO#WWO#jlO#klOP#RyQ#RyR#RyS#RyT#RyU#RyV#RyW#RyX#RyY#Ryc#Ryg#Ryh#Ryl#Rym#Ryn#Ryv#Ry!`#Ry!a#Ry!b#Ry!c#Ry!d#Ry!e#Ry!f#Ry!g#Ry!h#Ry!i#Ry!j#Ry!k#Ry!l#Ry!m#Ry!n#Ry!o#Ry!p#Ry!q#Ry!r#Ry!s#Ry!t#Ry!u#Ry!v#Ry#O#Ry$S#Ry~P' xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOP#RyQ#RyR#Ry~P1.{OP5aOQ!{OR5aOg5rO!}!zy~OS!zyT!zyU!zyV!zyW!zyX!zyZ!zyc!zyf!zyh!zyl!zym!zyn!zyv!zy!`!zy!a!zy!b!zy!c!zy!d!zy!e!zy!f!zy!g!zy!h!zy!i!zy!j!zy!k!zy!l!zy!m!zy!n!zy!o!zy!p!zy!q!zy!r!zy!s!zy!t!zy!u!zy!v!zy#O!zy~OP(ROQ5iOR(ROg(tO~P23VOS!zyT!zyU!zyV!zyW!zyX!zyc!zyf!zyh!zyl!zym!zyn!zyv!zy!`!zy!a!zy!b!zy!c!zy!d!zy!e!zy!f!zy!g!zy!h!zy!i!zy!j!zy!k!zy!l!zy!m!zy!n!zy!o!zy!p!zy!q!zy!r!zy!s!zy!t!zy!u!zy!v!zy#O!zy#V!zy~OP(SOQ5lOR(SOg:aO~P26POS!zyT!zyU!zyV!zyW!zyX!zyY!zyc!zyh!zyl!zym!zyn!zyv!zy!`!zy!a!zy!b!zy!c!zy!d!zy!e!zy!f!zy!g!zy!h!zy!i!zy!j!zy!k!zy!l!zy!m!zy!n!zy!o!zy!p!zy!q!zy!r!zy!s!zy!t!zy!u!zy!v!zy$S!zy~OP(TOQ5mOR(TOg(wO~P28yOW!zyX!zyc!zyh!zyl!zym!zyn!zyv!zy!`!zy!a!zy!b!zy!c!zy!d!zy!e!zy!f!zy!g!zy!h!zy!i!zy!j!zy!k!zy!l!zy!m!zy!n!zy!o!zy!p!zy!q!zy!r!zy!s!zy!t!zy!u!zy!v!zy#O!zy~OP(UOQ5nOR(UOg:bO$S!zy~P2;pOP(WOQ5qOR(WOg(yO[!zyb!zy#W!zy#j!zy#k!zy~P26PO!}!zy~P5sO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO#V!zy~P23VO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~P28yO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO[!zyb!zy#W!zy#j!zy#k!zy~P26POP5aOQ!{OR5aOg#R!R!}#R!R#V#R!R$S#R!R~OP'yOR'yOS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RZ#R!Rc#R!Rf#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R~OQ5dO~P2HQO[#R!Rb#R!Rf#R!Rg#R!Rl#R!Rv#R!R#O#R!R#W#R!R#j#R!R#k#R!RS#R!RT#R!RU#R!RV#R!RW#R!RX#R!Rc#R!Rh#R!Rm#R!Rn#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#V#R!R~OP'zOQ5cOR'zO_#R!R`#R!Ra#R!Ri#R!Rj#R!Rk#R!Ro#R!Rp#R!Rq#R!Rr#R!Rs#R!Rt#R!Ru#R!Rw#R!Rx#R!Ry#R!Rz#R!R{#R!R|#R!R}#R!R!O#R!R!P#R!R!Q#R!R!R#R!R!S#R!R!T#R!R!U#R!R!V#R!R!W#R!R!X#R!R!Y#R!R!Z#R!R![#R!R!]#R!R!^#R!R!_#R!R$S#R!RY#R!Re#R!R!}#R!RZ#R!R~P2JzOP'{OR'{OS#R!RT#R!RU#R!RV#R!RW#R!RX#R!Rc#R!Rf#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R#V#R!R~OQ5eO~P3!tOP'|OR'|OS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RY#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R$S#R!R~OQ5fO~P3%nOP'}OR'}OW#R!RX#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R$S#R!R~OQ5gO~P3(eOP(OOQ5hOR(OO~P2JzOP(POR(POS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RY#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R$S#R!R~OQ5jO~P3+]OP(QOR(QO[#R!Rg#R!Ro#R!Rp#R!Rq#R!Rr#R!Rs#R!Rt#R!Ru#R!Rw#R!Rx#R!Ry#R!Rz#R!R{#R!R|#R!R}#R!R!O#R!R!P#R!R!Q#R!R!R#R!R!S#R!R!T#R!R!U#R!R!V#R!R!W#R!R!X#R!R!Y#R!R!Z#R!R![#R!R!]#R!R!^#R!R!_#R!R#W#R!R~OQ5kO~P3.VOP(ROR(ROS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RZ#R!Rc#R!Rf#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R~OQ5dO~P30mOP(SOR(SOS#R!RT#R!RU#R!RV#R!RW#R!RX#R!Rc#R!Rf#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R#V#R!R~OQ5eO~P33gOP(TOR(TOS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RY#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R$S#R!R~OQ5fO~P36aOP(UOR(UOW#R!RX#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R$S#R!R~OQ5gO~P39WOP(WOQ5hOR(WO~P2JzOP(XOR(XOS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RY#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R$S#R!R~OQ5jO~P3<OOP(VOR(VO[#R!Rg#R!Ro#R!Rp#R!Rq#R!Rr#R!Rs#R!Rt#R!Ru#R!Rw#R!Rx#R!Ry#R!Rz#R!R{#R!R|#R!R}#R!R!O#R!R!P#R!R!Q#R!R!R#R!R!S#R!R!T#R!R!U#R!R!V#R!R!W#R!R!X#R!R!Y#R!R!Z#R!R![#R!R!]#R!R!^#R!R!_#R!R#W#R!R~OQ5kO~P3>xO_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klOP#R!RQ#R!RR#R!R~P3.]O[mOblO#WWO#jlO#klOP#R!RQ#R!RR#R!RS#R!RT#R!RU#R!RV#R!RW#R!RX#R!Rc#R!Rf#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R#V#R!RZ#R!R~P' xO[mOblOfmO#O>PO#WWO#jlO#klOP#R!RQ#R!RR#R!RS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RY#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R$S#R!R~P' xO[mOblOfmO#WWO#jlO#klOP#R!RQ#R!RR#R!RS#R!RT#R!RU#R!RV#R!RW#R!RX#R!RY#R!Rc#R!Rg#R!Rh#R!Rl#R!Rm#R!Rn#R!Rv#R!R!`#R!R!a#R!R!b#R!R!c#R!R!d#R!R!e#R!R!f#R!R!g#R!R!h#R!R!i#R!R!j#R!R!k#R!R!l#R!R!m#R!R!n#R!R!o#R!R!p#R!R!q#R!R!r#R!R!s#R!R!t#R!R!u#R!R!v#R!R#O#R!R$S#R!R~P' xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOP#R!RQ#R!RR#R!R~P2JzOP5aOQ!{OR5aOg5rO!}!z!R~OS!z!RT!z!RU!z!RV!z!RW!z!RX!z!RZ!z!Rc!z!Rf!z!Rh!z!Rl!z!Rm!z!Rn!z!Rv!z!R!`!z!R!a!z!R!b!z!R!c!z!R!d!z!R!e!z!R!f!z!R!g!z!R!h!z!R!i!z!R!j!z!R!k!z!R!l!z!R!m!z!R!n!z!R!o!z!R!p!z!R!q!z!R!r!z!R!s!z!R!t!z!R!u!z!R!v!z!R#O!z!R~OP(ROQ5iOR(ROg(tO~P4 UOS!z!RT!z!RU!z!RV!z!RW!z!RX!z!Rc!z!Rf!z!Rh!z!Rl!z!Rm!z!Rn!z!Rv!z!R!`!z!R!a!z!R!b!z!R!c!z!R!d!z!R!e!z!R!f!z!R!g!z!R!h!z!R!i!z!R!j!z!R!k!z!R!l!z!R!m!z!R!n!z!R!o!z!R!p!z!R!q!z!R!r!z!R!s!z!R!t!z!R!u!z!R!v!z!R#O!z!R#V!z!R~OP(SOQ5lOR(SOg:aO~P4$OOS!z!RT!z!RU!z!RV!z!RW!z!RX!z!RY!z!Rc!z!Rh!z!Rl!z!Rm!z!Rn!z!Rv!z!R!`!z!R!a!z!R!b!z!R!c!z!R!d!z!R!e!z!R!f!z!R!g!z!R!h!z!R!i!z!R!j!z!R!k!z!R!l!z!R!m!z!R!n!z!R!o!z!R!p!z!R!q!z!R!r!z!R!s!z!R!t!z!R!u!z!R!v!z!R$S!z!R~OP(TOQ5mOR(TOg(wO~P4&xOW!z!RX!z!Rc!z!Rh!z!Rl!z!Rm!z!Rn!z!Rv!z!R!`!z!R!a!z!R!b!z!R!c!z!R!d!z!R!e!z!R!f!z!R!g!z!R!h!z!R!i!z!R!j!z!R!k!z!R!l!z!R!m!z!R!n!z!R!o!z!R!p!z!R!q!z!R!r!z!R!s!z!R!t!z!R!u!z!R!v!z!R#O!z!R~OP(UOQ5nOR(UOg:bO$S!z!R~P4)oOP(WOQ5qOR(WOg(yO[!z!Rb!z!R#W!z!R#j!z!R#k!z!R~P4$OO!}!z!R~P5sO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO#V!z!R~P4 UO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~P4&xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO[!z!Rb!z!R#W!z!R#j!z!R#k!z!R~P4$OOP5aOQ!{OR5aOg#R!Z!}#R!Z#V#R!Z$S#R!Z~OP'yOR'yOS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZZ#R!Zc#R!Zf#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z~OQ5dO~P46PO[#R!Zb#R!Zf#R!Zg#R!Zl#R!Zv#R!Z#O#R!Z#W#R!Z#j#R!Z#k#R!ZS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!Zc#R!Zh#R!Zm#R!Zn#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#V#R!Z~OP'zOQ5cOR'zO_#R!Z`#R!Za#R!Zi#R!Zj#R!Zk#R!Zo#R!Zp#R!Zq#R!Zr#R!Zs#R!Zt#R!Zu#R!Zw#R!Zx#R!Zy#R!Zz#R!Z{#R!Z|#R!Z}#R!Z!O#R!Z!P#R!Z!Q#R!Z!R#R!Z!S#R!Z!T#R!Z!U#R!Z!V#R!Z!W#R!Z!X#R!Z!Y#R!Z!Z#R!Z![#R!Z!]#R!Z!^#R!Z!_#R!Z$S#R!ZY#R!Ze#R!Z!}#R!ZZ#R!Z~P48yOP'{OR'{OS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!Zc#R!Zf#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z#V#R!Z~OQ5eO~P4>sOP'|OR'|OS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZY#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z$S#R!Z~OQ5fO~P4AmOP'}OR'}OW#R!ZX#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z$S#R!Z~OQ5gO~P4DdOP(OOQ5hOR(OO~P48yOP(POR(POS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZY#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z$S#R!Z~OQ5jO~P4G[OP(QOR(QO[#R!Zg#R!Zo#R!Zp#R!Zq#R!Zr#R!Zs#R!Zt#R!Zu#R!Zw#R!Zx#R!Zy#R!Zz#R!Z{#R!Z|#R!Z}#R!Z!O#R!Z!P#R!Z!Q#R!Z!R#R!Z!S#R!Z!T#R!Z!U#R!Z!V#R!Z!W#R!Z!X#R!Z!Y#R!Z!Z#R!Z![#R!Z!]#R!Z!^#R!Z!_#R!Z#W#R!Z~OQ5kO~P4JUOP(ROR(ROS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZZ#R!Zc#R!Zf#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z~OQ5dO~P4LlOP(SOR(SOS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!Zc#R!Zf#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z#V#R!Z~OQ5eO~P5 fOP(TOR(TOS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZY#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z$S#R!Z~OQ5fO~P5$`OP(UOR(UOW#R!ZX#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z$S#R!Z~OQ5gO~P5'VOP(WOQ5hOR(WO~P48yOP(XOR(XOS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZY#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z$S#R!Z~OQ5jO~P5)}OP(VOR(VO[#R!Zg#R!Zo#R!Zp#R!Zq#R!Zr#R!Zs#R!Zt#R!Zu#R!Zw#R!Zx#R!Zy#R!Zz#R!Z{#R!Z|#R!Z}#R!Z!O#R!Z!P#R!Z!Q#R!Z!R#R!Z!S#R!Z!T#R!Z!U#R!Z!V#R!Z!W#R!Z!X#R!Z!Y#R!Z!Z#R!Z![#R!Z!]#R!Z!^#R!Z!_#R!Z#W#R!Z~OQ5kO~P5,wO_mO`mOamOblOfmOi4qOj4rOk4TOl#POvmO#O>PO#jlO#klOP#R!ZQ#R!ZR#R!Z~P4J[O[mOblO#WWO#jlO#klOP#R!ZQ#R!ZR#R!ZS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!Zc#R!Zf#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z#V#R!ZZ#R!Z~P' xO[mOblOfmO#O>PO#WWO#jlO#klOP#R!ZQ#R!ZR#R!ZS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZY#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z$S#R!Z~P' xO[mOblOfmO#WWO#jlO#klOP#R!ZQ#R!ZR#R!ZS#R!ZT#R!ZU#R!ZV#R!ZW#R!ZX#R!ZY#R!Zc#R!Zg#R!Zh#R!Zl#R!Zm#R!Zn#R!Zv#R!Z!`#R!Z!a#R!Z!b#R!Z!c#R!Z!d#R!Z!e#R!Z!f#R!Z!g#R!Z!h#R!Z!i#R!Z!j#R!Z!k#R!Z!l#R!Z!m#R!Z!n#R!Z!o#R!Z!p#R!Z!q#R!Z!r#R!Z!s#R!Z!t#R!Z!u#R!Z!v#R!Z#O#R!Z$S#R!Z~P' xO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXOP#R!ZQ#R!ZR#R!Z~P48yOP5aOQ!{OR5aOg5rO!}!z!Z~OS!z!ZT!z!ZU!z!ZV!z!ZW!z!ZX!z!ZZ!z!Zc!z!Zf!z!Zh!z!Zl!z!Zm!z!Zn!z!Zv!z!Z!`!z!Z!a!z!Z!b!z!Z!c!z!Z!d!z!Z!e!z!Z!f!z!Z!g!z!Z!h!z!Z!i!z!Z!j!z!Z!k!z!Z!l!z!Z!m!z!Z!n!z!Z!o!z!Z!p!z!Z!q!z!Z!r!z!Z!s!z!Z!t!z!Z!u!z!Z!v!z!Z#O!z!Z~OP(ROQ5iOR(ROg(tO~P5=TOS!z!ZT!z!ZU!z!ZV!z!ZW!z!ZX!z!Zc!z!Zf!z!Zh!z!Zl!z!Zm!z!Zn!z!Zv!z!Z!`!z!Z!a!z!Z!b!z!Z!c!z!Z!d!z!Z!e!z!Z!f!z!Z!g!z!Z!h!z!Z!i!z!Z!j!z!Z!k!z!Z!l!z!Z!m!z!Z!n!z!Z!o!z!Z!p!z!Z!q!z!Z!r!z!Z!s!z!Z!t!z!Z!u!z!Z!v!z!Z#O!z!Z#V!z!Z~OP(SOQ5lOR(SOg:aO~P5?}OS!z!ZT!z!ZU!z!ZV!z!ZW!z!ZX!z!ZY!z!Zc!z!Zh!z!Zl!z!Zm!z!Zn!z!Zv!z!Z!`!z!Z!a!z!Z!b!z!Z!c!z!Z!d!z!Z!e!z!Z!f!z!Z!g!z!Z!h!z!Z!i!z!Z!j!z!Z!k!z!Z!l!z!Z!m!z!Z!n!z!Z!o!z!Z!p!z!Z!q!z!Z!r!z!Z!s!z!Z!t!z!Z!u!z!Z!v!z!Z$S!z!Z~OP(TOQ5mOR(TOg(wO~P5BwOW!z!ZX!z!Zc!z!Zh!z!Zl!z!Zm!z!Zn!z!Zv!z!Z!`!z!Z!a!z!Z!b!z!Z!c!z!Z!d!z!Z!e!z!Z!f!z!Z!g!z!Z!h!z!Z!i!z!Z!j!z!Z!k!z!Z!l!z!Z!m!z!Z!n!z!Z!o!z!Z!p!z!Z!q!z!Z!r!z!Z!s!z!Z!t!z!Z!u!z!Z!v!z!Z#O!z!Z~OP(UOQ5nOR(UOg:bO$S!z!Z~P5EnOP(WOQ5qOR(WOg(yO[!z!Zb!z!Z#W!z!Z#j!z!Z#k!z!Z~P5?}O!}!z!Z~P5sO[mO_mO`mOamOblOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#WWO#jlO#klO#V!z!Z~P5=TO[mO_mO`mOamOblOfmOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO#O>PO#WWO#jlO#klO~P5BwO_mO`mOamOi4qOj4rOk4TOo'cOpXOq'cOr3fOsXOt'cOuXOwXOx'cOy3fOz<pO{AhO|DxO}GXO!OXO!P'iO!Q4SO!R=cO!SBZO!TEkO!UGzO!V4SO!W'iO!XXO!Y'cO!Z3fO![<pO!]AhO!^DxO!_GXO[!z!Zb!z!Z#W!z!Z#j!z!Z#k!z!Z~P5?}OP5aOQ!{OR5aOg5rO~OP(ROQ5iOR(ROg(tO~OP(SOQ5lOR(SOg:aO~OP(TOQ5mOR(TOg(wO~OP(UOQ5nOR(UOg:bO~OP(WOQ5qOR(WOg(yO~OP(XOQ5pOR(XOg(sO~OP'zOQ5cOR'zOg(^O~O[mO_mO`mOamOblOfmOi=fOj=kOkA^Ol#POo3XOpXOq3XOrA[OsXOt3XOuXOvmOwXOx3XOyA[OzDpO{GRO|HcO}HrO!O'gO!P'lO!Q=_O!RBVO!SEgO!TGvO!UHhO!V=_O!W'lO!XXO!Y3XO!ZA[O![DpO!]GRO!^HcO!_HrO#O>PO#WWO#jlO#klO~OP#mXQ#mXR#mXg#mX!}#mX~P5sOP#mXQ#mXR#mXg#mX#V#mX~P5sO!}*vOP!{XQ!{XR!{Xg!{X~O!}*wOP#fXQ#fXR#fXg#fX~O!}*xOP#fXQ#fXR#fXg#fX~O!}*yOP#fXQ#fXR#fXg#fX~O!}*zOP#fXQ#fXR#fXg#fX~O!}+^O~OQ,sO~P#5wOQ,uO~P#5wOQ,rO~P#5wOQ,tO~P#5wOQ,vO~P#5wOP'zOQ5cOR'zOg(^OW$ZaX$Zac$Zah$Zam$Zan$Za!`$Za!a$Za!b$Za!c$Za!d$Za!e$Za!f$Za!g$Za!h$Za!i$Za!j$Za!k$Za!l$Za!m$Za!n$Za!o$Za!p$Za!q$Za!r$Za!s$Za!t$Za!u$Za!v$Za$S$Za~P6%{OP'zOQ5cOR'zOg(^O~P6%{O[-^O#W8SO~P#AOO[-_O#W8TO~P#AOO[-`O#W8UO~P#AOO[-aO#W8VO~P#AOO#V/RO~P%#PO#V/SO~P%#PO#V/TO~P%#PO#V/UO~P%#POQ5iO~P)'xOQ5lO~P)0lOQ5mO~P)3fOQ5nO~P)6]OP(OOQ5qOR(OO~P)*rOQ5pO~P)9TOQ5oO~P);}OQ5iO~P)>eOQ5lO~P)A_OQ5mO~P)DXOQ5nO~P)GOOP(WOQ5qOR(WO~P)*rOQ5pO~P)IvOQ5oO~P)LpOQ5iO~P,4POQ5lO~P,<sOQ5mO~P,?mOQ5nO~P,BdOP(OOQ5qOR(OO~P,6yOQ5pO~P,E[OQ5oO~P,HUOQ5iO~P,JlOQ5lO~P,MfOQ5mO~P-!`OQ5nO~P-%VOP(WOQ5qOR(WO~P,6yOQ5pO~P-'}OQ5oO~P-*wOQ5iO~P/$pOQ5lO~P/'jOQ5mO~P/*dOQ5nO~P/-ZOP(OOQ5qOR(OO~P.LvOQ5pO~P/0ROQ5oO~P/2{OQ5iO~P/5zOQ5lO~P/>nOQ5mO~P/AhOQ5nO~P/D_OP(OOQ5qOR(OO~P/8tOQ5pO~P/GVOQ5oO~P/JPOQ5iO~P/LgOQ5lO~P0 aOQ5mO~P0$ZOQ5nO~P0'QOP(WOQ5qOR(WO~P/8tOQ5pO~P0)xOQ5oO~P0,rOQ5iO~P1,ROQ5lO~P14uOQ5mO~P17oOQ5nO~P1:fOP(OOQ5qOR(OO~P1.{OQ5pO~P1=^OQ5oO~P1@WOQ5iO~P1BnOQ5lO~P1EhOQ5mO~P1HbOQ5nO~P1KXOP(WOQ5qOR(WO~P1.{OQ5pO~P1NPOQ5oO~P2!yOQ5iO~P2HQOQ5lO~P3!tOQ5mO~P3%nOQ5nO~P3(eOP(OOQ5qOR(OO~P2JzOQ5pO~P3+]OQ5oO~P3.VOQ5iO~P30mOQ5lO~P33gOQ5mO~P36aOQ5nO~P39WOP(WOQ5qOR(WO~P2JzOQ5pO~P3<OOQ5oO~P3>xOQ5iO~P46POQ5lO~P4>sOQ5mO~P4AmOQ5nO~P4DdOP(OOQ5qOR(OO~P48yOQ5pO~P4G[OQ5oO~P4JUOQ5iO~P4LlOQ5lO~P5 fOQ5mO~P5$`OQ5nO~P5'VOP(WOQ5qOR(WO~P48yOQ5pO~P5)}OQ5oO~P5,wO",goto:"+$s$_PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP$`$c%b!BmPP#1l#MY$;S%*P%*P%EmPP%Ha&7q&7{P&8Y&8q&8u&9Y&9Y&9Y&9o&9u&9Y&9{'(n')w'FXPP(4q)!{)@P)@P*.T*.t*.t*/e$`*/l*/l*/p$`*/s*/y*6y*7_*7v*8U*8e*8s*9QPPP*9W*9a+!s*.T*.T+#[+#q+$aR!]OQ!VOQ!W!XQ!cPr!oW!k!x#^#x$a$h${%d%k%m%w&m8S8T8U8VQ#y![U#{!^>P>QQ%i#tX5b$f<l<m<nQYOS#O[3ZQ#Q]Q#R^Q#S_Q#T`Q#Ua(Y#Vbc}!O!U#W#X#a#m#n#s$t$u%_%`&U&V&a&b&u&v&{&|'U'V'Y'Z'^'`'d'e'f'g'h'i'j'k'l'm'n't'u'v'w)y)z){)|)}*O*Q*m*n*o*p,l,m,n,o,p,q-Y-Z-[-].l.m.n.o.p.q.}/O/P/Q0T0U0V0W0X0Y0f0g0h0i1h1i1j1k1l1m1y1z1{1|2_2`2a2b2c2j2k2l2m5W5X5Y5Z6b6c6d6e6f6m6n6o6p6q6{6|6}7O7P7Q7R7S7r7s7t7u7v8O8P8Q8R8u8v8w8x8y9R9S9T9U9t9u9v9w9x:Q:R:S:T:V:W:X:Y:Z:]:^:_:`={=|=}>OQ#XdQ#YeQ#ZfQ#[gQ#]hQ#`jS#bnrQ#gwQ#hxQ#iyQ#jzQ#k{Q#l|Q#n!PQ#o!QQ#p!RQ#q!SQ#r!TQ$O!aQ$m!{W$n!}#Q(x)wQ$o#RQ$p#SQ$q#TQ$r#UQ$u#YQ$v#ZQ$w#[Q$x#]Q%T#bQ%Y#hQ%Z#iQ%[#jQ%]#kQ%^#lQ%`#oQ%a#pQ%b#qQ%c#rQ&P$mS&Q$o,jQ&R$pQ&S$qQ&T$rQ&V$vQ&W$wQ&X$xQ&]%ZQ&^%[Q&_%]Q&`%^Q&b%aQ&c%bQ&d%cS&r&R.jQ&s&SQ&t&TQ&v&WQ&w&XQ&x&^Q&y&_Q&z&`Q&|&cQ&}&dS'S&s0RQ'T&tQ'V&wQ'W&yQ'X&zQ'Z&}S']'T1fQ'_'XQ(z2vQ({3eQ(|'cQ(}3dQ)O3bQ)P3`Q)Q3_Q)R3]Q)S3YQ)T3QQ)U2}Q)V2zQ)W2xQ)X2|Q)Y3SQ)Z3TQ)]3fQ)^3gQ)_3hQ)`3iQ)a3jQ)b3kQ)c3lQ)d3mQ)e3nQ)f3oQ)g3pQ)h3qQ)i3rQ)j3sQ)k3tQ)l3uQ)m3vQ)n3wQ)o3xQ)p3yQ)q3zQ)r3{Q)s3|Q)t3}Q)u4OQ)v4PQ)w4QQ)x4RQ*O4SQ*P4qS*R*t4sQ*S*sS*T*r4tQ*U*qS*V*u4uQ*b'oQ*c'pQ*d'qQ*e'rQ*f5QQ*g'sQ*h5RQ*i5SQ*j5TQ*k5UQ*l5VQ*{'xQ*|'yQ*}'zQ+O'{Q+P'|Q+Q'}Q+R(OQ+S(PQ+T(QQ+U5aQ+V(RQ+W(SQ+X(TQ+Y(UQ+Z(WQ+[(XS+]%Q(VQ+_5cQ+`5dQ+a5eQ+b5fQ+c5gQ+d5hQ+e5iQ+f5jQ+g5kQ+h5l^+i%R,r,s,t,u,v5oQ+j5mQ+k5nQ+l5qQ+m5pS+n5r5sS+o(_)^S+p(^)]S+q(`)_S+r(a)`S+s(b)aS+t(c)bS+u(e)dS+v(f)eS+w(j)iS+x(l)kS+y(n)mS+z(o)nS+{(r)qS+|(u)tS+}(v)uQ,O5tQ,P5uQ,Q5vQ,R5wQ,S5xQ,T5yQ,U5zQ,V5{Q,W5|Q,X5}Q,Y6OQ,Z6PQ,[6QQ,]6RQ,^6SQ,_6TQ,`6UQ,a6VQ,b6WQ,c6XQ,d6YQ,e6ZQ,f6[Q,g6]Q,h6^Q,i6_Q,j6`Q,k6aQ,q6gQ,w*RQ,x*SQ,y*TQ,z*UQ,{6rQ,|*VQ,}*hQ-O*iQ-P*jQ-Q*kQ-R6uQ-S*lQ-T6vQ-U6wQ-V6xQ-W6yQ-X6zQ-f+_Q-g+`Q-h+aQ-i+bQ-j+cQ-k+dQ-l+fQ-m+gQ-n7TQ-o,PQ-p,OQ-q,QQ-r,RQ-s,SQ-t,TQ-u,VQ-v,WQ-w,[Q-x,^Q-y,`Q-z,aQ-{,dQ-|,gQ-},hQ.O7UQ.P7VQ.Q7WQ.R7XQ.S7YQ.T7ZQ.U7[Q.V7]Q.W7^Q.X7_Q.Y7`Q.Z7aQ.[7bQ.]7cQ.^7dQ._7eQ.`7fQ.a7gQ.b7hQ.c7iQ.d7jQ.e7kQ.f7lQ.g7mQ.h7nQ.i7oQ.j7pQ.k7qQ.q7wQ.r-TQ.s-UQ.t-VQ.u-WQ.v7xQ.w-XQ.x7yQ.y7zQ.z7{Q.{7|Q.|7}Q/V8WQ/W.PQ/X.OQ/Y.QQ/Z.RQ/[.SQ/].TQ/^.VQ/_.WQ/`.[Q/a.^Q/b.`Q/c.aQ/d.dQ/e.gQ/f.hQ/g8XQ/h8YQ/i8ZQ/j8[Q/k8]Q/l8^Q/m8_Q/n8`Q/o8aQ/p8bQ/q8cQ/r8dQ/s8eQ/t8fQ/u8gQ/v8hQ/w8iQ/x8jQ/y8kQ/z8lQ/{8mQ/|8nQ/}8oQ0O8pQ0P8qQ0Q8rQ0R8sQ0S8tQ0Y8zQ0Z.xQ0[.yQ0].zQ0^.{Q0_8{Q0`.|Q0a8|Q0b8}Q0c9OQ0d9PQ0e9QQ0j9VQ0k/hQ0l/gQ0m/iQ0n/jQ0o/kQ0p/lQ0q/nQ0r/oQ0s/sQ0t/uQ0u/wQ0v/xQ0w/{Q0x0OQ0y0PQ0z9WQ0{9XQ0|9YQ0}9ZQ1O9[Q1P9]Q1Q9^Q1R9_Q1S9`Q1T9aQ1U9bQ1V9cQ1W9dQ1X9eQ1Y9fQ1Z9gQ1[9hQ1]9iQ1^9jQ1_9kQ1`9lQ1a9mQ1b9nQ1c9oQ1d9pQ1e9qQ1f9rQ1g9sQ1m9yQ1n0aQ1o0bQ1p0cQ1q0dQ1r9zQ1s0eQ1t9{Q1u9|Q1v9}Q1w:OQ1x:PQ1}:UQ2O0{Q2P0zQ2Q0|Q2R0}Q2S1OQ2T1PQ2U1RQ2V1SQ2W1WQ2X1YQ2Y1[Q2Z1]Q2[1`Q2]1cQ2^1dQ2d1tQ2e1uQ2f1vQ2g1wQ2h:[Q2i1xh2nPW!^!k$f*W*]<l<m<n>P>QS2o*X*^S2p*Y*_S2q*Z*`S2r6s6tS2s*[*aS2t#e#fb2u#^$a$}%d%x8S8T8U8VQ5s<oQ5t<pQ5u<qQ5v<rQ5w<sQ5x<tQ5y<uQ5z<vQ5{<wQ5|<xQ5}<yQ6O<zQ6P<{Q6Q<|Q6R<}Q6S=OQ6T=PQ6U=QQ6V=RQ6W=SQ6X=TQ6Y=UQ6Z=VQ6[=WQ6]=XQ6^=YQ6_=ZQ6`=[Q6a=]Q6b=^Q6c=_Q6d=`Q6e=aQ6f=bQ6g=cQ6h=eQ6i=fQ6j=gQ6k=hQ6l=iQ6r#uQ6u=qQ6v=rQ6w=sQ6x=tQ6y=uQ6z=vQ6{=wQ6|=xQ6}=yQ7O=zQ7T>RQ7U>SQ7V>TQ7W>UQ7X>VQ7Y>WQ7Z>XQ7[>YQ7]>ZQ7^>[Q7_>]Q7`>^Q7a>_Q7b>`Q7c>aQ7d>bQ7e>cQ7f>dQ7g>eQ7h>fQ7i>gQ7j>hQ7k>iQ7l>jQ7m>kQ7n>lQ7o>mQ7p>nQ7q>oQ7r>pQ7s>qQ7t>rQ7u>sQ7v>tQ7w>uQ7x>vQ7y>wQ7z>xQ7{>yQ7|>zQ7}>{Q8O>|Q8P>}Q8Q?OQ8R?PQ8W?QQ8X?RQ8Y?SQ8Z?TQ8[?UQ8]?VQ8^?WQ8_?XQ8`?YQ8a?ZQ8b?[Q8c?]Q8d?^Q8e?_Q8f?`Q8g?aQ8h?bQ8i?cQ8j?dQ8k?eQ8l?fQ8m?gQ8n?hQ8o?iQ8p?jQ8q?kQ8r?lQ8s?mQ8t?nQ8u?oQ8v?pQ8w?qQ8x?rQ8y?sQ8z?tQ8{?uQ8|?vQ8}?wQ9O?xQ9P?yQ9Q?zQ9R?{Q9S?|Q9T?}Q9U@OQ9V@PQ9W@QQ9X@RQ9Y@SQ9Z@TQ9[@UQ9]@VQ9^@WQ9_@XQ9`@YQ9a@ZQ9b@[Q9c@]Q9d@^Q9e@_Q9f@`Q9g@aQ9h@bQ9i@cQ9j@dQ9k@eQ9l@fQ9m@gQ9n@hQ9o@iQ9p@jQ9q@kQ9r@lQ9s@mQ9t@nQ9u@oQ9v@pQ9w@qQ9x@rQ9y@sQ9z@tQ9{@uQ9|@vQ9}@wQ:O@xQ:P@yQ:Q@zQ:R@{Q:S@|Q:T@}Q:UAOQ:VAPQ:WAQQ:XARQ:YASQ:ZATQ:[AUQ:]AVQ:^AWQ:_AXQ:`AYQ:c3^Q:d3VQ:e3RQ:f3OQ:g2{Q:h2wQ:i2yQ:j3PQ:k3UQ:l3WQ:m3XQ:n3[Q:o3aQ:p3cQ:qAZQ:rA[S:s(d)cS:t(g)fS:u(i)hS:v(k)jS:w(m)lS:x(p)oS:y(q)pS:z(t)sS:{:a:qS:|(w)vS:}:b:rS;O(y)xS;P(s)rS;Q(h)gQ;RA_Q;SA`Q;T+eQ;U+hQ;V+jQ;W+kQ;X+lQ;Y+mQ;Z+iQ;[,UQ;],XQ;^,ZQ;_,]Q;`,_Q;a,bQ;b,cQ;c,fQ;d;RQ;e,iQ;f;SQ;g,kQ;h,eQ;i,YQ;jAaQ;kAbQ;l.UQ;m.XQ;n.ZQ;o.]Q;p._Q;q.bQ;r.cQ;s.fQ;t;jQ;u.iQ;v;kQ;w.kQ;x.eQ;y.YQ;zAcQ;{AdQ;|/mQ;}/pQ<O/rQ<P/tQ<Q/vQ<R/yQ<S/zQ<T/}Q<U;zQ<V0QQ<W;{Q<X0SQ<Y/|Q<Z/qQ<[AeQ<]AfQ<^1QQ<_1TQ<`1VQ<a1XQ<b1ZQ<c1^Q<d1_Q<e1bQ<f<[Q<g1eQ<h<]Q<i1gQ<j1aQ<k1UQ>RAgQ>SAhQ>TAiQ>UAjQ>VAkQ>WAlQ>XAmQ>YAnQ>ZAoQ>[ApQ>]AqQ>^ArQ>_AsQ>`AtQ>aAuQ>bAvQ>cAwQ>dAxQ>eAyQ>fAzQ>gA{Q>hA|Q>iA}Q>jBOQ>kBPQ>lBQQ>mBRQ>nBSQ>oBTQ>pBUQ>qBVQ>rBWQ>sBXQ>tBYQ>uBZQ>vB[Q>wB]Q>xB^Q>yB_Q>zB`Q>{BaQ>|BbQ>}BcQ?OBdQ?PBeQ?QBfQ?RBgQ?SBhQ?TBiQ?UBjQ?VBkQ?WBlQ?XBmQ?YBnQ?ZBoQ?[BpQ?]BqQ?^BrQ?_BsQ?`BtQ?aBuQ?bBvQ?cBwQ?dBxQ?eByQ?fBzQ?gB{Q?hB|Q?iB}Q?jCOQ?kCPQ?lCQQ?mCRQ?nCSQ?oCTQ?pCUQ?qCVQ?rCWQ?sCXQ?tCYQ?uCZQ?vC[Q?wC]Q?xC^Q?yC_Q?zC`Q?{CaQ?|CbQ?}CcQ@OCdQ@PCeQ@QCfQ@RCgQ@SChQ@TCiQ@UCjQ@VCkQ@WClQ@XCmQ@YCnQ@ZCoQ@[CpQ@]CqQ@^CrQ@_CsQ@`CtQ@aCuQ@bCvQ@cCwQ@dCxQ@eCyQ@fCzQ@gC{Q@hC|Q@iC}Q@jDOQ@kDPQ@lDQQ@mDRQ@nDSQ@oDTQ@pDUQ@qDVQ@rDWQ@sDXQ@tDYQ@uDZQ@vD[Q@wD]Q@xD^Q@yD_Q@zD`Q@{DaQ@|DbQ@}DcQAODdQAPDeQAQDfQARDgQASDhQATDiQAUDjQAVDkQAWDlQAXDmQAYDnQA_DoQA`DpQAaDqQAbDrQAcDsQAdDtQAeDuQAfDvQBfDwQBgDxQBhDyQBiDzQBjD{QBkD|QBlD}QBmEOQBnEPQBoEQQBpERQBqESQBrETQBsEUQBtEVQBuEWQBvEXQBwEYQBxEZQByE[QBzE]QB{E^QB|E_QB}E`QCOEaQCPEbQCQEcQCREdQCSEeQCTEfQCUEgQCVEhQCWEiQCXEjQCYEkQCZElQC[EmQC]EnQC^EoQC_EpQC`EqQCaErQCbEsQCcEtQCdEuQCeEvQCfEwQCgExQChEyQCiEzQCjE{QCkE|QClE}QCmFOQCnFPQCoFQQCpFRQCqFSQCrFTQCsFUQCtFVQCuFWQCvFXQCwFYQCxFZQCyF[QCzF]QC{F^QC|F_QC}F`QDOFaQDPFbQDQFcQDRFdQDSFeQDTFfQDUFgQDVFhQDWFiQDXFjQDYFkQDZFlQD[FmQD]FnQD^FoQD_FpQD`FqQDaFrQDbFsQDcFtQDdFuQDeFvQDfFwQDgFxQDhFyQDiFzQDjF{QDkF|QDlF}QDmGOQDnGPQDqGQQDrGRQDsGSQDtGTQDuGUQDvGVQEvGWQEwGXQExGYQEyGZQEzG[QE{G]QE|G^QE}G_QFOG`QFPGaQFQGbQFRGcQFSGdQFTGeQFUGfQFVGgQFWGhQFXGiQFYGjQFZGkQF[GlQF]GmQF^GnQF_GoQF`GpQFaGqQFbGrQFcGsQFdGtQFeGuQFfGvQFgGwQFhGxQFiGyQFjGzQFkG{QFlG|QFmG}QFnHOQFoHPQFpHQQFqHRQFrHSQFsHTQFtHUQFuHVQFvHWQFwHXQFxHYQFyHZQFzH[QF{H]QF|H^QF}H_QGOH`QGPHaQGSHbQGTHcQGUHdQGVHeQHVHfQHWHgQHXHhQHYHiQHZHjQH[HkQH]HlQH^HmQH_HnQH`HoQHaHpQHdHqRHeHrQpO!*pq[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#a#b#h#i#j#k#l#m#n#o#p#q#r#s#u$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'd'e'f'g'h'i'j'k'l'm'n'o'p'q'r's't'u'v'w'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y)z){)|)}*O*Q*R*S*T*U*V*h*i*j*k*l*m*n*o*p*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v-T-U-V-W-X-Y-Z-[-].O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.p.q.x.y.z.{.|.}/O/P/Q/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0U0V0W0X0Y0a0b0c0d0e0f0g0h0i0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1i1j1k1l1m1t1u1v1w1x1y1z1{1|2_2`2a2b2c2j2k2l2m2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr[!_P!^<l<m<n>QS!zW!kQ%P#^l%V#e#f*W*X*Y*Z*[*]*^*_*`*a6s6tQ%z$aQ%}$fY&h%d8S8T8U8VR5[>P!*VoOPW[]^_`abcdefghjnrwxyz{|!O!P!Q!R!S!T!U!^!a!k!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%`%a%b%c%d%x&R&S&T&U&V&W&X&^&_&`&b&c&d&s&t&u&v&w&y&z&|&}'T'U'V'X'Z'^'c'd'f'i'j'k'l'm'n'o'p'q'r's't'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y){*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,n,q,r,t-T-U-V-W-X-Y-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.n.q.x.y.z.{.|.}/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0V0Y0a0b0c0d0e0f0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1j1m1t1u1v1w1x1y1{2_2a2j2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8S8T8U8V8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr!)roOP[]^_`abcdefghjnrwxyz{|!O!P!Q!R!S!T!U!^!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#a#b#e#f#h#i#j#k#l#n#o#p#q#r#s#u$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%`%a%b%c%x&R&S&T&U&V&W&X&^&_&`&b&c&d&s&t&u&v&w&y&z&|&}'T'U'V'X'Z'^'c'd'f'i'j'k'l'm'n'o'p'q'r's't'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y){*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,n,q,r,t-T-U-V-W-X-Y-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.n.q.x.y.z.{.|.}/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0V0Y0a0b0c0d0e0f0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1j1m1t1u1v1w1x1y1{2_2a2j2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr`!o!x#x$h${%k%m%w&mc!pW!k#^$a%d8S8T8U8VQVOU!`P!^<l!+S!qW[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!a!k!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#h#i#j#k#l#m#n#o#p#q#r#s#u$a$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%d%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'd'e'f'g'h'i'j'k'l'm'n'o'p'q'r's't'u'v'w'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y)z){)|)}*O*Q*R*S*T*U*V*h*i*j*k*l*m*n*o*p*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v-T-U-V-W-X-Y-Z-[-].O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.p.q.x.y.z.{.|.}/O/P/Q/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0U0V0W0X0Y0a0b0c0d0e0f0g0h0i0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1i1j1k1l1m1t1u1v1w1x1y1z1{1|2_2`2a2b2c2j2k2l2m2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8S8T8U8V8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHrl%U#e#f*W*X*Y*Z*[*]*^*_*`*a6s6tQ%|$fQ5]>PQ5^<mQ5_>QR5`<n!*VXOPW[]^_`abcdefghjnrwxyz{|!O!P!Q!R!S!T!U!^!a!k!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%`%a%b%c%d%x&R&S&T&U&V&W&X&^&_&`&b&c&d&s&t&u&v&w&y&z&|&}'T'U'V'X'Z'^'c'd'f'i'j'k'l'm'n'o'p'q'r's't'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y){*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,n,q,r,t-T-U-V-W-X-Y-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.n.q.x.y.z.{.|.}/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0V0Y0a0b0c0d0e0f0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1j1m1t1u1v1w1x1y1{2_2a2j2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8S8T8U8V8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHrQ!}iQ#ak^%S#`*P6h6i6j6k6lQ(^4TQ(_4UQ(`4VQ(a4WQ(b4XQ(c4YQ(d4ZQ(e4[Q(f4]Q(g4^Q(h4_Q(i4`Q(j4aQ(k4bQ(l4cQ(m4dQ(n4eQ(o4fQ(p4gQ(q4hQ(r4iQ(s4jQ(t4kQ(u4lQ(v4mQ(w4nQ(x4oQ(y4pQ*Q4rQ5r=dQ6m=jQ6n=kQ6o=lQ6p=mQ6q=nQ:aA]R:bA^!*xoOPW[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!k!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%d%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'e'f'g'i'j'k'l'm'n'o'p'q'r's't'u'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)z){)|*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,m,n,o,q,s,t,u-T-U-V-W-X-Y-Z-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.m.n.o.q.x.y.z.{.|.}/O/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0U0V0W0Y0a0b0c0d0e0f0g0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1i1j1k1m1t1u1v1w1x1y1z1{2`2a2b2j2k2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8S8T8U8V8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr#O#_ik#`*P4T4U4V4W4X4Y4Z4[4]4^4_4`4a4b4c4d4e4f4g4h4i4j4k4l4m4n4o4p4r6h6i6j6k6l=d=j=k=l=m=nA]A^Q%f#sQ-b7PQ-c7QQ-d7RR-e7Sa!rW!k#^%d8S8T8U8V`!lW!k#^%d8S8T8U8VR%m#xW!wW!k!x$h`$z#^#x$a${%k%m%w&mZ&e%d8S8T8U8VS!WO!Xs!oW!k!x#^#x$a$h${%d%k%m%w&m8S8T8U8VwUOW![!k!x#^#x$a$h${%d%k%m%w&m8S8T8U8VQ$X!fR%v$`Q%s$XR&o%v!+lqOP[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#s#u$f$m$o$p$q$r$t$u$v$w$x%Q%R%Z%[%]%^%_%`%a%b%c&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'd'e'f'g'h'i'j'k'l'm'n'o'p'q'r's't'u'v'w'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y)z){)|)}*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*p*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v-T-U-V-W-X-Y-Z-[-].O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.p.q.x.y.z.{.|.}/O/P/Q/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0U0V0W0X0Y0a0b0c0d0e0f0g0h0i0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1i1j1k1l1m1t1u1v1w1x1y1z1{1|2_2`2a2b2c2j2k2l2m2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHrS!zW!kW$|#^$a$}%xZ&f%d8S8T8U8V#O#_ik#`*P4T4U4V4W4X4Y4Z4[4]4^4_4`4a4b4c4d4e4f4g4h4i4j4k4l4m4n4o4p4r6h6i6j6k6l=d=j=k=l=m=nA]A^Z%g#s7P7Q7R7S!*toOP[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'e'f'g'i'j'k'l'm'n'o'p'q'r's't'u'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)z){)|*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,m,n,o,q,s,t,u-T-U-V-W-X-Y-Z-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.m.n.o.q.x.y.z.{.|.}/O/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0U0V0W0Y0a0b0c0d0e0f0g0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1i1j1k1m1t1u1v1w1x1y1z1{2`2a2b2j2k2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr^!sW!k%d8S8T8U8VQ!w!xS$b!t$dR&O$h!+UoOP[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'd'e'f'g'i'j'k'l'm'n'o'p'q'r's't'u'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y)z){)|*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,q,r,s,t,u-T-U-V-W-X-Y-Z-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.q.x.y.z.{.|.}/O/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0U0V0W0Y0a0b0c0d0e0f0g0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1i1j1k1m1t1u1v1w1x1y1z1{2_2`2a2b2j2k2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr^!sW!k%d8S8T8U8VQ!w!xS$b!t$dR&O$h!*toOP[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'e'f'g'i'j'k'l'm'n'o'p'q'r's't'u'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)z){)|*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,m,n,o,q,s,t,u-T-U-V-W-X-Y-Z-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.m.n.o.q.x.y.z.{.|.}/O/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0U0V0W0Y0a0b0c0d0e0f0g0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1i1j1k1m1t1u1v1w1x1y1z1{2`2a2b2j2k2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr^!vW!k%d8S8T8U8VT!w!x$h!+toOP[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'd'e'f'g'h'i'j'k'l'm'n'o'p'q'r's't'u'v'w'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)y)z){)|)}*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*p*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v-T-U-V-W-X-Y-Z-[-].O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.p.q.x.y.z.{.|.}/O/P/Q/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0T0U0V0W0X0Y0a0b0c0d0e0f0g0h0i0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1h1i1j1k1l1m1t1u1v1w1x1y1z1{1|2_2`2a2b2c2j2k2l2m2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr^!yW!k%d8S8T8U8VQ#ftQ*]4{Q*^4|Q*_4}Q*`5OQ*a5PR6t=p!+TqOPW[]^_`abcdefghjnrwxyz{|}!O!P!Q!R!S!T!U!^!a!k!{!}#Q#R#S#T#U#W#X#Y#Z#[#]#^#a#b#e#f#h#i#j#k#l#m#n#o#p#q#r#s#u$a$f$m$o$p$q$r$t$u$v$w$x$}%Q%R%Z%[%]%^%_%`%a%b%c%d%x&R&S&T&U&V&W&X&^&_&`&a&b&c&d&s&t&u&v&w&y&z&{&|&}'T'U'V'X'Y'Z'^'`'c'e'f'g'i'j'k'l'm'n'o'p'q'r's't'u'v'x'y'z'{'|'}(O(P(Q(R(S(T(U(V(W(X(^(_(`(a(b(c(d(e(f(g(h(i(j(k(l(m(n(o(p(q(r(s(t(u(v(w(x(y)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x)z){)|*O*Q*R*S*T*U*V*W*X*Y*Z*[*]*^*_*`*a*h*i*j*k*l*m*n*o*q*r*s*t*u+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m,O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,m,n,o,q,s,t,u-T-U-V-W-X-Y-Z-[.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.m.n.o.q.x.y.z.{.|.}/O/P/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0U0V0W0Y0a0b0c0d0e0f0g0h0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1i1j1k1m1t1u1v1w1x1y1z1{2`2a2b2j2k2l2v2w2x2y2z2{2|2}3O3P3Q3R3S3T3U3V3W3X3Y3Z3[3]3^3_3`3a3b3c3d3e3f3g3h3i3j3k3l3m3n3o3p3q3r3s3t3u3v3w3x3y3z3{3|3}4O4P4Q4R4S4q4s4t4u5Q5R5S5T5U5V5W5X5Y5Z5a5c5d5e5f5g5h5i5j5k5l5m5n5o5p5q5r5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6m6n6o6p6q6r6s6t6u6v6w6x6y6z6{6|6}7O7P7Q7R7S7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8S8T8U8V8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:a:b:q:r;R;S;j;k;z;{<[<]<l<m<n<o<p<q<r<s<t<u<v<w<x<y<z<{<|<}=O=P=Q=R=S=T=U=V=W=X=Y=Z=[=]=^=_=`=a=b=c=e=f=g=h=i=q=r=s=t=u=v=w=x=y=z={=|=}>O>P>Q>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYAZA[A_A`AaAbAcAdAeAfAgAhAiAjAkAlAmAnAoApAqArAsAtAuAvAwAxAyAzA{A|A}BOBPBQBRBSBTBUBVBWBXBYBZB[B]B^B_B`BaBbBcBdBeBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDoDpDqDrDsDtDuDvDwDxDyDzD{D|D}EOEPEQERESETEUEVEWEXEYEZE[E]E^E_E`EaEbEcEdEeEfEgEhEiEjEkElEmEnEoEpEqErEsEtEuEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGQGRGSGTGUGVGWGXGYGZG[G]G^G_G`GaGbGcGdGeGfGgGhGiGjGkGlGmGnGoGpGqGrGsGtGuGvGwGxGyGzG{G|G}HOHPHQHRHSHTHUHVHWHXHYHZH[H]H^H_H`HaHbHcHdHeHfHgHhHiHjHkHlHmHnHoHpHqHr!]vOPW!X![!^!k!x#^#t#x$a$f$h${%d%k%m%w&m8S8T8U8V<l<m<n>P>Q!]uOPW!X![!^!k!x#^#t#x$a$f$h${%d%k%m%w&m8S8T8U8V<l<m<n>P>QZ%h#s7P7Q7R7ST!ZO![R#x!YQ!XOR#v!XQ!|'iS#WbcS#m}!OQ#s!U$S$s#W#m#s$t%_&U&a&u&{'U'Y'^'`)y)z){)|)}*m*n*o*p,l,m,n,o,p-Y-Z-[-].l.m.n.o.p.}/O/P/Q0T0U0V0W0X0f0g0h0i1h1i1j1k1l1y1z1{1|2_2`2a2b2c2j2k2l2m7P7Q7R7SS$t#X#aS%S*O*QQ%_#nQ&U$uQ&a%`Q&q,qQ&u&VQ&{&bQ'R.qQ'U&vQ'Y&|Q'[0YQ'^'VQ'`'ZQ'a1mS)y'd'mS)z'e'jS){'f'nS)|'g'lS)}'h'kS*m't5WS*n'u5XS*o'v5YS*p'w5ZS,l6d6oS,m6b6mS,n6e6pS,o6c6nS,p6f6qQ-Y6{Q-Z6|Q-[6}Q-]7OQ.l7tQ.m7rQ.n7uQ.o7sQ.p7vQ.}8OQ/O8PQ/P8QQ/Q8RQ0T8wQ0U8uQ0V8xQ0W8vQ0X8yQ0f9RQ0g9SQ0h9TQ0i9UQ1h9vQ1i9tQ1j9wQ1k9uQ1l9xQ1y:QQ1z:RQ1{:SQ1|:TQ2_:XQ2`:VQ2a:YQ2b:WQ2c:ZQ2j:]Q2k:^Q2l:_Q2m:`Q7P={Q7Q=|Q7R=}R7S>O^!jW#^%d8S8T8U8VU$]!j$^&jQ$^!kR&j%j[${#^%d8S8T8U8VQ%k#xQ%w$aW&Y${%k%w&mR&m%mQ$S!dQ$U!eQ$Y!gV%o$S$U$Y[$}#^%d8S8T8U8VQ%x$aT&[$}%xb!tW!k$d$h%d8S8T8U8VR$c!t`!xW!k$h%d8S8T8U8VR$i!xQ![OR#z![^!bP!^<l<m<n>P>Q! q!|Y#O#Q#R#S#T#U#V#X#Y#Z#[#]#`#b#g#h#i#j#k#l#n#o#p#q#r$O$m$n$o$p$q$r$u$v$w$x%T%Y%Z%[%]%^%`%a%b%c&P&Q&R&S&T&V&W&X&]&^&_&`&b&c&d&r&s&t&v&w&x&y&z&|&}'S'T'V'W'X'Z']'_(z({(|(})O)P)Q)R)S)T)U)V)W)X)Y)Z)])^)_)`)a)b)c)d)e)f)g)h)i)j)k)l)m)n)o)p)q)r)s)t)u)v)w)x*O*P*R*S*T*U*V*b*c*d*e*f*g*h*i*j*k*l*{*|*}+O+P+Q+R+S+T+U+V+W+X+Y+Z+[+]+_+`+a+b+c+d+e+f+g+h+i+j+k+l+m+n+o+p+q+r+s+t+u+v+w+x+y+z+{+|+},O,P,Q,R,S,T,U,V,W,X,Y,Z,[,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,q,w,x,y,z,{,|,}-O-P-Q-R-S-T-U-V-W-X-f-g-h-i-j-k-l-m-n-o-p-q-r-s-t-u-v-w-x-y-z-{-|-}.O.P.Q.R.S.T.U.V.W.X.Y.Z.[.].^._.`.a.b.c.d.e.f.g.h.i.j.k.q.r.s.t.u.v.w.x.y.z.{.|/V/W/X/Y/Z/[/]/^/_/`/a/b/c/d/e/f/g/h/i/j/k/l/m/n/o/p/q/r/s/t/u/v/w/x/y/z/{/|/}0O0P0Q0R0S0Y0Z0[0]0^0_0`0a0b0c0d0e0j0k0l0m0n0o0p0q0r0s0t0u0v0w0x0y0z0{0|0}1O1P1Q1R1S1T1U1V1W1X1Y1Z1[1]1^1_1`1a1b1c1d1e1f1g1m1n1o1p1q1r1s1t1u1v1w1x1}2O2P2Q2R2S2T2U2V2W2X2Y2Z2[2]2^2d2e2f2g2h2i2n2o2p2q2r2s2t2u5s5t5u5v5w5x5y5z5{5|5}6O6P6Q6R6S6T6U6V6W6X6Y6Z6[6]6^6_6`6a6b6c6d6e6f6g6h6i6j6k6l6r6u6v6w6x6y6z6{6|6}7O7T7U7V7W7X7Y7Z7[7]7^7_7`7a7b7c7d7e7f7g7h7i7j7k7l7m7n7o7p7q7r7s7t7u7v7w7x7y7z7{7|7}8O8P8Q8R8W8X8Y8Z8[8]8^8_8`8a8b8c8d8e8f8g8h8i8j8k8l8m8n8o8p8q8r8s8t8u8v8w8x8y8z8{8|8}9O9P9Q9R9S9T9U9V9W9X9Y9Z9[9]9^9_9`9a9b9c9d9e9f9g9h9i9j9k9l9m9n9o9p9q9r9s9t9u9v9w9x9y9z9{9|9}:O:P:Q:R:S:T:U:V:W:X:Y:Z:[:]:^:_:`:c:d:e:f:g:h:i:j:k:l:m:n:o:p:q:r:s:t:u:v:w:x:y:z:{:|:};O;P;Q;R;S;T;U;V;W;X;Y;Z;[;];^;_;`;a;b;c;d;e;f;g;h;i;j;k;l;m;n;o;p;q;r;s;t;u;v;w;x;y;z;{;|;}<O<P<Q<R<S<T<U<V<W<X<Y<Z<[<]<^<_<`<a<b<c<d<e<f<g<h<i<j<k>R>S>T>U>V>W>X>Y>Z>[>]>^>_>`>a>b>c>d>e>f>g>h>i>j>k>l>m>n>o>p>q>r>s>t>u>v>w>x>y>z>{>|>}?O?P?Q?R?S?T?U?V?W?X?Y?Z?[?]?^?_?`?a?b?c?d?e?f?g?h?i?j?k?l?m?n?o?p?q?r?s?t?u?v?w?x?y?z?{?|?}@O@P@Q@R@S@T@U@V@W@X@Y@Z@[@]@^@_@`@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@{@|@}AOAPAQARASATAUAVAWAXAYA_A`AaAbAcAdAeAfBfBgBhBiBjBkBlBmBnBoBpBqBrBsBtBuBvBwBxByBzB{B|B}COCPCQCRCSCTCUCVCWCXCYCZC[C]C^C_C`CaCbCcCdCeCfCgChCiCjCkClCmCnCoCpCqCrCsCtCuCvCwCxCyCzC{C|C}DODPDQDRDSDTDUDVDWDXDYDZD[D]D^D_D`DaDbDcDdDeDfDgDhDiDjDkDlDmDnDqDrDsDtDuDvEvEwExEyEzE{E|E}FOFPFQFRFSFTFUFVFWFXFYFZF[F]F^F_F`FaFbFcFdFeFfFgFhFiFjFkFlFmFnFoFpFqFrFsFtFuFvFwFxFyFzF{F|F}GOGPGSGTGUGVHVHWHXHYHZH[H]H^H_H`HaHdHeS!ZO![s!mW!k!x#^#x$a$h${%d%k%m%w&m8S8T8U8VQ#esQ*W4vQ*X4wQ*Y4xQ*Z4yQ*[4zR6s=o^#ds4v4w4x4y4z=oQ#ftQ*]4{Q*^4|Q*_4}Q*`5OQ*a5PR6t=p^%W#e*W*X*Y*Z*[6s_%X#f*]*^*_*`*a6t",nodeNames:"⚠ ReporterLeft1Args ReporterLeft2Args ReporterLeft1ArgsOpt GlobalStr ExtensionStr BreedStr Own Set Let To End Identifier Command Reporter TurtleVar PatchVar LinkVar Constant Unsupported SpecialReporter SpecialCommand BreedToken AndOr APCommand APReporterFlip APReporterVar APReporter UnsupportedPrim SpecialCommandCreateTurtle SpecialCommandCreateLink SpecialReporter1ArgsBoth SpecialReporter0ArgsLink SpecialReporter1ArgsLink SpecialReporter2ArgsTurtle SpecialReporter0ArgsTurtle SpecialReporter1ArgsTurtle SpecialReporter0ArgsLinkP SpecialCommandCreateTurtlePossible Reporter0Args Reporter1Args Reporter2Args Reporter3Args Reporter4Args Reporter5Args Reporter6Args Reporter0ArgsVar Reporter1ArgsVar Reporter2ArgsVar Reporter3ArgsVar Reporter4ArgsVar Reporter5ArgsVar Reporter6ArgsVar Reporter2ArgsVar0 Reporter1ArgsVar0 SpecialReporter0Args SpecialReporter1Args SpecialReporter2Args SpecialReporter3Args SpecialReporter4Args SpecialReporter5Args SpecialReporter6Args Command0Args Command1Args Command2Args Command3Args Command4Args Command5Args Command6Args Command0ArgsVar Command1ArgsVar Command2ArgsVar Command3ArgsVar Command4ArgsVar Command5ArgsVar Command6ArgsVar Command3ArgsVar2 Command1_2ArgsOpt SpecialCommand0Args SpecialCommand1Args SpecialCommand2Args SpecialCommand3Args SpecialCommand4Args SpecialCommand5Args SpecialCommand6Args LineComment Program Embedded CommandStatement Arg Value CloseParen OpenParen Parenthetical WorseParentheticals ReporterStatement Parenthetical Parenthetical Reporters CloseBracket OpenBracket AnonymousProcedure AnonArguments Arguments Arrow ProcedureContent Parenthetical Error Extensions Globals Breed BreedPlural BreedSingular BreedsOwn ReporterContent ShortAnonymousProcedure List Literal Numeric String CodeBlock VariableName ReporterBlock Property VariableDeclaration NewVariableDeclaration SetVariable Commands Normal Misplaced Procedure ProcedureName OnelineReporter",maxTerm:152,context:contextTracker,nodeProps:[["openedBy",91,"OpenParen",99,"OpenBracket"],["closedBy",92,"CloseParen",100,"CloseBracket"]],skippedNodes:[0,13,14,20,85],repeatNodeCount:9,tokenData:"&d~R]XYzYZz]^zpqzrs!]xy#yyz$O}!O$T!O!P$a!Q![%^!]!^%q!}#O&Y#P#Q&_~!PS$U~XYzYZz]^zpqz~!`VOr!]rs!us#O!]#O#P!z#P;'S!];'S;=`#s<%lO!]~!zO#k~~!}RO;'S!];'S;=`#W;=`O!]~#ZWOr!]rs!us#O!]#O#P!z#P;'S!];'S;=`#s;=`<%l!]<%lO!]~#vP;=`<%l!]~$OO#O~~$TO!}~~$WR!O!P$a!Q![%^!`!a%l~$dP!Q![$g~$lQ#j~!Q![$g#X#Y$r~$uR{|%O}!O%O!Q![%U~%RP!Q![%U~%ZP#j~!Q![%U~%cR#j~!O!P$g!Q![%^#X#Y$r~%qO#[~~%vS!w~OY%qZ;'S%q;'S;=`&S<%lO%q~&VP;=`<%l%q~&_O#W~~&dO#V~",tokenizers:[0,keyword],topRules:{Program:[0,86]},dynamicPrecedences:{94:-2,120:-1},specialized:[{term:14,get:(O,R)=>specializeReporter(O)<<1,external:specializeReporter},{term:20,get:(O,R)=>specializeSpecialReporter(O)<<1,external:specializeSpecialReporter},{term:13,get:(O,R)=>specializeCommand(O)<<1,external:specializeCommand},{term:21,get:(O,R)=>specializeSpecialCommand(O)<<1,external:specializeSpecialCommand}],tokenPrec:0});

    const getCheckContext=function(e,r,t){return {state:e.state,preprocessState:t,parseState:r,breedNames:r.GetBreedNames(),breedVars:r.GetBreedVariables()}};const acceptableIdentifiers=["Unrecognized","NewVariableDeclaration","ProcedureName","Arguments","AnonArguments","Globals","BreedSingular","BreedPlural","BreedsOwn","Extensions"];const checkValidIdentifier=function(e,r,t){var o,n;if(r=r.toLowerCase(),acceptableIdentifiers.includes(null!==(n=null===(o=e.parent)||void 0===o?void 0:o.name)&&void 0!==n?n:""))return !0;if(t.parseState.Globals.has(r)||t.parseState.WidgetGlobals.has(r)||t.parseState.Procedures.has(r)||t.preprocessState.Commands.has(r)||t.preprocessState.Reporters.has(r))return !0;if(t.breedNames.includes(r)||t.breedVars.includes(r))return !0;return getLocalVariables(e,t.state,t.parseState).includes(r)};const getLocalVariables=function(e,r,t){let o=[],n=null;var a=getParentProcedure(r,e);if(a&&(n=t.Procedures.get(a.toLowerCase())),!n&&!a&&"Model"!=r.field(stateExtension).RecognizedMode)for(var s of t.Procedures.values())s.EditorID==r.field(stateExtension).EditorID&&(n=s);return n?(n.Variables.map((r=>{r.CreationPos<e.from&&o.push(r.Name);})),gatherAnonymousVariables(n.AnonymousProcedures,e,o),gatherAnonymousVariables(n.CodeBlocks,e,o),n.Arguments&&o.push(...n.Arguments),o):o};const gatherAnonymousVariables=function(e,r,t){e.map((e=>{r.from>=e.PositionStart&&r.to<=e.PositionEnd&&(e.Variables.map((e=>{e.CreationPos<r.from&&t.push(e.Name);})),t.push(...e.Arguments),gatherAnonymousVariables(e.CodeBlocks,r,t),gatherAnonymousVariables(e.AnonymousProcedures,r,t));}));};function checkUndefinedBreed(e,r,t,o){let n=getCodeName(t.state,o),a=MatchBreed(n,r,!0);if(!a.Valid&&a.Plural){if(!checkUnrecognizedWithSuggestions(e,t,o)){let r=getDiagnostic(t,o,"Unrecognized breed name _","error",a.Plural);void 0!==a.Type&&addBreedAction(r,a.Type,a.Plural,a.Singular),e.push(r);}return !0}if(a.Valid||0==a.Tag)return !1;{let r=getDiagnostic(t,o,"Invalid breed type _","error");return e.push(r),!0}}const UnrecognizedSuggestions={else:"ifelse","%":"mod","{":"[","}":"]","create-patch":"ask patch 0 0","create-patches":"ask patches","create-link":"create-link-with","create-links":"create-links-with","set-patch-color":"set pcolor","set-world-size":"resize-world",return:"report"};function checkUnrecognizedWithSuggestions(e,r,t){var o=getCodeName(r.state,t);if(UnrecognizedSuggestions.hasOwnProperty(o)){let n=getDiagnostic(r,t,"Unrecognized identifier with replacement _","error",o,UnrecognizedSuggestions[o]);return AddReplaceAction(n,UnrecognizedSuggestions[o]),e.push(n),!0}return !1}

    class AutoCompletion{constructor(e){this.BuiltinVariables=this.KeywordsToCompletions([...turtleVars,...patchVars,...linkVars],"Variable-Builtin"),this.SharedIdentifiers=[{label:"end",type:"Directive"},...this.BuiltinVariables,...this.KeywordsToCompletions(constants,"Constant")],this.LastExtensions="$NIL$",this.LastPrimitives=[],this.ParentMaps={Extensions:this.KeywordsToCompletions(PrimitiveManager.GetExtensions(),"Extension"),Program:this.KeywordsToCompletions(directives,"Directive"),Globals:[],BreedsOwn:[],Breed:[],ProcedureName:[],Arguments:[]},this.ParentTypes=Object.keys(this.ParentMaps),this.Editor=e;}KeywordsToCompletions(e,t){return e.map((function(e){return {label:e,type:t}}))}GetParentKeywords(e,t){let r=this.ParentMaps[e];switch(e){case"Extensions":r=r.filter((e=>!t.Extensions.has(e.label)));break;case"VariableName":r=r.concat(this.KeywordsToCompletions([...t.Globals.keys(),...t.WidgetGlobals.keys()],"Variable"));break;case"Program":r=r.concat(this.KeywordsToCompletions([...t.Breeds.values()].map((e=>e.Plural+"-own")),"Directive"));}return r}getBreedCommands(e){let t=[];for(let r of e.Breeds.values())r.BreedType!=BreedType.Patch&&(t=t.concat(this.addBreedCompletions(r,!0)));return t}getBreedReporters(e){let t=[];for(let r of e.Breeds.values())t=t.concat(this.addBreedCompletions(r,!1));return t}addBreedCompletions(e,t){let r=[];for(var s of BreedStatementRules)if((s.Type==e.BreedType||null==s.Type)&&s.isCommand==t&&s.Tag!=Own){if(1==s.Singular||null==s.Singular)for(var o of s.String)r.push(o.replace(/<breed>/g,e.Singular));if(0==s.Singular||null==s.Singular)for(var o of s.String)r.push(o.replace(/<breed>/g,e.Plural));}return r}GetCompletion(e){var t,r,s,o,i;const n=syntaxTree(e.state).resolveInner(e.pos,-1),a=/\./.test(n.name)?n.to:n.from,l=n.type.name;let d=null!==(r=null===(t=n.parent)||void 0===t?void 0:t.type.name)&&void 0!==r?r:"";const m=null!==(i=null===(o=null===(s=n.parent)||void 0===s?void 0:s.parent)||void 0===o?void 0:o.type.name)&&void 0!==i?i:"",p=this.Editor.LintContext;let u=n,h=[];for(;u.parent;)h.push(u.parent.name),u=u.parent;if(Log(n.name+"/"+h.join("/")),(h.includes("OnelineReporter")&&this.Editor.Options.ParseMode==ParseMode.Normal||"Normal"==m&&"⚠"==d)&&(d="Program"),this.ParentTypes.indexOf(d)>-1)return {from:a,options:this.GetParentKeywords(d,p)};if(this.ParentTypes.indexOf(m)>-1&&("Procedure"!=d||"To"==l))return {from:a,options:this.GetParentKeywords(m,p)};if(("Identifier"==l||"Extension"==l||l.includes("Reporter")||l.includes("Command")||"Set"==l||"Let"==l)&&"Unrecognized"!=d){let t=this.SharedIdentifiers;const r=[...p.Extensions.keys()],s=r.join(",");if(this.LastExtensions!=s&&(this.LastPrimitives=PrimitiveManager.GetCompletions(r),this.LastExtensions=s),t=t.concat(this.LastPrimitives),p.Breeds.size>0){let e=p.GetBreedNames();e=e.filter((e=>!["turtle","turtles","patch","patches","link","links"].includes(e))),t.push(...this.KeywordsToCompletions(e,"Breed")),t.push(...this.KeywordsToCompletions(this.getBreedCommands(p),"Command")),t.push(...this.KeywordsToCompletions(this.getBreedReporters(p),"Reporter")),t.push(...this.KeywordsToCompletions(p.GetBreedVariables(),"Variable-Breed"));}for(var c of(t.push(...this.KeywordsToCompletions([...p.Globals.keys(),...p.WidgetGlobals.keys()],"Variable-Global")),p.Procedures.values()))t.push({label:c.Name,type:c.IsCommand?"Command-Custom":"Reporter-Custom"});return t.push(...this.KeywordsToCompletions(getLocalVariables(n,e.state,p),"Variable-Local")),{from:a,options:t}}return null}GetCompletionSource(){return e=>this.GetCompletion(e)}}

    const NetLogoLanguage=LRLanguage.define({parser:parser.configure({props:[styleTags({Constant:tags$1.literal,String:tags$1.literal,Numeric:tags$1.literal,LineComment:tags$1.lineComment,OpenBracket:tags$1.paren,CloseBracket:tags$1.paren,Directive:tags$1.strong,Extension:tags$1.bool,AndOr:tags$1.operator,Reporter:tags$1.operator,Reporter0Args:tags$1.operator,Reporter1Args:tags$1.operator,Reporter2Args:tags$1.operator,Reporter3Args:tags$1.operator,Reporter4Args:tags$1.operator,Reporter5Args:tags$1.operator,Reporter6Args:tags$1.operator,Reporter0ArgsVar:tags$1.operator,Reporter1ArgsVar:tags$1.operator,Reporter2ArgsVar:tags$1.operator,Reporter3ArgsVar:tags$1.operator,Reporter4ArgsVar:tags$1.operator,Reporter5ArgsVar:tags$1.operator,Reporter6ArgsVar:tags$1.operator,Reporter2ArgsVar0:tags$1.operator,Reporter1ArgsVar0:tags$1.operator,ReporterLeft1ArgsOpt:tags$1.operator,ReporterLeft1Args:tags$1.operator,ReporterLeft2Args:tags$1.operator,SpecialReporter0Args:tags$1.operator,SpecialReporter1Args:tags$1.operator,SpecialReporter2Args:tags$1.operator,SpecialReporter3Args:tags$1.operator,SpecialReporter4Args:tags$1.operator,SpecialReporter5Args:tags$1.operator,SpecialReporter6Args:tags$1.operator,SpecialReporter1ArgsBoth:tags$1.operator,SpecialReporter0ArgsLink:tags$1.operator,SpecialReporter1ArgsLink:tags$1.operator,SpecialReporter2ArgsTurtle:tags$1.operator,SpecialReporter0ArgsTurtle:tags$1.operator,SpecialReporter1ArgsTurtle:tags$1.operator,SpecialReporter0ArgsLinkP:tags$1.operator,APReporter:tags$1.operator,APReporterFlip:tags$1.operator,APReporterVar:tags$1.operator,Command:tags$1.variableName,SpecialCommand:tags$1.variableName,Command0Args:tags$1.variableName,Command1Args:tags$1.variableName,Command2Args:tags$1.variableName,Command3Args:tags$1.variableName,Command4Args:tags$1.variableName,Command5Args:tags$1.variableName,Command6Args:tags$1.variableName,Command0ArgsVar:tags$1.variableName,Command1ArgsVar:tags$1.variableName,Command2ArgsVar:tags$1.variableName,Command3ArgsVar:tags$1.variableName,Command4ArgsVar:tags$1.variableName,Command5ArgsVar:tags$1.variableName,Command6ArgsVar:tags$1.variableName,Command3ArgsVar2:tags$1.variableName,SpecialCommand0Args:tags$1.variableName,SpecialCommand1Args:tags$1.variableName,SpecialCommand2Args:tags$1.variableName,SpecialCommand3Args:tags$1.variableName,SpecialCommand4Args:tags$1.variableName,SpecialCommand5Args:tags$1.variableName,SpecialCommand6Args:tags$1.variableName,SpecialCommandCreateTurtle:tags$1.variableName,SpecialCommandCreateLink:tags$1.variableName,APCommand:tags$1.variableName,Set:tags$1.variableName,Let:tags$1.variableName,LinkVar:tags$1.bool,PatchVar:tags$1.bool,TurtleVar:tags$1.bool,"VariableName/BreedToken":tags$1.bool,ExtensionStr:tags$1.strong,GlobalStr:tags$1.strong,"BreedDeclarative/BreedToken":tags$1.strong,BreedStr:tags$1.strong,Own:tags$1.strong,To:tags$1.strong,End:tags$1.strong,ProcedureName:tags$1.strong}),indentNodeProp.add({ReporterStatement:e=>delimitedStrategy(e),CommandStatement:e=>delimitedStrategy(e),ProcedureContent:delimitedIndent({closing:"[\n"}),CodeBlock:delimitedIndent({closing:"]"}),AnonymousProcedure:delimitedIndent({closing:"]",align:!1}),Extensions:delimitedIndent({closing:"]",align:!1}),Globals:delimitedIndent({closing:"]",align:!1}),Breed:delimitedIndent({closing:"]",align:!1}),BreedsOwn:delimitedIndent({closing:"]",align:!1}),Procedure:e=>/^\s*[Ee][Nn][Dd]/.test(e.textAfter)?e.baseIndent:e.lineIndent(e.node.from)+e.unit}),foldNodeProp.add({CodeBlock:foldInside,Procedure:foldProcedure})]}),languageData:{commentTokens:{line:";"},closeBrackets:closeBrackets(),indentOnInput:/^\s*end$/i}});function bracketedAligned(e){let r=e.node,t=r.childAfter(r.from),o=r.lastChild;if(!t)return null;let a=e.state.doc.lineAt(t.from).to;for(let e=t.to;;){let n=r.childAfter(e);if(!n||n==o)return null;if(!n.type.isSkipped)return n.from<a?t:null;e=n.to;}}function delimitedStrategy(e){var r,t,o,a,n,l,i;let s=e.node.resolveInner(e.pos);console.log(s.name,null===(r=s.node.parent)||void 0===r?void 0:r.name),console.log(e.textAfter,e.node.name,null===(t=e.node.parent)||void 0===t?void 0:t.name);let m=e.textAfter,p=m.match(/^\s*/)[0].length,d="Arg"!=(null===(o=e.node.firstChild)||void 0===o?void 0:o.name)&&"LineComment"!=(null===(a=e.node.firstChild)||void 0===a?void 0:a.name),g=m.slice(p,p+2),c="[\n"==g||"["==g||"]"==g,A=d?bracketedAligned(e):null;return "CommandStatement"==(null===(i=null===(l=null===(n=e.node.parent)||void 0===n?void 0:n.parent)||void 0===l?void 0:l.parent)||void 0===i?void 0:i.name)?e.continue():";"==m.slice(p,p+1)?e.baseIndent:A?c?e.column(A.from):e.column(A.to)+1:e.baseIndent+(c?0:1*e.unit)}function foldProcedure(e){var r=e.getChild("Arguments");r=null!=(r=null!=r?r:e.getChild("ProcedureName"))?r:e.firstChild;let t=e.lastChild;return r&&r.to<t.from?{from:r.to,to:t.type.isError?e.to:t.to}:null}function NetLogo(e){return new LanguageSupport(NetLogoLanguage,[NetLogoLanguage.data.of({autocomplete:new AutoCompletion(e).GetCompletionSource()})])}const EmptyContext=new PreprocessContext;function GetContext(){var e,r=ParseContext.get();return null==r?EmptyContext:(r.Context=null!==(e=r.Context)&&void 0!==e?e:r.state.field(preprocessStateExtension).Editor.PreprocessContext,r.Context)}

    const IdentifierLinter=(e,i,t)=>{const n=[],r=getCheckContext(e,t,i);return syntaxTree(e.state).cursor().iterate((i=>{var t=i.node.parent;if("Identifier"==i.name&&"⚠"!=(null==t?void 0:t.name)||"SpecialCommandCreateTurtlePossible"==i.name&&(null==t?void 0:t.name.includes("VariableName"))){const o=i.node,a=getCodeName(e.state,o);if(checkValidIdentifier(o,a,r))return;if(a.startsWith("-")&&checkValidIdentifier(o,a.slice(1),r)){let t=getDiagnostic(e,i,"Negation _");return t.actions=[{name:Localized.Get("Fix"),apply(e,i,t){a.startsWith("(")?e.dispatch({changes:{from:i,to:t,insert:"- "+a.slice(1)}}):e.dispatch({changes:{from:i,to:t,insert:"(- "+a.slice(1)+")"}});}}],void n.push(t)}if("?"===a)for(;null!==t;){if("CodeBlock"===t.name||"Value"===t.name)return void n.push(getDiagnostic(e,i,"Deprecated usage of ?"));t=t.parent;}if(","===a)return void n.push(getDiagnostic(e,i,"Incorrect usage of ,"));if(checkUnrecognizedWithSuggestions(n,e,o))return;if(checkUndefinedBreed(n,r.preprocessState,e,o))return;n.push(getDiagnostic(e,i,"Unrecognized identifier _"));}else if("SpecialCommandCreateTurtlePossible"==i.name&&!(null==t?void 0:t.name.includes("VariableName"))){if(checkUnrecognizedWithSuggestions(n,e,i.node))return;checkUndefinedBreed(n,r.preprocessState,e,i.node);}})),n};

    const UnrecognizedGlobalLinter=(e,r,o)=>{const t=[];let l=syntaxTree(e.state).cursor(),d=0;if(l.firstChild()&&"Normal"==l.node.name){for(var i of ["Extensions","Globals","BreedsOwn","Breed"])l.node.getChildren(i).map((e=>{e.from>d&&(d=e.from);}));for(var i of(l.node.getChildren("Procedure").map((r=>{var o;if(r.from<d){let l,d=null===(o=r.node.getChild("Procedure"))||void 0===o?void 0:o.getChild("ProcedureName");l=d?e.state.sliceDoc(d.from,d.to):e.state.sliceDoc(r.from,r.to).split("\n")[0],t.push({from:r.from,to:r.to,severity:"error",message:Localized.Get("Improperly placed procedure _",l)});}})),["Extensions","Globals"]))if(l.node.getChildren(i).length>1){let e=!0;l.node.getChildren(i).map((r=>{e?e=!1:t.push({from:r.from,to:r.to,severity:"error",message:Localized.Get("Duplicate global statement _",i)});}));}l.node.getChildren("Breed").map((e=>{let r=e.getChild("BreedSingular"),o=e.getChild("BreedPlural");r&&o&&r.to-r.from>0&&o.to-o.from>0||t.push({from:e.from,to:e.to,severity:"error",message:Localized.Get("Missing breed names _","breed")});}));}return t};

    const UnrecognizedLinter=(e,t,n)=>{const r=[],o=getCheckContext(e,n,t);return syntaxTree(e.state).cursor().iterate((t=>{var n,i,s,a,d;if(("⚠"==t.name||"Error"==t.name||"Misplaced"==t.name||"WorseParentheticals"==t.name)&&t.to!=t.from){let l=t.node,m=[];for(;l.parent;)m.push(l.parent.name),l=l.parent;const c=getCodeName(e.state,t);if(Log(c,t.name,m),"Misplaced"==t.name){let n=0;if(["Extensions","Globals","Breed","BreedsOwn","Procedure"].map((e=>{var r,o;n+=null!==(o=null===(r=t.node.parent)||void 0===r?void 0:r.getChildren(e).length)&&void 0!==o?o:0;})),0==n&&e.state.field(stateExtension).Mode!=ParseMode.Normal)return}if("Arguments"==(null===(n=t.node.parent)||void 0===n?void 0:n.name)){let n=t.node.firstChild;reserved.includes(c)||n&&(n.name.startsWith("Command")||n.name.startsWith("Reporter"))?r.push(getDiagnostic(e,t,"Argument is reserved _")):r.push(getDiagnostic(e,t,"Argument is invalid _"));}else if("SetVariable"==(null===(i=t.node.parent)||void 0===i?void 0:i.name))"Set"==(null===(s=t.node.prevSibling)||void 0===s?void 0:s.name)?r.push(getDiagnostic(e,t.node,"Term _ reserved","error",c,"Local variable")):r.push(getDiagnostic(e,t,"Unrecognized statement _"));else if(["[","]",")","(",'"'].includes(c)||checkUndefinedBreed(r,o.preprocessState,e,t.node))["[","]",")","(",'"'].includes(c)&&"Breed"==(null===(d=t.node.parent)||void 0===d?void 0:d.name)&&r.push(getDiagnostic(e,t.node.parent,"Missing breed names _"));else {if(checkUnrecognizedWithSuggestions(r,e,t))return;"Normal"==(null===(a=t.node.parent)||void 0===a?void 0:a.name)?r.push(getDiagnostic(e,t,"Unrecognized global statement _")):r.push(getDiagnostic(e,t,"Unrecognized statement _"));}}})),r};

    let primitives$2=PrimitiveManager;const ArgumentLinter=(e,t,r)=>{const n=[];return syntaxTree(e.state).cursor().iterate((r=>{var i;if("SetVariable"==r.name&&(1!=r.node.getChildren("VariableName").length||r.node.getChildren("Value").length+r.node.getChildren("ReporterStatement").length!=1)||"NewVariableDeclaration"==r.name&&(r.node.getChildren("Identifier").length+r.node.getChildren("UnsupportedPrim").length!=1||r.node.getChildren("Value").length+r.node.getChildren("ReporterStatement").length!=1)){let t="SetVariable"==r.name?"Set":"Let",i=2,o=0,g=r.node.cursor();if(g.firstChild())for(;g.nextSibling();)g.from!=g.to&&o++;let l=o;l<i&&n.push(getDiagnostic(e,r.node,"Too few right args for _. Expected _, found _.","error",t,i.toString(),l.toString()));}else if("ReporterStatement"==r.name||"CommandStatement"==r.name){const g=r.node;"⚠"==(null===(i=g.firstChild)||void 0===i?void 0:i.name)&&n.push(getDiagnostic(e,g,"Missing command _"));let l=getArgs(g);if(0==g.getChildren("VariableDeclaration").length&&l.func){const i=checkValidNumArgs(e.state,l,t);let o=i[0],g=i[1],a=i[2],s=i[3];null==g||null==a||null==s||("no primitive"==o?n.push(getDiagnostic(e,r.node,"Problem identifying primitive _. Expected _, found _.","error",g.toString(),a.toString(),s.toString())):"left"==o?n.push(getDiagnostic(e,r.node,"Left args for _. Expected _, found _.","error",g.toString(),a.toString(),s.toString())):"rightmin"==o?n.push(getDiagnostic(e,r.node,"Too few right args for _. Expected _, found _.","error",g.toString(),a.toString(),s.toString())):"rightmax"==o&&n.push(getDiagnostic(e,r.node,"Too many right args for _. Expected _, found _.","error",g.toString(),a.toString(),s.toString())));}if(l.func){let t=getCodeName(e.state,l.func);var o=!1;"while"==t?o=l.rightArgs.length>1&&"true"==getCodeName(e.state,l.rightArgs[0]):"loop"==t&&(o=!0),o&&!checkLoopEnd(e,g)&&n.push(getDiagnostic(e,r.node,"Infinite loop _","error",t));}}})),n};const checkLoopEnd=function(e,t){let r=!1;return t.cursor().iterate((t=>{var n=getCodeName(e.state,t);if(["stop","die","report"].includes(n))return r=!0,!1})),r};const getArgs=function(e){var t,r;let n=e.cursor(),i={leftArgs:null,rightArgs:[],func:null,hasParentheses:!1},o=!1,g=!1;if(!n.firstChild())return i;for(("OpenParen"==e.resolve(e.from,-1).name||"OpenParen"==e.resolve(e.from,-1).resolve(e.from,-1).name||(null!==(r=null===(t=e.parent)||void 0===t?void 0:t.getChildren("OpenParen").length)&&void 0!==r?r:-1)>0)&&(i.hasParentheses=!0);0==g;)"OpenParen"==n.node.name?i.hasParentheses=!0:o||"Arg"!=n.node.name?!o||"Arg"!=n.node.name&&"Commands"!=n.node.name&&"Reporters"!=n.node.name?(n.node.name.includes("Command")&&!n.node.name.includes("Commands")&&!n.node.name.includes("CommandStatement")||n.node.name.includes("Reporter")&&!n.node.name.includes("Reporters")&&!n.node.name.includes("ReporterStatement"))&&(i.func=n.node,o=!0):i.rightArgs.push(n.node):i.leftArgs=n.node,n.nextSibling()||(g=!0);return i};const checkValidNumArgs=function(e,t,r){var n,i,o,g,l,a,s,d,m,u,h,f;let p=getCodeName(e,t.func);if("-"==p){if(t.hasParentheses||t.leftArgs)return t.rightArgs.length>1?["rightmax",p,1,t.rightArgs.length]:[!0,p,0,0];{Log("left args");let e=1,r=t.leftArgs?1:0;return Log("left",e,r),["left",p,e,r]}}let c=p,A=null!==(i=null===(n=t.func)||void 0===n?void 0:n.name)&&void 0!==i?i:"";if(A.includes("Special"))switch(A){case"SpecialCommandCreateTurtle":A="Command2Args",c="create-turtles";break;case"SpecialCommandCreateLink":A="Command2Args",c="create-links-with";break;default:let e=null!==(g=null!==(o=r.Commands.get(p))&&void 0!==o?o:r.Reporters.get(p))&&void 0!==g?g:getBreedProcedureArgs(A);return [e==t.rightArgs.length,p,e,t.rightArgs.length]}let v=primitives$2.GetNamedPrimitive(c);if(v){if((null===(a=v.LeftArgumentType)||void 0===a?void 0:a.Types[0])==NetLogoType.Unit&&t.leftArgs||(null===(s=v.LeftArgumentType)||void 0===s?void 0:s.Types[0])!=NetLogoType.Unit&&!t.leftArgs){Log("left args");let e=(null===(d=v.LeftArgumentType)||void 0===d?void 0:d.Types[0])!=NetLogoType.Unit?1:0,r=t.leftArgs?1:0;return Log("left",e,r),["left",p,e,r]}{let e=0,r=0;return !A.includes("APCommand")&&!A.includes("Var")||t.hasParentheses?(e=t.hasParentheses?null!==(u=null!==(m=v.MinimumOption)&&void 0!==m?m:v.DefaultOption)&&void 0!==u?u:v.RightArgumentTypes.filter((e=>0==e.Optional)).length:null!==(h=v.DefaultOption)&&void 0!==h?h:v.RightArgumentTypes.filter((e=>0==e.Optional)).length,r=v.RightArgumentTypes.filter((e=>e.CanRepeat)).length>0&&t.hasParentheses?100:null!==(f=v.DefaultOption)&&void 0!==f?f:v.RightArgumentTypes.length):(A=A.replace("Command",""),A=A.replace("ArgsVar",""),e=Number(A[0]),r=Number(A[0])),t.rightArgs.length<e?(Log(t.rightArgs),Log(p,"rightargs",e,r,t.rightArgs.length),["rightmin",p,e,t.rightArgs.length]):t.rightArgs.length>r?["rightmax",p,r,t.rightArgs.length]:[!0,p,0,0]}}return Log("no primitive",null===(l=t.func)||void 0===l?void 0:l.name,p),["no primitive",p,0,0]};const getBreedProcedureArgs=function(e){let t=e.match(/[A-Za-z]*(\d)[A-Za-z]*/);return t?parseInt(t[1]):null};

    const UnsupportedLinter=(e,o,t)=>{const r=[],n=getCheckContext(e,t,o);let i=[];return syntaxTree(e.state).cursor().iterate((o=>{var t,a,d,s,m;if(i.includes(o.from))return;const u=getCodeName(e.state,o);unsupported.includes(u)&&(i.push(o.from),r.push({from:o.from,to:o.to,severity:"warning",message:Localized.Get("Unsupported statement _",u)})),o.name.includes("Unsupported")&&"VariableName"!=(null===(t=o.node.parent)||void 0===t?void 0:t.name)&&"NewVariableDeclaration"!=(null===(a=o.node.parent)||void 0===a?void 0:a.name)&&"Arguments"!=(null===(d=o.node.parent)||void 0===d?void 0:d.name)&&"AnonArguments"!=(null===(s=o.node.parent)||void 0===s?void 0:s.name)&&"ProcedureName"!=(null===(m=o.node.parent)||void 0===m?void 0:m.name)&&!checkValidIdentifier(o.node,u,n)&&(i.push(o.from),r.push({from:o.from,to:o.to,severity:"warning",message:Localized.Get("Unsupported extension statement _",u)}));})),r};

    let primitives$1=PrimitiveManager;const ExtensionLinter=(e,i,n)=>{const t=[];const a=getCheckContext(e,n,i);return syntaxTree(e.state).cursor().iterate((i=>{var d,m,l,p;if("Extensions"==i.name)i.node.getChildren("Identifier").map((i=>{let n=getCodeName(e.state,i);-1==primitives$1.GetExtensions().indexOf(n)&&t.push(getDiagnostic(e,i,"Unsupported extension _","warning"));})),i.node.getChildren("CloseBracket").map((e=>{e.from,i.node;}));else if((i.name.includes("Args")||i.name.includes("Unsupported")&&"VariableName"!=(null===(d=i.node.parent)||void 0===d?void 0:d.name)&&"Arguments"!=(null===(m=i.node.parent)||void 0===m?void 0:m.name)&&"AnonArguments"!=(null===(l=i.node.parent)||void 0===l?void 0:l.name)&&"ProcedureName"!=(null===(p=i.node.parent)||void 0===p?void 0:p.name)&&!checkValidIdentifier(i.node,getCodeName(e.state,i),a))&&!i.name.includes("Special")){let o=getCodeName(e.state,i).split(":");if(o.length<=1||n.Extensions.has(o[0]))return;t.push(addGlobalsAction(getDiagnostic(e,i,i.name.includes("Unsupported")?"Unsupported missing extension _":"Missing extension _","error",o[0]),"Extensions",[o[0]]));}})),t};

    let primitives=PrimitiveManager;const NamingLinter=(e,r,i)=>{const t=[];let a=[],n=[],o=["turtles","turtle","patches","patch","links","link"],l=GetAllBreedPrimitives(i);l.push(...turtleVars),l.push(...patchVars),l.push(...linkVars);var s=(r,i,s,d=!1)=>{const m=getCodeName(e.state,r);a.includes(m)||(null==s?void 0:s.includes(m))||!d&&n.includes(m)?t.push(getDiagnostic(e,r,"Term _ already used","error",m,i)):l.includes(m)?i.includes("variable")?"Local variable"!=i?t.push(removeAction(getDiagnostic(e,r,"Variable _ reserved","error",m,i))):t.push(getDiagnostic(e,r,"Variable _ reserved","error",m,i)):t.push(getDiagnostic(e,r,"Term _ reserved","error",m,i)):o.includes(m)||primitives.GetNamedPrimitive(m)?t.push(getDiagnostic(e,r,"Term _ reserved","error",m,i)):s?s.push(m):a.push(m);},d=e.state.field(stateExtension).Mode;return d!=ParseMode.Normal&&d!=ParseMode.Generative?(a.push(...i.GetDefined()),syntaxTree(e.state).cursor().iterate((r=>{var t;if("NewVariableDeclaration"==r.name){let a=null!==(t=r.node.getChild("Identifier"))&&void 0!==t?t:r.node.getChild("UnsupportedPrim");if(!a)return;let n=getLocalVariables(a,e.state,i);s(a,"Local variable",n);}}))):syntaxTree(e.state).cursor().iterate((r=>{var a,o,l,d;if("BreedSingular"==r.name||"BreedPlural"==r.name)s(r,"Breed");else if("Identifier"==r.name&&"Globals"==(null===(a=r.node.parent)||void 0===a?void 0:a.name))s(r,"Global variable");else if("ProcedureName"==r.name)0==(null===(o=r.node.parent)||void 0===o?void 0:o.getChildren("To").length)?t.push(getDiagnostic(e,r,"Unrecognized global statement _","error")):s(r,"Procedure");else if("BreedsOwn"==r.name){let t=r.node.getChild("Own"),a=[];if(!t)return;let o=getCodeName(e.state,r);o=o.substring(0,o.length-4),r.node.getChildren("Identifier").map((e=>{"turtles"==o?s(e,"Turtle variable"):"links"==o?s(e,"Link variable"):"patches"==o?s(e,"Patch variable"):isLinkBreed(o,i)?s(e,"Link variable",a,!0):s(e,"Turtle variable",a,!0);})),n.push(...a);}else if("NewVariableDeclaration"==r.name||"SetVariable"==r.name){let a=null===(l=r.node.firstChild)||void 0===l?void 0:l.nextSibling;if(!a)return;if(a.name.includes("Reporter")||a.name.includes("Command")){const r=getCodeName(e.state,a);t.push(getDiagnostic(e,a,"Term _ reserved","error",r,"Local variable"));}else if("NewVariableDeclaration"==r.name){let r=getLocalVariables(a,e.state,i);s(a,"Local variable",r);}}else if("Arguments"==r.name){let t=[];if("AnonArguments"==(null===(d=r.node.parent)||void 0===d?void 0:d.name)){let a=r.node.parent.parent;if(a){let r=null==a?void 0:a.cursor().moveTo(a.from-2).node;t=getLocalVariables(r,e.state,i);}}for(var m of ["Identifier","UnsupportedPrim"])r.node.getChildren(m).map((e=>{s(e,"Argument",t);}));}})),t};const isLinkBreed=(e,r)=>{for(var[i,t]of r.Breeds)if(t.Plural.toLowerCase()==e.toLowerCase())return t.BreedType==BreedType.DirectedLink||t.BreedType==BreedType.UndirectedLink;return null};

    const BracketLinter=(e,n,t)=>{const r=[];return syntaxTree(e.state).cursor().iterate((n=>{if(["OpenParen","CloseParen","OpenBracket","CloseBracket"].includes(n.name)){let t=[],o=n.node;for(;o.parent;)t.push(o.parent.name),o=o.parent;if(["OpenBracket","OpenParen"].includes(n.name)){let t=matchBrackets(e.state,n.from,1);if(t&&t.matched)return}let a="",i="";test_function(n,"OpenBracket","CloseBracket")?(a="[",i="]"):test_function(n,"CloseBracket","OpenBracket")?(a="]",i="["):test_function(n,"OpenParen","CloseParen")?(a="(",i=")"):test_function(n,"CloseParen","OpenParen")&&(a=")",i="("),""!=a&&r.push(getDiagnostic(e,n,"Unmatched item _","error",a,i));}})),r};const test_function=function(e,n,t){var r,o,a,i,l,d,c,s;return e.name==n&&("⚠"!=(null===(r=e.node.parent)||void 0===r?void 0:r.name)&&1!=(null===(o=e.node.parent)||void 0===o?void 0:o.getChildren(t).length)&&1!=(null===(i=null===(a=e.node.parent)||void 0===a?void 0:a.getChild("⚠"))||void 0===i?void 0:i.getChildren(t).length)||"⚠"==(null===(l=e.node.parent)||void 0===l?void 0:l.name)&&1!=(null===(d=e.node.parent)||void 0===d?void 0:d.getChildren(t).length)&&1!=(null===(s=null===(c=e.node.parent)||void 0===c?void 0:c.parent)||void 0===s?void 0:s.getChildren(t).length))};

    const ModeLinter=(e,r,o,n)=>{var t=n.Mode;const d=[];if(0==e.state.doc.length||t==ParseMode.Generative)return d;var l=syntaxTree(e.state).cursor().node;if("Program"!=l.name)return d;var i=null;if(null!=(i=null!=(i=null!=(i=null!=i?i:CheckMode(l,"OnelineReporter",t))?i:CheckMode(l,"Embedded",t))?i:CheckMode(l,"Normal",t)))return d.push(getDiagnostic(e,i,`Invalid for ${t} mode _`)),d;if(t!=ParseMode.Normal)for(let r of ["Unrecognized","Procedure","Extensions","Globals","Breed","BreedsOwn"])l.getChildren(r).map((r=>{d.push(getDiagnostic(e,r,`Invalid for ${t} mode _`));}));return d};const GetMode=function(e,r){return e.getChild(r)},CheckMode=function(e,r,o){var n=GetMode(e,r);return null==n||o==r?null:o!=ParseMode.Oneline||"OnelineReporter"!=r&&"Embedded"!=r?n:null};

    const ContextLinter=(t,e,o)=>{const r=[];let n=t.state.field(stateExtension);for(let e of n.ContextErrors)r.push(getDiagnostic(t,{from:e.From,to:e.To},"Invalid context _","error",contextToString(e.PriorContext),contextToString(e.ConflictingContext),e.Primitive));return r};const contextToString=function(t){let e=[];return t.Observer&&e.push(Localized.Get("Observer")),t.Turtle&&e.push(Localized.Get("Turtle")),t.Patch&&e.push(Localized.Get("Patch")),t.Link&&e.push(Localized.Get("Link")),e.join("/")};

    const CodeBlockLinter=(e,n,r)=>{const t=[];return syntaxTree(e.state).cursor().iterate((n=>{if("CodeBlock"!=n.name&&"Embedded"!=n.name)return;let r=n.node.cursor(),o=null;if(r.firstChild())for(;r.nextSibling();){var i=r.name;if(null==o){if(["LineComment","OpenBracket","CloseBracket"].includes(i))continue;o="ProcedureContent"==r.name;}o&&!["LineComment","OpenBracket","CloseBracket","ProcedureContent"].includes(i)?"Identifier"!==i&&t.push(getDiagnostic(e,r,"Invalid content for code block _","error")):o||"ProcedureContent"!=r.name||t.push(getDiagnostic(e,r,"Invalid content for list _","error"));}})),t};

    const ReporterLinter=(e,t,o)=>{var r,i;const n=[];return null===(i=null===(r=syntaxTree(e.state).topNode)||void 0===r?void 0:r.firstChild)||void 0===i||i.getChildren("Procedure").map((t=>{let o=t.node.getChild("To"),r="to-report"==getCodeName(e.state,null!=o?o:t.node),i=!1,a=null;if(syntaxTree(e.state).iterate({enter:t=>{"Command1Args"==t.name&&"report"==getCodeName(e.state,t.node)&&(i=!0,a=t.node);},from:t.from,to:t.to}),r&&!i&&o){let t=getDiagnostic(e,o,"Invalid to-report _","error","to-report");AddReplaceAction(t,"to"),n.push(t);}else if(!r&&i&&a&&o){n.push(getDiagnostic(e,a,"Invalid report _","error","report"));let t=getDiagnostic(e,o,"Invalid report warning _","warning","report");AddReplaceAction(t,"to-report"),n.push(t);}})),n};

    const netlogoLinters=[UnrecognizedLinter,UnrecognizedGlobalLinter,IdentifierLinter,ArgumentLinter,UnsupportedLinter,ExtensionLinter,NamingLinter,BracketLinter,ModeLinter,ContextLinter,CodeBlockLinter,ReporterLinter];

    const CompilerLinter=e=>e.state.field(stateExtension).CompilerErrors.map((function(e){return {from:e.start,to:e.end,severity:"error",message:e.message}}));const RuntimeLinter=e=>e.state.field(stateExtension).RuntimeErrors.map((function(e){return {from:e.start,to:e.end,severity:"error",message:e.message}}));

    const basicNormalize="function"==typeof String.prototype.normalize?e=>e.normalize("NFKD"):e=>e;class SearchCursor{constructor(e,t,r=0,i=e.length,n,a){this.test=a,this.value={from:0,to:0},this.done=!1,this.matches=[],this.buffer="",this.bufferPos=0,this.iter=e.iterRange(r,i),this.bufferStart=r,this.normalize=n?e=>n(basicNormalize(e)):basicNormalize,this.query=this.normalize(t);}peek(){if(this.bufferPos==this.buffer.length){if(this.bufferStart+=this.buffer.length,this.iter.next(),this.iter.done)return -1;this.bufferPos=0,this.buffer=this.iter.value;}return codePointAt(this.buffer,this.bufferPos)}next(){for(;this.matches.length;)this.matches.pop();return this.nextOverlapping()}nextOverlapping(){for(;;){let e=this.peek();if(e<0)return this.done=!0,this;let t=fromCodePoint(e),r=this.bufferStart+this.bufferPos;this.bufferPos+=codePointSize(e);let i=this.normalize(t);for(let e=0,n=r;;e++){let a=i.charCodeAt(e),o=this.match(a,n);if(o)return this.value=o,this;if(e==i.length-1)break;n==r&&e<t.length&&t.charCodeAt(e)==a&&n++;}}}match(e,t){let r=null;for(let i=0;i<this.matches.length;i+=2){let n=this.matches[i],a=!1;this.query.charCodeAt(n)==e&&(n==this.query.length-1?r={from:this.matches[i+1],to:t+1}:(this.matches[i]++,a=!0)),a||(this.matches.splice(i,2),i-=2);}return this.query.charCodeAt(0)==e&&(1==this.query.length?r={from:t,to:t+1}:this.matches.push(1,t)),r&&this.test&&!this.test(r.from,r.to,this.buffer,this.bufferPos)&&(r=null),r}}"undefined"!=typeof Symbol&&(SearchCursor.prototype[Symbol.iterator]=function(){return this});const empty={from:-1,to:-1,match:/.*/.exec("")},baseFlags="gm"+(null==/x/.unicode?"":"u");class RegExpCursor{constructor(e,t,r,i=0,n=e.length){if(this.text=e,this.to=n,this.curLine="",this.done=!1,this.value=empty,/\\[sWDnr]|\n|\r|\[\^/.test(t))return new MultilineRegExpCursor(e,t,r,i,n);this.re=new RegExp(t,baseFlags+((null==r?void 0:r.ignoreCase)?"i":"")),this.test=null==r?void 0:r.test,this.iter=e.iter();let a=e.lineAt(i);this.curLineStart=a.from,this.matchPos=toCharEnd(e,i),this.getLine(this.curLineStart);}getLine(e){this.iter.next(e),this.iter.lineBreak?this.curLine="":(this.curLine=this.iter.value,this.curLineStart+this.curLine.length>this.to&&(this.curLine=this.curLine.slice(0,this.to-this.curLineStart)),this.iter.next());}nextLine(){this.curLineStart=this.curLineStart+this.curLine.length+1,this.curLineStart>this.to?this.curLine="":this.getLine(0);}next(){for(let e=this.matchPos-this.curLineStart;;){this.re.lastIndex=e;let t=this.matchPos<=this.to&&this.re.exec(this.curLine);if(t){let r=this.curLineStart+t.index,i=r+t[0].length;if(this.matchPos=toCharEnd(this.text,i+(r==i?1:0)),r==this.curLineStart+this.curLine.length&&this.nextLine(),(r<i||r>this.value.to)&&(!this.test||this.test(r,i,t)))return this.value={from:r,to:i,match:t},this;e=this.matchPos-this.curLineStart;}else {if(!(this.curLineStart+this.curLine.length<this.to))return this.done=!0,this;this.nextLine(),e=0;}}}}const flattened=new WeakMap;class FlattenedDoc{constructor(e,t){this.from=e,this.text=t;}get to(){return this.from+this.text.length}static get(e,t,r){let i=flattened.get(e);if(!i||i.from>=r||i.to<=t){let i=new FlattenedDoc(t,e.sliceString(t,r));return flattened.set(e,i),i}if(i.from==t&&i.to==r)return i;let{text:n,from:a}=i;return a>t&&(n=e.sliceString(t,a)+n,a=t),i.to<r&&(n+=e.sliceString(i.to,r)),flattened.set(e,new FlattenedDoc(a,n)),new FlattenedDoc(t,n.slice(t-a,r-a))}}class MultilineRegExpCursor{constructor(e,t,r,i,n){this.text=e,this.to=n,this.done=!1,this.value=empty,this.matchPos=toCharEnd(e,i),this.re=new RegExp(t,baseFlags+((null==r?void 0:r.ignoreCase)?"i":"")),this.test=null==r?void 0:r.test,this.flat=FlattenedDoc.get(e,i,this.chunkEnd(i+5e3));}chunkEnd(e){return e>=this.to?this.to:this.text.lineAt(e).to}next(){for(;;){let e=this.re.lastIndex=this.matchPos-this.flat.from,t=this.re.exec(this.flat.text);if(t&&!t[0]&&t.index==e&&(this.re.lastIndex=e+1,t=this.re.exec(this.flat.text)),t){let e=this.flat.from+t.index,r=e+t[0].length;if((this.flat.to>=this.to||t.index+t[0].length<=this.flat.text.length-10)&&(!this.test||this.test(e,r,t)))return this.value={from:e,to:r,match:t},this.matchPos=toCharEnd(this.text,r+(e==r?1:0)),this}if(this.flat.to==this.to)return this.done=!0,this;this.flat=FlattenedDoc.get(this.text,this.flat.from,this.chunkEnd(this.flat.from+2*this.flat.text.length));}}}function validRegExp(e){try{return new RegExp(e,baseFlags),!0}catch(e){return !1}}function toCharEnd(e,t){if(t>=e.length)return t;let r,i=e.lineAt(t);for(;t<i.to&&(r=i.text.charCodeAt(t-i.from))>=56320&&r<57344;)t++;return t}function createLineDialog(e){let t=crelt("input",{class:"cm-textfield",name:"line"});function r(){let r=/^([+-])?(\d+)?(:\d+)?(%)?$/.exec(t.value);if(!r)return;let{state:i}=e,n=i.doc.lineAt(i.selection.main.head),[,a,o,s,c]=r,l=s?+s.slice(1):0,h=o?+o:n.number;if(o&&c){let e=h/100;a&&(e=e*("-"==a?-1:1)+n.number/i.doc.lines),h=Math.round(i.doc.lines*e);}else o&&a&&(h=h*("-"==a?-1:1)+n.number);let u=i.doc.line(Math.max(1,Math.min(i.doc.lines,h)));e.dispatch({effects:dialogEffect.of(!1),selection:EditorSelection.cursor(u.from+Math.max(0,Math.min(l,u.length))),scrollIntoView:!0}),e.focus();}return {dom:crelt("form",{class:"cm-gotoLine",onkeydown:t=>{27==t.keyCode?(t.preventDefault(),e.dispatch({effects:dialogEffect.of(!1)}),e.focus()):13==t.keyCode&&(t.preventDefault(),r());},onsubmit:e=>{e.preventDefault(),r();}},crelt("label",e.state.phrase("Go to line"),": ",t)," ",crelt("button",{class:"cm-button",type:"submit"},e.state.phrase("go")))}}"undefined"!=typeof Symbol&&(RegExpCursor.prototype[Symbol.iterator]=MultilineRegExpCursor.prototype[Symbol.iterator]=function(){return this});const dialogEffect=StateEffect.define(),dialogField=StateField.define({create:()=>!0,update(e,t){for(let r of t.effects)r.is(dialogEffect)&&(e=r.value);return e},provide:e=>showPanel.from(e,(e=>e?createLineDialog:null))}),gotoLine=e=>{let t=getPanel(e,createLineDialog);if(!t){let r=[dialogEffect.of(!0)];null==e.state.field(dialogField,!1)&&r.push(StateEffect.appendConfig.of([dialogField,baseTheme$1])),e.dispatch({effects:r}),t=getPanel(e,createLineDialog);}return t&&t.dom.querySelector("input").focus(),!0},baseTheme$1=EditorView.baseTheme({".cm-panel.cm-gotoLine":{padding:"2px 6px 4px","& label":{fontSize:"80%"}}}),defaultHighlightOptions={highlightWordAroundCursor:!1,minSelectionLength:1,maxMatches:100,wholeWords:!1},highlightConfig=Facet.define({combine:e=>combineConfig(e,defaultHighlightOptions,{highlightWordAroundCursor:(e,t)=>e||t,minSelectionLength:Math.min,maxMatches:Math.min})});function highlightSelectionMatches(e){let t=[defaultTheme,matchHighlighter];return e&&t.push(highlightConfig.of(e)),t}const matchDeco=Decoration.mark({class:"cm-selectionMatch"}),mainMatchDeco=Decoration.mark({class:"cm-selectionMatch cm-selectionMatch-main"});function insideWordBoundaries(e,t,r,i){return !(0!=r&&e(t.sliceDoc(r-1,r))==CharCategory.Word||i!=t.doc.length&&e(t.sliceDoc(i,i+1))==CharCategory.Word)}function insideWord(e,t,r,i){return e(t.sliceDoc(r,r+1))==CharCategory.Word&&e(t.sliceDoc(i-1,i))==CharCategory.Word}const matchHighlighter=ViewPlugin.fromClass(class{constructor(e){this.decorations=this.getDeco(e);}update(e){(e.selectionSet||e.docChanged||e.viewportChanged)&&(this.decorations=this.getDeco(e.view));}getDeco(e){let t=e.state.facet(highlightConfig),{state:r}=e,i=r.selection;if(i.ranges.length>1)return Decoration.none;let n,a=i.main,o=null;if(a.empty){if(!t.highlightWordAroundCursor)return Decoration.none;let e=r.wordAt(a.head);if(!e)return Decoration.none;o=r.charCategorizer(a.head),n=r.sliceDoc(e.from,e.to);}else {let e=a.to-a.from;if(e<t.minSelectionLength||e>200)return Decoration.none;if(t.wholeWords){if(n=r.sliceDoc(a.from,a.to),o=r.charCategorizer(a.head),!insideWordBoundaries(o,r,a.from,a.to)||!insideWord(o,r,a.from,a.to))return Decoration.none}else if(n=r.sliceDoc(a.from,a.to).trim(),!n)return Decoration.none}let s=[];for(let i of e.visibleRanges){let e=new SearchCursor(r.doc,n,i.from,i.to);for(;!e.next().done;){let{from:i,to:n}=e.value;if((!o||insideWordBoundaries(o,r,i,n))&&(a.empty&&i<=a.from&&n>=a.to?s.push(mainMatchDeco.range(i,n)):(i>=a.to||n<=a.from)&&s.push(matchDeco.range(i,n)),s.length>t.maxMatches))return Decoration.none}}return Decoration.set(s)}},{decorations:e=>e.decorations}),defaultTheme=EditorView.baseTheme({".cm-selectionMatch":{backgroundColor:"#99ff7780"},".cm-searchMatch .cm-selectionMatch":{backgroundColor:"transparent"}}),selectWord=({state:e,dispatch:t})=>{let{selection:r}=e,i=EditorSelection.create(r.ranges.map((t=>e.wordAt(t.head)||EditorSelection.cursor(t.head))),r.mainIndex);return !i.eq(r)&&(t(e.update({selection:i})),!0)};function findNextOccurrence(e,t){let{main:r,ranges:i}=e.selection,n=e.wordAt(r.head),a=n&&n.from==r.from&&n.to==r.to;for(let r=!1,n=new SearchCursor(e.doc,t,i[i.length-1].to);;){if(n.next(),!n.done){if(r&&i.some((e=>e.from==n.value.from)))continue;if(a){let t=e.wordAt(n.value.from);if(!t||t.from!=n.value.from||t.to!=n.value.to)continue}return n.value}if(r)return null;n=new SearchCursor(e.doc,t,0,Math.max(0,i[i.length-1].from-1)),r=!0;}}const selectNextOccurrence=({state:e,dispatch:t})=>{let{ranges:r}=e.selection;if(r.some((e=>e.from===e.to)))return selectWord({state:e,dispatch:t});let i=e.sliceDoc(r[0].from,r[0].to);if(e.selection.ranges.some((t=>e.sliceDoc(t.from,t.to)!=i)))return !1;let n=findNextOccurrence(e,i);return !!n&&(t(e.update({selection:e.selection.addRange(EditorSelection.range(n.from,n.to),!1),effects:EditorView.scrollIntoView(n.to)})),!0)},searchConfigFacet=Facet.define({combine:e=>combineConfig(e,{top:!1,caseSensitive:!1,literal:!1,regexp:!1,wholeWord:!1,createPanel:e=>new SearchPanel(e),scrollToMatch:e=>EditorView.scrollIntoView(e)})});class SearchQuery{constructor(e){this.search=e.search,this.caseSensitive=!!e.caseSensitive,this.literal=!!e.literal,this.regexp=!!e.regexp,this.replace=e.replace||"",this.valid=!!this.search&&(!this.regexp||validRegExp(this.search)),this.unquoted=this.unquote(this.search),this.wholeWord=!!e.wholeWord;}unquote(e){return this.literal?e:e.replace(/\\([nrt\\])/g,((e,t)=>"n"==t?"\n":"r"==t?"\r":"t"==t?"\t":"\\"))}eq(e){return this.search==e.search&&this.replace==e.replace&&this.caseSensitive==e.caseSensitive&&this.regexp==e.regexp&&this.wholeWord==e.wholeWord}create(){return this.regexp?new RegExpQuery(this):new StringQuery(this)}getCursor(e,t=0,r){let i=e.doc?e:EditorState.create({doc:e});return null==r&&(r=i.doc.length),this.regexp?regexpCursor(this,i,t,r):stringCursor(this,i,t,r)}}class QueryType{constructor(e){this.spec=e;}}function stringCursor(e,t,r,i){return new SearchCursor(t.doc,e.unquoted,r,i,e.caseSensitive?void 0:e=>e.toLowerCase(),e.wholeWord?stringWordTest(t.doc,t.charCategorizer(t.selection.main.head)):void 0)}function stringWordTest(e,t){return (r,i,n,a)=>((a>r||a+n.length<i)&&(a=Math.max(0,r-2),n=e.sliceString(a,Math.min(e.length,i+2))),!(t(charBefore(n,r-a))==CharCategory.Word&&t(charAfter(n,r-a))==CharCategory.Word||t(charAfter(n,i-a))==CharCategory.Word&&t(charBefore(n,i-a))==CharCategory.Word))}class StringQuery extends QueryType{constructor(e){super(e);}nextMatch(e,t,r){let i=stringCursor(this.spec,e,r,e.doc.length).nextOverlapping();return i.done&&(i=stringCursor(this.spec,e,0,t).nextOverlapping()),i.done?null:i.value}prevMatchInRange(e,t,r){for(let i=r;;){let r=Math.max(t,i-1e4-this.spec.unquoted.length),n=stringCursor(this.spec,e,r,i),a=null;for(;!n.nextOverlapping().done;)a=n.value;if(a)return a;if(r==t)return null;i-=1e4;}}prevMatch(e,t,r){return this.prevMatchInRange(e,0,t)||this.prevMatchInRange(e,r,e.doc.length)}getReplacement(e){return this.spec.unquote(this.spec.replace)}matchAll(e,t){let r=stringCursor(this.spec,e,0,e.doc.length),i=[];for(;!r.next().done;){if(i.length>=t)return null;i.push(r.value);}return i}highlight(e,t,r,i){let n=stringCursor(this.spec,e,Math.max(0,t-this.spec.unquoted.length),Math.min(r+this.spec.unquoted.length,e.doc.length));for(;!n.next().done;)i(n.value.from,n.value.to);}}function regexpCursor(e,t,r,i){return new RegExpCursor(t.doc,e.search,{ignoreCase:!e.caseSensitive,test:e.wholeWord?regexpWordTest(t.charCategorizer(t.selection.main.head)):void 0},r,i)}function charBefore(e,t){return e.slice(findClusterBreak(e,t,!1),t)}function charAfter(e,t){return e.slice(t,findClusterBreak(e,t))}function regexpWordTest(e){return (t,r,i)=>!i[0].length||(e(charBefore(i.input,i.index))!=CharCategory.Word||e(charAfter(i.input,i.index))!=CharCategory.Word)&&(e(charAfter(i.input,i.index+i[0].length))!=CharCategory.Word||e(charBefore(i.input,i.index+i[0].length))!=CharCategory.Word)}class RegExpQuery extends QueryType{nextMatch(e,t,r){let i=regexpCursor(this.spec,e,r,e.doc.length).next();return i.done&&(i=regexpCursor(this.spec,e,0,t).next()),i.done?null:i.value}prevMatchInRange(e,t,r){for(let i=1;;i++){let n=Math.max(t,r-1e4*i),a=regexpCursor(this.spec,e,n,r),o=null;for(;!a.next().done;)o=a.value;if(o&&(n==t||o.from>n+10))return o;if(n==t)return null}}prevMatch(e,t,r){return this.prevMatchInRange(e,0,t)||this.prevMatchInRange(e,r,e.doc.length)}getReplacement(e){return this.spec.unquote(this.spec.replace.replace(/\$([$&\d+])/g,((t,r)=>"$"==r?"$":"&"==r?e.match[0]:"0"!=r&&+r<e.match.length?e.match[r]:t)))}matchAll(e,t){let r=regexpCursor(this.spec,e,0,e.doc.length),i=[];for(;!r.next().done;){if(i.length>=t)return null;i.push(r.value);}return i}highlight(e,t,r,i){let n=regexpCursor(this.spec,e,Math.max(0,t-250),Math.min(r+250,e.doc.length));for(;!n.next().done;)i(n.value.from,n.value.to);}}const setSearchQuery=StateEffect.define(),togglePanel=StateEffect.define(),searchState=StateField.define({create:e=>new SearchState(defaultQuery(e).create(),null),update(e,t){for(let r of t.effects)r.is(setSearchQuery)?e=new SearchState(r.value.create(),e.panel):r.is(togglePanel)&&(e=new SearchState(e.query,r.value?createSearchPanel:null));return e},provide:e=>showPanel.from(e,(e=>e.panel))});class SearchState{constructor(e,t){this.query=e,this.panel=t;}}const matchMark=Decoration.mark({class:"cm-searchMatch"}),selectedMatchMark=Decoration.mark({class:"cm-searchMatch cm-searchMatch-selected"}),searchHighlighter=ViewPlugin.fromClass(class{constructor(e){this.view=e,this.decorations=this.highlight(e.state.field(searchState));}update(e){let t=e.state.field(searchState);(t!=e.startState.field(searchState)||e.docChanged||e.selectionSet||e.viewportChanged)&&(this.decorations=this.highlight(t));}highlight({query:e,panel:t}){if(!t||!e.spec.valid)return Decoration.none;let{view:r}=this,i=new RangeSetBuilder;for(let t=0,n=r.visibleRanges,a=n.length;t<a;t++){let{from:o,to:s}=n[t];for(;t<a-1&&s>n[t+1].from-500;)s=n[++t].to;e.highlight(r.state,o,s,((e,t)=>{let n=r.state.selection.ranges.some((r=>r.from==e&&r.to==t));i.add(e,t,n?selectedMatchMark:matchMark);}));}return i.finish()}},{decorations:e=>e.decorations});function searchCommand(e){return t=>{let r=t.state.field(searchState,!1);return r&&r.query.spec.valid?e(t,r):openSearchPanel(t)}}const findNext=searchCommand(((e,{query:t})=>{let{to:r}=e.state.selection.main,i=t.nextMatch(e.state,r,r);if(!i)return !1;let n=EditorSelection.single(i.from,i.to),a=e.state.facet(searchConfigFacet);return e.dispatch({selection:n,effects:[announceMatch(e,i),a.scrollToMatch(n.main,e)],userEvent:"select.search"}),selectSearchInput(e),!0})),findPrevious=searchCommand(((e,{query:t})=>{let{state:r}=e,{from:i}=r.selection.main,n=t.prevMatch(r,i,i);if(!n)return !1;let a=EditorSelection.single(n.from,n.to),o=e.state.facet(searchConfigFacet);return e.dispatch({selection:a,effects:[announceMatch(e,n),o.scrollToMatch(a.main,e)],userEvent:"select.search"}),selectSearchInput(e),!0})),selectMatches=searchCommand(((e,{query:t})=>{let r=t.matchAll(e.state,1e3);return !(!r||!r.length)&&(e.dispatch({selection:EditorSelection.create(r.map((e=>EditorSelection.range(e.from,e.to)))),userEvent:"select.search.matches"}),!0)})),selectSelectionMatches=({state:e,dispatch:t})=>{let r=e.selection;if(r.ranges.length>1||r.main.empty)return !1;let{from:i,to:n}=r.main,a=[],o=0;for(let t=new SearchCursor(e.doc,e.sliceDoc(i,n));!t.next().done;){if(a.length>1e3)return !1;t.value.from==i&&(o=a.length),a.push(EditorSelection.range(t.value.from,t.value.to));}return t(e.update({selection:EditorSelection.create(a,o),userEvent:"select.search.matches"})),!0},replaceNext=searchCommand(((e,{query:t})=>{let{state:r}=e,{from:i,to:n}=r.selection.main;if(r.readOnly)return !1;let a=t.nextMatch(r,i,i);if(!a)return !1;let o,s,c=[],l=[];if(a.from==i&&a.to==n&&(s=r.toText(t.getReplacement(a)),c.push({from:a.from,to:a.to,insert:s}),a=t.nextMatch(r,a.from,a.to),l.push(EditorView.announce.of(r.phrase("replaced match on line $",r.doc.lineAt(i).number)+"."))),a){let t=0==c.length||c[0].from>=a.to?0:a.to-a.from-s.length;o=EditorSelection.single(a.from-t,a.to-t),l.push(announceMatch(e,a)),l.push(r.facet(searchConfigFacet).scrollToMatch(o.main,e));}return e.dispatch({changes:c,selection:o,effects:l,userEvent:"input.replace"}),!0})),replaceAll=searchCommand(((e,{query:t})=>{if(e.state.readOnly)return !1;let r=t.matchAll(e.state,1e9).map((e=>{let{from:r,to:i}=e;return {from:r,to:i,insert:t.getReplacement(e)}}));if(!r.length)return !1;let i=e.state.phrase("replaced $ matches",r.length)+".";return e.dispatch({changes:r,effects:EditorView.announce.of(i),userEvent:"input.replace.all"}),!0}));function createSearchPanel(e){return e.state.facet(searchConfigFacet).createPanel(e)}function defaultQuery(e,t){var r,i,n,a,o;let s=e.selection.main,c=s.empty||s.to>s.from+100?"":e.sliceDoc(s.from,s.to);if(t&&!c)return t;let l=e.facet(searchConfigFacet);return new SearchQuery({search:(null!==(r=null==t?void 0:t.literal)&&void 0!==r?r:l.literal)?c:c.replace(/\n/g,"\\n"),caseSensitive:null!==(i=null==t?void 0:t.caseSensitive)&&void 0!==i?i:l.caseSensitive,literal:null!==(n=null==t?void 0:t.literal)&&void 0!==n?n:l.literal,regexp:null!==(a=null==t?void 0:t.regexp)&&void 0!==a?a:l.regexp,wholeWord:null!==(o=null==t?void 0:t.wholeWord)&&void 0!==o?o:l.wholeWord})}function getSearchInput(e){let t=getPanel(e,createSearchPanel);return t&&t.dom.querySelector("[main-field]")}function selectSearchInput(e){let t=getSearchInput(e);t&&t==e.root.activeElement&&t.select();}const openSearchPanel=e=>{let t=e.state.field(searchState,!1);if(t&&t.panel){let r=getSearchInput(e);if(r&&r!=e.root.activeElement){let i=defaultQuery(e.state,t.query.spec);i.valid&&e.dispatch({effects:setSearchQuery.of(i)}),r.focus(),r.select();}}else e.dispatch({effects:[togglePanel.of(!0),t?setSearchQuery.of(defaultQuery(e.state,t.query.spec)):StateEffect.appendConfig.of(searchExtensions)]});return !0},closeSearchPanel=e=>{let t=e.state.field(searchState,!1);if(!t||!t.panel)return !1;let r=getPanel(e,createSearchPanel);return r&&r.dom.contains(e.root.activeElement)&&e.focus(),e.dispatch({effects:togglePanel.of(!1)}),!0},searchKeymap=[{key:"Mod-f",run:openSearchPanel,scope:"editor search-panel"},{key:"F3",run:findNext,shift:findPrevious,scope:"editor search-panel",preventDefault:!0},{key:"Mod-g",run:findNext,shift:findPrevious,scope:"editor search-panel",preventDefault:!0},{key:"Escape",run:closeSearchPanel,scope:"editor search-panel"},{key:"Mod-Shift-l",run:selectSelectionMatches},{key:"Alt-g",run:gotoLine},{key:"Mod-d",run:selectNextOccurrence,preventDefault:!0}];class SearchPanel{constructor(e){this.view=e;let t=this.query=e.state.field(searchState).query.spec;function r(e,t,r){return crelt("button",{class:"cm-button",name:e,onclick:t,type:"button"},r)}this.commit=this.commit.bind(this),this.searchField=crelt("input",{value:t.search,placeholder:phrase(e,"Find"),"aria-label":phrase(e,"Find"),class:"cm-textfield",name:"search",form:"","main-field":"true",onchange:this.commit,onkeyup:this.commit}),this.replaceField=crelt("input",{value:t.replace,placeholder:phrase(e,"Replace"),"aria-label":phrase(e,"Replace"),class:"cm-textfield",name:"replace",form:"",onchange:this.commit,onkeyup:this.commit}),this.caseField=crelt("input",{type:"checkbox",name:"case",form:"",checked:t.caseSensitive,onchange:this.commit}),this.reField=crelt("input",{type:"checkbox",name:"re",form:"",checked:t.regexp,onchange:this.commit}),this.wordField=crelt("input",{type:"checkbox",name:"word",form:"",checked:t.wholeWord,onchange:this.commit}),this.dom=crelt("div",{onkeydown:e=>this.keydown(e),class:"cm-search"},[this.searchField,r("next",(()=>findNext(e)),[phrase(e,"next")]),r("prev",(()=>findPrevious(e)),[phrase(e,"previous")]),r("select",(()=>selectMatches(e)),[phrase(e,"all")]),crelt("label",null,[this.caseField,phrase(e,"match case")]),crelt("label",null,[this.reField,phrase(e,"regexp")]),crelt("label",null,[this.wordField,phrase(e,"by word")]),...e.state.readOnly?[]:[crelt("br"),this.replaceField,r("replace",(()=>replaceNext(e)),[phrase(e,"replace")]),r("replaceAll",(()=>replaceAll(e)),[phrase(e,"replace all")])],crelt("button",{name:"close",onclick:()=>closeSearchPanel(e),"aria-label":phrase(e,"close"),type:"button"},["×"])]);}commit(){let e=new SearchQuery({search:this.searchField.value,caseSensitive:this.caseField.checked,regexp:this.reField.checked,wholeWord:this.wordField.checked,replace:this.replaceField.value});e.eq(this.query)||(this.query=e,this.view.dispatch({effects:setSearchQuery.of(e)}));}keydown(e){runScopeHandlers(this.view,e,"search-panel")?e.preventDefault():13==e.keyCode&&e.target==this.searchField?(e.preventDefault(),(e.shiftKey?findPrevious:findNext)(this.view)):13==e.keyCode&&e.target==this.replaceField&&(e.preventDefault(),replaceNext(this.view));}update(e){for(let t of e.transactions)for(let e of t.effects)e.is(setSearchQuery)&&!e.value.eq(this.query)&&this.setQuery(e.value);}setQuery(e){this.query=e,this.searchField.value=e.search,this.replaceField.value=e.replace,this.caseField.checked=e.caseSensitive,this.reField.checked=e.regexp,this.wordField.checked=e.wholeWord;}mount(){this.searchField.select();}get pos(){return 80}get top(){return this.view.state.facet(searchConfigFacet).top}}function phrase(e,t){return e.state.phrase(t)}const AnnounceMargin=30,Break=/[\s\.,:;?!]/;function announceMatch(e,{from:t,to:r}){let i=e.state.doc.lineAt(t),n=e.state.doc.lineAt(r).to,a=Math.max(i.from,t-AnnounceMargin),o=Math.min(n,r+AnnounceMargin),s=e.state.sliceDoc(a,o);if(a!=i.from)for(let e=0;e<AnnounceMargin;e++)if(!Break.test(s[e+1])&&Break.test(s[e])){s=s.slice(e);break}if(o!=n)for(let e=s.length-1;e>s.length-AnnounceMargin;e--)if(!Break.test(s[e-1])&&Break.test(s[e])){s=s.slice(0,e);break}return EditorView.announce.of(`${e.state.phrase("current match")}. ${s} ${e.state.phrase("on line")} ${i.number}.`)}const baseTheme=EditorView.baseTheme({".cm-panel.cm-search":{padding:"2px 6px 4px",position:"relative","& [name=close]":{position:"absolute",top:"0",right:"4px",backgroundColor:"inherit",border:"none",font:"inherit",padding:0,margin:0},"& input, & button, & label":{margin:".2em .6em .2em 0"},"& input[type=checkbox]":{marginRight:".2em"},"& label":{fontSize:"80%",whiteSpace:"pre"}},"&light .cm-searchMatch":{backgroundColor:"#ffff0054"},"&dark .cm-searchMatch":{backgroundColor:"#00ffff8a"},"&light .cm-searchMatch-selected":{backgroundColor:"#ff6a0054"},"&dark .cm-searchMatch-selected":{backgroundColor:"#ff00ff8a"}}),searchExtensions=[searchState,Prec.lowest(searchHighlighter),baseTheme];

    class EditingFeatures{constructor(e){this.Galapagos=e,this.CodeMirror=e.CodeMirror,this.Parent=e.Parent;}Undo(){return undo(this.CodeMirror)}Redo(){return redo(this.CodeMirror)}Find(e){var r,o;openSearchPanel(this.CodeMirror);let t=null!==(o=null===(r=this.Parent.querySelector('.cm-textfield[name="search"]'))||void 0===r?void 0:r.value)&&void 0!==o?o:"";this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:e}))}),findNext(this.CodeMirror),this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:t}))}),closeSearchPanel(this.CodeMirror);}Replace(e,r){var o,t,i,l;openSearchPanel(this.CodeMirror);let a=null!==(t=null===(o=this.Parent.querySelector('.cm-textfield[name="search"]'))||void 0===o?void 0:o.value)&&void 0!==t?t:"",c=null!==(l=null===(i=this.Parent.querySelector('.cm-textfield[name="replace"]'))||void 0===i?void 0:i.value)&&void 0!==l?l:"";this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:e,replace:r}))}),replaceNext(this.CodeMirror),findNext(this.CodeMirror),this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:a,replace:c}))}),closeSearchPanel(this.CodeMirror);}FindAll(e){var r,o;openSearchPanel(this.CodeMirror);let t=null!==(o=null===(r=this.Parent.querySelector('.cm-textfield[name="search"]'))||void 0===r?void 0:r.value)&&void 0!==o?o:"";this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:e}))}),selectMatches(this.CodeMirror),this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:t}))}),closeSearchPanel(this.CodeMirror);}ReplaceAll(e,r){var o,t,i,l;openSearchPanel(this.CodeMirror);let a=null!==(t=null===(o=this.Parent.querySelector('.cm-textfield[name="search"]'))||void 0===o?void 0:o.value)&&void 0!==t?t:"",c=null!==(l=null===(i=this.Parent.querySelector('.cm-textfield[name="replace"]'))||void 0===i?void 0:i.value)&&void 0!==l?l:"";this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:e,replace:r}))}),replaceAll(this.CodeMirror),this.CodeMirror.dispatch({effects:setSearchQuery.of(new SearchQuery({search:a,replace:c}))}),closeSearchPanel(this.CodeMirror);}JumpTo(e){const{state:r}=this.CodeMirror,o=r.doc.line(Math.max(1,Math.min(r.doc.lines,e)));this.CodeMirror.dispatch({selection:{anchor:o.from},scrollIntoView:!0});}ShowFind(){this.HideAll(),openSearchPanel(this.CodeMirror);const e=this.Parent.querySelector('.cm-textfield[name="replace"]');e&&(e.style.display="none");const r=this.Parent.querySelector('.cm-button[name="replace"]');r&&(r.style.display="none");const o=this.Parent.querySelector('.cm-button[name="replaceAll"]');o&&(o.style.display="none");}ShowReplace(){this.HideAll(),openSearchPanel(this.CodeMirror);const e=this.Parent.querySelector('.cm-textfield[name="replace"]');e&&(e.style.display="inline-block");const r=this.Parent.querySelector('.cm-button[name="replace"]');r&&(r.style.display="inline-block");const o=this.Parent.querySelector('.cm-button[name="replaceAll"]');o&&(o.style.display="inline-block");}ShowJumpTo(){this.HideAll(),closeSearchPanel(this.CodeMirror);const e=this.Parent.querySelector(".cm-gotoLine");e?e.style.display="flex":gotoLine(this.CodeMirror);}HideJumpTo(){const e=this.Parent.querySelector(".cm-gotoLine");e&&(e.style.display="none");}HideAll(){closeSearchPanel(this.CodeMirror),this.HideJumpTo();}ShowProcedures(){}}

    function Diff(){}function buildValues(e,n,t,r,i){for(var o=0,a=n.length,l=0,s=0;o<a;o++){var f=n[o];if(f.removed){if(f.value=e.join(r.slice(s,s+f.count)),s+=f.count,o&&n[o-1].added){var u=n[o-1];n[o-1]=n[o],n[o]=u;}}else {if(!f.added&&i){var d=t.slice(l,l+f.count);d=d.map((function(e,n){var t=r[s+n];return t.length>e.length?t:e})),f.value=e.join(d);}else f.value=e.join(t.slice(l,l+f.count));l+=f.count,f.added||(s+=f.count);}}var c=n[a-1];return a>1&&"string"==typeof c.value&&(c.added||c.removed)&&e.equals("",c.value)&&(n[a-2].value+=c.value,n.pop()),n}function clonePath(e){return {newPos:e.newPos,components:e.components.slice(0)}}Diff.prototype={diff:function(e,n){var t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=t.callback;"function"==typeof t&&(r=t,t={}),this.options=t;var i=this;function o(e){return r?(setTimeout((function(){r(void 0,e);}),0),!0):e}e=this.castInput(e),n=this.castInput(n),e=this.removeEmpty(this.tokenize(e));var a=(n=this.removeEmpty(this.tokenize(n))).length,l=e.length,s=1,f=a+l;t.maxEditLength&&(f=Math.min(f,t.maxEditLength));var u=[{newPos:-1,components:[]}],d=this.extractCommon(u[0],n,e,0);if(u[0].newPos+1>=a&&d+1>=l)return o([{value:this.join(n),count:n.length}]);function c(){for(var t=-1*s;t<=s;t+=2){var r=void 0,f=u[t-1],d=u[t+1],c=(d?d.newPos:0)-t;f&&(u[t-1]=void 0);var h=f&&f.newPos+1<a,p=d&&0<=c&&c<l;if(h||p){if(!h||p&&f.newPos<d.newPos?(r=clonePath(d),i.pushComponent(r.components,void 0,!0)):((r=f).newPos++,i.pushComponent(r.components,!0,void 0)),c=i.extractCommon(r,n,e,t),r.newPos+1>=a&&c+1>=l)return o(buildValues(i,r.components,n,e,i.useLongestToken));u[t]=r;}else u[t]=void 0;}s++;}if(r)!function e(){setTimeout((function(){if(s>f)return r();c()||e();}),0);}();else for(;s<=f;){var h=c();if(h)return h}},pushComponent:function(e,n,t){var r=e[e.length-1];r&&r.added===n&&r.removed===t?e[e.length-1]={count:r.count+1,added:n,removed:t}:e.push({count:1,added:n,removed:t});},extractCommon:function(e,n,t,r){for(var i=n.length,o=t.length,a=e.newPos,l=a-r,s=0;a+1<i&&l+1<o&&this.equals(n[a+1],t[l+1]);)a++,l++,s++;return s&&e.components.push({count:s}),e.newPos=a,l},equals:function(e,n){return this.options.comparator?this.options.comparator(e,n):e===n||this.options.ignoreCase&&e.toLowerCase()===n.toLowerCase()},removeEmpty:function(e){for(var n=[],t=0;t<e.length;t++)e[t]&&n.push(e[t]);return n},castInput:function(e){return e},tokenize:function(e){return e.split("")},join:function(e){return e.join("")}};function generateOptions(e,n){if("function"==typeof e)n.callback=e;else if(e)for(var t in e)e.hasOwnProperty(t)&&(n[t]=e[t]);return n}var extendedWordChars=/^[A-Za-z\xC0-\u02C6\u02C8-\u02D7\u02DE-\u02FF\u1E00-\u1EFF]+$/,reWhitespace=/\S/,wordDiff=new Diff;function diffWords(e,n,t){return t=generateOptions(t,{ignoreWhitespace:!0}),wordDiff.diff(e,n,t)}wordDiff.equals=function(e,n){return this.options.ignoreCase&&(e=e.toLowerCase(),n=n.toLowerCase()),e===n||this.options.ignoreWhitespace&&!reWhitespace.test(e)&&!reWhitespace.test(n)},wordDiff.tokenize=function(e){for(var n=e.split(/([^\S\r\n]+|[()[\]{}'"\r\n]|\b)/),t=0;t<n.length-1;t++)!n[t+1]&&n[t+2]&&extendedWordChars.test(n[t])&&extendedWordChars.test(n[t+2])&&(n[t]+=n[t+2],n.splice(t+1,2),t--);return n};var lineDiff=new Diff;lineDiff.tokenize=function(e){var n=[],t=e.split(/(\n|\r\n)/);t[t.length-1]||t.pop();for(var r=0;r<t.length;r++){var i=t[r];r%2&&!this.options.newlineIsToken?n[n.length-1]+=i:(this.options.ignoreWhitespace&&(i=i.trim()),n.push(i));}return n};var sentenceDiff=new Diff;sentenceDiff.tokenize=function(e){return e.split(/(\S.+?[.!?])(?=\s+|$)/)};var cssDiff=new Diff;function _typeof(e){return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_typeof(e)}cssDiff.tokenize=function(e){return e.split(/([{}:;,]|\s+)/)};var objectPrototypeToString=Object.prototype.toString,jsonDiff=new Diff;function canonicalize(e,n,t,r,i){var o,a;for(n=n||[],t=t||[],r&&(e=r(i,e)),o=0;o<n.length;o+=1)if(n[o]===e)return t[o];if("[object Array]"===objectPrototypeToString.call(e)){for(n.push(e),a=new Array(e.length),t.push(a),o=0;o<e.length;o+=1)a[o]=canonicalize(e[o],n,t,r,i);return n.pop(),t.pop(),a}if(e&&e.toJSON&&(e=e.toJSON()),"object"===_typeof(e)&&null!==e){n.push(e),a={},t.push(a);var l,s=[];for(l in e)e.hasOwnProperty(l)&&s.push(l);for(s.sort(),o=0;o<s.length;o+=1)a[l=s[o]]=canonicalize(e[l],n,t,r,l);n.pop(),t.pop();}else a=e;return a}jsonDiff.useLongestToken=!0,jsonDiff.tokenize=lineDiff.tokenize,jsonDiff.castInput=function(e){var n=this.options,t=n.undefinedReplacement,r=n.stringifyReplacer,i=void 0===r?function(e,n){return void 0===n?t:n}:r;return "string"==typeof e?e:JSON.stringify(canonicalize(e,null,null,i),i,"  ")},jsonDiff.equals=function(e,n){return Diff.prototype.equals.call(jsonDiff,e.replace(/,([\r\n])/g,"$1"),n.replace(/,([\r\n])/g,"$1"))};var arrayDiff=new Diff;arrayDiff.tokenize=function(e){return e.slice()},arrayDiff.join=arrayDiff.removeEmpty=function(e){return e};

    let extend="lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((e=>e?parseInt(e,36):1));for(let e=1;e<extend.length;e++)extend[e]+=extend[e-1];class Text{constructor(){}lineAt(e){if(e<0||e>this.length)throw new RangeError(`Invalid position ${e} in document of length ${this.length}`);return this.lineInner(e,!1,1,0)}line(e){if(e<1||e>this.lines)throw new RangeError(`Invalid line number ${e} in ${this.lines}-line document`);return this.lineInner(e,!0,1,0)}replace(e,t,n){let i=[];return this.decompose(0,e,i,2),n.length&&n.decompose(0,n.length,i,3),this.decompose(t,this.length,i,1),TextNode.from(i,this.length-(t-e)+n.length)}append(e){return this.replace(this.length,this.length,e)}slice(e,t=this.length){let n=[];return this.decompose(e,t,n,0),TextNode.from(n,t-e)}eq(e){if(e==this)return !0;if(e.length!=this.length||e.lines!=this.lines)return !1;let t=this.scanIdentical(e,1),n=this.length-this.scanIdentical(e,-1),i=new RawTextCursor(this),r=new RawTextCursor(e);for(let e=t,s=t;;){if(i.next(e),r.next(e),e=0,i.lineBreak!=r.lineBreak||i.done!=r.done||i.value!=r.value)return !1;if(s+=i.value.length,i.done||s>=n)return !0}}iter(e=1){return new RawTextCursor(this,e)}iterRange(e,t=this.length){return new PartialTextCursor(this,e,t)}iterLines(e,t){let n;if(null==e)n=this.iter();else {null==t&&(t=this.lines+1);let i=this.line(e).from;n=this.iterRange(i,Math.max(i,t==this.lines+1?this.length:t<=1?0:this.line(t-1).to));}return new LineCursor(n)}toString(){return this.sliceString(0)}toJSON(){let e=[];return this.flatten(e),e}static of(e){if(0==e.length)throw new RangeError("A document must have at least one line");return 1!=e.length||e[0]?e.length<=32?new TextLeaf(e):TextNode.from(TextLeaf.split(e,[])):Text.empty}}class TextLeaf extends Text{constructor(e,t=textLength(e)){super(),this.text=e,this.length=t;}get lines(){return this.text.length}get children(){return null}lineInner(e,t,n,i){for(let r=0;;r++){let s=this.text[r],l=i+s.length;if((t?n:l)>=e)return new Line(i,l,n,s);i=l+1,n++;}}decompose(e,t,n,i){let r=e<=0&&t>=this.length?this:new TextLeaf(sliceText(this.text,e,t),Math.min(t,this.length)-Math.max(0,e));if(1&i){let e=n.pop(),t=appendText(r.text,e.text.slice(),0,r.length);if(t.length<=32)n.push(new TextLeaf(t,e.length+r.length));else {let e=t.length>>1;n.push(new TextLeaf(t.slice(0,e)),new TextLeaf(t.slice(e)));}}else n.push(r);}replace(e,t,n){if(!(n instanceof TextLeaf))return super.replace(e,t,n);let i=appendText(this.text,appendText(n.text,sliceText(this.text,0,e)),t),r=this.length+n.length-(t-e);return i.length<=32?new TextLeaf(i,r):TextNode.from(TextLeaf.split(i,[]),r)}sliceString(e,t=this.length,n="\n"){let i="";for(let r=0,s=0;r<=t&&s<this.text.length;s++){let l=this.text[s],h=r+l.length;r>e&&s&&(i+=n),e<h&&t>r&&(i+=l.slice(Math.max(0,e-r),t-r)),r=h+1;}return i}flatten(e){for(let t of this.text)e.push(t);}scanIdentical(){return 0}static split(e,t){let n=[],i=-1;for(let r of e)n.push(r),i+=r.length+1,32==n.length&&(t.push(new TextLeaf(n,i)),n=[],i=-1);return i>-1&&t.push(new TextLeaf(n,i)),t}}class TextNode extends Text{constructor(e,t){super(),this.children=e,this.length=t,this.lines=0;for(let t of e)this.lines+=t.lines;}lineInner(e,t,n,i){for(let r=0;;r++){let s=this.children[r],l=i+s.length,h=n+s.lines-1;if((t?h:l)>=e)return s.lineInner(e,t,n,i);i=l+1,n=h+1;}}decompose(e,t,n,i){for(let r=0,s=0;s<=t&&r<this.children.length;r++){let l=this.children[r],h=s+l.length;if(e<=h&&t>=s){let r=i&((s<=e?1:0)|(h>=t?2:0));s>=e&&h<=t&&!r?n.push(l):l.decompose(e-s,t-s,n,r);}s=h+1;}}replace(e,t,n){if(n.lines<this.lines)for(let i=0,r=0;i<this.children.length;i++){let s=this.children[i],l=r+s.length;if(e>=r&&t<=l){let h=s.replace(e-r,t-r,n),o=this.lines-s.lines+h.lines;if(h.lines<o>>4&&h.lines>o>>6){let r=this.children.slice();return r[i]=h,new TextNode(r,this.length-(t-e)+n.length)}return super.replace(r,l,h)}r=l+1;}return super.replace(e,t,n)}sliceString(e,t=this.length,n="\n"){let i="";for(let r=0,s=0;r<this.children.length&&s<=t;r++){let l=this.children[r],h=s+l.length;s>e&&r&&(i+=n),e<h&&t>s&&(i+=l.sliceString(e-s,t-s,n)),s=h+1;}return i}flatten(e){for(let t of this.children)t.flatten(e);}scanIdentical(e,t){if(!(e instanceof TextNode))return 0;let n=0,[i,r,s,l]=t>0?[0,0,this.children.length,e.children.length]:[this.children.length-1,e.children.length-1,-1,-1];for(;;i+=t,r+=t){if(i==s||r==l)return n;let h=this.children[i],o=e.children[r];if(h!=o)return n+h.scanIdentical(o,t);n+=h.length+1;}}static from(e,t=e.reduce(((e,t)=>e+t.length+1),-1)){let n=0;for(let t of e)n+=t.lines;if(n<32){let n=[];for(let t of e)t.flatten(n);return new TextLeaf(n,t)}let i=Math.max(32,n>>5),r=i<<1,s=i>>1,l=[],h=0,o=-1,a=[];function f(e){let t;if(e.lines>r&&e instanceof TextNode)for(let t of e.children)f(t);else e.lines>s&&(h>s||!h)?(u(),l.push(e)):e instanceof TextLeaf&&h&&(t=a[a.length-1])instanceof TextLeaf&&e.lines+t.lines<=32?(h+=e.lines,o+=e.length+1,a[a.length-1]=new TextLeaf(t.text.concat(e.text),t.length+1+e.length)):(h+e.lines>i&&u(),h+=e.lines,o+=e.length+1,a.push(e));}function u(){0!=h&&(l.push(1==a.length?a[0]:TextNode.from(a,o)),o=-1,h=a.length=0);}for(let t of e)f(t);return u(),1==l.length?l[0]:new TextNode(l,t)}}function textLength(e){let t=-1;for(let n of e)t+=n.length+1;return t}function appendText(e,t,n=0,i=1e9){for(let r=0,s=0,l=!0;s<e.length&&r<=i;s++){let h=e[s],o=r+h.length;o>=n&&(o>i&&(h=h.slice(0,i-r)),r<n&&(h=h.slice(n-r)),l?(t[t.length-1]+=h,l=!1):t.push(h)),r=o+1;}return t}function sliceText(e,t,n){return appendText(e,[""],t,n)}Text.empty=new TextLeaf([""],0);class RawTextCursor{constructor(e,t=1){this.dir=t,this.done=!1,this.lineBreak=!1,this.value="",this.nodes=[e],this.offsets=[t>0?1:(e instanceof TextLeaf?e.text.length:e.children.length)<<1];}nextInner(e,t){for(this.done=this.lineBreak=!1;;){let n=this.nodes.length-1,i=this.nodes[n],r=this.offsets[n],s=r>>1,l=i instanceof TextLeaf?i.text.length:i.children.length;if(s==(t>0?l:0)){if(0==n)return this.done=!0,this.value="",this;t>0&&this.offsets[n-1]++,this.nodes.pop(),this.offsets.pop();}else if((1&r)==(t>0?0:1)){if(this.offsets[n]+=t,0==e)return this.lineBreak=!0,this.value="\n",this;e--;}else if(i instanceof TextLeaf){let r=i.text[s+(t<0?-1:0)];if(this.offsets[n]+=t,r.length>Math.max(0,e))return this.value=0==e?r:t>0?r.slice(e):r.slice(0,r.length-e),this;e-=r.length;}else {let r=i.children[s+(t<0?-1:0)];e>r.length?(e-=r.length,this.offsets[n]+=t):(t<0&&this.offsets[n]--,this.nodes.push(r),this.offsets.push(t>0?1:(r instanceof TextLeaf?r.text.length:r.children.length)<<1));}}}next(e=0){return e<0&&(this.nextInner(-e,-this.dir),e=this.value.length),this.nextInner(e,this.dir)}}class PartialTextCursor{constructor(e,t,n){this.value="",this.done=!1,this.cursor=new RawTextCursor(e,t>n?-1:1),this.pos=t>n?e.length:0,this.from=Math.min(t,n),this.to=Math.max(t,n);}nextInner(e,t){if(t<0?this.pos<=this.from:this.pos>=this.to)return this.value="",this.done=!0,this;e+=Math.max(0,t<0?this.pos-this.to:this.from-this.pos);let n=t<0?this.pos-this.from:this.to-this.pos;e>n&&(e=n),n-=e;let{value:i}=this.cursor.next(e);return this.pos+=(i.length+e)*t,this.value=i.length<=n?i:t<0?i.slice(i.length-n):i.slice(0,n),this.done=!this.value,this}next(e=0){return e<0?e=Math.max(e,this.from-this.pos):e>0&&(e=Math.min(e,this.to-this.pos)),this.nextInner(e,this.cursor.dir)}get lineBreak(){return this.cursor.lineBreak&&""!=this.value}}class LineCursor{constructor(e){this.inner=e,this.afterBreak=!0,this.value="",this.done=!1;}next(e=0){let{done:t,lineBreak:n,value:i}=this.inner.next(e);return t?(this.done=!0,this.value=""):n?this.afterBreak?this.value="":(this.afterBreak=!0,this.next()):(this.value=i,this.afterBreak=!1),this}get lineBreak(){return !1}}"undefined"!=typeof Symbol&&(Text.prototype[Symbol.iterator]=function(){return this.iter()},RawTextCursor.prototype[Symbol.iterator]=PartialTextCursor.prototype[Symbol.iterator]=LineCursor.prototype[Symbol.iterator]=function(){return this});class Line{constructor(e,t,n,i){this.from=e,this.to=t,this.number=n,this.text=i;}get length(){return this.to-this.from}}

    class TextWidget extends WidgetType{constructor(t,e=""){super(),this.text=t,this.className=e;}toDOM(){let t=document.createElement("span");return t.setAttribute("aria-hidden","true"),t.className=`cm-text ${this.className}`,t.textContent=this.text,t}}class CheckboxWidget extends WidgetType{constructor(t,e){super(),this.CodeMirror=t,this.CurrentVersion=e;}toDOM(){let t=document.createElement("span");t.setAttribute("aria-hidden","true");let e=t.appendChild(document.createElement("input"));return e.type="checkbox",e.addEventListener("click",(t=>{let e=this.CodeMirror.state.doc.length,r=this.CurrentVersion.split("\n"),i=Text.of(r),s=this.CodeMirror.state.update({changes:{from:0,to:e,insert:i}});this.CodeMirror.dispatch(s);})),t}ignoreEvent(){return !1}}

    class SelectionFeatures{constructor(e){this.Galapagos=e,this.CodeMirror=e.CodeMirror;}SelectAll(){selectAll(this.CodeMirror),this.CodeMirror.focus();}Select(e,t){t>this.CodeMirror.state.doc.length||e<0||e>t||(this.CodeMirror.dispatch({selection:{anchor:e,head:t},scrollIntoView:!0}),this.CodeMirror.focus());}GetSelection(){return {from:this.CodeMirror.state.selection.main.from,to:this.CodeMirror.state.selection.main.to}}GetSelections(){return this.CodeMirror.state.selection.ranges}GetCursorPosition(){var e,t;return null!==(t=null===(e=this.CodeMirror.state.selection.ranges[0])||void 0===e?void 0:e.from)&&void 0!==t?t:0}SetCursorPosition(e){this.CodeMirror.dispatch({selection:{anchor:e},scrollIntoView:!0});}RefreshCursor(){this.SetCursorPosition(this.GetCursorPosition());}HighlightChanges(e){let t=!1;const o=this.CodeMirror.state.doc.toString(),r=this.CodeMirror.state,i=this.CodeMirror,s=diffWords(e,o),a=s.filter((e=>e.removed)).map((e=>e.value.replace("\n","↵\n"))),d=s.filter((e=>e.added)).map((e=>e.value)),n=StateEffect.define({map:({from:e,to:t},o)=>({from:o.mapPos(e),to:o.mapPos(t)})}),c=StateEffect.define({map:({from:e,to:t},o)=>({from:o.mapPos(e),to:o.mapPos(t)})}),f=Decoration.mark({attributes:{class:"cm-added"}});let l=0;const m=StateField.define({create:()=>Decoration.none,update(e,t){e=e.map(t.changes);for(let o of t.effects)if(o.is(n))e=e.update({add:[f.range(o.value.from,o.value.to)]});else if(o.is(c)){let t=Decoration.widget({widget:new TextWidget(a[l],"cm-removed"),side:1});l++,e=e.update({add:[t.range(o.value.to)]});}return e},provide:e=>EditorView.decorations.from(e)});d.forEach((e=>function(e,t){let o=[],r=new SearchCursor(e.state.doc,t,0);return r.next(),o.push(n.of({from:r.value.from,to:r.value.to})),!!o.length&&(e.state.field(m,!1)||o.push(StateEffect.appendConfig.of([m])),e.dispatch({effects:o}),!0)}(this.CodeMirror,e)));let h=0;s.forEach((e=>{e.removed?function(e,t,o="text"){let r=[];"text"===o&&r.push(c.of({from:0,to:t})),!!r.length&&(r.push(StateEffect.appendConfig.of([m])),e.dispatch({effects:r}));}(this.CodeMirror,h):h+=e.value.length;}));const p=StateField.define({create(){},update(e,o){var s;o.selection&&!t&&(console.log("selection changed "),(s=50,new Promise((e=>setTimeout(e,s)))).then((()=>{var e;e=r,i.setState(e),t=!1;})));}});this.CodeMirror.dispatch({effects:StateEffect.appendConfig.of([p])});}}

    const prettify=function(e,n=null,t=null){n&&t&&e.dispatch({selection:{anchor:n,head:t}}),n=e.state.selection.main.from,t=e.state.selection.main.to;let o=removeSpacingRegex(e.state.doc.toString().substring(n,t));return e.dispatch(e.state.replaceSelection(o)),e.dispatch({selection:{anchor:n,head:n+o.length}}),e.dispatch({changes:addSpacing(e,e.state.selection.main.from,e.state.selection.main.to,100)}),n=e.state.selection.main.from,t=e.state.selection.main.to,o=finalSpacing(e.state.doc.toString().substring(n,t)),e.dispatch(e.state.replaceSelection(o)),e.dispatch({selection:{anchor:n,head:n+o.length}}),e.dispatch({changes:indentRange(e.state,e.state.selection.main.from,e.state.selection.main.to)}),e.state.selection.main.to};const prettifyAll=function(e,n){let t=e.state.doc.toString();n.ForceParse();let o=removeSpacing(syntaxTree(e.state),t);e.dispatch({changes:{from:0,to:t.length,insert:o}}),n.ForceParse(),e.dispatch({changes:addSpacing(e,0,o.length,n.LineWidth)}),o=finalSpacing(e.state.doc.toString()),e.dispatch({changes:{from:0,to:e.state.doc.toString().length,insert:o}}),n.ForceParse(),e.dispatch({changes:indentRange(e.state,0,e.state.doc.toString().length)}),t!=e.state.doc.toString()&&Log("Prettifier made changes");};const doubleLineBreaks=["GlobalStr","ExtensionStr","BreedStr","Own","To"];function removeSpacing(e,n){var t="",o="",r=0;return e.iterate({enter:e=>{if(null==e.node.firstChild){var s=n.substring(e.from,e.to);if("("!==o&&")"!==s&&e.from>0){var i=n.substring(r,e.from);-1!==doubleLineBreaks.indexOf(e.node.name)?-1!=i.indexOf("\n\n")?t+="\n\n":-1!=i.indexOf("\n")?t+="\n":t+=" ":"LineComment"==e.name?(i=i.replace(/\n\n+/g,"\n\n"),t+=i):-1!=i.indexOf("\n")?t+="\n":t+=" ";}t+=s,o=s,r=e.to;}},mode:IterMode.IncludeAnonymous}),t}function removeSpacingRegex(e){let n=e.replace(/\n[ ]+/g,"\n");return n=n.replace(/(\n[^;\n]+)(\n\s*\[)/g,"$1 ["),n=n.replace(/(\n[^;\n]+)(\n\s*\])/g,"$1 ]"),n=n.replace(/(\[\n\s*)([\w\(])/g,"[ $2"),n=n.replace(/(\n)( +)(to[ -])/g,"$1$3"),n=n.replace(/ +/g," "),n=n.replace(/[ ]+\n/g,"\n"),n=n.replace(/\n\n+/g,"\n\n"),n}const finalSpacing=function(e){let n=e.replace(/\n[ ]+/g,"\n");return n=n.replace(/[ ]+\n/g,"\n"),n=n.replace(/\n\n+/g,"\n\n"),n=n.replace(/ +/g," "),n=n.replace(/^\s+/g,""),n=n.replace(/(\n[^;\n]+)\n[ ]*\[[ ]*\n/g,"$1 [\n"),n=n.replace(/(\n+)(\n\nto[ -])/g,"$2"),n=n.replace(/(\n+)(\n\n[\w-]+-own)/g,"$2"),n=n.replace(/[ ]+$/,""),n},addSpacing=function(e,n,t,o){let r=[],s=e.state.doc.toString(),i=0;return syntaxTree(e.state).cursor().iterate((a=>{var m,c,l;if(console.log(a.name,"'"+getCodeName(e.state,a.node)+"'"),a.from>=n&&a.to<=t){if(("Program"==(null===(m=a.node.parent)||void 0===m?void 0:m.name)&&"LineComment"!=a.name||"To"==a.name||"End"==a.name||"ProcedureContent"==a.name&&"CodeBlock"!=(null===(c=a.node.parent)||void 0===c?void 0:c.name))&&a.from>0&&"\n"!=s[a.from-1])r.push({from:a.from,to:a.from,insert:"\n"});else if("CodeBlock"==a.name){if(s.substring(a.from,a.to).match(/^\s*\[\s*[^\s]+\s*\]/g)){let e="[ "+s.substring(a.from,a.to).replace(/(\[|\]|\n)/g,"").trim()+" ]";return s.substring(0,a.from).match(/\n[ ]*$/)?r.push({from:a.from,to:a.to,insert:e}):r.push({from:a.from,to:a.to,insert:"\n"+e}),!1}if(checkBlock(a.node,"ProcedureContent",s,o))for(var f of ["ProcedureContent","CloseBracket"])a.node.getChildren(f).map((e=>{s.substring(Math.max(0,e.from-15),e.from).trim().endsWith("\n")&&r.push({from:e.from,to:e.from,insert:"\n"});}));}else if("ReporterBlock"==a.name&&checkBlock(a.node,"ReporterContent",s,o))for(var f of ["ReporterContent","CloseBracket"])a.node.getChildren(f).map((e=>{"\n"!=s[e.from-1]&&r.push({from:e.from,to:e.from,insert:"\n"});}));else if("CommandStatement"==a.name||"ReporterStatement"==a.name){let e=a.node.cursor();if(e.firstChild()){for(;"LineComment"==e.node.name;)e.nextSibling();let n=s.substring(0,e.from).lastIndexOf("\n"),t=s.substring(n,e.to).match(/^\s+/);t&&(n+=t[0].length),n=Math.max(n,i);let a=e.to,m=e.to;for("Arg"!=e.node.name&&"Arg"==(null===(l=e.node.nextSibling)||void 0===l?void 0:l.name)&&s.substring(e.from,e.to).length<o&&"\n"==s.substring(e.to,e.to+1)&&(r.push({from:e.to,to:e.to+1,insert:" "}),m=e.to+1);e.nextSibling();)"LineComment"!=e.node.name?(m>e.from&&(m=e.from),"Arg"==e.node.name&&(s.substring(a,e.from).includes("\n")&&s.substring(n,e.to).replace(/\s+/g," ").length<o?r.push({from:m,to:e.from,insert:" "}):s.substring(n,e.to).length>o&&!s.substring(a,e.to).includes("\n")&&e.node.nextSibling&&(r.push({from:m,to:e.from,insert:"\n"}),i=e.from),a=e.to),m=e.to):m=e.to+1;}}else if("AnonymousProcedure"==a.name&&(checkBlock(a.node,"ReporterContent",s,o)||checkBlock(a.node,"ProcedureContent",s,o)))for(var f of ["ProcedureContent","ReporterContent","CloseBracket"])a.node.getChildren(f).map((e=>{"\n"!=s[e.from-1]&&r.push({from:e.from,to:e.from,insert:"\n"});}));else if("OpenParen"!=a.name||[" ","(","\n"].includes(e.state.sliceDoc(a.from-1,a.from)))if("CloseParen"!=a.name||[" ","\n",")"].includes(e.state.sliceDoc(a.to,a.to+1))){if("OpenBracket"==a.name){let n="";" "!=e.state.sliceDoc(a.from-1,a.from)&&(n+=" "),n+="[",[" ","\n"].includes(e.state.sliceDoc(a.to,a.to+1))||(n+=" "),r.push({from:a.from,to:a.to,insert:n});}else if("CloseBracket"==a.name){let n="";" "!=e.state.sliceDoc(a.from-1,a.from)&&(n+=" "),n+="]",[" ","\n"].includes(e.state.sliceDoc(a.to,a.to+1))||(n+=" "),r.push({from:a.from,to:a.to,insert:n});}}else r.push({from:a.from,to:a.to,insert:") "});else r.push({from:a.from,to:a.to,insert:" ("});if(["Extensions","Globals","BreedsOwn"].includes(a.name)&&s.substring(a.from,a.to).includes("\n"))for(var f of ["CloseBracket","Extension","Identifier"])a.node.getChildren(f).map((e=>{"\n"!=s[e.from-1]&&e.from>0&&r.push({from:e.from,to:e.from,insert:"\n"});}));if(a.name.includes("Args")&&!a.name.includes("Special")){let e=s.substring(a.from,a.to).toLowerCase();r.push({from:a.from,to:a.to,insert:e});}}})),r},checkBlock=function(e,n,t,o){let r=0,s=t.substring(e.from,e.to).includes("[\n"),i=!1;return e.node.getChildren(n).map((e=>{r+=1,s=t.substring(e.from,e.to).includes("\n")||t.substring(e.from,e.to).length>o||s,e.getChildren("CommandStatement").map((e=>{e.getChildren("Arg").map((e=>{(e.getChildren("CodeBlock").length>0||e.getChildren("AnonymousProcedure").length>0)&&(i=!0);}));}));})),(s||i)&&1==r||r>1};

    function BuildSnapshot(e){e.UpdateContext();var r=e.GetState(),o=e.GetCode(),s=r.Extensions,n=r.Globals,t=new Map;for(var[a,i]of r.Breeds)t.set(a,JSON.parse(JSON.stringify(i)));var p=new Map;for(var[d,l]of r.Procedures)p.set(d,JSON.parse(JSON.stringify(l)));return {Code:o,Extensions:s,Globals:n,Breeds:t,Procedures:p}}function IntegrateSnapshot(e,r){for(var[o,s]of r.Breeds)e.Operations.AppendBreed(s.BreedType,s.Plural,s.Singular);for(var[o,s]of r.Breeds)e.Operations.AppendBreedVariables(s.Plural,s.Variables);e.Operations.AppendGlobals("Extensions",r.Extensions),e.Operations.AppendGlobals("Globals",r.Globals);}

    function FixGeneratedCode(e,o,n,t=!0){return __awaiter(this,void 0,void 0,(function*(){if(""==(o=o.trim()))return o;o.endsWith(";")&&(o=o.slice(0,-1)),e.SetCode(o),e.Semantics.PrettifyAll();var t=BuildSnapshot(e),l=[];let r=[],i=e.CodeMirror.state,s=[],m=null,d=null,u=null,a={Globals:null,Extensions:null},f=[],c=[],h=[],g=[...turtleVars,...patchVars,...linkVars,...constants];var p=e=>{if("Procedure"==e.name&&null==u)u=e.from;else if("Globals"==e.name||"Extensions"==e.name)if(null==a[e.name]){if(null!=u&&u<e.from)return r.push({from:0,to:0,insert:AddComments(i.sliceDoc(e.from,e.to),s)+"\n\n"}),r.push({from:null!=m?m:e.from,to:e.to,insert:""}),a[e.name]=AddComments(i.sliceDoc(e.from,e.to),s).length-1,s=[],d=null,void(m=null);a[e.name]=e.to-1;}else {let o=i.sliceDoc(e.from,e.to).replace(/globals\s*\[/i,"").replace(/extensions\s*\[/i,"").replace(/\]/,""),n=a[e.name];if(n)return r.push({from:n,to:n,insert:" "+o}),r.push({from:null!=m?m:e.from,to:e.to,insert:""}),s=[],d=null,void(m=null)}else if(null!=u&&("BreedsOwn"==e.name||"Misplaced"==e.name&&"BreedToken"==e.node.resolveInner(e.from,1).name))return r.push({from:0,to:0,insert:AddComments(i.sliceDoc(e.from,e.to),s)+"\n\n"}),r.push({from:null!=m?m:e.from,to:e.to,insert:""}),s=[],d=null,void(m=null);"LineComment"==e.name?(s=[i.sliceDoc(e.from,e.to)],m=e.from):s.length>0&&!d?d=e.from:s.length>0&&d&&e.from>d&&(s=[],d=null,m=null);};let C=syntaxTree(i).cursor();if(C.firstChild(),"Normal"==C.node.name&&C.firstChild())for(p(C.node);C.nextSibling();)p(C.node);e.Operations.ChangeCode(r),e.ForceParse(),i=e.CodeMirror.state,r=[],u=null,s=[],d=null,m=null;let v=i.doc.toString().toLowerCase();return syntaxTree(i).cursor().iterate((e=>{var o,n,t,a,p;if("Misplaced"==e.name||"Procedure"==e.name&&0==e.node.getChildren("To").length){let n=!1;if(Log(e.name,e.from,d,s),"Misplaced"==e.name){let t=null===(o=e.node.firstChild)||void 0===o?void 0:o.firstChild;t&&t.name.includes("0Args")&&(n=!0);}return n||l.push(AddComments(i.sliceDoc(e.from,e.to),s)),r.push({from:null!=m?m:e.from,to:Math.min(e.to+1,v.length),insert:""}),!1}if("Error"==e.name)return Log(e.name,s),r.push({from:null!=m?m:e.from,to:e.to+1,insert:""}),r.push({from:0,to:0,insert:AddComments(i.sliceDoc(e.from,e.to),s)+"\n"}),!1;if("Globals"==e.name){let o=e.node.getChildren("Identifier").length,n=0,t=[];e.node.getChildren("Identifier").map((e=>{let o=getCodeName(i,e);(c.includes(o)||g.includes(o))&&(t.push({from:e.from,to:e.to,insert:""}),n+=1),c.push(o);})),n==o||0==o?r.push({from:null!=m?m:e.from,to:e.to+1,insert:""}):r=r.concat(t);}else if("BreedsOwn"==e.name){let o=[],n=e.node.getChildren("Identifier").length,t=0,l=[];e.node.getChildren("Identifier").map((e=>{let n=i.sliceDoc(e.from,e.to);(o.includes(n.toLowerCase())||g.includes(n.toLowerCase()))&&(l.push({from:e.from,to:e.to,insert:""}),t+=1),o.push(n.toLowerCase());})),t==n||0==n?r.push({from:null!=m?m:e.from,to:e.to+1,insert:""}):r=r.concat(l);}else if("Breed"==e.name){let o=FixBreed(e.node,i,f);null!=o&&r.push({from:o.from,to:o.to,insert:o.insert});let n=e.node.getChild("BreedPlural"),t=e.node.getChild("BreedSingular");n&&t&&(f.push(i.sliceDoc(n.from,n.to).toLowerCase()),f.push(i.sliceDoc(t.from,t.to).toLowerCase()));}else if("Extensions"==e.name){let o=e.node.getChildren("Identifier").length,n=0,t=[];e.node.getChildren("Identifier").map((e=>{let o=getCodeName(i,e);(v.includes("("+o+":")||v.includes(" "+o+":")||v.includes("\n"+o+":")||h.includes(o))&&(t.push({from:e.from,to:e.to,insert:""}),n+=1),h.push(o);})),n==o||0==o?r.push({from:null!=m?m:e.from,to:e.to+1,insert:""}):r=r.concat(t);}else if("SpecialCommand0Args"==e.name&&"setup"==i.sliceDoc(e.from,e.to).toLowerCase()){let o=null===(t=null===(n=e.node.parent)||void 0===n?void 0:n.parent)||void 0===t?void 0:t.parent,l=null==o?void 0:o.getChild("ProcedureName");"Procedure"==(null==o?void 0:o.name)&&"go"==i.sliceDoc(null==l?void 0:l.from,null==l?void 0:l.to).toLowerCase()&&r.push({from:null!=m?m:e.from,to:e.to+1,insert:""});}if("Procedure"==e.name&&1==e.node.getChildren("ProcedureContent").length){let o=null===(p=null===(a=e.node.getChild("ProcedureContent"))||void 0===a?void 0:a.getChild("CommandStatement"))||void 0===p?void 0:p.getChild("SpecialCommand0Args");o&&v.includes("to "+getCodeName(i,o))&&r.push({from:e.from,to:e.to,insert:""});}else if("Procedure"==e.name&&0==e.node.getChildren("ProcedureContent").length){let o=e.node.getChild("ProcedureName"),n=getCodeName(i,o),t=v.match(new RegExp(n,"gi"));t&&1==t.length&&r.push({from:e.from,to:e.to,insert:""});}else e.name;u||"Procedure"!=e.name||(u=e.from),"LineComment"==e.name?(s=[i.sliceDoc(e.from,e.to)],m=e.from):s.length>0&&!d?d=e.from:s.length>0&&d&&e.from>d&&(s=[],d=null,m=null);})),0!=l.length&&r.push({from:null!=u?u:v.length,to:null!=u?u:v.length,insert:"\nto play\n"+l.join("\n")+"\nend\n\n"}),e.Operations.ChangeCode(r),IntegrateSnapshot(e,t),n&&IntegrateSnapshot(e,n),e.Semantics.PrettifyAll(),e.GetCode().trim()}))}function FixBreed(e,o,n){let t=e.getChild("BreedSingular"),l=e.getChild("BreedPlural"),r=["turtle","link","patch",...n].includes(o.sliceDoc(null==t?void 0:t.from,null==t?void 0:t.to).toLowerCase())||o.sliceDoc(null==t?void 0:t.from,null==t?void 0:t.to).toLowerCase()==o.sliceDoc(null==l?void 0:l.from,null==l?void 0:l.to).toLowerCase(),i=["turtles","links","patches",...n].includes(o.sliceDoc(null==l?void 0:l.from,null==l?void 0:l.to).toLowerCase());return t&&l&&r&&i?{from:e.from,to:e.to,insert:""}:t&&r?{from:null==t?void 0:t.from,to:null==t?void 0:t.to,insert:getSingularName(o.sliceDoc(null==l?void 0:l.from,null==l?void 0:l.to))}:l&&i?{from:null==l?void 0:l.from,to:null==l?void 0:l.to,insert:getPluralName(o.sliceDoc(null==t?void 0:t.from,null==t?void 0:t.to))}:null}function AddComments(e,o){return 0==o.length?e:o.join("\n")+"\n"+e}

    class SemanticFeatures{constructor(e){this.Galapagos=e,this.CodeMirror=e.CodeMirror;}GetSyntaxTree(){return syntaxTree(this.CodeMirror.state)}SyntaxNodesAt(e,t){this.GetSyntaxTree().cursorAt(e).iterate(t);}GetRecognizedMode(){return this.Galapagos.GetState().RecognizedMode}Highlight(){return this.Galapagos.ForceParse(),this.HighlightTree(this.GetSyntaxTree(),this.Galapagos.GetCode())}HighlightContent(e){return this.HighlightTree(this.Galapagos.Language.language.parser.parse(e),e)}HighlightTree(e,t){const r=document.createElement("span");return this.TraverseNodes(e,t,((e,t,i,a)=>{for(var o=e.split("\n"),s=0;s<o.length;s++){var n=o[s],h=document.createElement("span");h.innerText=n,""!=t&&(h.className=t),""!=h.innerHTML&&r.appendChild(h),s!=o.length-1&&r.appendChild(document.createElement("br"));}})),r}TraverseNodes(e,t,r){let i=0;highlightTree(e,highlightStyle,((e,a,o)=>{e>i&&r(t.slice(i,e),"",i,e),r(t.slice(e,a),o,e,a),i=a;})),i!=e.length&&r(t.slice(i,e.length),"",i,e.length);}Prettify(){prettify(this.CodeMirror);}PrettifyAll(){prettifyAll(this.CodeMirror,this.Galapagos);}PrettifyOrAll(){var e=this.CodeMirror.state.selection.ranges;0==e.length||e[0].from==e[0].to?this.PrettifyAll():this.Prettify();}BuildSnapshot(){return BuildSnapshot(this.Galapagos)}IntegrateSnapshot(e){return IntegrateSnapshot(this.Galapagos,e)}FixGeneratedCode(e,t){return __awaiter(this,void 0,void 0,(function*(){return FixGeneratedCode(this.Galapagos,e,t)}))}ForEachDiagnostic(e){forEachDiagnostic(this.CodeMirror.state,e);}}

    const basicSetup=(()=>[lineNumbers(),highlightActiveLineGutter(),highlightSpecialChars(),history(),foldGutter(),drawSelection(),dropCursor(),EditorState.allowMultipleSelections.of(!0),indentOnInput(),syntaxHighlighting(defaultHighlightStyle,{fallback:!0}),bracketMatching(),closeBrackets(),autocompletion(),rectangularSelection(),crosshairCursor(),highlightActiveLine(),highlightSelectionMatches(),keymap.of([...closeBracketsKeymap,...defaultKeymap,...searchKeymap,...historyKeymap,...foldKeymap,...completionKeymap,...lintKeymap])])();(()=>[highlightSpecialChars(),history(),drawSelection(),syntaxHighlighting(defaultHighlightStyle,{fallback:!0}),keymap.of([...defaultKeymap,...historyKeymap])])();

    class GalapagosEditor{constructor(e,t){var r,i;this.Linters=[],this.LineWidth=50,this.IsReadOnly=!1,this.ID=0,this.Children=[],this.ParentEditor=null,this.PreprocessContext=new PreprocessContext,this.LintContext=new LintContext,this.Version=0,this.IsVisible=!0,this.Editable=new Compartment,this.Parent=e,this.Options=t;const o=[basicSetup,lightTheme,this.Editable.of(EditorView.editable.of(!this.Options.ReadOnly)),updateExtension((e=>this.onUpdate(e))),highlight,keymap.of([indentWithTab])];switch(t.Language){case EditorLanguage.Javascript:this.Language=javascript();break;case EditorLanguage.CSS:this.Language=css();break;case EditorLanguage.HTML:this.Language=html();break;default:this.Language=NetLogo(this),o.push(preprocessStateExtension),o.push(stateExtension),o.push(buildToolTips(this)),Dictionary.ClickHandler=null!==(r=Dictionary.ClickHandler)&&void 0!==r?r:t.OnDictionaryClick,this.Linters=netlogoLinters.map((e=>buildLinter(e,this))),this.Options.OneLine&&(o.unshift(Prec.highest(keymap.of([{key:"Enter",run:()=>!0}]))),o.unshift(Prec.highest(keymap.of([{key:"Tab",run:acceptCompletion}])))),o.push(...this.Linters),o.push(linter(CompilerLinter)),o.push(linter(RuntimeLinter)),o.push(lintGutter());}o.push(this.Language),o.push(EditorView.domEventHandlers({keydown:e=>{var r;return null===(r=t.OnKeyDown)||void 0===r?void 0:r.call(t,e,this)},keyup:e=>{var r;return null===(r=t.OnKeyUp)||void 0===r?void 0:r.call(t,e,this)},click:e=>{var r;return null===(r=t.OnClick)||void 0===r?void 0:r.call(t,e,this)}})),this.Options.Wrapping&&o.push(EditorView.lineWrapping),this.Options.Placeholder&&o.push(placeholder(this.Options.Placeholder)),this.CodeMirror=new EditorView({extensions:o,parent:e}),this.GetPreprocessState().SetEditor(this),this.Options.ParseMode=null!==(i=this.Options.ParseMode)&&void 0!==i?i:ParseMode.Normal,this.GetState(!1).Mode=this.Options.ParseMode,this.GetState(!1).Preprocess=this.PreprocessContext,this.Editing=new EditingFeatures(this),this.Selection=new SelectionFeatures(this),this.Semantics=new SemanticFeatures(this),this.Operations=new CodeEditing(this.CodeMirror);this.Parent.getElementsByClassName("cm-content")[0].setAttribute("data-enable-grammarly","false");}GetState(e){return e&&this.UpdateContext(),this.CodeMirror.state.field(stateExtension)}GetPreprocessState(){return this.CodeMirror.state.field(preprocessStateExtension)}SetCode(e){this.CodeMirror.dispatch({changes:{from:0,to:this.CodeMirror.state.doc.length,insert:e}});}GetCode(){return this.CodeMirror.state.doc.toString()}GetCodeSlice(e,t){return this.CodeMirror.state.sliceDoc(e,t)}SetReadOnly(e){this.IsReadOnly=e,this.CodeMirror.dispatch({effects:this.Editable.reconfigure(EditorView.editable.of(!e))});}AddChild(e){if(e.Children.length>0)throw new Error("Cannot add an editor that already has children as child.");this.Children.push(e),e.ID=this.Children.length,e.ParentEditor=this,e.CodeMirror.state.field(stateExtension).EditorID=e.ID,e.Options.ParseMode!==ParseMode.Generative&&(e.LintContext=this.LintContext,e.PreprocessContext=this.PreprocessContext,e.GetState(!1).Preprocess=this.PreprocessContext);}SyncContext(e){e.LintContext=this.LintContext,e.PreprocessContext=this.PreprocessContext,e.GetState(!1).Preprocess=this.PreprocessContext;}Blur(){this.CodeMirror.contentDOM.blur();}Focus(){this.CodeMirror.focus();}CloseCompletion(){closeCompletion(this.CodeMirror);}SetWidgetVariables(e,t){if(null!=this.ParentEditor)throw new Error("Cannot set widget variables on a child editor.");var r=this.GetState(),i=r.WidgetGlobals,o=i.length!=e.length;if(!o)for(var s=0;s<e.length;s++)if(i[s]!=e[s]){o=!0;break}o&&(r.WidgetGlobals=e.map((e=>e.toLowerCase())),r.SetDirty(),this.Options.ParseMode==ParseMode.Normal?this.UpdateContext():this.UpdateSharedContext(),t&&this.ForceLint());}SetMode(e,t){var r=this.GetState();r.Mode!=e&&(r.Mode=e,this.UpdateContext(),t&&this.ForceLint());}SetCompilerErrors(e){var t=this.GetState();0==t.CompilerErrors.length&&0==t.RuntimeErrors.length&&0==e.length||(this.FixUnknownErrors(e),t.CompilerErrors=e,t.RuntimeErrors=[],this.ForceLint(),e.length>0&&this.Selection.SetCursorPosition(e[0].start));}SetRuntimeErrors(e){var t=this.GetState();0==t.RuntimeErrors.length&&0==e.length||(this.FixUnknownErrors(e),t.RuntimeErrors=e,this.ForceLint(),e.length>0&&this.Selection.SetCursorPosition(e[0].start));}FixUnknownErrors(e){var t=this.GetCode(),r=t.indexOf("\n");-1===r&&(r=t.length),e.forEach((e=>{if(2147483647==e.start)e.start=0,e.end=r;else try{e.code=t.slice(e.start,e.end);}catch(e){}}));}SetContext(e){this.Options.ParseMode!=ParseMode.Oneline&&this.Options.ParseMode!=ParseMode.OnelineReporter||!this.GetState(!1).SetContext(e)||(this.ForceParse(),this.ForceLint());}GetID(){return this.ID}GetVersion(){return this.Version}SetVisible(e){this.IsVisible!=e&&(this.IsVisible=e,this.IsVisible&&this.ForceLint());}GetChildren(){if(this.Options.ParseMode==ParseMode.Generative){if(this.ParentEditor)return [this,this.ParentEditor]}else if(this.Options.ParseMode==ParseMode.Normal)return [...this.Children,this];return [this]}UpdateContext(){const e=this.CodeMirror.state.field(stateExtension);return !!e.GetDirty()&&(this.ForceParse(),this.Version+=1,e.ParseState(this.CodeMirror.state),this.ParentEditor&&this.Options.ParseMode!=ParseMode.Generative?this.ParentEditor&&this.Options.ParseMode==ParseMode.Normal&&this.ParentEditor.UpdateContext():this.UpdateSharedContext(),!0)}UpdateSharedContext(){var e=this.LintContext.Clear();for(var t of this.GetChildren()){let a=t.CodeMirror.state.field(stateExtension);for(var r of a.Extensions)e.Extensions.set(r,t.ID);for(var r of a.Globals)e.Globals.set(r,t.ID);for(var r of a.WidgetGlobals)e.WidgetGlobals.set(r,t.ID);for(var[r,i]of a.Procedures)i.EditorID=t.ID,e.Procedures.set(r,i);for(var[r,o]of a.Breeds){o.EditorID=t.ID;var s=e.Breeds.get(r);if(s){var n=s.Variables;o.Variables.forEach((e=>{n.includes(e)||n.push(e);}));}else s=new Breed(o.Singular,o.Plural,[...o.Variables],o.BreedType),e.Breeds.set(r,s);}}this.RefreshContexts();}RefreshContexts(){for(var e of(this.IsVisible&&(this.ForceParse(!1),this.ForceLint()),this.Children))e.Version+=1,e.RefreshContexts();}UpdatePreprocessContext(){return this.Version+=1,this.ParentEditor&&this.Options.ParseMode!=ParseMode.Generative?this.ParentEditor&&this.Options.ParseMode==ParseMode.Normal&&this.ParentEditor.UpdatePreprocessContext():this.UpdateSharedPreprocess(),!0}UpdateSharedPreprocess(){var e,t=this.PreprocessContext.Clear();for(var r of this.GetChildren())if(r.Options.ParseMode==ParseMode.Normal||r==this){let p=r.CodeMirror.state.field(preprocessStateExtension);for(var i=0;i<p.PluralBreeds.length;i++){var o=p.PluralBreeds[i],s=p.SingularBreeds[i],n=p.BreedTypes[i];t.PluralBreeds.set(o,r.ID),t.SingularBreeds.set(s,r.ID),t.PluralToSingulars.set(o,s),t.SingularToPlurals.set(s,o),t.BreedTypes.set(o,n);}for(var[a,d]of p.BreedVars)for(var h of d){t.BreedVars.set(h,r.ID);let i=t.BreedVarToPlurals.has(h)&&null!==(e=t.BreedVarToPlurals.get(h))&&void 0!==e?e:[];i.push(a),t.BreedVarToPlurals.set(h,i);}for(var[a,l]of p.Commands)t.Commands.set(a,l),t.CommandsOrigin.set(a,r.ID);for(var[a,l]of p.Reporters)t.Reporters.set(a,l),t.ReportersOrigin.set(a,r.ID);}}ForceLintAsync(){return __awaiter(this,void 0,void 0,(function*(){var e=[];for(var t of this.Linters){var r=yield Promise.resolve(t.Source(this.CodeMirror));e.push(...r);}return e}))}ForceParse(e=!0){forceParsing(this.CodeMirror,this.CodeMirror.state.doc.length,1e5),e&&this.CodeMirror.state.field(stateExtension).SetDirty();}ForceLint(){const e=this.CodeMirror.plugins;for(var t=0;t<e.length;t++)if(e[t].value.hasOwnProperty("lintTime")){e[t].value.set=!0,e[t].value.force();break}}onUpdate(e){e.docChanged&&this.SetCompilerErrors([]),null!=this.Options.OnUpdate&&this.Options.OnUpdate(e.docChanged,e),e.focusChanged&&(this.CodeMirror.hasFocus?null!=this.Options.OnFocused&&this.Options.OnFocused(this.CodeMirror):null!=this.Options.OnBlurred&&this.Options.OnBlurred(this.CodeMirror));}}const Localized=new LocalizationManager;try{window.GalapagosEditor=GalapagosEditor,window.EditorLocalized=Localized;}catch(e){}

    exports.GalapagosEditor = GalapagosEditor;
    exports.Localized = Localized;

    Object.defineProperty(exports, '__esModule', { value: true });

    return exports;

})({});
